
      subroutine genericpdfset(ndns)
c wrap for pdfset; avoids subsequent
c calls to pdfset (you never know)
      integer ndns
      character * 20 parm(20)
      real * 8 val(20)
      integer ndns0
      data ndns0/-1/
      save ndns0
      if(ndns.ne.ndns0) then
         ndns0=ndns
         parm(1)='DEFAULT'
         val(1)=ndns
         call pdfset(parm,val)
      endif
      end

      subroutine genericpdf(ndns,ih,xmu2,x,fx)
c Interface to lhapdf package.
      implicit none
      integer ndns,ih
      real * 8 xmu2,x,fx(-6:6)
      integer j
      real * 8 tmp
      call genericpdfset(ndns)
      call pftopdg(x,sqrt(xmu2),fx)
c pftopdg returns density times x
      do j=-6,6
         fx(j)=fx(j)/x
      enddo
c 1 is proton, -1 is antiproton, 3 is pi+, -3 is pi-
      if(ih.eq.1) then
         return
      elseif(ih.eq.-1) then
         do j=1,6
            tmp=fx(j)
            fx(j)=fx(-j)
            fx(-j)=tmp
         enddo
      elseif(ih.eq.3) then
         tmp=fx(1)
         fx(1)=fx(-1)
         fx(-1)=tmp
      elseif(ih.eq.-3) then
         tmp=fx(2)
         fx(2)=fx(-2)
         fx(-2)=tmp
      elseif(ih.eq.0) then
c 0 is deuteron
        fx(1)  = 0.5 * ( fx(1)+fx(2) )
        fx(-1) = 0.5 * ( fx(-1)+fx(-2) )
        fx(2)  = fx(1)
        fx(-2) = fx(-1)         
      elseif(ih.eq.4) then
c photon pdf
         continue
      else
         write(*,*) ' genericpdf: unimplemented hadron type ',ih
         stop
      endif
c Bug fixes for version 5.3 of lhapdf
      if(ndns.eq.363) then
         do j=1,6
            fx(j)=fx(j)/2
            fx(-j)=fx(-j)/2
         enddo
      endif
      
      end

      subroutine genericpdfpar(ndns,ih,xlam,scheme,iret)
      implicit none
      integer ndns,ih
      real * 8 xlam
      character * 2 scheme
      integer iret
      real * 8 QCDL4,QCDL5
      COMMON/W50512/QCDL4,QCDL5
      call genericpdfset(ndns)
      xlam=qcdl5
      scheme='MS'
      iret=0
c bug fix: lambda=0 CTEQ65 and CTEQ65c sets.
      if((ndns.ge.10350.and.ndns.le.10390).or.
     #   (ndns.ge.10450.and.ndns.le.10456)) then
         if(qcdl5.lt.0.001) then
            QCDL5 = 0.226d0
            QCDL4 = 0.326d0
            xlam=qcdl5
         endif
      endif
      end

      function whichpdfpk()
      character * 3 whichpdfpk
      whichpdfpk='lha'
      end
