      PROGRAM HWIGPR
C---COMMON BLOCKS ARE INCLUDED AS FILE HERWIG65.INC
      INCLUDE 'herwig6510.h'
      include 'LesHouches.h'
      integer nevnum
      common/cevnum/nevnum
      integer ih1,ih2
      INTEGER N
      integer iseed(2)
      double precision hwrset,tmp
C---PROCESS; set to negative for user supplied me
      iproc=-1                  ! Les Houches interface
C--- Opens input file and counts number of events, setting MAXEV;
c    MAXEV must be set before HWIGIN call.
      call opencount
C---INITIALISE OTHER COMMON BLOCKS
      CALL HWIGIN
C---USER CAN RESET PARAMETERS AT
C   THIS POINT, OTHERWISE DEFAULT
C   VALUES IN HWIGIN WILL BE USED.
c      PTMIN=100.
C---COMPUTE PARAMETER-DEPENDENT CONSTANTS
      CALL HWUINC
C---CALL HWUSTA TO MAKE ANY PARTICLE STABLE
      CALL HWUSTA('PI0     ')
c      CALL HWUSTA('Z0/GAMA*')
C---USER'S INITIAL CALCULATIONS
      CALL abegin
C---INITIALISE ELEMENTARY PROCESS
      CALL HWEINI
C---LOOP OVER EVENTS
      DO N=1,maxev
C---INITIALISE EVENT
      CALL HWUINE
C---GENERATE HARD SUBPROCESS
      CALL HWEPRO
      if(nup.eq.0) goto 111
C---GENERATE PARTON CASCADES
      CALL HWBGEN
C---DO HEAVY OBJECT DECAYS
      CALL HWDHOB
C---DO CLUSTER FORMATION
      CALL HWCFOR
C---DO CLUSTER DECAYS
      CALL HWCDEC
C---DO UNSTABLE PARTICLE DECAYS
      CALL HWDHAD
C---DO HEAVY FLAVOUR HADRON DECAYS
      CALL HWDHVY
C---ADD SOFT UNDERLYING EVENT IF NEEDED
      CALL HWMEVT
C---FINISH EVENT
      CALL HWUFNE
C---USER'S EVENT ANALYSIS
      if(IERROR.eq.0) CALL analize
      ENDDO
 111  continue
C---TERMINATE ELEMENTARY PROCESS
      CALL HWEFIN
C---USER'S TERMINAL CALCULATIONS
      CALL aend
      END

      subroutine UPINIT
      character * 6 string
      include 'LesHouches.h'
      call lhefreadhdr(97)
      if(lprup(1).eq.1004) then
         call hwusta('D+      ')
         call hwusta('D-      ')
         call hwusta('D0      ')
         call hwusta('DBAR0   ')
      elseif(lprup(1).eq.1005) then
         call hwusta('B_D0    ')
         call hwusta('B_DBAR0 ')
         call hwusta('B-      ')
         call hwusta('B+      ')
      endif
      end

      subroutine opencount
      include 'HERWIG65.INC'
      character * 50 file
      integer ios
      character * 6 string
      file='pwglhef.events'
      open(unit=97,file=file,status='old',iostat=ios)
      if(ios.ne.0) then
         write(*,*)' enter name of event file'
         read(*,'(a)') file
         open(unit=97,file=file,status='old')
      endif
 1    continue
      read(unit=97,fmt='(a)',end=2) string
      if(string.eq.'<event') then
         maxev=maxev+1
         goto 1
      endif
      goto 1
 2    continue
      write(*,*) ' found ',maxev,' events in file'
      rewind(97)
      end

      subroutine UPEVNT
      implicit none
      include 'LesHouches.h'
      integer ini
      call lhefreadev(97)
      end


      subroutine hwaend
      call aend
      end
