      subroutine bbinit
      implicit none
      include 'fixvar-hvq.h'
      include 'strfun.h'
      real * 8 ptminsq
      common/cptmin/ptminsq
      real * 8 asscfc
      common/casscfc/asscfc
      integer jflborn
      common/cjflborn/jflborn
      real * 8 sigtot
      common/csigma/sigtot
      integer iret
      real * 8 error,estimn,errorn,fracneg
      real * 8 bbarra
      integer ndim,ncall1,ncall2,itmx1,itmx2
      parameter (ndim=6)
      real * 8 xx(ndim),xint(0:50,ndim),xmax(50,ndim)
      common/cminthvq/xint,xmax
      logical negflag
      common /cbbarra/negflag
      integer ifold(6)
      common/cifold/ifold
      character * 20 pwgprefix
      integer lprefix
      common/cpwgprefix/pwgprefix,lprefix
      integer j
      real * 8 powheginput
      external bbarra,powheginput
      do j=1,6
         ifold(j)=1
      enddo
      open(unit=57,file=pwgprefix(1:lprefix)//'stat.dat',
     #  status='unknown')
      call physpar
      ncall1=powheginput('ncall1')
      ncall2=powheginput('ncall2')
      itmx1=powheginput('itmx1')
      itmx2=powheginput('itmx2')
      call loadgrids(sh, ih1, ih2, ndns1, ndns2, sigtot, error,
     #  fracneg,  iret)
      if(iret.ne.0) then
         negflag=.false.
         write(*,*)
         write(*,*)' POWHEG: initialization'
         write(*,*)' Computing the integral of the absolute value'
         write(*,*)' of the cross section to set up the adaptive grid'
         open(unit=11,file=pwgprefix(1:lprefix)//'grid.top',
     #        status='unknown')
         write(*,*)' result +- error (picobarn) for each iteration'
         call mint(bbarra,ndim,ncall1,itmx1,0,
     #        xint,xmax,sigtot,error)
         estimn=sigtot
         errorn=error
         close(11)
c setup folding
         ifold(4)=powheginput('foldx')
         ifold(5)=powheginput('foldy')
         ifold(6)=powheginput('foldphi')
         if( (50/ifold(4))*ifold(4).ne.50 .or.
     #       (50/ifold(5))*ifold(5).ne.50 .or.
     #       (50/ifold(6))*ifold(6).ne.50 ) then
            write(*,*)
     #  ' error: ifoldx, ifoldy and ifoldphi should be divisors of 50'
            write(*,*) ' are ',ifold(4),ifold(5),ifold(6)
            stop
         endif
         negflag=.true.
         write(*,*)
         write(*,*)' POWHEG: Computing negative weight contribution'
     #           //' to inclusive cross section' 
         call mint(bbarra,ndim,ncall2,itmx2,1,
     #        xint,xmax,estimn,errorn)
         write(*,*) 'neg. weights:', -estimn,'+-', errorn
         negflag=.false.
         write(*,*)' POWHEG: Computing positive weight contribution'
     #           //' to inclusive cross section' 
         call mint(bbarra,ndim,ncall2,itmx2,1,
     #        xint,xmax,sigtot,error)
         write(*,*) 'pos. weights:', sigtot,'+-', error
         sigtot=sigtot-estimn
         error=sqrt(error**2+errorn**2)
         write(*,*) 'pos+neg', sigtot,'+-', error
         fracneg=estimn/sigtot
         call storegrids(sh, ih1, ih2, ndns1, ndns2, sigtot,
     #        error, fracneg)
      else
         write(*,*)
     #     ' stored grids successfully loaded'
         negflag=.false.
      endif
      write(*,*) ' Estimated fraction of neg. weights', fracneg
      write(*,*) ' Total cross section in pb', sigtot,'+-',error
      write(57,*) ' Estimated fraction of neg. weights', fracneg
      write(57,*) ' Total cross section in pb', sigtot,'+-',error
c initialize gen
      negflag=.false.
      call gen(bbarra,ndim,xint,xmax,0,xx)
      call calcmaxrat
c print statistics
      call gen(bbarra,ndim,xint,xmax,3,xx)
      if(xx(1).gt.0) write(*,*) 'POWHEG: efficiency in the generation'
     # //' of the Born variables =',xx(1)
      end

      subroutine genbbarra
      integer ndim
      parameter (ndim=6)
      real * 8 xx(ndim),xint(0:50,ndim),xmax(50,ndim)
      common/cminthvq/xint,xmax
      real * 8 bbarra
      external bbarra
      call gen(bbarra,ndim,xint,xmax,1,xx)
      end


      subroutine storegrids(sh, ih1, ih2, ndns1,
     #     ndns2, sigtot, error, fracneg)
      implicit none
      real * 8 sh,sigtot,error,fracneg
      integer ih1, ih2, ndns1, ndns2
      integer ndim
      parameter (ndim=6)
      integer nbins
      parameter (nbins=50)
      real * 8 xint(0:nbins,ndim),xmax(nbins,ndim)
      common/cminthvq/xint,xmax
      integer ifold(6)
      common/cifold/ifold
      character * 20 pwgprefix
      integer lprefix
      common/cpwgprefix/pwgprefix,lprefix
      integer j,k
      open(unit=13,file=pwgprefix(1:lprefix)//'grid.dat',
     #     form='unformatted',status='unknown')
      write(13) ((xint(j,k),k=1,ndim),j=0,nbins)
      write(13) ((xmax(j,k),k=1,ndim),j=1,nbins)
      write(13) (ifold(k),k=1,ndim)
      write(13) sh, ih1, ih2, ndns1, ndns2
      write(13) sigtot, error, fracneg
      close(13)
      end

      subroutine loadgrids(sh, ih1, ih2, ndns1,
     #     ndns2, sigtot, error, fracneg, iret)
      implicit none
      real * 8 sh,sigtot,error,fracneg
      integer ih1, ih2, ndns1, ndns2, iret, ios
      integer ndim
      parameter (ndim=6)
      integer nbins
      parameter (nbins=50)
      real * 8 xint(0:nbins,ndim),xmax(nbins,ndim)
      common/cminthvq/xint,xmax
      integer ifold(6)
      common/cifold/ifold
      character * 20 pwgprefix
      integer lprefix
      common/cpwgprefix/pwgprefix,lprefix
      real * 8 shx
      integer ih1x, ih2x, ndns1x, ndns2x
      integer j,k
      real * 8 powheginput
      external powheginput
      if(powheginput('use-old-grid').ne.0) then
         iret=1
         return
      endif
      open(unit=13,file=pwgprefix(1:lprefix)//'grid.dat',
     #     form='unformatted',status='old',iostat=ios)
      if(ios.ne.0) then
         iret=-1
         return
      endif
      read(13) ((xint(j,k),k=1,ndim),j=0,nbins)
      read(13) ((xmax(j,k),k=1,ndim),j=1,nbins)
      read(13) (ifold(k),k=1,ndim)
      read(13) shx, ih1x, ih2x, ndns1x, ndns2x
      if(shx.ne.sh.or.ih1x.ne.ih1.or.ih2x.ne.ih2
     #            .or.ndns1x.ne.ndns1.or.ndns2x.ne.ndns2) then
         iret=-1
         close(13)
         return
      endif
      read(13) sigtot, error, fracneg
      close(13)
      iret=0
      end

c Function bbarra, corresponds to \tilde{B}, defined in eq. 5.9 in hpph/0606275 (ZZ paper)
c depends upon variables xx(1:6), defined in the unit hypercube,
c that parametrize the phase space:
c xx(1)-> m2qq
c xx(2)-> yqq
c xx(3)-> cth1
c xx(4)-> x
c xx(5)-> y
c xx(6)-> th2 (from 0 to pi)
c For more details see subroutine setkinpars.
c
c Int d xx(4) dxx(5) dxx(6) bbarra(xx) = Bbarra(xx(1:3))
c with Bbarra corresp{onding to \bar{B} in 3.2
c Int Bbarra(xx(1:3)) d xx(1) d xx(2) d xx(3) = sigmatot in pb
c Bbarra is as defined in the ZZ paper, up to the appropriate jacobian
c
c DEPENDENCIES:
c common blocks in included file fixvar-hvq.h
c on input:
c common /cbbarra/negflag: if true returns theta(-bbarra)*abs(bbarra)
c                          if false        theta(bbarra)*bbarra
c Needed to estimate negative weight fraction and to reject negative weights in normal
c computation.
c on output
c common/cresults/results(j), j=-5,5: returns the individual flavour contributions to the total.
c index j: (underlying Born flavour)
c j=0:  gg, j>0: q-qbar, j<0 qbar-q
c common/vvars/m2qq,yqq,ro,cth1: upon return, contains the appropriate values of the invariant
c                                mass and rapidity of the heavy flavour pair, ro=(4*xm2**2)/m2qq,
c                                and cos theta_1 (see ZZ paper).
c common/rvars/xscaled,y,th2: upon return contain xscaled=(x-xmin)/(1-xmin), y, theta_2 rad. variables
c common/xval/x:              upon return contains x=m2vv/s
c
c NOTE: we assume betfac=1,delta = 2 here in interface to hvqcrsx
      function bbarra(xx,www,ifirst)
      implicit none
      real * 8 bbarra,xx(6),www
      integer ifirst
      real * 8 hc2
c GeV^-2 to pb cross section
      parameter(hc2=3.8937966d8)
      real * 8 results(-5:5)
      common/cresults/results
      logical negflag
      common /cbbarra/negflag
      real * 8 xjacb,xjacl,xjacr,tmp
      real * 8 resb(-5:5),ressv(-5:5),rescaa(-5:5),rescab(-5:5),
     #         resraa(-5:5),resraa0(-5:5),resrab(-5:5),resrab0(-5:5)
      integer j
      character * 3 contrib
      common/ccontrin/contrib
      save resb,ressv,rescaa,rescab
      if(ifirst.eq.0) then
         call setkinpars(xx,xjacb,xjacl,xjacr)
c first call of a set of with fixed yqq,m2qq,th, variable x,y,phi
         call bbarrab(resb)
         call bbarrasv(ressv)
         call bbarracaa(rescaa)
         call bbarracab(rescab)
         call bbarraraa(resraa,resraa0)
         call bbarrarab(resrab,resrab0)
         bbarra=0
         do j=-5,5
            tmp=((resb(j)+ressv(j))*xjacb+
     #           (rescaa(j)+rescab(j))*xjacl+
     #           (resraa(j)+resrab(j))*xjacr )*hc2
c initial value in results
            results(j)=tmp*www
            bbarra=bbarra+tmp*www
         enddo
      elseif(ifirst.eq.1) then
c subsequent calls:
         call setkinpars(xx,xjacb,xjacl,xjacr)
         call bbarracaa(rescaa)
         call bbarracab(rescab)
         call bbarraraa(resraa,resraa0)
         call bbarrarab(resrab,resrab0)
         bbarra=0
         do j=-5,5
            tmp=((resb(j)+ressv(j))*xjacb+
     #           (rescaa(j)+rescab(j))*xjacl+
     #           (resraa(j)+resrab(j))*xjacr )*hc2
c accumulate values in results
            results(j)=results(j)+tmp*www
            bbarra=bbarra+tmp*www
         enddo
      elseif(ifirst.eq.2) then
c closing call: accumulate values with correct signs
         bbarra=0
         do j=-5,5
            if(negflag) then
               if(results(j).lt.0) then
                  results(j)=-results(j)
               else
                  results(j)=0
               endif
            else
               if(results(j).lt.0) then
                  results(j)=0
               endif
            endif
            bbarra=bbarra+results(j)
         enddo
      endif
      end


      function fppx(ifl,s0,x0,y0,xm20,q1q0,q2q0,w1h0,w2h0,cth20)
c front-end to fpp in hvqcrsx.f that deals with the cases:
c prc=gq,
c ifl=-1, i.e. light quark -> light antiquark
c Thus
c prc ifl
c gg  0     -> gluon gluon
c qq  1     -> quark antiquark
c qq -1     -> antiquark quark
c qg  1     -> quark gluon
c qg -1     -> antiquark gluon
c gq -1     -> gluon quark
c gq  1     -> gluon antiquark
      implicit none
      real * 8 fppx,s0,x0,y0,xm20,q1q0,q2q0,w1h0,w2h0,cth20
      integer ifl
      character * 2 prc
      common/process/prc
      character * 2 oprc
      real * 8 s,x,y,xm2,q1q,q2q,w1h,w2h,cth2
      real * 8 fpp
      external fpp
      oprc=prc
      s=s0
      x=x0
      y=y0
      xm2=xm20
      q1q=q1q0
      q2q=q2q0
      w1h=w1h0
      w2h=w2h0
      cth2=cth20
      if(prc.eq.'gg') then
         if(ifl.eq.0) then
            continue
         else
            goto 998
         endif
      elseif(prc.eq.'qq') then
         if(ifl.eq.1) then
            continue
         elseif(ifl.eq.-1) then
            call exchk1k2(s,x,y,xm2,q1q,q2q,w1h,w2h,cth2)
         else
            goto 998
         endif
      elseif(prc.eq.'qg') then
         if(ifl.eq.1) then
            continue
         elseif(ifl.eq.-1) then
            call exchk1k2(s,x,y,xm2,q1q,q2q,w1h,w2h,cth2)
         else
            goto 998
         endif
      elseif(prc.eq.'gq') then
         prc='qg'
         call exchp1p2(s,x,y,xm2,q1q,q2q,w1h,w2h,cth2)
         if(ifl.eq.-1) then
            continue
         elseif(ifl.eq.1) then
            call exchk1k2(s,x,y,xm2,q1q,q2q,w1h,w2h,cth2)
         else
            goto 998
         endif
      else
         goto 998
      endif
      fppx=fpp(s,x,y,xm2,q1q,q2q,w1h,w2h,cth2)
      prc=oprc
      goto 999
 998  write(*,*) 'fppx called with inconsistent prc,jfl=',prc,ifl
      stop
 999  end

      subroutine setkinpars(xx,xjacb,xjacl,xjacr)
      implicit none
      real * 8 xx(6),xjacb,xjacl,xjacr
      real * 8 m2qq,yqq,ro,cth1
      common/vvars/m2qq,yqq,ro,cth1
      real * 8 xscaled,y,th2
      common/rvars/xscaled,y,th2
      real * 8 x1b,x2b
      common/x1x2born/x1b,x2b
      real * 8 tiny
      parameter (tiny=1d-6)
c also x is computed here, but is valid only for the real contribution
      real * 8 xmin
      real * 8 x
      common/xval/x
      real * 8 alfas
      include 'mathpar.h'
      include 'fixvar-hvq.h'
      xjacb=1
      xjacl=1
      xjacr=1

c The following choice is too much spread out
c      m2qq = 4*xm2 + xx(1)*(sh-4*xm2)
c favor the threshold region
      m2qq=4*xm2*exp(xx(1)*log(sh/(4*xm2)))
      ro=4*xm2/m2qq
      xjacb=xjacb*m2qq*log(sh/(4*xm2))

      yqq = log(sh/m2qq)*(-1+2*xx(2))/2
      xjacb=xjacb*log(sh/m2qq)

      cth1 = -1+2*xx(3)
      xjacb=xjacb*2
c here we cannot generate x, because x is different
c in radiation and subtraction terms.
      xscaled = (1-xx(4))**2*(1-tiny)
      xjacl=xjacb*2*(1-xx(4))

c we need a tiny cutoff for the radiation angle;
      y = -1+2*xx(5)     
      xjacr=xjacl*2*1.5d0*(1-y**2)
      y=1.5d0*(y-y**3/3)*(1-tiny)

c extend the range in th2 from 0,pi to -pi,pi
      th2 = (1-2*xx(6))*pi
c the jacobian: as if 0<th2<pi (sigh)
      xjacr=xjacr*pi

c
      call setscalesbb

      as=alfas(xmuren2,xlam,nl)

      x1b=sqrt(m2qq/sh)*exp(yqq)
      x2b=m2qq/sh/x1b

      call pwggetxmin(y,xmin)
      x=xmin+xscaled*(1-xmin)

      end
      

      subroutine bbarrab(results)
c integrated in d m2qq d yqq d cth1 yields the physical
c cross section
      implicit none
      real * 8 results(-5:5)
      real * 8 m2qq,yqq,ro,cth1
      common/vvars/m2qq,yqq,ro,cth1
      real * 8 s,t,beta
      real * 8 x1b,x2b
      common/x1x2born/x1b,x2b
      character * 2 prc
      common/process/prc
      real * 8 sf(-5:5),sig
      integer j
      real * 8 ggborn, qqborn
      include 'mathpar.h'
      include 'fixvar-hvq.h'
      s=m2qq
      beta=sqrt(1-ro)
      t=-s/2*(1-beta*cth1)
c Compute the Born contributions for all subprocesses:
c gg, and qj-qbarj, j=-5,5 (except 0) and store them in results
c strfun output depends upon prc
      prc='gg'
      sig=ggborn(s,t,xm2) * beta/sh * as**2 * pi
      call strfun(x1b,x2b,sf)
      results(0)= sig * sf(0)
c
      prc='qq'
      sig=qqborn(s,t,xm2) * beta/sh * as**2 * pi
      call strfun(x1b,x2b,sf)
      do j=1,5
         results(j)=sig*sf(j)
         results(-j)=sig*sf(-j)
      enddo
      end

      subroutine bbarrasv(results)
c soft+virtual
c integrated in d m2qq d yqq d cth1 yields the physical
c cross section
      implicit none
      real * 8 results(-5:5)
      real * 8 m2qq,yqq,ro,cth1
      common/vvars/m2qq,yqq,ro,cth1
      real * 8 s,t,u,beta
      real * 8 x1b,x2b
      common/x1x2born/x1b,x2b
      character * 2 prc
      common/process/prc      
      real * 8 sf(-5:5),sig
      integer j
      real * 8 ppsv
      external ppsv
      include 'mathpar.h'
      include 'fixvar-hvq.h'
      s=m2qq
      beta=sqrt(1-ro)
      t=-s/2*(1-beta*cth1)
      u=-s/2*(1+beta*cth1)
c gluon
      prc='gg'
      call strfun(x1b,x2b,sf)
c notice: to have different factorization scales for hadron 1 and 2:
c  xmufct2, xmufct2 --> xmufct2hadron1, xmufct2hadron2
      sig=ppsv(s,t,xm2,xmuren2,xmufct2,xmufct2)
      sig = sig*beta/sh * as**3/4
      results(0)=sig*sf(0)
c To compute correctly the asymmetry must separate q qbar and qbar q
c quark antiquark
      prc='qq'
      call strfun(x1b,x2b,sf)
      sig=ppsv(s,t,xm2,xmuren2,xmufct2,xmufct2)
      sig = sig*beta/sh * as**3/4
      do j=1,5
         results(j)=sig*sf(j)
      enddo
c antiquark quark
c CAVEAT! to have different factorization scales for hadron 1 and 2
c  xmufct2, xmufct2 --> xmufct2hadron2, xmufct2hadron1 here.
      sig=ppsv(s,u,xm2,xmuren2,xmufct2,xmufct2)
      sig = sig*beta/sh * as**3/4
      do j=-5,-1
         results(j)=sig*sf(j)
      enddo
      end

      subroutine pwggetxmin(y,xmin)
      implicit none
      real * 8 y,xmin
      real * 8 x1b,x2b
      common/x1x2born/x1b,x2b
      if(y.eq.1d0) then
         xmin=x1b
      elseif(y.eq.-1d0) then
         xmin=x2b
      else
         xmin=max(
     #        (sqrt((1+x1b**2)**2*(1-y)**2+16*y*x1b**2)
     #        -(1-y)*(1-x1b**2))/(2*(1+y)),
     #        (sqrt((1+x2b**2)**2*(1+y)**2-16*y*x2b**2)
     #        -(1+y)*(1-x2b**2))/(2*(1-y)))
      endif
      if(xmin.gt.1) then
         write(*,*) ' xmin > 1!!!!'
         stop
      endif
      end

      subroutine exchk1k2(s,x,y,xm2,q1q,q2q,w1h,w2h,cth2)
c exchange of momenta of heavy quarks
      implicit none
      real * 8 s,x,y,xm2,q1q,q2q,w1h,w2h,cth2
      real * 8 tk,uk,tmp
      tk=-0.5d0*s*(1-x)*(1-y)
      uk=-0.5d0*s*(1-x)*(1+y)
c exchange
      q1q=-s-tk-q1q
      q2q=-s-uk-q2q
      tmp=w1h
      w1h=w2h
      w2h=tmp
      cth2=-cth2
      end

      subroutine exchp1p2(s,x,y,xm2,q1q,q2q,w1h,w2h,cth2)
c exchange of momenta of incoming partons
      implicit none
      real * 8 s,x,y,xm2,q1q,q2q,w1h,w2h,cth2
      real * 8 tk,uk,tmp
      tk=-0.5d0*s*(1-x)*(1-y)
      uk=-0.5d0*s*(1-x)*(1+y)
      tmp=q1q
      q1q=-s-uk-q2q
      q2q=-s-tk-tmp
      y=-y
c What happens to cth2?  theta2-> 2 pi - theta2, no change
      end

      subroutine hvqr0(x,y,th2,rrr)
c multiplied by (1/(1-y)+1/(1+y))/(1-x)
c and integrated in d x dy dth2 (0,pi)
c d m2qq d yqq d cth1 yields the physical
c cross section in GeV^-2
      implicit none
      real * 8 x,y,th2,rrr(-5:5)
      include 'mathpar.h'
      real * 8 m2qq,yqq,ro,cth1
      common/vvars/m2qq,yqq,ro,cth1
      real * 8 x1b,x2b
      common/x1x2born/x1b,x2b
      real * 8 x1,x2
      common/x1x2real/x1,x2
      character * 2 prc
      common/process/prc
      real * 8 xjac,s,cth2,q1q,q2q,q1c,q2c,w1,w2,w1h,w2h,
     # t,u,sf(-5:5)
      real * 8 sig
      integer j
      real * 8 fppx
      external fppx
      include 'fixvar-hvq.h'
      do j=-5,5
         rrr(j)=0
      enddo
      xjac=1
      s=m2qq/x
      cth2=cos(th2)
      call 
     # invar(xm2,s,x,y,cth1,th2,'bi',t,u,q1q,q2q,q1c,q2c,w1,w2,w1h,w2h)
      x1=x1b*sqrt((s+t)/(s+u)/x)
      x2=x2b*sqrt((s+u)/(s+t)/x)
      if(x1.gt.1.or.x2.gt.1) then
c         write(*,*) ' hvqr0: got x1,x2=',x1,x2,'; return 0'
         return
      endif
      call strfun(x1,x2,sf)
c in this context rox=ro!!!
      xjac=xjac*sqrt(1-ro)/(s*64*pi**2) * as**3*4*pi /(sh*x)
      if(prc.eq.'gg') then
         rrr(0) = fppx(0,s,x,y,xm2,q1q,q2q,w1h,w2h,cth2)*xjac * sf(0)
      else
         do j=-5,5
            if(j.ne.0) then
               sig=fppx(j/abs(j),s,x,y,xm2,q1q,q2q,w1h,w2h,cth2)*xjac
               rrr(j)=sig*sf(j)
            endif
         enddo
      endif
      end

      subroutine bbarraraa(results,result0)
c integrated in d xscaled (0,1) dy (-1,1) dth2 (0,pi)
c d m2qq d yqq d cth1 yields real contribution to the physical
c cross section in GeV^-2.
c Subtracted: in result
c Unsubtracted: in result0
      implicit none
      real * 8 results(-5:5),result0(-5:5)
      include 'mathpar.h'
      character * 2 prc
      common/process/prc
      real * 8 m2qq,yqq,ro,cth1
      common/vvars/m2qq,yqq,ro,cth1
      real * 8 xscaled,y,th2
      common/rvars/xscaled,y,th2
      real * 8 xmin,xminp,xminm,
     #         x,xp,xm,xl,xlp,xlm
      real * 8 r0(-5:5),rp(-5:5),rm(-5:5)
      integer j,kb
      include 'fixvar-hvq.h'
      call pwggetxmin(y,xmin)
      call pwggetxmin(1d0,xminp)
      call pwggetxmin(-1d0,xminm)
      x=xmin + xscaled*(1-xmin)
      xp=xminp + xscaled*(1-xminp)
      xm=xminm + xscaled*(1-xminm)
      do j=-5,5
         results(j)=0
         result0(j)=0
      enddo
      do kb=1,2
         if(kb.eq.1) then
            prc='gg'
         else
            prc='qq'
         endif
         call hvqr0(x ,   y,th2,r0)
         call hvqr0(xp, 1d0,th2,rp)
         call hvqr0(xm,-1d0,th2,rm)
         do j=-5,5
            results(j)= results(j)+
     #           ((r0(j)-rp(j))/(1-y)
     #           +(r0(j)-rm(j))/(1+y))/(1-xscaled)
            result0(j)= result0(j)+
     #           (r0(j)/(1-y)+r0(j)/(1+y))/(1-xscaled)
         enddo
c soft subtraction
         call hvqr0(1d0,   y,th2,r0)
         call hvqr0(1d0, 1d0,th2,rp)
         call hvqr0(1d0,-1d0,th2,rm)
         do j=-5,5
            results(j)=results(j)-
     #           ((r0(j)-rp(j))/(1-y)
     #           +(r0(j)-rm(j))/(1+y))/(1-xscaled)
         enddo
c remnants (see xscaled.pdf in docs directory)
         xl =log((1-xmin )/(1-ro))
         xlp=log((1-xminp)/(1-ro))
         xlm=log((1-xminm)/(1-ro))
         do j=-5,5
            results(j)=results(j)+
     #           ((r0(j)*xl-rp(j)*xlp)/(1-y)
     #           +(r0(j)*xl-rm(j)*xlm)/(1+y))
         enddo

      enddo
      end

      subroutine bbarrarab(results,result0)
c integrated in d xscaled (0,1) dy (-1,1) dth2 (0,pi)
c d m2qq d yqq d cth1 yields the physical
c cross section
      implicit none
      real * 8 results(-5:5),result0(-5:5)
      include 'mathpar.h'
      character * 2 prc
      common/process/prc
      character * 2 brn
      common/whichbrn/brn
      real * 8 xscaled,y,th2
      common/rvars/xscaled,y,th2
      real * 8 xmin,xminp,xminm,x,xp,xm
      real * 8 r0(-5:5),rp(-5:5),rm(-5:5)
      integer j,kb
      include 'fixvar-hvq.h'
      integer ijfl
c returns the flavour of the underlying born: 0 for gg, j for q qbar
      ijfl(j)=(kb-1)*j
c
      call pwggetxmin(y,xmin)
      call pwggetxmin(1d0,xminp)
      call pwggetxmin(-1d0,xminm)
      x=xmin + xscaled*(1-xmin)
      xp=xminp + xscaled*(1-xminp)
      xm=xminm + xscaled*(1-xminm)
      do j=-5,5
         results(j)=0
         result0(j)=0
      enddo
      do kb=1,2
         if(kb.eq.1) then
            brn='gg'
         else
            brn='qq'
         endif
c collinear  y -> -1
         if(brn.eq.'gg') then
            prc='gq'
c with q -> g q
         else
            prc='qg'
c with g -> qq
         endif
         call hvqr0(x,   y,th2,r0)
         call hvqr0(xm,-1d0,th2,rm)
         do j=-5,5
            results(ijfl(j)) = results(ijfl(j))
     #         +(r0(j)-rm(j))/(1+y)/(1-xscaled)
c result0 does not enter in Bbarra: leave the process flavour
            result0(j) = result0(j)
     #         +r0(j)/(1+y)/(1-xscaled)
         enddo
c collinear  y -> 1
         if(brn.eq.'gg') then
            prc='qg'
         else
            prc='gq'
         endif
         call hvqr0(x,  y,th2,r0)
         call hvqr0(xp,1d0,th2,rp)
         do j=-5,5
            results(ijfl(j)) = results(ijfl(j))
     #          + (r0(j)-rp(j))/(1-y)/(1-xscaled)
            result0(j) = result0(j)
     #          + r0(j)/(1-y)/(1-xscaled)
         enddo
      enddo
c
      end

      subroutine bbarracaa(results)
      implicit none
      real * 8 results(-5:5)
      character * 2 prc
      common/process/prc
      real * 8 xscaled,y,th2
      common/rvars/xscaled,y,th2
      real * 8 m2qq,yqq,ro,cth1
      common/vvars/m2qq,yqq,ro,cth1
      real * 8 x1b,x2b
      common/x1x2born/x1b,x2b
      real * 8 x,xmin,xjac,r0(-5:5),r0l(-5:5),r1(-5:5),r1l(-5:5)
      integer j,kb,iy
      include 'mathpar.h'
      include 'fixvar-hvq.h'
      do j=-5,5
         results(j)=0
      enddo
      do kb=1,2
         if(kb.eq.1) then
            prc='gg'
         else
            prc='qq'
         endif
c loop over the two collinear directions
         do iy=-1,1,2
            if(iy.eq.1) then
               xmin=x1b
            else
               xmin=x2b
            endif
            x=xmin + xscaled*(1-xmin)
            xjac=1-xmin
            call hvqc0(x,iy,r0,r0l)
            call hvqc0(1d0,iy,r1,r1l)
            do j=-5,5
               results(j)=results(j)+
     #        ((r0(j)-r1(j))/(1-x)+(r0l(j)-r1l(j))*log(1-x)/(1-x))*xjac
     #              -r1(j)*log((1-ro)/(1-xmin))
     #              -r1l(j)*(log(1-ro)**2-log(1-xmin)**2)/2
            enddo
         enddo
      enddo
      end

      subroutine bbarracab(results)
      implicit none
      real * 8 results(-5:5)
      character * 2 brn
      common/whichbrn/brn
      character * 2 prc
      common/process/prc
      real * 8 xscaled,y,th2
      common/rvars/xscaled,y,th2
      real * 8 m2qq,yqq,ro,cth1
      common/vvars/m2qq,yqq,ro,cth1
      real * 8 x1b,x2b
      common/x1x2born/x1b,x2b
      real * 8 x,xmin,xjac,r0(-5:5),r0l(-5:5)
      integer j,kb,iy
      include 'mathpar.h'
      include 'fixvar-hvq.h'
      integer ijfl
c returns the flavour of the underlying born: 0 for gg, j for q qbar
      ijfl(j)=(kb-1)*j
      do j=-5,5
         results(j)=0
      enddo
      do kb=1,2
         if(kb.eq.1) then
            brn='gg'
         else
            brn='qq'
         endif
         do iy=-1,1,2
            if(iy.eq.1) then
               xmin=x1b
               if(brn.eq.'gg') then
                  prc='qg'
               else
                  prc='gq'
               endif
            else
               xmin=x2b
               if(brn.eq.'gg') then
                  prc='gq'
               else
                  prc='qg'
               endif
            endif
            x=xmin + xscaled*(1-xmin)
            xjac=1-xmin
            call hvqc0(x,iy,r0,r0l)
            do j=-5,5
               results(ijfl(j))=results(ijfl(j))+(r0(j)/(1-x)
     #              +r0l(j)*log(1-x)/(1-x))*xjac
            enddo
         enddo
      enddo
      end

      subroutine hvqc0(x,iy,colp,coll)
      implicit none
      include 'mathpar.h'
      real * 8 x,colp(-5:5),coll(-5:5)
      integer iy
      real * 8 m2qq,yqq,ro,cth1
      common/vvars/m2qq,yqq,ro,cth1
      real * 8 x1b,x2b
      common/x1x2born/x1b,x2b
      character * 2 prc
      common/process/prc
      real * 8 xjac,s,cth2,t,u,x1,x2,sf(-5:5),yc,beta,tt,ttf,sigp,sigl,
     #         xl
      integer j
      real * 8 ppcoll,ppcolp
      include 'fixvar-hvq.h'
c arbitrary value:
      cth2=0.5d0
      beta=sqrt(1-ro)
      if(iy.eq.1) then
         yc=1
      elseif(iy.eq.-1) then
         yc=-1
      else
         write(*,*) ' error '
         stop
      endif
      s=m2qq/x
      tt=-m2qq/2*(1-beta*cth1)
      xl=log(s/xmufct2)
      if(iy.eq.1) then
         t=0
         u=-s*(1-x)
         x1=x1b/x
         x2=x2b
      else
         t=-s*(1-x)
         u=0
         x1=x1b
         x2=x2b/x
      endif
      call strfun(x1,x2,sf)
      xjac=beta/(16*pi)/(x*sh) * (as*4*pi)**3
      if(prc.eq.'qq'.or.prc.eq.'gg') then
         sigp=ppcolp(yc,s,tt,x,xm2,xl)
         sigl=ppcoll(yc,s,tt,x,xm2)
      elseif(prc.eq.'qg') then
         sigp=ppcolp(yc,s,tt,x,xm2,xl)
         sigl=ppcoll(yc,s,tt,x,xm2)
      elseif(prc.eq.'gq') then
         prc='qg'
         ttf=-m2qq/2*(1+beta*cth1)
         sigp=ppcolp(-yc,s,ttf,x,xm2,xl)
         sigl=ppcoll(-yc,s,ttf,x,xm2)
         prc='gq'
      else
         write(*,*) ' non esistent subprocess prc=',prc
         stop
      endif
      do j=-5,5
         colp(j)=sigp*sf(j)*xjac
         coll(j)=sigl*sf(j)*xjac
      enddo
      end
      subroutine pwhginit
      implicit none
      include 'LesHouches.h'
      include 'strfun.h'
      include 'fixvar-hvq.h'
      real * 8 sigtot
      common/csigma/sigtot
      real * 8 ptminsq
      common/cptmin/ptminsq
      integer iupper
      common/cupper/iupper
      integer nhvq
      common/cnhvq/nhvq
c the variables below are only to call pickwdecay for initialization
      integer iwp1,iwp2, iwm1,iwm2,itdec
      real * 8 mdecwp1,mdecwp2,mdecwm1,mdecwm2
      real * 8 totbr
c
      real * 8 xmq
      real * 8 powheginput
      external powheginput
      character * 3 whichpdfpk
      external whichpdfpk
c store Les Houches process information
      iupper=1
c Set default value for iupper, ignore alternative small
c x implementation for now.
c Uncomment the following line to test alternative iupper=2
c value (tested in Jan 11 2007)
c      iupper=powheginput('iupper')
c
c ID of beam particles 1 and 2 (pdg convention)
c proton:
c
      call resetrandom
c     
      ih1=powheginput('ih1')
      ih2=powheginput('ih2')
      if(whichpdfpk().eq.'lha') then
         ndns1=powheginput('lhans1')
         ndns2=powheginput('lhans2')
      elseif(whichpdfpk().eq.'mlm') then
         ndns1=powheginput('ndns1')
         ndns2=powheginput('ndns2')
      else
         write(*,*) ' unimplemented pdf package',whichpdfpk()
         stop
      endif
      ebmup(1)=powheginput('ebeam1')
      ebmup(2)=powheginput('ebeam2')
      xmq=powheginput('qmass')
      xm2=xmq**2
      idbmup(1) = 2212*ih1
      idbmup(2) = 2212*ih2
c pdf group; negative to use internal herwig pdf's for showering
      pdfgup(1)=-1
      pdfgup(2)=-1
c pdf set
      pdfsup(1)=-1
      pdfsup(2)=-1
c unweighted events in input:
      idwtup = 3
c number of user subprocesses
c Irrelevant if idwtup=+-3,+-4
      nprup = 1
      sh=(ebmup(1)+ebmup(2))**2
c
      call bbinit
      if(nl.eq.3) then
         nhvq=4
      elseif(nl.eq.4) then
         nhvq=5
      elseif(nl.eq.5) then
         nhvq=6
      else
         write(*,*) ' nl= ' ,nl, ' ERROR! (UPEVNT)'
         stop
      endif
      lprup(1)=1000+nhvq
c now the cross section is available
      xsecup(1)=sigtot
      if(nhvq.eq.6) then
         itdec=powheginput('#topdecaymode')
         if(itdec.eq.-1000000) itdec=0
         if(itdec.ne.0) then
            lprup(1)=300000+itdec
c first call to pickwdecay, to initialize and get back the branching fraction
            call  pickwdecays(iwp1,mdecwp1,iwp2,mdecwp2,
     #                 iwm1,mdecwm1,iwm2,mdecwm2,totbr)
            xsecup(1)=sigtot*totbr
         endif
      endif
      END

      subroutine pwhgevnt
      implicit none
      include 'LesHouches.h'
      include 'invar-hvq.h'
      include 'fixvar-hvq.h'
      real * 8 xscaled,y,th2
      common/rvars/xscaled,y,th2
      real * 8 x
      common/xval/x
      real * 8 x1b,x2b
      common/x1x2born/x1b,x2b
      integer jflborn
      common/cjflborn/jflborn
      integer jflreal
      common/cjflreal/jflreal
      character * 2 genprc
      common/cgenprc/genprc
      real * 8 ycm,tau
      common/x1x2/ycm,tau
c colour codes to use MCatNLO event file format
      integer iccode
      common/ciccode/iccode
      real * 8 t,u,x1,x2,yq1l,yq2l,ypl
      real * 8 t512,t152,t125,t521,t251,t215,t1r,t2r,t5r
c     particles id's
      integer nhvq
      common/cnhvq/nhvq
      integer igluon
      parameter (igluon=21)
      real * 8 bbarra,pt2
      external bbarra,pt2
      real * 8 pt2val
      real * 8 ptminsq
      common/cptmin/ptminsq
      integer iclabel
      common/ciclabel/iclabel
      real * 8 powheginput,random
      external powheginput,random
      integer ichoice,j,itmp
      integer ipick
      external ipick
      call genbbarra
c     generate flavour
      call genjflborn
      if(jflborn.gt.0) call increasecnt('jflborn p')
      if(jflborn.lt.0) call increasecnt('jflborn n')
c set normalization of upper bounding function for the chosen flavour
      call setunorm
c     the following os to check the implementation of the generation
c     of radiation
      itmp=powheginput('#testsuda')
      if(itmp.eq.0) then
         call genptint
      endif
c     generate radiation
      call genptxy
c     perform random azimuthal rotation of the event
      call addrnmphi(pq1,pq2,pp)
c
      call increasecnt('events number')
      if(jflreal.gt.0) call increasecnt('jflreal p')
      if(jflreal.lt.0) call increasecnt('jflreal n')
      pt2val=pt2()
c     veto harder radiation in shower
      scalup=sqrt(max(pt2val,ptminsq))
c     reconstruct momenta
      t=-(1-x)*(1-y)/2
      u=-(1-x)*(1+y)/2
      x1=x1b*sqrt((1+t)/(1+u)/x)
      x2=x2b*sqrt((1+u)/(1+t)/x)
      tau=x1*x2
      ycm=log(x1/x2)/2
      yq1l=yq1+ycm
      yq2l=yq2+ycm
      ypl=yp+ycm
c     Set up the Les Houches common block
      if(pt2val.lt.ptminsq/2) then
c     meaning: pt2val=0!!!
         NUP=4
      else
         NUP=5
      endif
c     Type of current event (just 1 type!)
      IDPRUP=lprup(1)
c     weight of event: set to 1 for unweighted
      XWGTUP=1
c     incoming
      ISTUP(1)=-1
      ISTUP(2)=-1
      ISTUP(3)=1
      ISTUP(4)=1
      if(nup.eq.5) ISTUP(5)=1
c     mother
      mothup(1,1)=0
      mothup(2,1)=0
      mothup(1,2)=0
      mothup(2,2)=0
c     
      mothup(1,3)=1
      mothup(2,3)=2
      mothup(1,4)=1
      mothup(2,4)=2
      if(nup.eq.5) then
         mothup(1,5)=1
         mothup(2,5)=2
      endif
c     Momenta
      pup(3,1)=sqrt(sh)*x1/2
      pup(3,2)=-sqrt(sh)*x2/2
      pup(1,1)=0
      pup(1,2)=0
      pup(2,1)=0
      pup(2,2)=0
      pup(4,1)=abs(pup(3,1))
      pup(4,2)=abs(pup(3,2))
      pup(5,1)=0
      pup(5,2)=0
      call ptytop5(pq1,yq1l,xm2,pup(1,3))
      call ptytop5(pq2,yq2l,xm2,pup(1,4))
      if(nup.eq.5) then
         call ptytop5(pp,ypl,0d0,pup(1,5))
      endif
c     Particles
      idup(3)=nhvq
      idup(4)=-nhvq
      iclabel=130
      if(nup.eq.4) then
         if(jflborn.eq.0) then
            idup(1)=igluon
            idup(2)=igluon
c     this links colour as if all particles were outgoing
            if(random().gt.0.5d0) then
               iccode=3
               call clinkqgga
     #           (icolup(1,3),icolup(1,1),icolup(1,2),icolup(1,4))
            else
               iccode=4
               call clinkqgga
     #           (icolup(1,3),icolup(1,2),icolup(1,1),icolup(1,4))
            endif 
c     1 and 2 are incoming! conjugate color
            call conjcolor(icolup(1,1))
            call conjcolor(icolup(1,2))
         else
            idup(1)=jflborn
            idup(2)=-jflborn
            if(jflborn.gt.0) then
               iccode=1
               call clinkqa(icolup(1,3),icolup(1,1))
               call clinkqa(icolup(1,2),icolup(1,4))
            else
               iccode=2
               call clinkqa(icolup(1,3),icolup(1,2))
               call clinkqa(icolup(1,1),icolup(1,4))
            endif
            call conjcolor(icolup(1,1))
            call conjcolor(icolup(1,2))
         endif
      else
         if(genprc.eq.'gg') then
            idup(1)=igluon
            idup(2)=igluon
            idup(5)=igluon
         elseif(genprc.eq.'qq') then
            idup(1)=jflreal
            idup(2)=-jflreal
            idup(5)=igluon
         elseif(genprc.eq.'qg') then
            idup(1)=jflreal
            idup(2)=igluon
            idup(5)=jflreal
         elseif(genprc.eq.'gq') then
            idup(1)=igluon
            idup(2)=-jflreal
            idup(5)=-jflreal
         endif
         if(genprc.eq.'gg') then
            call ggplanar(pup(1,1),1,pup(1,2),1,pup(1,5),1,
     #           pup(1,3),pup(1,4),xm2,
     #           t512,t152,t125,t521,t251,t215)
            ichoice=ipick(t512,t152,t125,t521,t251,t215)
            if(ichoice.eq.1) then
               iccode=13
               call clinkqggga(
     #      icolup(1,3),icolup(1,5),icolup(1,1),icolup(1,2),icolup(1,4))
            elseif(ichoice.eq.2) then
               iccode=14
               call clinkqggga(
     #      icolup(1,3),icolup(1,1),icolup(1,5),icolup(1,2),icolup(1,4))
            elseif(ichoice.eq.3) then
               iccode=15
               call clinkqggga(
     #      icolup(1,3),icolup(1,1),icolup(1,2),icolup(1,5),icolup(1,4))
            elseif(ichoice.eq.4) then
               iccode=16
               call clinkqggga(
     #      icolup(1,3),icolup(1,5),icolup(1,2),icolup(1,1),icolup(1,4))
            elseif(ichoice.eq.5) then
               iccode=17
               call clinkqggga(
     #      icolup(1,3),icolup(1,2),icolup(1,5),icolup(1,1),icolup(1,4))
            elseif(ichoice.eq.6) then
               iccode=18
               call clinkqggga(
     #      icolup(1,3),icolup(1,2),icolup(1,1),icolup(1,5),icolup(1,4))
            endif
c     1 and 2 are incoming
            call conjcolor(icolup(1,1))
            call conjcolor(icolup(1,2))
         elseif(genprc.eq.'qq'.and.jflreal.gt.0) then
c     quark antiquark incoming: antiquark-quark outgoing
            call qqbplanar(pup(1,1),1,pup(1,2),1,pup(1,5),1,
     #           pup(1,3),pup(1,4),xm2,t1r,t2r)
            ichoice=ipick(t1r,t2r,0d0,0d0,0d0,0d0)
            if(ichoice.eq.1) then
               iccode=1
               call clinkqga(icolup(1,3),icolup(1,5),icolup(1,1))
               call clinkqa(icolup(1,2),icolup(1,4))
            else
               iccode=2
               call clinkqa(icolup(1,3),icolup(1,1))
               call clinkqga(icolup(1,2),icolup(1,5),icolup(1,4))
            endif
            call conjcolor(icolup(1,1))
            call conjcolor(icolup(1,2))
         elseif(genprc.eq.'qq'.and.jflreal.lt.0) then
c     antiquark-quark
            call qqbplanar(pup(1,2),1,pup(1,1),1,pup(1,5),1,
     #           pup(1,3),pup(1,4),xm2,t2r,t1r)
            ichoice=ipick(t2r,t1r,0d0,0d0,0d0,0d0)
            if(ichoice.eq.1) then
               iccode=5
               call clinkqga(icolup(1,3),icolup(1,5),icolup(1,2))
               call clinkqa(icolup(1,1),icolup(1,4))
            else
               iccode=6
               call clinkqa(icolup(1,3),icolup(1,2))
               call clinkqga(icolup(1,1),icolup(1,5),icolup(1,4))
            endif
            call conjcolor(icolup(1,1))
            call conjcolor(icolup(1,2))
         elseif(genprc.eq.'qg'.and.jflreal.gt.0) then
c     quark-gluone
            call qqbplanar(pup(1,1),1,pup(1,5),-1,pup(1,2),-1,
     #           pup(1,3),pup(1,4),xm2,t1r,t5r)
            ichoice=ipick(t1r,t5r,0d0,0d0,0d0,0d0)
            if(ichoice.eq.1) then
               iccode=3
               call clinkqga(icolup(1,3),icolup(1,2),icolup(1,1))
               call clinkqa(icolup(1,5),icolup(1,4))
            else
               iccode=4
               call clinkqa(icolup(1,3),icolup(1,1))
               call clinkqga(icolup(1,5),icolup(1,2),icolup(1,4))
            endif
            call conjcolor(icolup(1,1))
            call conjcolor(icolup(1,2))
         elseif(genprc.eq.'qg'.and.jflreal.lt.0) then
c     antiquark-gluon
            call qqbplanar(pup(1,5),-1,pup(1,1),1,pup(1,2),-1,
     #           pup(1,3),pup(1,4),xm2,t5r,t1r)
            ichoice=ipick(t5r,t1r,0d0,0d0,0d0,0d0)
            if(ichoice.eq.1) then
               iccode=7
               call clinkqga(icolup(1,3),icolup(1,2),icolup(1,5))
               call clinkqa(icolup(1,1),icolup(1,4))
            else
               iccode=8
               call clinkqa(icolup(1,3),icolup(1,5))
               call clinkqga(icolup(1,1),icolup(1,2),icolup(1,4))
            endif
            call conjcolor(icolup(1,1))
            call conjcolor(icolup(1,2))
         elseif(genprc.eq.'gq'.and.jflreal.lt.0) then
c     gluon-quark
            call qqbplanar(pup(1,2),1,pup(1,5),-1,pup(1,1),-1,
     #           pup(1,3),pup(1,4),xm2,t2r,t5r)
            ichoice=ipick(t2r,t5r,0d0,0d0,0d0,0d0)
            if(ichoice.eq.1) then
               iccode=9
               call clinkqga(icolup(1,3),icolup(1,1),icolup(1,2))
               call clinkqa(icolup(1,5),icolup(1,4))
            else
               iccode=10
               call clinkqa(icolup(1,3),icolup(1,2))
               call clinkqga(icolup(1,5),icolup(1,1),icolup(1,4))
            endif
            call conjcolor(icolup(1,1))
            call conjcolor(icolup(1,2))
         elseif(genprc.eq.'gq'.and.jflreal.gt.0) then
c     gluon-antiquark
            call qqbplanar(pup(1,5),-1, pup(1,2),1,pup(1,1),-1,
     #           pup(1,3),pup(1,4),xm2,t5r,t2r)
            ichoice=ipick(t5r,t2r,0d0,0d0,0d0,0d0)
            if(ichoice.eq.1) then
               iccode=11
               call clinkqga(icolup(1,3),icolup(1,1),icolup(1,5))
               call clinkqa(icolup(1,2),icolup(1,4))
            else
               iccode=12
               call clinkqa(icolup(1,3),icolup(1,5))
               call clinkqga(icolup(1,2),icolup(1,1),icolup(1,4))
            endif
            call conjcolor(icolup(1,1))
            call conjcolor(icolup(1,2))
         endif
      endif
      call incrcntrs2('event type',idup(1),idup(2))
      do j=1,nup
         spinup(j)=9
         vtimup(j)=0
      enddo
      if(nhvq.eq.6) call ttdecay
      end

      subroutine assigncol(icol,ocol,isign)
c assigns colour tags of icol to ocol, flipping colour-anticolour if isign<0
      implicit none
      integer icol(2),ocol(2),isign
      if(isign.gt.0) then
         ocol(1)=icol(1)
         ocol(2)=icol(2)
      elseif(isign.lt.0) then
         ocol(1)=icol(2)
         ocol(2)=icol(1)
      else
         write(*,*)' error: assigncol called with isign=',isign
         stop
      endif
      end


      subroutine ptytop5(pt,y,m2,p5)
      implicit none
      real * 8 pt(2),y,m2,p5(5)
      real * 8 mt2,p0ppz,p0mpz
      p5(1)=pt(1)
      p5(2)=pt(2)
      mt2=m2+pt(1)**2+pt(2)**2
      p0ppz=exp(y)*sqrt(mt2)
      p0mpz=mt2/p0ppz
      p5(3)=(p0ppz-p0mpz)/2
      p5(4)=(p0ppz+p0mpz)/2
      p5(5)=sqrt(m2)
      end


      subroutine addrnmphi(pq1,pq2,pp)
c rotate the 2-momenta pq1,pq2 and pp by the same
c random angle
      implicit none      
      real * 8 pq1(2),pq2(2),pp(2)
      real * 8 sphi,cphi,tmp,tmp1,tmp2
      real * 8 pi,phi
      parameter (pi=3.141592653589793d0)
      real * 8 random
      external random
      phi=2*pi*random()
      sphi=sin(phi)
      cphi=cos(phi)
c Rotate the vectors
      tmp1 = cphi*pq1(1)-sphi*pq1(2)
      tmp2 = sphi*pq1(1)+cphi*pq1(2)
      pq1(1)=tmp1
      pq1(2)=tmp2
c
      tmp1 = cphi*pq2(1)-sphi*pq2(2)
      tmp2 = sphi*pq2(1)+cphi*pq2(2)
      pq2(1)=tmp1
      pq2(2)=tmp2
c
      tmp1 = cphi*pp(1)-sphi*pp(2)
      tmp2 = sphi*pp(1)+cphi*pp(2)
      pp(1)=tmp1
      pp(2)=tmp2
c
      end

      subroutine tolab
      implicit none
      real * 8 pwl(2),pzl(2),ppl(2)
      common/plbvar/pwl,pzl,ppl
      real * 8 ywl,yzl,ypl
      common/ylbvar/ywl,yzl,ypl
      real * 8 pw(2),pz(2),pp(2)
      common/perpen/pw,pz,pp
      real * 8 yw,yz,yp
      common/ycmvar/yw,yz,yp
      integer i
      do i=1,2
         pwl(i)=pw(i)
         pzl(i)=pz(i)
         ppl(i)=pp(i)
      enddo
      ywl=yw
      yzl=yz
      ypl=yp
      end


      subroutine displeshouches
      include 'LesHouches.h'
      integer mark(200),icol(200),j,k,ilist,icur
      write(*,*) 'incoming beams:', idbmup(1), idbmup(2)
      write(*,*) 'number of partons in subprocess',nup
      write(*,'(a,10(i3,1x))') 'ist:',(istup(j),j=1,nup)
      write(*,'(a,10(i3,1x))') 'ids:',(idup(j),j=1,nup)
      do j=1,nup
         write(*,'(5(d10.4,1x))') (pup(k,j),k=1,5)
      enddo
c check that quarks have zero anticolour, and antiquarks
c have zero colour
      do j=1,nup
         if(idup(j).ge.1.and.idup(j).le.6.and.icolup(2,j).ne.0) then
            write(*,*) ' error: anticolor in quark'
         elseif(idup(j).ge.-6.and.idup(j).le.-1.and.icolup(1,j).ne.0)
     #           then
            write(*,*) ' error: color in quark'
         endif
      enddo
c Print color linked lists
c first conjugate incoming colors
      call conjcolor(icolup(1,1))
      call conjcolor(icolup(1,2))
      do j=1,nup
         mark(j)=1
      enddo
      mark(8)=0
      icur=8
      ilist=1
      imarked=1
      icol(ilist)=8
 12   continue
      do j=1,nup
         if(istup(j).ne.2) then
         if(mark(j).ne.0.and.icolup(1,icur).eq.icolup(2,j)) then
            ilist=ilist+1
            imarked=imarked+1
            icol(ilist)=j
            mark(j)=0
            icur=j
            if(imarked.eq.nup) goto 22
            if(icolup(1,icur).eq.0) then
               do k=1,nup
                  if(mark(k).ne.0.and.icolup(2,k).eq.0) then
                     ilist=ilist+2
                     icol(ilist)=k
                     icol(ilist-1)=0
                     imarked=imarked+1
                     icur=k
                     mark(k)=0
                     goto 12
                  endif
               enddo
               write(*,*) ' inconsistent colors!'
            endif
            goto 12
         endif
         endif
      enddo
      write(*,*) ' inconsistent colors!'
 22   continue
      call conjcolor(icolup(1,1))
      call conjcolor(icolup(1,2))
      write(*,*) (icol(j),j=1,ilist)
      end

c Subroutine to link colours for
c quark - gluon -gluon  -gluon - aquark
c in planar order
      subroutine clinkqggga(ic1,ic2,ic3,ic4,ic5)
      integer iclabel
      common/ciclabel/iclabel
      integer ic1(2),ic2(2),ic3(2),ic4(2),ic5(2)
c ic1 is a quark: has colour, zero anticolor
      ic1(1)=iclabel+2
      ic1(2)=0
c ic2 is a gluon: link to quark
      ic2(1)=iclabel+3
      ic2(2)=iclabel+2
c ic3 is a gluon
      ic3(1)=iclabel+4
      ic3(2)=iclabel+3
c ic4 is an gluon
      ic4(1)=iclabel+5
      ic4(2)=iclabel+4
c ic5 is an antiquark
      ic5(1)=0
      ic5(2)=iclabel+5
      iclabel=iclabel+10
      end

c Subroutine to link colours for
c quark - gluon -gluon - aquark
c in planar order
      subroutine clinkqgga(ic1,ic2,ic3,ic4)
      integer iclabel
      common/ciclabel/iclabel
      integer ic1(2),ic2(2),ic3(2),ic4(2)
c ic1 is a quark: has colour, zero anticolor
      ic1(1)=iclabel+2
      ic1(2)=0
c ic2 is a gluon: link to quark
      ic2(1)=iclabel+3
      ic2(2)=iclabel+2
c ic3 is a gluon
      ic3(1)=iclabel+4
      ic3(2)=iclabel+3
c ic4 is an anti-quark
      ic4(1)=0
      ic4(2)=iclabel+4
      iclabel=iclabel+10
      end

c Subroutine to link colours for
c quark - gluon - aquark
c in planar order
      subroutine clinkqga(ic1,ic2,ic3)
      integer iclabel
      common/ciclabel/iclabel
      integer ic1(2),ic2(2),ic3(2)
c ic1 is a quark: has colour, zero anticolor
      ic1(1)=iclabel+2
      ic1(2)=0
c ic2 is a gluon: link to quark
      ic2(1)=iclabel+3
      ic2(2)=iclabel+2
c ic3 is an antiquark
      ic3(1)=0
      ic3(2)=iclabel+3
      iclabel=iclabel+10
      end

c Subroutine to link colours for
c quark - aquark
c in planar order
      subroutine clinkqa(ic1,ic2)
      integer iclabel
      common/ciclabel/iclabel
      integer ic1(2),ic2(2)
c ic1 is a quark: has colour, zero anticolor
      ic1(1)=iclabel+2
      ic1(2)=0
c ic2 is an antiquark
      ic2(1)=0
      ic2(2)=iclabel+2
      iclabel=iclabel+10
      end

      subroutine conjcolor(cl)
      integer cl(2),i
      i=cl(1)
      cl(1)=cl(2)
      cl(2)=i
      end

      function ipick(y1,y2,y3,y4,y5,y6)
      implicit none
      integer ipick
      real * 8 y1,y2,y3,y4,y5,y6
      real * 8 t1,t2,t3,t4,t5,t6,r
      real * 8 random
      external random
      t1=y1
      t2=t1+y2
      t3=t2+y3
      t4=t3+y4
      t5=t4+y5
      t6=t5+y6
      r=t6*random()
      if(r.lt.t1) then
         ipick=1
      elseif(r.lt.t2) then
         ipick=2
      elseif(r.lt.t3) then
         ipick=3
      elseif(r.lt.t4) then
         ipick=4
      elseif(r.lt.t5) then
         ipick=5
      else
         ipick=6
      endif
      end

      subroutine ggplanar(p1,ip1,p2,ip2,k,ik,k1,k2,m2,
     # tr12,t1r2,t12r,tr21,t2r1,t21r)
      implicit none
      real * 8 p1(4),p2(4),k(4),k1(4),k2(4)
      REAL * 8 s,tk,uk,q1,q2,q1c,q2c,w1,w2,m,s2,
     # m2,tr12,t1r2,t12r,tr21,t2r1,t21r
      integer ip1,ip2,ik
      real * 8 dotprod
      external dotprod
      m=sqrt(m2)
      s=2*dotprod(p1,p2)*ip1*ip2
      tk=-2*dotprod(p1,k)*ip1*ik
      uk=-2*dotprod(p2,k)*ip2*ik
      q1=-2*dotprod(p1,k1)*ip1
      q2=-2*dotprod(p2,k2)*ip2
c Planar invariant squared amplitudes, summed over spins and color   
c for the planar g g -> q qbar g process; misses a factor Ncolor^4   
c k1: quark momentum
c k2: anti-quark momentum   
c p1: incoming gluon momentum   
c p2: incoming gluon momentum   
c k: radiated gluon momentum   
c   
c Planar configurations are obtained with the gluon all on the same
c side of the fermion line; a given colour flow is specified by
c the ordering of the attachment of the gluons on the fermion
c line. For example: k1,k,p1,p2,k2 is the color structure
c                             
c    k1 -<----||--<--  ---<---  ---<--- k2
c             ||     ||       ||       
c             ^V     ^V       ^V       
c             ||     ||       ||       
c             ||     ||       ||       
c             k      p1       p2
c
c
c return values:   
c tr12: planar configuration k1,k,p1,p2,k2   
c t1r2:                      k1,p1,k,p2,k2   
c t12r:                      k1,p1,p2,k,k2   
c tr21:                      k1,k,p2,p1,k2   
c t2r1:                      k1,p2,k,p1,k2   
c t21r:                      k1,p2,p1,k,k2   
c txyz: xyz stand for incoming gluon 1, 2, and radiated gluon (r)   
c   
c    d(p1,p1)=0   
c    d(p2,p2)=0   
c    d(k,k)=0   
c    d(k1,k1)=m2   
c    d(k2,k2)=m2   
c    d(p1,p2)=s/2   
c    d(p1,k)=-tk/2   
c    d(p2,k)=-uk/2   
c    d(p1,k1)=-q1/2   
c    d(p2,k2)=-q2/2   
c    d(k1,k2)=(s2-2*m2)/2   
c    d(p1,k2)=-q1c/2   
c    d(p2,k1)=-q2c/2   
c    d(k,k1)=w1/2   
c    d(k,k2)=w2/2   
c   
c  Relations among invariants   
c   
      s2=s+tk+uk   
      q1c=-s-tk-q1   
      q2c=-s-uk-q2   
      w1=-q1+q2-tk   
      w2=q1-q2-uk   
      TR12 = -(8*Q2*S*S2*TK*W1**5+(8*Q2*S*S2*TK**2+(8*Q2*S*S2**2+(-16*Q2
     1   *S**2-16*Q2**2*S)*S2)*TK-8*M**2*S**2*S2**2)*W1**4+(6*Q2*S*S2*TK
     2   **3+((8*M**2*Q2-24*Q2**2)*S-12*Q2*S**2)*S2*TK**2+(6*Q2*S*S2**3+
     3   ((-12*Q2-16*M**2)*S**2+8*M**2*Q2*S)*S2**2+(12*Q2*S**3+(24*Q2**2
     4   -16*M**2*Q2)*S**2+24*Q2**3*S)*S2)*TK+16*M**2*Q2*S**2*S2**2-16*M
     5   **2*Q2*S**3*S2)*W1**3+((2*Q2*S*S2-8*M**2*Q2**2)*TK**4+((-6*Q2*S
     6   **2+(8*M**2*Q2-12*Q2**2)*S+16*M**2*Q2**2)*S2-16*M**2*Q2**2*S)*T
     7   K**3+((-12*M**2*S**2-8*M**2*Q2**2)*S2**2+(6*Q2*S**3+(24*Q2**2-1
     8   6*M**2*Q2)*S**2+(24*Q2**3-8*M**2*Q2**2)*S)*S2-24*M**2*Q2**2*S**
     9   2)*TK**2+(2*Q2*S*S2**4+(8*M**2*Q2*S-6*Q2*S**2)*S2**3+(6*Q2*S**3
     :   +(-8*M**2*Q2-16*M**4)*S**2)*S2**2+(-4*Q2*S**4+(-12*Q2**2-16*M**
     ;   2*Q2)*S**3+(-24*Q2**3-8*M**2*Q2**2)*S**2-16*Q2**4*S)*S2-16*M**2
     <   *Q2**2*S**3)*TK-8*M**2*Q2**2*S**2*S2**2+16*M**2*Q2**2*S**3*S2-8
     =   *M**2*Q2**2*S**4)*W1**2+((-2*Q2*S**2-4*Q2**2*S)*S2*TK**4+((6*Q2
     >   **2*S-4*M**2*S**2)*S2**2+((6*Q2**2-4*M**2*Q2)*S**2+(12*Q2**3-16
     ?   *M**2*Q2**2+16*M**4*Q2)*S-16*M**2*Q2**3)*S2)*TK**3+(-6*Q2**2*S*
     @   S2**3+((-12*M**2*Q2-16*M**4)*S**2+(-12*Q2**3-8*M**2*Q2**2-16*M*
     1   *4*Q2)*S+16*M**2*Q2**3)*S2**2+(-2*Q2*S**4+(-6*Q2**2-4*M**2*Q2)*
     2   S**3+(-12*Q2**3-16*M**2*Q2**2+16*M**4*Q2)*S**2+(-16*Q2**4-16*M*
     3   *2*Q2**3)*S)*S2)*TK**2+(2*Q2**2*S*S2**4+(6*Q2**3+8*M**2*Q2**2+1
     4   6*M**4*Q2)*S*S2**3+((8*Q2**4+8*M**2*Q2**3)*S-16*M**4*Q2*S**2)*S
     5   2**2+(2*Q2**2*S**4+(6*Q2**3+8*M**2*Q2**2+16*M**4*Q2)*S**3+(8*Q2
     6   **4+8*M**2*Q2**3)*S**2+8*Q2**5*S)*S2)*TK)*W1+(-4*M**2*Q2*S**3+(
     7   -12*M**2*Q2**2-16*M**4*Q2-16*M**6)*S**2+(-16*M**2*Q2**3-16*M**4
     8   *Q2**2)*S-8*M**2*Q2**4)*S2**2*TK**2)/(Q2**2*S**2*S2**2*TK**2*W1
     9   **2)
      T1R2 = ((2*Q1*Q2*S2*TK**2+(4*Q1**2*Q2-2*Q1*Q2**2)*S2*TK+8*M**2*Q1*
     1   *2*Q2**2)*UK**4+((4*M**2*Q2*S2**2+(6*Q1*Q2**2+(4*M**2*Q1-6*Q1**
     2   2)*Q2)*S2)*TK**2+(-6*Q1**2*Q2*S2**2+(-6*Q1*Q2**3+(12*Q1**2-8*M*
     3   *2*Q1)*Q2**2+(-12*Q1**3+16*M**2*Q1**2-16*M**4*Q1)*Q2)*S2+16*M**
     4   2*Q1**2*Q2**2)*TK+(16*M**2*Q1**3*Q2-16*M**2*Q1**2*Q2**2)*S2)*UK
     5   **3+(2*Q1*Q2*S2*TK**4+(4*M**2*Q1*S2**2+((6*Q1**2+4*M**2*Q1)*Q2-
     6   6*Q1*Q2**2)*S2)*TK**3+((12*M**2*Q2**2+(12*M**2*Q1+16*M**4)*Q2+1
     7   2*M**2*Q1**2+16*M**4*Q1+16*M**6)*S2**2+(12*Q1*Q2**3+(16*M**2*Q1
     8   -24*Q1**2)*Q2**2+(12*Q1**3+16*M**2*Q1**2-16*M**4*Q1)*Q2)*S2+24*
     9   M**2*Q1**2*Q2**2)*TK**2+(6*Q1**2*Q2*S2**3+((12*Q1**3+8*M**2*Q1*
     :   *2+16*M**4*Q1)*Q2+16*M**2*Q1**3+16*M**4*Q1**2)*S2**2+(-8*Q1*Q2*
     ;   *4+(24*Q1**2-8*M**2*Q1)*Q2**3+(8*M**2*Q1**2-24*Q1**3)*Q2**2+(16
     <   *Q1**4+16*M**2*Q1**3)*Q2)*S2)*TK+(8*M**2*Q1**2*Q2**2-16*M**2*Q1
     =   **3*Q2+8*M**2*Q1**4)*S2**2)*UK**2+((4*Q1*Q2**2-2*Q1**2*Q2)*S2*T
     >   K**4+(-6*Q1*Q2**2*S2**2+(-12*Q1*Q2**3+(12*Q1**2+16*M**2*Q1)*Q2*
     ?   *2+(-6*Q1**3-8*M**2*Q1**2-16*M**4*Q1)*Q2)*S2+16*M**2*Q1**2*Q2**
     @   2)*TK**3+(6*Q1*Q2**2*S2**3+((12*Q1+16*M**2)*Q2**3+(8*M**2*Q1+16
     1   *M**4)*Q2**2+16*M**4*Q1*Q2)*S2**2+(16*Q1*Q2**4+(16*M**2*Q1-24*Q
     2   1**2)*Q2**3+(24*Q1**3+8*M**2*Q1**2)*Q2**2+(-8*Q1**4-8*M**2*Q1**
     3   3)*Q2)*S2)*TK**2+((-2*Q1*Q2**2-2*Q1**2*Q2)*S2**4+(-6*Q1*Q2**3-8
     4   *M**2*Q1*Q2**2+(-6*Q1**3-8*M**2*Q1**2-16*M**4*Q1)*Q2)*S2**3+(-8
     5   *Q1*Q2**4-8*M**2*Q1*Q2**3+(-8*Q1**4-8*M**2*Q1**3)*Q2)*S2**2+(-8
     6   *Q1*Q2**5+16*Q1**2*Q2**4-24*Q1**3*Q2**3+16*Q1**4*Q2**2-8*Q1**5*
     7   Q2)*S2)*TK)*UK+8*M**2*Q1**2*Q2**2*TK**4+(16*M**2*Q1*Q2**3-16*M*
     8   *2*Q1**2*Q2**2)*S2*TK**3+(8*M**2*Q2**4-16*M**2*Q1*Q2**3+8*M**2*
     9   Q1**2*Q2**2)*S2**2*TK**2)/(Q1**2*Q2**2*S2**2*TK**2*UK**2)
      T12R = -(8*Q1*S*S2*UK*W2**5+(8*Q1*S*S2*UK**2+(8*Q1*S*S2**2+(-16*Q1
     1   *S**2-16*Q1**2*S)*S2)*UK-8*M**2*S**2*S2**2)*W2**4+(6*Q1*S*S2*UK
     2   **3+((8*M**2*Q1-24*Q1**2)*S-12*Q1*S**2)*S2*UK**2+(6*Q1*S*S2**3+
     3   ((-12*Q1-16*M**2)*S**2+8*M**2*Q1*S)*S2**2+(12*Q1*S**3+(24*Q1**2
     4   -16*M**2*Q1)*S**2+24*Q1**3*S)*S2)*UK+16*M**2*Q1*S**2*S2**2-16*M
     5   **2*Q1*S**3*S2)*W2**3+((2*Q1*S*S2-8*M**2*Q1**2)*UK**4+((-6*Q1*S
     6   **2+(8*M**2*Q1-12*Q1**2)*S+16*M**2*Q1**2)*S2-16*M**2*Q1**2*S)*U
     7   K**3+((-12*M**2*S**2-8*M**2*Q1**2)*S2**2+(6*Q1*S**3+(24*Q1**2-1
     8   6*M**2*Q1)*S**2+(24*Q1**3-8*M**2*Q1**2)*S)*S2-24*M**2*Q1**2*S**
     9   2)*UK**2+(2*Q1*S*S2**4+(8*M**2*Q1*S-6*Q1*S**2)*S2**3+(6*Q1*S**3
     :   +(-8*M**2*Q1-16*M**4)*S**2)*S2**2+(-4*Q1*S**4+(-12*Q1**2-16*M**
     ;   2*Q1)*S**3+(-24*Q1**3-8*M**2*Q1**2)*S**2-16*Q1**4*S)*S2-16*M**2
     <   *Q1**2*S**3)*UK-8*M**2*Q1**2*S**2*S2**2+16*M**2*Q1**2*S**3*S2-8
     =   *M**2*Q1**2*S**4)*W2**2+((-2*Q1*S**2-4*Q1**2*S)*S2*UK**4+((6*Q1
     >   **2*S-4*M**2*S**2)*S2**2+((6*Q1**2-4*M**2*Q1)*S**2+(12*Q1**3-16
     ?   *M**2*Q1**2+16*M**4*Q1)*S-16*M**2*Q1**3)*S2)*UK**3+(-6*Q1**2*S*
     @   S2**3+((-12*M**2*Q1-16*M**4)*S**2+(-12*Q1**3-8*M**2*Q1**2-16*M*
     1   *4*Q1)*S+16*M**2*Q1**3)*S2**2+(-2*Q1*S**4+(-6*Q1**2-4*M**2*Q1)*
     2   S**3+(-12*Q1**3-16*M**2*Q1**2+16*M**4*Q1)*S**2+(-16*Q1**4-16*M*
     3   *2*Q1**3)*S)*S2)*UK**2+(2*Q1**2*S*S2**4+(6*Q1**3+8*M**2*Q1**2+1
     4   6*M**4*Q1)*S*S2**3+((8*Q1**4+8*M**2*Q1**3)*S-16*M**4*Q1*S**2)*S
     5   2**2+(2*Q1**2*S**4+(6*Q1**3+8*M**2*Q1**2+16*M**4*Q1)*S**3+(8*Q1
     6   **4+8*M**2*Q1**3)*S**2+8*Q1**5*S)*S2)*UK)*W2+(-4*M**2*Q1*S**3+(
     7   -12*M**2*Q1**2-16*M**4*Q1-16*M**6)*S**2+(-16*M**2*Q1**3-16*M**4
     8   *Q1**2)*S-8*M**2*Q1**4)*S2**2*UK**2)/(Q1**2*S**2*S2**2*UK**2*W2
     9   **2)
      TR21 = -(8*Q1C*S*S2*UK*W1**5+(8*Q1C*S*S2*UK**2+(8*Q1C*S*S2**2+(-16
     1   *Q1C*S**2-16*Q1C**2*S)*S2)*UK-8*M**2*S**2*S2**2)*W1**4+(6*Q1C*S
     2   *S2*UK**3+((8*M**2*Q1C-24*Q1C**2)*S-12*Q1C*S**2)*S2*UK**2+(6*Q1
     3   C*S*S2**3+((-12*Q1C-16*M**2)*S**2+8*M**2*Q1C*S)*S2**2+(12*Q1C*S
     4   **3+(24*Q1C**2-16*M**2*Q1C)*S**2+24*Q1C**3*S)*S2)*UK+16*M**2*Q1
     5   C*S**2*S2**2-16*M**2*Q1C*S**3*S2)*W1**3+((2*Q1C*S*S2-8*M**2*Q1C
     6   **2)*UK**4+((-6*Q1C*S**2+(8*M**2*Q1C-12*Q1C**2)*S+16*M**2*Q1C**
     7   2)*S2-16*M**2*Q1C**2*S)*UK**3+((-12*M**2*S**2-8*M**2*Q1C**2)*S2
     8   **2+(6*Q1C*S**3+(24*Q1C**2-16*M**2*Q1C)*S**2+(24*Q1C**3-8*M**2*
     9   Q1C**2)*S)*S2-24*M**2*Q1C**2*S**2)*UK**2+(2*Q1C*S*S2**4+(8*M**2
     :   *Q1C*S-6*Q1C*S**2)*S2**3+(6*Q1C*S**3+(-8*M**2*Q1C-16*M**4)*S**2
     ;   )*S2**2+(-4*Q1C*S**4+(-12*Q1C**2-16*M**2*Q1C)*S**3+(-24*Q1C**3-
     <   8*M**2*Q1C**2)*S**2-16*Q1C**4*S)*S2-16*M**2*Q1C**2*S**3)*UK-8*M
     =   **2*Q1C**2*S**2*S2**2+16*M**2*Q1C**2*S**3*S2-8*M**2*Q1C**2*S**4
     >   )*W1**2+((-2*Q1C*S**2-4*Q1C**2*S)*S2*UK**4+((6*Q1C**2*S-4*M**2*
     ?   S**2)*S2**2+((6*Q1C**2-4*M**2*Q1C)*S**2+(12*Q1C**3-16*M**2*Q1C*
     @   *2+16*M**4*Q1C)*S-16*M**2*Q1C**3)*S2)*UK**3+(-6*Q1C**2*S*S2**3+
     1   ((-12*M**2*Q1C-16*M**4)*S**2+(-12*Q1C**3-8*M**2*Q1C**2-16*M**4*
     2   Q1C)*S+16*M**2*Q1C**3)*S2**2+(-2*Q1C*S**4+(-6*Q1C**2-4*M**2*Q1C
     3   )*S**3+(-12*Q1C**3-16*M**2*Q1C**2+16*M**4*Q1C)*S**2+(-16*Q1C**4
     4   -16*M**2*Q1C**3)*S)*S2)*UK**2+(2*Q1C**2*S*S2**4+(6*Q1C**3+8*M**
     5   2*Q1C**2+16*M**4*Q1C)*S*S2**3+((8*Q1C**4+8*M**2*Q1C**3)*S-16*M*
     6   *4*Q1C*S**2)*S2**2+(2*Q1C**2*S**4+(6*Q1C**3+8*M**2*Q1C**2+16*M*
     7   *4*Q1C)*S**3+(8*Q1C**4+8*M**2*Q1C**3)*S**2+8*Q1C**5*S)*S2)*UK)*
     8   W1+(-4*M**2*Q1C*S**3+(-12*M**2*Q1C**2-16*M**4*Q1C-16*M**6)*S**2
     9   +(-16*M**2*Q1C**3-16*M**4*Q1C**2)*S-8*M**2*Q1C**4)*S2**2*UK**2)
     :   /(Q1C**2*S**2*S2**2*UK**2*W1**2)
      T2R1 = ((2*Q1C*Q2C*S2*TK**2+(4*Q1C**2*Q2C-2*Q1C*Q2C**2)*S2*TK+8*M*
     1   *2*Q1C**2*Q2C**2)*UK**4+((4*M**2*Q2C*S2**2+(6*Q1C*Q2C**2+(4*M**
     2   2*Q1C-6*Q1C**2)*Q2C)*S2)*TK**2+(-6*Q1C**2*Q2C*S2**2+(-6*Q1C*Q2C
     3   **3+(12*Q1C**2-8*M**2*Q1C)*Q2C**2+(-12*Q1C**3+16*M**2*Q1C**2-16
     4   *M**4*Q1C)*Q2C)*S2+16*M**2*Q1C**2*Q2C**2)*TK+(16*M**2*Q1C**3*Q2
     5   C-16*M**2*Q1C**2*Q2C**2)*S2)*UK**3+(2*Q1C*Q2C*S2*TK**4+(4*M**2*
     6   Q1C*S2**2+((6*Q1C**2+4*M**2*Q1C)*Q2C-6*Q1C*Q2C**2)*S2)*TK**3+((
     7   12*M**2*Q2C**2+(12*M**2*Q1C+16*M**4)*Q2C+12*M**2*Q1C**2+16*M**4
     8   *Q1C+16*M**6)*S2**2+(12*Q1C*Q2C**3+(16*M**2*Q1C-24*Q1C**2)*Q2C*
     9   *2+(12*Q1C**3+16*M**2*Q1C**2-16*M**4*Q1C)*Q2C)*S2+24*M**2*Q1C**
     :   2*Q2C**2)*TK**2+(6*Q1C**2*Q2C*S2**3+((12*Q1C**3+8*M**2*Q1C**2+1
     ;   6*M**4*Q1C)*Q2C+16*M**2*Q1C**3+16*M**4*Q1C**2)*S2**2+(-8*Q1C*Q2
     <   C**4+(24*Q1C**2-8*M**2*Q1C)*Q2C**3+(8*M**2*Q1C**2-24*Q1C**3)*Q2
     =   C**2+(16*Q1C**4+16*M**2*Q1C**3)*Q2C)*S2)*TK+(8*M**2*Q1C**2*Q2C*
     >   *2-16*M**2*Q1C**3*Q2C+8*M**2*Q1C**4)*S2**2)*UK**2+((4*Q1C*Q2C**
     ?   2-2*Q1C**2*Q2C)*S2*TK**4+(-6*Q1C*Q2C**2*S2**2+(-12*Q1C*Q2C**3+(
     @   12*Q1C**2+16*M**2*Q1C)*Q2C**2+(-6*Q1C**3-8*M**2*Q1C**2-16*M**4*
     1   Q1C)*Q2C)*S2+16*M**2*Q1C**2*Q2C**2)*TK**3+(6*Q1C*Q2C**2*S2**3+(
     2   (12*Q1C+16*M**2)*Q2C**3+(8*M**2*Q1C+16*M**4)*Q2C**2+16*M**4*Q1C
     3   *Q2C)*S2**2+(16*Q1C*Q2C**4+(16*M**2*Q1C-24*Q1C**2)*Q2C**3+(24*Q
     4   1C**3+8*M**2*Q1C**2)*Q2C**2+(-8*Q1C**4-8*M**2*Q1C**3)*Q2C)*S2)*
     5   TK**2+((-2*Q1C*Q2C**2-2*Q1C**2*Q2C)*S2**4+(-6*Q1C*Q2C**3-8*M**2
     6   *Q1C*Q2C**2+(-6*Q1C**3-8*M**2*Q1C**2-16*M**4*Q1C)*Q2C)*S2**3+(-
     7   8*Q1C*Q2C**4-8*M**2*Q1C*Q2C**3+(-8*Q1C**4-8*M**2*Q1C**3)*Q2C)*S
     8   2**2+(-8*Q1C*Q2C**5+16*Q1C**2*Q2C**4-24*Q1C**3*Q2C**3+16*Q1C**4
     9   *Q2C**2-8*Q1C**5*Q2C)*S2)*TK)*UK+8*M**2*Q1C**2*Q2C**2*TK**4+(16
     :   *M**2*Q1C*Q2C**3-16*M**2*Q1C**2*Q2C**2)*S2*TK**3+(8*M**2*Q2C**4
     ;   -16*M**2*Q1C*Q2C**3+8*M**2*Q1C**2*Q2C**2)*S2**2*TK**2)/(Q1C**2*
     <   Q2C**2*S2**2*TK**2*UK**2)
      T21R = -(8*Q2C*S*S2*TK*W2**5+(8*Q2C*S*S2*TK**2+(8*Q2C*S*S2**2+(-16
     1   *Q2C*S**2-16*Q2C**2*S)*S2)*TK-8*M**2*S**2*S2**2)*W2**4+(6*Q2C*S
     2   *S2*TK**3+((8*M**2*Q2C-24*Q2C**2)*S-12*Q2C*S**2)*S2*TK**2+(6*Q2
     3   C*S*S2**3+((-12*Q2C-16*M**2)*S**2+8*M**2*Q2C*S)*S2**2+(12*Q2C*S
     4   **3+(24*Q2C**2-16*M**2*Q2C)*S**2+24*Q2C**3*S)*S2)*TK+16*M**2*Q2
     5   C*S**2*S2**2-16*M**2*Q2C*S**3*S2)*W2**3+((2*Q2C*S*S2-8*M**2*Q2C
     6   **2)*TK**4+((-6*Q2C*S**2+(8*M**2*Q2C-12*Q2C**2)*S+16*M**2*Q2C**
     7   2)*S2-16*M**2*Q2C**2*S)*TK**3+((-12*M**2*S**2-8*M**2*Q2C**2)*S2
     8   **2+(6*Q2C*S**3+(24*Q2C**2-16*M**2*Q2C)*S**2+(24*Q2C**3-8*M**2*
     9   Q2C**2)*S)*S2-24*M**2*Q2C**2*S**2)*TK**2+(2*Q2C*S*S2**4+(8*M**2
     :   *Q2C*S-6*Q2C*S**2)*S2**3+(6*Q2C*S**3+(-8*M**2*Q2C-16*M**4)*S**2
     ;   )*S2**2+(-4*Q2C*S**4+(-12*Q2C**2-16*M**2*Q2C)*S**3+(-24*Q2C**3-
     <   8*M**2*Q2C**2)*S**2-16*Q2C**4*S)*S2-16*M**2*Q2C**2*S**3)*TK-8*M
     =   **2*Q2C**2*S**2*S2**2+16*M**2*Q2C**2*S**3*S2-8*M**2*Q2C**2*S**4
     >   )*W2**2+((-2*Q2C*S**2-4*Q2C**2*S)*S2*TK**4+((6*Q2C**2*S-4*M**2*
     ?   S**2)*S2**2+((6*Q2C**2-4*M**2*Q2C)*S**2+(12*Q2C**3-16*M**2*Q2C*
     @   *2+16*M**4*Q2C)*S-16*M**2*Q2C**3)*S2)*TK**3+(-6*Q2C**2*S*S2**3+
     1   ((-12*M**2*Q2C-16*M**4)*S**2+(-12*Q2C**3-8*M**2*Q2C**2-16*M**4*
     2   Q2C)*S+16*M**2*Q2C**3)*S2**2+(-2*Q2C*S**4+(-6*Q2C**2-4*M**2*Q2C
     3   )*S**3+(-12*Q2C**3-16*M**2*Q2C**2+16*M**4*Q2C)*S**2+(-16*Q2C**4
     4   -16*M**2*Q2C**3)*S)*S2)*TK**2+(2*Q2C**2*S*S2**4+(6*Q2C**3+8*M**
     5   2*Q2C**2+16*M**4*Q2C)*S*S2**3+((8*Q2C**4+8*M**2*Q2C**3)*S-16*M*
     6   *4*Q2C*S**2)*S2**2+(2*Q2C**2*S**4+(6*Q2C**3+8*M**2*Q2C**2+16*M*
     7   *4*Q2C)*S**3+(8*Q2C**4+8*M**2*Q2C**3)*S**2+8*Q2C**5*S)*S2)*TK)*
     8   W2+(-4*M**2*Q2C*S**3+(-12*M**2*Q2C**2-16*M**4*Q2C-16*M**6)*S**2
     9   +(-16*M**2*Q2C**3-16*M**4*Q2C**2)*S-8*M**2*Q2C**4)*S2**2*TK**2)
     :   /(Q2C**2*S**2*S2**2*TK**2*W2**2)
      END


      subroutine qqbplanar(p1,ip1,p2,ip2,k,ik,k1,k2,m2,
     # t1r,t2r)
      implicit none
      real * 8 p1(4),p2(4),k(4),k1(4),k2(4)
      REAL * 8 s,tk,uk,q1,q2,q1c,q2c,w1,w2,m,s2,
     # m2,t1r,t2r
      real * 8 dotprod
      external dotprod
      integer ip1,ip2,ik
c Planar invariant squared amplitudes, summed over spins and color 
c for the planar lq lqb -> q qbar g process; misses a factor Ncolor^4 
c k1: quark momentum 
c k2: anti-quark momentum 
c p1: incoming light quark momentum 
c p2: incoming light antiquark momentum 
c k: radiated gluon momentum 
c 
c return values: 
c t1r: planar configuration p1,k,k1 
c t2r: planar configuration p2,k,k2 
c 
c    d(p1,p1)=0 
c    d(p2,p2)=0 
c    d(k,k)=0 
c    d(k1,k1)=m2 
c    d(k2,k2)=m2 
c    d(p1,p2)=s/2 
c    d(p1,k)=-tk/2 
c    d(p2,k)=-uk/2 
c    d(p1,k1)=-q1/2 
c    d(p2,k2)=-q2/2 
c    d(k1,k2)=(s2-2*m2)/2 
c    d(p1,k2)=-q1c/2 
c    d(p2,k1)=-q2c/2 
c    d(k,k1)=w1/2 
c    d(k,k2)=w2/2 
c 
c  Relations among invariants 
c 
      m=sqrt(m2)
      s=2*dotprod(p1,p2)*ip1*ip2
      tk=-2*dotprod(p1,k)*ip1*ik
      uk=-2*dotprod(p2,k)*ip2*ik
      q1=-2*dotprod(p1,k1)*ip1
      q2=-2*dotprod(p2,k2)*ip2
      s2=s+tk+uk 
      q1c=-s-tk-q1 
      q2c=-s-uk-q2 
      w1=-q1+q2-tk 
      w2=q1-q2-uk 
      T1R = -(4*S*S2*W1**4+(8*S*S2*TK+(-4*S**2-12*Q2*S)*S2)*W1**3+(8*M**
     1   2*TK**3+((8*S-16*M**2)*S2+16*M**2*S)*TK**2+((8*M**2-4*S)*S2**2+
     2   ((-20*Q2-12*M**2)*S-4*S**2)*S2+12*M**2*S**2)*TK+2*S*S2**3+(4*Q2
     3   +4*M**2)*S*S2**2+(2*S**3+(8*Q2+4*M**2)*S**2+16*Q2**2*S)*S2+4*M*
     4   *2*S**3)*W1**2+(4*S*S2*TK**3+(((8*M**2-12*Q2)*S+16*M**2*Q2)*S2-
     5   4*S*S2**2)*TK**2+(2*S*S2**3+(8*Q2*S-16*M**2*Q2)*S2**2+(2*S**3+(
     6   4*Q2+12*M**2)*S**2+(16*Q2**2+16*M**2*Q2)*S)*S2)*TK-2*Q2*S*S2**3
     7   +(-4*Q2**2-4*M**2*Q2)*S*S2**2+(-2*Q2*S**3+(-4*Q2**2-4*M**2*Q2)*
     8   S**2-8*Q2**3*S)*S2)*W1+(4*M**2*S**2+(8*M**2*Q2+8*M**4)*S+8*M**2
     9   *Q2**2)*S2**2*TK)/(S**2*S2**2*TK*W1**2)
      T2R = -(4*S*S2*W2**4+(8*S*S2*UK+(-4*S**2-12*Q1*S)*S2)*W2**3+(8*M**
     1   2*UK**3+((8*S-16*M**2)*S2+16*M**2*S)*UK**2+((8*M**2-4*S)*S2**2+
     2   ((-20*Q1-12*M**2)*S-4*S**2)*S2+12*M**2*S**2)*UK+2*S*S2**3+(4*Q1
     3   +4*M**2)*S*S2**2+(2*S**3+(8*Q1+4*M**2)*S**2+16*Q1**2*S)*S2+4*M*
     4   *2*S**3)*W2**2+(4*S*S2*UK**3+(((8*M**2-12*Q1)*S+16*M**2*Q1)*S2-
     5   4*S*S2**2)*UK**2+(2*S*S2**3+(8*Q1*S-16*M**2*Q1)*S2**2+(2*S**3+(
     6   4*Q1+12*M**2)*S**2+(16*Q1**2+16*M**2*Q1)*S)*S2)*UK-2*Q1*S*S2**3
     7   +(-4*Q1**2-4*M**2*Q1)*S*S2**2+(-2*Q1*S**3+(-4*Q1**2-4*M**2*Q1)*
     8   S**2-8*Q1**3*S)*S2)*W2+(4*M**2*S**2+(8*M**2*Q1+8*M**4)*S+8*M**2
     9   *Q1**2)*S2**2*UK)/(S**2*S2**2*UK*W2**2)
      END

      subroutine genjflborn
c it picks a flavour with a probability proportional
c to its contribution (stored in common/cresults/results)
      integer jflborn
      common/cjflborn/jflborn
      real * 8 results(-5:5)
      common/cresults/results
      call genindex(results(-5),11,jflborn)
      jflborn=jflborn-6
      end


      subroutine genindex(vec,n,jres)
c generates a random index 1<= j <=n with probability
c proportional to vec(genindex)
      implicit none
      integer n,jres
      real * 8 vec(n)
      real * 8 tot(100)
      integer j
      real * 8 x
      real * 8 random
      external random
      if(n.gt.99) then
         write(*,*) ' genindex: n=',n,'>99; increase limits'
         stop
      endif
      tot(1)=0
      do j=1,n
         tot(j+1)=tot(j)+vec(j)
      enddo
      x=random()*tot(n+1)
      do j=1,n
         if(x.lt.tot(j+1)) then
            jres=j
            return
         endif
      enddo
      end


      subroutine maxrat(xnorm)
c sets the normalization for upper bounding function in unorm
c (factor N_q in 5.20 in ZZ paper)
      implicit none
      real * 8 ptminsq
      common/cptmin/ptminsq
      real * 8 xnorm,ptsq,qqqq,qqgg,qqqg,qqgq,
     #  qgrres(-5:5),gqrres(-5:5),sigb
      real * 8 x1b,x2b
      common/x1x2born/x1b,x2b
      real * 8 x1,x2
      common/x1x2real/x1,x2
      include 'fixvar-hvq.h'
      real * 8 xmaxq
      parameter (xmaxq=0.9d0)
      real * 8 qqb,upper,pt2
      logical refusepdf
      external qqb,upper,pt2,refusepdf
      ptsq=pt2()
      xnorm=0
      if(ptsq.gt.ptminsq) then
            sigb = qqb()
            if(sigb.gt.0.and.x1.lt.xmaxq.and.x2.lt.xmaxq
     #              .and.xmufct2.gt.2.and..not.refusepdf()) then
               call qqr(qqgg,qqqq,qqqg,qqgq,qgrres,gqrres)
               xnorm = (qqgg+qqqq+qqqg+qqgq)/(sigb*upper())
            else
               xnorm=0
            endif
      endif
      end

      function refusepdf()
c Some pdf have (inconsistently) vanishing quark density at x values
c when the gluon density is not zero; cannot use these points to compute
c maxrat
      implicit none
      logical refusepdf
      include 'fixvar-hvq.h'
      integer jflborn
      common/cjflborn/jflborn
      real * 8 x1b,x2b
      common/x1x2born/x1b,x2b
      character * 2 prc
      common/process/prc
      real * 8 sf(-5:5),ss,suppfc,x
      suppfc(x)=(1-x)*x
      if(jflborn.eq.0) then
         prc='gg'
      else
         prc='qq'
      endif
      if(prc.eq.'qq') then
         call strfun(x1b,x2b,sf)
         ss=sf(jflborn)
         prc='qg'
         call strfun(x1b,x2b,sf)
         if(sf(jflborn)*suppfc(x2b).gt.30*ss) then
c i.e. fg(x2)*x2*(1-x2) > 30*fq(x2)
            refusepdf=.true.
            call increasecnt('Suspect pdf values')
            return
         endif
         prc='gq'
         call strfun(x1b,x2b,sf)
         if(sf(jflborn)*suppfc(x1b).gt.30*ss) then
c i.e. fg(x1)*x1*(1-x1) > 30*fq(x1)
            refusepdf=.true.
            call increasecnt('Suspect pdf values')
            return
         endif
      endif
      refusepdf=.false.
      end


      function pt2solve(pt2,i)
c Returns  xlr - log(\Delta^{(\tilde{V})}) , see eq. D14, D15 in ZZ paper
c We use it to find its zero in pt2.
      implicit none
      real * 8 pt2solve,pt2
c i set by dzero: 1 for first call, 2 for subsequent calls, 3 for last call
c before a normal exit; not used here
      integer i
      real * 8 pi
      parameter (pi=3.141592653589793d0)
      real * 8 xlr,q2,xlam2c,kt2max,cunorm
      integer nlc
      common/cpt2solve/xlr,q2,kt2max,xlam2c,cunorm,nlc
      real * 8 m2qq,yqq,ro,cth1
      common/vvars/m2qq,yqq,ro,cth1
      integer iupper
      common/cupper/iupper
      real * 8 b0
      b0=(33-2*nlc)/(12*pi)
      if(iupper.eq.2) then
         pt2solve=cunorm*pi/b0/2
     #        *(log(q2/xlam2c)*log(log(kt2max/xlam2c)/log(pt2/xlam2c))
     #        - log(kt2max/pt2)) + xlr
      elseif(iupper.eq.1) then
         if(pt2.lt.m2qq) then
            if(m2qq.lt.kt2max) then
               pt2solve=cunorm*pi/b0/2*(
     #        (log(2*m2qq/xlam2c)*log(log(m2qq/xlam2c)/log(pt2/xlam2c))
     #        - log(m2qq/pt2)) +
     #           log(2d0)*log(log(kt2max/xlam2c)/log(m2qq/xlam2c)))
     #           + xlr
            else
               pt2solve=cunorm*pi/b0/2*(
     #     (log(2*m2qq/xlam2c)*log(log(kt2max/xlam2c)/log(pt2/xlam2c))
     #        - log(kt2max/pt2)) )
     #           + xlr
            endif
         else
            pt2solve=cunorm*pi/b0/2*(log(2d0)
     #           *log(log(kt2max/xlam2c)/log(pt2/xlam2c)))
     #           + xlr
         endif
      endif
      end


      function dfxmin(y,i)
      implicit none
      real * 8 dfxmin,y
      integer i
      real * 8 x1b,x2b
      common/x1x2born/x1b,x2b
      real * 8 xmin
      common/cdfxmin/xmin
      real * 8 df1,df2
      df1=2*(1+y)*x1b**2/(sqrt((1+x1b**2)**2*(1-y)**2+16*y*x1b**2)
     # +(1-y)*(1-x1b**2))
      df2=2*(1-y)*x2b**2/(sqrt((1+x2b**2)**2*(1+y)**2-16*y*x2b**2)
     # +(1+y)*(1-x2b**2))
      dfxmin=df1-df2
      xmin=max(df1,df2)
      if(xmin.lt.min(x1b,x2b)/4*sqrt(x1b*x2b)) then
         write(*,*) ' problem with bnd'
      endif
      end

      subroutine genptxy
c Generates hard radiation kinematics according to
c appendix D in ZZ paper.
c
c  common/cptmin/ptminsq: minimum pt^2 accepted
c 
      implicit none
      include 'fixvar-hvq.h'
      real * 8 m2qq,yqq,ro,cth1
      common/vvars/m2qq,yqq,ro,cth1
      real * 8 unorm
      common/cunorm/unorm
      integer jflborn
      common/cjflborn/jflborn
      integer jflreal
      common/cjflreal/jflreal
      character * 2 genprc
      common/cgenprc/genprc
      real * 8 ptminsq
      common/cptmin/ptminsq
      real * 8 x
      common/xval/x
      real * 8 xscaled,y,th2
      common/rvars/xscaled,y,th2
      real * 8 x1b,x2b
      common/x1x2born/x1b,x2b
      real * 8 xlr,q2,xlam2c,kt2max,cunorm
      integer nlc
      common/cpt2solve/xlr,q2,kt2max,xlam2c,cunorm,nlc
      integer iupper
      common/cupper/iupper
      real * 8 asscfc
      common/casscfc/asscfc
      real * 8 xmin,t,rv,xp,xm,chi,tk,uk,qqqq0,ubound,ufct,
     #   qqqq,qqgg,qqqg,qqgq,qgrres(-5:5),gqrres(-5:5),
     #   value,err,tmp1,tmp2,tmp,rvalue
      common/cdfxmin/xmin
      include 'mathpar.h'
      real * 8 random,alfas,alfas0,qqb,pt2solve,dfxmin,upper
      external random,alfas,alfas0,qqb,pt2solve,dfxmin,upper
      integer ix,iy
      call KERSET('C205. ',0,0,101)
      call dzero(-1d0,1d0,y,err,1d-8,1000000,dfxmin)
c this call sets xmin
      tmp=dfxmin(y,0)
c see Notes/kt2max.pdf
      kt2max = m2qq*(1-x2b**2)*(1-x1b**2)/(x1b+x2b)**2
      if(kt2max.lt.ptminsq) then
         t=0
         goto 3
      endif
c upper bound is log(q2/t)
      if(iupper.eq.1) then
         q2=2*m2qq
      elseif(iupper.eq.2) then
         q2=4*m2qq/min(x1b,x2b)**2
      endif
c see section 4 in ZZ paper, last paragraph
      xlam2c=xlamnl**2
      cunorm=unorm
      nlc=nl
      xlr=0
 1    continue
      xlr=xlr+log(random())
c dzero(xmin,xmax,x(return value),err(return value),requested accuracy, max number of calls, f(x))
      call dzero(ptminsq,kt2max,t,err,1d-8,1000000,pt2solve)
c error conditions
      if(t.eq.0.and.err.lt.0d0
     # .and.err.gt.ptminsq-kt2max) then
         write(*,*) 'DZERO fails'
         write(*,*) ' number of calls exceeded'
         stop
      endif
 3    if(t.lt.ptminsq) then
c below cut: generate a 2-body event
         if(jflborn.eq.0) then
            genprc='gg'
         else
            genprc='qq'
         endif
         call bornmoms
         return
      endif
c vetoes:
      rv=random()
      xp=(sqrt(1+t/m2qq)+sqrt(t/m2qq))**2
      xm=(sqrt(1+t/m2qq)-sqrt(t/m2qq))**2
c tmp1: V(t)/\tilde{V}(t) in appendix D of ZZ paper;
c (typo: in D.13, log log -> log
      xmin=min(x1b,x2b)/(2*sqrt(1+t/m2qq))
      if(iupper.eq.1) then
         tmp1=log((sqrt(xp-xmin)+sqrt(xm-xmin))
     #       /(sqrt(xp-xmin)-sqrt(xm-xmin)))
         if(t.lt.m2qq) then
            tmp1=tmp1/(log(2*m2qq/t)/2)
         else
            tmp1=tmp1/(log(2d0)/2)
         endif
      elseif(iupper.eq.2) then
         tmp1=log(2/xmin*(sqrt((xp-xmin)*(xm-xmin))
     # +1-xmin/2*(xp+xm))/(xp-xm)) /(log(q2/t)/2)
      endif
c compare with D.11-D.12
c to set xmuren2:
      call setscalesrad(t)
      tmp2=alfas(xmuren2,xlamc,nl)/alfas0(t,xlamnl,nl)
      tmp=tmp1*tmp2
      if(tmp.gt.1) then
         write(*,*) ' errore: maggiorante non maggiora',
     #        tmp,tmp1,tmp2,xmuren2,t
         stop
      endif
      if(rv.gt.tmp) then
         goto 1
      endif
c At this stage: pt generated according to D.2
c generate x proportional to 1/(x sqrt((xp-x)*(xm-x)))
c in the range xmin < x < xm (cf. D.5)
c Generate in d sqrt(xm-x) /sqrt(xp-x)  (iupper=1) or d sqrt(xm-x) /(x sqrt(xp-x)) (iupper=2)
c using       d sqrt(xm-x) /sqrt(xp-xm) (iupper=1) or d sqrt(xm-x) /(xmin sqrt(xp-xm)) (iupper=2) as upper bound using hit and miss
 2    chi=sqrt(xm-xmin)*random()
      x=xm-chi**2
      if(iupper.eq.1) then
         if(random().gt.sqrt(xp-xm)/sqrt(xp-x)) goto 2
      elseif(iupper.eq.2) then
         if(random().gt.(xmin*sqrt(xp-xm))/(x*sqrt(xp-x))) goto 2
      endif
c get y (abs to avoid tiny negative values)
      y=sqrt(abs(1-4*x/(1-x)**2*t/m2qq))
      if(random().gt.0.5d0) y=-y
      th2 = 2*pi*random()
c At this point an x-y pair is generated according to the
c distribution upper().
c
c Veto if out of range (x1>1 or x2>1)
      tk=-1d0/2*(1-x)*(1-y)
      uk=-1d0/2*(1-x)*(1+y)
      if(   x1b*sqrt((1+tk)/(1+uk)/x) .gt. 1
     # .or. x2b*sqrt((1+uk)/(1+tk)/x) .gt. 1) then
         goto 1
      endif
c extra suppression factor of upper bounding function (may depend upon radiation variables)
      call uboundfct(ufct,ix,iy)
      if(random().gt.ufct) goto 1
c Veto from upper bound to real value. Count how many vetoes,
c since these may be expensive.
      qqqq0=qqb()
      if(qqqq0.lt.0) then
         qqqq0=0
      endif
      ubound=qqqq0*upper()*unorm*ufct
      call qqr(qqgg,qqqq,qqqg,qqgq,qgrres,gqrres)
      value=qqqq+qqgg+qqqg+qqgq
      if(value.gt.ubound) then
         call increasecnt(
     # 'upper bound failures in generation of radiation')
      endif
      rvalue=random()*ubound
      if(rvalue.gt.value) then
         call increasecnt('vetoed radiation')
         goto 1
      else
         if(jflborn.ne.0.and.rvalue.lt.qqqq) then
            genprc='qq'
         elseif(jflborn.eq.0.and.rvalue.lt.qqgg)then
            genprc='gg'
         elseif(rvalue.lt.qqqq+qqgg+qqqg)then
            genprc='qg'
         else
            genprc='gq'
         endif
         jflreal=jflborn
         if(jflborn.eq.0) then
            if(genprc.eq.'qg') then
c     in this cases (qg and gq with underlying Born = gg) the process
c     flavour differs from the underlying Born flavour
               call genindex(qgrres(-5),11,jflreal)
c     returns jflreal=1,...,11; shift back to -5,...,5
               jflreal=jflreal-6
            elseif(genprc.eq.'gq') then
               call genindex(gqrres(-5),11,jflreal)
               jflreal=jflreal-6
            endif
         endif
      endif
      end

      function upper()
      implicit none
      real * 8 upper
      include 'fixvar-hvq.h'
      real * 8 xscaled,y,th2
      common/rvars/xscaled,y,th2
      real * 8 x
      common/xval/x
      real * 8 asscfc
      common/casscfc/asscfc
      integer iupper
      common/cupper/iupper
      real * 8 pt2,alfas
      external pt2,alfas
      call setscalesrad(pt2())
      if(iupper.eq.1) then
         upper = 1/((1-x)*(1-y**2))*alfas(xmuren2,xlamc,nl)
      elseif(iupper.eq.2) then
         upper = 1/(x*(1-x)*(1-y**2))*alfas(xmuren2,xlamc,nl)
      elseif(iupper.eq.3) then
         upper = 1/(x**2*(1-x)*(1-y**2))*alfas(xmuren2,xlamc,nl)
      endif
      end

      function pt2()
      implicit none
      real * 8 pt2
      real * 8 m2qq,yqq,ro,cth1
      common/vvars/m2qq,yqq,ro,cth1
      real * 8 xscaled,y,th2
      common/rvars/xscaled,y,th2
      real * 8 x
      common/xval/x
      pt2=m2qq/(4*x)*(1-x)**2*(1-y**2)
      end

      subroutine qqr(gg,qq,qg,gq,qgrres,gqrres)
c integrated in d x dy (-1,1) dth2 (0,pi)
c d m2qq d yqq d cth1 yields the physical
c cross section real contributions for a
c fixed underlying born configuration jflborn.
c qqrres is only relevant when jflborn=0 (gg underlying born)
c in the gq or qg subprocess; the flavour of the quark
c should be decided in proportion to qqrres
      implicit none
      real * 8 qq,gg,qg,gq,qgrres(-5:5),gqrres(-5:5)
      real * 8 rres(-5:5)
      include 'mathpar.h'
      include 'fixvar-hvq.h'
      integer jflborn
      common/cjflborn/jflborn
      real * 8 xscaled,y,th2
      common/rvars/xscaled,y,th2
      real * 8 x
      common/xval/x
      character * 2 prc
      common/process/prc
      real * 8 pt2,alfas,xyfacp,xyfacm
      integer j
      call setscalesrad(pt2())
      xyfacp=1/((1-y)*(1-x))
      xyfacm=1/((1+y)*(1-x))
      as=alfas(xmuren2,xlamc,nl)
      if(jflborn.ne.0) then
         prc='qq'
         call  hvqr0(x,y,th2,rres)
         qq=rres(jflborn)*(xyfacp+xyfacm)
         if(qq.lt.0) qq=0
         gg=0
      else
         prc='gg'
         call  hvqr0(x,y,th2,rres)
         gg=rres(jflborn)*(xyfacp+xyfacm)
         if(gg.lt.0) gg=0
         qq=0
      endif
      prc='qg'
      call  hvqr0(x,y,th2,rres)
      do j=-5,5
         if(rres(j).lt.0) rres(j)=0
      enddo
      if(jflborn.eq.0) then
         qg=0
         do j=1,5
c Fix: 2/3/2007
            qg=qg+(rres(j)+rres(-j))*xyfacp
         enddo
         do j=-5,5
            qgrres(j)=rres(j)
         enddo
      else
c Fix: 2/3/2007
         qg=rres(jflborn)*xyfacm
      endif
      prc='gq'
      call  hvqr0(x,y,th2,rres)
      do j=-5,5
         if(rres(j).lt.0) rres(j)=0
      enddo
      if(jflborn.eq.0) then
         gq=0
         do j=1,5
c Fix: 2/3/2007
            gq=gq+(rres(j)+rres(-j))*xyfacm
         enddo
         do j=-5,5
            gqrres(j)=rres(j)
         enddo
      else
c Fix: 2/3/2007
         gq=rres(jflborn)*xyfacp
      endif
      end

      function qqb()
c integrated in d m2qq d yqq d cth1 yields the physical
c cross section
c The factorization scale is computed at the "low"
c scale, according to the value of pt2()
      implicit none
      real * 8 qqb
      include 'fixvar-hvq.h'
      integer jflborn
      common/cjflborn/jflborn
      real * 8 results(-5:5)
      real * 8 asscfc
      common/casscfc/asscfc
      character * 2 prc
      common/process/prc      
      real * 8 pt2,alfas
      external pt2,alfas
      include 'mathpar.h'
      call setscalesrad(pt2())
      as=alfas(xmuren2,xlamc,nl)
      call bbarrab(results)
      qqb=results(jflborn)
      end

      subroutine bornmoms
      implicit none
      real * 8 x
      common/xval/x
      real * 8 xscaled,y,th2
      common/rvars/xscaled,y,th2
      include 'fixvar-hvq.h'
      real * 8 m2qq,yqq,ro,cth1
      common/vvars/m2qq,yqq,ro,cth1
      real *  8 s,t,u,xth2,q1q,q2q,q1c,q2c,w1,w2,w1h,w2h
      x=1
      y=0
      xth2=0
      s=m2qq
      call invar(xm2,s,x,y,cth1,xth2,'bi',t,u,
     #           q1q,q2q,q1c,q2c,w1,w2,w1h,w2h)
      end


      subroutine realmoms
      implicit none
      real * 8 x
      common/xval/x
      real * 8 xscaled,y,th2
      common/rvars/xscaled,y,th2
      include 'fixvar-hvq.h'
      real * 8 m2qq,yqq,ro,cth1
      common/vvars/m2qq,yqq,ro,cth1
      real *  8 s,t,u,q1q,q2q,q1c,q2c,w1,w2,w1h,w2h
      s=m2qq/x
      call invar(xm2,s,x,y,cth1,th2,'bi',t,u,
     #           q1q,q2q,q1c,q2c,w1,w2,w1h,w2h)
      end


c Integrator Package for POWHEG
c      subroutine mint(fun,ndim,ncalls0,nitmax,imode,
c ndim=number of dimensions
c ncalls0=# of calls per iteration
c nitmax =# of iterations
c fun(xx,www,ifirst): returns the function to be integrated multiplied by www;
c                     xx(1:ndim) are the variables of integration
c                     ifirst=0: normal behaviour
c imode: integer flag
c
c imode=0:
c When called with imode=0 the routine integrates the absolute value of the function
c and sets up a grid xgrid(0:50,ndim) such that in each ndim-1 dimensional slice
c (i.e. xgrid(m-1,n)<xx(n)<xgrid(m,n)) the contribution of the integral is the same
c the array xgrid is setup at this stage; ans and err are the integral and its error 
c
c imode=1 (in fact #0)
c When called with imode=1, the routine performs the integral of the function fun
c using the grid xgrid. If some number in the array ifold, (say, ifold(n))
c is different from 1, it must be a divisor of 50, and the 50 intervals xgrid(0:50,n)
c are grouped into ifold(n) groups, each group containing 50/ifold(n) nearby
c intervals. For example, if ifold(1)=5, the 50 intervals for the first dimension
c are divided in 5 groups of 10. The integral is then performed by folding on top
c of each other these 5 groups. Suppose, for example, that we choose a random point
c in xx(1) = xgrid(2,1)+x*(xgrid(3,1)-xgrid(2,1)), in the group of the first 5 interval.
c we sum the contribution of this point to the contributions of points
c xgrid(2+m*10,1)+x*(xgrid(3+m*10,1)-xgrid(2+m*10,1)), with m=1,...,4.
c In the sequence of calls to the
c function fun, the call for the first point is performed with ifirst=0, and that for
c all subsequent points with ifirst=1, so that the function can avoid to compute
c quantities that only depend upon dimensions that have ifold=1, and do not change
c in each group of folded call. The values returned by fun in a sequence of folded
c calls with ifirst=0 and ifirst=1 are not used. The function itself must accumulate
c the values, and must return them when called with ifirst=2.
c 

      subroutine mint(fun,ndim,ncalls0,nitmax,imode,
     #     xgrid,ymax,ans,err)
c imode=0: integrate and adapt the grid
c imode=1: frozen grid, compute the integral and the upper bounds
c others: same as 1 (for now)
      implicit none
      integer nintervals,ndimmax
      parameter (nintervals=50,ndimmax=6)
      integer ncalls0,ndim,nitmax,imode
      real * 8 fun,xgrid(0:nintervals,ndim),ymax(nintervals,ndim),
     #  ans,err
      real * 8 x(ndimmax),vol
      real * 8 xacc(0:nintervals,ndimmax)
      integer icell(ndimmax),ncell(ndimmax)
      integer ifold(ndimmax),kfold(ndimmax)
      common/cifold/ifold
      integer nhits(1:nintervals,ndimmax)
      real * 8 rand(ndimmax)
      real * 8 dx(ndimmax),f,vtot,etot,prod
      integer kdim,kint,kpoint,nit,ncalls,ibin,iret,nintcurr,ifirst
      real * 8 random
      external random,fun
      if(imode.eq.0) then
         do kdim=1,ndim
            ifold(kdim)=1
            do kint=0,nintervals
               xgrid(kint,kdim)=dble(kint)/nintervals
            enddo
         enddo
      elseif(imode.eq.1) then
         do kdim=1,ndim
            nintcurr=nintervals/ifold(kdim)
            do kint=1,nintcurr
               ymax(kint,kdim)=
     #              ans**(1d0/ndim)
            enddo
         enddo
      endif
      ncalls=ncalls0
      nit=0
      ans=0
      err=0
 10   continue
      nit=nit+1
      if(nit.gt.nitmax) return
      if(imode.eq.0) then
         do kdim=1,ndim
            do kint=0,nintervals
               xacc(kint,kdim)=0
               if(kint.gt.0) then
                  nhits(kint,kdim)=0
               endif
            enddo
         enddo
      endif
      vtot=0
      etot=0
      do kpoint=1,ncalls
c find random x, and its random cell
         do kdim=1,ndim
            kfold(kdim)=1
            ncell(kdim)=nintervals/ifold(kdim)*random()+1
            rand(kdim)=random()
         enddo
         f=0
         ifirst=0
 1       continue
         vol=1
         do kdim=1,ndim
            nintcurr=nintervals/ifold(kdim)
            icell(kdim)=ncell(kdim)+(kfold(kdim)-1)*nintcurr
            ibin=icell(kdim)
            dx(kdim)=xgrid(icell(kdim),kdim)-xgrid(icell(kdim)-1,kdim)
            vol=vol*dx(kdim)*nintcurr
            x(kdim)=xgrid(icell(kdim)-1,kdim)+rand(kdim)*dx(kdim)
            if(imode.eq.0) nhits(ibin,kdim)=nhits(ibin,kdim)+1
         enddo
c contribution to integral
         if(imode.eq.0) then
            f=abs(fun(x,vol,ifirst))+f
         else
c this accumulated value will not be used (see bbbarra(x,x,2))
            f=fun(x,vol,ifirst)+f
            ifirst=1
            call nextlexi(ndim,ifold,kfold,iret)
            if(iret.eq.0) goto 1
c closing call: accumulated value with correct sign
            f=fun(x,vol,2)
         endif
c
         if(imode.eq.0) then
c accumulate the function in xacc(icell(kdim),kdim) to adjust the grid later
            do kdim=1,ndim
               xacc(icell(kdim),kdim)=xacc(icell(kdim),kdim)+f
            enddo
         else
            prod=1
            do kdim=1,ndim
               prod=prod*ymax(ncell(kdim),kdim)
            enddo
            prod=(f/prod)
            if(prod.gt.1) then
c This guarantees a 10% increase of the upper bound in this cell
               prod=1+0.1d0/ndim
               do kdim=1,ndim
                  ymax(ncell(kdim),kdim)=ymax(ncell(kdim),kdim)
     #          * prod
               enddo
            endif
         endif
         vtot=vtot+f/ncalls
         etot=etot+f**2/ncalls
      enddo
      if(imode.eq.0) then
c iteration is finished; now rearrange the grid
         do kdim=1,ndim
            call regrid(xacc(0,kdim),xgrid(0,kdim),
     #           nhits(1,kdim),nintervals,nit)
         enddo
      endif
      etot=sqrt((etot-vtot**2)/ncalls)
      write(*,*) vtot,etot
      if(nit.eq.1) then
         ans=vtot
         err=etot
      else
c protect against zero error!
c         ans=(ans/err+vtot/etot)/(1/err+1/etot)
         ans=(ans*etot**2+vtot*err**2)/(err**2+etot**2)
         if(err.ne.0.and.etot.ne.0) then
            err=1/sqrt(1/err**2+1/etot**2)
         else
c if one is zero, pick the non-zero one.
            err=err+etot
         endif
      endif
      goto 10
      end

      subroutine regrid(xacc,xgrid,nhits,nint,nit)
      implicit none
      integer  nint,nhits(nint),nit
      real * 8 xacc(0:nint),xgrid(0:nint)
      real * 8 xn(100),r
      integer kint,jint
      do kint=1,nint
c xacc (xerr) already containe a factor equal to the interval size
c Thus the integral of rho is performed by summing up
         if(nhits(kint).ne.0) then
            xacc(kint)= xacc(kint-1)
     #           + abs(xacc(kint))/nhits(kint)
         else
            xacc(kint)=xacc(kint-1)
         endif
      enddo
      do kint=1,nint
         xacc(kint)=xacc(kint)/xacc(nint)
      enddo
      write(11,*) 'set limits x 0 1 y 0 1'
      write(11,*) 0, 0
      do kint=1,nint
         write(11,*) xgrid(kint),xacc(kint)
      enddo
      write(11,*) 'join 0'

      do kint=1,nint
         r=dble(kint)/nint

         write(11,*) 0, r
         write(11,*) 1, r
         write(11,*) ' join'

         do jint=1,nint
            if(r.lt.xacc(jint)) then
               xn(kint)=xgrid(jint-1)+(r-xacc(jint-1))
     #        /(xacc(jint)-xacc(jint-1))*(xgrid(jint)-xgrid(jint-1))
               goto 11
            endif
         enddo
         if(jint.ne.nint+1.and.kint.ne.nint) then
            write(*,*) ' error',jint,nint
            stop
         endif
         xn(nint)=1
 11      continue
      enddo
      do kint=1,nint
         xgrid(kint)=xn(kint)
c         xgrid(kint)=(xn(kint)+2*xgrid(kint))/3
c         xgrid(kint)=(xn(kint)+xgrid(kint)*log(dble(nit)))
c     #        /(log(dble(nit))+1)
         write(11,*) xgrid(kint), 0
         write(11,*) xgrid(kint), 1
         write(11,*) ' join'
      enddo
      write(11,*) ' newplot'
      end


c      implicit none
c      integer ndim
c      parameter (ndim=3)
c      integer iii(ndim),kkk(ndim)
c      integer j,iret
c      data kkk/1,1,1/
c      data iii/2,3,2/
c 1    continue
c      write(*,*) (kkk(j),j=1,3)
c      call nextlexi(ndim,iii,kkk,iret)
c      if(iret.eq.0) then
c         goto 1
c      endif
c      end

      subroutine nextlexi(ndim,iii,kkk,iret)
c kkk: array of integers 1 <= kkk(j) <= iii(j), j=1,ndim
c at each call iii is increased lexicographycally.
c for example, starting from ndim=3, kkk=(1,1,1), iii=(2,3,2)
c subsequent calls to nextlexi return
c         kkk(1)      kkk(2)      kkk(3)    iret
c 0 calls   1           1           1       0
c 1         1           1           2       0    
c 2         1           2           1       0
c 3         1           2           2       0
c 4         1           3           1       0
c 5         1           3           2       0
c 6         2           1           1       0
c 7         2           1           2       0
c 8         2           2           1       0
c 9         2           2           2       0
c 10        2           3           1       0
c 11        2           3           2       0
c 12        2           3           2       1
      implicit none
      integer ndim,iret,kkk(ndim),iii(ndim)
      integer k
      k=ndim
 1    continue
      if(kkk(k).lt.iii(k)) then
         kkk(k)=kkk(k)+1
         iret=0
         return
      else
         kkk(k)=1
         k=k-1
         if(k.eq.0) then
            iret=1
            return
         endif
         goto 1
      endif
      end


      subroutine gen(fun,ndim,xgrid,ymax,imode,x)
c imode=0 to initialize
c imode=1 to generate
c imode=3 store generation efficiency in x(1)
      implicit none
      integer ndim,imode
      integer nintervals,ndimmax
      parameter (nintervals=50,ndimmax=6)
      real * 8 fun,xgrid(0:nintervals,ndim),
     #         ymax(nintervals,ndim),x(ndim)
      real * 8 dx(ndimmax)
      integer icell(ndimmax),ncell(ndimmax)
      integer ifold(ndimmax),kfold(ndimmax)
      common/cifold/ifold
      real * 8 r,f,ubound,vol,random,xmmm(nintervals,ndimmax)
      real * 8 rand(ndimmax)
      external fun,random
      integer icalls,mcalls,kdim,kint,nintcurr,iret,ifirst
      save icalls,mcalls,xmmm
      if(imode.eq.0) then
         do kdim=1,ndim
            nintcurr=nintervals/ifold(kdim)
            xmmm(1,kdim)=ymax(1,kdim)
            do kint=2,nintcurr
               xmmm(kint,kdim)=xmmm(kint-1,kdim)+
     #              ymax(kint,kdim)
            enddo
            do kint=1,nintcurr
               xmmm(kint,kdim)=xmmm(kint,kdim)/xmmm(nintcurr,kdim)
            enddo
         enddo
         icalls=0
         mcalls=0
         return
      elseif(imode.eq.3) then
         if(icalls.gt.0) then
            x(1)=dble(mcalls)/icalls
         else
            x(1)=-1
         endif
         return
      endif
      mcalls=mcalls+1
 10   continue
      do kdim=1,ndim
         nintcurr=nintervals/ifold(kdim)
         r=random()
         do kint=1,nintcurr
            if(r.lt.xmmm(kint,kdim)) then
               ncell(kdim)=kint
               goto 1
            endif
         enddo
 1       continue
         rand(kdim)=random()
      enddo
      ubound=1
      do kdim=1,ndim
         ubound=ubound*ymax(ncell(kdim),kdim)
      enddo
      do kdim=1,ndim
         kfold(kdim)=1
      enddo
      f=0
      ifirst=0
 5    continue
      vol=1
      do kdim=1,ndim
         nintcurr=nintervals/ifold(kdim)
         icell(kdim)=ncell(kdim)+(kfold(kdim)-1)*nintcurr
         dx(kdim)=xgrid(icell(kdim),kdim)-xgrid(icell(kdim)-1,kdim)
         vol=vol*dx(kdim)*nintervals/ifold(kdim)
         x(kdim)=xgrid(icell(kdim)-1,kdim)+rand(kdim)*dx(kdim)
      enddo
      f=f+fun(x,vol,ifirst)
      ifirst=1
      call nextlexi(ndim,ifold,kfold,iret)
      if(iret.eq.0) goto 5
c get final value (x and vol not used in this call)
      f=fun(x,vol,2)
      if(f.lt.0) then
         write(*,*) 'gen: non positive function'
         stop
      endif
      if(f.gt.ubound) then
         call increasecnt
     #       ('upper bound failure in inclusive cross section')
      endif
      ubound=ubound*random()
      icalls=icalls+1
      if(ubound.gt.f) then
         call increasecnt
     #       ('vetoed calls in inclusive cross section')
         goto 10
      endif
      end
c This file contains all the relevant cross section formulae for heavy
c quark production, to be used in conjunction with the heavy quark
c package.
c Common blocks :
c    /process/prc           (character * 2)
c    /nl/nl
c    /scheme/schhad1,schhad2  (character * 2)
c    /betfac/betfac,delta
c Functions called:
c    ddilog  (cernlib)
c
c NR06:  Normalization:
c NR06:   d sigma = ppsv * f(x1) * f(x2) * gs^6/(16 pi 16 pi^2)   beta dcosth1 dx1 dx2
c NR06:                                         as^3/4
      function ppsv(s,t,xm2,xmur2,xmuf1h1,xmuf2h2)
      implicit real * 8 (a-h,o-z)
      parameter (pi=3.14159265358979312D0)
      parameter (vca=3.d0)
      parameter (vtf=0.5d0)
      parameter (vcf=4/3.d0)
      character * 2 prc
      common/process/prc
      common/nl/nl
      common/betfac/betfac,delta
      b = sqrt(1-4*xm2/s)
      xlb = log(b*betfac)
      b0 = (11*vca-4*vtf*nl)/(12*pi)
      csih1h2  = log(xmuf1h1/xmuf2h2)
      csirh = log(xmur2/xmuf2h2)
      if(prc.eq.'gg')then
        bbb = ggqq2(s,t,xm2,xmuf2h2,nl)+(8*pi*b0*csirh
     #       -(4*pi*b0+8*vca*xlb)*csih1h2)*ggborn(s,t,xm2)
      elseif(prc.eq.'qq')then
        bbb = qqqq2(s,t,xm2,xmuf2h2,nl)+(8*pi*b0*csirh
     #       -vcf*(3.d0+8*xlb)*csih1h2)*qqborn(s,t,xm2)
      elseif(prc.eq.'qg') then
        bbb = qgqq2(s,t,xm2,nl)
      else
        write(*,*)'PPSV: non existent process ',prc
        stop
      endif
      ppsv = bbb
      end

c NR06:  Normalization:
c NR06:   d sigma ={ ppcolp/(1-x)_rho + ppcoll*[log(1-x)/(1-x)]_rho }
c NR06:          * f(x1) * f(x2) * gs^6/(16 pi)   betax dcosth1 dx1 dx2 dx
      function ppcolp(y,s,q1q,x,xm2,xlmude)
      implicit real * 8 (a-h,o-z)
      character * 2 prc,schhad1,schhad2,schtmp
      common/nl/nl
      common/process/prc
      common/scheme/schhad1,schhad2
      common/schtmp/schtmp
      if(prc.eq.'gg') then
          if( y .eq. 1) then
             schtmp=schhad1
          elseif( y .eq. -1 ) then
             schtmp=schhad2
          else
             write(*,*) 'error in ppcolp: y=',y
             stop
          endif
          ppcolp = ggcolp(s,q1q,x,xm2,xlmude,nl)
      elseif(prc.eq.'qq') then
          if( y .eq. 1) then
             schtmp=schhad1
          elseif( y .eq. -1 ) then
             schtmp=schhad2
          else
             write(*,*) 'error in ppcolp: y=',y
             stop
          endif
          ppcolp = qqcolp(s,q1q,x,xm2,xlmude,nl)
      elseif(prc.eq.'qg') then
          if( y .eq. 1 ) then
             ppcolp = qgcolp1(s,q1q,x,xm2,xlmude,nl)
          elseif( y .eq. -1 ) then
             ppcolp = qgcolp2(s,q1q,x,xm2,xlmude,nl)
          else
             write(*,*) 'error in ppcolp: y=',y
             stop
          endif
      else
          write(*,*) 'error in ppcolp: prc=',prc
          stop
      endif
      end

      function ppcoll(y,s,q1q,x,xm2)
      implicit real * 8 (a-h,o-z)
      character * 2 prc,schhad1,schhad2,schtmp
      common/nl/nl
      common/process/prc
      common/scheme/schhad1,schhad2
      common/schtmp/schtmp
      if(prc.eq.'gg') then
          if( y .eq. 1) then
             schtmp=schhad1
          elseif( y .eq. -1 ) then
             schtmp=schhad2
          else
             write(*,*) 'error in ppcoll: y=',y
             stop
          endif
          ppcoll = ggcoll(s,q1q,x,xm2,nl)
      elseif(prc.eq.'qq') then
          if( y .eq. 1) then
             schtmp=schhad1
          elseif( y .eq. -1 ) then
             schtmp=schhad2
          else
             write(*,*) 'error in ppcoll: y=',y
             stop
          endif
          ppcoll = qqcoll(s,q1q,x,xm2,nl)
      elseif(prc.eq.'qg') then
          if( y .eq. 1 ) then
             ppcoll = qgcoll1(s,q1q,x,xm2,nl)
          elseif( y .eq. -1 ) then
             ppcoll = qgcoll2(s,q1q,x,xm2,nl)
          else
             write(*,*) 'error in ppcoll: y=',y
             stop
          endif
      else
          write(*,*) 'error in ppcoll: prc=',prc
          stop
      endif
      end



c NR06:  Normalization: (NB: 0 < th2 < pi)
c NR06:   d sigma = fgg/qq/qg * f(x1)*f(x2) * gs^6/(16 pi^2 64 pi^2)
c NR06:   1/(1-x)_rho (1/(1-y)_+ + 1/(1-y)_-) betax/s dcosth1 dth2 dy dx dx1 dx2
c NR06:  NB: fqg -> q(p1)+g(p2)
      function fpp(s0,x,y,xm20,q1q0,q2q0,w1h,w2h,cth2)
      implicit real * 8 (a-h,o-z)
      character * 2 prc
      common/process/prc
      s=1
      xm2=xm20/s0
      q1q=q1q0/s0
      q2q=q2q0/s0
      if(prc.eq.'gg') then
         fpp = fgg(s,x,y,xm2,q1q,q2q,w1h,w2h,cth2)
      elseif(prc.eq.'qg') then
         fpp = fqg(s,x,y,xm2,q1q,q2q,w1h,w2h,cth2)
      elseif(prc.eq.'qq') then
         fpp = fqq(s,x,y,xm2,q1q,q2q,w1h,w2h,cth2)
      else
         write(*,*) 'FPP: non existent subprocess',prc
         stop
      endif
      end

C Correction terms for change of subtraction scheme.
C Assume that the change of structure functions is given by:
C xkdij(), xkpij(x), xklij(x).
C
      function cthdgg1(t1,ro,nl)
      implicit double precision (a-z)
      integer nl
      data one/1.d0/
      xkd = xkdgg(nl)
      xkp = xkpgg(one,nl)
      xkl = xklgg(one,nl)
      t2   = 1 - t1
      xlg2 = log(t2)
      cthdgg1 = -( xkd-xlg2*xkp+xlg2**2*xkl/2 )*hqh0gg(t1,ro)
      return
      end

      function cthdgg2(t1,ro,nl)
      implicit double precision (a-z)
      integer nl
      data one/1.d0/
      xkd = xkdgg(nl)
      xkp = xkpgg(one,nl)
      xkl = xklgg(one,nl)
      xlg1 = log(t1)
      cthdgg2 = -( xkd-xlg1*xkp+xlg1**2*xkl/2 )*hqh0gg(t1,ro)
      return
      end

      function cthdqa1(t1,ro,nl)
      implicit double precision (a-z)
      integer nl
      data one/1.d0/
      xkd = xkdqq(nl)
      xkp = xkpqq(one,nl)
      xkl = xklqq(one,nl)
      t2   = 1 - t1
      xlg2 = log(t2)
      cthdqa1 = -( xkd-xlg2*xkp+xlg2**2*xkl/2 )*hqh0qa(t1,ro)
      return
      end

      function cthdqa2(t1,ro,nl)
      implicit double precision (a-z)
      integer nl
      data one/1.d0/
      xkd = xkdqq(nl)
      xkp = xkpqq(one,nl)
      xkl = xklqq(one,nl)
      xlg1 = log(t1)
      cthdqa2 = -( xkd-xlg1*xkp+xlg1**2*xkl/2 )*hqh0qa(t1,ro)
      return
      end

      function cthdqg1(t1,ro,nl)
      implicit double precision (a-z)
      integer nl
      data one/1.d0/
      xkd2 = xkdgq(nl)
      xkp2 = xkpgq(one,nl)
      xkl2 = xklgq(one,nl)
      t2   = 1 - t1
      xlg2 = log(t2)
      cthdqg1 = -( xkd2-xlg2*xkp2+xlg2**2*xkl2/2 )*hqh0gg(t1,ro)
      return
      end

      function cthdqg2(t1,ro,nl)
      implicit double precision (a-z)
      integer nl
      data one/1.d0/
      xkd1 = xkdqg(nl)
      xkp1 = xkpqg(one,nl)
      xkl1 = xklqg(one,nl)
      xlg1 = log(t1)
      cthdqg2 = -( xkd1-xlg1*xkp1+xlg1**2*xkl1/2 )*hqh0qa(t1,ro)
      return
      end

      function cthpgg1(tx,t1,ro,nl)
      implicit double precision (a-z)
      integer nl
      t2 = 1 - t1 - tx
      r2 = t2/(1-t1)
      xkp2 = xkpgg(r2,nl)
      xkl2 = xklgg(r2,nl)
      cthpgg1 = -(xkp2-log(1-t1)*xkl2)*hqh0gg(t1,ro/r2)/r2
      return
      end

      function cthpgg2(tx,t1,ro,nl)
      implicit double precision (a-z)
      integer nl
      t2 = 1 - t1 - tx
      r1 = t1/(1-t2)
      xkp1 = xkpgg(r1,nl)
      xkl1 = xklgg(r1,nl)
      cthpgg2 = -( xkp1-log(1-t2)*xkl1 )*hqh0gg(t2,ro/r1)/r1
      return
      end

      function cthpqa1(tx,t1,ro,nl)
      implicit double precision (a-z)
      integer nl
      t2 = 1 - t1 - tx
      r2 = t2/(1-t1)
      xkp2 = xkpqq(r2,nl)
      xkl2 = xklqq(r2,nl)
      cthpqa1 = -( xkp2-log(1-t1)*xkl2 )*hqh0qa(t1,ro/r2)/r2
      return
      end

      function cthpqa2(tx,t1,ro,nl)
      implicit double precision (a-z)
      integer nl
      t2 = 1 - t1 - tx
      r1 = t1/(1-t2)
      xkp1 = xkpqq(r1,nl)
      xkl1 = xklqq(r1,nl)
      cthpqa2 = -( xkp1-log(1-t2)*xkl1 )*hqh0qa(t2,ro/r1)/r1
      return
      end

      function cthpqg1(tx,t1,ro,nl)
      implicit double precision (a-z)
      integer nl
      t2 = 1 - t1 - tx
      r2 = t2/(1-t1)
      xkp2 = xkpgq(r2,nl)
      xkl2 = xklgq(r2,nl)
      cthpqg1 = -( xkp2-log(1-t1)*xkl2 )*hqh0gg(t1,ro/r2)/r2
      return
      end

      function cthpqg2(tx,t1,ro,nl)
      implicit double precision (a-z)
      integer nl
      t2 = 1 - t1 - tx
      r1 = t1/(1-t2)
      xkp1 = xkpqg(r1,nl)
      xkl1 = xklqg(r1,nl)
      cthpqg2 = -(xkp1-log(1-t2)*xkl1)*hqh0qa(t2,ro/r1)/r1
      return
      end

      function cthlgg1(tx,t1,ro,nl)
      implicit double precision (a-z)
      integer nl
      t2 = 1 - t1 - tx
      r2 = t2/(1-t1)
      xkl2 = xklgg(r2,nl)
      cthlgg1 = -xkl2*hqh0gg(t1,ro/r2)/r2
      return
      end

      function cthlgg2(tx,t1,ro,nl)
      implicit double precision (a-z)
      integer nl
      t2 = 1 - t1 - tx
      r1 = t1/(1-t2)
      xkl1 = xklgg(r1,nl)
      cthlgg2 = -xkl1*hqh0gg(t2,ro/r1)/r1
      return
      end

      function cthlqa1(tx,t1,ro,nl)
      implicit double precision (a-z)
      integer nl
      t2 = 1 - t1 - tx
      r2 = t2/(1-t1)
      xkl2 = xklqq(r2,nl)
      cthlqa1 = -xkl2*hqh0qa(t1,ro/r2)/r2
      return
      end

      function cthlqa2(tx,t1,ro,nl)
      implicit double precision (a-z)
      integer nl
      t2 = 1 - t1 - tx
      r1 = t1/(1-t2)
      xkl1 = xklqq(r1,nl)
      cthlqa2 = -xkl1*hqh0qa(t2,ro/r1)/r1
      return
      end

      function cthlqg1(tx,t1,ro,nl)
      implicit double precision (a-z)
      integer nl
      t2 = 1 - t1 - tx
      r2 = t2/(1-t1)
      xkl2 = xklgq(r2,nl)
      cthlqg1 = -xkl2*hqh0gg(t1,ro/r2)/r2
      return
      end

      function cthlqg2(tx,t1,ro,nl)
      implicit double precision (a-z)
      integer nl
      t2 = 1 - t1 - tx
      r1 = t1/(1-t2)
      xkl1 = xklqg(r1,nl)
      cthlqg2 = -xkl1*hqh0qa(t2,ro/r1)/r1
      return
      end

      FUNCTION ASHDQA(T1,RO)
      IMPLICIT DOUBLE PRECISION (A-Z)
      DATA PI/3.141 592 653 589 793/
      T2 = 1-T1
      B = DSQRT(1-RO)
      LP = (B+1)/ 2.D0
      LM = (1-B)/ 2.D0
      AT = T1
      AW = T2
      VLTM = DLOG(4*AT/RO)
      VLPM = DLOG(LP/LM)
      VLSM = DLOG(4/RO)
      VLWM = DLOG(4*AW/RO)
      VDW = DDILOG((AW-RO/ 4.D0)/AW)-VLWM**2/ 2.D0
      VDT = DDILOG((AT-RO/ 4.D0)/AT)-VLTM**2/ 2.D0
      VDMP = DDILOG(-LM/LP)
      AUINV = 1/(RO/ 4.D0-AW)
      ATINV = 1/(RO/ 4.D0-AT)
      SRLGPR = DLOG((1-B)*T2/((B+1)*T1))*DLOG((B+1)*T2/((1-B)*T1))
      SRL21P = DDILOG(1-(B+1)*T1/((1-B)*T2))
      SRL21M = DDILOG(1-(1-B)*T1/((B+1)*T2))
      SRL22P = DDILOG(1-(B+1)*T2/((1-B)*T1))
      SRL22M = DDILOG(1-(1-B)*T2/((B+1)*T1))
      SRLG1 = DLOG((B+1)/(1-B))/B
      SL3515 = SRLGPR+B**2*SRLG1**2+SRL21P+SRL21M
      SL3525 = SRLGPR+B**2*SRLG1**2+SRL22P+SRL22M
      DD = -5*(2*(4*T1**2-2*T1+1)+3*RO)*VLSM*VLWM/ 27.D0
      DD = DD-5*AUINV*(2*(T1-1)*T1+RO)*VLWM/ 27.D0
      DD = 5*(2*(4*T1**2-6*T1+3)+3*RO)*VLSM*VLTM/ 27.D0+DD
      DD = 5*ATINV*(2*(T1-1)*T1+RO)*VLTM/ 27.D0+DD
      DD = 5*(2*T1-1)*VLSM**2/ 27.D0+DD
      DD = 10*(2*T1-1)*VLSM/( 27.D0*B**2)+DD
      DD = DD-5*(RO*(2*T1-1)-2*(3*T1-2))*VLPM**2/( 54.D0*B)
      DD = DD-5*(2*(T1-1)+RO)*VLPM**2/( 54.D0*B**3)
      DD = DD-5*(2*(2*T1-1)+RO)*VDW/ 27.D0
      DD = 5*(RO-2*(2*T1-1))*VDT/ 27.D0+DD
      DD = DD-10*(RO*(2*T1-1)-2*(3*T1-2))*VDMP/( 27.D0*B)
      DD = DD-10*(2*(T1-1)+RO)*VDMP/( 27.D0*B**3)
      DD = DD-5*SL3525*(2*(2*T1**2-2*T1+1)+RO)/ 27.D0
      DD = 5*SL3515*(2*(2*T1**2-2*T1+1)+RO)/ 27.D0+DD
      DD = DD-5*PI**2*(RO*(2*T1-1)-2*(3*T1-2))/( 162.D0*B)
      DD = DD-5*PI**2*(2*(T1-1)+RO)/( 162.D0*B**3)
      DD = 5*PI**2*(2*T1-1)/ 81.D0+DD
      ASHDQA = DD
      RETURN
      END
      FUNCTION ASHPQA(TX,T1,RO)
      IMPLICIT DOUBLE PRECISION (A-Z)
      IF(TX.EQ.0)THEN
      T2 = 1-T1
      SRL12 = DLOG(T1/T2)
      PP = 20*SRL12*(2*(2*T1**2-2*T1+1)+RO)/ 27.D0
      ASHPQA = PP
      RETURN
      ELSE
      T2 = -TX-T1+1
      T11 = 1/(1-T1)
      T22 = 1/(TX+T1)
      B = DSQRT((1-TX)**2-RO)
      DLAM2 = 1/(TX**2-2*TX-RO+1)
      RLGXRO = DLOG((4*TX+RO)/RO)/TX
      RLG12 = DLOG(T1/(1-T2))/TX
      RLG21 = DLOG(T2/(1-T1))/TX
      RLG11 = DLOG(T1/(1-T1))
      RLG22 = DLOG(T2/(1-T2))
      RL34 = DLOG((2*TX**2+2*B*TX-2*TX-RO)/(2*TX**2-2*B*TX-2*TX-RO))/(B*
     1   TX)
      RL35 = DLOG((2*TX+RO-2*B-2)/(2*TX+RO+2*B-2))/B
      PP = -5*RLGXRO*(T2-1)*(T2+T1-1)*(2*(T2-T1)+RO)*T22/ 54.D0
      PP = 5*T22*(4*(T2**2+(-T1-5)*T2-3*T1+4)*TX+RO*(T2**2+(T1-7)*T2-5*T
     1   1+6))/( 54.D0*(4*TX+RO))+PP
      PP = 5*RLGXRO*(T1-1)*T11*(T2+T1-1)*(RO-2*(T2-T1))/ 54.D0+PP
      PP = PP-5*T11*(RO*((T1-5)*T2+T1**2-7*T1+6)-4*((T1+3)*T2-T1**2+5*T1
     1   -4)*TX)/( 54.D0*(4*TX+RO))
      PP = PP-5*RLG22*(2*(3*T2**2-2*T2+T1**2+1)+RO*(T2+T1+1))/( 27.D0*(T
     1   2+T1))
      PP = 5*RLG21*(T2+T1-1)*(2*(2*T2**2+2*T1**2-2*T1+1)+RO)/( 27.D0*(T2
     1   +T1))+PP
      PP = PP-5*RLG12*(T2+T1-1)*(2*(2*T2**2-2*T2+2*T1**2+1)+RO)/( 27.D0*
     1   (T2+T1))
      PP = 5*RLG11*(2*(T2**2+3*T1**2-2*T1+1)+RO*(T2+T1+1))/( 27.D0*(T2+T
     1   1))+PP
      TMP0 = RO-2*T1*(T2+T1)
      TMP0 = -5*DLAM2*RL35*(T2+T1-1)**2*(T2+T1+RO)*TMP0/( 27.D0*(T2+T1))
      PP = TMP0+PP
      PP = PP-5*RL35*(T2+T1-1)*(RO*(2*T1-1)-2*(T2**2-T1*T2-2*T1**2+T1))/
     1   ( 27.D0*(T2+T1))
      PP = 5*DLAM2*RL34*(T2+T1-1)*(RO-2*T2*(T2+T1))*(-RO*TX+T2+T1)/( 27.
     1   D0*(T2+T1))+PP
      PP = 5*RL34*(T2+T1-1)*(2*(T2**2+T2-T1**2)+RO*(2*T1-1))/( 27.D0*(T2
     1   +T1))+PP
      TMP0 = RO-2*((T1+1)*T2+T1**2-T1)
      TMP0 = -20*DLAM2*(T2+T1-2)*(T2+T1-1)*TMP0/( 27.D0*(4*TX+RO))
      PP = TMP0+PP
      PP = PP-20*(T2+T1-2)*(T2+T1-1)/( 27.D0*(4*TX+RO))
      ASHPQA = PP
      RETURN
      ENDIF
      END
      FUNCTION ASHPQG(TX,T1,RO)
      IMPLICIT DOUBLE PRECISION (A-Z)
      IF(TX.EQ.0)THEN
      PP = 0
      ASHPQG = PP
      RETURN
      ELSE
      T2 = -TX-T1+1
      T11 = 1/(1-T1)
      T22 = 1/(TX+T1)
      B = DSQRT((1-TX)**2-RO)
      DLAM2 = 1/(TX**2-2*TX-RO+1)
      RLGXRO = DLOG((4*TX+RO)/RO)/TX
      RLG12 = DLOG(T1/(1-T2))/TX
      RLG21 = DLOG(T2/(1-T1))/TX
      RLGRO = DLOG(4*(1-T1)*(1-T2)/RO)
      RR = T2*(T2*TX**2+RO*(1-T2))
      RR = DSQRT(RR)
      RL3424 = 2*DLOG((T2*TX+RR)/(RR-T2*TX))/(RR*TX)
      RL34 = DLOG((2*TX**2+2*B*TX-2*TX-RO)/(2*TX**2-2*B*TX-2*TX-RO))/(B*
     1   TX)
      PP = RO*T2-2*(T2-1)*(T1*T2+T1-1)
      PP = 5*PP*RLGXRO*(T2+T1-1)**2*T22**2/( 72.D0*T2)
      TMP0 = RO-2*((T1+1)*T2+T1-1)
      TMP0 = -5*(T2+1)*(T2+T1-1)**2*T22**2*TMP0/( 18.D0*T2*(4*TX+RO))
      PP = TMP0+PP
      PP = 5*RLGXRO*(T2+T1-1)**2*(RO*(T2+1)-2*(T2**2+3*T1*T2+3*T1-2))*T2
     1   2/( 72.D0*T2)+PP
      PP = PP-5*(T2+T1-1)*(RO-2*(T2+2*T1-1))*T22/( 72.D0*T2)
      PP = PP-5*RLGXRO*(T1-1)*T11**2*(T2+T1-1)**3/( 72.D0*T2)
      TMP0 = 3*RO-4*((2*T1+1)*T2+T1-1)
      TMP0 = 5*(T1-1)*T11**2*(T2+T1-1)**2*TMP0/( 144.D0*T2*(4*TX+RO))
      PP = TMP0+PP
      TMP0 = RO*(T1-1)-2*((T1-2)*T2+2*T1**2-4*T1+2)
      TMP0 = -5*RLGXRO*T11*(T2+T1-1)**2*TMP0/( 144.D0*T2)
      PP = TMP0+PP
      PP = 5*T11*(T2+T1-1)*(-T1*T2-4*T1**2+6*T1+RO*(T1-1)-2)/( 144.D0*T2
     1   )+PP
      PP = PP-5*RLGRO*(T2+T1-1)*(2*(2*T2**2+(4*T1-4)*T2+4*T1**2-6*T1+3)+
     1   RO)/( 72.D0*(T2-1)*T2)
      TMP0 = 2*(T2**2+(2*T1-2)*T2+4*T1**2-4*T1+2)+RO*T2
      TMP0 = 5*RLG21*(T2+T1-1)**2*TMP0/( 72.D0*(T2-1)*T2)
      PP = TMP0+PP
      TMP0 = 2*T2*(3*T2**2+(6*T1-4)*T2+8*T1**2-6*T1+3)+RO*(T2-4)*(T2-1)
      TMP0 = 5*RLG12*(T2+T1-1)**2*TMP0/( 72.D0*(T2-1)*T2**2)
      PP = TMP0+PP
      TMP0 = 2*T2*(3*T2**2+(6*T1-4)*T2+4*T1**2-4*T1+2)*TX+RO*(T2**3+(T1+
     1   1)*T2**2+(4*T1-2)*T2-4*T1)
      TMP0 = -5*RL3424*(T2+T1-1)**2*TMP0/( 144.D0*(T2-1)*T2)
      PP = TMP0+PP
      PP = 5*DLAM2*RL34*(T2+T1-1)**2*(T2+T1)*(RO-2*T2*(T2+T1))/( 144.D0*
     1   T2)+PP
      TMP0 = RO*(T2+T1+2)-2*(T2**2+(3*T1-2)*T2+2*T1**2-T1)
      TMP0 = 5*RL34*(T2+T1-1)**2*TMP0/( 144.D0*T2)
      PP = TMP0+PP
      TMP0 = RO-2*((T1+1)*T2+T1**2-T1)
      TMP0 = 5*DLAM2*(T2+T1-1)**2*(T2+T1)*TMP0/( 36.D0*T2*(4*TX+RO))
      PP = TMP0+PP
      PP = 5*(T2+T1-1)*(-4*(3*T2**2+(2*T1-6)*T2-10*T1+3)*TX+RO*(-5*T2**2
     1   -(8*T1-24)*T2+24*T1-19)+RO**2*(T2-3))/( 144.D0*(T2-1)*T2*(4*TX+
     2   RO))+PP
      ASHPQG = PP
      RETURN
      ENDIF
      END
      function hqh0qa(t1,ro)
      implicit double precision (a-z)
      t2=1-t1
      hqh0qa=2*(2*t1**2+2*t2**2+ro)/9
      return
      end

      function hqbdqa(t1,ro,nl)
      implicit double precision (a-z)
      parameter(c1=2.d0/3,c2=8.d0/3)
      integer nl
      t2 = 1-t1
      hqbdqa = ( 7 - nl * c1 + c2*log(t1*t2) )*hqh0qa(t1,ro)
      return
      end

      function hqadqa(t1,ro,nl)
      implicit double precision (a-z)
      parameter (vcf=4/3.d0)
      integer nl
      t2 = 1-t1
      hqadqa = ( 2*vcf*log(t2)-3*vcf/2.d0 )*hqh0qa(t1,ro)
      return
      end

      function hqbpqa(tx,t1,ro)
      implicit double precision (a-z)
      parameter (cf=4.d0/3)
      pqq(x) = cf*(1+x**2)
      t2 = 1-tx-t1
      hqbpqa = -(1-t1)/t2*hqh0qa(t1  ,ro*(1-t1)/t2)*pqq(t2/(1-t1))
     #         -(1-t2)/t1*hqh0qa(1-t2,ro*(1-t2)/t1)*pqq(t1/(1-t2))
      return
      end

      function hqaaqa(tx,t1,ro)
      implicit double precision (a-z)
      parameter (cf=4.d0/3)
      pqq(x) = cf*(1+x**2)
      t2 = 1-tx-t1
      hqaaqa = -(1-t1)/t2*hqh0qa(t1  ,ro*(1-t1)/t2)*pqq(t2/(1-t1))
      return
      end

      function hqhlqa(tx,t1,ro)
      implicit double precision (a-z)
      hqhlqa = - 2 * hqbpqa(tx,t1,ro)
      return
      end

      function hqh0gg(t1,ro)
      implicit double precision (a-z)
      parameter (cf=4.d0/3)
      tt=cf
      t2 = 1-t1
      hqh0gg = (cf/t1/t2-3)*(t1**2+t2**2+ro*(1-ro/t1/t2/4))/8
      return
      end

      function hqbdgg(t1,ro,nl)
      implicit double precision (a-z)
      t2 = 1-t1
      hqbdgg = 6*log(t1*t2)*hqh0gg(t1,ro)
      return
      end

      function hqadgg(t1,ro,nl)
      implicit double precision (a-z)
      integer nl
      parameter (pi=3.14159265358979312D0)
      parameter (vca=3.d0)
      parameter (vtf=0.5d0)
      t2 = 1-t1
      b0 = (11*vca-4*vtf*nl)/(12*pi)
      hqadgg = ( 2*vca*log(t2)-2*pi*b0 )*hqh0gg(t1,ro)
      return
      end

      function hqbpgg(tx,t1,ro)
      implicit double precision (a-z)
      pgg(x) = 6*(x+(1-x)**2*(1/x+x))
      t2 = 1-t1-tx
      hqbpgg = -(1-t1)/t2*hqh0gg(t1  ,ro*(1-t1)/t2)*pgg(t2/(1-t1))
     #         -(1-t2)/t1*hqh0gg(1-t2,ro*(1-t2)/t1)*pgg(t1/(1-t2))
      return
      end

      function hqaagg(tx,t1,ro)
      implicit double precision (a-z)
      parameter (vca=3.d0)
      pgg(x) = 2*vca*(x+(1-x)**2*(1/x+x))
      t2 = 1-t1-tx
      hqaagg = -(1-t1)/t2*hqh0gg(t1  ,ro*(1-t1)/t2)*pgg(t2/(1-t1))
      return
      end

      function hqhlgg(tx,t1,ro)
      implicit double precision (a-z)
      hqhlgg = - 2 * hqbpgg(tx,t1,ro)
      return
      end

      function hqbpqg(tx,t1,ro)
      implicit double precision (a-z)
      parameter (cf=4.d0/3)
      t2 = 1-t1-tx
      x = t2/(1-t1)
      pgq = cf*(1+(1-x)**2)/x
      x = t1/(1-t2)
      pqg = (x**2+(1-x)**2)/2
      hqbpqg = -1/t2*hqh0gg(t1  ,ro*(1-t1)/t2)*tx*pgq
     #         -1/t1*hqh0qa(1-t2,ro*(1-t2)/t1)*tx*pqg
      return
      end

      function hqaaqg(tx,t1,ro)
      implicit double precision (a-z)
      parameter (cf=4.d0/3)
      t2 = 1-t1-tx
      x = t2/(1-t1)
      pgq = cf*(1+(1-x)**2)/x
      hqaaqg = -1/t2*hqh0gg(t1  ,ro*(1-t1)/t2)*tx*pgq
      return
      end

      function hqhlqg(tx,t1,ro)
      implicit double precision (a-z)
      hqhlqg = - 2 * hqbpqg(tx,t1,ro)
      return
      end
      FUNCTION HQHDGG(T1,RO,NL)
      IMPLICIT DOUBLE PRECISION (A-Z)
      INTEGER NL
      DATA PI/3.141 592 653 589 793/
      NLF = NL
      T2 = 1-T1
      B = DSQRT(1-RO)
      LP = (B+1)/ 2.D0
      LM = (1-B)/ 2.D0
      AT = T1
      AW = T2
      VLTM = DLOG(4*AT/RO)
      VLPM = DLOG(LP/LM)
      VLSM = DLOG(4/RO)
      VLWM = DLOG(4*AW/RO)
      VLBL = DLOG(B/LM)
      VDW = DDILOG((AW-RO/ 4.D0)/AW)-VLWM**2/ 2.D0
      VDT = DDILOG((AT-RO/ 4.D0)/AT)-VLTM**2/ 2.D0
      VDMP = DDILOG(-LM/LP)
      VDMB = VLBL**2/ 2.D0+DDILOG(-LM/B)
      AUINV = 1/(RO/ 4.D0-AW)
      ATINV = 1/(RO/ 4.D0-AT)
      SRLGPR = DLOG((1-B)*T2/((B+1)*T1))*DLOG((B+1)*T2/((1-B)*T1))
      SRL21P = DDILOG(1-(B+1)*T1/((1-B)*T2))
      SRL21M = DDILOG(1-(1-B)*T1/((B+1)*T2))
      SRL22P = DDILOG(1-(B+1)*T2/((1-B)*T1))
      SRL22M = DDILOG(1-(1-B)*T2/((B+1)*T1))
      SRLG1 = DLOG((B+1)/(1-B))/B
      SRL2L = (DDILOG(-4*B/(1-B)**2)-DDILOG(4*B/(B+1)**2))/B
      SRL212 = DLOG(4*T1*T2/RO)**2/ 2.D0+DDILOG(1-RO/( 4.D0*T1*T2))
      SL3515 = SRLGPR+B**2*SRLG1**2+SRL21P+SRL21M
      SL3525 = SRLGPR+B**2*SRLG1**2+SRL22P+SRL22M
      DD = -(RO**2*(36*T1**3-112*T1**2+107*T1-39)-8*(T1-1)**2*(9*T1**3-1
     1   0*T1**2+20*T1-11)+4*RO*(T1-1)**2*(18*T1**2-29*T1+19))*VLWM**2/(
     2    1152.D0*(T1-1)**3*T1)
      DD = DD-(2*(T1-1)*T1*(2*T1**2-2*T1+1)+RO**2*(T1**2-T1+1)+2*RO*(T1-
     1   1)*T1)*VLTM*VLWM/( 16.D0*(T1-1)**2*T1**2)
      DD = 9*(2*(T1-1)*T1*(12*T1**4-32*T1**3+35*T1**2-18*T1+4)+2*RO*(T1-
     1   1)*T1*(5*T1**2-8*T1+4)+RO**2*(3*T1**2-4*T1+2))*VLSM*VLWM/( 32.D
     2   0*(T1-1)**2*T1**2)+DD
      DD = (9*T1-10)*(-4*(T1-1)*(T1**2-2*T1+2)-2*RO**2*(T1**2-3*T1+3)-2*
     1   RO*(T1-1)*T1+RO**3)*VLPM*VLWM/( 576.D0*B*(T1-1)**2*T1)+DD
      TMP0 = -32*(T1-1)**3*(3*T1**2-23*T1+8)+8*RO*(T1-1)**2*(T1**2+17*T1
     1   +12)+12*RO**2*(T1-1)*(T1+3)+3*RO**3
      TMP0 = -AUINV**2*(9*T1-1)*TMP0*VLWM/( 4608.D0*(T1-1)**2*T1)
      DD = TMP0+DD
      DD = DD-AUINV*(9*T1-1)*(RO**2*(8*T1**2+8*T1-17)+4*(T1-1)**3*(25*T1
     1   -8)+2*RO*(T1-1)**2*(16*T1+27)+4*RO**3)*VLWM/( 576.D0*(T1-1)**2*
     2   T1)
      DD = (RO**2*(36*T1**3+4*T1**2-9*T1+8)-8*T1**2*(9*T1**3-17*T1**2+27
     1   *T1-8)-4*RO*T1**2*(18*T1**2-7*T1+8))*VLTM**2/( 1152.D0*(T1-1)*T
     2   1**3)+DD
      DD = 9*(2*(T1-1)*T1*(12*T1**4-16*T1**3+11*T1**2-4*T1+1)+2*RO*(T1-1
     1   )*T1*(5*T1**2-2*T1+1)+RO**2*(3*T1**2-2*T1+1))*VLSM*VLTM/( 32.D0
     2   *(T1-1)**2*T1**2)+DD
      DD = (9*T1+1)*(-2*RO**2*(T1**2+T1+1)+4*T1*(T1**2+1)-2*RO*(T1-1)*T1
     1   +RO**3)*VLPM*VLTM/( 576.D0*B*(T1-1)*T1**2)+DD
      DD = DD-ATINV**2*(9*T1-8)*(32*T1**3*(3*T1**2+17*T1-12)+8*RO*T1**2*
     1   (T1**2-19*T1+30)+12*RO**2*(T1-4)*T1+3*RO**3)*VLTM/( 4608.D0*(T1
     2   -1)*T1**2)
      DD = DD-ATINV*(9*T1-8)*(RO**2*(8*T1**2-24*T1-1)+4*T1**3*(25*T1-17)
     1   -2*RO*T1**2*(16*T1-43)+4*RO**3)*VLTM/( 576.D0*(T1-1)*T1**2)
      DD = DD-((T1-1)*T1*(2*T1**2-2*T1+1)*(432*T1**2-432*T1+191)+RO*(T1-
     1   1)*T1*(414*T1**2-414*T1+191)+2*RO**2*(54*T1**2-54*T1+25))*VLSM*
     2   *2/( 64.D0*(T1-1)**2*T1**2)
      TMP0 = 2*RO*(T1-1)*T1*(8*T1**2-8*T1-5)*(18*T1**2-18*T1-1)
      TMP0 = TMP0+2*RO**2*(54*T1**4-108*T1**3-25*T1**2+79*T1+3)+3*RO**3*
     1   (18*T1**2-18*T1-1)-4*(T1-1)*T1*(4*T1-5)*(4*T1+1)*(9*T1**2-9*T1+
     2   5)
      TMP0 = -TMP0*VLPM*VLSM/( 1152.D0*B*(T1-1)**2*T1**2)
      DD = TMP0+DD
      DD = DD-9*(2*T1-1)**2*(4*(3*T1**2-3*T1+1)-RO*(2*T1-1)**2+RO**2)*VL
     1   SM/( 64.D0*B**2*(T1-1)*T1)
      DD = DD-27*(2*T1-1)**2*(RO-2*(2*T1**2-2*T1+1))*VLSM/( 128.D0*B**4*
     1   (T1-1)*T1)
      DD = ((T1-1)*T1*(2304*T1**4-4608*T1**3+5128*T1**2-2824*T1+593)+14*
     1   RO*(T1-1)*T1*(36*T1**2-36*T1+25)+32*RO**2*(9*T1**2-9*T1+4))*VLS
     2   M/( 576.D0*(T1-1)**2*T1**2)+DD
      DD = DD-(2*(2448*T1**4-4896*T1**3+4513*T1**2-2065*T1+286)+RO*(144*
     1   T1**4-288*T1**3+181*T1**2-37*T1+2)+2*RO**2*(54*T1**2-54*T1+19))
     2   *VLPM**2/( 2304.D0*B*(T1-1)*T1)
      DD = DD-9*(-2*(24*T1**4-48*T1**3+49*T1**2-25*T1+4)+RO*(16*T1**4-32
     1   *T1**3+49*T1**2-33*T1+6)+RO**2*(-7*T1**2+7*T1-3)+RO**3)*VLPM**2
     2   /( 256.D0*B**3*(T1-1)*T1)
      DD = DD-9*(2*T1-1)**2*(8*(T1**2-T1+1)+4*RO*(T1-2)*(T1+1)+3*RO**2)*
     1   VLPM**2/( 512.D0*B**5*(T1-1)*T1)
      DD = DD-(2*(29*T1**2-29*T1+21)+2*RO**2*(27*T1**2-27*T1+4)+9*RO*(2*
     1   T1-1)**2)*VLPM**2/( 1152.D0*(T1-1)*T1)
      DD = B*(27*RO**2*(2*T1-1)**2+18*RO*(2*T1-1)**2+72*T1**2-72*T1+29)*
     1   VLPM/( 576.D0*(T1-1)*T1)+DD
      DD = (-2*(T1-1)*T1*(936*T1**4-1872*T1**3+2086*T1**2-1150*T1+285)+R
     1   O*(T1-1)*T1*(864*T1**4-1728*T1**3+836*T1**2+28*T1-229)+2*RO**2*
     2   (324*T1**4-648*T1**3+317*T1**2+7*T1-64)+16*RO**3*(9*T1**2-9*T1+
     3   4))*VLPM/( 1152.D0*B*(T1-1)**2*T1**2)+DD
      DD = DD-(8*(T1-1)**2*(315*T1**3-413*T1**2+160*T1+2)+4*RO*(T1-1)**2
     1   *(9*T1-1)*(20*T1-1)+RO**2*(2*T1-3)*(2*T1-1)*(9*T1-1))*VDW/( 115
     2   2.D0*(T1-1)**3*T1)
      DD = (8*T1**2*(315*T1**3-532*T1**2+279*T1-64)-4*RO*T1**2*(9*T1-8)*
     1   (20*T1-19)+RO**2*(2*T1-1)*(2*T1+1)*(9*T1-8))*VDT/( 1152.D0*(T1-
     2   1)*T1**3)+DD
      DD = (-2*(T1-1)*T1*(2592*T1**4-5184*T1**3+4721*T1**2-2129*T1+282)-
     1   2*RO**2*(18*T1**4-36*T1**3+57*T1**2-39*T1-1)-RO*(T1-1)*T1*(117*
     2   T1**2-117*T1-2)+RO**3*(18*T1**2-18*T1-1))*VDMP/( 576.D0*B*(T1-1
     3   )**2*T1**2)+DD
      DD = DD-9*(-2*(24*T1**4-48*T1**3+49*T1**2-25*T1+4)+RO*(16*T1**4-32
     1   *T1**3+49*T1**2-33*T1+6)+RO**2*(-7*T1**2+7*T1-3)+RO**3)*VDMP/(
     2   64.D0*B**3*(T1-1)*T1)
      DD = DD-9*(2*T1-1)**2*(8*(T1**2-T1+1)+4*RO*(T1-2)*(T1+1)+3*RO**2)*
     1   VDMP/( 128.D0*B**5*(T1-1)*T1)
      TMP0 = 4*(T1-1)*T1*(2*T1**2-2*T1+1)+4*RO*(T1-1)*T1+RO**2
      TMP0 = (RO-2)*(18*T1**2-18*T1-1)*TMP0*VDMB/( 576.D0*B*(T1-1)**2*T1
     1   **2)
      DD = TMP0+DD
      TMP0 = 4*(T1-1)*T1*(2*T1**2-2*T1+1)+4*RO*(T1-1)*T1+RO**2
      TMP0 = -(RO-2)*SRL2L*(18*T1**2-18*T1-1)*TMP0/( 2304.D0*(T1-1)**2*T
     1   1**2)
      DD = TMP0+DD
      DD = DD-9*SRL212*(2*T1**2-2*T1+1)*(4*(T1-1)*T1*(2*T1**2-2*T1+1)+4*
     1   RO*(T1-1)*T1+RO**2)/( 64.D0*(T1-1)**2*T1**2)
      DD = DD-SL3525*(3*T1-1)*(3*T1+1)*(4*(T1-1)*T1*(2*T1**2-2*T1+1)+4*R
     1   O*(T1-1)*T1+RO**2)/( 64.D0*(T1-1)**2*T1**2)
      DD = DD-SL3515*(3*T1-4)*(3*T1-2)*(4*(T1-1)*T1*(2*T1**2-2*T1+1)+4*R
     1   O*(T1-1)*T1+RO**2)/( 64.D0*(T1-1)**2*T1**2)
      DD = DD-PI**2*(2*(T1-1)*T1*(2016*T1**4-4032*T1**3+3889*T1**2-1873*
     1   T1+298)+RO*(T1-1)*T1*(576*T1**4-1152*T1**3+373*T1**2+203*T1+14)
     2   +2*RO**2*(162*T1**4-324*T1**3+121*T1**2+41*T1+3)+3*RO**3*(18*T1
     3   **2-18*T1-1))/( 6912.D0*B*(T1-1)**2*T1**2)
      DD = DD-9*(2*T1-1)**4/( 64.D0*B**2*(T1-1)*T1)
      DD = DD-3*PI**2*(-2*(24*T1**4-48*T1**3+49*T1**2-25*T1+4)+RO*(16*T1
     1   **4-32*T1**3+49*T1**2-33*T1+6)+RO**2*(-7*T1**2+7*T1-3)+RO**3)/(
     2    256.D0*B**3*(T1-1)*T1)
      DD = DD-3*PI**2*(2*T1-1)**2*(8*(T1**2-T1+1)+4*RO*(T1-2)*(T1+1)+3*R
     1   O**2)/( 512.D0*B**5*(T1-1)*T1)
      TMP0 = 8*RO*(T1-1)**2*(PI**2*(T1**2+6*T1)+204*T1-60)+32*(T1-1)**3*
     1   (PI**2*T1**2-24*T1**2+228*T1-96)+12*RO**2*(T1-1)*(PI**2*(T1+1)+
     2   8*T1-2)+3*PI**2*RO**3
      TMP0 = AUINV*(9*T1-1)*TMP0/( 27648.D0*(T1-1)**3*T1)
      DD = TMP0+DD
      DD = DD-ATINV*(9*T1-8)*(-32*T1**3*(PI**2*(T1**2-2*T1+1)-24*T1**2-1
     1   80*T1+108)+8*RO*T1**2*(PI**2*(T1**2-8*T1+7)-204*T1+144)+12*RO**
     2   2*T1*(8*T1+PI**2*(T1-2)-6)+3*PI**2*RO**3)/( 27648.D0*(T1-1)*T1*
     3   *3)
      TMP0 = 2*RO**2*(PI**2*(81*T1**6-243*T1**5+221*T1**4-37*T1**3-57*T1
     1   **2+35*T1-4)-648*T1**6+1944*T1**5-1674*T1**4+108*T1**3+462*T1**
     2   2-192*T1)
      TMP0 = TMP0-2*(T1-1)**2*T1**2*(PI**2*(648*T1**4-1296*T1**3+1083*T1
     1   **2-435*T1+40)-3456*T1**4+6912*T1**3+516*T1**2-3972*T1+1293)
      TMP0 = TMP0-3*RO*(T1-1)*T1*(PI**2*(96*T1**4-192*T1**3+209*T1**2-11
     1   3*T1+16)+(72*NLF-1296)*T1**4+(2592-144*NLF)*T1**3+(90*NLF-1728)
     2   *T1**2+(432-18*NLF)*T1+64)
      TMP0 = TMP0/( 3456.D0*(T1-1)**3*T1**3)
      DD = TMP0+DD
      HQHDGG = DD
      RETURN
      END
      FUNCTION HQHDQA(T1,RO,NL)
      IMPLICIT DOUBLE PRECISION (A-Z)
      INTEGER NL
      DATA PI/3.141 592 653 589 793/
      NLF = NL
      T2 = 1-T1
      B = DSQRT(1-RO)
      LP = (B+1)/ 2.D0
      LM = (1-B)/ 2.D0
      AT = T1
      AW = T2
      VLTM = DLOG(4*AT/RO)
      VLPM = DLOG(LP/LM)
      VLSM = DLOG(4/RO)
      VLWM = DLOG(4*AW/RO)
      VLBL = DLOG(B/LM)
      VDW = DDILOG((AW-RO/ 4.D0)/AW)-VLWM**2/ 2.D0
      VDT = DDILOG((AT-RO/ 4.D0)/AT)-VLTM**2/ 2.D0
      VDMP = DDILOG(-LM/LP)
      VDMB = VLBL**2/ 2.D0+DDILOG(-LM/B)
      AUINV = 1/(RO/ 4.D0-AW)
      ATINV = 1/(RO/ 4.D0-AT)
      SRLGPR = DLOG((1-B)*T2/((B+1)*T1))*DLOG((B+1)*T2/((1-B)*T1))
      SRL21P = DDILOG(1-(B+1)*T1/((1-B)*T2))
      SRL21M = DDILOG(1-(1-B)*T1/((B+1)*T2))
      SRL22P = DDILOG(1-(B+1)*T2/((1-B)*T1))
      SRL22M = DDILOG(1-(1-B)*T2/((B+1)*T1))
      SRLG1 = DLOG((B+1)/(1-B))/B
      SRL2L = (DDILOG(-4*B/(1-B)**2)-DDILOG(4*B/(B+1)**2))/B
      SRL212 = DLOG(4*T1*T2/RO)**2/ 2.D0+DDILOG(1-RO/( 4.D0*T1*T2))
      SL3515 = SRLGPR+B**2*SRLG1**2+SRL21P+SRL21M
      SL3525 = SRLGPR+B**2*SRLG1**2+SRL22P+SRL22M
      DD = -(2*(28*T1**2-46*T1+23)+5*RO)*VLSM*VLWM/ 27.D0
      DD = AUINV*(2*(T1-1)*T1+RO)*VLWM/ 3.D0+DD
      DD = DD-(2*(28*T1**2-10*T1+5)+5*RO)*VLSM*VLTM/ 27.D0
      DD = ATINV*(2*(T1-1)*T1+RO)*VLTM/ 3.D0+DD
      DD = (152*(2*T1**2-2*T1+1)+67*RO)*VLSM**2/ 54.D0+DD
      DD = 2*(RO-2)*(2*(2*T1**2-2*T1+1)+RO)*VLPM*VLSM/( 27.D0*B)+DD
      DD = DD-2*(2*T1-1)*(RO*(2*T1-1)-6*T1+5)*VLSM/( 3.D0*B**2)
      DD = DD-(2*(6*T1**2-10*T1+3)+RO*(8*T1-3))*VLSM/( 3.D0*B**4)
      DD = 4*((2*NLF-37)*(2*T1**2-2*T1+1)+(NLF-14)*RO)*VLSM/ 27.D0+DD
      DD = (2*(68*T1**2-95*T1+43)+2*RO*T1*(2*T1+7)+RO**2)*VLPM**2/( 54.D
     1   0*B)+DD
      DD = (2*(T1-1)+RO)*(RO*(2*T1-1)-6*T1+5)*VLPM**2/( 6.D0*B**3)+DD
      DD = (4*RO*(T1-1)*(T1+2)+8*(T1-1)**2+3*RO**2)*VLPM**2/( 12.D0*B**5
     1   )+DD
      DD = 2*B*(RO+2)*((2*T1-1)**2+RO)*VLPM/ 27.D0+DD
      DD = DD-(-2*(26*T1**2-26*T1+15)+RO*(24*T1**2-24*T1-1)+8*RO**2)*VLP
     1   M/( 27.D0*B)
      DD = (2*(2*T1-1)+RO)*VDW/ 3.D0+DD
      DD = (RO-2*(2*T1-1))*VDT/ 3.D0+DD
      DD = 4*(8*T1**2+RO*T1-11*T1+5)*VDMP/( 3.D0*B)+DD
      DD = 2*(2*(T1-1)+RO)*(RO*(2*T1-1)-6*T1+5)*VDMP/( 3.D0*B**3)+DD
      DD = (4*RO*(T1-1)*(T1+2)+8*(T1-1)**2+3*RO**2)*VDMP/( 3.D0*B**5)+DD
      DD = DD-2*(RO-2)*(2*(2*T1**2-2*T1+1)+RO)*VDMB/( 27.D0*B)
      DD = (RO-2)*SRL2L*(2*(2*T1**2-2*T1+1)+RO)/ 54.D0+DD
      DD = DD-2*SRL212*(2*(2*T1**2-2*T1+1)+RO)/ 27.D0
      DD = SL3525*(2*(2*T1**2-2*T1+1)+RO)/ 3.D0+DD
      DD = SL3515*(2*(2*T1**2-2*T1+1)+RO)/ 3.D0+DD
      DD = PI**2*(56*T1**2+RO*T1*(8*T1+1)-83*T1+2*RO**2+37)/( 81.D0*B)+D
     1   D
      DD = 2*(2*T1-1)**2/( 3.D0*B**2)+DD
      DD = PI**2*(2*(T1-1)+RO)*(RO*(2*T1-1)-6*T1+5)/( 18.D0*B**3)+DD
      DD = PI**2*(4*RO*(T1-1)*(T1+2)+8*(T1-1)**2+3*RO**2)/( 36.D0*B**5)+
     1   DD
      DD = DD-(4*(PI**2*(22*T1**2-22*T1+11)+(40*NLF-392)*T1**2+(392-40*N
     1   LF)*T1+20*NLF-223)+RO*(96*T1**2-96*T1+31*PI**2+40*NLF-344)+24*R
     2   O**2)/ 162.D0
      HQHDQA = DD
      RETURN
      END
      FUNCTION HQHPGG(TX,T1,RO)
      IMPLICIT DOUBLE PRECISION (A-Z)
      IF(TX.EQ.0)THEN
      T2 = 1-T1
      B = DSQRT(1-RO)
      VLSM = DLOG(4/RO)
      SRL12 = DLOG(T1/T2)
      SRLGRO = DLOG(4*T1*T2/RO)
      SRLG1 = DLOG((B+1)/(1-B))/B
      PP = -(9*T1**2-9*T1+4)*(4*(T1-1)*T1*(2*T1**2-2*T1+1)+4*RO*(T1-1)*T
     1   1+RO**2)*VLSM/( 4.D0*(T1-1)**2*T1**2)
      PP = 9*SRLGRO*(2*T1**2-2*T1+1)*(4*(T1-1)*T1*(2*T1**2-2*T1+1)+4*RO*
     1   (T1-1)*T1+RO**2)/( 32.D0*(T1-1)**2*T1**2)+PP
      TMP0 = 4*(T1-1)*T1*(2*T1**2-2*T1+1)+4*RO*(T1-1)*T1+RO**2
      TMP0 = -(RO-2)*SRLG1*(18*T1**2-18*T1-1)*TMP0/( 576.D0*(T1-1)**2*T1
     1   **2)
      PP = TMP0+PP
      PP = 9*SRL12*(2*T1-1)*(4*(T1-1)*T1*(2*T1**2-2*T1+1)+4*RO*(T1-1)*T1
     1   +RO**2)/( 32.D0*(T1-1)**2*T1**2)+PP
      PP = (9*T1**2-9*T1+4)*(4*(T1-1)*T1*(2*T1**2-2*T1+1)+4*RO*(T1-1)*T1
     1   +RO**2)/( 18.D0*(T1-1)**2*T1**2)+PP
      HQHPGG = PP
      RETURN
      ELSE
      T2 = -TX-T1+1
      T11 = 1/(1-T1)
      ITX = 1/(1-TX)
      T22 = 1/(TX+T1)
      DRO = 1/(4*TX+RO)
      B = DSQRT((1-TX)**2-RO)
      DLAM2 = 1/(TX**2-2*TX-RO+1)
      VLSM = DLOG(4/RO)
      RLGXRO = DLOG((4*TX+RO)/RO)/TX
      RLG12 = DLOG(T1/(1-T2))/TX
      RLG21 = DLOG(T2/(1-T1))/TX
      RLG11 = DLOG(T1/(1-T1))
      RLG22 = DLOG(T2/(1-T2))
      RLGRO = DLOG(4*(1-T1)*(1-T2)/RO)
      RR = T1*(T1-RO*(1-T2))
      D2435 = 1/RR
      RR = DSQRT(RR)
      RL3524 = 2*DLOG((T1+RR)/(T1-RR))/RR
      RR = T2*(T2-RO*(1-T1))
      D1435 = 1/RR
      RR = DSQRT(RR)
      RL3514 = 2*DLOG((T2+RR)/(T2-RR))/RR
      RR = T1*(T1*TX**2+RO*(1-T1))
      RR = DSQRT(RR)
      RL3414 = 2*DLOG((T1*TX+RR)/(RR-T1*TX))/(RR*TX)
      RR = T2*(T2*TX**2+RO*(1-T2))
      RR = DSQRT(RR)
      RL3424 = 2*DLOG((T2*TX+RR)/(RR-T2*TX))/(RR*TX)
      RR = TX**2+RO*(1-T1)*(1-T2)
      RR = DSQRT(RR)
      RL1424 = 2*DLOG((TX+RR)/(RR-TX))/(RR*TX)
      RL34 = DLOG((2*TX**2+2*B*TX-2*TX-RO)/(2*TX**2-2*B*TX-2*TX-RO))/(B*
     1   TX)
      RL35 = DLOG((2*TX+RO-2*B-2)/(2*TX+RO+2*B-2))/B
      TMP0 = T1*(-T2-T1+1)*T22**2+(-T2-T1+1)/T1+T1/(-T2-T1+1)
      TMP0 = -3*(3*T2**2-3*T2+4/ 3.D0)*(4*RO*T2**2/(T1*T22)-4*RO*T2/(T1*
     1   T22)+RO**2/(T1**2*T22**2)+8*T2**4-16*T2**3+12*T2**2-4*T2)*T22**
     2   2*TMP0/( 8.D0*T1*T2**2)
      PP = T11**2*(-T2-T1+1)*T2+T2/(-T2-T1+1)+(-T2-T1+1)/T2
      PP = -3*PP*(3*T1**2-3*T1+4/ 3.D0)*T11**2*(4*RO*T1**2/(T11*T2)-4*RO
     1   *T1/(T11*T2)+RO**2/(T11**2*T2**2)+8*T1**4-16*T1**3+12*T1**2-4*T
     2   1)/( 8.D0*T1**2*T2)
      PP = TMP0+PP
      PP = PP*(-T2-T1+1)*VLSM
      TMP0 = -4*(486*T2**5+(-225*T1**2+1622*T1-1530)*T2**4+(-207*T1**3+2
     1   866*T1**2-3399*T1+1692)*T2**3+(1539*T1**3-2997*T1**2+1761*T1-75
     2   6)*T2**2+(-293*T1**3-40*T1**2+187*T1+126)*T2-207*T1**3+396*T1**
     3   2-171*T1-18)
      TMP0 = TMP0+2*RO*((36*T1+324)*T2**4+(72*T1**2+749*T1-716)*T2**3+(4
     1   21*T1**2-906*T1+476)*T2**2+(-13*T1**2+125*T1-100)*T2-32*T1**2-4
     2   *T1+16)+RO**2*(-(36*T1+360)*T2**3-(356*T1-673)*T2**2-(354-358*T
     3   1)*T2-46*T1+41)+2*RO**3*(T2-1)*(9*T2-1)
      TMP0 = -RLGXRO*(T2+T1-1)*T22**3*TMP0/( 2304.D0*T1*T2)
      PP = TMP0+PP
      TMP0 = -32*((3*T1**2-20*T1-13)*T2**2+(-20*T1**2-6*T1+26)*T2-13*T1*
     1   *2+26*T1-13)*TX+8*RO*((T1**2+18*T1+47)*T2**2+(18*T1**2+76*T1-94
     2   )*T2+47*T1**2-94*T1+47)-12*RO**2*((T1+6)*T2+6*T1-6)+3*RO**3
      TMP0 = DRO*(T2+T1-1)*(T2+2*T1-1)*(9*T2-1)*T22**3*TMP0/( 576.D0*T1*
     1   T2*(4*TX+RO))
      PP = TMP0+PP
      PP = PP-(T2+T1-1)**2*(4*RO-T1*(81*T2**3-162*T2**2+125*T2-36))*T22*
     1   *3/( 18.D0*T1)
      TMP0 = RO*(27*T2-4)-2*(27*T1*T2**2+(-4*T1-27)*T2-27*T1+27)
      TMP0 = RLGXRO*(T2+T1-1)**2*T22**2*TMP0/( 128.D0*T2)
      PP = TMP0+PP
      TMP0 = 4*T2*(5184*T2**7+(10368*T1-25920)*T2**6+(10368*T1**2-41472*
     1   T1+54144)*T2**5+(-32076*T1**2+67131*T1-61056)*T2**4+(-1872*T1**
     2   3+33152*T1**2-56453*T1+39744)*T2**3+(-1800*T1**4-8139*T1**3-113
     3   60*T1**2+25485*T1-14400)*T2**2+(-5632*T1**4+11315*T1**3-656*T1*
     4   *2-4983*T1+2304)*T2+424*T1**4-920*T1**3+572*T1**2-76*T1)*TX
      TMP0 = RO**2*((5184*T1+7264)*T2**4+(4608*T1**2-5703*T1-19712)*T2**
     1   3+(-7584*T1**2-7229*T1+19936)*T2**2+(-2392*T1**2+12324*T1-9792)
     2   *T2+2304*T1**2-4608*T1+2304)*TX+TMP0
      TMP0 = TMP0+RO*T2*(5184*T2**7+(10368*T1-25920)*T2**6+(10368*T1**2-
     1   20736*T1+59904)*T2**5+(29952*T1**2-10733*T1-84096)*T2**4+(58752
     2   *T1**3-175028*T1**2+62123*T1+74304)*T2**3+(18432*T1**4-168599*T
     3   1**3+248724*T1**2-70771*T1-37440)*T2**2+(-42320*T1**4+141423*T1
     4   **3-144396*T1**2+39577*T1+8064)*T2+10768*T1**4-31320*T1**3+3038
     5   0*T1**2-9828*T1)+4*RO**3*(364*T2**4+(359*T1-1052)*T2**3+(67*T1*
     6   *2-990*T1+1156)*T2**2+(-307*T1**2+919*T1-612)*T2+144*T1**2-288*
     7   T1+144)
      TMP0 = -T22**2*TMP0/( 1152.D0*T1**2*T2**2*(4*TX+RO))
      PP = TMP0+PP
      TMP0 = -154*T2**3+2*RO*(T2**2-T2+T1**2-T1)-(66*T1-311)*T2**2-(66*T
     1   1**2-132*T1+157)*T2-154*T1**3+311*T1**2-157*T1
      TMP0 = -RLGXRO*T11*(T2+T1-1)**2*T22*TMP0/( 128.D0*T1*T2)
      PP = TMP0+PP
      TMP0 = 9*T11*(T2+T1-1)*(-18*T2**3+RO*(T2**2-T2+T1**2-T1)-(12*T1-41
     1   )*T2**2-(12*T1**2-24*T1+23)*T2-18*T1**3+41*T1**2-23*T1)*T22/( 1
     2   28.D0*T1*T2)
      PP = TMP0+PP
      TMP0 = -T1**2*(3240*T2**6+(9720*T1-9720)*T2**5+(9072*T1**2-23040*T
     1   1+12960)*T2**4+(1944*T1**3-13716*T1**2+23548*T1-9720)*T2**3+(-6
     2   48*T1**4+2772*T1**3+8414*T1**2-13300*T1+3240)*T2**2+(4392*T1**4
     3   -1904*T1**3-4723*T1**2+3044*T1)*T2+1610*T1**4-3063*T1**3+1433*T
     4   1**2+28*T1)
      TMP0 = TMP0+2*RO*T1*(2430*T2**5+(5670*T1-6480)*T2**4+(4068*T1**2-1
     1   1393*T1+6480)*T2**3+(990*T1**3-5450*T1**2+7396*T1-3240)*T2**2+(
     2   324*T1**4-849*T1**3+1383*T1**2-1673*T1+810)*T2-33*T1**4+51*T1**
     3   3-9*T1**2)-2*RO**2*(810*T2**4+(1215*T1-2025)*T2**3+(9*T1**3+485
     4   *T1**2-2025*T1+1620)*T2**2+(9*T1**4+76*T1**3-485*T1**2+810*T1-4
     5   05)*T2-13*T1**4+11*T1**3)+RO**3*T1**2*(8*T2-T1)
      TMP0 = -RLGXRO*(T2+T1-1)*T22*TMP0/( 1152.D0*T1**4*T2)
      PP = TMP0+PP
      PP = 9*RLGRO*(2*(8*T2**3+(14*T1-21)*T2**2+(16*T1**3-27*T1+22)*T2+1
     1   6*T1**4-32*T1**3+12*T1**2+9*T1-9)+RO*(2*T2**2+3*T2+8*T1**2-8*T1
     2   -5)+4*RO**2)*T22/( 128.D0*T1)+PP
      PP = RLG22*(2*T2*(2*T2**3+(-T1-2)*T2**2-T1**2*T2-2*T1**3+T1**2-T1)
     1   +RO*(-(8*T1-2)*T2**2-(6*T1**2-5*T1+2)*T2+2*T1**2-T1)+RO**2*(T2*
     2   *2+(3*T1+1)*T2+2*T1**2-T1))*T22/( 64.D0*T1*T2**2)+PP
      TMP0 = -4*T1*(31*T2**3+(-72*T1**3+27*T1**2-10*T1-11)*T2**2+(-72*T1
     1   **4+144*T1**3-25*T1**2-44*T1)*T2+72*T1**4-144*T1**3+72*T1**2)+R
     2   O*(26*T2**3+(-27*T1**2-39*T1-8)*T2**2+(-36*T1**3+149*T1**2-45*T
     3   1-18)*T2+36*T1**3-58*T1**2+20*T1)+2*RO**2*(9*T2**2+(T1+7)*T2-2*
     4   T1**2+T1)
      TMP0 = -RLG21*(T2+T1-1)**2*T22*TMP0/( 128.D0*T1**2*T2**2)
      PP = TMP0+PP
      TMP0 = 4*T1**2*(180*T2**6+(360*T1-360)*T2**5+(144*T1**2-666*T1+360
     1   )*T2**4+(-108*T1**3-306*T1**2+517*T1-180)*T2**3+(-72*T1**4+36*T
     2   1**3+89*T1**2-209*T1)*T2**2+(2*T1**3-35*T1**2)*T2-72*T1**4+72*T
     3   1**3)
      TMP0 = TMP0-RO*T1*(1080*T2**5+(1440*T1-1800)*T2**4+(243*T1**2-2026
     1   *T1+1080)*T2**3+(-72*T1**3-354*T1**2+604*T1-360)*T2**2+(104*T1*
     2   *3-45*T1**2-18*T1)*T2-40*T1**3+20*T1**2)+2*RO**2*(180*T2**4+(90
     3   *T1-270)*T2**3+(-27*T1**2-90*T1+90)*T2**2+(-T1**3-7*T1**2)*T2+2
     4   *T1**4-T1**3)
      TMP0 = RLG12*(T2+T1-1)**2*T22*TMP0/( 128.D0*T1**4*T2**2)
      PP = TMP0+PP
      TMP0 = 2*RO*((T1**2-3*T1+1)*T2-3*T1**2+T1-1)+RO**2*((T1+1)*T2+2*T1
     1   **2+T1+1)-4*T1*((T1+1)*T2+T1**2-T1)
      TMP0 = -RL3524*(T2+T1-1)*T22*TMP0/( 128.D0*T1)
      PP = TMP0+PP
      TMP0 = -2*(T2**3+(5*T1+1)*T2**2+(8*T1**2+T1)*T2+8*T1**3)*TX+RO*(T2
     1   **3-4*T1*T2**2+(-2*T1**2-T1-1)*T2-2*T1**2+T1)+RO**2*T2*(T2+1)
      TMP0 = -9*RL3424*(T2+T1-1)**2*T22*TMP0/( 128.D0*T1*T2)
      PP = TMP0+PP
      TMP0 = -4*((T1-1)*T2+T1**2-T1+2)*TX+RO**2*((T1-1)*T2+2*T1**2-3*T1+
     1   3)+2*RO*(T2+1)*(T2+T1**2-T1-1)
      TMP0 = RL1424*(T2+T1-1)**2*T22*TMP0/( 128.D0*T1)
      PP = TMP0+PP
      PP = PP-D2435*(RO-2*T1)*(16*T1**2+16*RO*T1+RO**2)*(T2+T1-1)**2*T22
     1   /( 72.D0*T1)
      TMP0 = 4*T1**3*((36*T1-72)*T2**5+(-144*T1**2-468*T1-25)*T2**4+(-10
     1   8*T1**3-414*T1**2+424*T1+270)*T2**3+(-144*T1**4-270*T1**3+711*T
     2   1**2-139*T1-177)*T2**2+(-144*T1**5+576*T1**4-520*T1**3-59*T1**2
     3   +147*T1+4)*T2+144*T1**5-432*T1**4+432*T1**3-144*T1**2)*TX
      TMP0 = TMP0+RO*T1*(6912*T2**7+(20736*T1-27648)*T2**6+(36*T1**3+223
     1   56*T1**2-64732*T1+44544)*T2**5+(-144*T1**4+6984*T1**3-53223*T1*
     2   *2+79032*T1-39936)*T2**4+(-108*T1**5-3258*T1**4-10806*T1**3+495
     3   30*T1**2-56064*T1+25344)*T2**3+(-144*T1**6-2106*T1**5+5755*T1**
     4   4+6643*T1**3-29251*T1**2+30280*T1-12288)*T2**2+(-144*T1**7+432*
     5   T1**6+1080*T1**5-2183*T1**4-4021*T1**3+11024*T1**2-9252*T1+3072
     6   )*T2+144*T1**7-288*T1**6+440*T1**5-1024*T1**4+1164*T1**3-436*T1
     7   **2)
      TMP0 = TMP0+RO**2*(-(1728*T1+1152)*T2**6-(3456*T1**2-1728*T1-4032)
     1   *T2**5-(2151*T1**3-5135*T1**2-2688*T1+5120)*T2**4-(-288*T1**4-3
     2   673*T1**3+3375*T1**2+2688*T1-3200)*T2**3-(-423*T1**5+278*T1**4+
     3   3738*T1**3-3889*T1**2-576*T1+1920)*T2**2-(-36*T1**6+296*T1**5+4
     4   79*T1**4-2573*T1**3+913*T1**2+2112*T1-1472)*T2-36*T1**6-278*T1*
     5   *5+926*T1**4-357*T1**3-1280*T1**2+1536*T1-512)
      TMP0 = TMP0+2*RO**3*(144*T2**5+(288*T1-360)*T2**4+(17*T1**2-432*T1
     1   +280)*T2**3+(-25*T1**3+80*T1**2+128*T1-120)*T2**2+(-4*T1**4+56*
     2   T1**3-65*T1**2-112*T1+120)*T2+30*T1**4-63*T1**3-32*T1**2+128*T1
     3   -64)
      TMP0 = T22*TMP0/( 128.D0*T1**4*T2**2*(4*TX+RO))
      PP = TMP0+PP
      TMP0 = 4*((207*T1**3-1539*T1**2+293*T1+207)*T2**3+(225*T1**4-2866*
     1   T1**3+2997*T1**2+40*T1-396)*T2**2+(-1622*T1**4+3399*T1**3-1761*
     2   T1**2-187*T1+171)*T2-486*T1**5+1530*T1**4-1692*T1**3+756*T1**2-
     3   126*T1+18)
      TMP0 = TMP0+2*RO*((72*T1**3+421*T1**2-13*T1-32)*T2**2+(36*T1**4+74
     1   9*T1**3-906*T1**2+125*T1-4)*T2+324*T1**4-716*T1**3+476*T1**2-10
     2   0*T1+16)+RO**2*(-(36*T1**3+356*T1**2-358*T1+46)*T2-360*T1**3+67
     3   3*T1**2-354*T1+41)+2*RO**3*(T1-1)*(9*T1-1)
      TMP0 = -RLGXRO*T11**3*(T2+T1-1)*TMP0/( 2304.D0*T1*T2)
      PP = TMP0+PP
      TMP0 = -32*((3*T1**2-20*T1-13)*T2**2+(-20*T1**2-6*T1+26)*T2-13*T1*
     1   *2+26*T1-13)*TX+8*RO*((T1**2+18*T1+47)*T2**2+(18*T1**2+76*T1-94
     2   )*T2+47*T1**2-94*T1+47)-12*RO**2*((T1+6)*T2+6*T1-6)+3*RO**3
      TMP0 = DRO*(9*T1-1)*T11**3*(T2+T1-1)*(2*T2+T1-1)*TMP0/( 576.D0*T1*
     1   T2*(4*TX+RO))
      PP = TMP0+PP
      PP = PP-T11**3*(T2+T1-1)**2*(4*RO-(81*T1**3-162*T1**2+125*T1-36)*T
     1   2)/( 18.D0*T2)
      TMP0 = RO*(27*T1-4)-2*((27*T1**2-4*T1-27)*T2-27*T1+27)
      TMP0 = RLGXRO*T11**2*(T2+T1-1)**2*TMP0/( 128.D0*T1)
      PP = TMP0+PP
      TMP0 = -4*T1*((1800*T1**2+5632*T1-424)*T2**4+(1872*T1**3+8139*T1**
     1   2-11315*T1+920)*T2**3+(-10368*T1**5+32076*T1**4-33152*T1**3+113
     2   60*T1**2+656*T1-572)*T2**2+(-10368*T1**6+41472*T1**5-67131*T1**
     3   4+56453*T1**3-25485*T1**2+4983*T1+76)*T2-5184*T1**7+25920*T1**6
     4   -54144*T1**5+61056*T1**4-39744*T1**3+14400*T1**2-2304*T1)*TX
      TMP0 = RO**2*((4608*T1**3-7584*T1**2-2392*T1+2304)*T2**2+(5184*T1*
     1   *4-5703*T1**3-7229*T1**2+12324*T1-4608)*T2+7264*T1**4-19712*T1*
     2   *3+19936*T1**2-9792*T1+2304)*TX+TMP0
      TMP0 = TMP0+RO*T1*((18432*T1**2-42320*T1+10768)*T2**4+(58752*T1**3
     1   -168599*T1**2+141423*T1-31320)*T2**3+(10368*T1**5+29952*T1**4-1
     2   75028*T1**3+248724*T1**2-144396*T1+30380)*T2**2+(10368*T1**6-20
     3   736*T1**5-10733*T1**4+62123*T1**3-70771*T1**2+39577*T1-9828)*T2
     4   +5184*T1**7-25920*T1**6+59904*T1**5-84096*T1**4+74304*T1**3-374
     5   40*T1**2+8064*T1)+4*RO**3*((67*T1**2-307*T1+144)*T2**2+(359*T1*
     6   *3-990*T1**2+919*T1-288)*T2+364*T1**4-1052*T1**3+1156*T1**2-612
     7   *T1+144)
      TMP0 = -T11**2*TMP0/( 1152.D0*T1**2*T2**2*(4*TX+RO))
      PP = TMP0+PP
      TMP0 = -T2**2*((648*T1**2-4392*T1-1610)*T2**4+(-1944*T1**3-2772*T1
     1   **2+1904*T1+3063)*T2**3+(-9072*T1**4+13716*T1**3-8414*T1**2+472
     2   3*T1-1433)*T2**2+(-9720*T1**5+23040*T1**4-23548*T1**3+13300*T1*
     3   *2-3044*T1-28)*T2-3240*T1**6+9720*T1**5-12960*T1**4+9720*T1**3-
     4   3240*T1**2)
      TMP0 = TMP0-2*RO*T2*((324*T1-33)*T2**4+(990*T1**2-849*T1+51)*T2**3
     1   +(4068*T1**3-5450*T1**2+1383*T1-9)*T2**2+(5670*T1**4-11393*T1**
     2   3+7396*T1**2-1673*T1)*T2+2430*T1**5-6480*T1**4+6480*T1**3-3240*
     3   T1**2+810*T1)+2*RO**2*((9*T1-13)*T2**4+(9*T1**2+76*T1+11)*T2**3
     4   +(485*T1**2-485*T1)*T2**2+(1215*T1**3-2025*T1**2+810*T1)*T2+810
     5   *T1**4-2025*T1**3+1620*T1**2-405*T1)+RO**3*T2**2*(T2-8*T1)
      TMP0 = RLGXRO*T11*(T2+T1-1)*TMP0/( 1152.D0*T1*T2**4)
      PP = TMP0+PP
      PP = 9*RLGRO*T11*(2*(16*T2**4+(16*T1-32)*T2**3+12*T2**2+(14*T1**2-
     1   27*T1+9)*T2+8*T1**3-21*T1**2+22*T1-9)+RO*(8*T2**2-8*T2+2*T1**2+
     2   3*T1-5)+4*RO**2)/( 128.D0*T2)+PP
      TMP0 = -4*T2**2*((72*T1**2+72)*T2**4+(108*T1**3-36*T1**2-2*T1-72)*
     1   T2**3+(-144*T1**4+306*T1**3-89*T1**2+35*T1)*T2**2+(-360*T1**5+6
     2   66*T1**4-517*T1**3+209*T1**2)*T2-180*T1**6+360*T1**5-360*T1**4+
     3   180*T1**3)
      TMP0 = TMP0+2*RO**2*(2*T2**4+(-T1-1)*T2**3+(-27*T1**2-7*T1)*T2**2+
     1   (90*T1**3-90*T1**2)*T2+180*T1**4-270*T1**3+90*T1**2)+RO*T2*((72
     2   *T1**2-104*T1+40)*T2**3+(-243*T1**3+354*T1**2+45*T1-20)*T2**2+(
     3   -1440*T1**4+2026*T1**3-604*T1**2+18*T1)*T2-1080*T1**5+1800*T1**
     4   4-1080*T1**3+360*T1**2)
      TMP0 = RLG21*T11*(T2+T1-1)**2*TMP0/( 128.D0*T1**2*T2**4)
      PP = TMP0+PP
      TMP0 = -4*T2*((72*T1-72)*T2**4+(72*T1**2-144*T1+144)*T2**3+(-27*T1
     1   **2+25*T1-72)*T2**2+(10*T1**2+44*T1)*T2-31*T1**3+11*T1**2)+RO*(
     2   (36*T1-36)*T2**3+(27*T1**2-149*T1+58)*T2**2+(39*T1**2+45*T1-20)
     3   *T2-26*T1**3+8*T1**2+18*T1)+2*RO**2*(2*T2**2+(-T1-1)*T2-9*T1**2
     4   -7*T1)
      TMP0 = RLG12*T11*(T2+T1-1)**2*TMP0/( 128.D0*T1**2*T2**2)
      PP = TMP0+PP
      PP = RLG11*T11*(-2*T1*(2*T2**3+(T1-1)*T2**2+(T1**2+1)*T2-2*T1**3+2
     1   *T1**2)+RO*(-(6*T1-2)*T2**2-(8*T1**2-5*T1+1)*T2+2*T1**2-2*T1)+R
     2   O**2*(2*T2**2+(3*T1-1)*T2+T1**2+T1))/( 64.D0*T1**2*T2)+PP
      TMP0 = 2*RO*((T1-3)*T2**2+(1-3*T1)*T2+T1-1)+RO**2*(2*T2**2+(T1+1)*
     1   T2+T1+1)-4*T2*(T2**2+(T1-1)*T2+T1)
      TMP0 = -RL3514*T11*(T2+T1-1)*TMP0/( 128.D0*T2)
      PP = TMP0+PP
      TMP0 = -2*(8*T2**3+8*T1*T2**2+(5*T1**2+T1)*T2+T1**3+T1**2)*TX+RO*(
     1   -(2*T1+2)*T2**2-(4*T1**2+T1-1)*T2+T1**3-T1)+RO**2*T1*(T1+1)
      TMP0 = -9*RL3414*T11*(T2+T1-1)**2*TMP0/( 128.D0*T1*T2)
      PP = TMP0+PP
      TMP0 = -4*(T2**2+(T1-1)*T2-T1+2)*TX+RO**2*(2*T2**2+(T1-3)*T2-T1+3)
     1   +2*RO*(T1+1)*(T2**2-T2+T1-1)
      TMP0 = RL1424*T11*(T2+T1-1)**2*TMP0/( 128.D0*T2)
      PP = TMP0+PP
      PP = PP-D1435*T11*(RO-2*T2)*(T2+T1-1)**2*(16*T2**2+16*RO*T2+RO**2)
     1   /( 72.D0*T2)
      TMP0 = 4*T2**3*((144*T1-144)*T2**5+(144*T1**2-576*T1+432)*T2**4+(1
     1   08*T1**3+270*T1**2+520*T1-432)*T2**3+(144*T1**4+414*T1**3-711*T
     2   1**2+59*T1+144)*T2**2+(-36*T1**5+468*T1**4-424*T1**3+139*T1**2-
     3   147*T1)*T2+72*T1**5+25*T1**4-270*T1**3+177*T1**2-4*T1)*TX
      TMP0 = TMP0+RO*T2*((144*T1-144)*T2**7+(144*T1**2-432*T1+288)*T2**6
     1   +(108*T1**3+2106*T1**2-1080*T1-440)*T2**5+(144*T1**4+3258*T1**3
     2   -5755*T1**2+2183*T1+1024)*T2**4+(-36*T1**5-6984*T1**4+10806*T1*
     3   *3-6643*T1**2+4021*T1-1164)*T2**3+(-22356*T1**5+53223*T1**4-495
     4   30*T1**3+29251*T1**2-11024*T1+436)*T2**2+(-20736*T1**6+64732*T1
     5   **5-79032*T1**4+56064*T1**3-30280*T1**2+9252*T1)*T2-6912*T1**7+
     6   27648*T1**6-44544*T1**5+39936*T1**4-25344*T1**3+12288*T1**2-307
     7   2*T1)
      TMP0 = TMP0+RO**2*(-(36*T1-36)*T2**6-(423*T1**2-296*T1-278)*T2**5-
     1   (288*T1**3-278*T1**2-479*T1+926)*T2**4-(-2151*T1**4+3673*T1**3-
     2   3738*T1**2+2573*T1-357)*T2**3-(-3456*T1**5+5135*T1**4-3375*T1**
     3   3+3889*T1**2-913*T1-1280)*T2**2-(-1728*T1**6+1728*T1**5+2688*T1
     4   **4-2688*T1**3+576*T1**2-2112*T1+1536)*T2+1152*T1**6-4032*T1**5
     5   +5120*T1**4-3200*T1**3+1920*T1**2-1472*T1+512)
      TMP0 = TMP0+2*RO**3*((4*T1-30)*T2**4+(25*T1**2-56*T1+63)*T2**3+(-1
     1   7*T1**3-80*T1**2+65*T1+32)*T2**2+(-288*T1**4+432*T1**3-128*T1**
     2   2+112*T1-128)*T2-144*T1**5+360*T1**4-280*T1**3+120*T1**2-120*T1
     3   +64)
      TMP0 = -T11*TMP0/( 128.D0*T1**2*T2**4*(4*TX+RO))
      PP = TMP0+PP
      TMP0 = -RO*T1*T2*(30*T2**5+(40*T1-20)*T2**4+(8*T1**2-15*T1+10)*T2*
     1   *3+8*T1**3*T2**2+(40*T1**4-15*T1**3)*T2+30*T1**5-20*T1**4+10*T1
     2   **3)
      TMP0 = TMP0+5*RO**2*(2*T2**5+(T1-1)*T2**4+T1**4*T2+2*T1**5-T1**4)+
     1   2*T1**2*T2**2*(T2+T1)*(10*T2**4+(10*T1-10)*T2**3+(-4*T1**2-5*T1
     2   +10)*T2**2+(10*T1**3-5*T1**2)*T2+10*T1**4-10*T1**3+10*T1**2)
      TMP0 = 9*RLGXRO*(T2+T1-1)**2*TMP0/( 64.D0*T1**4*T2**4)
      PP = TMP0+PP
      PP = PP-9*RLGRO*(2*(16*T2**4+(48*T1-40)*T2**3+(96*T1**2-126*T1+41)
     1   *T2**2+(48*T1**3-126*T1**2+90*T1-17)*T2+16*T1**4-40*T1**3+41*T1
     2   **2-17*T1)+RO*(6*T2**2-5*T2+6*T1**2-5*T1))/( 128.D0*T1*T2)
      PP = 9*ITX*RLG22*(-2*T2*(17*T2**3+(10*T1-21)*T2**2+(9*T1**2-7*T1+1
     1   4)*T2-2*T1**2+2*T1-4)+RO*(-5*T2**3-(4*T1+7)*T2**2-(-T1**2-3*T1-
     2   4)*T2+2*T1**2-4*T1)+2*RO**2*(T2+T1-2))/( 128.D0*T2**2)+PP
      PP = PP-RLG22*(-2*T2*((81*T1-4)*T2**2+(45*T1**2-43*T1+8)*T2+36*T1*
     1   *3-20*T1**2+20*T1-4)+RO*(-45*T1*T2**2-(63*T1**2-17*T1-4)*T2+22*
     2   T1**2-38*T1)+2*RO**2*((18*T1+1)*T2+18*T1**2-8*T1-2))/( 128.D0*T
     3   1*T2**2)
      TMP0 = RO*(2*T2**3+(3*T1**2+2*T1+4)*T2**2+(-5*T1**3+2*T1**2+8*T1)*
     1   T2-6*T1**3+4*T1**2)-4*T1*T2*((8*T1**2-4*T1-1)*T2**2+(-4*T1-4)*T
     2   2-4*T1**3+3*T1**2-6*T1)+2*RO**2*(T2**2+(2*T1-4)*T2+3*T1**2-4*T1
     3   )
      TMP0 = 9*ITX*RLG21*(T2+T1-1)**2*TMP0/( 128.D0*T1**2*T2**2)
      PP = TMP0+PP
      TMP0 = 2*RO**2*(18*T1**2*T2**5+(18*T1**3-73*T1**2+72*T1-104)*T2**4
     1   +(18*T1**4-132*T1**3+223*T1**2-208*T1+136)*T2**3+(18*T1**5-271*
     2   T1**4+241*T1**3-156*T1**2+64*T1-32)*T2**2+(-414*T1**5+468*T1**4
     3   -208*T1**3+64*T1**2)*T2-252*T1**6+486*T1**5-338*T1**4+136*T1**3
     4   -32*T1**2)
      TMP0 = TMP0-4*T1**2*T2**2*((72*T1-72)*T2**5+(396*T1**2-306*T1+272)
     1   *T2**4+(1116*T1**3-1080*T1**2+637*T1-400)*T2**3+(1584*T1**4-229
     2   5*T1**3+1505*T1**2-653*T1+264)*T2**2+(1116*T1**5-2169*T1**4+209
     3   5*T1**3-1058*T1**2+310*T1-64)*T2+396*T1**6-1008*T1**5+1280*T1**
     4   4-940*T1**3+336*T1**2-64*T1)
      TMP0 = TMP0+RO*T1*T2*((216*T1**2-188*T1+832)*T2**4+(1323*T1**3-121
     1   0*T1**2+1310*T1-1088)*T2**3+(3159*T1**4-3199*T1**3+1370*T1**2-5
     2   46*T1+256)*T2**2+(3636*T1**5-5138*T1**4+2768*T1**3-546*T1**2)*T
     3   2+1656*T1**6-3528*T1**5+3064*T1**4-1448*T1**3+256*T1**2)
      TMP0 = -RLG21*(T2+T1-1)*TMP0/( 128.D0*T1**4*T2**4)
      PP = TMP0+PP
      TMP0 = RO*(-(5*T1+6)*T2**3-(-3*T1**2-2*T1-4)*T2**2-(-2*T1**2-8*T1)
     1   *T2+2*T1**3+4*T1**2)+4*T1*T2*(4*T2**3+(-8*T1**2-3)*T2**2+(4*T1*
     2   *2+4*T1+6)*T2+T1**2+4*T1)+2*RO**2*(3*T2**2+(2*T1-4)*T2+T1**2-4*
     3   T1)
      TMP0 = 9*ITX*RLG12*(T2+T1-1)**2*TMP0/( 128.D0*T1**2*T2**2)
      PP = TMP0+PP
      TMP0 = -RO*T1*T2*(1656*T2**6+(3636*T1-3528)*T2**5+(3159*T1**2-5138
     1   *T1+3064)*T2**4+(1323*T1**3-3199*T1**2+2768*T1-1448)*T2**3+(216
     2   *T1**4-1210*T1**3+1370*T1**2-546*T1+256)*T2**2+(-188*T1**4+1310
     3   *T1**3-546*T1**2)*T2+832*T1**4-1088*T1**3+256*T1**2)
      TMP0 = TMP0+4*T1**2*T2**2*(396*T2**6+(1116*T1-1008)*T2**5+(1584*T1
     1   **2-2169*T1+1280)*T2**4+(1116*T1**3-2295*T1**2+2095*T1-940)*T2*
     2   *3+(396*T1**4-1080*T1**3+1505*T1**2-1058*T1+336)*T2**2+(72*T1**
     3   5-306*T1**4+637*T1**3-653*T1**2+310*T1-64)*T2-72*T1**5+272*T1**
     4   4-400*T1**3+264*T1**2-64*T1)
      TMP0 = TMP0+2*RO**2*(252*T2**6+(-18*T1**2+414*T1-486)*T2**5+(-18*T
     1   1**3+271*T1**2-468*T1+338)*T2**4+(-18*T1**4+132*T1**3-241*T1**2
     2   +208*T1-136)*T2**3+(-18*T1**5+73*T1**4-223*T1**3+156*T1**2-64*T
     3   1+32)*T2**2+(-72*T1**4+208*T1**3-64*T1**2)*T2+104*T1**4-136*T1*
     4   *3+32*T1**2)
      TMP0 = RLG12*(T2+T1-1)*TMP0/( 128.D0*T1**4*T2**4)
      PP = TMP0+PP
      PP = 9*ITX*RLG11*(-2*T1*((9*T1-2)*T2**2+(10*T1**2-7*T1+2)*T2+17*T1
     1   **3-21*T1**2+14*T1-4)+RO*((T1+2)*T2**2+(-4*T1**2+3*T1-4)*T2-5*T
     2   1**3-7*T1**2+4*T1)+2*RO**2*(T2+T1-2))/( 128.D0*T1**2)+PP
      PP = PP-RLG11*(-2*T1*(36*T2**3+(45*T1-20)*T2**2+(81*T1**2-43*T1+20
     1   )*T2-4*T1**2+8*T1-4)+RO*(-(63*T1-22)*T2**2-(45*T1**2-17*T1+38)*
     2   T2+4*T1)+2*RO**2*(18*T2**2+(18*T1-8)*T2+T1-2))/( 128.D0*T1**2*T
     3   2)
      TMP0 = RO*((T1+1)*T2**2+(2*T1-2)*T2-T1**3+3*T1**2)+2*T1*((T1+1)*T2
     1   +3*T1**2+T1+2)+RO**2*((T1+1)*T2-T1**2-T1-2)
      TMP0 = 9*ITX*RL3524*(T2+T1-1)*TMP0/( 128.D0*T1)
      PP = TMP0+PP
      TMP0 = -2*RO*T1*(2*T2**3+(2*T1-4)*T2**2+(-6*T1-1)*T2+3*T1+3)-8*T1*
     1   *2*(2*T2**2+(2*T1-2)*T2-T1)+RO**2*(T2-1)*(3*T2-T1-3)
      TMP0 = -D2435**2*RL3524*RO**3*(T2+T1-1)*TMP0/ 144.D0
      PP = TMP0+PP
      TMP0 = D2435*RL3524*RO*(T2+T1-1)*(32*T1**2*(T1+1)*TX-16*RO*T1*((5*
     1   T1-1)*T2+T1**2-3*T1+1)-2*RO**2*T1*((T1+1)*T2-8*T1)+RO**3*((T1-1
     2   )*T2+1))/( 288.D0*T1)
      PP = TMP0+PP
      PP = RL3524*(RO*(-(65*T1+65)*T2**3-(-14*T1**2-421*T1-209)*T2**2-(-
     1   79*T1**3-362*T1**2+257*T1+144)*T2+2*T1**3+16*T1**2-18*T1)-2*RO*
     2   *2*(64*T2**3+(93*T1-99)*T2**2+(21*T1**2-72*T1+27)*T2+T1**3+10*T
     3   1**2+10*T1+9)-2*T1*((63*T1+63)*T2**2+(79*T1**2-47)*T2-2*T1**3-1
     4   8*T1**2-2*T1-18)+RO**3*((8*T1+1)*T2**2+(8*T1**2-6*T1)*T2+T1**2+
     5   9*T1))/( 1152.D0*T1*T2)+PP
      TMP0 = RO*(T2**3-3*T2**2+(-T1**2-2*T1)*T2-T1**2+2*T1)-2*T2*(3*T2**
     1   2+(T1+1)*T2+T1+2)+RO**2*(T2**2+(1-T1)*T2-T1+2)
      TMP0 = -9*ITX*RL3514*(T2+T1-1)*TMP0/( 128.D0*T2)
      PP = TMP0+PP
      TMP0 = 2*RO*T2*((2*T1**2-6*T1+3)*T2+2*T1**3-4*T1**2-T1+3)+8*T2**2*
     1   ((2*T1-1)*T2+2*T1**2-2*T1)+RO**2*(T1-1)*(T2-3*T1+3)
      TMP0 = D1435**2*RL3514*RO**3*(T2+T1-1)*TMP0/ 144.D0
      PP = TMP0+PP
      TMP0 = D1435*RL3514*RO*(T2+T1-1)*(32*T2**2*(T2+1)*TX-16*RO*T2*(T2*
     1   *2+(5*T1-3)*T2-T1+1)+RO**3*(T1*T2-T1+1)-2*RO**2*T2*((T1-8)*T2+T
     2   1))/( 288.D0*T2)
      PP = TMP0+PP
      PP = RL3514*(RO*((79*T1+2)*T2**3+(14*T1**2+362*T1+16)*T2**2+(-65*T
     1   1**3+421*T1**2-257*T1-18)*T2-65*T1**3+209*T1**2-144*T1)+2*T2*(2
     2   *T2**3+(18-79*T1)*T2**2+(2-63*T1**2)*T2-63*T1**2+47*T1+18)-2*RO
     3   **2*(T2**3+(21*T1+10)*T2**2+(93*T1**2-72*T1+10)*T2+64*T1**3-99*
     4   T1**2+27*T1+9)+RO**3*((8*T1+1)*T2**2+(8*T1**2-6*T1+9)*T2+T1**2)
     5   )/( 1152.D0*T1*T2)+PP
      TMP0 = -4*RO*(T2**2+3*T1*T2+T1**2)+4*(T2+T1)**2*(T2**2+T1**2)+3*RO
     1   **2
      TMP0 = -9*DLAM2**2*ITX*RL35*(T2+T1-1)**3*(T2+T1+RO)*TMP0/ 64.D0
      PP = TMP0+PP
      TMP0 = -4*(T2+T1)*(3*T2**3+(5*T1-2)*T2**2+5*T1**2*T2+3*T1**3-2*T1*
     1   *2)-RO*(T2+T1)*(12*T2**2+(8*T1-13)*T2+12*T1**2-13*T1+4)+RO**2*(
     2   8*T2+8*T1-5)
      TMP0 = -9*DLAM2*ITX*RL35*(T2+T1-1)**2*TMP0/ 128.D0
      PP = TMP0+PP
      TMP0 = -2*(2*T2**3+(6*T1-11)*T2**2+(6*T1**2-6*T1+12)*T2+2*T1**3-11
     1   *T1**2+12*T1)+RO*(-4*T2**2-(8*T1-1)*T2-4*T1**2+T1-1)+4*RO**2
      TMP0 = 9*ITX*RL35*(T2+T1-1)*TMP0/ 128.D0
      PP = TMP0+PP
      TMP0 = 4*RO*T1*T2*(32*T2**4+(64*T1-68)*T2**3+(64*T1**2-48*T1+37)*T
     1   2**2+(64*T1**3-48*T1**2+106*T1)*T2+32*T1**4-68*T1**3+37*T1**2)
      TMP0 = TMP0+RO**2*(-128*T1*T2**3-(384*T1**2-44*T1+3)*T2**2-(128*T1
     1   **3-44*T1**2+102*T1)*T2-3*T1**2)+8*T1*T2*(T2+T1)**2*(18*T2**3+(
     2   18*T1-17)*T2**2+(18*T1**2-2*T1)*T2+18*T1**3-17*T1**2)+96*RO**3*
     3   T1*T2
      TMP0 = DLAM2**2*RL35*(T2+T1-1)**2*TMP0/( 256.D0*T1*T2)
      PP = TMP0+PP
      TMP0 = -4*RO*(207*T1*T2**4+(369*T1**2-387*T1)*T2**3+(369*T1**3-198
     1   *T1**2+207*T1+5)*T2**2+(207*T1**4-387*T1**3+207*T1**2+T1)*T2+5*
     2   T1**2)-4*T1*T2*(T2+T1)*(243*T2**3+(405*T1-243)*T2**2+(405*T1**2
     3   -234*T1-11)*T2+243*T1**3-243*T1**2-11*T1)+9*RO**2*((60*T1-2)*T2
     4   **2+(60*T1**2-32*T1+3)*T2-2*T1**2+3*T1)+9*RO**3*(T2+T1)
      TMP0 = DLAM2*RL35*(T2+T1-1)*TMP0/( 1152.D0*T1*T2)
      PP = TMP0+PP
      PP = RL35*((162*T1-18)*T2**4+RO*((126*T1-18)*T2**3+(324*T1**2-594*
     1   T1+16)*T2**2+(126*T1**3-594*T1**2+468*T1+3)*T2-18*T1**3+16*T1**
     2   2+3*T1)+(486*T1**2-567*T1+18)*T2**3+RO**2*(9*T2**2+(10-36*T1)*T
     3   2+9*T1**2+10*T1)+(486*T1**3-1242*T1**2+725*T1-38)*T2**2+(162*T1
     4   **4-567*T1**3+725*T1**2-292*T1)*T2-18*T1**4+18*T1**3-38*T1**2)/
     5   ( 576.D0*T1*T2)+PP
      TMP0 = 2*T2*(9*T2**2+(13*T1-8)*T2+8*T1**2-8*T1+4)*TX+RO*(5*T2**3+(
     1   3*T1-2)*T2**2+(-2*T1**2+2*T1-4)*T2-8*T1)+4*RO**2*(T2**2-T2+1)
      TMP0 = -9*ITX*RL3424*(T2+T1-1)**2*TMP0/( 256.D0*T2)
      PP = TMP0+PP
      TMP0 = 2*T2*((17*T1-6)*T2**2+(24*T1**2-34*T1+4)*T2+16*T1**3-32*T1*
     1   *2+16*T1)*TX+RO*((5*T1-2)*T2**3+(6*T1**2+2*T1-6)*T2**2+(12*T1**
     2   2-22*T1)*T2-32*T1**2)+2*RO**2*(T2-2)*T2
      TMP0 = 9*RL3424*(T2+T1-1)**2*TMP0/( 256.D0*T1*T2**2)
      PP = TMP0+PP
      TMP0 = 2*T1*(8*T2**2+(13*T1-8)*T2+9*T1**2-8*T1+4)*TX+RO*(-2*T1*T2*
     1   *2-(-3*T1**2-2*T1+8)*T2+5*T1**3-2*T1**2-4*T1)+4*RO**2*(T1**2-T1
     2   +1)
      TMP0 = -9*ITX*RL3414*(T2+T1-1)**2*TMP0/( 256.D0*T1)
      PP = TMP0+PP
      TMP0 = 2*T1*(16*T2**3+(24*T1-32)*T2**2+(17*T1**2-34*T1+16)*T2-6*T1
     1   **2+4*T1)*TX+RO*((6*T1**2+12*T1-32)*T2**2+(5*T1**3+2*T1**2-22*T
     2   1)*T2-2*T1**3-6*T1**2)+2*RO**2*(T1-2)*T1
      TMP0 = 9*RL3414*(T2+T1-1)**2*TMP0/( 256.D0*T1**2*T2)
      PP = TMP0+PP
      TMP0 = -4*RO*(T2**2+3*T1*T2+T1**2)+4*(T2+T1)**2*(T2**2+T1**2)+3*RO
     1   **2
      TMP0 = -9*DLAM2**2*ITX*RL34*(-T2-T1+RO)*(T2+T1-1)**2*TMP0/ 64.D0
      PP = TMP0+PP
      TMP0 = 4*(T2+T1)*(T2**3+(2-T1)*T2**2-T1**2*T2+T1**3+2*T1**2)-RO*(T
     1   2+T1)*(4*T2**2+(5-8*T1)*T2+4*T1**2+5*T1+4)+5*RO**2
      TMP0 = -9*DLAM2*ITX*RL34*(T2+T1-1)**2*TMP0/ 128.D0
      PP = TMP0+PP
      TMP0 = -2*(2*T2**3+(14*T1+3)*T2**2+(14*T1**2+22*T1-12)*T2+2*T1**3+
     1   3*T1**2-12*T1)+RO*(2*T2+2*T1-1)+4*RO**2
      TMP0 = 9*ITX*RL34*(T2+T1-1)**2*TMP0/ 128.D0
      PP = TMP0+PP
      TMP0 = 4*RO*((32*T1**2+8*T1)*T2**5+(96*T1**3-48*T1**2-4*T1+2)*T2**
     1   4+(96*T1**4-112*T1**3+40*T1**2-3*T1)*T2**3+(32*T1**5-48*T1**4+4
     2   0*T1**3-18*T1**2)*T2**2+(8*T1**5-4*T1**4-3*T1**3)*T2+2*T1**4)
      TMP0 = -24*RO**3*T1*T2*TX+TMP0-8*(T2+T1)**2*((2*T1+1)*T2**4+(2*T1*
     1   *2-3*T1)*T2**3+2*T1**3*T2**2+(2*T1**4-3*T1**3)*T2+T1**4)+RO**2*
     2   (-48*T1*T2**4-(176*T1**2-64*T1)*T2**3-(176*T1**3-160*T1**2+28*T
     3   1+3)*T2**2-(48*T1**4-64*T1**3+28*T1**2-18*T1)*T2-3*T1**2)
      TMP0 = 9*DLAM2**2*RL34*(T2+T1-1)*TMP0/( 256.D0*T1*T2)
      PP = TMP0+PP
      TMP0 = RO*((26*T1+8)*T2**4+(110*T1**2-49*T1+8)*T2**3+(110*T1**3-11
     1   4*T1**2+57*T1-4)*T2**2+(26*T1**4-49*T1**3+57*T1**2-52*T1)*T2+8*
     2   T1**4+8*T1**3-4*T1**2)
      TMP0 = TMP0+(T2+T1)*((17*T1-24)*T2**4+(83*T1**2-41*T1+8)*T2**3+(83
     1   *T1**3-162*T1**2+52*T1)*T2**2+(17*T1**4-41*T1**3+52*T1**2)*T2-2
     2   4*T1**4+8*T1**3)-2*RO**2*(2*T2**3+(19*T1+2)*T2**2+(19*T1**2-16*
     3   T1-1)*T2+2*T1**3+2*T1**2-T1)+2*RO**3*(T2+T1)
      TMP0 = -9*DLAM2*RL34*(T2+T1-1)*TMP0/( 256.D0*T1*T2)
      PP = TMP0+PP
      TMP0 = (8*T1-32)*T2**4+2*RO*(4*T2**3+(4-21*T1)*T2**2+(-21*T1**2+42
     1   *T1-8)*T2+4*T1**3+4*T1**2-8*T1)+(56*T1**2+101*T1+32)*T2**3+(56*
     2   T1**3+106*T1**2-197*T1-16)*T2**2+(8*T1**4+101*T1**3-197*T1**2+1
     3   32*T1)*T2-32*T1**4+32*T1**3-16*T1**2
      TMP0 = 9*RL34*(T2+T1-1)*TMP0/( 256.D0*T1*T2)
      PP = TMP0+PP
      TMP0 = 4*(T2**2+(2*T1-20)*T2+T1**2-20*T1+20)*TX-2*RO*((T1+10)*T2**
     1   2+(T1**2-20*T1-1)*T2+10*T1**2-T1)+RO**2*(-2*T2**2-(-14*T1-33)*T
     2   2-2*T1**2+33*T1-60)+RO**3*((8*T1+1)*T2+T1-10)
      TMP0 = -RL1424*(T2+T1-1)**2*TMP0/( 1152.D0*T1*T2)
      PP = TMP0+PP
      TMP0 = 3*T1*T2**3+(6*T1**2+14*T1+13)*T2**2+(3*T1**3+14*T1**2-4*T1)
     1   *T2+13*T1**2
      TMP0 = 32*(T2-T1)**2*(T2+T1)*TMP0*TX
      TMP0 = TMP0-8*RO*(72*T1*T2**7+(288*T1**2-287*T1)*T2**6+(504*T1**3-
     1   287*T1**2+464*T1-47)*T2**5+(576*T1**4+574*T1**3-720*T1**2-415*T
     2   1+16)*T2**4+(504*T1**5+574*T1**4-2368*T1**3+1326*T1**2+128*T1+2
     3   2)*T2**3+(288*T1**6-287*T1**5-720*T1**4+1326*T1**3-576*T1**2-22
     4   *T1)*T2**2+(72*T1**7-287*T1**6+464*T1**5-415*T1**4+128*T1**3-22
     5   *T1**2)*T2-47*T1**5+16*T1**4+22*T1**3)
      TMP0 = TMP0+4*RO**2*(36*T1*T2**6+(108*T1**2+36*T1)*T2**5+(144*T1**
     1   3+792*T1**2-T1-18)*T2**4+(144*T1**4+1512*T1**3-1151*T1**2-368*T
     2   1-40)*T2**3+(108*T1**5+792*T1**4-1151*T1**3-92*T1**2+472*T1+40)
     3   *T2**2+(36*T1**6+36*T1**5-T1**4-368*T1**3+472*T1**2-224*T1)*T2-
     4   18*T1**4-40*T1**3+40*T1**2)
      TMP0 = -108*RO**4*T1*T2*TX+TMP0-3*RO**3*(48*T1*T2**4+(192*T1**2+14
     1   4*T1-1)*T2**3+(192*T1**3+240*T1**2-383*T1-8)*T2**2+(48*T1**4+14
     2   4*T1**3-383*T1**2+208*T1)*T2-T1**3-8*T1**2)
      TMP0 = -DLAM2**2*DRO*(T2+T1-1)*TMP0/( 64.D0*T1*T2*(4*TX+RO))
      PP = TMP0+PP
      TMP0 = RO*(8*T2**3+(-T1-8)*T2**2+(2*T1-T1**2)*T2+8*T1**3-8*T1**2)-
     1   6*T1*T2*(6*T2**3+(12*T1-13)*T2**2+(12*T1**2-32*T1+12)*T2+6*T1**
     2   3-13*T1**2+12*T1-2)
      TMP0 = DRO*(T2+T1-1)**2*TMP0/( 9.D0*T1**2*T2**2*(4*TX+RO))
      PP = TMP0+PP
      TMP0 = 8*(T2+T1)**2*(T2**2+T1**2)*TX+4*RO*(T2**4+(2*T1+1)*T2**3+(2
     1   *T1**2+11*T1-1)*T2**2+(2*T1**3+11*T1**2-10*T1)*T2+T1**4+T1**3-T
     2   1**2)-4*RO**2*(T2**2+(3*T1+2)*T2+T1**2+2*T1-2)+3*RO**3
      TMP0 = 13*DLAM2**2*(T2+T1-1)**2*TMP0/( 8.D0*(4*TX+RO))
      PP = TMP0+PP
      TMP0 = RO*(3762*T1*T2**4+(6678*T1**2+3663*T1+1548)*T2**3+(6678*T1*
     1   *3+11934*T1**2-11187*T1-500)*T2**2+(3762*T1**4+3663*T1**3-11187
     2   *T1**2+3356*T1)*T2+1548*T1**3-500*T1**2)
      TMP0 = TMP0-8415*T1*T2**5-(24444*T1**2-9711*T1+1944)*T2**4-(32058*
     1   T1**3-27117*T1**2-1244*T1-568)*T2**3-18*RO**2*((177*T1+32)*T2**
     2   2+(177*T1**2-136*T1-6)*T2+32*T1**2-6*T1)-(24444*T1**4-27117*T1*
     3   *3+8024*T1**2+568*T1)*T2**2+144*RO**3*(T2+T1)-(8415*T1**5-9711*
     4   T1**4-1244*T1**3+568*T1**2)*T2-1944*T1**4+568*T1**3
      TMP0 = -DLAM2*(T2+T1-1)*TMP0/( 576.D0*T1*T2*(4*TX+RO))
      PP = TMP0+PP
      PP = D2435**2*RO**2*(-4*RO*T1*(T2**3+(2*T1-2)*T2**2+T1**2*T2+2*T1*
     1   *2-T1+1)+RO**2*(3*T2**2+(2*T1-6)*T2+3*T1**2-2*T1+3)+4*T1**2*(2*
     2   T2**2+(4*T1-2)*T2+2*T1**2-2*T1+1))/ 36.D0+PP
      PP = PP-D2435*(RO**2+16*RO+16)*(2*T1*(T2+T1)+RO*(T2-T1-1))/ 72.D0
      PP = D1435**2*RO**2*(-4*RO*T2*((T1+2)*T2**2+(2*T1**2-1)*T2+T1**3-2
     1   *T1**2+1)+RO**2*(3*T2**2+(2*T1-2)*T2+3*T1**2-6*T1+3)+4*T2**2*(2
     2   *T2**2+(4*T1-2)*T2+2*T1**2-2*T1+1))/ 36.D0+PP
      PP = D1435*(RO**2+16*RO+16)*(RO*(T2-T1+1)-2*T2*(T2+T1))/ 72.D0+PP
      TMP0 = 2*T1**2*T2**2*(18144*T2**6+(49248*T1-44064)*T2**5+(103311*T
     1   1**2-76932*T1+42912)*T2**4+(116478*T1**3-124803*T1**2+46060*T1-
     2   26208)*T2**3+(103311*T1**4-124803*T1**3+56836*T1**2-17288*T1+92
     3   16)*T2**2+(49248*T1**5-76932*T1**4+46060*T1**3-17288*T1**2-432*
     4   T1)*T2+18144*T1**6-44064*T1**5+42912*T1**4-26208*T1**3+9216*T1*
     5   *2)*TX
      TMP0 = TMP0+RO**2*(-(23328*T1+18144)*T2**7-(48924*T1**2+5184*T1-51
     1   840)*T2**6-(39456*T1**3-6157*T1**2-62208*T1+54720)*T2**5-(19584
     2   *T1**4+743*T1**3-24722*T1**2+39744*T1-34560)*T2**4-(39456*T1**5
     3   +743*T1**4+1856*T1**3+18810*T1**2-30240*T1+21600)*T2**3-(48924*
     4   T1**6-6157*T1**5-24722*T1**4+18810*T1**3-52992*T1**2+24192*T1-8
     5   064)*T2**2-(23328*T1**7+5184*T1**6-62208*T1**5+39744*T1**4-3024
     6   0*T1**3+24192*T1**2)*T2-18144*T1**7+51840*T1**6-54720*T1**5+345
     7   60*T1**4-21600*T1**3+8064*T1**2)
      TMP0 = TMP0+2*RO*T1*T2*((4536*T1+46656)*T2**7+(12312*T1**2+133488*
     1   T1-145152)*T2**6+(26910*T1**3+156591*T1**2-305690*T1+176256)*T2
     2   **5+(30132*T1**4+83799*T1**3-244768*T1**2+254782*T1-124416)*T2*
     3   *4+(26910*T1**5+83799*T1**4-138222*T1**3+175977*T1**2-149144*T1
     4   +67392)*T2**3+(12312*T1**6+156591*T1**5-244768*T1**4+175977*T1*
     5   *3-141696*T1**2+62028*T1-20736)*T2**2+(4536*T1**7+133488*T1**6-
     6   305690*T1**5+254782*T1**4-149144*T1**3+62028*T1**2)*T2+46656*T1
     7   **7-145152*T1**6+176256*T1**5-124416*T1**4+67392*T1**3-20736*T1
     8   **2)
      TMP0 = TMP0+2*RO**3*(2268*T2**6+(4536*T1-4212)*T2**5+(2287*T1**2-3
     1   888*T1+2628)*T2**4+(1514*T1**3-972*T1**2+1368*T1-1692)*T2**3+(2
     2   287*T1**4-972*T1**3+2592*T1**2-2016*T1+1008)*T2**2+(4536*T1**5-
     3   3888*T1**4+1368*T1**3-2016*T1**2)*T2+2268*T1**6-4212*T1**5+2628
     4   *T1**4-1692*T1**3+1008*T1**2)
      TMP0 = TMP0/( 1152.D0*T1**4*T2**4*(4*TX+RO))
      PP = TMP0+PP
      HQHPGG = PP
      RETURN
      ENDIF
      END
      FUNCTION HQHPQA(TX,T1,RO)
      IMPLICIT DOUBLE PRECISION (A-Z)
      IF(TX.EQ.0)THEN
      T2 = 1-T1
      B = DSQRT(1-RO)
      VLSM = DLOG(4/RO)
      SRL12 = DLOG(T1/T2)
      SRLGRO = DLOG(4*T1*T2/RO)
      SRLG1 = DLOG((B+1)/(1-B))/B
      PP = 64*(2*(2*T1**2-2*T1+1)+RO)*VLSM/ 27.D0
      PP = 4*SRLGRO*(2*(2*T1**2-2*T1+1)+RO)/ 27.D0+PP
      PP = 2*(RO-2)*SRLG1*(2*(2*T1**2-2*T1+1)+RO)/ 27.D0+PP
      PP = PP
      PP = PP-32*(2*(2*T1**2-2*T1+1)+RO)/ 27.D0
      HQHPQA = PP
      RETURN
      ELSE
      T2 = -TX-T1+1
      T11 = 1/(1-T1)
      T22 = 1/(TX+T1)
      DRO = 1/(4*TX+RO)
      B = DSQRT((1-TX)**2-RO)
      DLAM2 = 1/(TX**2-2*TX-RO+1)
      VLSM = DLOG(4/RO)
      RLGXRO = DLOG((4*TX+RO)/RO)/TX
      RLG12 = DLOG(T1/(1-T2))/TX
      RLG21 = DLOG(T2/(1-T1))/TX
      RLG11 = DLOG(T1/(1-T1))
      RLG22 = DLOG(T2/(1-T2))
      RLGRO = DLOG(4*(1-T1)*(1-T2)/RO)
      RL34 = DLOG((2*TX**2+2*B*TX-2*TX-RO)/(2*TX**2-2*B*TX-2*TX-RO))/(B*
     1   TX)
      RL35 = DLOG((2*TX+RO-2*B-2)/(2*TX+RO+2*B-2))/B
      TMP0 = RO/(T1*T22)+4*T2**2-4*T2+2
      TMP0 = 16*((-T2-T1+1)**2+2*T1*(-T2-T1+1)+2*T1**2)*T22*TMP0/( 27.D0
     1   *T1*(-T2-T1+1))
      PP = RO/(T11*T2)+4*T1**2-4*T1+2
      PP = 16*PP*T11*((-T2-T1+1)**2+2*T1*(-T2-T1+1)-2*(-T2-T1+1)+2*T1**2
     1   -4*T1+2)/( 27.D0*(-T2-T1+1)*T2)
      PP = TMP0+PP
      PP = PP*(-T2-T1+1)*VLSM
      PP = PP-RLGXRO*(T2+T1-1)*(9*RO*(T2-1)-2*(9*T2**2+(27*T1-11)*T2-11*
     1   T1+2))*T22/ 54.D0
      PP = T22*(4*((63*T1-32)*T2**2+(45*T1**2-89*T1+64)*T2-49*T1**2+26*T
     1   1-32)*TX+RO*((63*T1-32)*T2**2+(63*T1**2-107*T1+64)*T2-67*T1**2+
     2   44*T1-32))/( 54.D0*T1*(4*TX+RO))+PP
      PP = PP-RLGXRO*T11*(T2+T1-1)*(9*RO*(T1-1)-2*((27*T1-11)*T2+9*T1**2
     1   -11*T1+2))/ 54.D0
      PP = T11*(4*((45*T1-49)*T2**2+(63*T1**2-89*T1+26)*T2-32*T1**2+64*T
     1   1-32)*TX+RO*((63*T1-67)*T2**2+(63*T1**2-107*T1+44)*T2-32*T1**2+
     2   64*T1-32))/( 54.D0*T2*(4*TX+RO))+PP
      PP = 4*RLGRO*(2*(T2**2-T2+T1**2-T1+1)+RO)/ 27.D0+PP
      PP = RLG22*(2*(3*T2**2-2*T2+T1**2+1)+RO*(T2+T1+1))/( 3.D0*(T2+T1))
     1   +PP
      TMP0 = RO*(2*T2**3+(2*T1-9)*T2**2+(16*T1**2-32*T1+16)*T2+16*T1**3-
     1   32*T1**2+16*T1)+2*T2*(2*T2**2+2*T1**2-2*T1+1)*(2*T2**2+(7-14*T1
     2   )*T2-16*T1**2+16*T1)
      TMP0 = -RLG21*(T2+T1-1)*TMP0/( 27.D0*T2**2*(T2+T1))
      PP = TMP0+PP
      TMP0 = RO*(16*T2**3+(16*T1-32)*T2**2+(2*T1**2-32*T1+16)*T2+2*T1**3
     1   -9*T1**2+16*T1)-2*T1*(2*T2**2-2*T2+2*T1**2+1)*(16*T2**2+(14*T1-
     2   16)*T2-2*T1**2-7*T1)
      TMP0 = -RLG12*(T2+T1-1)*TMP0/( 27.D0*T1**2*(T2+T1))
      PP = TMP0+PP
      PP = RLG11*(2*(T2**2+3*T1**2-2*T1+1)+RO*(T2+T1+1))/( 3.D0*(T2+T1))
     1   +PP
      TMP0 = RO**2*(-(12*T1-48)*T2**2-(20*T1**2-140*T1+3)*T2-8*T1**3+56*
     1   T1**2-3*T1)+4*RO*T1*(T2+T1)*((2*T1-32)*T2**2+(4*T1**2-34*T1+3)*
     2   T2+2*T1**3-2*T1**2+2*T1)-8*T1**2*(T2+T1)**3+3*RO**3*(T2+T1-9)
      TMP0 = DLAM2**2*RL35*(T2+T1-1)**2*TMP0/( 54.D0*(T2+T1))
      PP = TMP0+PP
      TMP0 = RO*(-(8*T1**2-54*T1+7)*T2**2-(16*T1**3-80*T1**2+40*T1+7)*T2
     1   -8*T1**4+26*T1**3-33*T1**2+11*T1)-2*T1*(T2+T1)*(9*T2**2+(-4*T1-
     2   7)*T2-13*T1**2+11*T1)+RO**2*((4*T1-11)*T2+4*T1**2-29*T1+18)
      TMP0 = DLAM2*RL35*(T2+T1-1)*TMP0/( 27.D0*(T2+T1))
      PP = TMP0+PP
      PP = RL35*(-2*(10*T2**3+(T1-9)*T2**2+(12*T1**2-2*T1+1)*T2+21*T1**3
     1   -29*T1**2+10*T1)+RO*(7*T2**2+(4*T1**2-8*T1+2)*T2+4*T1**3-15*T1*
     2   *2+20*T1-9)+RO**2*(T2+T1))/( 27.D0*(T2+T1))+PP
      TMP0 = RO**2*(-12*T2**4-(56*T1-16)*T2**3-(88*T1**2-68*T1+4)*T2**2-
     1   (56*T1**3-76*T1**2+20*T1-3)*T2-12*T1**4+24*T1**3-12*T1**2+3*T1)
      TMP0 = -3*RO**3*(2*T2+2*T1-1)*TX+TMP0+4*RO*T2*(T2+T1)*((8*T1+2)*T2
     1   **3+(24*T1**2-12*T1-2)*T2**2+(24*T1**3-30*T1**2+6*T1-2)*T2+8*T1
     2   **4-16*T1**3+8*T1**2-3*T1)+8*T2**2*(T2+T1)**3
      TMP0 = -DLAM2**2*RL34*(T2+T1-1)*TMP0/( 6.D0*(T2+T1))
      PP = TMP0+PP
      TMP0 = RO*(-(12*T1-2)*T2**3-(28*T1**2-16*T1-4)*T2**2-(20*T1**3-22*
     1   T1**2+4*T1-1)*T2-4*T1**4+8*T1**3-8*T1**2+3*T1)-2*T2*(T2+T1)*(4*
     2   T2**2+T2-4*T1**2+3*T1)+RO**2*(T2+3*T1-2)*(2*T2+2*T1-1)
      TMP0 = -DLAM2*RL34*(T2+T1-1)*TMP0/( 3.D0*(T2+T1))
      PP = TMP0+PP
      PP = RL34*(T2+T1-1)*(9*RO*(2*T2**2-T2-2*T1**2+T1-1)-2*(36*T2**3-7*
     1   T2**2+(16-14*T1)*T2+36*T1**3-43*T1**2+25*T1))/( 27.D0*(T2+T1))+
     2   PP
      TMP0 = 32*(T2+T1)*((3*T1**2-20*T1-13)*T2**2+(6*T1**3-26*T1**2+20*T
     1   1)*T2+3*T1**4-6*T1**3+3*T1**2)*TX
      TMP0 = TMP0-8*RO*((36*T1**2+144*T1+36)*T2**4+(144*T1**3+289*T1**2-
     1   342*T1-25)*T2**3+(216*T1**4+3*T1**3-598*T1**2+473*T1+20)*T2**2+
     2   (144*T1**5-285*T1**4-26*T1**3+437*T1**2-248*T1-22)*T2+36*T1**6-
     3   143*T1**5+194*T1**4-61*T1**3-68*T1**2+42*T1)
      TMP0 = -27*RO**4*TX+TMP0+4*RO**2*((18*T1**2+180*T1+126)*T2**3+(54*
     1   T1**3+378*T1**2-159*T1-252)*T2**2+(54*T1**4+216*T1**3-409*T1**2
     2   -12*T1+220)*T2+18*T1**5+18*T1**4-124*T1**3+88*T1**2+76*T1-76)-3
     3   *RO**3*((36*T1+72)*T2**2+(60*T1**2+60*T1-119)*T2+24*T1**3-71*T1
     4   +56)
      TMP0 = 2*DLAM2**2*DRO*(T2+T1-1)*TMP0/( 27.D0*(4*TX+RO))
      PP = TMP0+PP
      PP = PP-128*DRO*(T2-T1)*(T2+T1-1)**2/( 27.D0*(4*TX+RO))
      TMP0 = 16*(T2+T1)**2*(9*T2**2+4*T1**2)*TX+4*RO*(9*T2**4+(18*T1+36)
     1   *T2**3+(26*T1**2+166*T1-23)*T2**2+(34*T1**3+120*T1**2-130*T1)*T
     2   2+17*T1**4-10*T1**3-3*T1**2)-4*RO**2*(9*T2**2+(39*T1+39)*T2+17*
     3   T1**2+13*T1-26)+39*RO**3
      TMP0 = -4*DLAM2**2*(T2+T1-1)**2*TMP0/( 27.D0*(4*TX+RO))
      PP = TMP0+PP
      TMP0 = 2*(72*T2**4+(216*T1-144)*T2**3+(280*T1**2-347*T1+45)*T2**2+
     1   (200*T1**3-276*T1**2+138*T1-16)*T2+64*T1**4-73*T1**3-7*T1**2+16
     2   *T1)+RO*(-36*T2**3-(72*T1+36)*T2**2-(100*T1**2+172*T1-219)*T2-6
     3   4*T1**3-72*T1**2+201*T1-88)+2*RO**2*(9*T2+25*T1-17)
      TMP0 = -4*DLAM2*(T2+T1-1)*TMP0/( 27.D0*(4*TX+RO))
      PP = TMP0+PP
      TMP0 = 8*T1*T2*(36*T1*T2**3+(72*T1**2-125*T1+16)*T2**2+(68*T1**3-1
     1   32*T1**2+96*T1-16)*T2+16*T1**2-16*T1)*TX
      TMP0 = TMP0+RO*(-32*T2**5-(-72*T1**2+96*T1-96)*T2**4-(-144*T1**3+4
     1   63*T1**2-224*T1+96)*T2**3-(-200*T1**4+591*T1**3-528*T1**2+128*T
     2   1-32)*T2**2-(96*T1**4-224*T1**3+128*T1**2)*T2-32*T1**5+96*T1**4
     3   -96*T1**3+32*T1**2)+8*RO**2*(T2**4+(2*T1-2)*T2**3+(6*T1**2-2*T1
     4   +1)*T2**2+(2*T1**3-2*T1**2)*T2+T1**4-2*T1**3+T1**2)
      TMP0 = -TMP0/( 27.D0*T1**2*T2**2*(4*TX+RO))
      PP = TMP0+PP
      HQHPQA = PP
      RETURN
      ENDIF
      END
      FUNCTION HQHPQG(TX,T1,RO)
      IMPLICIT DOUBLE PRECISION (A-Z)
      IF(TX.EQ.0)THEN
      PP = 0
      HQHPQG = PP
      RETURN
      ELSE
      T2 = -TX-T1+1
      T11 = 1/(1-T1)
      T22 = 1/(TX+T1)
      B = DSQRT((1-TX)**2-RO)
      DLAM2 = 1/(TX**2-2*TX-RO+1)
      VLSM = DLOG(4/RO)
      RLGXRO = DLOG((4*TX+RO)/RO)/TX
      RLG12 = DLOG(T1/(1-T2))/TX
      RLG21 = DLOG(T2/(1-T1))/TX
      RLGRO = DLOG(4*(1-T1)*(1-T2)/RO)
      RR = T2*(T2*TX**2+RO*(1-T2))
      RR = DSQRT(RR)
      RL3424 = 2*DLOG((T2*TX+RR)/(RR-T2*TX))/(RR*TX)
      RL34 = DLOG((2*TX**2+2*B*TX-2*TX-RO)/(2*TX**2-2*B*TX-2*TX-RO))/(B*
     1   TX)
      PP = T11*T2-2*(T1-1)/T2-2
      PP = -PP*(3*T1**2-3*T1+4/ 3.D0)*T11**2*(4*RO*(1-T1)*T1**2/T2-4*RO*
     1   (1-T1)*T1/T2+RO**2*(1-T1)**2/T2**2+8*T1**4-16*T1**3+12*T1**2-4*
     2   T1)/( 12.D0*T1**2*T2)
      PP = 2*(4*T2**2-4*T2+RO*(1-T2)/T1+2)*(2*T1**2*T22**2-2*T1*T22+1)/(
     1    9.D0*T1)+PP
      PP = PP*(-T2-T1+1)*VLSM
      TMP0 = RO*(9*T2-2)-2*(T2-1)*((9*T1+2)*T2+9*T1-9)
      TMP0 = -RLGXRO*(T2+T1-1)**2*T22**2*TMP0/( 72.D0*T2)
      PP = TMP0+PP
      PP = (T2+T1-1)*T22**2*(2*((7*T1+23)*T2**2+(46*T1-16)*T2+7*T1-7)*TX
     1   +RO*(15*T2**2+(23*T1-8)*T2+7*T1-7))/( 18.D0*T2*(4*TX+RO))+PP
      TMP0 = RO*(7*T2+9)-2*(7*T2**2+(23*T1+2)*T2+23*T1-16)
      TMP0 = -RLGXRO*(T2+T1-1)**2*T22*TMP0/( 72.D0*T2)
      PP = TMP0+PP
      PP = (T2+T1-1)*T22*(-8*RO**2*TX-RO*T1*((2*T1+16)*T2**2+(7*T1+16)*T
     1   2+32*T1-32)+2*T1**2*T2*(2*T2**2+(4*T1+5)*T2+14*T1-23))/( 72.D0*
     2   T1**2*T2**2)+PP
      PP = PP-RLGXRO*(9*T1+7)*T11**2*(T2+T1-1)**3/( 72.D0*T2)
      TMP0 = (9*T1**3-5*T1+4)*T2**3+(18*T1**4-T1**3-36*T1**2+31*T1-12)*T
     1   2**2+(18*T1**5-18*T1**4-46*T1**3+90*T1**2-60*T1+16)*T2+18*T1**5
     2   -72*T1**4+116*T1**3-96*T1**2+42*T1-8
      TMP0 = 16*RO**2*(T1-1)*TMP0*TX
      TMP0 = TMP0-4*T1**2*T2**2*((144*T1**3-306*T1**2+185*T1-55)*T2**2+(
     1   288*T1**4-864*T1**3+983*T1**2-526*T1+119)*T2+288*T1**5-1152*T1*
     2   *4+1856*T1**3-1536*T1**2+672*T1-128)*TX**2
      TMP0 = TMP0-RO*T1*T2*((144*T1**4+288*T1**3-971*T1**2+763*T1-256)*T
     1   2**3+(288*T1**5+864*T1**4-3963*T1**3+4918*T1**2-2875*T1+768)*T2
     2   **2+(288*T1**6+1152*T1**5-7104*T1**4+12544*T1**3-10848*T1**2+49
     3   92*T1-1024)*T2+1152*T1**6-5760*T1**5+12032*T1**4-13568*T1**3+88
     4   32*T1**2-3200*T1+512)*TX
      TMP0 = TMP0+4*RO**3*(T1-1)*((9*T1**2-9*T1+4)*T2**3+(31*T1**3-58*T1
     1   **2+39*T1-12)*T2**2+(36*T1**4-108*T1**3+124*T1**2-68*T1+16)*T2+
     2   18*T1**5-72*T1**4+116*T1**3-96*T1**2+42*T1-8)
      TMP0 = -T11**2*TMP0/( 144.D0*T1**2*T2**4*(4*TX+RO))
      PP = TMP0+PP
      TMP0 = 2*T2*((27*T1+16)*T2+18*T1**2+14*T1-16)+RO*(-(9*T1+23)*T2-32
     1   *T1+32)+8*RO**2
      TMP0 = RLGXRO*T11*(T2+T1-1)**2*TMP0/( 144.D0*T2**2)
      PP = TMP0+PP
      PP = PP-T11*(RO*T1*T2*((9*T1**2+23*T1)*T2**2+(-576*T1**3+592*T1**2
     1   -272*T1+256)*T2-576*T1**4+864*T1**3-256*T1**2+224*T1-256)*TX+T1
     2   **2*T2**3*((9*T1+22)*T2-36*T1**2+8*T1-4)*TX+4*RO**2*(2*T1**2*T2
     3   **3+(-17*T1**3-T1**2+2*T1+16)*T2**2+(-72*T1**4+108*T1**3-32*T1*
     4   *2+28*T1-32)*T2-36*T1**5+90*T1**4-70*T1**3+30*T1**2-30*T1+16))/
     5   ( 144.D0*T1**2*T2**4)
      TMP0 = 2*(2*T2**2+(4*T1-4)*T2+4*T1**2-6*T1+3)+RO
      TMP0 = -RLGRO*(T2+T1-1)*(2*T2-1)*TMP0/( 8.D0*(T2-1)*T2)
      PP = TMP0+PP
      TMP0 = 2*T1*T2**2*(36*T1*T2**4+(144*T1**2-117*T1+16)*T2**3+(216*T1
     1   **3-378*T1**2+212*T1-48)*T2**2+(144*T1**4-468*T1**3+496*T1**2-2
     2   58*T1+64)*T2-144*T1**4+288*T1**3-280*T1**2+136*T1-32)
      TMP0 = TMP0-RO*T1*T2*((45*T1-32)*T2**3+(144*T1**2-230*T1+96)*T2**2
     1   +(144*T1**3-432*T1**2+384*T1-128)*T2-144*T1**3+288*T1**2-208*T1
     2   +64)+2*RO**2*(T2-1)*((5*T1-4)*T2**2+(18*T1**2-18*T1+8)*T2+18*T1
     3   **3-36*T1**2+26*T1-8)
      TMP0 = RLG21*(T2+T1-1)**2*TMP0/( 72.D0*T1**2*(T2-1)*T2**4)
      PP = TMP0+PP
      TMP0 = 2*T1*T2**2*(32*T2**5+(100*T1-64)*T2**4+(136*T1**2-159*T1+64
     1   )*T2**3+(72*T1**3-154*T1**2+136*T1-64)*T2**2+(-72*T1**3+154*T1*
     2   *2-159*T1+64)*T2+72*T1**3-136*T1**2+100*T1-32)
      TMP0 = TMP0-RO*(T2-1)*T2*(16*T2**4+(32*T1-16)*T2**3+(27*T1**2-32*T
     1   1)*T2**2+(64*T1-68*T1**2)*T2+208*T1**2-64*T1)+2*RO**2*(T2-1)*((
     2   5*T1-4)*T2**2+(8-18*T1)*T2+26*T1-8)
      TMP0 = RLG12*(T2+T1-1)**2*TMP0/( 72.D0*T1**2*(T2-1)*T2**4)
      PP = TMP0+PP
      TMP0 = 2*T2*(3*T2**2+(6*T1-4)*T2+4*T1**2-4*T1+2)*TX+RO*(T2**3+(T1+
     1   1)*T2**2+(4*T1-2)*T2-4*T1)
      TMP0 = RL3424*(T2-2)*(T2+T1-1)**2*TMP0/( 16.D0*(T2-1)*T2**2)
      PP = TMP0+PP
      TMP0 = RO*(-(16*T1+16)*T2**2-(16*T1**2-16*T1+7)*T2+9*T1)+2*T2*(T2+
     1   T1)*(7*T2-9*T1)+8*RO**2*T2
      TMP0 = DLAM2*RL34*(T2+T1-1)**2*TMP0/( 144.D0*T2)
      PP = TMP0+PP
      TMP0 = RO*(7*T2-9*T1-18)-2*(9*T2**2+(23*T1-16)*T2-18*T1**2+27*T1)
      TMP0 = -RL34*(T2+T1-1)**2*TMP0/( 144.D0*T2)
      PP = TMP0+PP
      TMP0 = 2*(32*T2**4+(64*T1-32)*T2**3+(32*T1**2-25*T1+7)*T2**2+(-2*T
     1   1**2-16*T1)*T2-9*T1**3+9*T1**2)+RO*(-16*T2**3-(16*T1+32)*T2**2-
     2   (32*T1-25)*T2+9*T1)+8*RO**2*T2
      TMP0 = DLAM2*(T2+T1-1)**2*TMP0/( 36.D0*T2*(4*TX+RO))
      PP = TMP0+PP
      TMP0 = -4*T1*T2**2*(64*T2**5+(464*T1-128)*T2**4+(688*T1**2-705*T1+
     1   32)*T2**3+(864*T1**3-1138*T1**2+470*T1+32)*T2**2+(576*T1**4-172
     2   8*T1**3+1066*T1**2-485*T1)*T2-576*T1**4+864*T1**3-544*T1**2+256
     3   *T1)*TX**2
      TMP0 = TMP0-RO*T2*((64*T1+128)*T2**6+(464*T1**2+256*T1-384)*T2**5+
     1   (688*T1**3+509*T1**2-864*T1+384)*T2**4+(864*T1**4+5576*T1**3-38
     2   48*T1**2+2976*T1-128)*T2**3+(576*T1**5+9216*T1**4-19144*T1**3+9
     3   851*T1**2-7040*T1)*T2**2+(4608*T1**5-21024*T1**4+21664*T1**3-12
     4   160*T1**2+6912*T1)*T2-5184*T1**5+10944*T1**4-8640*T1**3+5184*T1
     5   **2-2304*T1)*TX
      TMP0 = RO**2*(32*T2**6+(64*T1-64)*T2**5+(243*T1**2-56*T1)*T2**4+(1
     1   440*T1**3+375*T1**2+352*T1+640)*T2**3+(1296*T1**4-288*T1**3-276
     2   0*T1**2+504*T1-1760)*T2**2+(-3888*T1**3+4320*T1**2-2160*T1+1728
     3   )*T2-1296*T1**4+2736*T1**3-2160*T1**2+1296*T1-576)*TX+TMP0
      TMP0 = TMP0+2*RO**3*(T2-1)*((5*T1-4)*T2**3+(141*T1**2-27*T1+76)*T2
     1   **2+(324*T1**3-360*T1**2+180*T1-144)*T2+162*T1**4-342*T1**3+270
     2   *T1**2-162*T1+72)
      TMP0 = TMP0/( 144.D0*T1**2*(T2-1)*T2**4*(4*TX+RO))
      PP = TMP0+PP
      HQHPQG = PP
      RETURN
      ENDIF
      END

c NR06:  Normalization:
c NR06:   d sigma = ggborn
c NR06:          * f(x1) * f(x2) * gs^4/(16 pi)   beta dcosth1 dx1 dx2
       function ggborn(s,t,m2)
c
c      d sigma (born_gg) = g^4 ggborn d phi2
c
       implicit real * 8 (a-z)
       v = 8
       n = 3
       p12 = s/2
       p13 = -t/2
       p23 = p12 - p13
          ggborn = 1/(2*v*n)*(v/(p13*p23)-2*n**2/p12**2)*
     #           (p13**2+p23**2+2*m2*p12-(m2*p12)**2/(p13*p23))
       ggborn = ggborn/(2*s)
       return
       end

       function qqborn(s,t,m2)
c
c      d sigma (born_qq) = g^4 qqborn d phi2
c
       implicit real * 8 (a-z)
       v = 8
       n2 = 3**2
       p12 = s/2
       p13 = -t/2
       p23 = p12 - p13
       qqborn = v/(2*n2)*( (p13**2+p23**2)/p12**2+m2/p12)
       qqborn = qqborn/(2*s)
       return
       end

       function ggcolp(s,q1q,x,m2,xlmude,nl)
c
c      d sigma_gg (c+-) = g^6 [ 1/(1-x)_rho ggcolp
c                    +       [log(1-x)/(1-x)]_rho * ggcoll ] d phi2x
c
c      xlmude = log(s/xmu2) + log(delta/2)
c
       implicit real * 8 (a-z)
       integer nl
       character * 2 schtmp
       common/schtmp/schtmp
       data pi/3.141 592 653 589 793/
       n = 3
       ggcolp = n/(4*pi**2) * xlmude *
     #           ( x + (1-x)**2/x + x*(1-x)**2 )
       if(schtmp.eq.'DI')then
           ggcolp = ggcolp - xkpgg(x,nl)/(8*pi**2)
       elseif(schtmp.ne.'MS')then
           write(6,*)'scheme ',schtmp,'not known'
           stop
       endif
       ggcolp = ggcolp * ggborn(s*x,q1q,m2)
       return
       end

       function ggcoll(s,q1q,x,m2,nl)
       implicit real * 8 (a-z)
       integer nl
       character * 2 schtmp
       common/schtmp/schtmp
       data pi/3.141 592 653 589 793/
       n = 3
       ggcoll = n/(4*pi**2) * 2 *
     #          ( x + (1-x)**2/x + x*(1-x)**2 )
       if(schtmp.eq.'DI')then
           ggcoll = ggcoll - xklgg(x,nl)/(8*pi**2)
       elseif(schtmp.ne.'MS')then
           write(6,*)'scheme ',schtmp,'not known'
           stop
       endif
       ggcoll = ggcoll * ggborn(s*x,q1q,m2)
       return
       end



       function qqcolp(s,q1q,x,m2,xlmude,nl)
c
c      d sigma_qq (c+-) = g^6 [ 1/(1-x)_rho qqcolp
c                    +       [log(1-x)/(1-x)]_rho * qqcoll ] d phi2x
c
c      xlmude = log(s/xmu2) + log(delta/2)
c
       implicit real * 8 (a-z)
       integer nl
       character * 2 schtmp
       common/schtmp/schtmp
       data pi/3.141 592 653 589 793/
       cf = 4.d0/3.d0
       qqcolp = cf/(8*pi**2) * (xlmude * (1+x**2) + (1-x)**2)
       if(schtmp.eq.'DI')then
           qqcolp = qqcolp - xkpqq(x,nl)/(8*pi**2)
       elseif(schtmp.ne.'MS')then
           write(6,*)'scheme ',schtmp,'not known'
           stop
       endif
       qqcolp = qqcolp * qqborn(s*x,q1q,m2)
       return
       end

       function qqcoll(s,q1q,x,m2,nl)
       implicit real * 8 (a-z)
       integer nl
       character * 2 schtmp
       common/schtmp/schtmp
       data pi/3.141 592 653 589 793/
       cf = 4.d0/3.d0
       qqcoll = cf/(8*pi**2) * 2 * (1+x**2)
       if(schtmp.eq.'DI')then
           qqcoll = qqcoll - xklqq(x,nl)/(8*pi**2)
       elseif(schtmp.ne.'MS')then
           write(6,*)'scheme ',schtmp,'not known'
           stop
       endif
       qqcoll = qqcoll * qqborn(s*x,q1q,m2)
       return
       end

       function qgcolp1(s,q2q,x,m2,xlmude,nl)
c
c      d sigma_qg (c+) = g^6 [ 1/(1-x)_rho qgcolp1
c                    +       [log(1-x)/(1-x)]_rho * qgcoll1 ] d phi2x
c
c      xlmude = log(s/xmu2) + log(delta/2)
c
       implicit real * 8 (a-z)
       integer nl
       character * 2 schhad1,schhad2
       common/scheme/schhad1,schhad2
       data pi/3.141 592 653 589 793/
       cf = 4.d0/3.d0
       qgcolp1 = cf/(8*pi**2) *
     #   ( xlmude*(1 + (1-x)**2)/x + x )*(1-x)
       if(schhad1.eq.'DI')then
           qgcolp1 = qgcolp1 - xkpgq(x,nl)/(8*pi**2)
       elseif(schhad1.ne.'MS')then
           write(6,*)'scheme ',schhad1,'not known'
           stop
       endif
       qgcolp1 = qgcolp1 * ggborn(s*x,q2q,m2)
       return
       end

       function qgcoll1(s,q2q,x,m2,nl)
       implicit real * 8 (a-z)
       integer nl
       character * 2 schhad1,schhad2
       common/scheme/schhad1,schhad2
       data pi/3.141 592 653 589 793/
       cf = 4.d0/3.d0
       qgcoll1 = cf/(8*pi**2) *
     #   2*(1 + (1-x)**2)/x * (1-x)
       if(schhad1.eq.'DI')then
           qgcoll1 = qgcoll1 - xklgq(x,nl)/(8*pi**2)
       elseif(schhad1.ne.'MS')then
           write(6,*)'scheme ',schhad1,'not known'
           stop
       endif
       qgcoll1 = qgcoll1 * ggborn(s*x,q2q,m2)
       return
       end


       function qgcolp2(s,q1q,x,m2,xlmude,nl)
c
c      d sigma_qg (c-) = g^6 [ 1/(1-x)_rho qgcolp2
c                    +       [log(1-x)/(1-x)]_rho * qgcoll2 ] d phi2x
c
c      xlmude = log(s/xmu2) + log(delta/2)
c
       implicit real * 8 (a-z)
       integer nl
       character * 2 schhad1,schhad2
       common/scheme/schhad1,schhad2
       data pi/3.141 592 653 589 793/
       tf = .5d0
       qgcolp2 =
     #  tf/(8*pi**2)*(xlmude*(x**2+(1-x)**2)+2*x*(1-x))*(1-x)
       if(schhad2.eq.'DI')then
           qgcolp2 = qgcolp2 - xkpqg(x,nl)/(8*pi**2)
       elseif(schhad2.ne.'MS')then
           write(6,*)'scheme ',schhad2,'not known'
           stop
       endif
       qgcolp2 = qgcolp2 * qqborn(s*x,q1q,m2)
       return
       end

       function qgcoll2(s,q1q,x,m2,nl)
       implicit real * 8 (a-z)
       integer nl
       character * 2 schhad1,schhad2
       common/scheme/schhad1,schhad2
       data pi/3.141 592 653 589 793/
       tf = .5d0
       qgcoll2 = tf/(8*pi**2)*2*(x**2+(1-x)**2)*(1-x)
       if(schhad2.eq.'DI')then
           qgcoll2 = qgcoll2 - xklqg(x,nl)/(8*pi**2)
       elseif(schhad2.ne.'MS')then
           write(6,*)'scheme ',schhad2,'not known'
           stop
       endif
       qgcoll2 = qgcoll2 * qqborn(s*x,q1q,m2)
       return
       end

       FUNCTION FGG(S,X,Y,XM2,Q1Q,Q2Q,W1H,W2H,CTH2)
c
c      d sigma_gg (f) = N g^6 / (64 pi^2 s) beta_x d costh1 d th2 dy dx
c                    1/(1-x)_rho ( 1/(1-y)_+ + 1/(1+y)_+ ) fgg
c
c           N = 1 / (4 pi)^2
c
       IMPLICIT REAL* 8(A-H,O-Z)
       REAL* 8 N
       TINY = .1d-6
       V = 8
       N = 3
       N2 = N*N
       CF = 4.D0/3.D0
       CA = 3
       TK = - (1-X)*(1-Y)*S/2
       UK = - (1-X)*(1+Y)*S/2
       IF(1-X.LT.TINY)THEN
          Q2C=-S-Q2Q
          P13 = -Q1Q/2
          P23 = -Q2C/2
          P12 = S/2
          BORN = 1/(2*V*N)*(V/(P13*P23)-2*N**2/P12**2)*
     #           (P13**2+P23**2+2*XM2*P12-(XM2*P12)**2/(P13*P23))
          XXX  = N**2/(4*V)*( (P12+2*XM2)/P23-(P12+2*XM2)/P13
     #           +XM2**2/P13**2-XM2**2/P23**2+2*(P23-P13)/P12 )
          YYY  = 1/(4*V*N**2)*
     #           (P13**2+P23**2+2*XM2*P12-(XM2*P12)**2/(P13*P23))
     #          *(1/(P13*P23)+2*N**2/P12**2)
C         --------------------------------------------------------------
C         Fattori iconali moltiplicati per 4*tk*uk
C         P1.K = -TK/2
C         P2.K = -UK/2
C         P3.K = W1/2
C         P4.K = W2/2
C
          P14 = P23
          P24 = P13
C
          E13 = 16*(1+Y)*P13/W1H
          E14 = 16*(1+Y)*P14/W2H
          E23 = 16*(1-Y)*P23/W1H
          E24 = 16*(1-Y)*P24/W2H
          E12 = 16*P12
          E33 = 16*(1-Y)*(1+Y)* XM2/W1H**2
          E44 = 16*(1-Y)*(1+Y)* XM2/W2H**2
          E34 = 16*(1-Y)*(1+Y)* (S/2-XM2)/(W1H*W2H)
          SUM = BORN*( CF*(E13+E14+E23+E24-2*E12-E33-E44) +2*N*E12 )
     #        +        XXX *(E14+E23-E13-E24)
     #        +        YYY *(2*E12+2*E34-E13-E24-E14-E23)
          FGG = 1/(2*S)*SUM
       ELSEIF(1-Y.LT.TINY)THEN
          Q2C = -S-UK-Q2Q
          P13 = - X*Q1Q/2
          P23 = -Q2C/2
          P12 = S*X/2
          BX = SQRT(1-4*XM2/(S*X))
          CTH1 = (P23-P13)/P12/BX
          AZIDEP =
     #    -512*BX**2*(CTH1-1)*(CTH1+1)*V*(2*V+BX**2*CTH1**2*N2-N2)
     #    *(X-1)**2*XM2/((BX*CTH1-1)**2*(BX*CTH1+1)**2*X**2)
          AZIDEP = AZIDEP * (2*CTH2**2-1)/2 /(4*64)
          BORN = 1/(2*V*N)*(V/(P13*P23)-2*N**2/P12**2)*
     #           (P13**2+P23**2+2*XM2*P12-(XM2*P12)**2/(P13*P23))
          SUM = - BORN*(8*UK)*2*CA*(X/(1-X)+(1-X)/X+X*(1-X))
     #    + AZIDEP
          FGG = 1/(2*X*S)*SUM
       ELSEIF(1+Y.LT.TINY)THEN
          Q2C = -S-UK-Q2Q
          P13 = -Q1Q/2
          P23 = -X*Q2C/2
          P12 = S*X/2
          BX = SQRT(1-4*XM2/(S*X))
          CTH1 = (P23-P13)/P12/BX
          AZIDEP =
     #    -512*BX**2*(CTH1-1)*(CTH1+1)*V*(2*V+BX**2*CTH1**2*N2-N2)
     #    *(X-1)**2*XM2/((BX*CTH1-1)**2*(BX*CTH1+1)**2*X**2)
          AZIDEP = AZIDEP * (2*CTH2**2-1)/2 /(4*64)
          BORN = 1/(2*V*N)*(V/(P13*P23)-2*N**2/P12**2)*
     #           (P13**2+P23**2+2*XM2*P12-(XM2*P12)**2/(P13*P23))
          SUM = - BORN*(8*TK)*2*CA*(X/(1-X)+(1-X)/X+X*(1-X))
     #          + AZIDEP
          FGG = 1/(2*X*S)*SUM
       ELSE
       S2 = S+TK+UK
       Q1C=-S-TK-Q1Q
       Q2C=-S-UK-Q2Q
       W1 =Q2Q-Q1Q-TK
       W2 =Q1Q-Q2Q-UK
C
       P12 = (S2 - 2*XM2)/2
       P13 = W1/2
       P14 = Q1Q/2
       P15 = Q2C/2
       P23 = W2/2
       P24 = Q1C/2
       P25 = Q2Q/2
       P34 = TK/2
       P35 = UK/2
       P45 = S/2
      ANS = FBB1(XM2,P12,P13,P14,P15,P23,P24,P25,P34,P35,P45)
      ANS = 4*TK*UK*ANS/(2*S*4*64)
      FGG = ANS
      ENDIF
      RETURN
      END

      FUNCTION FBB1(XM2,P12,P13,P14,P15,P23,P24,P25,P34,P35,P45)
      IMPLICIT REAL * 8 (A-Z)
      n = 3
      n2 = n**2
      v = n2-1
      s = 2*xm2+2*p12
      ans = 0
      tmp0 = v**3*xm2*((xm2**2+4*p24*xm2-2*p24*p25)/(p13**2*p24**2)+(p34
     1   *s+2*p15*p25-p14*p24)/(p13*p14*p23*p24))/n2/2+v*xm2*(xm2**2/(
     2   p13*p14*p23*p25)-(5*p13*s+6*p13*p25+8*p13*p23-4*p13**2)/(p13*p1
     3   4*p23*p24)/4)/n2
      tmp0 = v**2*xm2*(-4*xm2**2/(p13*p14*p25**2)+2*s*xm2/(p13*p14*p23*p
     1   25)+(-(p23+p13)*p45+p23**2+p13**2)/(p13*p14*p23*p25))/n2/4+((
     2   -p13*s+p15*p25+p23**2+p15**2+p13**2)/(p13*p15*p24*p25*p34)+(p24
     3   +p15)/(p13*p14*p23*p25))*v*xm2**2-v*((2*(p45+p35)*xm2+p25**2+p1
     4   5**2)/(p14*p23*p34)/2+p13*(2*(p35+p34)*xm2+p23**2+p13**2)/(p1
     5   4*p15*p25*p34))+(n2+1)*p12*v*(2*(p45+p35)*xm2+p25**2+p15**2)/(n
     6   2*p13*p14*p23*p24)/4+v**2*xm2*((p45+p34)*xm2/(p13*p25*p34*p45
     7   )+2*xm2/(p15**2*p34)+(p13/p25-p23/p15)**2/p34**2)+tmp0
      ans = -2*n2*(s**2/4+p45**2+p34**2)*v*xm2**2/(p13*p25*p34*p45*s)+
     1   n2*p14*p24*v*(2*(p45+p34)*xm2+p24**2+p14**2)/(p13*p25*p34*p45*s
     2   )+2*n2*p23*v*(2*(p35+p34)*xm2+p23**2+p13**2)/(p25*p34*p45*s)-(n
     3   2+1)*v*xm2*(4*p12*xm2+s**2+2*p23*p24+2*p13*p14)/(n2*p13*p14*p23
     4   *p24)/8+n2*v*((p34-2*xm2)/(p13*p24*s)-s/(p15*p25*p34)/4)*xm
     5   2+v*((p12-3*xm2)/(p15*p25*p34)+(5*p13*p25+3*p13*p23-2*p13**2)/(
     6   p13*p14*p23*p24))*xm2+2*n2*(-s*(s+2*p34)/8+4*p15*p25+p14*p24+
     7   p13*p23)*v*xm2/(p15*p25*p34*s)+4*n2*(2*p23**2/(p15*p34**2*s)+(p
     8   45**2+p35**2+p34**2)/(p34**2*s**2))*v*xm2+tmp0+ans
      tmp0 = v**3*xm2*((xm2**2+4*p23*xm2-2*p23*p25)/(p14**2*p23**2)+(p34
     1   *s+2*p15*p25-p13*p23)/(p13*p14*p23*p24))/n2/2
      tmp0 = v*xm2*(xm2**2/(p13*p14*p24*p25)-(5*p14*s+6*p14*p25+8*p14*p2
     1   4-4*p14**2)/(p13*p14*p23*p24)/4)/n2+v**2*xm2*(-4*xm2**2/(p13*
     2   p14*p25**2)+2*s*xm2/(p13*p14*p24*p25)+(-(p24+p14)*p35+p24**2+p1
     3   4**2)/(p13*p14*p24*p25))/n2/4+((-p14*s+p15*p25+p24**2+p15**2+
     4   p14**2)/(p14*p15*p23*p25*p34)+(p23+p15)/(p13*p14*p24*p25))*v*xm
     5   2**2-v*((2*(p45+p35)*xm2+p25**2+p15**2)/(p13*p24*p34)/2+p14*(
     6   2*(p45+p34)*xm2+p24**2+p14**2)/(p13*p15*p25*p34))+(n2+1)*p12*v*
     7   (2*(p45+p35)*xm2+p25**2+p15**2)/(n2*p13*p14*p23*p24)/4+2*n2*p
     8   24*v*(2*(p45+p34)*xm2+p24**2+p14**2)/(p25*p34*p35*s)+tmp0
      ans = -2*n2*(s**2/4+p35**2+p34**2)*v*xm2**2/(p14*p25*p34*p35*s)+
     1   v**2*xm2*((p35+p34)*xm2/(p14*p25*p34*p35)+2*xm2/(p15**2*p34)+(p
     2   14/p25-p24/p15)**2/p34**2)+n2*p13*p23*v*(2*(p35+p34)*xm2+p23**2
     3   +p13**2)/(p14*p25*p34*p35*s)-(n2+1)*v*xm2*(4*p12*xm2+s**2+2*p23
     4   *p24+2*p13*p14)/(n2*p13*p14*p23*p24)/8+n2*v*((p34-2*xm2)/(p14
     5   *p23*s)-s/(p15*p25*p34)/4)*xm2+v*((p12-3*xm2)/(p15*p25*p34)+(
     6   5*p14*p25+3*p14*p24-2*p14**2)/(p13*p14*p23*p24))*xm2+2*n2*(-s*(
     7   s+2*p34)/8+4*p15*p25+p14*p24+p13*p23)*v*xm2/(p15*p25*p34*s)+4
     8   *n2*(2*p24**2/(p15*p34**2*s)+(p45**2+p35**2+p34**2)/(p34**2*s**
     9   2))*v*xm2+tmp0+ans
      tmp0 = v**3*xm2*((xm2**2+4*p25*xm2-2*p23*p25)/(p14**2*p25**2)+(p45
     1   *s-p15*p25+2*p13*p23)/(p14*p15*p24*p25))/n2/2
      tmp0 = v*xm2*(xm2**2/(p14*p15*p23*p24)-(5*p14*s+8*p14*p24+6*p14*p2
     1   3-4*p14**2)/(p14*p15*p24*p25)/4)/n2+v**2*xm2*(-4*xm2**2/(p14*
     2   p15*p23**2)+2*s*xm2/(p14*p15*p23*p24)+(-(p24+p14)*p35+p24**2+p1
     3   4**2)/(p14*p15*p23*p24))/n2/4-2*n2*(s**2/4+p45**2+p35**2)*v
     4   *xm2**2/(p14*p23*p35*p45*s)+((-p14*s+p24**2+p13*p23+p14**2+p13*
     5   *2)/(p13*p14*p23*p25*p45)+(p25+p13)/(p14*p15*p23*p24))*v*xm2**2
     6   -v*(p14*(2*(p45+p34)*xm2+p24**2+p14**2)/(p13*p15*p23*p45)+(2*(p
     7   35+p34)*xm2+p23**2+p13**2)/(p15*p24*p45)/2)+v**2*xm2*((p45+p3
     8   5)*xm2/(p14*p23*p35*p45)+2*xm2/(p13**2*p45)+(p14/p23-p24/p13)**
     9   2/p45**2)+n2*p15*p25*v*(2*(p45+p35)*xm2+p25**2+p15**2)/(p14*p23
     :   *p35*p45*s)+tmp0
      ans = 2*n2*p24*v*(2*(p45+p34)*xm2+p24**2+p14**2)/(p23*p35*p45*s)+(
     1   n2+1)*p12*v*(2*(p35+p34)*xm2+p23**2+p13**2)/(n2*p14*p15*p24*p25
     2   )/4-(n2+1)*v*xm2*(4*p12*xm2+s**2+2*p24*p25+2*p14*p15)/(n2*p14
     3   *p15*p24*p25)/8+n2*v*((p45-2*xm2)/(p14*p25*s)-s/(p13*p23*p45)
     4   /4)*xm2+v*((p12-3*xm2)/(p13*p23*p45)+(3*p14*p24+5*p14*p23-2*p
     5   14**2)/(p14*p15*p24*p25))*xm2+2*n2*(-s*(s+2*p45)/8+p15*p25+p1
     6   4*p24+4*p13*p23)*v*xm2/(p13*p23*p45*s)+4*n2*(2*p24**2/(p13*p45*
     7   *2*s)+(p45**2+p35**2+p34**2)/(p45**2*s**2))*v*xm2+tmp0+ans
      tmp0 = v**3*xm2*((xm2**2+4*p24*xm2-2*p23*p24)/(p15**2*p24**2)+(p45
     1   *s-p14*p24+2*p13*p23)/(p14*p15*p24*p25))/n2/2
      tmp0 = v*xm2*(xm2**2/(p14*p15*p23*p25)-(5*p15*s+8*p15*p25+6*p15*p2
     1   3-4*p15**2)/(p14*p15*p24*p25)/4)/n2+v**2*xm2*(-4*xm2**2/(p14*
     2   p15*p23**2)+2*s*xm2/(p14*p15*p23*p25)+(-(p25+p15)*p34+p25**2+p1
     3   5**2)/(p14*p15*p23*p25))/n2/4-2*n2*(s**2/4+p45**2+p34**2)*v
     4   *xm2**2/(p15*p23*p34*p45*s)+((-p15*s+p25**2+p13*p23+p15**2+p13*
     5   *2)/(p13*p15*p23*p24*p45)+(p24+p13)/(p14*p15*p23*p25))*v*xm2**2
     6   -v*(p15*(2*(p45+p35)*xm2+p25**2+p15**2)/(p13*p14*p23*p45)+(2*(p
     7   35+p34)*xm2+p23**2+p13**2)/(p14*p25*p45)/2)+2*n2*p25*v*(2*(p4
     8   5+p35)*xm2+p25**2+p15**2)/(p23*p34*p45*s)+v**2*xm2*((p45+p34)*x
     9   m2/(p15*p23*p34*p45)+2*xm2/(p13**2*p45)+(p15/p23-p25/p13)**2/p4
     :   5**2)+tmp0
      ans = n2*p14*p24*v*(2*(p45+p34)*xm2+p24**2+p14**2)/(p15*p23*p34*p4
     1   5*s)+(n2+1)*p12*v*(2*(p35+p34)*xm2+p23**2+p13**2)/(n2*p14*p15*p
     2   24*p25)/4-(n2+1)*v*xm2*(4*p12*xm2+s**2+2*p24*p25+2*p14*p15)/(
     3   n2*p14*p15*p24*p25)/8+n2*v*((p45-2*xm2)/(p15*p24*s)-s/(p13*p2
     4   3*p45)/4)*xm2+v*((p12-3*xm2)/(p13*p23*p45)+(3*p15*p25+5*p15*p
     5   23-2*p15**2)/(p14*p15*p24*p25))*xm2+2*n2*(-s*(s+2*p45)/8+p15*
     6   p25+p14*p24+4*p13*p23)*v*xm2/(p13*p23*p45*s)+4*n2*(2*p25**2/(p1
     7   3*p45**2*s)+(p45**2+p35**2+p34**2)/(p45**2*s**2))*v*xm2+tmp0+an
     8   s
      tmp0 = v**3*xm2*((xm2**2+4*p23*xm2-2*p23*p24)/(p15**2*p23**2)+(p35
     1   *s+2*p14*p24-p13*p23)/(p13*p15*p23*p25))/n2/2
      tmp0 = v*xm2*(xm2**2/(p13*p15*p24*p25)-(5*p15*s+8*p15*p25+6*p15*p2
     1   4-4*p15**2)/(p13*p15*p23*p25)/4)/n2+v**2*xm2*(-4*xm2**2/(p13*
     2   p15*p24**2)+2*s*xm2/(p13*p15*p24*p25)+(-(p25+p15)*p34+p25**2+p1
     3   5**2)/(p13*p15*p24*p25))/n2/4+((-p15*s+p25**2+p14*p24+p15**2+
     4   p14**2)/(p14*p15*p23*p24*p35)+(p23+p14)/(p13*p15*p24*p25))*v*xm
     5   2**2-v*(p15*(2*(p45+p35)*xm2+p25**2+p15**2)/(p13*p14*p24*p35)+(
     6   2*(p45+p34)*xm2+p24**2+p14**2)/(p13*p25*p35)/2)+2*n2*p25*v*(2
     7   *(p45+p35)*xm2+p25**2+p15**2)/(p24*p34*p35*s)+(n2+1)*p12*v*(2*(
     8   p45+p34)*xm2+p24**2+p14**2)/(n2*p13*p15*p23*p25)/4+tmp0
      ans = -2*n2*(s**2/4+p35**2+p34**2)*v*xm2**2/(p15*p24*p34*p35*s)+
     1   v**2*xm2*((p35+p34)*xm2/(p15*p24*p34*p35)+2*xm2/(p14**2*p35)+(p
     2   15/p24-p25/p14)**2/p35**2)+n2*p13*p23*v*(2*(p35+p34)*xm2+p23**2
     3   +p13**2)/(p15*p24*p34*p35*s)-(n2+1)*v*xm2*(4*p12*xm2+s**2+2*p23
     4   *p25+2*p13*p15)/(n2*p13*p15*p23*p25)/8+n2*v*((p35-2*xm2)/(p15
     5   *p23*s)-s/(p14*p24*p35)/4)*xm2+v*((p12-3*xm2)/(p14*p24*p35)+(
     6   3*p15*p25+5*p15*p24-2*p15**2)/(p13*p15*p23*p25))*xm2+2*n2*(-s*(
     7   s+2*p35)/8+p15*p25+4*p14*p24+p13*p23)*v*xm2/(p14*p24*p35*s)+4
     8   *n2*(2*p25**2/(p14*p35**2*s)+(p45**2+p35**2+p34**2)/(p35**2*s**
     9   2))*v*xm2+tmp0+ans
      tmp0 = v**3*xm2*((xm2**2+4*p25*xm2-2*p24*p25)/(p13**2*p25**2)+(p35
     1   *s-p15*p25+2*p14*p24)/(p13*p15*p23*p25))/n2/2
      tmp0 = v*xm2*(xm2**2/(p13*p15*p23*p24)-(5*p13*s+6*p13*p24+8*p13*p2
     1   3-4*p13**2)/(p13*p15*p23*p25)/4)/n2+v**2*xm2*(-4*xm2**2/(p13*
     2   p15*p24**2)+2*s*xm2/(p13*p15*p23*p24)+(-(p23+p13)*p45+p23**2+p1
     3   3**2)/(p13*p15*p23*p24))/n2/4-2*n2*(s**2/4+p45**2+p35**2)*v
     4   *xm2**2/(p13*p24*p35*p45*s)+((-p13*s+p14*p24+p23**2+p14**2+p13*
     5   *2)/(p13*p14*p24*p25*p35)+(p25+p14)/(p13*p15*p23*p24))*v*xm2**2
     6   -v*((2*(p45+p34)*xm2+p24**2+p14**2)/(p15*p23*p35)/2+p13*(2*(p
     7   35+p34)*xm2+p23**2+p13**2)/(p14*p15*p24*p35))+v**2*xm2*((p45+p3
     8   5)*xm2/(p13*p24*p35*p45)+2*xm2/(p14**2*p35)+(p13/p24-p23/p14)**
     9   2/p35**2)+n2*p15*p25*v*(2*(p45+p35)*xm2+p25**2+p15**2)/(p13*p24
     :   *p35*p45*s)+tmp0
      ans = (n2+1)*p12*v*(2*(p45+p34)*xm2+p24**2+p14**2)/(n2*p13*p15*p23
     1   *p25)/4+2*n2*p23*v*(2*(p35+p34)*xm2+p23**2+p13**2)/(p24*p35*p
     2   45*s)-(n2+1)*v*xm2*(4*p12*xm2+s**2+2*p23*p25+2*p13*p15)/(n2*p13
     3   *p15*p23*p25)/8+n2*v*((p35-2*xm2)/(p13*p25*s)-s/(p14*p24*p35)
     4   /4)*xm2+v*((p12-3*xm2)/(p14*p24*p35)+(5*p13*p24+3*p13*p23-2*p
     5   13**2)/(p13*p15*p23*p25))*xm2+2*n2*(-s*(s+2*p35)/8+p15*p25+4*
     6   p14*p24+p13*p23)*v*xm2/(p14*p24*p35*s)+4*n2*(2*p23**2/(p14*p35*
     7   *2*s)+(p45**2+p35**2+p34**2)/(p35**2*s**2))*v*xm2+tmp0+ans
      tmp0 = v**3*xm2*((xm2**2+4*p14*xm2-2*p14*p15)/(p14**2*p23**2)+(p34
     1   *s+2*p15*p25-p14*p24)/(p13*p14*p23*p24))/n2/2+v*xm2*(xm2**2/(
     2   p13*p15*p23*p24)-(5*p23*s-4*p23**2+6*p15*p23+8*p13*p23)/(p13*p1
     3   4*p23*p24)/4)/n2
      tmp0 = v**2*xm2*(-4*xm2**2/(p15**2*p23*p24)+2*s*xm2/(p13*p15*p23*p
     1   24)+(-(p23+p13)*p45+p23**2+p13**2)/(p13*p15*p23*p24))/n2/4+((
     2   -p23*s+p25**2+p15*p25+p23**2+p13**2)/(p14*p15*p23*p25*p34)+(p25
     3   +p14)/(p13*p15*p23*p24))*v*xm2**2-v*((2*(p45+p35)*xm2+p25**2+p1
     4   5**2)/(p13*p24*p34)/2+p23*(2*(p35+p34)*xm2+p23**2+p13**2)/(p1
     5   5*p24*p25*p34))+(n2+1)*p12*v*(2*(p45+p35)*xm2+p25**2+p15**2)/(n
     6   2*p13*p14*p23*p24)/4+v**2*xm2*((p45+p34)*xm2/(p15*p23*p34*p45
     7   )+2*xm2/(p25**2*p34)+(p23/p15-p13/p25)**2/p34**2)+tmp0
      ans = -2*n2*(s**2/4+p45**2+p34**2)*v*xm2**2/(p15*p23*p34*p45*s)+
     1   n2*p14*p24*v*(2*(p45+p34)*xm2+p24**2+p14**2)/(p15*p23*p34*p45*s
     2   )+2*n2*p13*v*(2*(p35+p34)*xm2+p23**2+p13**2)/(p15*p34*p45*s)-(n
     3   2+1)*v*xm2*(4*p12*xm2+s**2+2*p23*p24+2*p13*p14)/(n2*p13*p14*p23
     4   *p24)/8+n2*v*((p34-2*xm2)/(p14*p23*s)-s/(p15*p25*p34)/4)*xm
     5   2+v*((p12-3*xm2)/(p15*p25*p34)+(-2*p23**2+5*p15*p23+3*p13*p23)/
     6   (p13*p14*p23*p24))*xm2+2*n2*(-s*(s+2*p34)/8+4*p15*p25+p14*p24
     7   +p13*p23)*v*xm2/(p15*p25*p34*s)+4*n2*(2*p13**2/(p25*p34**2*s)+(
     8   p45**2+p35**2+p34**2)/(p34**2*s**2))*v*xm2+tmp0+ans
      tmp0 = v**3*xm2*((xm2**2+4*p13*xm2-2*p13*p15)/(p13**2*p24**2)+(p34
     1   *s+2*p15*p25-p13*p23)/(p13*p14*p23*p24))/n2/2
      tmp0 = v*xm2*(xm2**2/(p14*p15*p23*p24)-(5*p24*s-4*p24**2+6*p15*p24
     1   +8*p14*p24)/(p13*p14*p23*p24)/4)/n2+v**2*xm2*(-4*xm2**2/(p15*
     2   *2*p23*p24)+2*s*xm2/(p14*p15*p23*p24)+(-(p24+p14)*p35+p24**2+p1
     3   4**2)/(p14*p15*p23*p24))/n2/4+((-p24*s+p25**2+p15*p25+p24**2+
     4   p14**2)/(p13*p15*p24*p25*p34)+(p25+p13)/(p14*p15*p23*p24))*v*xm
     5   2**2-v*((2*(p45+p35)*xm2+p25**2+p15**2)/(p14*p23*p34)/2+p24*(
     6   2*(p45+p34)*xm2+p24**2+p14**2)/(p15*p23*p25*p34))+(n2+1)*p12*v*
     7   (2*(p45+p35)*xm2+p25**2+p15**2)/(n2*p13*p14*p23*p24)/4+2*n2*p
     8   14*v*(2*(p45+p34)*xm2+p24**2+p14**2)/(p15*p34*p35*s)+tmp0
      ans = -2*n2*(s**2/4+p35**2+p34**2)*v*xm2**2/(p15*p24*p34*p35*s)+
     1   v**2*xm2*((p35+p34)*xm2/(p15*p24*p34*p35)+2*xm2/(p25**2*p34)+(p
     2   24/p15-p14/p25)**2/p34**2)+n2*p13*p23*v*(2*(p35+p34)*xm2+p23**2
     3   +p13**2)/(p15*p24*p34*p35*s)-(n2+1)*v*xm2*(4*p12*xm2+s**2+2*p23
     4   *p24+2*p13*p14)/(n2*p13*p14*p23*p24)/8+n2*v*((p34-2*xm2)/(p13
     5   *p24*s)-s/(p15*p25*p34)/4)*xm2+v*((p12-3*xm2)/(p15*p25*p34)+(
     6   -2*p24**2+5*p15*p24+3*p14*p24)/(p13*p14*p23*p24))*xm2+2*n2*(-s*
     7   (s+2*p34)/8+4*p15*p25+p14*p24+p13*p23)*v*xm2/(p15*p25*p34*s)+
     8   4*n2*(2*p14**2/(p25*p34**2*s)+(p45**2+p35**2+p34**2)/(p34**2*s*
     9   *2))*v*xm2+tmp0+ans
      tmp0 = v**3*xm2*((xm2**2+4*p15*xm2-2*p13*p15)/(p15**2*p24**2)+(p45
     1   *s-p15*p25+2*p13*p23)/(p14*p15*p24*p25))/n2/2
      tmp0 = v*xm2*(xm2**2/(p13*p14*p24*p25)-(5*p24*s-4*p24**2+8*p14*p24
     1   +6*p13*p24)/(p14*p15*p24*p25)/4)/n2+v**2*xm2*(-4*xm2**2/(p13*
     2   *2*p24*p25)+2*s*xm2/(p13*p14*p24*p25)+(-(p24+p14)*p35+p24**2+p1
     3   4**2)/(p13*p14*p24*p25))/n2/4-2*n2*(s**2/4+p45**2+p35**2)*v
     4   *xm2**2/(p13*p24*p35*p45*s)+((-p24*s+p24**2+p23**2+p13*p23+p14*
     5   *2)/(p13*p15*p23*p24*p45)+(p23+p15)/(p13*p14*p24*p25))*v*xm2**2
     6   -v*(p24*(2*(p45+p34)*xm2+p24**2+p14**2)/(p13*p23*p25*p45)+(2*(p
     7   35+p34)*xm2+p23**2+p13**2)/(p14*p25*p45)/2)+v**2*xm2*((p45+p3
     8   5)*xm2/(p13*p24*p35*p45)+2*xm2/(p23**2*p45)+(p24/p13-p14/p23)**
     9   2/p45**2)+n2*p15*p25*v*(2*(p45+p35)*xm2+p25**2+p15**2)/(p13*p24
     :   *p35*p45*s)+tmp0
      ans = 2*n2*p14*v*(2*(p45+p34)*xm2+p24**2+p14**2)/(p13*p35*p45*s)+(
     1   n2+1)*p12*v*(2*(p35+p34)*xm2+p23**2+p13**2)/(n2*p14*p15*p24*p25
     2   )/4-(n2+1)*v*xm2*(4*p12*xm2+s**2+2*p24*p25+2*p14*p15)/(n2*p14
     3   *p15*p24*p25)/8+n2*v*((p45-2*xm2)/(p15*p24*s)-s/(p13*p23*p45)
     4   /4)*xm2+v*((p12-3*xm2)/(p13*p23*p45)+(-2*p24**2+3*p14*p24+5*p
     5   13*p24)/(p14*p15*p24*p25))*xm2+2*n2*(-s*(s+2*p45)/8+p15*p25+p
     6   14*p24+4*p13*p23)*v*xm2/(p13*p23*p45*s)+4*n2*(2*p14**2/(p23*p45
     7   **2*s)+(p45**2+p35**2+p34**2)/(p45**2*s**2))*v*xm2+tmp0+ans
      tmp0 = v**3*xm2*((xm2**2+4*p14*xm2-2*p13*p14)/(p14**2*p25**2)+(p45
     1   *s-p14*p24+2*p13*p23)/(p14*p15*p24*p25))/n2/2
      tmp0 = v*xm2*(xm2**2/(p13*p15*p24*p25)-(5*p25*s-4*p25**2+8*p15*p25
     1   +6*p13*p25)/(p14*p15*p24*p25)/4)/n2+v**2*xm2*(-4*xm2**2/(p13*
     2   *2*p24*p25)+2*s*xm2/(p13*p15*p24*p25)+(-(p25+p15)*p34+p25**2+p1
     3   5**2)/(p13*p15*p24*p25))/n2/4-2*n2*(s**2/4+p45**2+p34**2)*v
     4   *xm2**2/(p13*p25*p34*p45*s)+((-p25*s+p25**2+p23**2+p13*p23+p15*
     5   *2)/(p13*p14*p23*p25*p45)+(p23+p14)/(p13*p15*p24*p25))*v*xm2**2
     6   -v*(p25*(2*(p45+p35)*xm2+p25**2+p15**2)/(p13*p23*p24*p45)+(2*(p
     7   35+p34)*xm2+p23**2+p13**2)/(p15*p24*p45)/2)+2*n2*p15*v*(2*(p4
     8   5+p35)*xm2+p25**2+p15**2)/(p13*p34*p45*s)+v**2*xm2*((p45+p34)*x
     9   m2/(p13*p25*p34*p45)+2*xm2/(p23**2*p45)+(p25/p13-p15/p23)**2/p4
     :   5**2)+tmp0
      ans = n2*p14*p24*v*(2*(p45+p34)*xm2+p24**2+p14**2)/(p13*p25*p34*p4
     1   5*s)+(n2+1)*p12*v*(2*(p35+p34)*xm2+p23**2+p13**2)/(n2*p14*p15*p
     2   24*p25)/4-(n2+1)*v*xm2*(4*p12*xm2+s**2+2*p24*p25+2*p14*p15)/(
     3   n2*p14*p15*p24*p25)/8+n2*v*((p45-2*xm2)/(p14*p25*s)-s/(p13*p2
     4   3*p45)/4)*xm2+v*((p12-3*xm2)/(p13*p23*p45)+(-2*p25**2+3*p15*p
     5   25+5*p13*p25)/(p14*p15*p24*p25))*xm2+2*n2*(-s*(s+2*p45)/8+p15
     6   *p25+p14*p24+4*p13*p23)*v*xm2/(p13*p23*p45*s)+4*n2*(2*p15**2/(p
     7   23*p45**2*s)+(p45**2+p35**2+p34**2)/(p45**2*s**2))*v*xm2+tmp0+a
     8   ns
      tmp0 = v**3*xm2*((xm2**2+4*p13*xm2-2*p13*p14)/(p13**2*p25**2)+(p35
     1   *s+2*p14*p24-p13*p23)/(p13*p15*p23*p25))/n2/2
      tmp0 = v*xm2*(xm2**2/(p14*p15*p23*p25)-(5*p25*s-4*p25**2+8*p15*p25
     1   +6*p14*p25)/(p13*p15*p23*p25)/4)/n2+v**2*xm2*(-4*xm2**2/(p14*
     2   *2*p23*p25)+2*s*xm2/(p14*p15*p23*p25)+(-(p25+p15)*p34+p25**2+p1
     3   5**2)/(p14*p15*p23*p25))/n2/4+((-p25*s+p25**2+p24**2+p14*p24+
     4   p15**2)/(p13*p14*p24*p25*p35)+(p24+p13)/(p14*p15*p23*p25))*v*xm
     5   2**2-v*(p25*(2*(p45+p35)*xm2+p25**2+p15**2)/(p14*p23*p24*p35)+(
     6   2*(p45+p34)*xm2+p24**2+p14**2)/(p15*p23*p35)/2)+2*n2*p15*v*(2
     7   *(p45+p35)*xm2+p25**2+p15**2)/(p14*p34*p35*s)+(n2+1)*p12*v*(2*(
     8   p45+p34)*xm2+p24**2+p14**2)/(n2*p13*p15*p23*p25)/4+tmp0
      ans = -2*n2*(s**2/4+p35**2+p34**2)*v*xm2**2/(p14*p25*p34*p35*s)+
     1   v**2*xm2*((p35+p34)*xm2/(p14*p25*p34*p35)+2*xm2/(p24**2*p35)+(p
     2   25/p14-p15/p24)**2/p35**2)+n2*p13*p23*v*(2*(p35+p34)*xm2+p23**2
     3   +p13**2)/(p14*p25*p34*p35*s)-(n2+1)*v*xm2*(4*p12*xm2+s**2+2*p23
     4   *p25+2*p13*p15)/(n2*p13*p15*p23*p25)/8+n2*v*((p35-2*xm2)/(p13
     5   *p25*s)-s/(p14*p24*p35)/4)*xm2+v*((p12-3*xm2)/(p14*p24*p35)+(
     6   -2*p25**2+3*p15*p25+5*p14*p25)/(p13*p15*p23*p25))*xm2+2*n2*(-s*
     7   (s+2*p35)/8+p15*p25+4*p14*p24+p13*p23)*v*xm2/(p14*p24*p35*s)+
     8   4*n2*(2*p15**2/(p24*p35**2*s)+(p45**2+p35**2+p34**2)/(p35**2*s*
     9   *2))*v*xm2+tmp0+ans
      tmp0 = v**3*xm2*((xm2**2+4*p15*xm2-2*p14*p15)/(p15**2*p23**2)+(p35
     1   *s-p15*p25+2*p14*p24)/(p13*p15*p23*p25))/n2/2
      tmp0 = v*xm2*(xm2**2/(p13*p14*p23*p25)-(5*p23*s-4*p23**2+6*p14*p23
     1   +8*p13*p23)/(p13*p15*p23*p25)/4)/n2+v**2*xm2*(-4*xm2**2/(p14*
     2   *2*p23*p25)+2*s*xm2/(p13*p14*p23*p25)+(-(p23+p13)*p45+p23**2+p1
     3   3**2)/(p13*p14*p23*p25))/n2/4-2*n2*(s**2/4+p45**2+p35**2)*v
     4   *xm2**2/(p14*p23*p35*p45*s)+((-p23*s+p24**2+p14*p24+p23**2+p13*
     5   *2)/(p14*p15*p23*p24*p35)+(p24+p15)/(p13*p14*p23*p25))*v*xm2**2
     6   -v*((2*(p45+p34)*xm2+p24**2+p14**2)/(p13*p25*p35)/2+p23*(2*(p
     7   35+p34)*xm2+p23**2+p13**2)/(p14*p24*p25*p35))+v**2*xm2*((p45+p3
     8   5)*xm2/(p14*p23*p35*p45)+2*xm2/(p24**2*p35)+(p23/p14-p13/p24)**
     9   2/p35**2)+n2*p15*p25*v*(2*(p45+p35)*xm2+p25**2+p15**2)/(p14*p23
     :   *p35*p45*s)+tmp0
      ans = (n2+1)*p12*v*(2*(p45+p34)*xm2+p24**2+p14**2)/(n2*p13*p15*p23
     1   *p25)/4+2*n2*p13*v*(2*(p35+p34)*xm2+p23**2+p13**2)/(p14*p35*p
     2   45*s)-(n2+1)*v*xm2*(4*p12*xm2+s**2+2*p23*p25+2*p13*p15)/(n2*p13
     3   *p15*p23*p25)/8+n2*v*((p35-2*xm2)/(p15*p23*s)-s/(p14*p24*p35)
     4   /4)*xm2+v*((p12-3*xm2)/(p14*p24*p35)+(-2*p23**2+5*p14*p23+3*p
     5   13*p23)/(p13*p15*p23*p25))*xm2+2*n2*(-s*(s+2*p35)/8+p15*p25+4
     6   *p14*p24+p13*p23)*v*xm2/(p14*p24*p35*s)+4*n2*(2*p13**2/(p24*p35
     7   **2*s)+(p45**2+p35**2+p34**2)/(p35**2*s**2))*v*xm2+tmp0+ans
      fbb1 = ans
      return
      end

      function ggqq2(s,t,m2,mu2,nl)
c
c     d sigma_gg (sv) = N g^6 ggqq2 d phi2
c        N = 1/(4*pi)**2
c
      implicit double precision (a-z)
      integer nl
      character * 2 schhad1,schhad2
      common/betfac/betfac,delta
      common/scheme/schhad1,schhad2
      data pi/3.141 592 653 589 793/
      ro = 4*m2/s
      t1 = -t/s
      zg = 1
      vca = 3
      vcf = 4
      vcf = vcf/ 3.d0
      vtf = 1
      vtf = vtf/ 2.d0
      vda = 8
      nlf = nl
      t2 = 1-t1
      b = dsqrt(1-ro)
      lp = (b+1)/ 2.d0
      lm = (1-b)/ 2.d0
      at = s*t1
      aw = s*t2
      vlm2 = dlog(m2/mu2)
      vltm = dlog(at/m2)
      vlpm = dlog(lp/lm)
      vlsm = dlog(s/m2)
      vlsmu = dlog(s/mu2)
      vlwm = dlog(aw/m2)
      vlbl = dlog(b/lm)
      vdw = ddilog((aw-m2)/aw)-vlwm**2/ 2.d0
      vdt = ddilog((at-m2)/at)-vltm**2/ 2.d0
      vdmp = ddilog(-lm/lp)
      vdmb = vlbl**2/ 2.d0+ddilog(-lm/b)
      auinv = 1/(m2-aw)
      atinv = 1/(m2-at)
      softt1 = ddilog(1-2*t1/(b+1))+ddilog(1-2*t1/(1-b))+log(2*t1/(1-b))
     1   *log(2*t1/(b+1))
      softt2 = ddilog(1-2*t2/(b+1))+ddilog(1-2*t2/(1-b))+log(2*t2/(1-b))
     1   *log(2*t2/(b+1))
      softb = ddilog(2*b/(b+1))-ddilog(-2*b/(1-b))
      lt1 = log(t1)
      lt2 = log(t2)
      lb = log(b*betfac)
      ss = -4*lb*(8*t1**4-16*t1**3+4*ro*t1**2+12*t1**2-4*ro*t1-4*t1+ro**
     1   2)*vca*(vcf+t1**2*vca-t1*vca)*vlsmu*vtf*zg**6/(s*(t1-1)**2*t1**
     2   2*vda)
      tmp0 = 4*nlf*vtf-11*vca
      tmp0 = (8*t1**4-16*t1**3+4*ro*t1**2+12*t1**2-4*ro*t1-4*t1+ro**2)*t
     1   mp0*(vcf+t1**2*vca-t1*vca)*vlsmu*vtf*zg**6/(s*(t1-1)**2*t1**2*v
     2   da* 6.d0)
      ss = tmp0+ss
      ss = ss-(8*t1**4-16*t1**3+4*ro*t1**2+12*t1**2-4*ro*t1-4*t1+ro**2)*
     1   vca*(6*vcf+4*t1**2*vca-4*t1*vca-vca)*vlsm**2*vtf*zg**6/(s*(t1-1
     2   )**2*t1**2*vda* 4.d0)
      tmp0 = 2*vcf+2*t1**2*vca-2*t1*vca-vca
      tmp0 = (ro-2)*(8*t1**4-16*t1**3+4*ro*t1**2+12*t1**2-4*ro*t1-4*t1+r
     1   o**2)*tmp0*(2*vcf-vca)*vlpm*vlsm*vtf*zg**6/(b*s*(t1-1)**2*t1**2
     2   *vda* 8.d0)
      ss = tmp0+ss
      ss = ss-lt2*(8*t1**4-16*t1**3+4*ro*t1**2+12*t1**2-4*ro*t1-4*t1+ro*
     1   *2)*vca*(2*vcf+t1**2*vca-vca)*vlsm*vtf*zg**6/(s*(t1-1)**2*t1**2
     2   *vda* 2.d0)
      ss = ss-lt1*(8*t1**4-16*t1**3+4*ro*t1**2+12*t1**2-4*ro*t1-4*t1+ro*
     1   *2)*vca*(2*vcf+t1**2*vca-2*t1*vca)*vlsm*vtf*zg**6/(s*(t1-1)**2*
     2   t1**2*vda* 2.d0)
      ss = ss-lb*(8*t1**4-16*t1**3+4*ro*t1**2+12*t1**2-4*ro*t1-4*t1+ro**
     1   2)*vca*(4*vcf+2*t1**2*vca-2*t1*vca-vca)*vlsm*vtf*zg**6/(s*(t1-1
     2   )**2*t1**2*vda)
      tmp0 = 32*nlf*t1**4*vcf*vtf-64*nlf*t1**3*vcf*vtf+16*nlf*ro*t1**2*v
     1   cf*vtf+48*nlf*t1**2*vcf*vtf-16*nlf*ro*t1*vcf*vtf-16*nlf*t1*vcf*
     2   vtf+4*nlf*ro**2*vcf*vtf+32*nlf*t1**6*vca*vtf-96*nlf*t1**5*vca*v
     3   tf+16*nlf*ro*t1**4*vca*vtf
      tmp0 = 112*nlf*t1**4*vca*vtf-32*nlf*ro*t1**3*vca*vtf-64*nlf*t1**3*
     1   vca*vtf+4*nlf*ro**2*t1**2*vca*vtf+16*nlf*ro*t1**2*vca*vtf+16*nl
     2   f*t1**2*vca*vtf-4*nlf*ro**2*t1*vca*vtf-48*t1**4*vcf**2+96*t1**3
     3   *vcf**2-24*ro*t1**2*vcf**2-72*t1**2*vcf**2+24*ro*t1*vcf**2+24*t
     4   1*vcf**2-6*ro**2*vcf**2-48*t1**6*vca*vcf+144*t1**5*vca*vcf-24*r
     5   o*t1**4*vca*vcf-352*t1**4*vca*vcf+48*ro*t1**3*vca*vcf+464*t1**3
     6   *vca*vcf-6*ro**2*t1**2*vca*vcf-164*ro*t1**2*vca*vcf-252*t1**2*v
     7   ca*vcf+6*ro**2*t1*vca*vcf+140*ro*t1*vca*vcf+44*t1*vca*vcf-35*ro
     8   **2*vca*vcf-160*t1**6*vca**2+480*t1**5*vca**2-116*ro*t1**4*vca*
     9   *2-512*t1**4*vca**2+232*ro*t1**3*vca**2+224*t1**3*vca**2-29*ro*
     :   *2*t1**2*vca**2-104*ro*t1**2*vca**2-32*t1**2*vca**2+29*ro**2*t1
     ;   *vca**2-12*ro*t1*vca**2+3*ro**2*vca**2+tmp0
      tmp0 = -tmp0*vlsm*vtf*zg**6/(s*(t1-1)**2*t1**2*vda* 6.d0)
      ss = tmp0+ss
      ss = ss-(8*t1**4-16*t1**3+4*ro*t1**2+12*t1**2-4*ro*t1-4*t1+ro**2)*
     1   vca*(4*vcf+2*t1**2*vca-2*t1*vca-vca)*vlpm**2*vtf*zg**6/(s*(t1-1
     2   )**2*t1**2*vda* 8.d0)
      tmp0 = 2*vcf+2*t1**2*vca-2*t1*vca-vca
      tmp0 = lb*(ro-2)*(8*t1**4-16*t1**3+4*ro*t1**2+12*t1**2-4*ro*t1-4*t
     1   1+ro**2)*tmp0*(2*vcf-vca)*vlpm*vtf*zg**6/(b*s*(t1-1)**2*t1**2*v
     2   da* 2.d0)
      ss = tmp0+ss
      tmp0 = 16*ro*t1**4*vcf**2-32*ro*t1**3*vcf**2+16*ro**2*t1**2*vcf**2
      tmp0 = 16*t1**2*vcf**2-16*ro**2*t1*vcf**2+16*ro*t1*vcf**2-16*t1*vc
     1   f**2+4*ro**3*vcf**2-4*ro**2*vcf**2+16*ro*t1**6*vca*vcf-48*ro*t1
     2   **5*vca*vcf+16*ro**2*t1**4*vca*vcf+16*ro*t1**4*vca*vcf+48*t1**4
     3   *vca*vcf-32*ro**2*t1**3*vca*vcf+48*ro*t1**3*vca*vcf-96*t1**3*vc
     4   a*vcf+4*ro**3*t1**2*vca*vcf-4*ro**2*t1**2*vca*vcf+48*t1**2*vca*
     5   vcf-4*ro**3*t1*vca*vcf+20*ro**2*t1*vca*vcf-32*ro*t1*vca*vcf-4*r
     6   o**3*vca*vcf+8*ro**2*vca*vcf-8*ro*t1**6*vca**2+16*t1**6*vca**2+
     7   24*ro*t1**5*vca**2-48*t1**5*vca**2-8*ro**2*t1**4*vca**2-4*ro*t1
     8   **4*vca**2+40*t1**4*vca**2+16*ro**2*t1**3*vca**2-32*ro*t1**3*vc
     9   a**2-2*ro**3*t1**2*vca**2+12*ro*t1**2*vca**2-8*t1**2*vca**2+2*r
     :   o**3*t1*vca**2-8*ro**2*t1*vca**2+8*ro*t1*vca**2+ro**3*vca**2-2*
     ;   ro**2*vca**2+tmp0
      tmp0 = -tmp0*vlpm*vtf*zg**6/(b*s*(t1-1)**2*t1**2*vda* 4.d0)
      ss = tmp0+ss
      ss = ss-softt2*(8*t1**4-16*t1**3+4*ro*t1**2+12*t1**2-4*ro*t1-4*t1+
     1   ro**2)*vca*(2*vcf+t1**2*vca-vca)*vtf*zg**6/(s*(t1-1)**2*t1**2*v
     2   da* 2.d0)
      ss = ss-softt1*(8*t1**4-16*t1**3+4*ro*t1**2+12*t1**2-4*ro*t1-4*t1+
     1   ro**2)*vca*(2*vcf+t1**2*vca-2*t1*vca)*vtf*zg**6/(s*(t1-1)**2*t1
     2   **2*vda* 2.d0)
      tmp0 = 2*vcf+2*t1**2*vca-2*t1*vca-vca
      tmp0 = -(ro-2)*softb*(8*t1**4-16*t1**3+4*ro*t1**2+12*t1**2-4*ro*t1
     1   -4*t1+ro**2)*tmp0*(2*vcf-vca)*vtf*zg**6/(b*s*(t1-1)**2*t1**2*vd
     2   a* 8.d0)
      ss = tmp0+ss
      ss = pi**2*(8*t1**4-16*t1**3+4*ro*t1**2+12*t1**2-4*ro*t1-4*t1+ro**
     1   2)*vca*(vcf+t1**2*vca-t1*vca)*vtf*zg**6/(s*(t1-1)**2*t1**2*vda*
     2    3.d0)+ss
      ss = ss-2*lb*lt2*(8*t1**4-16*t1**3+4*ro*t1**2+12*t1**2-4*ro*t1-4*t
     1   1+ro**2)*vca*(2*vcf+t1**2*vca-vca)*vtf*zg**6/(s*(t1-1)**2*t1**2
     2   *vda)
      ss = lt2*(2*t1**2-2*t1+ro)**2*vca*(2*vcf+t1**2*vca-vca)*vtf*zg**6/
     1   (s*(t1-1)**2*t1**2*vda)+ss
      ss = ss-2*lb*lt1*(8*t1**4-16*t1**3+4*ro*t1**2+12*t1**2-4*ro*t1-4*t
     1   1+ro**2)*vca*(2*vcf+t1**2*vca-2*t1*vca)*vtf*zg**6/(s*(t1-1)**2*
     2   t1**2*vda)
      ss = lt1*(2*t1**2-2*t1+ro)**2*vca*(2*vcf+t1**2*vca-2*t1*vca)*vtf*z
     1   g**6/(s*(t1-1)**2*t1**2*vda)+ss
      ss = ss-8*lb**2*(8*t1**4-16*t1**3+4*ro*t1**2+12*t1**2-4*ro*t1-4*t1
     1   +ro**2)*vca*(vcf+t1**2*vca-t1*vca)*vtf*zg**6/(s*(t1-1)**2*t1**2
     2   *vda)
      ss = 4*lb*(8*t1**4-16*t1**3+4*ro*t1**2+12*t1**2-4*ro*t1-4*t1+ro**2
     1   )*vcf*(vcf+t1**2*vca-t1*vca)*vtf*zg**6/(s*(t1-1)**2*t1**2*vda)+
     2   ss
      tmp0 = 8*nlf*t1**4*vtf-16*nlf*t1**3*vtf+8*nlf*ro*t1**2*vtf+8*nlf*t
     1   1**2*vtf-8*nlf*ro*t1*vtf+2*nlf*ro**2*vtf-12*t1**4*vcf+24*t1**3*
     2   vcf-12*ro*t1**2*vcf-12*t1**2*vcf+12*ro*t1*vcf-3*ro**2*vcf-34*t1
     3   **4*vca+68*t1**3*vca-40*ro*t1**2*vca-34*t1**2*vca+40*ro*t1*vca-
     4   10*ro**2*vca
      tmp0 = 2*tmp0*(vcf+t1**2*vca-t1*vca)*vtf*zg**6/(s*(t1-1)**2*t1**2*
     1   vda* 3.d0)
      ss = tmp0+ss
      dd = 2*vcf+t1*vca-vca
      dd = -auinv*dd*pi*(4*t1+ro-4)*(8*t1**4-16*t1**3+12*ro*t1**2+8*t1**
     1   2-12*ro*t1+3*ro**2)*(2*vcf-vca)*vlwm**2*vtf*zg**6/((t1-1)**3*t1
     2   *vda* 8.d0)
      tmp0 = 8*ro*t1**3*vcf+16*t1**3*vcf+4*ro**2*t1**2*vcf-8*ro*t1**2*vc
     1   f-48*t1**2*vcf-8*ro**2*t1*vcf+4*ro*t1*vcf+48*t1*vcf+6*ro**2*vcf
     2   -4*ro*vcf-16*vcf+4*ro*t1**4*vca+4*t1**4*vca+2*ro**2*t1**3*vca-1
     3   2*ro*t1**3*vca-24*t1**3*vca-8*ro**2*t1**2*vca+18*ro*t1**2*vca+4
     4   8*t1**2*vca+11*ro**2*t1*vca-16*ro*t1*vca-40*t1*vca-5*ro**2*vca+
     5   6*ro*vca+12*vca
      tmp0 = pi*tmp0*(2*vcf-vca)*vlwm**2*vtf*zg**6/(s*(t1-1)**3*t1*vda)
      dd = tmp0+dd
      dd = 4*pi*(4*t1**4-8*t1**3+ro**2*t1**2+2*ro*t1**2+6*t1**2-ro**2*t1
     1   -2*ro*t1-2*t1+ro**2)*vca*(2*vcf-vca)*vltm*vlwm*vtf*zg**6/(s*(t1
     2   -1)**2*t1**2*vda)+dd
      dd = 2*pi*(8*t1**4-24*t1**3+2*ro*t1**2+30*t1**2-2*ro*t1-18*t1+ro**
     1   2+4)*vca**2*vlsm*vlwm*vtf*zg**6/(s*(t1-1)**2*vda)+dd
      tmp0 = 2*vcf+t1*vca-2*vca
      tmp0 = pi*(4*t1**3+2*ro**2*t1**2+2*ro*t1**2-12*t1**2-6*ro**2*t1-2*
     1   ro*t1+16*t1-ro**3+6*ro**2-8)*tmp0*(2*vcf-vca)*vlpm*vlwm*vtf*zg*
     2   *6/(b*s*(t1-1)**2*t1*vda)
      dd = tmp0+dd
      tmp0 = 96*t1**5*vcf+16*ro*t1**4*vcf-256*t1**4*vcf+96*ro*t1**3*vcf+
     1   256*t1**3*vcf+24*ro**2*t1**2*vcf-192*ro*t1**2*vcf-192*t1**2*vcf
     2   +12*ro**2*t1*vcf+32*ro*t1*vcf+160*t1*vcf+6*ro**3*vcf-36*ro**2*v
     3   cf+48*ro*vcf-64*vcf-32*t1**5*vca-8*ro*t1**4*vca-56*ro*t1**3*vca
     4   +192*t1**3*vca-12*ro**2*t1**2*vca+104*ro*t1**2*vca-256*t1**2*vc
     5   a-8*ro**2*t1*vca-8*ro*t1*vca+96*t1*vca-3*ro**3*vca+20*ro**2*vca
     6   -32*ro*vca
      tmp0 = auinv**2*pi*s*tmp0*(2*vcf+t1*vca-vca)*vlwm*vtf*zg**6/((t1-1
     1   )**2*t1*vda* 8.d0)
      dd = tmp0+dd
      tmp0 = 16*t1**4*vcf+8*ro*t1**3*vcf-20*t1**3*vcf+2*ro**2*t1**2*vcf+
     1   2*ro*t1**2*vcf+2*ro**2*t1*vcf-10*ro*t1*vcf-4*t1*vcf+ro**3*vcf-2
     2   *ro**2*vcf+8*vcf+4*t1**4*vca-28*t1**3*vca-2*ro*t1**2*vca+44*t1*
     3   *2*vca-4*ro*t1*vca-20*t1*vca-ro**2*vca+6*ro*vca
      tmp0 = -auinv*pi*tmp0*(2*vcf+t1*vca-vca)*vlwm*vtf*zg**6/((t1-1)**2
     1   *t1*vda)
      dd = tmp0+dd
      dd = dd-4*pi*(2*t1**2-2*t1+ro)**2*vca*(2*vcf+t1**2*vca-vca)*vlwm*v
     1   tf*zg**6/(s*(t1-1)**2*t1**2*vda)
      tmp0 = 2*vcf-t1*vca
      tmp0 = atinv*pi*(4*t1-ro)*(8*t1**4-16*t1**3+12*ro*t1**2+8*t1**2-12
     1   *ro*t1+3*ro**2)*tmp0*(2*vcf-vca)*vltm**2*vtf*zg**6/((t1-1)*t1**
     2   3*vda* 8.d0)
      dd = tmp0+dd
      dd = dd-pi*(2*vcf-vca)*(8*ro*t1**3*vcf+16*t1**3*vcf-4*ro**2*t1**2*
     1   vcf-16*ro*t1**2*vcf+12*ro*t1*vcf-2*ro**2*vcf-4*ro*t1**4*vca-4*t
     2   1**4*vca+2*ro**2*t1**3*vca+4*ro*t1**3*vca-8*t1**3*vca+2*ro**2*t
     3   1**2*vca-6*ro*t1**2*vca+ro**2*t1*vca)*vltm**2*vtf*zg**6/(s*(t1-
     4   1)*t1**3*vda)
      dd = 2*pi*(8*t1**4-8*t1**3+2*ro*t1**2+6*t1**2-2*ro*t1-2*t1+ro**2)*
     1   vca**2*vlsm*vltm*vtf*zg**6/(s*t1**2*vda)+dd
      tmp0 = 2*vcf-t1*vca-vca
      tmp0 = pi*(4*t1**3-2*ro**2*t1**2-2*ro*t1**2-2*ro**2*t1+2*ro*t1+4*t
     1   1+ro**3-2*ro**2)*tmp0*(2*vcf-vca)*vlpm*vltm*vtf*zg**6/(b*s*(t1-
     2   1)*t1**2*vda)
      dd = tmp0+dd
      dd = atinv**2*pi*s*(2*vcf-t1*vca)*(96*t1**5*vcf-16*ro*t1**4*vcf-22
     1   4*t1**4*vcf+160*ro*t1**3*vcf+192*t1**3*vcf-24*ro**2*t1**2*vcf-1
     2   92*ro*t1**2*vcf+60*ro**2*t1*vcf-6*ro**3*vcf-32*t1**5*vca+8*ro*t
     3   1**4*vca+160*t1**4*vca-88*ro*t1**3*vca-128*t1**3*vca+12*ro**2*t
     4   1**2*vca+112*ro*t1**2*vca-32*ro**2*t1*vca+3*ro**3*vca)*vltm*vtf
     5   *zg**6/((t1-1)*t1**2*vda* 8.d0)+dd
      dd = atinv*pi*(2*vcf-t1*vca)*(16*t1**4*vcf-8*ro*t1**3*vcf-44*t1**3
     1   *vcf+2*ro**2*t1**2*vcf+26*ro*t1**2*vcf+36*t1**2*vcf-6*ro**2*t1*
     2   vcf-18*ro*t1*vcf+ro**3*vcf+2*ro**2*vcf+4*t1**4*vca+12*t1**3*vca
     3   -2*ro*t1**2*vca-16*t1**2*vca+8*ro*t1*vca-ro**2*vca)*vltm*vtf*zg
     4   **6/((t1-1)*t1**2*vda)+dd
      dd = dd-4*pi*(2*t1**2-2*t1+ro)**2*vca*(2*vcf+t1**2*vca-2*t1*vca)*v
     1   ltm*vtf*zg**6/(s*(t1-1)**2*t1**2*vda)
      dd = pi*(ro+1)*(2*t1**2-2*t1+1)*vca**2*vlsm**2*vtf*zg**6/(s*(t1-1)
     1   *t1*vda)+dd
      tmp0 = 16*t1**4*vcf-32*t1**3*vcf-12*ro**2*t1**2*vcf+4*ro*t1**2*vcf
     1   +40*t1**2*vcf+12*ro**2*t1*vcf-4*ro*t1*vcf-24*t1*vcf-2*ro**3*vcf
     2   +4*ro**2*vcf+4*ro**2*t1**4*vca+4*ro*t1**4*vca-20*t1**4*vca-8*ro
     3   **2*t1**3*vca-8*ro*t1**3*vca+40*t1**3*vca-2*ro**3*t1**2*vca+18*
     4   ro**2*t1**2*vca+2*ro*t1**2*vca-40*t1**2*vca+2*ro**3*t1*vca-14*r
     5   o**2*t1*vca+2*ro*t1*vca+20*t1*vca+ro**3*vca-2*ro**2*vca
      tmp0 = -pi*tmp0*(2*vcf-vca)*vlpm*vlsm*vtf*zg**6/(b*s*(t1-1)**2*t1*
     1   *2*vda* 2.d0)
      dd = tmp0+dd
      dd = pi*(2*t1-1)**2*(4*ro*t1**2-12*t1**2-4*ro*t1+12*t1-ro**2+ro-4)
     1   *vca**2*vlsm*vtf*zg**6/(b**2*s*(t1-1)*t1*vda)+dd
      dd = 3*pi*(2*t1-1)**2*(4*t1**2-4*t1-ro+2)*vca**2*vlsm*vtf*zg**6/(b
     1   **4*s*(t1-1)*t1*vda* 2.d0)+dd
      dd = dd-pi*(16*t1**6-48*t1**5+24*ro*t1**4+48*t1**4-48*ro*t1**3-16*
     1   t1**3+4*ro**2*t1**2+34*ro*t1**2-t1**2-4*ro**2*t1-10*ro*t1+t1+2*
     2   ro**2)*vca**2*vlsm*vtf*zg**6/(s*(t1-1)**2*t1**2*vda)
      dd = pi*(32*ro*t1**2*vcf**2-32*t1**2*vcf**2-32*ro*t1*vcf**2+32*t1*
     1   vcf**2-8*ro**2*vcf**2-8*ro*vcf**2+16*vcf**2+32*ro*t1**4*vca*vcf
     2   -64*t1**4*vca*vcf-64*ro*t1**3*vca*vcf+128*t1**3*vca*vcf+24*ro**
     3   2*t1**2*vca*vcf-8*ro*t1**2*vca*vcf-88*t1**2*vca*vcf-24*ro**2*t1
     4   *vca*vcf+40*ro*t1*vca*vcf+24*t1*vca*vcf+16*ro**2*vca*vcf+8*ro*v
     5   ca*vcf-32*vca*vcf-16*ro*t1**4*vca**2-32*t1**4*vca**2+32*ro*t1**
     6   3*vca**2+64*t1**3*vca**2-12*ro**2*t1**2*vca**2-5*ro*t1**2*vca**
     7   2-66*t1**2*vca**2+12*ro**2*t1*vca**2-11*ro*t1*vca**2+34*t1*vca*
     8   *2-6*ro**2*vca**2-2*ro*vca**2+4*vca**2)*vlpm**2*vtf*zg**6/(b*s*
     9   (t1-1)*t1*vda* 4.d0)+dd
      dd = dd-pi*(16*ro*t1**4-48*t1**4-32*ro*t1**3+96*t1**3-7*ro**2*t1**
     1   2+49*ro*t1**2-98*t1**2+7*ro**2*t1-33*ro*t1+50*t1+ro**3-3*ro**2+
     2   6*ro-8)*vca**2*vlpm**2*vtf*zg**6/(b**3*s*(t1-1)*t1*vda* 4.d0)
      dd = dd-pi*(2*t1-1)**2*(4*ro*t1**2+8*t1**2-4*ro*t1-8*t1+3*ro**2-8*
     1   ro+8)*vca**2*vlpm**2*vtf*zg**6/(b**5*s*(t1-1)*t1*vda* 8.d0)
      dd = dd-pi*vlpm**2*vtf*(8*ro**2*t1**2*vca*vtf-8*ro**2*t1*vca*vtf+2
     1   *ro**2*vca*vtf+32*t1**2*vcf**2-32*t1*vcf**2-8*ro**2*vcf**2+48*v
     2   cf**2-16*ro*t1**2*vca*vcf-56*t1**2*vca*vcf+16*ro*t1*vca*vcf+56*
     3   t1*vca*vcf+10*ro**2*vca*vcf-4*ro*vca*vcf-64*vca*vcf+8*ro*t1**2*
     4   vca**2+20*t1**2*vca**2-8*ro*t1*vca**2-20*t1*vca**2-3*ro**2*vca*
     5   *2+2*ro*vca**2+20*vca**2)*zg**6/(s*(t1-1)*t1*vda* 4.d0)
      dd = b*pi*vlpm*vtf*(8*ro**2*t1**2*vca*vtf-8*ro**2*t1*vca*vtf+2*ro*
     1   *2*vca*vtf+8*vcf**2-16*ro*t1**2*vca*vcf-16*t1**2*vca*vcf+16*ro*
     2   t1*vca*vcf+16*t1*vca*vcf-4*ro*vca*vcf-14*vca*vcf+8*ro*t1**2*vca
     3   **2+8*t1**2*vca**2-8*ro*t1*vca**2-8*t1*vca**2+2*ro*vca**2+5*vca
     4   **2)*zg**6/(s*(t1-1)*t1*vda)+dd
      tmp0 = 16*ro*t1**4*vcf-64*t1**4*vcf-32*ro*t1**3*vcf+128*t1**3*vcf+
     1   16*ro**2*t1**2*vcf-16*ro*t1**2*vcf-72*t1**2*vcf-16*ro**2*t1*vcf
     2   +32*ro*t1*vcf+8*t1*vcf+4*ro**3*vcf-8*ro**2*vcf+48*ro*t1**6*vca-
     3   80*t1**6*vca-144*ro*t1**5*vca+240*t1**5*vca+8*ro**2*t1**4*vca+1
     4   00*ro*t1**4*vca-196*t1**4*vca-16*ro**2*t1**3*vca+40*ro*t1**3*vc
     5   a-8*t1**3*vca+4*ro**3*t1**2*vca-10*ro**2*t1**2*vca-31*ro*t1**2*
     6   vca+54*t1**2*vca-4*ro**3*t1*vca+18*ro**2*t1*vca-13*ro*t1*vca-10
     7   *t1*vca-2*ro**3*vca+4*ro**2*vca
      tmp0 = pi*tmp0*(2*vcf-vca)*vlpm*vtf*zg**6/(b*s*(t1-1)**2*t1**2*vda
     1   * 2.d0)
      dd = tmp0+dd
      tmp0 = 4*nlf*vtf-11*vca
      tmp0 = -2*pi*(8*t1**4-16*t1**3+4*ro*t1**2+12*t1**2-4*ro*t1-4*t1+ro
     1   **2)*tmp0*(vcf+t1**2*vca-t1*vca)*vlm2*vtf*zg**6/(s*(t1-1)**2*t1
     2   **2*vda* 3.d0)
      dd = tmp0+dd
      tmp0 = 16*t1**4*vcf-32*t1**3*vcf+24*ro*t1**2*vcf+16*t1**2*vcf-24*r
     1   o*t1*vcf+6*ro**2*vcf-8*t1**4*vca+16*t1**3*vca-12*ro*t1**2*vca-4
     2   *t1**2*vca+12*ro*t1*vca-8*t1*vca-3*ro**2*vca+4*vca
      tmp0 = -auinv*pi*(4*t1+ro-4)*tmp0*(2*vcf+t1*vca-vca)*vdw*vtf*zg**6
     1   /((t1-1)**3*t1*vda* 8.d0)
      dd = tmp0+dd
      tmp0 = 16*ro*t1**3*vcf**2
      tmp0 = 32*t1**3*vcf**2+8*ro**2*t1**2*vcf**2-16*ro*t1**2*vcf**2-96*
     1   t1**2*vcf**2-16*ro**2*t1*vcf**2+8*ro*t1*vcf**2+96*t1*vcf**2+12*
     2   ro**2*vcf**2-8*ro*vcf**2-32*vcf**2+8*ro*t1**4*vca*vcf-8*t1**4*v
     3   ca*vcf+4*ro**2*t1**3*vca*vcf-32*ro*t1**3*vca*vcf-16*t1**3*vca*v
     4   cf-16*ro**2*t1**2*vca*vcf+36*ro*t1**2*vca*vcf+92*t1**2*vca*vcf+
     5   22*ro**2*t1*vca*vcf-20*ro*t1*vca*vcf-104*t1*vca*vcf-12*ro**2*vc
     6   a*vcf+8*ro*vca*vcf+36*vca*vcf-16*t1**5*vca**2-8*ro*t1**4*vca**2
     7   +56*t1**4*vca**2-2*ro**2*t1**3*vca**2+20*ro*t1**3*vca**2-62*t1*
     8   *3*vca**2+6*ro**2*t1**2*vca**2-18*ro*t1**2*vca**2+10*t1**2*vca*
     9   *2-7*ro**2*t1*vca**2+8*ro*t1*vca**2+22*t1*vca**2+3*ro**2*vca**2
     :   -2*ro*vca**2-10*vca**2+tmp0
      tmp0 = pi*tmp0*vdw*vtf*zg**6/(s*(t1-1)**3*t1*vda)
      dd = tmp0+dd
      tmp0 = 16*t1**4*vcf-32*t1**3*vcf+24*ro*t1**2*vcf+16*t1**2*vcf-24*r
     1   o*t1*vcf+6*ro**2*vcf-8*t1**4*vca+16*t1**3*vca-12*ro*t1**2*vca-4
     2   *t1**2*vca+12*ro*t1*vca-3*ro**2*vca
      tmp0 = atinv*pi*(4*t1-ro)*tmp0*(2*vcf-t1*vca)*vdt*vtf*zg**6/((t1-1
     1   )*t1**3*vda* 8.d0)
      dd = tmp0+dd
      dd = dd-pi*(16*ro*t1**3*vcf**2+32*t1**3*vcf**2-8*ro**2*t1**2*vcf**
     1   2-32*ro*t1**2*vcf**2+24*ro*t1*vcf**2-4*ro**2*vcf**2-8*ro*t1**4*
     2   vca*vcf+8*t1**4*vca*vcf+4*ro**2*t1**3*vca*vcf-48*t1**3*vca*vcf+
     3   4*ro**2*t1**2*vca*vcf+12*ro*t1**2*vca*vcf+4*t1**2*vca*vcf+2*ro*
     4   *2*t1*vca*vcf-12*ro*t1*vca*vcf+2*ro**2*vca*vcf-16*t1**5*vca**2+
     5   8*ro*t1**4*vca**2+24*t1**4*vca**2-2*ro**2*t1**3*vca**2-12*ro*t1
     6   **3*vca**2+2*t1**3*vca**2+6*ro*t1**2*vca**2-ro**2*t1*vca**2)*vd
     7   t*vtf*zg**6/(s*(t1-1)*t1**3*vda)
      tmp0 = 32*t1**4*vcf**2-64*t1**3*vcf**2-24*ro**2*t1**2*vcf**2+8*ro*
     1   t1**2*vcf**2
      tmp0 = 80*t1**2*vcf**2+24*ro**2*t1*vcf**2-8*ro*t1*vcf**2-48*t1*vcf
     1   **2-4*ro**3*vcf**2+8*ro**2*vcf**2+8*ro**2*t1**4*vca*vcf+8*ro*t1
     2   **4*vca*vcf-56*t1**4*vca*vcf-16*ro**2*t1**3*vca*vcf-16*ro*t1**3
     3   *vca*vcf+112*t1**3*vca*vcf-4*ro**3*t1**2*vca*vcf+48*ro**2*t1**2
     4   *vca*vcf-120*t1**2*vca*vcf+4*ro**3*t1*vca*vcf-40*ro**2*t1*vca*v
     5   cf+8*ro*t1*vca*vcf+64*t1*vca*vcf+4*ro**3*vca*vcf-8*ro**2*vca*vc
     6   f-64*t1**6*vca**2+192*t1**5*vca**2-4*ro**2*t1**4*vca**2-5*ro*t1
     7   **4*vca**2-226*t1**4*vca**2+8*ro**2*t1**3*vca**2+10*ro*t1**3*vc
     8   a**2+132*t1**3*vca**2+2*ro**3*t1**2*vca**2-18*ro**2*t1**2*vca**
     9   2-3*ro*t1**2*vca**2-22*t1**2*vca**2-2*ro**3*t1*vca**2+14*ro**2*
     :   t1*vca**2-2*ro*t1*vca**2-12*t1*vca**2-ro**3*vca**2+2*ro**2*vca*
     ;   *2+tmp0
      tmp0 = pi*tmp0*vdmp*vtf*zg**6/(b*s*(t1-1)**2*t1**2*vda)
      dd = tmp0+dd
      dd = dd-pi*(16*ro*t1**4-48*t1**4-32*ro*t1**3+96*t1**3-7*ro**2*t1**
     1   2+49*ro*t1**2-98*t1**2+7*ro**2*t1-33*ro*t1+50*t1+ro**3-3*ro**2+
     2   6*ro-8)*vca**2*vdmp*vtf*zg**6/(b**3*s*(t1-1)*t1*vda)
      dd = dd-pi*(2*t1-1)**2*(4*ro*t1**2+8*t1**2-4*ro*t1-8*t1+3*ro**2-8*
     1   ro+8)*vca**2*vdmp*vtf*zg**6/(b**5*s*(t1-1)*t1*vda* 2.d0)
      tmp0 = 2*vcf+2*t1**2*vca-2*t1*vca-vca
      tmp0 = -pi*(ro-2)*(8*t1**4-16*t1**3+4*ro*t1**2+12*t1**2-4*ro*t1-4*
     1   t1+ro**2)*tmp0*(2*vcf-vca)*vdmb*vtf*zg**6/(b*s*(t1-1)**2*t1**2*
     2   vda)
      dd = tmp0+dd
      tmp0 = 128*ro*t1**4*vcf**2-224*t1**4*vcf**2-256*ro*t1**3*vcf**2+44
     1   8*t1**3*vcf**2+40*ro**2*t1**2*vcf**2+72*ro*t1**2*vcf**2-304*t1*
     2   *2*vcf**2-40*ro**2*t1*vcf**2+56*ro*t1*vcf**2+80*t1*vcf**2+12*ro
     3   **3*vcf**2-24*ro**2*vcf**2+128*ro*t1**6*vca*vcf
      tmp0 = -256*t1**6*vca*vcf-384*ro*t1**5*vca*vcf+768*t1**5*vca*vcf+7
     1   2*ro**2*t1**4*vca*vcf+200*ro*t1**4*vca*vcf-696*t1**4*vca*vcf-14
     2   4*ro**2*t1**3*vca*vcf+240*ro*t1**3*vca*vcf+112*t1**3*vca*vcf+12
     3   *ro**3*t1**2*vca*vcf+16*ro**2*t1**2*vca*vcf-128*ro*t1**2*vca*vc
     4   f+136*t1**2*vca*vcf-12*ro**3*t1*vca*vcf+56*ro**2*t1*vca*vcf-56*
     5   ro*t1*vca*vcf-64*t1*vca*vcf-12*ro**3*vca*vcf+24*ro**2*vca*vcf-6
     6   4*ro*t1**6*vca**2+64*t1**6*vca**2+192*ro*t1**5*vca**2-192*t1**5
     7   *vca**2-36*ro**2*t1**4*vca**2-133*ro*t1**4*vca**2+158*t1**4*vca
     8   **2+72*ro**2*t1**3*vca**2-54*ro*t1**3*vca**2+4*t1**3*vca**2-6*r
     9   o**3*t1**2*vca**2-18*ro**2*t1**2*vca**2+45*ro*t1**2*vca**2-54*t
     :   1**2*vca**2+6*ro**3*t1*vca**2-18*ro**2*t1*vca**2+14*ro*t1*vca**
     ;   2+20*t1*vca**2+3*ro**3*vca**2-6*ro**2*vca**2+tmp0
      tmp0 = pi**3*tmp0*vtf*zg**6/(b*s*(t1-1)**2*t1**2*vda* 12.d0)
      dd = tmp0+dd
      dd = pi*(ro-1)*(2*t1-1)**2*vca*(2*vcf-vca)*vtf*zg**6/(b**2*s*(t1-1
     1   )*t1*vda)+dd
      dd = dd-pi**3*(16*ro*t1**4-48*t1**4-32*ro*t1**3+96*t1**3-7*ro**2*t
     1   1**2+49*ro*t1**2-98*t1**2+7*ro**2*t1-33*ro*t1+50*t1+ro**3-3*ro*
     2   *2+6*ro-8)*vca**2*vtf*zg**6/(b**3*s*(t1-1)*t1*vda* 12.d0)
      dd = pi*(ro-1)*(2*t1-1)**4*vca**2*vtf*zg**6/(b**4*s*(t1-1)*t1*vda)
     1   +dd
      dd = dd-pi**3*(2*t1-1)**2*(4*ro*t1**2+8*t1**2-4*ro*t1-8*t1+3*ro**2
     1   -8*ro+8)*vca**2*vtf*zg**6/(b**5*s*(t1-1)*t1*vda* 24.d0)
      tmp0 = 64*pi**2*t1**5*vcf+192*t1**5*vcf+16*pi**2*ro*t1**4*vcf-192*
     1   pi**2*t1**4*vcf+192*t1**4*vcf+64*pi**2*ro*t1**3*vcf
      tmp0 = 240*ro*t1**3*vcf+192*pi**2*t1**3*vcf-960*t1**3*vcf+24*pi**2
     1   *ro**2*t1**2*vcf-24*ro**2*t1**2*vcf-176*pi**2*ro*t1**2*vcf+288*
     2   ro*t1**2*vcf-64*pi**2*t1**2*vcf-192*t1**2*vcf+192*ro**2*t1*vcf+
     3   96*pi**2*ro*t1*vcf-1296*ro*t1*vcf+1536*t1*vcf+6*pi**2*ro**3*vcf
     4   -24*pi**2*ro**2*vcf-168*ro**2*vcf+768*ro*vcf-768*vcf-32*pi**2*t
     5   1**5*vca-8*pi**2*ro*t1**4*vca+96*pi**2*t1**4*vca-1152*t1**4*vca
     6   -32*pi**2*ro*t1**3*vca-288*ro*t1**3*vca-96*pi**2*t1**3*vca+3456
     7   *t1**3*vca-12*pi**2*ro**2*t1**2*vca+88*pi**2*ro*t1**2*vca+288*r
     8   o*t1**2*vca+32*pi**2*t1**2*vca-3456*t1**2*vca-72*ro**2*t1*vca-4
     9   8*pi**2*ro*t1*vca+288*ro*t1*vca+1152*t1*vca-3*pi**2*ro**3*vca+1
     :   2*pi**2*ro**2*vca+72*ro**2*vca-288*ro*vca+tmp0
      tmp0 = -auinv*pi*tmp0*(2*vcf+t1*vca-vca)*vtf*zg**6/((t1-1)**3*t1*v
     1   da* 48.d0)
      dd = tmp0+dd
      tmp0 = 64*pi**2*t1**5*vcf+192*t1**5*vcf-16*pi**2*ro*t1**4*vcf-128*
     1   pi**2*t1**4*vcf-1152*t1**4*vcf+128*pi**2*ro*t1**3*vcf+240*ro*t1
     2   **3*vcf+64*pi**2*t1**3*vcf+1728*t1**3*vcf-24*pi**2*ro**2*t1**2*
     3   vcf+24*ro**2*t1**2*vcf-112*pi**2*ro*t1**2*vcf-1008*ro*t1**2*vcf
     4   +48*pi**2*ro**2*t1*vcf+144*ro**2*t1*vcf-6*pi**2*ro**3*vcf-32*pi
     5   **2*t1**5*vca+8*pi**2*ro*t1**4*vca+64*pi**2*t1**4*vca+1152*t1**
     6   4*vca-64*pi**2*ro*t1**3*vca-288*ro*t1**3*vca-32*pi**2*t1**3*vca
     7   -1152*t1**3*vca+12*pi**2*ro**2*t1**2*vca+56*pi**2*ro*t1**2*vca+
     8   576*ro*t1**2*vca-24*pi**2*ro**2*t1*vca-72*ro**2*t1*vca+3*pi**2*
     9   ro**3*vca
      tmp0 = atinv*pi*tmp0*(2*vcf-t1*vca)*vtf*zg**6/((t1-1)*t1**3*vda*
     1   48.d0)
      dd = tmp0+dd
      tmp0 = 256*nlf*t1**6*vcf*vtf-768*nlf*t1**5*vcf*vtf+256*nlf*ro*t1**
     1   4*vcf*vtf+768*nlf*t1**4*vcf*vtf-512*nlf*ro*t1**3*vcf*vtf-256*nl
     2   f*t1**3*vcf*vtf+64*nlf*ro**2*t1**2*vcf*vtf+256*nlf*ro*t1**2*vcf
     3   *vtf
      tmp0 = -64*nlf*ro**2*t1*vcf*vtf+256*nlf*t1**8*vca*vtf-1024*nlf*t1*
     1   *7*vca*vtf-24*pi**2*ro**2*t1**6*vca*vtf+192*ro**2*t1**6*vca*vtf
     2   +288*nlf*ro*t1**6*vca*vtf+32*ro*t1**6*vca*vtf+1536*nlf*t1**6*vc
     3   a*vtf+72*pi**2*ro**2*t1**5*vca*vtf-576*ro**2*t1**5*vca*vtf-864*
     4   nlf*ro*t1**5*vca*vtf-96*ro*t1**5*vca*vtf-1024*nlf*t1**5*vca*vtf
     5   -78*pi**2*ro**2*t1**4*vca*vtf+64*nlf*ro**2*t1**4*vca*vtf+624*ro
     6   **2*t1**4*vca*vtf+872*nlf*ro*t1**4*vca*vtf+104*ro*t1**4*vca*vtf
     7   +256*nlf*t1**4*vca*vtf+36*pi**2*ro**2*t1**3*vca*vtf-128*nlf*ro*
     8   *2*t1**3*vca*vtf-288*ro**2*t1**3*vca*vtf-304*nlf*ro*t1**3*vca*v
     9   tf-48*ro*t1**3*vca*vtf-6*pi**2*ro**2*t1**2*vca*vtf+64*nlf*ro**2
     :   *t1**2*vca*vtf+48*ro**2*t1**2*vca*vtf+8*nlf*ro*t1**2*vca*vtf+8*
     ;   ro*t1**2*vca*vtf-96*pi**2*t1**6*vcf**2-1152*t1**6*vcf**2+288*pi
     <   **2*t1**5*vcf**2+3456*t1**5*vcf**2-8*pi**2*ro**2*t1**4*vcf**2-9
     =   6*pi**2*ro*t1**4*vcf**2-576*ro*t1**4*vcf**2-368*pi**2*t1**4*vcf
     >   **2-4992*t1**4*vcf**2+16*pi**2*ro**2*t1**3*vcf**2+tmp0
      tmp0 = 192*pi**2*ro*t1**3*vcf**2+1152*ro*t1**3*vcf**2+256*pi**2*t1
     1   **3*vcf**2+4224*t1**3*vcf**2-24*pi**2*ro**2*t1**2*vcf**2-192*ro
     2   **2*t1**2*vcf**2-144*pi**2*ro*t1**2*vcf**2-768*ro*t1**2*vcf**2-
     3   80*pi**2*t1**2*vcf**2-1536*t1**2*vcf**2+16*pi**2*ro**2*t1*vcf**
     4   2+192*ro**2*t1*vcf**2+48*pi**2*ro*t1*vcf**2+192*ro*t1*vcf**2-8*
     5   pi**2*ro**2*vcf**2-1152*t1**8*vca*vcf+4608*t1**7*vca*vcf+16*pi*
     6   *2*ro*t1**6*vca*vcf-768*ro*t1**6*vca*vcf+264*pi**2*t1**6*vca*vc
     7   f-8864*t1**6*vca*vcf-48*pi**2*ro*t1**5*vca*vcf+2304*ro*t1**5*vc
     8   a*vcf-792*pi**2*t1**5*vca*vcf+10464*t1**5*vca*vcf+42*pi**2*ro**
     9   2*t1**4*vca*vcf-192*ro**2*t1**4*vca*vcf+124*pi**2*ro*t1**4*vca*
     :   vcf-3920*ro*t1**4*vca*vcf+968*pi**2*t1**4*vca*vcf-6264*t1**4*vc
     ;   a*vcf-84*pi**2*ro**2*t1**3*vca*vcf+384*ro**2*t1**3*vca*vcf-168*
     <   pi**2*ro*t1**3*vca*vcf+4000*ro*t1**3*vca*vcf-616*pi**2*t1**3*vc
     =   a*vcf+464*t1**3*vca*vcf+78*pi**2*ro**2*t1**2*vca*vcf-512*ro**2*
     >   t1**2*vca*vcf+tmp0
      tmp0 = 100*pi**2*ro*t1**2*vca*vcf-1520*ro*t1**2*vca*vcf+176*pi**2*
     1   t1**2*vca*vcf+744*t1**2*vca*vcf-36*pi**2*ro**2*t1*vca*vcf+320*r
     2   o**2*t1*vca*vcf-24*pi**2*ro*t1*vca*vcf-96*ro*t1*vca*vcf+4*pi**2
     3   *ro**2*vca*vcf+160*pi**2*t1**8*vca**2-1088*t1**8*vca**2-640*pi*
     4   *2*t1**7*vca**2+4352*t1**7*vca**2+64*pi**2*ro*t1**6*vca**2-1296
     5   *ro*t1**6*vca**2+1004*pi**2*t1**6*vca**2-5952*t1**6*vca**2-192*
     6   pi**2*ro*t1**5*vca**2+3888*ro*t1**5*vca**2-772*pi**2*t1**5*vca*
     7   *2+2624*t1**5*vca**2+pi**2*ro**2*t1**4*vca**2-320*ro**2*t1**4*v
     8   ca**2+214*pi**2*ro*t1**4*vca**2-3772*ro*t1**4*vca**2+260*pi**2*
     9   t1**4*vca**2+640*t1**4*vca**2-2*pi**2*ro**2*t1**3*vca**2+640*ro
     :   **2*t1**3*vca**2-108*pi**2*ro*t1**3*vca**2+1064*ro*t1**3*vca**2
     ;   +20*pi**2*t1**3*vca**2-576*t1**3*vca**2-3*pi**2*ro**2*t1**2*vca
     <   **2-320*ro**2*t1**2*vca**2+22*pi**2*ro*t1**2*vca**2+116*ro*t1**
     =   2*vca**2-32*pi**2*t1**2*vca**2+4*pi**2*ro**2*t1*vca**2+tmp0
      tmp0 = -pi*tmp0*vtf*zg**6/(s*(t1-1)**3*t1**3*vda* 12.d0)
      dd = tmp0+dd
      ggqq2 = dd/(pi* 4.d0)+ss
      if(schhad1.eq.'DI')then
           one = 1
           xk = xkdgg(nl) + 2*xkpgg(one,nl)*lb + 2*xklgg(one,nl)*lb**2
           xk = xk*16*pi**2
           ggqq2 = ggqq2 - xk*ggborn(s,t,m2)/(8*pi**2)
      elseif(schhad1.ne.'MS')then
           write(6,*)'scheme ',schhad1,'not known'
           stop
      endif
      if(schhad2.eq.'DI')then
           one = 1
           xk = xkdgg(nl) + 2*xkpgg(one,nl)*lb + 2*xklgg(one,nl)*lb**2
           xk = xk*16*pi**2
           ggqq2 = ggqq2 - xk*ggborn(s,t,m2)/(8*pi**2)
      elseif(schhad2.ne.'MS')then
           write(6,*)'scheme ',schhad2,'not known'
           stop
      endif
      return
      end

       FUNCTION FQQ(S,X,Y,XM2,Q1Q,Q2Q,W1H,W2H,CTH2)
c
c      q(p1) + q_barra(p2) --> Q(k1) + Q_barra(k2) + g(k)
c
c      d sigma_qq (f) = N g^6 / (64 pi^2 s) beta_x d costh1 d th2 dy dx
c                       1/(1-x)_rho ( 1/(1-y)_+ + 1/(1+y)_+ ) FQQ
c
c           N = 1 / (4 pi)^2
c
       IMPLICIT REAL* 8(A-H,O-Z)
       REAL* 8 N
       TINY = .1D-10
       V = 8
       N = 3
       N2 = N*N
       CF = 4.D0/3.D0
       CA = 3
       TK = - (1-X)*(1-Y)*S/2
       UK = - (1-X)*(1+Y)*S/2
       IF(1-X.LT.TINY)THEN
          Q2C=-S-Q2Q
          P13 = -Q1Q/2
          P23 = -Q2C/2
          P12 = S/2
          BORN = V/(2*N2)*( (P13**2+P23**2)/P12**2 + XM2/P12 )
C
C         Fattori iconali moltiplicati per 4*tk*uk
C         P1.K = -TK/2
C         P2.K = -UK/2
C         P3.K = W1/2
C         P4.K = W2/2
C
          P14 = P23
          P24 = P13
C
          E13 = 16*(1+Y)*P13/W1H
          E14 = 16*(1+Y)*P14/W2H
          E23 = 16*(1-Y)*P23/W1H
          E24 = 16*(1-Y)*P24/W2H
          E12 = 16*P12
          E33 = 16*(1-Y)*(1+Y)* XM2/W1H**2
          E44 = 16*(1-Y)*(1+Y)* XM2/W2H**2
          E34 = 16*(1-Y)*(1+Y)* (S/2-XM2)/(W1H*W2H)
          SUM = BORN*( CF*(2*E13+2*E24-E33-E44)
     #        +           (2*E14+2*E23-E13-E24-E12-E34)/N )
          FQQ = 1/(2*S)*SUM
       ELSEIF(1-Y.LT.TINY)THEN
          Q2C = -S-UK-Q2Q
          P13 = - X*Q1Q/2
          P23 = -Q2C/2
          P12 = S*X/2
          BORN = V/(2*N2)*( (P13**2+P23**2)/P12**2 + XM2/P12 )
          SUM = - BORN*(8*UK)*CF*(1+X**2)/(1-X)
          FQQ = 1/(2*X*S)*SUM
       ELSEIF(1+Y.LT.TINY)THEN
          Q2C = -S-UK-Q2Q
          P13 = -Q1Q/2
          P23 = -X*Q2C/2
          P12 = S*X/2
          BORN = V/(2*N2)*( (P13**2+P23**2)/P12**2 + XM2/P12 )
          SUM = - BORN*(8*TK)*CF*(1+X**2)/(1-X)
          FQQ = 1/(2*X*S)*SUM
       ELSE
       S2 = S+TK+UK
       Q1C=-S-TK-Q1Q
       Q2C=-S-UK-Q2Q
       W1 =Q2Q-Q1Q-TK
       W2 =Q1Q-Q2Q-UK
C
       P12 = S/2
       P13 = Q1Q/2
       P14 = Q1C/2
       P15 = TK/2
       P23 = Q2C/2
       P24 = Q2Q/2
       P25 = UK/2
       P34 = (S2-2*XM2)/2
       P35 = W1/2
       P45 = W2/2
      ans = Q4G1M(XM2,P34,P24,P14,P45,P23,P13,P35,P12,P25,P15)
      ANS = 4*TK*UK*ANS/(2*S*4*9)
      FQQ = ANS
      ENDIF
      RETURN
      END

       FUNCTION FQG(S,X,Y,XM2,Q1Q,Q2Q,W1H,W2H,CTH2)
c
c      q(p1) + g(p2) --> Q(k1) + Q_barra(k2) + g(k)
c
c      d sigma_qg (f) = N g^6 / (64 pi^2 s) beta_x d costh1 d th2 dy dx
c                       1/(1-x)_rho ( 1/(1-y)_+ + 1/(1+y)_+ ) FQG
c
c           N = 1 / (4 pi)^2
c
       IMPLICIT REAL* 8(A-H,O-Z)
       REAL* 8 N
       TINY = .1D-10
       V = 8
       N = 3
       N2 = N*N
       TF = .5D0
       CF = 4.D0/3.D0
       CA = 3
       TK = - (1-X)*(1-Y)*S/2
       UK = - (1-X)*(1+Y)*S/2
       IF(1-X.LT.TINY)THEN
          FQG = 0
       ELSEIF(1-Y.LT.TINY)THEN
          Q2C = -S-UK-Q2Q
          P13 = - X*Q1Q/2
          P23 = -Q2C/2
          P12 = S*X/2
          BX = SQRT(1-4*XM2/(S*X))
          CTH1 = (P23-P13)/P12/BX
          AZIDEP =
     #    -512*BX**2*(CTH1-1)*(CTH1+1)*V*(2*V+BX**2*CTH1**2*N2-N2)
     #    *(X-1)**2*XM2/((BX*CTH1-1)**2*(BX*CTH1+1)**2*X**2)
          AZIDEP = AZIDEP * (2*CTH2**2-1)/2 /(4*64)
          AZIDEP = AZIDEP * CF / CA
          BORN = 1/(2*V*N)*(V/(P13*P23)-2*N**2/P12**2)*
     #           (P13**2+P23**2+2*XM2*P12-(XM2*P12)**2/(P13*P23))
          SUM = - BORN*(8*UK)*CF*(1+(1-X)**2)/X
     #    + AZIDEP
          FQG = 1/(2*X*S)*SUM
       ELSEIF(1+Y.LT.TINY)THEN
          Q2C = -S-UK-Q2Q
          P13 = -Q1Q/2
          P23 = -X*Q2C/2
          P12 = S*X/2
          BORN = V/(2*N2)*( (P13**2+P23**2)/P12**2 + XM2/P12 )
          SUM = - BORN*(8*TK)*TF*(X**2+(1-X)**2)
          FQG = 1/(2*X*S)*SUM
       ELSE
       S2 = S+TK+UK
       Q1C=-S-TK-Q1Q
       Q2C=-S-UK-Q2Q
       W1 =Q2Q-Q1Q-TK
       W2 =Q1Q-Q2Q-UK
C
       P12 = S/2
       P13 = Q1Q/2
       P14 = Q1C/2
       P15 = TK/2
       P23 = Q2C/2
       P24 = Q2Q/2
       P25 = UK/2
       P34 = (S2-2*XM2)/2
       P35 = W1/2
       P45 = W2/2
      ANS = Q4G1M(XM2,P34,P45,P14,P24,P35,P13,P23,P15,P25,P12)
      ANS = - 4*TK*UK*ANS/(2*S*4*3*8)
      FQG = ANS
      ENDIF
      RETURN
      END


c
c       This function subroutine, Q4G1M, calculates the
c       invariant matrix element squared for the process:
c
c       Q(-p1) + Qbar(-p2) --> q(p3) + qbar(p4) + g(p5)
C
c       summed over initial and final spins and colors including
c       masses for the incoming quark-antiquark pair.
c       The final state quark-antiquark pair are massless.
c       No averaging is performed for initial spins or colors.
c
c
c       1.      p1...p5 are the outgoing four momenta of the
c               partons, satisfying
c                       p1 + p2 + p3 + p4 + p5 = 0
c
c       2.      xm2 is the mass^2 of the heavy Quark and AntiQuark lines
c               with
c                       p1**2 = p2**2 = xm2
c               where
c                       pi**2 = pi(4)**2-pi(1)**2-pi(2)**2-pi(3)**2
c
c Abbiamo:
c             p12 = p1(4)*p2(4)-p1(1)*p2(1)-p1(2)*p2(2)-p1(3)*p2(3)
c             etc...
c
c Per il processo
c       Q(-p1) + Qbar(-p2) --> q(p3) + qbar(p4) + g(p5)
c chiamare
c       Q4G1M(XM2,P12,P13,P14,P15,P23,P24,P25,P34,P35,P45)*g**6/4/N**2
c
c Per
c       q(-p1) + qbar(-p2) --> Q(p3) + Qbar(p4) + g(p5)
c che equivarrebbe a
c       Q(-p4)+Qbar(-p3) --> q(p2)+qbar(p1)+g(p5)
c chiamare
c       Q4G1M(XM2,P34,P24,P14,P45,P23,P13,P35,P12,P25,P15)*g**6/4/N**2
c
c

      FUNCTION  Q4G1M(XM2,P12,P13,P14,P15,P23,P24,P25,P34,P35,P45)
      REAL*8  DL1, DL2, DL3, DL4
      REAL*8  P12, P13, P14, P15, P23, P24, P25, P34, P35, P45
      REAL*8  Q4G1M, XM2, RES, S, XN, XV
      PARAMETER         (XN = 3.D0)

      XV  = XN**2 - 1
      S = 2*(P12+XM2)

      DL1 = P13/P25-2*P35/S
      DL2 = P14/P25-2*P45/S
      DL3 = P23/P15-2*P35/S
      DL4 = P24/P15-2*P45/S


      RES =
     & +(P13**2+P23**2+P14**2+P24**2+XM2*(P12+P34+XM2))/2/S/P34
     & *(4*XV**2/XN*(P13/P15/P35+P24/P25/P45)
     & +4*XV/XN*(2*P14/P15/P45+2*P23/P25/P35
     & -P13/P15/P35-P24/P25/P45-P12/P15/P25-P34/P35/P45) )

      RES = RES
     & -XV*(XN**2-4)/XN
     & *2*XM2/S/P34*((P13-P14)/P25-(P23-P24)/P15)
     & +4*XV**2/XN*XM2*( (P35**2+P45**2)/P35/P45/S**2
     & -0.5*(1/P15+1/P25+1/P35+1/P45)/S
     & -0.25*(1/P15+1/P25+XM2/P15**2+XM2/P25**2+4/S)/P34
     & -(DL1**2+DL2**2+DL3**2+DL4**2)/4/P34**2)
     & -2*XV/XN
     & *XM2/S/P34*(1+2*P34/S+XM2/P15+XM2/P25+(P35**2+P45**2)/P15/P25
     & +(P13-P14)*(DL1-DL2)/P34+(P23-P24)*(DL3-DL4)/P34 )

      Q4G1M = RES


      RETURN
      END

      function qqqq2(s,t,m2,mu2,nl)
c
c     q(p1) + q_bar(p2) --> Q(k1) + Q_bar(k2)
c
c     t = (p1-k1)^2
c
      implicit double precision (a-z)
      integer nl
      character * 2 schhad1,schhad2
      common/betfac/betfac,delta
      common/scheme/schhad1,schhad2
      data pi/3.141 592 653 589 793/
      ro = 4*m2/s
      t1 = -t/s
      zg = 1
      vn = 3
      vca = 3
      vcf = 4
      vcf = vcf/ 3.d0
      vtf = 1
      vtf = vtf/ 2.d0
      vda = 8
      vbf = -(vn**2-4)*(vn**2-1)/( 16.d0*vn)
      nlf = nl
      t2 = 1-t1
      b = dsqrt(1-ro)
      lp = (b+1)/ 2.d0
      lm = (1-b)/ 2.d0
      at = s*t1
      aw = s*t2
      vlm2 = dlog(m2/mu2)
      vltm = dlog(at/m2)
      vlpm = dlog(lp/lm)
      vlsm = dlog(s/m2)
      vlsmu = dlog(s/mu2)
      vlwm = dlog(aw/m2)
      vlbl = dlog(b/lm)
      vdw = ddilog((aw-m2)/aw)-vlwm**2/ 2.d0
      vdt = ddilog((at-m2)/at)-vltm**2/ 2.d0
      vdmp = ddilog(-lm/lp)
      vdmb = vlbl**2/ 2.d0+ddilog(-lm/b)
      auinv = 1/(m2-aw)
      atinv = 1/(m2-at)
      softt1 = ddilog(1-2*t1/(b+1))+ddilog(1-2*t1/(1-b))+log(2*t1/(1-b))
     1   *log(2*t1/(b+1))
      softt2 = ddilog(1-2*t2/(b+1))+ddilog(1-2*t2/(1-b))+log(2*t2/(1-b))
     1   *log(2*t2/(b+1))
      softb = ddilog(2*b/(b+1))-ddilog(-2*b/(1-b))
      lt1 = log(t1)
      lt2 = log(t2)
      lb = log(b*betfac)
      ss = lb*(4*t1**2-4*t1+ro+2)*vlsmu*(vn-1)**2*(vn+1)**2*zg**6/(s*vn*
     1   *3)
      ss = 3*(4*t1**2-4*t1+ro+2)*vlsmu*(vn-1)**2*(vn+1)**2*zg**6/( 8.d0*
     1   s*vn**3)+ss
      ss = (4*t1**2-4*t1+ro+2)*vlsm**2*(vn-1)*(vn+1)*(3*vn**2-1)*zg**6/(
     1    8.d0*s*vn**3)+ss
      ss = (ro-2)*(4*t1**2-4*t1+ro+2)*vlpm*vlsm*(vn-1)*(vn+1)*zg**6/( 8.
     1   d0*b*s*vn**3)+ss
      ss = lt2*(4*t1**2-4*t1+ro+2)*vlsm*(vn-1)*(vn+1)*zg**6/(s*vn**3)+ss
      ss = lt1*(4*t1**2-4*t1+ro+2)*vlsm*(vn-1)*(vn+1)*(vn**2-2)*zg**6/(
     1   2.d0*s*vn**3)+ss
      ss = lb*(4*t1**2-4*t1+ro+2)*vlsm*(vn-1)*(vn+1)*zg**6/(s*vn)+ss
      ss = ss-vlsm*(vn-1)*(vn+1)*(20*t1**2*vn**2-20*t1*vn**2+5*ro*vn**2+
     1   2*vn**2-20*t1**2+20*t1-5*ro-6)*zg**6/( 8.d0*s*vn**3)
      ss = (4*t1**2-4*t1+ro+2)*vlpm**2*(vn-1)*(vn+1)*zg**6/( 8.d0*s*vn)+
     1   ss
      ss = lb*(ro-2)*(4*t1**2-4*t1+ro+2)*vlpm*(vn-1)*(vn+1)*zg**6/( 2.d0
     1   *b*s*vn**3)+ss
      ss = vlpm*(vn-1)*(vn+1)*(4*t1**2*vn**2-4*t1*vn**2+ro*vn**2+2*vn**2
     1   -4*t1**2+4*t1-4)*zg**6/( 4.d0*b*s*vn**3)+ss
      ss = softt2*(4*t1**2-4*t1+ro+2)*(vn-1)*(vn+1)*zg**6/(s*vn**3)+ss
      ss = softt1*(4*t1**2-4*t1+ro+2)*(vn-1)*(vn+1)*(vn**2-2)*zg**6/( 2.
     1   d0*s*vn**3)+ss
      ss = ss-(ro-2)*softb*(4*t1**2-4*t1+ro+2)*(vn-1)*(vn+1)*zg**6/( 8.d
     1   0*b*s*vn**3)
      ss = ss-pi**2*(4*t1**2-4*t1+ro+2)*(vn-1)**2*(vn+1)**2*zg**6/( 12.d
     1   0*s*vn**3)
      ss = 4*lb*lt2*(4*t1**2-4*t1+ro+2)*(vn-1)*(vn+1)*zg**6/(s*vn**3)+ss
      ss = 2*lt2*(vn-1)*(vn+1)*zg**6/(s*vn**3)+ss
      ss = 2*lb*lt1*(4*t1**2-4*t1+ro+2)*(vn-1)*(vn+1)*(vn**2-2)*zg**6/(s
     1   *vn**3)+ss
      ss = lt1*(vn-1)*(vn+1)*(vn**2-2)*zg**6/(s*vn**3)+ss
      ss = 2*lb**2*(4*t1**2-4*t1+ro+2)*(vn-1)**2*(vn+1)**2*zg**6/(s*vn**
     1   3)+ss
      ss = ss-lb*(4*t1**2-4*t1+ro+2)*(vn-1)**2*(vn+1)**2*zg**6/(s*vn**3)
      ss = ss-5*(vn-1)**2*(vn+1)**2*zg**6/( 4.d0*s*vn**3)
      dd = -2*pi*(8*t1**2-12*t1+ro+6)*vcf**2*vlsm*vlwm*(vca*vda*vtf**2+4
     1   *vbf)*zg**6/(s*vda**2*vtf**2)
      dd = 2*auinv*pi*(2*t1**2-2*t1+ro)*vcf**2*vlwm*(vca*vda*vtf**2+4*vb
     1   f)*zg**6/(vda**2*vtf**2)+dd
      dd = dd-8*pi*vcf**2*vlwm*(vca*vda*vtf**2+4*vbf)*zg**6/(s*vda**2*vt
     1   f**2)
      dd = dd-2*pi*(8*t1**2-4*t1+ro+2)*vcf**2*vlsm*vltm*(vca*vda*vtf**2-
     1   4*vbf)*zg**6/(s*vda**2*vtf**2)
      dd = 2*atinv*pi*(2*t1**2-2*t1+ro)*vcf**2*vltm*(vca*vda*vtf**2-4*vb
     1   f)*zg**6/(vda**2*vtf**2)+dd
      dd = dd-8*pi*vcf**2*vltm*(vca*vda*vtf**2-4*vbf)*zg**6/(s*vda**2*vt
     1   f**2)
      dd = dd-pi*vcf**2*vlsm**2*(16*t1**2*vcf*vda*vtf**2-16*t1*vcf*vda*v
     1   tf**2+4*ro*vcf*vda*vtf**2+8*vcf*vda*vtf**2-16*t1**2*vca*vda*vtf
     2   **2+16*t1*vca*vda*vtf**2-3*ro*vca*vda*vtf**2-8*vca*vda*vtf**2+1
     3   6*t1*vbf-8*vbf)*zg**6/(s*vda**2*vtf**2)
      dd = dd-4*pi*(2*t1-1)*vcf**2*vlsm*(2*ro*t1*vca*vda*vtf**2-6*t1*vca
     1   *vda*vtf**2-ro*vca*vda*vtf**2+5*vca*vda*vtf**2+4*vbf)*zg**6/(b*
     2   *2*s*vda**2*vtf**2)
      dd = dd-2*pi*(12*t1**2+8*ro*t1-20*t1-3*ro+6)*vca*vcf**2*vlsm*zg**6
     1   /(b**4*s*vda)
      dd = 4*pi*vcf**2*vlsm*(16*nlf*t1**2*vtf-16*nlf*t1*vtf+4*nlf*ro*vtf
     1   +8*nlf*vtf+36*t1**2*vcf-36*t1*vcf+9*ro*vcf+6*vcf-44*t1**2*vca+4
     2   4*t1*vca-8*ro*vca-16*vca)*zg**6/( 3.d0*s*vda)+dd
      dd = dd-pi*vcf**2*vlpm**2*(8*ro*t1**2*vcf*vda*vtf**2-16*t1**2*vcf*
     1   vda*vtf**2-8*ro*t1*vcf*vda*vtf**2+16*t1*vcf*vda*vtf**2+2*ro**2*
     2   vcf*vda*vtf**2-8*vcf*vda*vtf**2-4*ro*t1**2*vca*vda*vtf**2-8*t1*
     3   *2*vca*vda*vtf**2+2*ro*t1*vca*vda*vtf**2+14*t1*vca*vda*vtf**2-r
     4   o**2*vca*vda*vtf**2-6*vca*vda*vtf**2-8*ro*t1*vbf+24*t1*vbf+4*ro
     5   *vbf-16*vbf)*zg**6/(b*s*vda**2*vtf**2)
      dd = pi*(2*t1+ro-2)*vcf**2*vlpm**2*(2*ro*t1*vca*vda*vtf**2-6*t1*vc
     1   a*vda*vtf**2-ro*vca*vda*vtf**2+5*vca*vda*vtf**2+4*vbf)*zg**6/(b
     2   **3*s*vda**2*vtf**2)+dd
      dd = pi*(4*ro*t1**2+8*t1**2+4*ro*t1-16*t1+3*ro**2-8*ro+8)*vca*vcf*
     1   *2*vlpm**2*zg**6/( 2.d0*b**5*s*vda)+dd
      dd = 4*b*pi*(ro+2)*vcf**2*vlpm*(8*t1**2*vtf-8*t1*vtf+2*ro*vtf+4*vt
     1   f+6*vcf-3*vca)*zg**6/( 3.d0*s*vda)+dd
      dd = dd-2*pi*(8*ro*t1**2-12*t1**2-8*ro*t1+12*t1-ro+2)*vcf**2*(2*vc
     1   f-vca)*vlpm*zg**6/(b*s*vda)
      dd = 4*pi*(4*t1**2-4*t1+ro+2)*vcf**2*vlm2*(4*nlf*vtf-11*vca)*zg**6
     1   /( 3.d0*s*vda)+dd
      dd = 2*pi*(4*t1+ro-2)*vcf**2*vdw*(vca*vda*vtf**2+4*vbf)*zg**6/(s*v
     1   da**2*vtf**2)+dd
      dd = dd-2*pi*(4*t1-ro-2)*vcf**2*vdt*(vca*vda*vtf**2-4*vbf)*zg**6/(
     1   s*vda**2*vtf**2)
      dd = 8*pi*vcf**2*vdmp*(8*t1**2*vca*vda*vtf**2+ro*t1*vca*vda*vtf**2
     1   -11*t1*vca*vda*vtf**2+5*vca*vda*vtf**2+4*ro*t1*vbf-12*t1*vbf-2*
     2   ro*vbf+8*vbf)*zg**6/(b*s*vda**2*vtf**2)+dd
      dd = 4*pi*(2*t1+ro-2)*vcf**2*vdmp*(2*ro*t1*vca*vda*vtf**2-6*t1*vca
     1   *vda*vtf**2-ro*vca*vda*vtf**2+5*vca*vda*vtf**2+4*vbf)*zg**6/(b*
     2   *3*s*vda**2*vtf**2)+dd
      dd = 2*pi*(4*ro*t1**2+8*t1**2+4*ro*t1-16*t1+3*ro**2-8*ro+8)*vca*vc
     1   f**2*vdmp*zg**6/(b**5*s*vda)+dd
      dd = 4*pi*(ro-2)*(4*t1**2-4*t1+ro+2)*vcf**2*(2*vcf-vca)*vdmb*zg**6
     1   /(b*s*vda)+dd
      dd = dd-2*pi**3*vcf**2*(16*ro*t1**2*vcf*vda*vtf**2-32*t1**2*vcf*vd
     1   a*vtf**2-16*ro*t1*vcf*vda*vtf**2+32*t1*vcf*vda*vtf**2+4*ro**2*v
     2   cf*vda*vtf**2-16*vcf*vda*vtf**2-8*ro*t1**2*vca*vda*vtf**2+8*t1*
     3   *2*vca*vda*vtf**2+7*ro*t1*vca*vda*vtf**2-5*t1*vca*vda*vtf**2-2*
     4   ro**2*vca*vda*vtf**2+3*vca*vda*vtf**2-4*ro*t1*vbf+12*t1*vbf+2*r
     5   o*vbf-8*vbf)*zg**6/( 3.d0*b*s*vda**2*vtf**2)
      dd = dd-4*pi*(ro-1)*vcf**2*(2*vcf-vca)*zg**6/(b**2*s*vda)
      dd = pi**3*(2*t1+ro-2)*vcf**2*(2*ro*t1*vca*vda*vtf**2-6*t1*vca*vda
     1   *vtf**2-ro*vca*vda*vtf**2+5*vca*vda*vtf**2+4*vbf)*zg**6/( 3.d0*
     2   b**3*s*vda**2*vtf**2)+dd
      dd = dd-4*pi*(ro-1)*(2*t1-1)**2*vca*vcf**2*zg**6/(b**4*s*vda)
      dd = pi**3*(4*ro*t1**2+8*t1**2+4*ro*t1-16*t1+3*ro**2-8*ro+8)*vca*v
     1   cf**2*zg**6/( 6.d0*b**5*s*vda)+dd
      dd = dd-pi*vcf**2*(192*ro*t1**2*vda*vtf**3+320*nlf*t1**2*vda*vtf**
     1   3+320*t1**2*vda*vtf**3-192*ro*t1*vda*vtf**3-320*nlf*t1*vda*vtf*
     2   *3-320*t1*vda*vtf**3+48*ro**2*vda*vtf**3+80*nlf*ro*vda*vtf**3+1
     3   76*ro*vda*vtf**3+160*nlf*vda*vtf**3+160*vda*vtf**3-192*pi**2*t1
     4   **2*vcf*vda*vtf**2+1728*t1**2*vcf*vda*vtf**2+192*pi**2*t1*vcf*v
     5   da*vtf**2-1728*t1*vcf*vda*vtf**2-48*pi**2*ro*vcf*vda*vtf**2+432
     6   *ro*vcf*vda*vtf**2-96*pi**2*vcf*vda*vtf**2+576*vcf*vda*vtf**2+7
     7   2*pi**2*t1**2*vca*vda*vtf**2-1216*t1**2*vca*vda*vtf**2-72*pi**2
     8   *t1*vca*vda*vtf**2+1216*t1*vca*vda*vtf**2+21*pi**2*ro*vca*vda*v
     9   tf**2-304*ro*vca*vda*vtf**2+36*pi**2*vca*vda*vtf**2-680*vca*vda
     :   *vtf**2+48*pi**2*t1*vbf-24*pi**2*vbf)*zg**6/( 9.d0*s*vda**2*vtf
     ;   **2)
      qqqq2 = ss+dd/( 4.d0*pi)
      if(schhad1.eq.'DI')then
           one = 1
           xk = xkdqq(nl) + 2*xkpqq(one,nl)*lb + 2*xklqq(one,nl)*lb**2
           xk = xk*16*pi**2
           qqqq2 = qqqq2 - xk*qqborn(s,t,m2)/(8*pi**2)
      elseif(schhad1.ne.'MS')then
           write(6,*)'scheme ',schhad1,'not known'
           stop
      endif
      if(schhad2.eq.'DI')then
           one = 1
           xk = xkdqq(nl) + 2*xkpqq(one,nl)*lb + 2*xklqq(one,nl)*lb**2
           xk = xk*16*pi**2
           qqqq2 = qqqq2 - xk*qqborn(s,t,m2)/(8*pi**2)
      elseif(schhad2.ne.'MS')then
           write(6,*)'scheme ',schhad2,'not known'
           stop
      endif
      return
      end



      function qgqq2(s,t,m2,nl)
c
c     q(p1) + g(p2) --> Q(k1) + Q_bar(k2)
c
c     t = (p1-k1)^2
c
      implicit double precision (a-z)
      integer nl
      character * 2 schhad1,schhad2
      common/betfac/betfac,delta
      common/scheme/schhad1,schhad2
      data pi/3.141 592 653 589 793/
      qgqq2 = 0
      if(schhad1.eq.'DI')then
           one = 1
           ro = 4*m2/s
           b  = sqrt(1-ro)
           lb = log(b*betfac)
           xk = xkdgq(nl) + 2*xkpgq(one,nl)*lb + 2*xklgq(one,nl)*lb**2
           xk = xk*16*pi**2
           qgqq2 = qgqq2 - xk*ggborn(s,t,m2)/(8*pi**2)
      elseif(schhad1.ne.'MS')then
           write(6,*)'scheme ',schhad1,'not known'
           stop
      endif
      if(schhad2.eq.'DI')then
           one = 1
           ro = 4*m2/s
           b  = sqrt(1-ro)
           lb = log(b*betfac)
           xk = xkdqg(nl) + 2*xkpqg(one,nl)*lb + 2*xklqg(one,nl)*lb**2
           xk = xk*16*pi**2
           qgqq2 = qgqq2 - xk*qqborn(s,t,m2)/(8*pi**2)
      elseif(schhad2.ne.'MS')then
           write(6,*)'scheme ',schhad2,'not known'
           stop
      endif
      return
      end

c
c Transformation functions from MS_bar scheme to
c scheme of DFLM.
c
      function xkpqq(x,nl)
      implicit double precision (a-z)
      parameter (fot=4/3.d0)
      integer nl
      xkpqq = fot*(-1.5d0-(1+x**2)*log(x)+(1-x)*(3+2*x))
      return
      end

      function xkdqq(nl)
      implicit double precision (a-z)
      parameter (fot=4/3.d0)
      integer nl
      data pi/3.141 592 653 589 793/
      xkdqq = -fot*(4.5d0 + pi**2/3)
      return
      end

      function xklqq(x,nl)
      implicit double precision (a-z)
      parameter (fot=4/3.d0)
      integer nl
      xklqq = fot*(1+x**2)
      return
      end

      function xkpqg(x,nl)
      implicit double precision (a-z)
      integer nl
      xkpqg = (1-x)*(-(x**2+(1-x)**2)*log(x)+8*x*(1-x)-1)/2
      return
      end

      function xkdqg(nl)
      implicit double precision (a-z)
      integer nl
      xkdqg = 0
      return
      end

      function xklqg(x,nl)
      implicit double precision (a-z)
      integer nl
      xklqg = (1-x)*(x**2+(1-x)**2)/2
      return
      end

      function xkdgg(nl)
      implicit double precision (a-z)
      integer nl
      xkdgg = - 2 * nl * xkdqg(nl)
      return
      end

      function xkpgg(x,nl)
      implicit double precision (a-z)
      integer nl
      xkpgg = - 2 * nl * xkpqg(x,nl)
      return
      end

      function xklgg(x,nl)
      implicit double precision (a-z)
      integer nl
      xklgg = - 2 * nl * xklqg(x,nl)
      return
      end

      function xkdgq(nl)
      implicit double precision (a-z)
      integer nl
      xkdgq = - xkdqq(nl)
      return
      end

      function xkpgq(x,nl)
      implicit double precision (a-z)
      integer nl
      xkpgq = - xkpqq(x,nl)
      return
      end

      function xklgq(x,nl)
      implicit double precision (a-z)
      integer nl
      xklgq = - xklqq(x,nl)
      return
      end

c
c Fit to heavy quark partonic total production cross section.
c The cross section is:
c
c  A)  g+g --> Q+Qb
c  sigg(ro) = as^2/M^2*(f0gg(ro)+g^2*(f1gg(ro)+fbgg(ro)*log(mu^2/M^2);
c
c  B)  q+g --> Q+Qb
c  siqg(ro) = as^2/M^2*(g^2*(f1qg(ro)+fbqg(ro)*log(mu^2/M^2);
c
c  C)  q+qb --> Q+Qb
c  siqq(ro) = as^2/M^2*(f0qq(ro)+g^2*(f1qq(ro)+fbqq(ro)*log(mu^2/M^2);
c
c  with g^2 = 4*pi*as, ro = 4*M^2/s, s is the partonic CM energy,
c  M is the heavy quark mass.
c  The symbols are: g for gluon, q for light quark,
c  qb for light antiquark, Q for heavy quark, Qb for heavy antiquark.
c
c  All above is in ms_bar. For the DFLM scheme, use f1qqp,f1ggp and f1qgp
c  instead of f1qq,f1qg,f1gg.
c  The functions cqqq and cqqg are the corrections to apply to f1qq and
c  f1qg due to a redefinition of the quark according to the DIS scheme.
c  cgqg and cggg are the corrections to apply to f1qg and f1gg due to
c  a redefinition of the gluon according to the DFLM group.
c
c  The ratio of the fits to the numerically integrated results is
c  well within 1% of accuracy.
c
      function f1qqp(rho)
      implicit real * 8 (a-h,o-z)
      f1qqp = f1qq(rho)+cqqq(rho)
      end

      function f1qgp(rho)
      implicit real * 8 (a-h,o-z)
      f1qgp = f1qg(rho)+cqqg(rho)+cgqg(rho)
      end

      function f1ggp(rho)
      implicit real * 8 (a-h,o-z)
      f1ggp = f1gg(rho)+cggg(rho)
      end

      function f0qq(rho)
      implicit real * 8 (a-h,o-z)
      parameter(pi=3.14159265358979312D0)
      b = sqrt(1-rho)
      f0qq = (pi*b*rho)/27*(2+rho)
      end

      function f0gg(rho)
      implicit real * 8 (a-h,o-z)
      parameter(pi=3.14159265358979312D0)
      b = sqrt(1-rho)
      f0gg = (pi*b*rho)/192*(1/b*(rho**2+16*rho+16)*log((1+b)/(1-b))
     #         -28-31*rho)
      end

      function fbqq(rho)
      implicit real * 8 (a-h,o-z)
      parameter(pi=3.14159265358979312D0)
      parameter(pi2=pi*pi)
      common/nl/nl
      b = sqrt(1-rho)
      b2 = b*b
      fbqq = 1/(8*pi2)*( (16*pi)/81 * rho*log((1+b)/(1-b))
     #           + f0qq(rho)/9 * (127-6*nl+48*log(rho/(4*b2))) )
      end

      function fbgg(rho)
      implicit real * 8 (a-h,o-z)
      parameter(pi=3.14159265358979312D0)
      parameter(pi2=pi*pi)
      common/nl/nl
      rho2 = rho*rho
      b = sqrt(1-rho)
      b2 = b*b
      h1 = log((1+b)/2)**2-log((1-b)/2)**2
     #     +2*ddilog((1+b)/2)-2*ddilog((1-b)/2)
      h2 = ddilog(2*b/(1+b))-ddilog(-2*b/(1-b))
      fbgg = 1/(8*pi2)*( pi/192 * (
     #   2*rho * (59*rho2+198*rho-288) * log((1+b)/(1-b)) +
     #   12*rho * (rho2+16*rho+16)*h2 - 6*rho * (rho2-16*rho+32)*h1
     #   -(4*b)/15*(7449*rho2-3328*rho+724)
     #   ) + 12*f0gg(rho)*log(rho/(4*b2)) )
      end

      function fbqg(rho)
      implicit real * 8 (a-h,o-z)
      parameter(pi=3.14159265358979312D0)
      parameter(pi2=pi*pi)
      common/nl/nl
      rho2 = rho*rho
      b = sqrt(1-rho)
      b2 = b*b
      h1 = log((1+b)/2)**2-log((1-b)/2)**2
     #     +2*ddilog((1+b)/2)-2*ddilog((1-b)/2)
      h2 = ddilog(2*b/(1+b))-ddilog(-2*b/(1-b))
      fbqg = 1/(8*pi2) * pi/192 * (
     #   (4*rho)/9 * (14*rho2+27*rho-136) * log((1+b)/(1-b)) -
     #   (32*rho)/3*(2-rho)*h1 - (8*b)/135 * (1319*rho2-3468*rho+724)
     #  )
      end

      function f1qq(rho)
      implicit real * 8 (a-h,o-z)
      parameter(pi=3.14159265358979312D0)
      parameter(pi2=pi*pi)
      common/nl/nl
      data a0,a1,a2,a3,a4,a5,a6,a7
     # / 0.180899d0,  0.101949d0, -0.234371d0, -0.0109950d0,
     #  -0.0185575d0, 0.00907527,  0.0160367,   0.00786727/
      rho2 = rho*rho
      b = sqrt(1-rho)
      b2 = b*b
      b4 = b2*b2
      b6 = b4*b2
      xlb = log(8*b2)
      xlrh = log(rho)
      f1qq =
     # rho/(72*pi)*( (16*b)/3*xlb**2-(82*b)/3*xlb-pi2/6)
     # +b*rho*( a0 + b2*(a1*xlb+a2) + b4*(a3*xlb+a4) + a5*b6*xlb
     #         + a6*xlrh + a7*xlrh**2 )
     # + 1/(8*pi2) * (nl-4) * f0qq(rho)*(2.d0/3*log(4/rho)-10.d0/9)
      end

      function f1gg(rho)
      implicit real * 8 (a-h,o-z)
      parameter(pi=3.14159265358979312D0)
      parameter(pi2=pi*pi)
      common/nl/nl
      data a0,a1,a2,a3,a4,a5,a6,a7
     # / 0.108068d0,  -0.114997d0,  0.0428630d0, 0.131429d0,
     #   0.0438768d0, -0.0760996d0,-0.165878d0, -0.158246d0/
      rho2 = rho*rho
      b = sqrt(1-rho)
      b2 = b*b
      b4 = b2*b2
      b6 = b4*b2
      xlb = log(8*b2)
      xlrh = log(rho)
      f1gg =
     # 7/(1536*pi)*( 12*b*xlb**2-(366*b)/7*xlb+(11*pi2)/42)
     # +b*( a0 + b2*(a1*xlb+a2) + b4*a3*xlb + rho2*(a4*xlrh+a5*xlrh**2)
     # + rho*(a6*xlrh+a7*xlrh**2) )
     # + rho2/(1024*pi) * (nl-4) * (log((1+b)/(1-b))-2*b)
      end

      function f1qg(rho)
      implicit real * 8 (a-h,o-z)
      parameter(pi=3.14159265358979312D0)
      parameter(pi2=pi*pi)
      common/nl/nl
      data a0,a1,a2,a3,a4,a5,a6,a7
     # / 0.0110549d0,  -0.426773d0,  -0.00103876d0, 0.450626d0,
     #  -0.227229d0,    0.0472502d0, -0.197611d0,  -0.0529130d0/
      rho2 = rho*rho
      b = sqrt(1-rho)
      b2 = b*b
      b4 = b2*b2
      b6 = b4*b2
      xlb = log(b)
      xlrh = log(rho)
      f1qg =
     #  b*( b2*(a0*xlb+a1) + b4*(a2*xlb+a3) + rho2*(a4*xlrh+a5*xlrh**2)
     # + rho*(a6*xlrh+a7*xlrh**2) )
      end

      function cqqq(rho)
      implicit real * 8 (a-h,o-z)
      parameter(pi=3.14159265358979312D0)
      parameter(pi2=pi*pi)
      common/nl/nl
      rho2 = rho*rho
      b = sqrt(1-rho)
      b2 = b*b
      h2 = ddilog(2*b/(1+b))-ddilog(-2*b/(1-b))
      xlrob2 = log(rho/(4*b2))
      cqqq = 1/(8*pi2) * (8.d0/3.d0*f0qq(rho)*
     # (13.d0/18.d0+2*pi2/3-xlrob2**2-25.d0/6*xlrob2)
     # +8.d0/3*(pi*rho)/27*(7.d0/3*b-2*(4+xlrob2 )
     # *log((1+b)/(1-b))-2*h2) )
      end

      function cqqg(rho)
      implicit real * 8 (a-h,o-z)
      parameter(pi=3.14159265358979312D0)
      parameter(pi2=pi*pi)
      common/nl/nl
      rho2 = rho*rho
      b = sqrt(1-rho)
      b2 = b*b
      h2 = ddilog(2*b/(1+b))-ddilog(-2*b/(1-b))
      xlrob2 = log(rho/(4*b2))
      xlbp1  = log((1+b)/(1-b))
      cqqg = 1/(8*pi2)*(pi*rho)/27*(
     #  (1-3*rho2/4)*(h2+xlbp1 *xlrob2 ) +
     # b*(13.d0/6*rho-8.d0/3)*xlrob2
     # -3*rho2*xlbp1 +b*(115*rho/9-70.d0/9) )
      end

      function cggg(rho)
      implicit real * 8 (a-h,o-z)
      parameter(pi=3.14159265358979312D0)
      parameter(pi2=pi*pi)
      common/nl/nl
c chisquare=  0.2949500883595510
      data a0,a1,a2,a3,a4,a5,a6,a7
     #/-1.2987168754095587D-03, -9.6976043812505796D-03
     #, 2.7173207835442481D-02, -1.6568156284241256D-02
     #,-1.2852283894558339D-02, -3.8494419116341811D-03
     #,-1.0828640684513157D-03,  1.6428466771704755D-03/
      rho2 = rho*rho
      rho3 = rho*rho2
      b = sqrt(1-rho)
      b2 = b*b
      b4 = b2*b2
      xlrh = log(rho)
      cggg = nl*b2*rho*(a0*rho3+a1*b2*rho3+a2*b4*rho3+a3*b2
     #  +a4*b2*xlrh+a5*b2*xlrh**2+a6*b2*xlrh**3+a7*b2*rho*xlrh**2)
      end

      function cgqg(rho)
      implicit real * 8 (a-h,o-z)
      parameter(pi=3.14159265358979312D0)
      parameter(pi2=pi*pi)
      common/nl/nl
c chisquare=  0.3084278592622398
      data a0,a1,a2,a3,a4,a5,a6,a7
     #/ 3.8596216074859431D-03, 4.9522213636822912D-02
     #,-9.1583774142403212D-02, 2.9094012063027844D-02
     #,-4.1378041486677086D-03, 2.6131355402790908D-03
     #,-7.5785107186006094D-04,-1.3395653263722391D-02/
      rho2 = rho*rho
      rho3 = rho*rho2
      b = sqrt(1-rho)
      b2 = b*b
      b4 = b2*b2
      xl2b = log(2*b)
      xlrh = log(rho)
      cgqg = -f0gg(rho)/(36*pi2)*(4*pi2-24*xl2b**2+66*xl2b-39)
     #     +b2*rho*(a0*rho3+a1*b2*rho3+a2*b4*rho3+a3*b2
     #     +a4*b2*xlrh+a5*b2*xlrh**2+a6*b2*xlrh**3+a7*b2*rho*xlrh**2)
      end

      function bbgg(rho)
      implicit real * 8 (a-h,o-z)
      parameter(pi=3.14159265358979312D0)
      parameter(pi2=pi*pi)
      parameter (vca=3.d0)
      parameter (vtf=0.5d0)
      common/nl/nl
      b0 = (11*vca-4*vtf*nl)/(12*pi)
      bbgg = fbgg(rho)-b0/(2*pi)*f0gg(rho)
      bbgg = bbgg/2.d0
      end

      function bbqq(rho)
      implicit real * 8 (a-h,o-z)
      parameter(pi=3.14159265358979312D0)
      parameter(pi2=pi*pi)
      parameter (vca=3.d0)
      parameter (vtf=0.5d0)
      common/nl/nl
      b0 = (11*vca-4*vtf*nl)/(12*pi)
      bbqq = fbqq(rho)-b0/(2*pi)*f0qq(rho)
      bbqq = bbqq/2.d0
      end

      function bbqg(rho)
      implicit real * 8 (a-h,o-z)
      parameter(pi=3.14159265358979312D0)
      parameter(pi2=pi*pi)
      parameter (vtf=0.5d0)
      b = sqrt(1-rho)
      vlpm = log((1+b)/(1-b))
      tmp = vtf*rho*( vlpm*(12-9*rho**2)+b*(26*rho-32) )/(1296*pi)
      bbqg = fbqg(rho)+tmp
      end
C
C End total cross section package
C
      subroutine invar
     #(xm2,s,x,y,cth1,th2,str,tk,uk,q1q,q2q,q1c,q2c,w1,w2,w1h,w2h)
c--------------------------------------------------------------------
c Dati s, le variabili x e y e i coseni degli angoli th1 e th2
c (cth1,cht2) INVAR calcola tk,uk,q1q,q2q,q1c,q2c,w1,w2.
c Inoltre calcola w1h e w2h, definiti da
c     w1 = w1h *s/2 *(1-x)
c     w2 = w2h *s/2 *(1-x).
c Gli angoli th1 e th2 sono definiti nel sistema di riposo della
c coppia Q Qbar.
c Gli assi sono presi in modo che p1,p2,k giacciano nel piano yz.
c Gli angoli psi,psi1,psi2 sono definiti da
c     p1 = p10*(1,0,spsi2,cpsi2)
c     p2 = p20*(1,0,spsi ,cpsi )
c     k  = k0 *(1,0,spsi1,cpsi1)
c Gli impulsi k1,k2 di Q e Qbar rispettivamente sono dati da
c     k1 = k10 (1, bx*sth2*sth1, bx*cth2*sth1, bx*cth1)
c     k2 = k20 (1,-bx*sth2*sth1,-bx*cth2*sth1,-bx*cth1)
c con k20=k10
c
c La variabile STR definisce l'orientazione dell'asse z nel piano
c degli impulsi p1,p2 e k:
c se str='p1', si sceglie p1 = p10 (1,0,0,1) (psi2 =0)
c se str='p2', si sceglie p2 = p20 (1,0,0,1) (psi  =0)
c se str='k ', si sceglie k  = k0  (1,0,0,1) (psi1 =0)
c se str='bi', si sceglie l'asse z perpendicolare alla bisettrice di p1-p2
c              p1(y)>0, p2(y)>0
c
c A partire dagli invarianti, INVAR calcola le rapidita' e gli impulsi
c trasversi delle paricelle nello stato finale, nel sistema del centro
c di massa.
c Gli impulsi traversi vengono messi nel COMMON/PERPEN/,
c e le rapidita' nel centro di massa in  COMMON/YCMVAR/.
      implicit none
      real * 8 xm2,s,x,y,cth1,th2,tk,uk,q1q,q2q,q1c,q2c,
     # w1,w2,w1h,w2h
      character * 2 str
      include 'invar-hvq.h'
      real * 8 s2,drs2,p10,p20,k0,k10,k20,bx,sth1,aaa,aap,aam,cpsi,cth2,
     1 sth2,spsi,cpsi2,spsi2,cpsi1,spsi1,xktsq,xkt1sq,xkt2sq,xx,aa,bb,cc
c
      cth2=cos(th2)
      sth2=sin(th2)
      tk  = -s/2*(1-x)*(1-y)
      uk  = -s/2*(1-x)*(1+y)
      s2  = tk+uk+s
      drs2 = 2*sqrt(s2)
      p10 = (s+tk)/drs2
      p20 = (s+uk)/drs2
      k0  = -(tk+uk)/drs2
      k10 = drs2/4
      k20 = drs2/4
      bx = sqrt(1-4*xm2/s2)
      sth1 = sqrt(1-cth1**2)
c
c aaa =  1 - s/(2*p10*p20)
c aam =  1 + tk/(2*p10*k0)
c aap =  1 + uk/(2*p20*k0)
c
      aaa = -1+(1-x)**2*(1-y)*(1+y)/(2*x+(1-x)**2*(1-y)*(1+y)/2)
      aap = 1-2*( (x*(1+y))/((1-y)+(x*(1+y)))  )
      aam = 1-2*( (x*(1-y))/((1+y)+(x*(1-y)))  )
      if(str.eq.'p1') then
         cpsi2 = 1
         spsi2 = 0
         cpsi  = aaa
         spsi  = sqrt(1-cpsi**2)
         cpsi1 = aam
         spsi1 = sqrt(1-cpsi1**2)
      elseif(str.eq.'k ') then
         cpsi1 = 1
         spsi1 = 0
         cpsi  = aap
         spsi  = -sqrt(1-cpsi**2)
         cpsi2 = aam
         spsi2 = sqrt(1-cpsi2**2)
      elseif(str.eq.'p2') then
         cpsi  = 1
         spsi  = 0
         cpsi1 = aap
         spsi1 = sqrt(1-cpsi1**2)
         cpsi2 = aaa
         spsi2 = sqrt(1-cpsi2**2)
      elseif(str.eq.'bi')then
c asse z perpendicolare alla bisettice dell'angolo tra p1 e p2 sul piano y-z
         cpsi2 = sqrt((1-aaa)/2)
         spsi2 = sqrt((1+aaa)/2)
         cpsi1 = (aam - aap)/(2*cpsi2)
         spsi1 = sqrt(1-cpsi1**2)
         cpsi  = -cpsi2
         spsi  = spsi2
      else
         write(6,*) 'error in invar: str=',str
         stop
      endif
      q1q = - 2*p10*k10*(1-bx*(cth2*sth1*spsi2+cth1*cpsi2))
      q2q = - 2*p20*k20*(1+bx*(cth2*sth1*spsi +cth1*cpsi ))
      q1c = - s - tk - q1q
      q2c = - s - uk - q2q
      w1  = - q1q + q2q - tk
      w2  = - q2q + q1q - uk
      w1h = 1-bx*(cth2*sth1*spsi1+cth1*cpsi1)
      w2h = 1+bx*(cth2*sth1*spsi1+cth1*cpsi1)
c-----------------------------------------------------------------
c Rapidita' e p_perp del Q, QB e del partone uscente
c
      yq1 = .5d0*log( q2c/q1q )
      yq2 = .5d0*log( q2q/q1c )
      if(tk.eq.0) then
         yp  = 1000000
      elseif(uk.eq.0) then
         yp  = -1000000
      else
         yp  = .5d0*log( uk/tk )
      endif
c-----------------------------------------------------------------
c xktsq, xkt1sq e xkt2sq sono i quadrati dei momenti traversi del partone,
c di Q e di QB. The frame is chosen with the y-axis along pq1-pq2 and
c the x-axis is such that pq1(1) = pq2(1) > 0 .
c
      xktsq   = uk*tk/s
      xkt1sq  = q2c*q1q/s - xm2
      xkt2sq  = q2q*q1c/s - xm2
      if(xktsq.eq.0) then
c Must be the smooth limit of the general case when
c aa > 0, bb=-aa, cc=0.
         pq1(1) = 0
         pq1(2) = sqrt(xkt1sq)
         pq2(1) = 0
         pq2(2) = -pq1(2)
         pp(1) = 0
         pp(2) = 0
      else
         xx = sqrt(2*(xkt1sq+xkt2sq) - xktsq)
         aa = ((xkt1sq-xkt2sq)/xx + xx)/2
         bb = aa-xx
         cc = sqrt(abs(xkt1sq - aa**2))
         pq1(1) = cc
         pq1(2) = aa
         pq2(1) = cc
         pq2(2) = bb
         pp(1) = -2*cc
         pp(2) = -aa-bb
         if(sth2.lt.0) then
            pq1(1)=-pq1(1)
            pq2(1)=-pq2(1)
            pp(1)=-pp(1)
         endif
      endif
      end
      subroutine increasecnt(string)
      implicit none
      character *(*) string
      integer maxnum
      parameter (maxnum=100)
      character * 100 keywords(maxnum)
      real * 8 counters(maxnum)
      integer ncounters
      common/ccounters/keywords,counters,ncounters
      integer ini,j
      data ini/0/
      save ini
      if(ini.eq.0) then
         ncounters=0
         ini=1
      endif
      do j=1,ncounters
         if(string.eq.keywords(j)) then
            counters(j)=counters(j)+1
            return
         endif
      enddo
c not found
      if(ncounters.eq.maxnum) then
         write(*,*) ' too many counters requested'
         stop
      endif
      ncounters=ncounters+1
      keywords(ncounters)=string
      counters(ncounters)=1
      end

      subroutine incrcntrs(string,k)
      implicit none
      integer k
      character *(*) string
      character * 20 line
      line=string
      line(17:)=' '
      write(line(17:),'(i4)') k
      call increasecnt(line)
      end

      subroutine incrcntrs2(string,j,k)
      implicit none
      integer j,k
      character *(*) string
      character * 20 line
      line=string
      line(17:)=' '
      write(line(13:),'(i4)') j
      write(line(17:),'(i4)') k
      call increasecnt(line)
      end

      subroutine printcnt(iun)
      implicit none
      integer iun
      integer maxnum
      parameter (maxnum=100)
      character * 100 keywords(maxnum)
      real * 8 counters(maxnum)
      integer ncounters
      common/ccounters/keywords,counters,ncounters
      integer j,k
      if(ncounters.eq.0) return
      write(iun,*)
      write(iun,*) 'Value of counters at end of run:'
      do j=1,ncounters
         k=100
 1       if(keywords(j)(k:k).eq.' ') then
            k=k-1
            goto 1
         endif
         write(iun,*) keywords(j)(1:k),' = ',counters(j)
      enddo
      write(iun,*)
      end

      function getcnt(string)
      implicit none
      real * 8 getcnt
      character *(*) string
      integer maxnum
      parameter (maxnum=100)
      character * 100 keywords(maxnum)
      real * 8 counters(maxnum)
      integer ncounters
      common/ccounters/keywords,counters,ncounters
      integer j
      do j=1,ncounters
         if(string.eq.keywords(j)) then
            getcnt=counters(j)
            return
         endif
      enddo
      getcnt=0
      end
c-------------------------------------------------------------------------
      subroutine strfun(x1,x2,sf)
c----------------------------------------------------------------------
c   Values returned : (a_ = q_bar_)
c   (NB: if k=-j, qj=ak, qk=aj)
c
c   prc = 'gg'  -->  sf(0) = g_h1(x1)*g_h2(x2), sf(j)=0 for j#0;
c
c   prc = 'qq'  -->  sf(j) = qj_h1(x1)*aj_h2(x2), j#0, sf(0)=0;
c
c   prc = 'qg', -->  sf(j) = qj_h1(x1)*g_h2(x2),  j#0, sf(0)=0;
c
c   prc = 'gq', -->  sf(j) = g_h1(x1)*aj_h2(x2),  j#0, sf(0)=0;
      implicit none
      character * 2 prc
      common/process/prc
      real*8 fh1x1(-6:6),fh2x2(-6:6)
      real * 8 x1,x2,sf
      dimension sf(-5:5)
      include 'fixvar-hvq.h'
      include 'strfun.h'
      real * 8 xmuf2h1, xmuf2h2
      integer j
      xmuf2h1=xmufct2
      xmuf2h2=xmufct2
c
      call genericpdf0(ndns1,ih1,xmuf2h1,x1,fh1x1)
      call genericpdf0(ndns2,ih2,xmuf2h2,x2,fh2x2)
c
      do j=-5,5
         sf(j)=0
      enddo
c
      if(prc.eq.'gg') then
         do j=-nl,nl
            if(j.eq.0) then
               sf(j) = fh1x1(0)*fh2x2(0)
            else
               sf(j)=0
            endif
         enddo
      elseif(prc.eq.'qq') then
         do j=-nl,nl
            if(j.ne.0) then
               sf(j) = fh1x1( j) * fh2x2(-j)
            else
               sf(j)=0
            endif
         enddo
      elseif(prc.eq.'qg') then
         do j=-nl,nl
            if(j.ne.0) then
               sf(j) = fh1x1(j) * fh2x2(0)
            else
               sf(j)=0
            endif
         enddo
         sf(0)=0
      elseif(prc.eq.'gq') then
         do j=-nl,nl
            if(j.ne.0) then
               sf(j) = fh1x1(0) * fh2x2(-j)
            else
               sf(j)=0
            endif
         enddo
      else
         write(*,*)'error: strfun, prc= ',prc
         stop
      endif
      end



c Front end to genericpdf; it stores the arguments and return values of
c the nrec most recent calls to genericpdf. When invoked it looks in the
c stored calls; if a match its found, its return value is used.
c In this framework it is found that nrec=8 would be enough.
c This provides a remarkable increase in spead (better than a factor of 3)
c when cteq6 pdf are used.
      subroutine genericpdf0(ns,ih,xmu2,x,fx)
      implicit none
      integer ns,ih
      real * 8 xmu2,x,fx(-6:6)
      integer nrec
      parameter (nrec=10)
      real * 8 oxmu2(nrec),ox(nrec),ofx(-6:6,nrec)
      integer ons(nrec),oih(nrec)
      integer irec
      save oxmu2,ox,ofx,ons,oih,irec
c set to impossible values to begin with
      data ox/nrec*-1d0/
      data irec/0/
      integer j,k
      do j=1,nrec
         if(x.eq.ox(j)) then
            if(xmu2.eq.oxmu2(j)) then
               if(ns.eq.ons(j).and.ih.eq.oih(j)) then
                  do k=-6,6
                     fx(k)=ofx(k,j)
                  enddo
                  return
               endif
            endif
         endif
      enddo
      irec=irec+1
      if(irec.gt.nrec) irec=1
      ons(irec)=ns
      oih(irec)=ih
      oxmu2(irec)=xmu2
      ox(irec)=x
      call genericpdf(ns,ih,xmu2,x,ofx(-6,irec))
c Flavour thresholds:
      if(xmu2.lt.25) then
         ofx(5,irec)=0
         ofx(-5,irec)=0
      endif
      if(xmu2.lt.2.25) then
         ofx(4,irec)=0
         ofx(-4,irec)=0
      endif
      do k=-6,6
         fx(k)=ofx(k,irec)
      enddo
      end



      
      

      subroutine physpar
      implicit none
      character * 2 scheme1,scheme2
      common/scheme/scheme1,scheme2
      include 'mathpar.h'
      include 'fixvar-hvq.h'
      include 'strfun.h'
      real * 8 ptminsq
      common/cptmin/ptminsq
      real * 8 betfac,delta
      common/betfac/betfac,delta
c the following is in the hvqcrsx common block
      integer nlhvq
      common/nl/nlhvq
      real * 8 xlam3,xlam4,xlam5,xlam6
      integer iret
      call genericpdfpar(ndns1,ih1,xlam,scheme1,iret)
      if(iret.ne.0) then
         write(*,*) ' error for pdf 1, iret=',iret
         stop
      endif
      call genericpdfpar(ndns2,ih2,xlam,scheme2,iret)
      if(iret.ne.0) then
         write(*,*) ' error for pdf 1, iret=',iret
         stop
      endif
      call lamvals(xlam,5,xlam3,xlam4,xlam5,xlam6)
      delta=2
      betfac=1
c number of light flavours
      if(xm2.lt.3**2) then
         nl = 3
         xlamnl=xlam3
      elseif(xm2.lt.10**2) then
         nl = 4
         xlamnl=xlam4
      else
         nl=5
         xlamnl=xlam5
      endif
c The generation of radiation will use alfas
c with xlam -> xlam * 1.569
c (see
c  %\cite{Catani:1990rr}
c  \bibitem{Catani:1990rr}
c  S.~Catani, B.~R.~Webber and G.~Marchesini,
c  %``QCD Coherent Branching And Semiinclusive Processes At Large X,''
c  Nucl.\ Phys.\ B {\bf 349} (1991) 635.
c  %%CITATION = NUPHA,B349,635;%%
      xlamc=xlam*1.569
      xlamnl=xlamnl*1.569
c
      ptminsq=xlamnl**2
      ptminsq=ptminsq*5
      nlhvq=nl
      end

      subroutine setscalesbb
c called by bbarra to set up renormalization and factorization scales
      implicit none
      real * 8 m2qq,yqq,ro,cth1
      common/vvars/m2qq,yqq,ro,cth1
      include 'fixvar-hvq.h'
      real * 8 pqsq,xmu2
      real * 8 powheginput
      real * 8 facscfact,renscfact
      external powheginput
      integer bbscalevar,ini
      data ini/0/
      save ini,bbscalevar,facscfact,renscfact
      if(ini.eq.0) then
         bbscalevar=powheginput('bbscalevar')
         facscfact=powheginput('facscfact')
         renscfact=powheginput('renscfact')
         ini=1
      endif
      if(bbscalevar.eq.1) then
c     In partonic cm: m2qq = 4 E_q^2, E_q^2=m2qq/4, pq^2=E_q^2-xm2
         pqsq=m2qq/4-xm2
         xmu2= xm2 + pqsq*(1-cth1**2)
      elseif(bbscalevar.eq.0) then
         xmu2=xm2
      else
         write(*,*) ' setscalesbb: bbscalevar invalid, ',bbscalevar
         stop
      endif
      xmufct2=xmu2*facscfact**2
      xmuren2=xmu2*renscfact**2
      end

      subroutine setscalesrad(ptsq)
c scales used by genrad
      real * 8 ptsq
      include 'fixvar-hvq.h'
c this cannot be changed; fixed by NLL Sudakov
      xmuren2=ptsq
c this can be changed by a factor O(1)
      xmufct2=max(2d0,ptsq)
      end
      subroutine uboundfct(fct,ix,iy)
      implicit none
      real * 8 fct
      real * 8 unorm
      common/cunorm/unorm
      integer jflborn
      common/cjflborn/jflborn
      real * 8 m2qq,yqq,ro,cth1
      common/vvars/m2qq,yqq,ro,cth1
      real * 8 xscaled,y,th2
      common/rvars/xscaled,y,th2
      real * 8 x
      common/xval/x
      real * 8 x1b,x2b
      common/x1x2born/x1b,x2b
      real * 8 unorms
      integer iymax,ixmax,idimunorm
      parameter (idimunorm=100)
      common/cunorms/unorms(-5:5,idimunorm,idimunorm),iymax,ixmax
      integer iy,ix
      include 'fixvar-hvq.h'
      if(max(iymax,ixmax).gt.idimunorm) then
         write(*,*) 'iymax,ixmax should be <=',idimunorm,
     #        ', are ',iymax,ixmax
         stop
      endif
      iy=abs(y)*iymax+1
      ix=log(1/x)/log(sh/(4*xm2))*ixmax+1
      if((iy.lt.1.or.iy.gt.iymax).or.(ix.lt.1.or.ix.gt.ixmax))then
         write(*,*)'iy,ix off limits, got ',iy,ix,
     #        ', should be <=',iymax,ixmax
         stop
      endif
      if(unorm.ne.0) then
         fct=unorms(jflborn,iy,ix)/unorm
      else
         fct=1
      endif
      end
      

      subroutine setunorm
      implicit none
      real * 8 m2qq,yqq,ro,cth1
      common/vvars/m2qq,yqq,ro,cth1
      include 'fixvar-hvq.h'
      real * 8 unorm
      common/cunorm/unorm
      real * 8 unorms
      integer iymax,ixmax,idimunorm
      parameter (idimunorm=100)
      common/cunorms/unorms(-5:5,idimunorm,idimunorm),iymax,ixmax
      integer jflborn
      common/cjflborn/jflborn
      integer iy,ix
      unorm=0
      do ix=1,ixmax
         do iy=1,iymax            
            unorm=max(unorm,unorms(jflborn,iy,ix))
         enddo
      enddo
      end

      subroutine maxunorm(xnorm)
      implicit none
      real * 8 m2qq,yqq,ro,cth1
      common/vvars/m2qq,yqq,ro,cth1
      include 'fixvar-hvq.h'
      real * 8 unorms
      real * 8 xscaled,y,th2
      common/rvars/xscaled,y,th2
      real * 8 x
      common/xval/x
      integer iymax,ixmax,idimunorm
      parameter (idimunorm=100)
      common/cunorms/unorms(-5:5,idimunorm,idimunorm),iymax,ixmax
      real * 8 xnorm
      integer jflborn
      common/cjflborn/jflborn
      integer iy,ix
      if(max(iymax,ixmax).gt.idimunorm) then
         write(*,*) 'iymax,ixmax should be <=',idimunorm,
     #        ', are ',iymax,ixmax
         stop
      endif
      iy=abs(y)*iymax+1
      ix=log(1/x)/log(sh/(4*xm2))*ixmax+1
      if((iy.lt.1.or.iy.gt.iymax).or.(ix.lt.1.or.ix.gt.ixmax))then
         write(*,*)'iy,ix off limits, got ',iy,ix,
     #        ', should be <=',iymax,ixmax
         stop
      endif
      unorms(jflborn,iy,ix)=max(xnorm,unorms(jflborn,iy,ix))
      end

      subroutine calcmaxrat
      implicit none
      integer j,ios
      real * 8 bbarra
      real * 8 xnorm
      real * 8 unorms
      integer iymax,ixmax,idimunorm
      parameter (idimunorm=100)
      common/cunorms/unorms(-5:5,idimunorm,idimunorm),iymax,ixmax
      external bbarra
      integer jflborn
      common/cjflborn/jflborn
      real * 8 m2qq,yqq,ro,cth1
      common/vvars/m2qq,yqq,ro,cth1
      real * 8 xscaled,y,th2
      common/rvars/xscaled,y,th2
      real * 8 x
      common/xval/x
      real * 8 x1b,x2b
      common/x1x2born/x1b,x2b
      character * 20 pwgprefix
      integer lprefix
      common/cpwgprefix/pwgprefix,lprefix
      real * 8 random, xmin,pi
      parameter (pi=3.141592653589793d0)
      real * 8 powheginput
      real * 8 xupbound
      integer nubound
      integer iy,ix,iymaxold,ixmaxold
      external powheginput
      nubound=powheginput('nubound')
      iymax=powheginput('iymax')
      ixmax=powheginput('ixmax')
      xupbound=powheginput('xupbound')
      if(nubound.eq.0) stop
      j=powheginput('use-old-ubound')
      if(j.eq.0) then
         open(unit=32,file=pwgprefix(1:lprefix)//'ubound.dat',
     #        status='old',iostat=ios)
         if(ios.eq.0) then
c iymax,ixmax will be overridden by iymaxold,ixmaxold if all goes well
            read(32,fmt=*,iostat=ios,end=10) iymaxold,ixmaxold
            do ix=1,ixmaxold
               read(32,fmt=*,iostat=ios,end=10)
               do iy=1,iymaxold
                  read(32,fmt=*,iostat=ios,end=10)
     #                 (unorms(j,iy,ix),j=-5,5)
               enddo
            enddo
 10         close(32)
         endif
         if(ios.eq.0) then
c all went well: override iymax,ixmax
            ixmax=ixmaxold
            iymax=iymaxold
            write(*,*)
     # ' normalization of upper bounding function for radiation',
     # ' successfully loaded'
            goto 998
         endif
      endif
      write(*,*)
      write(*,*)
     # ' POWHEG: computing normalization of upper'//
     # ' bounding function for radiation'
      do j=-5,5
         do iy=1,idimunorm
            do ix=1,idimunorm
               unorms(j,iy,ix)=0
            enddo
         enddo
      enddo
      do j=1,nubound
         call genbbarra
         call genjflborn
         y=2*random()-1
         th2=2*pi*random()
         call pwggetxmin(y,xmin)
         xscaled=random()
         x=(1-xmin)*xscaled+xmin
         call maxrat(xnorm)
         call maxunorm(xnorm)
      enddo
      open(unit=32,file=pwgprefix(1:lprefix)//'ubound.dat',
     #        status='unknown')
      write(32,*) iymax,ixmax
      do ix=1,ixmax
         write(32,*)
         do iy=1,iymax
            write(32,'(d10.4,10(1x,d10.4))') (unorms(j,iy,ix),j=-5,5)
         enddo
      enddo
      close(32)
 998  do ix=1,ixmax
         do iy=1,iymax
            do j=-5,5
               unorms(j,iy,ix)=unorms(j,iy,ix)*xupbound
            enddo
         enddo
      enddo
      end
      subroutine genptint
c tests the implementation of the generation of radiation
c It computes the integral of the R/B (real over born)
c times theta(pt2(r)-pt2) as a function of pt2,
c and then computes the negative exponent of the integral
c (which is the probability of no emission).
c It then computes the probability of radiation above a given pt cut.
c This is related to the no-emission probability (1-m the above).
c the two results are compared.
      implicit none
      real * 8 pi
      parameter (pi=3.141592653589793d0)
      integer ncalls,nbins
      parameter (ncalls=50000,nbins=40)
      include 'fixvar-hvq.h'
      integer jflborn
      common/cjflborn/jflborn
      real * 8 xmaxq
      parameter (xmaxq=0.9d0)
      real * 8 x
      common/xval/x
      real * 8 xscaled,y,th2
      common/rvars/xscaled,y,th2
      real * 8 m2qq,yqq,ro,cth1
      common/vvars/m2qq,yqq,ro,cth1
      real * 8 x1b,x2b
      common/x1x2born/x1b,x2b
      real * 8 ptminsq
      common/cptmin/ptminsq
      character * 20 pwgprefix
      integer lprefix
      common/cpwgprefix/pwgprefix,lprefix
      real * 8 xx(6),hist1(nbins),hist2(nbins)
      real * 8 xjacb,xjacl,xjacr,sigb,tk,uk,xk2,tot,xmin,x1,x2
      real * 8 qqgg,qqqq,qqqg,qqgq,qgrres(-5:5),gqrres(-5:5)
      integer j,k,ini
      data ini/0/
      real * 8 qqb,pt2,random
      external qqb,pt2,random
      save ini
      if(ini.eq.0) then
         open(unit=42,file=pwgprefix(1:lprefix)//'testsuda.top',
     #        status='unknown')
         ini=1
      endif
      do k=1,nbins
         hist1(k)=0
         hist2(k)=0
      enddo
      do j=1,ncalls
         x=random()
         y=1-2*random()
         th2=pi*random()
c Zero if out of range
         tk=-1d0/2*(1-x)*(1-y)
         uk=-1d0/2*(1-x)*(1+y)
         xk2=pt2()
         x1=x1b*sqrt((1+tk)/(1+uk)/x)
         x2=x2b*sqrt((1+uk)/(1+tk)/x)
         if(max(x1,x2).ge. xmaxq
     #           .or. xk2.lt.ptminsq) then
            tot=0
         else
            call qqr(qqgg,qqqq,qqqg,qqgq,qgrres,gqrres)
            sigb=qqb()
            if(sigb.ne.0) then
               tot=(qqgg+qqqq+qqqg+qqgq)*2*pi/sigb
            else
               tot=0
            endif
            do k=1,nbins
               if(log(xk2/ptminsq).gt.k*log(sh/ptminsq)/nbins) then
                  hist1(k)=hist1(k)+tot
               endif
            enddo
         endif
      enddo
      do j=1,ncalls
         call genptxy
         xk2=pt2()
         if(xk2.ge.ptminsq) then
            do k=1,nbins
               if(log(xk2/ptminsq).gt.k*log(sh/ptminsq)/nbins) then
                  hist2(k)=hist2(k)+1
               endif
            enddo
         endif
      enddo
      write(42,*) ' newplot'
      write(42,*) ' set scale x log'
      do k=1,nbins
         write(42,*) exp(k*log(sh/ptminsq)/nbins)*ptminsq,
     #                   exp(-hist1(k)/ncalls)
      enddo
      write(42,*) ' join'
      do k=1,nbins
         write(42,*) exp(k*log(sh/ptminsq)/nbins)*ptminsq,
     #                   1-hist2(k)/ncalls
      enddo
      write(42,*) ' join dashes'
      end
      
      subroutine ttdecay
c From a : parton parton -> t tbar
c      or: parton parton -> t tbar parton
c event on the Les Houches interface, add the t-tbar decay
c products on the Les Houches interface.
c The products of W decays are decided by the subroutine
c pickwdecays(iwp1,mdecwp1,iwp2,mdecwp2,iwm1,mdecwm1,iwm2,mdecwm2)
c that returns the pdg codes and masses of the decay products of the w+
c and w-.
      implicit none
      include 'LesHouches.h'
c Momenta in our (p1,p2,p3,E) and Madvent (E,p1,p2,p3) convention
      real * 8 pp(4,9),pps(4,9),ppss(4,9),pme(0:3,9)
c Madevent parameters
      include 'MEcoupl.inc'
      real * 8 beta(3),betacm(3)
      integer itop,itbr,ijet,j,k,iwp,iwp1,iwp2,iwm,iwm1,iwm2
      parameter (itop=3,itbr=4,ijet=5)
      real * 8 mdecwp1,mdecwp2,mdecwm1,mdecwm2
      real * 8 xm2,s,q1q,tk,uk,q2q,w1h,w2h,x,y
      real * 8 tpvirt2,tmvirt2,wpvirt2,ebp,wmvirt2,ebm,res,resmnr,rat,
     #         cth2,ttenmnr,cmenmnr,krtop2,kpair,tten,cmen
      real * 8 xboundb
      character * 2 proc
      real * 8 boundnorm,ubound
      integer ini
      data ini/0/
      data boundnorm,ubound/8d0,0d0/
      save ini,boundnorm,ubound
      real * 8 dotprod,random,fgg,fqq,fqg,ggborn,qqborn,powheginput
      external dotprod,random,fgg,fqq,fqg,ggborn,qqborn,powheginput
      real * 8 topdecamp,wdecamp,tvirt2,wvirt2
      real * 8 pi
      parameter (pi=3.141592653589793d0)
      real * 8 dummy
c spin summmed and averaged amplitude squared for top decay
      topdecamp(tvirt2,wvirt2)=-(2*wvirt2**2-tvirt2*wvirt2
     # -bmass**2*wvirt2-tvirt2**2+2*bmass**2*tvirt2-bmass**4)/wvirt2
     #    *4*pi*alpha/(2*sin2w)
     #    /2
c spin summmed and averaged amplitude squared for W decay
      wdecamp(wvirt2)=(2*wvirt2) / 3 * 4*pi*alpha/(2*sin2w)
      if(ini.eq.2) then
         return
      elseif(ini.eq.0) then
         if(powheginput('#topdecaymode').eq.-1d6) then
            ini=2
            return
         endif
         if(powheginput('topdecaymode').eq.0d0) then
            ini=2
            return
         endif
         ini=1
         call madeventinput
      endif
c Compute MNR cross section for normalization
c now compute the MNR invariants; we need to do this after permutations
      do j=1,4
         do k=1,nup
            pp(j,k)=pup(j,k)
c pps shall not change from now on, in case one need to recompute
c things because of hit and miss
            pps(j,k)=pup(j,k)
         enddo
      enddo
      call momcons(2,pp,nup-2,pp(1,3))
c exchange momenta in pp to put them in standard form
      call momstdform(idup,1,3,4,proc,pp)
c compute mnr invariants
      s=2*dotprod(pp(1,1),pp(1,2))
      q1q=-2*dotprod(pp(1,1),pp(1,3))
      xm2=tmass**2
      if(nup.eq.5) then
         tk=-2*dotprod(pp(1,1),pp(1,5))
         uk=-2*dotprod(pp(1,2),pp(1,5))
         q2q=-2*dotprod(pp(1,2),pp(1,4))
c w1=-q1+q2-tk, w2=q1-q2-uk, w1(w2) = w1h(w2h) *s*(1-x)/2
         w1h=2*(q2q-q1q-tk)/(-tk-uk)
         w2h=2*(q1q-q2q-uk)/(-tk-uk)
         x=1+(tk+uk)/s
         y=(tk-uk)/(s*(1-x))
c cth2 is not used by fgg,fqg,fqq, unless we are very near the collinear limit
         cth2=0
         if(proc.eq.'gg')  then
            resmnr = fgg(s,x,y,xm2,q1q,q2q,w1h,w2h,cth2)/(4*tk*uk)
         elseif(proc.eq.'qg') then
            resmnr = fqg(s,x,y,xm2,q1q,q2q,w1h,w2h,cth2)/(4*tk*uk)
         elseif(proc.eq.'qa') then
            resmnr = fqq(s,x,y,xm2,q1q,q2q,w1h,w2h,cth2)/(4*tk*uk)
         else
            write(*,*)' error: ttdecay, invalid process 1',proc
            stop
         endif
      elseif(nup.eq.4) then
         if(proc.eq.'gg') then
            resmnr=ggborn(s,q1q,xm2)
         elseif(proc.eq.'qa') then
            resmnr=qqborn(s,q1q,xm2)
         else
            write(*,*)' error: ttdecay, invalid process 2'
            stop
         endif
      endif
c End of MNR calculation of cross section
c
c find decay mode of W+ and W-; iwp1, iwp2 refer to the pdg id' of
c W decay products 1 and 2; by convention 1 is down type (e,mu,tau,d,s
c for W-, their antiparticles for W+) and 2 is up type.
c mdecw%% are the corresponding masses of the decay products.
      call pickwdecays(iwp1,mdecwp1,iwp2,mdecwp2,
     #                 iwm1,mdecwm1,iwm2,mdecwm2,dummy)
      rat=0
c Main hit-and-miss return point
 1    continue
c restore pp momenta
      do j=1,4
         do k=1,nup
            pp(j,k)=pps(j,k)
         enddo
      enddo      
c boost to partonic CM
      do j=1,3
         betacm(j)=-(pp(j,1)+pp(j,2))/(pp(4,1)+pp(4,2))
      enddo
      call boostm(betacm,nup,pp(1,1),pp(1,1))
      ttenmnr=pp(4,3)+pp(4,4)
      if(nup.eq.5) then
         kpair=pp(4,5)
      else
         kpair=0
      endif
      if(nup.eq.5) then
c     boost heavy quarks in their rest frame
         do j=1,3
            beta(j)=pp(j,5)/ttenmnr
         enddo
         call boostm(beta,2,pp(1,3),pp(1,3))
      endif
c krtop: relative top momentum (i.e. in the top-antitop CM)
      krtop2=pp(4,3)**2-tmass**2
      call twvirts(krtop2,kpair,tpvirt2,wpvirt2,tmvirt2,wmvirt2)
c Uncomment the following to test strict pole approximation
c      tpvirt2=tmass**2
c      tmvirt2=tmass**2
c      wpvirt2=wmass**2
c      wmvirt2=wmass**2
c
      pp(4,3)=sqrt(tpvirt2+krtop2)
      pp(4,4)=sqrt(tmvirt2+krtop2)
      if(nup.eq.5) then
c     boost heavy quarks back to partonic CM
         do j=1,3
            beta(j)=-pp(j,5)/sqrt(kpair**2+(pp(4,3)+pp(4,4))**2)
         enddo
         call boostm(beta,2,pp(1,3),pp(1,3))
      endif
c t tbar energy partonic CM
      tten=pp(4,3)+pp(4,4)
c total final state energy in partonic CM
      cmen=tten+kpair
c total final state energy in partonic CM in the zero top width case
      cmenmnr=ttenmnr+kpair
c rescale initial momenta to conserve energy
      do k=1,2
         do j=1,4
            pp(j,k)=pp(j,k)*cmen/cmenmnr
         enddo
      enddo
c boost to lab cm
      do j=1,3
         betacm(j)=-betacm(j)
      enddo
      call boostm(betacm,nup,pp(1,1),pp(1,1))
c to avoid bugs in HELAS, restore exact masslessness of incoming partons
      pp(4,1)=abs(pp(3,1))
      pp(4,2)=abs(pp(3,2))
c reset the values of the Les Houches common block, to account for off-shell tt.
c We need to do this now; pp is used later to store decay products momenta
      do k=1,nup
         do j=1,4
            pup(j,k)=pp(j,k)
         enddo
      enddo
      pup(5,3)=sqrt(tpvirt2)
      pup(5,4)=sqrt(tmvirt2)
      call momcons(2,pp,nup-2,pp(1,3))
c fill the first two entries of the madevent phase space array;
      do k=1,2
         do j=1,4
            ppss(j,k)=pp(j,k)
         enddo
      enddo
c if we have an extra parton in the final state
      if(nup.eq.5) then
         do j=1,4
            ppss(j,9)=pp(j,5)
         enddo
      endif
c t and tbar decay products
      ebm=(tpvirt2+bmass**2-wpvirt2)/(2*sqrt(tpvirt2))
      ebp=(tmvirt2+bmass**2-wmvirt2)/(2*sqrt(tmvirt2))
      call decaytop(pup(1,3),wpvirt2,ebm,ppss(1,3))
      call decaytop(pup(1,4),wmvirt2,ebp,ppss(1,6))
c check mom.cons.
      call momcons(1,pup(1,3),3,ppss(1,3))
      call momcons(1,pup(1,4),3,ppss(1,6))
      call momcons(2,ppss,nup-4+6,ppss(1,3))
c Store the ppss in pp for permutations (ppss are saved)
      do k=1,9
         do j=1,4
            pp(j,k)=ppss(j,k)
         enddo
      enddo
c exchange momenta to get standard form
      call momstdform(idup,3,3,6,proc,pp)
c check mom.cons.
      call momcons(2,pp,nup-4+6,pp(1,3))
c Check the invariant masses
c      call invmasschain(pp)
c      write(*,*) sqrt(wpvirt2),sqrt(wmvirt2),sqrt(tpvirt2),sqrt(tmvirt2)
c
c MadEvent uses the (E,p1,p2,p3)
c convention for momenta
      do j=1,9
         do k=1,3
            pme(k,j)=pp(k,j)
         enddo
         pme(0,j)=pp(4,j)
      enddo
c         
      if(nup.eq.4) then
         if(proc.eq.'qa') then
            call uub_ttb(pme,res)
         elseif(proc.eq.'gg') then
            call gg_ttb(pme,res)
         endif
      else
         if(proc.eq.'qa') then
            call uub_ttbg(pme,res)
         elseif(proc.eq.'gg') then
            call gg_ttbg(pme,res)
         elseif(proc.eq.'qg') then
            call ug_ttbu(pme,res)
         endif
      endif
c /(2*s)
      res=res/(4*dotprod(pp(1,1),pp(1,2)))
c All subsequent factors are included in MadEvent, but not
c in MNR
      xboundb=1
      xboundb=xboundb/(
     #       ((tpvirt2-tmass**2)**2+tmass**2*twidth**2)*
     #       ((wpvirt2-wmass**2)**2+wmass**2*wwidth**2)*
     #       ((tmvirt2-tmass**2)**2+tmass**2*twidth**2)*
     #       ((wmvirt2-wmass**2)**2+wmass**2*wwidth**2) )
c Amplitude squared for top decay
      xboundb=xboundb*topdecamp(tpvirt2,wpvirt2)*
     #                topdecamp(tmvirt2,wmvirt2)*
     #                wdecamp(wpvirt2)*
     #                wdecamp(wmvirt2)
c
      rat=res/(xboundb*resmnr)
      if(rat.gt.boundnorm)
     #  call  increasecnt('topdecay upper bound violations')
      ubound=max(rat,ubound)
      if(boundnorm*random().gt.rat) then
         call increasecnt('topdecay vetoed configurations')
         goto 1
      endif
c End Hit and Miss loop
c restore pp as before exchanges
      do k=1,9
         do j=1,4
            pp(j,k)=ppss(j,k)
         enddo
      enddo
c Put finite masses to W decay products
      call momcons(2,pp,nup-4+6,pp(1,3))
      call truemasses(pp(1,3),mdecwp1,mdecwp2)
      call truemasses(pp(1,6),mdecwm1,mdecwm2)
      call momcons(2,pp,nup-4+6,pp(1,3))
c Add the decay products on the Les Houches interface.
c Set istup=2 for t,tbar (intermediate resonance, preserve mass
c We also add the W momentum as istup=2
      istup(itop)=2
      istup(itbr)=2
c W+
      nup=nup+1
      iwp=nup
      idup(nup)=24
      do j=1,4
         pup(j,nup)=pp(j,3)+pp(j,4)
      enddo
      pup(5,nup)=sqrt(wpvirt2)
      istup(nup)=2
      mothup(1,nup)=itop
      mothup(2,nup)=itop
      icolup(1,nup)=0
      icolup(2,nup)=0
      spinup(nup)=9
c b
      nup=nup+1
      idup(nup)=5
      do j=1,4
         pup(j,nup)=pp(j,5)
      enddo
      pup(5,nup) = bmass
      istup(nup) = 1
      mothup(1,nup)=itop
      mothup(2,nup)=itop
      icolup(1,nup)=icolup(1,itop)
      icolup(2,nup)=icolup(2,itop)
      spinup(nup)=-1
c W-
      nup=nup+1      
      iwm=nup
      idup(nup)=-24
      do j=1,4
         pup(j,nup)=pp(j,6)+pp(j,7)
      enddo
      pup(5,nup)=sqrt(wmvirt2)
      istup(nup)=2
      mothup(1,nup)=itbr
      mothup(2,nup)=itbr
      icolup(1,nup)=0
      icolup(2,nup)=0
      spinup(nup)=9
c bbar
      nup=nup+1
      idup(nup)=-5
      do j=1,4
         pup(j,nup)=pp(j,8)
      enddo
      pup(5,nup) = bmass
      istup(nup) = 1
      mothup(1,nup)=itbr
      mothup(2,nup)=itbr
      icolup(1,nup)=icolup(1,itbr)
      icolup(2,nup)=icolup(2,itbr)
      spinup(nup)=1
c 1st W+ decay products
      nup=nup+1
      idup(nup)=iwp1
      do j=1,4
         pup(j,nup)=pp(j,3)
      enddo
      pup(5,nup) = mdecwp1
      istup(nup) = 1
      mothup(1,nup)=iwp
      mothup(2,nup)=iwp
      spinup(nup)=1
c setup colours
      if(abs(iwp1).lt.11) then
c find free colour tag
         k=1
         do j=1,nup
            k=max(icolup(1,j),icolup(2,j),k)
         enddo
         k=k+1
c tag found
         if(iwp1.gt.0) then
            icolup(1,nup)=k
            icolup(2,nup)=0
         else
            icolup(1,nup)=0
            icolup(2,nup)=k
         endif
      else
         icolup(1,nup)=0
         icolup(2,nup)=0
      endif
c second
      nup=nup+1
      idup(nup)=iwp2
      do j=1,4
         pup(j,nup)=pp(j,4)
      enddo
      pup(5,nup) = mdecwp2
      istup(nup) = 1
      mothup(1,nup)=iwp
      mothup(2,nup)=iwp
      icolup(1,nup)=icolup(2,nup-1)
      icolup(2,nup)=icolup(1,nup-1)
      spinup(nup)=-1
c 1st W- decay products
      nup=nup+1
      idup(nup)=iwm1
      do j=1,4
         pup(j,nup)=pp(j,6)
      enddo
      pup(5,nup) = mdecwm1
      istup(nup) = 1
      mothup(1,nup)=iwm
      mothup(2,nup)=iwm
      spinup(nup)=-1
c setup colours
      if(abs(iwm1).lt.11) then
c find free colour tag
         k=1
         do j=1,nup
            k=max(icolup(1,j),icolup(2,j),k)
         enddo
         k=k+1
c tag found
         if(iwm1.gt.0) then
            icolup(1,nup)=k
            icolup(2,nup)=0
         else
            icolup(1,nup)=0
            icolup(2,nup)=k
         endif
      else
         icolup(1,nup)=0
         icolup(2,nup)=0
      endif
c second
      nup=nup+1
      idup(nup)=iwm2
      do j=1,4
         pup(j,nup)=pp(j,7)
      enddo
      pup(5,nup) = mdecwp2
      istup(nup) = 1
      mothup(1,nup)=iwm
      mothup(2,nup)=iwm
      icolup(1,nup)=icolup(2,nup-1)
      icolup(2,nup)=icolup(1,nup-1)
      spinup(nup)=1
c
      do k=1,nup
         vtimup(k)=0
      enddo
      end


      subroutine truemasses(decprod,m1,m2)
      implicit none
      real * 8 decprod(4,2),m1,m2
      real * 8 beta(3),wv,mom
      integer j
      real * 8 decmom
      external decmom
      do j=1,3
         beta(j)= - (decprod(j,1)+decprod(j,2)) /
     #              (decprod(4,1)+decprod(4,2))
      enddo
      call boostm(beta,2,decprod,decprod)
      wv=decprod(4,1)+decprod(4,2)
      mom=decmom(wv,m1,m2)
      do j=1,3
         decprod(j,1)=decprod(j,1)*mom/decprod(4,1)
         decprod(j,2)=decprod(j,2)*mom/decprod(4,2)
      enddo
      decprod(4,1)=sqrt(mom**2+m1**2)
      decprod(4,2)=sqrt(mom**2+m2**2)
      do j=1,3
         beta(j)=-beta(j)
      enddo
      call boostm(beta,2,decprod,decprod)
      end

      subroutine invmasschain(pp)
c print the invarian masses of the W's and tops in the event
c (for edbugging)
      implicit none
      real * 8 pp(4,9),w(2),t(2),tt
      integer k,i,j
c w virtualities
      do k=1,2
         w(k)=0
c i=0,3
         i=3*(k-1)
         do j=1,3
            w(k)=w(k)-(pp(j,3+i)+pp(j,4+i))**2
         enddo
         w(k)=w(k)+(pp(4,3+i)+pp(4,4+i))**2
      enddo
c t virtualities
      do k=1,2
         t(k)=0
         i=3*(k-1)
         do j=1,3
            t(k)=t(k)-(pp(j,3+i)+pp(j,4+i)+pp(j,5+i))**2
         enddo
         t(k)=t(k)+(pp(4,3+i)+pp(4,4+i)+pp(4,5+i))**2
      enddo
      tt=0
      do j=1,3
         tt=tt-(pp(j,3)+pp(j,4)+pp(j,5)+pp(j,6)+pp(j,7)+pp(j,8))**2
      enddo
      tt=tt+(pp(4,3)+pp(4,4)+pp(4,5)+pp(4,6)+pp(4,7)+pp(4,8))**2
      write(*,*) sqrt(w(1)),sqrt(w(2)),sqrt(t(1)),sqrt(t(2)),sqrt(tt)
      end

      function pdfcorr(corfac)
c compute the correction factor to the luminosity,
c due to the rescaling of the initial momenta when
c the top and anti-top invariant masses are off the pole mass
      implicit none
      include 'LesHouches.h'
      include 'strfun.h'
      real * 8 pdfcorr,corfac
      real * 8 mufc2,x(2),xc(2),r
      real * 8 fx(-6:6)
      real * 8 powheginput
      external powheginput
      integer ndns(2),ipart(2),ih(2),k
      ndns(1)=ndns1
      ndns(2)=ndns2
      ih(1)=ih1
      ih(2)=ih2
c Factorization scale (relay on 5 being the light parton)
      if(nup.eq.4) then
         mufc2=5d0
      else
         mufc2=max(5d0,pup(2,5)**2+pup(3,5)**2)
      endif
      do k=1,2
         x(k)=pup(4,k)/ebmup(k)
         xc(k)=x(k)*corfac
         if(xc(k).gt.1) then
            pdfcorr=0
            return
         endif
      enddo
      do k=1,2
         if(idbmup(k).eq.2212) then
            ih(k)=1
         elseif(idbmup(k).eq.-2212) then
            ih(k)=-1
         else
            write(*,*) ' pdfcorr: cannot handle incoming hadrons',
     #           idbmup(1),idbmup(2)
            stop
         endif
      enddo
c parton types, from pdg to generic pdf
      do k=1,2
         if(idup(k).eq.21) then
            ipart(k)=0
         else
            ipart(k)=idup(k)
         endif
      enddo
      r=1
      do k=1,2
         call genericpdf(ndns(k),ih(k),mufc2,x(k),fx)
         if(fx(ipart(k)).ne.0) then
            r=r/fx(ipart(k))
            call genericpdf(ndns(k),ih(k),mufc2,xc(k),fx)
            r=r*fx(ipart(k))
         endif
      enddo
      pdfcorr=r
      end

      function decmom(m,m1,m2)
c compute the momentum of the two body decay products, from mass m-> m1,m2
      implicit none
      real * 8 decmom,m,m1,m2
      if(m.lt.m1+m2) then
         decmom=0
      else
         decmom=sqrt((m-m1-m2)*(m-m1+m2)*(m+m1-m2)*(m+m1+m2))/(2*m)
      endif
      end


      subroutine twvirts(krtop2,kpair,
     #     tpvirt2,wpvirt2,tmvirt2,wmvirt2)
c Computes the random virtualities for t+, t-, W+ and W-, according to
c their breit-Wigner shape, to phase space, and to (small) luminosity changes
c due to t and tbar going off the pole mass. The scheme adopted here is that
c the relative 3-momentum of the top in the t-tbar rest system, and the
c 3 momentum of the radiated light parton (if any) in the partonic CM system
c are kept fixed.
c Input:
c krtop2: relative 3-momentum squared of t (i.e. t momentum in t+ t- rest frame
c kpair:  t+ t- total 3-momentum in partonic CM system
c tpvirt2,wpvirt2,tmvirt2,wmvirt2: t+,W+,t-,W- virtualities squared
c The values of the top and W mass and widths, and the value of the b mass,
c are taken from the MEcoupl.inc common blocks.
      implicit none
      include 'MEcoupl.inc'
      real * 8 krtop2,kpair,
     #     tpvirt2,wpvirt2,tmvirt2,wmvirt2,tpvirt,tmvirt,wpvirt,wmvirt
      real * 8 bmass2,tmass2,wmass2,eb0,ttmass0,tten0,cfac,ttmass,
     #         kb0,wpkl0,wmkl0,tten,cmen,cmen0,ran(5)
      real * 8  pdfcorr,decmom
      external pdfcorr,decmom
      integer j
      real * 8 pi
      parameter (pi=3.141592653589793d0)
      real * 8 virt2,mass,gam
c generate squared virtuality according to Breit-Wigner and random number ran(j)
      virt2(mass,gam,j)=gam*mass*tan(pi/2*(1-2*ran(j)))+mass**2
      bmass2=bmass**2
      tmass2=tmass**2
      wmass2=wmass**2
c b energy in t rest frame in zero width limit
      eb0=(tmass2+bmass2-wmass2)/(2*tmass)
c momentum of decay products in t rest frame
      kb0=decmom(tmass,wmass,bmass)
c momentum of decay products in W decays
      wpkl0=decmom(wmass,0d0,0d0)
      wmkl0=decmom(wmass,0d0,0d0)
c invariant mass of t+t- system (zero width)
      ttmass0=2*sqrt(tmass2+krtop2)
      tten0=sqrt(ttmass0**2+kpair**2)
      cmen0=tten0+kpair
c Begin loop for hit and miss
 1    continue
c get 5 random numbers
      call rm48(ran,5)
c First get virtualities according to Lorentian;
c avoid too extreme values
      tpvirt2=virt2(tmass,twidth,1)
      if(tpvirt2.lt.wmass2.or.tpvirt2.gt.2*tmass2) goto 1
      tpvirt=sqrt(tpvirt2)
      tmvirt2=virt2(tmass,twidth,2)
      if(tmvirt2.lt.wmass2.or.tmvirt2.gt.2*tmass2) goto 1
      tmvirt=sqrt(tmvirt2)
      wpvirt2=virt2(wmass,wwidth,3)
      if(wpvirt2.gt.tpvirt2.or.wpvirt2.lt.0) goto 1
      wpvirt=sqrt(wpvirt2)
      wmvirt2=virt2(wmass,wwidth,4)
      if(wmvirt2.gt.tmvirt2.or.wmvirt2.lt.0) goto 1
      wmvirt=sqrt(wmvirt2)
c estimate phase space factor and do hit and miss with it
c this is from missing 1/(k0(top) * k0(antitop)) in top-antitop rest frame
      cfac=(tmass2+krtop2)/sqrt((tpvirt2+krtop2)*(tmvirt2+krtop2))
c this is from phase space in t->W+b
      cfac=cfac*(decmom(tpvirt,wpvirt,bmass)/tpvirt)/(kb0/tmass)
c this is from phase space in tbar->W- + b
      cfac=cfac*(decmom(tmvirt,wmvirt,bmass)/tmvirt)/(kb0/tmass)
c this is from phase space in W+ decay
      cfac=cfac*(decmom(wpvirt,0d0,0d0)/wpvirt)/(wpkl0/wmass)
c this is from phase space in W- decay
      cfac=cfac*(decmom(wmvirt,0d0,0d0)/wmvirt)/(wmkl0/wmass)
c this is from ttmass/tten*sqrt(tau) factor
      ttmass=sqrt(tpvirt2+krtop2)+sqrt(tmvirt2+krtop2)
      tten=sqrt(ttmass**2+kpair**2)
      cmen=tten+kpair
      cfac=cfac * (cmen*ttmass/tten) / (cmen0*ttmass0/tten0)
      cfac=cfac*pdfcorr(cmen/cmen0)
c we optimize for cfac at most = 2 (no prize for larger values)
      if(2*ran(5).gt.cfac) goto 1
      end
      
      subroutine momstdform(idup,ndec,it,itbar,proc,pp)
c puts momenta in standard order, for evaluation by MNR and MadEvent
c MadEvent -> g(1)g(2) -> l+(3)nu(4)b(5) l-(6)nub(7)bb(8)
c MadEvent -> q(1)qb(2)-> l+(3)nu(4)b(5) l-(6)nub(7)bb(8)
c MadEvent -> g(1)g(2) -> l+(3)nu(4)b(5) l-(6)nub(7)bb(8) g(9)
c MadEvent -> q(1)qb(2)-> l+(3)nu(4)b(5) l-(6)nub(7)bb(8) g(9)
c MadEvent -> q(1)g(2) -> l+(3)nu(4)b(5) l-(6)nub(7)bb(8) q(9)
c or
c MNR -> g(1)g(2) -> t+(3) t-(4)
c MNR -> q(1)qb(2)-> t+(3) t-(4)
c MNR -> g(1)g(2) -> t+(3) t-(4) g(5)
c MNR -> q(1)qb(2)-> t+(3) t-(4) g(5)
c MNR -> q(1)g(2) -> t+(3) t-(4) q(5)
c
c by exchanging 1<->2, and by mimicking charge conjugation by 3<->4 (MNR)
c or (3,4,5)<->(6,7,8) (MadEvent) exchange
c
c Calling sequence:
c call momstdform(idup,1,3,4,proc,pp) (MNR)
c call momstdform(idup,3,3,6,proc,pp) (MadEvent)
c idup: idup array of Les Houches Common Block
c return values:
c proc: two characted string: 'gg', 'qa', 'qg'
c pp: momentum array in input, permuted array in output
      implicit none
      character * 2 proc
      integer idup(2)
      real * 8 pp(4,*)
      integer ndec,it,itbar
      integer k
c now label the process and do the exchanges
      if(idup(1).gt.0.and.idup(2).lt.0) then
c quark antiquark
         proc='qa'
      elseif(idup(1).eq.21.and.idup(2).eq.21) then
         proc='gg'
      elseif(idup(1).gt.0.and.idup(2).eq.21) then
         proc='qg'
      elseif(idup(1).lt.0.and.idup(2).gt.0) then
         call exchmom(pp(1,1),pp(1,2))
         proc='qa'
      elseif(idup(1).eq.21.and.idup(2).gt.0) then
         call exchmom(pp(1,1),pp(1,2))
         proc='qg'
      elseif(idup(1).lt.0.and.idup(2).eq.21) then
c Exchange t and t-tbar, to mimic charge conjugation.
         do k=0,ndec-1
            call exchmom(pp(1,it+k),pp(1,itbar+k))
         enddo
         proc='qg'
      elseif(idup(1).eq.21.and.idup(2).lt.0) then
c Exchange initial state momenta and t-tbar decay products
         call exchmom(pp(1,1),pp(1,2))
         do k=0,ndec-1
            call exchmom(pp(1,it+k),pp(1,itbar+k))
         enddo
         proc='qg'
      endif
      end

      subroutine decaytop(ptop,wvirt2,eb,decprod)
c Put momenta of top decay in decprod, distributed according phase space,
c for a given W virtuality
c Input (momenta as p(1:4)=(p1,p2,p3,E)
c ptop: top 4 momentum
c wvirt2:    W virtuality squared
c eb:   b energy in top rest frame
c m1:   mass of first W decay product
c m2:   mass of second W decay product
c output:
c decprod(1:4,1): W first decay product
c decprod(1:4,2): W second decay product
c decprod(1:4,3): bottom momentum
      implicit none
      include 'MEcoupl.inc'
      real * 8 ptop(4),wvirt2,eb,decprod(4,3)
      real * 8 wvirt,pb,ew,pl,beta(3)
      wvirt=sqrt(wvirt2)
c modulus of b momentum
      pb=sqrt(eb**2-bmass**2)
c W energy in top rest frame
      ew=sqrt(pb**2+wvirt2)
c generate random directed b momentum in t rest frame
      call rn3vec(decprod(1,3),pb)
      decprod(4,3)=eb
c 1st W decay product in W rest frame
      pl=wvirt/2
      call rn3vec(decprod(1,1),pl)
      decprod(4,1)=pl
c 2nd W decay product in W rest frame
      decprod(1,2)=-decprod(1,1)
      decprod(2,2)=-decprod(2,1)
      decprod(3,2)=-decprod(3,1)
      decprod(4,2)=pl
c boost W decay products with W velocity in t rest frame
c (its momentum is opposite to the b momentum)
      beta(1)=-decprod(1,3)/ew
      beta(2)=-decprod(2,3)/ew
      beta(3)=-decprod(3,3)/ew
      call boostm(beta,2,decprod(1,1),decprod(1,1))
c boost all decay products along top velocity
      beta(1)=ptop(1)/ptop(4)
      beta(2)=ptop(2)/ptop(4)
      beta(3)=ptop(3)/ptop(4)
      call boostm(beta,3,decprod(1,1),decprod(1,1))
      end

      subroutine momcons(n1,p1,n2,p2)
c check that sum of n1 momenta in p1
c equals the sum of n2 momenta in p2
      implicit none
      integer n1,n2
      real * 8 p1(4,*),p2(4,*)
      real * 8 res(4)
      integer j,k
      do j=1,4
         res(j)=0
         do k=1,n1
            res(j)=res(j)+p1(j,k)
         enddo
         do k=1,n2
            res(j)=res(j)-p2(j,k)
         enddo
      enddo
      do j=1,4
         if(abs(res(j)).gt.1d-7) then
            write(*,*) ' mom. check failed'
            write(*,*) (res(k),k=1,4)
            return
         endif
      enddo
      end

c boosts the m 4 vectors vin, output in vout, boost velocity beta
c vin and vout may be the same
      subroutine boostm(beta,m,vin,vout)
      implicit none
      integer m
      real * 8 beta(3),vin(4,m),vout(4,m)
      real * 8 betav,gamma
      real * 8 vdotb
      integer ipart,idim
      betav=sqrt(beta(1)**2 + beta(2)**2 + beta(3)**2)
      gamma=1/sqrt(1-betav**2)
      do ipart=1,m
         vdotb=vin(1,ipart)*beta(1)
     #         +vin(2,ipart)*beta(2)+vin(3,ipart)*beta(3)
         do idim=1,3
            vout(idim,ipart)=vin(idim,ipart)
     # +beta(idim)/betav*((gamma-1)*vdotb/betav
     #     +gamma*betav*vin(4,ipart))
         enddo
         vout(4,ipart)=gamma*(vin(4,ipart)+vdotb)
      enddo
      end


      subroutine exchmom(p1,p2)
      implicit none
      real * 8 p1(4),p2(4),tmp
      integer j
      do j=1,4
         tmp=p1(j)
         p1(j)=p2(j)
         p2(j)=tmp
      enddo
      end


      subroutine pickwdecays(iwp1,mdecwp1,iwp2,mdecwp2,
     #                 iwm1,mdecwm1,iwm2,mdecwm2,totbr)
c Finds which decays to choose with correct probability, according
c to an integer of 5 digits that are either 0, or 2, representing in
c the order the maximum number of the following particles(antiparticles)
c in the final state:
c          e  mu tau up charm
c For example
c 22222    All decays (up to 2 units of everything)
c 20000    both top go into b l nu (with the appropriate signs)
c 10011    one top goes into electron (or positron), the other into (any) hadrons
c 00022    Fully hadronic
c 00002    Fully hadronic with two charms
c 00011    Fully hadronic with a single charm
c 00012    Fully hadronic with at least one charm
      implicit none
      integer iwp1,iwp2, iwm1,iwm2, iwp(5,2),iwa(4)
      real * 8 mdecwp1,mdecwp2,mdecwm1,mdecwm2
      real * 8 probs(5,5),prbs(25),pr(5),mass(16),
     #     sin2cabibbo,ebr,hbr,r,totbr
      equivalence (probs(1,1),prbs(1))
      integer ini,ii(5),j,k,imode
      logical semileptonic
      real * 8 random,powheginput
      external random,powheginput
      data ini/0/
c pdg id's of 1st and 2nd W+ decay products for e,mu,tau,up and charm decays (ignoring CKM)
      data ((iwp(j,k),k=1,2),j=1,5)/-11,12, -13,14, -15,16, -1,2, -3,4/
      save ini,probs,iwp,mass,sin2cabibbo,semileptonic
      if(ini.eq.2) return
      if(ini.eq.0) then
         ini=1
c on first run look for decay mode in powheginput
         imode=powheginput('topdecaymode')
         semileptonic=powheginput('#semileptonic').eq.1
         if(imode.eq.0) then
            ini=2
            return
         endif
         ii(1)=imode/10000
         imode=imode-ii(1)*10000
         ii(2)=imode/1000
         imode=imode-ii(2)*1000
         ii(3)=imode/100
         imode=imode-ii(3)*100
         ii(4)=imode/10
         imode=imode-ii(4)*10
         ii(5)=imode
         ebr=powheginput('tdec/elbranching')
         hbr=(1-3*ebr)/2
         do j=1,5
            if(ii(j).eq.0) then
               pr(j)=0
            else
               if(j.le.3) then
                  pr(j)=ebr
               else
                  pr(j)=hbr
               endif
            endif
         enddo
         do j=1,5
            do k=1,5
               if(j.eq.k.and.ii(k).lt.2) then
                  probs(j,k)=0
               else
                  if(semileptonic.and.( (j.gt.3.and.k.gt.3)
     1                 .or.(j.le.3.and.k.le.3) ) ) then
                     probs(j,k)=0
                  else
                     probs(j,k)=pr(j)*pr(k)
                  endif
               endif
            enddo
         enddo
         do j=2,25
            prbs(j)=prbs(j)+prbs(j-1)
         enddo
         totbr=prbs(25)
         if(totbr.eq.0) then
            write(*,*) 'pickwdecays: the input parameters are such'
            write(*,*) 'that no decays are possible:'
            write(*,*) 'topdecaymode=',nint(powheginput('topdecaymode'))
            if(semileptonic) then
               write(*,*) 'semileptonic=1'
            endif
            write(*,*) ' Halting execution'
            stop
         endif
         mass(11)=powheginput('tdec/emass')
         mass(13)=powheginput('tdec/mumass')
         mass(15)=powheginput('tdec/taumass')
         mass(12)=0
         mass(14)=0
         mass(16)=0
         mass(1)=powheginput('tdec/dmass')
         mass(2)=powheginput('tdec/umass')
         mass(3)=powheginput('tdec/smass')
         mass(4)=powheginput('tdec/cmass')
         sin2cabibbo=powheginput('tdec/sin2cabibbo')
         return
      endif
c end initialization
      r=random()*probs(5,5)
      do k=1,5
         do j=1,5
            if(r.lt.probs(j,k)) goto 1
         enddo
      enddo
 1    continue
c now we have j,k decay mode
      iwa(1)=iwp(j,1)
      iwa(2)=iwp(j,2)
      iwa(3)=-iwp(k,1)
      iwa(4)=-iwp(k,2)
c if any is down or strange, it may turn to
c strange/down with a probability sin^2 theta
      do j=1,4,1
         if(abs(iwa(j)).eq.1) then
            if(random().lt.sin2cabibbo) then
               iwa(j)=sign(3,iwa(j))
            endif
         elseif(abs(iwa(j)).eq.3) then
            if(random().lt.sin2cabibbo) then
               iwa(j)=sign(1,iwa(j))
            endif
         endif
      enddo
      iwp1=iwa(1)
      iwp2=iwa(2)
      iwm1=iwa(3)
      iwm2=iwa(4)
      mdecwp1=mass(abs(iwp1))
      mdecwp2=mass(abs(iwp2))
      mdecwm1=mass(abs(iwm1))
      mdecwm2=mass(abs(iwm2))
      end




      subroutine madeventinput
      implicit none
c Fills HELAS common blocks for masses and couplings. The electron charge
c squared and the masses may eventually be passed through a common block
c on a event-by-event basis. This code is mainly taken from coupsm-ORIGINAL.F 
c of the HELAS package. Here, we limit ourselves to setting the following
c parameters:
c
c       real    gw                : weak coupling constant
c       real    gwwa              : dimensionless WWA  coupling
c       real    gwwz              : dimensionless WWZ  coupling
c       complex gal(2)            : coupling with A of charged leptons
c       complex gau(2)            : coupling with A of up-type quarks
c       complex gad(2)            : coupling with A of down-type quarks
c       complex gwf(2)            : coupling with W-,W+ of fermions
c       complex gzn(2)            : coupling with Z of neutrinos
c       complex gzl(2)            : coupling with Z of charged leptons
c       complex gzu(2)            : coupling with Z of up-type quarks
c       complex gzd(2)            : coupling with Z of down-type quarks
c       complex gg(2)             : QCD gqq coupling (L,R)
c
c through the following parameters, given by powheginput
c
c       real    zmass,wmass       : weak boson masses
c       real    zwidth,wwidth     : weak boson width
c       real    tmass,twidth      : top mass and width
c       real    bmass             : bottom mass
c       real    sin2w             : square of sine of the weak angle
c       real    ee2               : positron charge squared
c       real    g                 : QCD 3-,4-gluon coupling
c
      include 'MEcoupl.inc'
      real * 8 powheginput
      double precision zero,half,one,two,three,pi,ee2,sw,cw,ez,ey,sc2,v
      parameter (zero=0.d0)
      parameter (half=0.5d0)
      parameter (one=1.d0)
      parameter (two=2.d0)
      parameter (three=3.d0)
      parameter (pi=3.14159265358979312D0)
      integer ini
      data ini/0/
      save ini
      external powheginput
      if(ini.eq.1) return
      ini=1
      wmass=powheginput('tdec/wmass')
      wwidth=powheginput('tdec/wwidth')
      zmass=0
      zwidth=0
      tmass=powheginput('qmass')
      twidth=powheginput('tdec/twidth')
      bmass=powheginput('tdec/bmass')
      sin2w=0.23
      alpha=1
      ee2=4*pi*alpha
c
      g     = 1
c
      amass=0.d0
      awidth=1.d-99
c
      ee=sqrt(ee2)
c
      sw  = sqrt( sin2w )
      cw  = sqrt( One - sin2w )
      ez  = ee/(sw*cw)
      ey  = ee*(sw/cw)
      sc2 = sin2w*( One - sin2w )
      v   = Two*zmass*sqrt(sc2)/ee
c
c vector boson couplings
c
      gw   = ee/sw
      gwwa = ee
      gwwz = ee*cw/sw
c
c fermion-fermion-vector couplings
c
      gal(1) = dcmplx(  ee          , Zero )
      gal(2) = dcmplx(  ee          , Zero )
      gau(1) = dcmplx( -ee*Two/Three, Zero )
      gau(2) = dcmplx( -ee*Two/Three, Zero )
      gad(1) = dcmplx(  ee/Three    , Zero )
      gad(2) = dcmplx(  ee/Three    , Zero )
c
      gwf(1) = dcmplx( -ee/sqrt(Two*sin2w), Zero )
      gwf(2) = dcmplx(  Zero              , Zero )
c
      gzn(1) = dcmplx( -ez*Half                     , Zero )
      gzn(2) = dcmplx(  Zero                        , Zero )
      gzl(1) = dcmplx( -ez*(-Half + sin2w)          , Zero )
      gzl(2) = dcmplx( -ey                          , Zero )
      gzu(1) = dcmplx( -ez*( Half - sin2w*Two/Three), Zero )
      gzu(2) = dcmplx(  ey*Two/Three                , Zero )
      gzd(1) = dcmplx( -ez*(-Half + sin2w/Three)    , Zero )
      gzd(2) = dcmplx( -ey/Three                    , Zero )
c
c QCD coupling
c
      gg(1) = dcmplx( -g, Zero )
      gg(2) = gg(1)
c
      return
      end


      subroutine switchmom(p1,p,ic,jc,nexternal)
c**************************************************************************
c     Changes stuff for crossings
c**************************************************************************
      implicit none
      integer nexternal
      integer jc(nexternal),ic(nexternal)
      real*8 p1(0:3,nexternal),p(0:3,nexternal)
      integer i,j
c-----
c Begin Code
c-----
      do i=1,nexternal
         do j=0,3
            p(j,ic(i))=p1(j,i)
         enddo
      enddo
      do i=1,nexternal
         jc(i)=1
      enddo
      jc(ic(1))=-1
      jc(ic(2))=-1
      end


c
c
c Begin of qqbar --> ttbar
c
c
C SF: The following routine is SMATRIX generated by MadEvent, suitably modified
      SUBROUTINE UUB_TTB(P1,ANS)
C  
C Generated by MadGraph II Version 3.90. Updated 08/26/05               
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C AND HELICITIES
C FOR THE POINT IN PHASE SPACE P(0:3,NEXTERNAL)
C  
C FOR PROCESS : u u~ -> e+ ve b e- ve~ b~  
C  
C Crossing   1 is u u~ -> e+ ve b e- ve~ b~  
      IMPLICIT NONE
C  
C CONSTANTS
C  
C SF: replace the following include with the explicit inclusion of
c nexternal.inc, originally included by genps.inc
c      Include "genps.inc"
      integer    nexternal
      parameter (nexternal=  8)
      INTEGER                 NCOMB,     NCROSS         
      PARAMETER (             NCOMB= 256, NCROSS=  1)
      INTEGER    THEL
      PARAMETER (THEL=NCOMB*NCROSS)
C  
C ARGUMENTS 
C  
      REAL*8 P1(0:3,NEXTERNAL),ANS(NCROSS)
C  
C LOCAL VARIABLES 
C  
      INTEGER NHEL(NEXTERNAL,NCOMB),NTRY
      REAL*8 T, P(0:3,NEXTERNAL)
      REAL*8 MATUUB_TTB
      INTEGER IHEL,IDEN(NCROSS),IC(NEXTERNAL,NCROSS)
      INTEGER IPROC,JC(NEXTERNAL), I
      LOGICAL GOODHEL(NCOMB,NCROSS)
      INTEGER NGRAPHS
      REAL*8 hwgt, xtry, xrej
      INTEGER idum, ngood, igood(ncomb), jhel, j
      LOGICAL warned
      REAL     xran1
      EXTERNAL xran1
C  
C GLOBAL VARIABLES
C  
C SF: comment out all instances of amp2, used by multi_channel
c      Double Precision amp2(maxamps), jamp2(0:maxamps)
c      common/to_amps/  amp2,       jamp2

      character*79         hel_buff
C SF: comment out all common blocks
c      common/to_helicity/  hel_buff

      integer          isum_hel
      logical                    multi_channel
C SF: comment out all common blocks
c      common/to_matrix/isum_hel, multi_channel
C SF: comment out all instances of mapconfig, used by multi_channel
c      INTEGER MAPCONFIG(0:LMAXCONFIGS), ICONFIG
c      common/to_mconfigs/mapconfig, iconfig
      DATA NTRY,IDUM /0,-1/
      DATA xtry, xrej, ngood /0,0,0/
      DATA warned, isum_hel/.false.,0/
      DATA multi_channel/.true./
      SAVE igood, IDUM, jhel
      DATA NGRAPHS /    1/          
C SF: comment out all instances of amp2, used by multi_channel
c      DATA jamp2(0) /   1/          
      DATA GOODHEL/THEL*.FALSE./
      DATA (NHEL(IHEL,   1),IHEL=1,8) /-1,-1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,   2),IHEL=1,8) /-1,-1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,   3),IHEL=1,8) /-1,-1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,   4),IHEL=1,8) /-1,-1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,   5),IHEL=1,8) /-1,-1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,   6),IHEL=1,8) /-1,-1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,   7),IHEL=1,8) /-1,-1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,   8),IHEL=1,8) /-1,-1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,   9),IHEL=1,8) /-1,-1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  10),IHEL=1,8) /-1,-1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  11),IHEL=1,8) /-1,-1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  12),IHEL=1,8) /-1,-1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  13),IHEL=1,8) /-1,-1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  14),IHEL=1,8) /-1,-1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  15),IHEL=1,8) /-1,-1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  16),IHEL=1,8) /-1,-1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  17),IHEL=1,8) /-1,-1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  18),IHEL=1,8) /-1,-1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  19),IHEL=1,8) /-1,-1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  20),IHEL=1,8) /-1,-1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  21),IHEL=1,8) /-1,-1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  22),IHEL=1,8) /-1,-1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  23),IHEL=1,8) /-1,-1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  24),IHEL=1,8) /-1,-1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  25),IHEL=1,8) /-1,-1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  26),IHEL=1,8) /-1,-1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  27),IHEL=1,8) /-1,-1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  28),IHEL=1,8) /-1,-1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  29),IHEL=1,8) /-1,-1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  30),IHEL=1,8) /-1,-1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  31),IHEL=1,8) /-1,-1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  32),IHEL=1,8) /-1,-1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  33),IHEL=1,8) /-1,-1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  34),IHEL=1,8) /-1,-1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  35),IHEL=1,8) /-1,-1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  36),IHEL=1,8) /-1,-1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  37),IHEL=1,8) /-1,-1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  38),IHEL=1,8) /-1,-1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  39),IHEL=1,8) /-1,-1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  40),IHEL=1,8) /-1,-1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  41),IHEL=1,8) /-1,-1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  42),IHEL=1,8) /-1,-1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  43),IHEL=1,8) /-1,-1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  44),IHEL=1,8) /-1,-1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  45),IHEL=1,8) /-1,-1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  46),IHEL=1,8) /-1,-1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  47),IHEL=1,8) /-1,-1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  48),IHEL=1,8) /-1,-1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  49),IHEL=1,8) /-1,-1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  50),IHEL=1,8) /-1,-1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  51),IHEL=1,8) /-1,-1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  52),IHEL=1,8) /-1,-1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  53),IHEL=1,8) /-1,-1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  54),IHEL=1,8) /-1,-1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  55),IHEL=1,8) /-1,-1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  56),IHEL=1,8) /-1,-1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  57),IHEL=1,8) /-1,-1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  58),IHEL=1,8) /-1,-1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  59),IHEL=1,8) /-1,-1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  60),IHEL=1,8) /-1,-1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  61),IHEL=1,8) /-1,-1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  62),IHEL=1,8) /-1,-1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  63),IHEL=1,8) /-1,-1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  64),IHEL=1,8) /-1,-1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  65),IHEL=1,8) /-1, 1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  66),IHEL=1,8) /-1, 1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  67),IHEL=1,8) /-1, 1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  68),IHEL=1,8) /-1, 1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  69),IHEL=1,8) /-1, 1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  70),IHEL=1,8) /-1, 1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  71),IHEL=1,8) /-1, 1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  72),IHEL=1,8) /-1, 1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  73),IHEL=1,8) /-1, 1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  74),IHEL=1,8) /-1, 1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  75),IHEL=1,8) /-1, 1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  76),IHEL=1,8) /-1, 1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  77),IHEL=1,8) /-1, 1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  78),IHEL=1,8) /-1, 1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  79),IHEL=1,8) /-1, 1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  80),IHEL=1,8) /-1, 1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  81),IHEL=1,8) /-1, 1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  82),IHEL=1,8) /-1, 1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  83),IHEL=1,8) /-1, 1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  84),IHEL=1,8) /-1, 1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  85),IHEL=1,8) /-1, 1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  86),IHEL=1,8) /-1, 1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  87),IHEL=1,8) /-1, 1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  88),IHEL=1,8) /-1, 1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  89),IHEL=1,8) /-1, 1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  90),IHEL=1,8) /-1, 1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  91),IHEL=1,8) /-1, 1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  92),IHEL=1,8) /-1, 1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  93),IHEL=1,8) /-1, 1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  94),IHEL=1,8) /-1, 1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  95),IHEL=1,8) /-1, 1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  96),IHEL=1,8) /-1, 1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  97),IHEL=1,8) /-1, 1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  98),IHEL=1,8) /-1, 1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  99),IHEL=1,8) /-1, 1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 100),IHEL=1,8) /-1, 1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 101),IHEL=1,8) /-1, 1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 102),IHEL=1,8) /-1, 1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 103),IHEL=1,8) /-1, 1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 104),IHEL=1,8) /-1, 1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 105),IHEL=1,8) /-1, 1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 106),IHEL=1,8) /-1, 1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 107),IHEL=1,8) /-1, 1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 108),IHEL=1,8) /-1, 1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 109),IHEL=1,8) /-1, 1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 110),IHEL=1,8) /-1, 1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 111),IHEL=1,8) /-1, 1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 112),IHEL=1,8) /-1, 1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 113),IHEL=1,8) /-1, 1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 114),IHEL=1,8) /-1, 1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 115),IHEL=1,8) /-1, 1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 116),IHEL=1,8) /-1, 1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 117),IHEL=1,8) /-1, 1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 118),IHEL=1,8) /-1, 1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 119),IHEL=1,8) /-1, 1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 120),IHEL=1,8) /-1, 1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 121),IHEL=1,8) /-1, 1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 122),IHEL=1,8) /-1, 1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 123),IHEL=1,8) /-1, 1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 124),IHEL=1,8) /-1, 1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 125),IHEL=1,8) /-1, 1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 126),IHEL=1,8) /-1, 1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 127),IHEL=1,8) /-1, 1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 128),IHEL=1,8) /-1, 1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 129),IHEL=1,8) / 1,-1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 130),IHEL=1,8) / 1,-1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 131),IHEL=1,8) / 1,-1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 132),IHEL=1,8) / 1,-1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 133),IHEL=1,8) / 1,-1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 134),IHEL=1,8) / 1,-1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 135),IHEL=1,8) / 1,-1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 136),IHEL=1,8) / 1,-1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 137),IHEL=1,8) / 1,-1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 138),IHEL=1,8) / 1,-1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 139),IHEL=1,8) / 1,-1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 140),IHEL=1,8) / 1,-1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 141),IHEL=1,8) / 1,-1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 142),IHEL=1,8) / 1,-1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 143),IHEL=1,8) / 1,-1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 144),IHEL=1,8) / 1,-1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 145),IHEL=1,8) / 1,-1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 146),IHEL=1,8) / 1,-1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 147),IHEL=1,8) / 1,-1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 148),IHEL=1,8) / 1,-1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 149),IHEL=1,8) / 1,-1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 150),IHEL=1,8) / 1,-1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 151),IHEL=1,8) / 1,-1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 152),IHEL=1,8) / 1,-1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 153),IHEL=1,8) / 1,-1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 154),IHEL=1,8) / 1,-1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 155),IHEL=1,8) / 1,-1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 156),IHEL=1,8) / 1,-1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 157),IHEL=1,8) / 1,-1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 158),IHEL=1,8) / 1,-1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 159),IHEL=1,8) / 1,-1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 160),IHEL=1,8) / 1,-1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 161),IHEL=1,8) / 1,-1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 162),IHEL=1,8) / 1,-1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 163),IHEL=1,8) / 1,-1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 164),IHEL=1,8) / 1,-1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 165),IHEL=1,8) / 1,-1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 166),IHEL=1,8) / 1,-1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 167),IHEL=1,8) / 1,-1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 168),IHEL=1,8) / 1,-1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 169),IHEL=1,8) / 1,-1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 170),IHEL=1,8) / 1,-1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 171),IHEL=1,8) / 1,-1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 172),IHEL=1,8) / 1,-1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 173),IHEL=1,8) / 1,-1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 174),IHEL=1,8) / 1,-1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 175),IHEL=1,8) / 1,-1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 176),IHEL=1,8) / 1,-1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 177),IHEL=1,8) / 1,-1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 178),IHEL=1,8) / 1,-1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 179),IHEL=1,8) / 1,-1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 180),IHEL=1,8) / 1,-1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 181),IHEL=1,8) / 1,-1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 182),IHEL=1,8) / 1,-1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 183),IHEL=1,8) / 1,-1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 184),IHEL=1,8) / 1,-1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 185),IHEL=1,8) / 1,-1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 186),IHEL=1,8) / 1,-1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 187),IHEL=1,8) / 1,-1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 188),IHEL=1,8) / 1,-1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 189),IHEL=1,8) / 1,-1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 190),IHEL=1,8) / 1,-1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 191),IHEL=1,8) / 1,-1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 192),IHEL=1,8) / 1,-1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 193),IHEL=1,8) / 1, 1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 194),IHEL=1,8) / 1, 1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 195),IHEL=1,8) / 1, 1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 196),IHEL=1,8) / 1, 1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 197),IHEL=1,8) / 1, 1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 198),IHEL=1,8) / 1, 1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 199),IHEL=1,8) / 1, 1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 200),IHEL=1,8) / 1, 1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 201),IHEL=1,8) / 1, 1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 202),IHEL=1,8) / 1, 1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 203),IHEL=1,8) / 1, 1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 204),IHEL=1,8) / 1, 1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 205),IHEL=1,8) / 1, 1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 206),IHEL=1,8) / 1, 1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 207),IHEL=1,8) / 1, 1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 208),IHEL=1,8) / 1, 1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 209),IHEL=1,8) / 1, 1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 210),IHEL=1,8) / 1, 1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 211),IHEL=1,8) / 1, 1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 212),IHEL=1,8) / 1, 1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 213),IHEL=1,8) / 1, 1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 214),IHEL=1,8) / 1, 1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 215),IHEL=1,8) / 1, 1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 216),IHEL=1,8) / 1, 1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 217),IHEL=1,8) / 1, 1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 218),IHEL=1,8) / 1, 1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 219),IHEL=1,8) / 1, 1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 220),IHEL=1,8) / 1, 1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 221),IHEL=1,8) / 1, 1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 222),IHEL=1,8) / 1, 1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 223),IHEL=1,8) / 1, 1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 224),IHEL=1,8) / 1, 1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 225),IHEL=1,8) / 1, 1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 226),IHEL=1,8) / 1, 1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 227),IHEL=1,8) / 1, 1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 228),IHEL=1,8) / 1, 1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 229),IHEL=1,8) / 1, 1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 230),IHEL=1,8) / 1, 1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 231),IHEL=1,8) / 1, 1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 232),IHEL=1,8) / 1, 1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 233),IHEL=1,8) / 1, 1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 234),IHEL=1,8) / 1, 1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 235),IHEL=1,8) / 1, 1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 236),IHEL=1,8) / 1, 1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 237),IHEL=1,8) / 1, 1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 238),IHEL=1,8) / 1, 1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 239),IHEL=1,8) / 1, 1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 240),IHEL=1,8) / 1, 1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 241),IHEL=1,8) / 1, 1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 242),IHEL=1,8) / 1, 1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 243),IHEL=1,8) / 1, 1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 244),IHEL=1,8) / 1, 1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 245),IHEL=1,8) / 1, 1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 246),IHEL=1,8) / 1, 1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 247),IHEL=1,8) / 1, 1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 248),IHEL=1,8) / 1, 1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 249),IHEL=1,8) / 1, 1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 250),IHEL=1,8) / 1, 1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 251),IHEL=1,8) / 1, 1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 252),IHEL=1,8) / 1, 1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 253),IHEL=1,8) / 1, 1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 254),IHEL=1,8) / 1, 1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 255),IHEL=1,8) / 1, 1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 256),IHEL=1,8) / 1, 1, 1, 1, 1, 1, 1, 1/
      DATA (  IC(IHEL,  1),IHEL=1,8) / 1, 2, 3, 4, 5, 6, 7, 8/
      DATA (IDEN(IHEL),IHEL=  1,  1) /  36/
C ----------
C BEGIN CODE
C ----------
      NTRY=NTRY+1
      DO IPROC=1,NCROSS
      CALL SWITCHMOM(P1,P,IC(1,IPROC),JC,NEXTERNAL)
      DO IHEL=1,NEXTERNAL
         JC(IHEL) = +1
      ENDDO
       
C SF: comment out all instances of multi_channel
c      IF (multi_channel) THEN
c          DO IHEL=1,NGRAPHS
c              amp2(ihel)=0d0
c              jamp2(ihel)=0d0
c          ENDDO
c          DO IHEL=1,int(jamp2(0))
c              jamp2(ihel)=0d0
c          ENDDO
c      ENDIF
      ANS(IPROC) = 0D0
      write(hel_buff,'(16i5)') (0,i=1,nexternal)
      IF (ISUM_HEL .EQ. 0 .OR. NTRY .LT. 10) THEN
          DO IHEL=1,NCOMB
              IF (GOODHEL(IHEL,IPROC) .OR. NTRY .LT. 2) THEN
                 T=MATUUB_TTB(P ,NHEL(1,IHEL),JC(1))            
                 ANS(IPROC)=ANS(IPROC)+T
                  IF (T .GT. 0D0 .AND. .NOT. GOODHEL(IHEL,IPROC)) THEN
                      GOODHEL(IHEL,IPROC)=.TRUE.
                      NGOOD = NGOOD +1
                      IGOOD(NGOOD) = IHEL
C                WRITE(*,*) ngood,IHEL,T
                  ENDIF
              ENDIF
          ENDDO
          JHEL = 1
          ISUM_HEL=MIN(ISUM_HEL,NGOOD)
      ELSE              !RANDOM HELICITY
          DO J=1,ISUM_HEL
              JHEL=JHEL+1
              IF (JHEL .GT. NGOOD) JHEL=1
              HWGT = REAL(NGOOD)/REAL(ISUM_HEL)
              IHEL = IGOOD(JHEL)
              T=MATUUB_TTB(P ,NHEL(1,IHEL),JC(1))            
           ANS(IPROC)=ANS(IPROC)+T*HWGT
          ENDDO
          IF (ISUM_HEL .EQ. 1) THEN
              WRITE(HEL_BUFF,'(16i5)')(NHEL(i,IHEL),i=1,nexternal)
          ENDIF
      ENDIF
C SF: comment out all instances of multi_channel
c      IF (MULTI_CHANNEL) THEN
c          XTOT=0D0
c          DO IHEL=1,MAPCONFIG(0)
c              XTOT=XTOT+AMP2(MAPCONFIG(IHEL))
c          ENDDO
c          ANS(IPROC)=ANS(IPROC)*AMP2(MAPCONFIG(ICONFIG))/XTOT
c      ENDIF
      ANS(IPROC)=ANS(IPROC)/DBLE(IDEN(IPROC))
      ENDDO
      END
       
       
C SF: the original name MATRIX has been replaced by MATUUB_TTB
      REAL*8 FUNCTION MATUUB_TTB(P,NHEL,IC)
C  
C Generated by MadGraph II Version 3.90. Updated 08/26/05               
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : u u~ -> e+ ve b e- ve~ b~  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS,    NEIGEN 
      PARAMETER (NGRAPHS=   1,NEIGEN=  1) 
C SF: replace the following include with the explicit inclusion of
c nexternal.inc, originally included by genps.inc
c      include "genps.inc"
      integer    nexternal
      parameter (nexternal=  8)
      INTEGER    NWAVEFUNCS     , NCOLOR
      PARAMETER (NWAVEFUNCS=  13, NCOLOR=   1) 
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      REAL*8 P(0:3,NEXTERNAL)
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J
      COMPLEX*16 ZTEMP
      REAL*8 DENOM(NCOLOR), CF(NCOLOR,NCOLOR)
      COMPLEX*16 AMP(NGRAPHS), JAMP(NCOLOR)
      COMPLEX*16 W(6,NWAVEFUNCS)
C  
C GLOBAL VARIABLES
C  
C SF: comment out all instances of amp2, used by multi_channel
c      Double Precision amp2(maxamps), jamp2(0:maxamps)
c      common/to_amps/  amp2,       jamp2
C SF: The original coupl.inc has been renamed MEcoupl.inc
      include "MEcoupl.inc"
C  
C COLOR DATA
C  
      DATA Denom(1  )/            1/                                       
      DATA (CF(i,1  ),i=1  ,1  ) /     2/                                  
C               T[8,2]T[1,5]                                               
C ----------
C BEGIN CODE
C ----------
      CALL IXXXXX(P(0,1   ),ZERO ,NHEL(1   ),+1*IC(1   ),W(1,1   ))
      CALL OXXXXX(P(0,2   ),ZERO ,NHEL(2   ),-1*IC(2   ),W(1,2   ))
      CALL IXXXXX(P(0,3   ),ZERO ,NHEL(3   ),-1*IC(3   ),W(1,3   ))
      CALL OXXXXX(P(0,4   ),ZERO ,NHEL(4   ),+1*IC(4   ),W(1,4   ))
      CALL OXXXXX(P(0,5   ),BMASS ,NHEL(5   ),+1*IC(5   ),W(1,5   ))
      CALL OXXXXX(P(0,6   ),ZERO ,NHEL(6   ),+1*IC(6   ),W(1,6   ))
      CALL IXXXXX(P(0,7   ),ZERO ,NHEL(7   ),-1*IC(7   ),W(1,7   ))
      CALL IXXXXX(P(0,8   ),BMASS ,NHEL(8   ),-1*IC(8   ),W(1,8   ))
      CALL JIOXXX(W(1,1   ),W(1,2   ),GG ,ZERO    ,ZERO    ,W(1,9   ))
      CALL JIOXXX(W(1,3   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,10  ))
      CALL FVOXXX(W(1,5   ),W(1,10  ),GWF ,TMASS   ,TWIDTH  ,W(1,11  ))
      CALL FVOXXX(W(1,11  ),W(1,9   ),GG ,TMASS   ,TWIDTH  ,W(1,12  ))
      CALL JIOXXX(W(1,7   ),W(1,6   ),GWF ,WMASS   ,WWIDTH  ,W(1,13  ))
      CALL IOVXXX(W(1,8   ),W(1,12  ),W(1,13  ),GWF ,AMP(1   ))
      JAMP(   1) = +AMP(   1)
      MATUUB_TTB = 0.D0 
      DO I = 1, NCOLOR
          ZTEMP = (0.D0,0.D0)
          DO J = 1, NCOLOR
              ZTEMP = ZTEMP + CF(J,I)*JAMP(J)
          ENDDO
          MATUUB_TTB =MATUUB_TTB+ZTEMP*DCONJG(JAMP(I))/DENOM(I)   
      ENDDO
C SF: comment out all instances of amp2, used by multi_channel
c      Do I = 1, NGRAPHS
c          amp2(i)=amp2(i)+amp(i)*dconjg(amp(i))
c      Enddo
c      Do I = 1, NCOLOR
c          Jamp2(i)=Jamp2(i)+Jamp(i)*dconjg(Jamp(i))
c      Enddo
C      CALL GAUGECHECK(JAMP,ZTEMP,EIGEN_VEC,EIGEN_VAL,NCOLOR,NEIGEN) 
      END
c
c
c End of qqbar --> ttbar
c
c
c
c
c Begin of gg --> ttbar
c
c
C SF: The following routine is SMATRIX generated by MadEvent, suitably modified
      SUBROUTINE GG_TTB(P1,ANS)
C  
C Generated by MadGraph II Version 3.90. Updated 08/26/05               
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C AND HELICITIES
C FOR THE POINT IN PHASE SPACE P(0:3,NEXTERNAL)
C  
C FOR PROCESS : g g -> e+ ve b e- ve~ b~  
C  
C Crossing   1 is g g -> e+ ve b e- ve~ b~  
      IMPLICIT NONE
C  
C CONSTANTS
C  
C SF: replace the following include with the explicit inclusion of
c nexternal.inc, originally included by genps.inc
c      Include "genps.inc"
      integer    nexternal
      parameter (nexternal=  8)
      INTEGER                 NCOMB,     NCROSS         
      PARAMETER (             NCOMB= 256, NCROSS=  1)
      INTEGER    THEL
      PARAMETER (THEL=NCOMB*NCROSS)
C  
C ARGUMENTS 
C  
      REAL*8 P1(0:3,NEXTERNAL),ANS(NCROSS)
C  
C LOCAL VARIABLES 
C  
      INTEGER NHEL(NEXTERNAL,NCOMB),NTRY
      REAL*8 T, P(0:3,NEXTERNAL)
      REAL*8 MATGG_TTB
      INTEGER IHEL,IDEN(NCROSS),IC(NEXTERNAL,NCROSS)
      INTEGER IPROC,JC(NEXTERNAL), I
      LOGICAL GOODHEL(NCOMB,NCROSS)
      INTEGER NGRAPHS
      REAL*8 hwgt, xtot, xtry, xrej, xr, yfrac(0:ncomb)
      INTEGER idum, ngood, igood(ncomb), jhel, j
      LOGICAL warned
      REAL     xran1
      EXTERNAL xran1
C  
C GLOBAL VARIABLES
C  
C SF: comment out all instances of amp2, used by multi_channel
c      Double Precision amp2(maxamps), jamp2(0:maxamps)
c      common/to_amps/  amp2,       jamp2

      character*79         hel_buff
C SF: comment out all common blocks
c      common/to_helicity/  hel_buff

      integer          isum_hel
      logical                    multi_channel
C SF: comment out all common blocks
c      common/to_matrix/isum_hel, multi_channel
C SF: comment out all instances of mapconfig, used by multi_channel
c      INTEGER MAPCONFIG(0:LMAXCONFIGS), ICONFIG
c      common/to_mconfigs/mapconfig, iconfig
      DATA NTRY,IDUM /0,-1/
      DATA xtry, xrej, ngood /0,0,0/
      DATA warned, isum_hel/.false.,0/
      DATA multi_channel/.true./
      SAVE yfrac, igood, IDUM, jhel
      DATA NGRAPHS /    3/          
C SF: comment out all instances of amp2, used by multi_channel
c      DATA jamp2(0) /   2/          
      DATA GOODHEL/THEL*.FALSE./
      DATA (NHEL(IHEL,   1),IHEL=1,8) /-1,-1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,   2),IHEL=1,8) /-1,-1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,   3),IHEL=1,8) /-1,-1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,   4),IHEL=1,8) /-1,-1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,   5),IHEL=1,8) /-1,-1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,   6),IHEL=1,8) /-1,-1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,   7),IHEL=1,8) /-1,-1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,   8),IHEL=1,8) /-1,-1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,   9),IHEL=1,8) /-1,-1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  10),IHEL=1,8) /-1,-1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  11),IHEL=1,8) /-1,-1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  12),IHEL=1,8) /-1,-1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  13),IHEL=1,8) /-1,-1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  14),IHEL=1,8) /-1,-1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  15),IHEL=1,8) /-1,-1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  16),IHEL=1,8) /-1,-1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  17),IHEL=1,8) /-1,-1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  18),IHEL=1,8) /-1,-1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  19),IHEL=1,8) /-1,-1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  20),IHEL=1,8) /-1,-1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  21),IHEL=1,8) /-1,-1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  22),IHEL=1,8) /-1,-1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  23),IHEL=1,8) /-1,-1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  24),IHEL=1,8) /-1,-1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  25),IHEL=1,8) /-1,-1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  26),IHEL=1,8) /-1,-1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  27),IHEL=1,8) /-1,-1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  28),IHEL=1,8) /-1,-1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  29),IHEL=1,8) /-1,-1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  30),IHEL=1,8) /-1,-1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  31),IHEL=1,8) /-1,-1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  32),IHEL=1,8) /-1,-1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  33),IHEL=1,8) /-1,-1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  34),IHEL=1,8) /-1,-1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  35),IHEL=1,8) /-1,-1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  36),IHEL=1,8) /-1,-1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  37),IHEL=1,8) /-1,-1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  38),IHEL=1,8) /-1,-1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  39),IHEL=1,8) /-1,-1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  40),IHEL=1,8) /-1,-1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  41),IHEL=1,8) /-1,-1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  42),IHEL=1,8) /-1,-1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  43),IHEL=1,8) /-1,-1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  44),IHEL=1,8) /-1,-1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  45),IHEL=1,8) /-1,-1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  46),IHEL=1,8) /-1,-1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  47),IHEL=1,8) /-1,-1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  48),IHEL=1,8) /-1,-1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  49),IHEL=1,8) /-1,-1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  50),IHEL=1,8) /-1,-1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  51),IHEL=1,8) /-1,-1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  52),IHEL=1,8) /-1,-1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  53),IHEL=1,8) /-1,-1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  54),IHEL=1,8) /-1,-1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  55),IHEL=1,8) /-1,-1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  56),IHEL=1,8) /-1,-1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  57),IHEL=1,8) /-1,-1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  58),IHEL=1,8) /-1,-1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  59),IHEL=1,8) /-1,-1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  60),IHEL=1,8) /-1,-1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  61),IHEL=1,8) /-1,-1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  62),IHEL=1,8) /-1,-1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  63),IHEL=1,8) /-1,-1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  64),IHEL=1,8) /-1,-1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  65),IHEL=1,8) /-1, 1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  66),IHEL=1,8) /-1, 1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  67),IHEL=1,8) /-1, 1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  68),IHEL=1,8) /-1, 1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  69),IHEL=1,8) /-1, 1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  70),IHEL=1,8) /-1, 1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  71),IHEL=1,8) /-1, 1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  72),IHEL=1,8) /-1, 1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  73),IHEL=1,8) /-1, 1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  74),IHEL=1,8) /-1, 1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  75),IHEL=1,8) /-1, 1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  76),IHEL=1,8) /-1, 1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  77),IHEL=1,8) /-1, 1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  78),IHEL=1,8) /-1, 1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  79),IHEL=1,8) /-1, 1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  80),IHEL=1,8) /-1, 1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  81),IHEL=1,8) /-1, 1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  82),IHEL=1,8) /-1, 1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  83),IHEL=1,8) /-1, 1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  84),IHEL=1,8) /-1, 1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  85),IHEL=1,8) /-1, 1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  86),IHEL=1,8) /-1, 1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  87),IHEL=1,8) /-1, 1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  88),IHEL=1,8) /-1, 1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  89),IHEL=1,8) /-1, 1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  90),IHEL=1,8) /-1, 1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  91),IHEL=1,8) /-1, 1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  92),IHEL=1,8) /-1, 1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  93),IHEL=1,8) /-1, 1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  94),IHEL=1,8) /-1, 1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  95),IHEL=1,8) /-1, 1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  96),IHEL=1,8) /-1, 1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  97),IHEL=1,8) /-1, 1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  98),IHEL=1,8) /-1, 1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  99),IHEL=1,8) /-1, 1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 100),IHEL=1,8) /-1, 1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 101),IHEL=1,8) /-1, 1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 102),IHEL=1,8) /-1, 1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 103),IHEL=1,8) /-1, 1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 104),IHEL=1,8) /-1, 1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 105),IHEL=1,8) /-1, 1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 106),IHEL=1,8) /-1, 1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 107),IHEL=1,8) /-1, 1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 108),IHEL=1,8) /-1, 1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 109),IHEL=1,8) /-1, 1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 110),IHEL=1,8) /-1, 1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 111),IHEL=1,8) /-1, 1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 112),IHEL=1,8) /-1, 1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 113),IHEL=1,8) /-1, 1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 114),IHEL=1,8) /-1, 1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 115),IHEL=1,8) /-1, 1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 116),IHEL=1,8) /-1, 1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 117),IHEL=1,8) /-1, 1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 118),IHEL=1,8) /-1, 1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 119),IHEL=1,8) /-1, 1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 120),IHEL=1,8) /-1, 1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 121),IHEL=1,8) /-1, 1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 122),IHEL=1,8) /-1, 1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 123),IHEL=1,8) /-1, 1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 124),IHEL=1,8) /-1, 1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 125),IHEL=1,8) /-1, 1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 126),IHEL=1,8) /-1, 1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 127),IHEL=1,8) /-1, 1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 128),IHEL=1,8) /-1, 1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 129),IHEL=1,8) / 1,-1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 130),IHEL=1,8) / 1,-1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 131),IHEL=1,8) / 1,-1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 132),IHEL=1,8) / 1,-1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 133),IHEL=1,8) / 1,-1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 134),IHEL=1,8) / 1,-1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 135),IHEL=1,8) / 1,-1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 136),IHEL=1,8) / 1,-1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 137),IHEL=1,8) / 1,-1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 138),IHEL=1,8) / 1,-1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 139),IHEL=1,8) / 1,-1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 140),IHEL=1,8) / 1,-1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 141),IHEL=1,8) / 1,-1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 142),IHEL=1,8) / 1,-1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 143),IHEL=1,8) / 1,-1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 144),IHEL=1,8) / 1,-1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 145),IHEL=1,8) / 1,-1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 146),IHEL=1,8) / 1,-1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 147),IHEL=1,8) / 1,-1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 148),IHEL=1,8) / 1,-1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 149),IHEL=1,8) / 1,-1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 150),IHEL=1,8) / 1,-1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 151),IHEL=1,8) / 1,-1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 152),IHEL=1,8) / 1,-1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 153),IHEL=1,8) / 1,-1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 154),IHEL=1,8) / 1,-1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 155),IHEL=1,8) / 1,-1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 156),IHEL=1,8) / 1,-1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 157),IHEL=1,8) / 1,-1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 158),IHEL=1,8) / 1,-1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 159),IHEL=1,8) / 1,-1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 160),IHEL=1,8) / 1,-1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 161),IHEL=1,8) / 1,-1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 162),IHEL=1,8) / 1,-1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 163),IHEL=1,8) / 1,-1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 164),IHEL=1,8) / 1,-1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 165),IHEL=1,8) / 1,-1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 166),IHEL=1,8) / 1,-1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 167),IHEL=1,8) / 1,-1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 168),IHEL=1,8) / 1,-1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 169),IHEL=1,8) / 1,-1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 170),IHEL=1,8) / 1,-1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 171),IHEL=1,8) / 1,-1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 172),IHEL=1,8) / 1,-1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 173),IHEL=1,8) / 1,-1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 174),IHEL=1,8) / 1,-1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 175),IHEL=1,8) / 1,-1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 176),IHEL=1,8) / 1,-1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 177),IHEL=1,8) / 1,-1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 178),IHEL=1,8) / 1,-1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 179),IHEL=1,8) / 1,-1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 180),IHEL=1,8) / 1,-1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 181),IHEL=1,8) / 1,-1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 182),IHEL=1,8) / 1,-1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 183),IHEL=1,8) / 1,-1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 184),IHEL=1,8) / 1,-1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 185),IHEL=1,8) / 1,-1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 186),IHEL=1,8) / 1,-1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 187),IHEL=1,8) / 1,-1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 188),IHEL=1,8) / 1,-1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 189),IHEL=1,8) / 1,-1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 190),IHEL=1,8) / 1,-1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 191),IHEL=1,8) / 1,-1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 192),IHEL=1,8) / 1,-1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 193),IHEL=1,8) / 1, 1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 194),IHEL=1,8) / 1, 1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 195),IHEL=1,8) / 1, 1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 196),IHEL=1,8) / 1, 1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 197),IHEL=1,8) / 1, 1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 198),IHEL=1,8) / 1, 1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 199),IHEL=1,8) / 1, 1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 200),IHEL=1,8) / 1, 1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 201),IHEL=1,8) / 1, 1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 202),IHEL=1,8) / 1, 1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 203),IHEL=1,8) / 1, 1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 204),IHEL=1,8) / 1, 1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 205),IHEL=1,8) / 1, 1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 206),IHEL=1,8) / 1, 1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 207),IHEL=1,8) / 1, 1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 208),IHEL=1,8) / 1, 1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 209),IHEL=1,8) / 1, 1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 210),IHEL=1,8) / 1, 1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 211),IHEL=1,8) / 1, 1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 212),IHEL=1,8) / 1, 1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 213),IHEL=1,8) / 1, 1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 214),IHEL=1,8) / 1, 1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 215),IHEL=1,8) / 1, 1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 216),IHEL=1,8) / 1, 1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 217),IHEL=1,8) / 1, 1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 218),IHEL=1,8) / 1, 1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 219),IHEL=1,8) / 1, 1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 220),IHEL=1,8) / 1, 1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 221),IHEL=1,8) / 1, 1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 222),IHEL=1,8) / 1, 1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 223),IHEL=1,8) / 1, 1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 224),IHEL=1,8) / 1, 1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 225),IHEL=1,8) / 1, 1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 226),IHEL=1,8) / 1, 1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 227),IHEL=1,8) / 1, 1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 228),IHEL=1,8) / 1, 1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 229),IHEL=1,8) / 1, 1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 230),IHEL=1,8) / 1, 1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 231),IHEL=1,8) / 1, 1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 232),IHEL=1,8) / 1, 1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 233),IHEL=1,8) / 1, 1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 234),IHEL=1,8) / 1, 1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 235),IHEL=1,8) / 1, 1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 236),IHEL=1,8) / 1, 1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 237),IHEL=1,8) / 1, 1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 238),IHEL=1,8) / 1, 1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 239),IHEL=1,8) / 1, 1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 240),IHEL=1,8) / 1, 1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 241),IHEL=1,8) / 1, 1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 242),IHEL=1,8) / 1, 1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 243),IHEL=1,8) / 1, 1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 244),IHEL=1,8) / 1, 1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 245),IHEL=1,8) / 1, 1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 246),IHEL=1,8) / 1, 1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 247),IHEL=1,8) / 1, 1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 248),IHEL=1,8) / 1, 1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 249),IHEL=1,8) / 1, 1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 250),IHEL=1,8) / 1, 1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 251),IHEL=1,8) / 1, 1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 252),IHEL=1,8) / 1, 1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 253),IHEL=1,8) / 1, 1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 254),IHEL=1,8) / 1, 1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 255),IHEL=1,8) / 1, 1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 256),IHEL=1,8) / 1, 1, 1, 1, 1, 1, 1, 1/
      DATA (  IC(IHEL,  1),IHEL=1,8) / 1, 2, 3, 4, 5, 6, 7, 8/
      DATA (IDEN(IHEL),IHEL=  1,  1) / 256/
C ----------
C BEGIN CODE
C ----------
      NTRY=NTRY+1
      DO IPROC=1,NCROSS
      CALL SWITCHMOM(P1,P,IC(1,IPROC),JC,NEXTERNAL)
      DO IHEL=1,NEXTERNAL
         JC(IHEL) = +1
      ENDDO
       
C SF: comment out all instances of multi_channel
c      IF (multi_channel) THEN
c          DO IHEL=1,NGRAPHS
c              amp2(ihel)=0d0
c              jamp2(ihel)=0d0
c          ENDDO
c          DO IHEL=1,int(jamp2(0))
c              jamp2(ihel)=0d0
c          ENDDO
c      ENDIF
      ANS(IPROC) = 0D0
      write(hel_buff,'(16i5)') (0,i=1,nexternal)
      IF (ISUM_HEL .EQ. 0 .OR. NTRY .LT. 10) THEN
          DO IHEL=1,NCOMB
              IF (GOODHEL(IHEL,IPROC) .OR. NTRY .LT. 2) THEN
                 T=MATGG_TTB(P ,NHEL(1,IHEL),JC(1))            
                 ANS(IPROC)=ANS(IPROC)+T
                  IF (T .GT. 0D0 .AND. .NOT. GOODHEL(IHEL,IPROC)) THEN
                      GOODHEL(IHEL,IPROC)=.TRUE.
                      NGOOD = NGOOD +1
                      IGOOD(NGOOD) = IHEL
C                WRITE(*,*) ngood,IHEL,T
                  ENDIF
              ENDIF
          ENDDO
          JHEL = 1
          ISUM_HEL=MIN(ISUM_HEL,NGOOD)
      ELSE              !RANDOM HELICITY
          DO J=1,ISUM_HEL
              JHEL=JHEL+1
              IF (JHEL .GT. NGOOD) JHEL=1
              HWGT = REAL(NGOOD)/REAL(ISUM_HEL)
              IHEL = IGOOD(JHEL)
              T=MATGG_TTB(P ,NHEL(1,IHEL),JC(1))            
           ANS(IPROC)=ANS(IPROC)+T*HWGT
          ENDDO
          IF (ISUM_HEL .EQ. 1) THEN
              WRITE(HEL_BUFF,'(16i5)')(NHEL(i,IHEL),i=1,nexternal)
          ENDIF
      ENDIF
C SF: comment out all instances of multi_channel
c      IF (MULTI_CHANNEL) THEN
c          XTOT=0D0
c          DO IHEL=1,MAPCONFIG(0)
c              XTOT=XTOT+AMP2(MAPCONFIG(IHEL))
c          ENDDO
c          ANS(IPROC)=ANS(IPROC)*AMP2(MAPCONFIG(ICONFIG))/XTOT
c      ENDIF
      ANS(IPROC)=ANS(IPROC)/DBLE(IDEN(IPROC))
      ENDDO
      END
       
       
C SF: the original name MATRIX has been replaced by MATGG_TTB
      REAL*8 FUNCTION MATGG_TTB(P,NHEL,IC)
C  
C Generated by MadGraph II Version 3.90. Updated 08/26/05               
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : g g -> e+ ve b e- ve~ b~  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS,    NEIGEN 
      PARAMETER (NGRAPHS=   3,NEIGEN=  2) 
C SF: replace the following include with the explicit inclusion of
c nexternal.inc, originally included by genps.inc
c      include "genps.inc"
      integer    nexternal
      parameter (nexternal=  8)
      INTEGER    NWAVEFUNCS     , NCOLOR
      PARAMETER (NWAVEFUNCS=  16, NCOLOR=   2) 
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      REAL*8 P(0:3,NEXTERNAL)
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J
      COMPLEX*16 ZTEMP
      REAL*8 DENOM(NCOLOR), CF(NCOLOR,NCOLOR)
      COMPLEX*16 AMP(NGRAPHS), JAMP(NCOLOR)
      COMPLEX*16 W(6,NWAVEFUNCS)
C  
C GLOBAL VARIABLES
C  
C SF: comment out all instances of amp2, used by multi_channel
c      Double Precision amp2(maxamps), jamp2(0:maxamps)
c      common/to_amps/  amp2,       jamp2
C SF: The original coupl.inc has been renamed MEcoupl.inc
      include "MEcoupl.inc"
C  
C COLOR DATA
C  
      DATA Denom(1  )/            3/                                       
      DATA (CF(i,1  ),i=1  ,2  ) /    16,   -2/                            
C               T[8,5,1,2]                                                 
      DATA Denom(2  )/            3/                                       
      DATA (CF(i,2  ),i=1  ,2  ) /    -2,   16/                            
C               T[8,5,2,1]                                                 
C ----------
C BEGIN CODE
C ----------
      CALL VXXXXX(P(0,1   ),ZERO ,NHEL(1   ),-1*IC(1   ),W(1,1   ))        
      CALL VXXXXX(P(0,2   ),ZERO ,NHEL(2   ),-1*IC(2   ),W(1,2   ))        
      CALL IXXXXX(P(0,3   ),ZERO ,NHEL(3   ),-1*IC(3   ),W(1,3   ))        
      CALL OXXXXX(P(0,4   ),ZERO ,NHEL(4   ),+1*IC(4   ),W(1,4   ))        
      CALL OXXXXX(P(0,5   ),BMASS ,NHEL(5   ),+1*IC(5   ),W(1,5   ))       
      CALL OXXXXX(P(0,6   ),ZERO ,NHEL(6   ),+1*IC(6   ),W(1,6   ))        
      CALL IXXXXX(P(0,7   ),ZERO ,NHEL(7   ),-1*IC(7   ),W(1,7   ))        
      CALL IXXXXX(P(0,8   ),BMASS ,NHEL(8   ),-1*IC(8   ),W(1,8   ))       
      CALL JIOXXX(W(1,3   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,9   ))    
      CALL FVOXXX(W(1,5   ),W(1,9   ),GWF ,TMASS   ,TWIDTH  ,W(1,10  ))    
      CALL JIOXXX(W(1,7   ),W(1,6   ),GWF ,WMASS   ,WWIDTH  ,W(1,11  ))    
      CALL FVIXXX(W(1,8   ),W(1,11  ),GWF ,TMASS   ,TWIDTH  ,W(1,12  ))    
      CALL FVOXXX(W(1,10  ),W(1,2   ),GG ,TMASS   ,TWIDTH  ,W(1,13  ))     
      CALL IOVXXX(W(1,12  ),W(1,13  ),W(1,1   ),GG ,AMP(1   ))             
      CALL FVOXXX(W(1,10  ),W(1,1   ),GG ,TMASS   ,TWIDTH  ,W(1,14  ))     
      CALL IOVXXX(W(1,12  ),W(1,14  ),W(1,2   ),GG ,AMP(2   ))             
      CALL JVVXXX(W(1,1   ),W(1,2   ),G ,ZERO    ,ZERO    ,W(1,15  ))      
      CALL FVOXXX(W(1,10  ),W(1,15  ),GG ,TMASS   ,TWIDTH  ,W(1,16  ))     
      CALL IOVXXX(W(1,8   ),W(1,16  ),W(1,11  ),GWF ,AMP(3   ))            
      JAMP(   1) = +AMP(   1)-AMP(   3)
      JAMP(   2) = +AMP(   2)+AMP(   3)
      MATGG_TTB = 0.D0 
      DO I = 1, NCOLOR
          ZTEMP = (0.D0,0.D0)
          DO J = 1, NCOLOR
              ZTEMP = ZTEMP + CF(J,I)*JAMP(J)
          ENDDO
          MATGG_TTB =MATGG_TTB+ZTEMP*DCONJG(JAMP(I))/DENOM(I)   
      ENDDO
C SF: comment out all instances of amp2, used by multi_channel
c      Do I = 1, NGRAPHS
c          amp2(i)=amp2(i)+amp(i)*dconjg(amp(i))
c      Enddo
c      Do I = 1, NCOLOR
c          Jamp2(i)=Jamp2(i)+Jamp(i)*dconjg(Jamp(i))
c      Enddo
C      CALL GAUGECHECK(JAMP,ZTEMP,EIGEN_VEC,EIGEN_VAL,NCOLOR,NEIGEN) 
      END
c
c
c End of gg --> ttbar
c
c
c
c
c Begin of qqbar --> ttbar g
c
c
C SF: The following routine is SMATRIX generated by MadEvent, suitably modified
      SUBROUTINE UUB_TTBG(P1,ANS)
C  
C Generated by MadGraph II Version 3.90. Updated 08/26/05               
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C AND HELICITIES
C FOR THE POINT IN PHASE SPACE P(0:3,NEXTERNAL)
C  
C FOR PROCESS : u u~ -> e+ ve b e- ve~ b~ g  
C  
C Crossing   1 is u u~ -> e+ ve b e- ve~ b~ g  
      IMPLICIT NONE
C  
C CONSTANTS
C  
C SF: replace the following include with the explicit inclusion of
c nexternal.inc, originally included by genps.inc
c      Include "genps.inc"
      integer    nexternal
      parameter (nexternal=  9)
      INTEGER                 NCOMB,     NCROSS         
      PARAMETER (             NCOMB= 512, NCROSS=  1)
      INTEGER    THEL
      PARAMETER (THEL=NCOMB*NCROSS)
C  
C ARGUMENTS 
C  
      REAL*8 P1(0:3,NEXTERNAL),ANS(NCROSS)
C  
C LOCAL VARIABLES 
C  
      INTEGER NHEL(NEXTERNAL,NCOMB),NTRY
      REAL*8 T, P(0:3,NEXTERNAL)
      REAL*8 MATUUB_TTBG
      INTEGER IHEL,IDEN(NCROSS),IC(NEXTERNAL,NCROSS)
      INTEGER IPROC,JC(NEXTERNAL), I
      LOGICAL GOODHEL(NCOMB,NCROSS)
      INTEGER NGRAPHS
      REAL*8 hwgt, xtot, xtry, xrej, xr, yfrac(0:ncomb)
      INTEGER idum, ngood, igood(ncomb), jhel, j
      LOGICAL warned
      REAL     xran1
      EXTERNAL xran1
C  
C GLOBAL VARIABLES
C  
C SF: comment out all instances of amp2, used by multi_channel
c      Double Precision amp2(maxamps), jamp2(0:maxamps)
c      Double Precision amp2(maxamps), jamp2(0:maxamps)
c      common/to_amps/  amp2,       jamp2

      character*79         hel_buff
C SF: comment out all common blocks
c      common/to_helicity/  hel_buff

      integer          isum_hel
      logical                    multi_channel
C SF: comment out all common blocks
c      common/to_matrix/isum_hel, multi_channel
C SF: comment out all instances of mapconfig, used by multi_channel
c      INTEGER MAPCONFIG(0:LMAXCONFIGS), ICONFIG
c      common/to_mconfigs/mapconfig, iconfig
      DATA NTRY,IDUM /0,-1/
      DATA xtry, xrej, ngood /0,0,0/
      DATA warned, isum_hel/.false.,0/
      DATA multi_channel/.true./
      SAVE yfrac, igood, IDUM, jhel
      DATA NGRAPHS /    5/          
C SF: comment out all instances of amp2, used by multi_channel
c      DATA jamp2(0) /   4/          
      DATA GOODHEL/THEL*.FALSE./
      DATA (NHEL(IHEL,   1),IHEL=1,9) /-1,-1,-1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,   2),IHEL=1,9) /-1,-1,-1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,   3),IHEL=1,9) /-1,-1,-1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,   4),IHEL=1,9) /-1,-1,-1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,   5),IHEL=1,9) /-1,-1,-1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,   6),IHEL=1,9) /-1,-1,-1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,   7),IHEL=1,9) /-1,-1,-1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,   8),IHEL=1,9) /-1,-1,-1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,   9),IHEL=1,9) /-1,-1,-1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  10),IHEL=1,9) /-1,-1,-1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  11),IHEL=1,9) /-1,-1,-1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  12),IHEL=1,9) /-1,-1,-1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  13),IHEL=1,9) /-1,-1,-1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  14),IHEL=1,9) /-1,-1,-1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  15),IHEL=1,9) /-1,-1,-1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  16),IHEL=1,9) /-1,-1,-1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  17),IHEL=1,9) /-1,-1,-1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  18),IHEL=1,9) /-1,-1,-1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  19),IHEL=1,9) /-1,-1,-1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  20),IHEL=1,9) /-1,-1,-1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  21),IHEL=1,9) /-1,-1,-1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  22),IHEL=1,9) /-1,-1,-1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  23),IHEL=1,9) /-1,-1,-1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  24),IHEL=1,9) /-1,-1,-1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  25),IHEL=1,9) /-1,-1,-1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  26),IHEL=1,9) /-1,-1,-1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  27),IHEL=1,9) /-1,-1,-1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  28),IHEL=1,9) /-1,-1,-1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  29),IHEL=1,9) /-1,-1,-1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  30),IHEL=1,9) /-1,-1,-1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  31),IHEL=1,9) /-1,-1,-1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  32),IHEL=1,9) /-1,-1,-1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  33),IHEL=1,9) /-1,-1,-1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  34),IHEL=1,9) /-1,-1,-1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  35),IHEL=1,9) /-1,-1,-1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  36),IHEL=1,9) /-1,-1,-1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  37),IHEL=1,9) /-1,-1,-1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  38),IHEL=1,9) /-1,-1,-1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  39),IHEL=1,9) /-1,-1,-1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  40),IHEL=1,9) /-1,-1,-1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  41),IHEL=1,9) /-1,-1,-1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  42),IHEL=1,9) /-1,-1,-1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  43),IHEL=1,9) /-1,-1,-1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  44),IHEL=1,9) /-1,-1,-1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  45),IHEL=1,9) /-1,-1,-1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  46),IHEL=1,9) /-1,-1,-1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  47),IHEL=1,9) /-1,-1,-1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  48),IHEL=1,9) /-1,-1,-1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  49),IHEL=1,9) /-1,-1,-1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  50),IHEL=1,9) /-1,-1,-1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  51),IHEL=1,9) /-1,-1,-1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  52),IHEL=1,9) /-1,-1,-1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  53),IHEL=1,9) /-1,-1,-1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  54),IHEL=1,9) /-1,-1,-1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  55),IHEL=1,9) /-1,-1,-1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  56),IHEL=1,9) /-1,-1,-1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  57),IHEL=1,9) /-1,-1,-1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  58),IHEL=1,9) /-1,-1,-1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  59),IHEL=1,9) /-1,-1,-1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  60),IHEL=1,9) /-1,-1,-1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  61),IHEL=1,9) /-1,-1,-1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  62),IHEL=1,9) /-1,-1,-1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  63),IHEL=1,9) /-1,-1,-1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  64),IHEL=1,9) /-1,-1,-1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  65),IHEL=1,9) /-1,-1, 1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  66),IHEL=1,9) /-1,-1, 1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  67),IHEL=1,9) /-1,-1, 1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  68),IHEL=1,9) /-1,-1, 1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  69),IHEL=1,9) /-1,-1, 1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  70),IHEL=1,9) /-1,-1, 1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  71),IHEL=1,9) /-1,-1, 1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  72),IHEL=1,9) /-1,-1, 1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  73),IHEL=1,9) /-1,-1, 1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  74),IHEL=1,9) /-1,-1, 1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  75),IHEL=1,9) /-1,-1, 1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  76),IHEL=1,9) /-1,-1, 1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  77),IHEL=1,9) /-1,-1, 1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  78),IHEL=1,9) /-1,-1, 1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  79),IHEL=1,9) /-1,-1, 1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  80),IHEL=1,9) /-1,-1, 1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  81),IHEL=1,9) /-1,-1, 1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  82),IHEL=1,9) /-1,-1, 1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  83),IHEL=1,9) /-1,-1, 1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  84),IHEL=1,9) /-1,-1, 1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  85),IHEL=1,9) /-1,-1, 1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  86),IHEL=1,9) /-1,-1, 1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  87),IHEL=1,9) /-1,-1, 1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  88),IHEL=1,9) /-1,-1, 1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  89),IHEL=1,9) /-1,-1, 1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  90),IHEL=1,9) /-1,-1, 1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  91),IHEL=1,9) /-1,-1, 1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  92),IHEL=1,9) /-1,-1, 1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  93),IHEL=1,9) /-1,-1, 1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  94),IHEL=1,9) /-1,-1, 1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  95),IHEL=1,9) /-1,-1, 1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  96),IHEL=1,9) /-1,-1, 1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  97),IHEL=1,9) /-1,-1, 1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  98),IHEL=1,9) /-1,-1, 1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  99),IHEL=1,9) /-1,-1, 1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 100),IHEL=1,9) /-1,-1, 1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 101),IHEL=1,9) /-1,-1, 1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 102),IHEL=1,9) /-1,-1, 1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 103),IHEL=1,9) /-1,-1, 1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 104),IHEL=1,9) /-1,-1, 1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 105),IHEL=1,9) /-1,-1, 1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 106),IHEL=1,9) /-1,-1, 1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 107),IHEL=1,9) /-1,-1, 1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 108),IHEL=1,9) /-1,-1, 1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 109),IHEL=1,9) /-1,-1, 1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 110),IHEL=1,9) /-1,-1, 1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 111),IHEL=1,9) /-1,-1, 1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 112),IHEL=1,9) /-1,-1, 1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 113),IHEL=1,9) /-1,-1, 1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 114),IHEL=1,9) /-1,-1, 1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 115),IHEL=1,9) /-1,-1, 1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 116),IHEL=1,9) /-1,-1, 1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 117),IHEL=1,9) /-1,-1, 1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 118),IHEL=1,9) /-1,-1, 1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 119),IHEL=1,9) /-1,-1, 1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 120),IHEL=1,9) /-1,-1, 1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 121),IHEL=1,9) /-1,-1, 1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 122),IHEL=1,9) /-1,-1, 1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 123),IHEL=1,9) /-1,-1, 1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 124),IHEL=1,9) /-1,-1, 1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 125),IHEL=1,9) /-1,-1, 1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 126),IHEL=1,9) /-1,-1, 1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 127),IHEL=1,9) /-1,-1, 1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 128),IHEL=1,9) /-1,-1, 1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 129),IHEL=1,9) /-1, 1,-1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 130),IHEL=1,9) /-1, 1,-1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 131),IHEL=1,9) /-1, 1,-1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 132),IHEL=1,9) /-1, 1,-1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 133),IHEL=1,9) /-1, 1,-1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 134),IHEL=1,9) /-1, 1,-1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 135),IHEL=1,9) /-1, 1,-1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 136),IHEL=1,9) /-1, 1,-1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 137),IHEL=1,9) /-1, 1,-1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 138),IHEL=1,9) /-1, 1,-1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 139),IHEL=1,9) /-1, 1,-1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 140),IHEL=1,9) /-1, 1,-1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 141),IHEL=1,9) /-1, 1,-1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 142),IHEL=1,9) /-1, 1,-1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 143),IHEL=1,9) /-1, 1,-1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 144),IHEL=1,9) /-1, 1,-1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 145),IHEL=1,9) /-1, 1,-1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 146),IHEL=1,9) /-1, 1,-1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 147),IHEL=1,9) /-1, 1,-1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 148),IHEL=1,9) /-1, 1,-1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 149),IHEL=1,9) /-1, 1,-1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 150),IHEL=1,9) /-1, 1,-1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 151),IHEL=1,9) /-1, 1,-1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 152),IHEL=1,9) /-1, 1,-1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 153),IHEL=1,9) /-1, 1,-1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 154),IHEL=1,9) /-1, 1,-1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 155),IHEL=1,9) /-1, 1,-1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 156),IHEL=1,9) /-1, 1,-1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 157),IHEL=1,9) /-1, 1,-1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 158),IHEL=1,9) /-1, 1,-1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 159),IHEL=1,9) /-1, 1,-1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 160),IHEL=1,9) /-1, 1,-1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 161),IHEL=1,9) /-1, 1,-1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 162),IHEL=1,9) /-1, 1,-1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 163),IHEL=1,9) /-1, 1,-1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 164),IHEL=1,9) /-1, 1,-1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 165),IHEL=1,9) /-1, 1,-1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 166),IHEL=1,9) /-1, 1,-1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 167),IHEL=1,9) /-1, 1,-1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 168),IHEL=1,9) /-1, 1,-1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 169),IHEL=1,9) /-1, 1,-1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 170),IHEL=1,9) /-1, 1,-1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 171),IHEL=1,9) /-1, 1,-1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 172),IHEL=1,9) /-1, 1,-1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 173),IHEL=1,9) /-1, 1,-1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 174),IHEL=1,9) /-1, 1,-1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 175),IHEL=1,9) /-1, 1,-1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 176),IHEL=1,9) /-1, 1,-1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 177),IHEL=1,9) /-1, 1,-1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 178),IHEL=1,9) /-1, 1,-1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 179),IHEL=1,9) /-1, 1,-1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 180),IHEL=1,9) /-1, 1,-1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 181),IHEL=1,9) /-1, 1,-1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 182),IHEL=1,9) /-1, 1,-1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 183),IHEL=1,9) /-1, 1,-1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 184),IHEL=1,9) /-1, 1,-1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 185),IHEL=1,9) /-1, 1,-1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 186),IHEL=1,9) /-1, 1,-1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 187),IHEL=1,9) /-1, 1,-1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 188),IHEL=1,9) /-1, 1,-1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 189),IHEL=1,9) /-1, 1,-1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 190),IHEL=1,9) /-1, 1,-1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 191),IHEL=1,9) /-1, 1,-1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 192),IHEL=1,9) /-1, 1,-1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 193),IHEL=1,9) /-1, 1, 1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 194),IHEL=1,9) /-1, 1, 1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 195),IHEL=1,9) /-1, 1, 1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 196),IHEL=1,9) /-1, 1, 1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 197),IHEL=1,9) /-1, 1, 1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 198),IHEL=1,9) /-1, 1, 1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 199),IHEL=1,9) /-1, 1, 1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 200),IHEL=1,9) /-1, 1, 1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 201),IHEL=1,9) /-1, 1, 1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 202),IHEL=1,9) /-1, 1, 1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 203),IHEL=1,9) /-1, 1, 1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 204),IHEL=1,9) /-1, 1, 1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 205),IHEL=1,9) /-1, 1, 1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 206),IHEL=1,9) /-1, 1, 1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 207),IHEL=1,9) /-1, 1, 1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 208),IHEL=1,9) /-1, 1, 1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 209),IHEL=1,9) /-1, 1, 1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 210),IHEL=1,9) /-1, 1, 1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 211),IHEL=1,9) /-1, 1, 1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 212),IHEL=1,9) /-1, 1, 1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 213),IHEL=1,9) /-1, 1, 1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 214),IHEL=1,9) /-1, 1, 1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 215),IHEL=1,9) /-1, 1, 1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 216),IHEL=1,9) /-1, 1, 1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 217),IHEL=1,9) /-1, 1, 1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 218),IHEL=1,9) /-1, 1, 1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 219),IHEL=1,9) /-1, 1, 1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 220),IHEL=1,9) /-1, 1, 1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 221),IHEL=1,9) /-1, 1, 1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 222),IHEL=1,9) /-1, 1, 1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 223),IHEL=1,9) /-1, 1, 1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 224),IHEL=1,9) /-1, 1, 1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 225),IHEL=1,9) /-1, 1, 1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 226),IHEL=1,9) /-1, 1, 1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 227),IHEL=1,9) /-1, 1, 1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 228),IHEL=1,9) /-1, 1, 1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 229),IHEL=1,9) /-1, 1, 1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 230),IHEL=1,9) /-1, 1, 1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 231),IHEL=1,9) /-1, 1, 1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 232),IHEL=1,9) /-1, 1, 1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 233),IHEL=1,9) /-1, 1, 1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 234),IHEL=1,9) /-1, 1, 1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 235),IHEL=1,9) /-1, 1, 1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 236),IHEL=1,9) /-1, 1, 1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 237),IHEL=1,9) /-1, 1, 1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 238),IHEL=1,9) /-1, 1, 1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 239),IHEL=1,9) /-1, 1, 1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 240),IHEL=1,9) /-1, 1, 1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 241),IHEL=1,9) /-1, 1, 1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 242),IHEL=1,9) /-1, 1, 1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 243),IHEL=1,9) /-1, 1, 1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 244),IHEL=1,9) /-1, 1, 1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 245),IHEL=1,9) /-1, 1, 1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 246),IHEL=1,9) /-1, 1, 1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 247),IHEL=1,9) /-1, 1, 1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 248),IHEL=1,9) /-1, 1, 1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 249),IHEL=1,9) /-1, 1, 1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 250),IHEL=1,9) /-1, 1, 1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 251),IHEL=1,9) /-1, 1, 1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 252),IHEL=1,9) /-1, 1, 1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 253),IHEL=1,9) /-1, 1, 1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 254),IHEL=1,9) /-1, 1, 1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 255),IHEL=1,9) /-1, 1, 1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 256),IHEL=1,9) /-1, 1, 1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 257),IHEL=1,9) / 1,-1,-1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 258),IHEL=1,9) / 1,-1,-1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 259),IHEL=1,9) / 1,-1,-1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 260),IHEL=1,9) / 1,-1,-1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 261),IHEL=1,9) / 1,-1,-1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 262),IHEL=1,9) / 1,-1,-1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 263),IHEL=1,9) / 1,-1,-1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 264),IHEL=1,9) / 1,-1,-1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 265),IHEL=1,9) / 1,-1,-1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 266),IHEL=1,9) / 1,-1,-1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 267),IHEL=1,9) / 1,-1,-1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 268),IHEL=1,9) / 1,-1,-1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 269),IHEL=1,9) / 1,-1,-1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 270),IHEL=1,9) / 1,-1,-1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 271),IHEL=1,9) / 1,-1,-1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 272),IHEL=1,9) / 1,-1,-1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 273),IHEL=1,9) / 1,-1,-1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 274),IHEL=1,9) / 1,-1,-1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 275),IHEL=1,9) / 1,-1,-1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 276),IHEL=1,9) / 1,-1,-1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 277),IHEL=1,9) / 1,-1,-1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 278),IHEL=1,9) / 1,-1,-1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 279),IHEL=1,9) / 1,-1,-1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 280),IHEL=1,9) / 1,-1,-1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 281),IHEL=1,9) / 1,-1,-1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 282),IHEL=1,9) / 1,-1,-1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 283),IHEL=1,9) / 1,-1,-1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 284),IHEL=1,9) / 1,-1,-1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 285),IHEL=1,9) / 1,-1,-1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 286),IHEL=1,9) / 1,-1,-1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 287),IHEL=1,9) / 1,-1,-1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 288),IHEL=1,9) / 1,-1,-1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 289),IHEL=1,9) / 1,-1,-1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 290),IHEL=1,9) / 1,-1,-1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 291),IHEL=1,9) / 1,-1,-1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 292),IHEL=1,9) / 1,-1,-1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 293),IHEL=1,9) / 1,-1,-1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 294),IHEL=1,9) / 1,-1,-1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 295),IHEL=1,9) / 1,-1,-1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 296),IHEL=1,9) / 1,-1,-1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 297),IHEL=1,9) / 1,-1,-1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 298),IHEL=1,9) / 1,-1,-1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 299),IHEL=1,9) / 1,-1,-1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 300),IHEL=1,9) / 1,-1,-1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 301),IHEL=1,9) / 1,-1,-1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 302),IHEL=1,9) / 1,-1,-1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 303),IHEL=1,9) / 1,-1,-1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 304),IHEL=1,9) / 1,-1,-1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 305),IHEL=1,9) / 1,-1,-1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 306),IHEL=1,9) / 1,-1,-1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 307),IHEL=1,9) / 1,-1,-1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 308),IHEL=1,9) / 1,-1,-1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 309),IHEL=1,9) / 1,-1,-1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 310),IHEL=1,9) / 1,-1,-1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 311),IHEL=1,9) / 1,-1,-1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 312),IHEL=1,9) / 1,-1,-1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 313),IHEL=1,9) / 1,-1,-1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 314),IHEL=1,9) / 1,-1,-1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 315),IHEL=1,9) / 1,-1,-1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 316),IHEL=1,9) / 1,-1,-1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 317),IHEL=1,9) / 1,-1,-1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 318),IHEL=1,9) / 1,-1,-1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 319),IHEL=1,9) / 1,-1,-1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 320),IHEL=1,9) / 1,-1,-1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 321),IHEL=1,9) / 1,-1, 1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 322),IHEL=1,9) / 1,-1, 1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 323),IHEL=1,9) / 1,-1, 1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 324),IHEL=1,9) / 1,-1, 1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 325),IHEL=1,9) / 1,-1, 1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 326),IHEL=1,9) / 1,-1, 1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 327),IHEL=1,9) / 1,-1, 1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 328),IHEL=1,9) / 1,-1, 1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 329),IHEL=1,9) / 1,-1, 1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 330),IHEL=1,9) / 1,-1, 1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 331),IHEL=1,9) / 1,-1, 1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 332),IHEL=1,9) / 1,-1, 1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 333),IHEL=1,9) / 1,-1, 1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 334),IHEL=1,9) / 1,-1, 1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 335),IHEL=1,9) / 1,-1, 1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 336),IHEL=1,9) / 1,-1, 1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 337),IHEL=1,9) / 1,-1, 1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 338),IHEL=1,9) / 1,-1, 1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 339),IHEL=1,9) / 1,-1, 1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 340),IHEL=1,9) / 1,-1, 1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 341),IHEL=1,9) / 1,-1, 1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 342),IHEL=1,9) / 1,-1, 1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 343),IHEL=1,9) / 1,-1, 1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 344),IHEL=1,9) / 1,-1, 1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 345),IHEL=1,9) / 1,-1, 1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 346),IHEL=1,9) / 1,-1, 1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 347),IHEL=1,9) / 1,-1, 1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 348),IHEL=1,9) / 1,-1, 1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 349),IHEL=1,9) / 1,-1, 1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 350),IHEL=1,9) / 1,-1, 1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 351),IHEL=1,9) / 1,-1, 1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 352),IHEL=1,9) / 1,-1, 1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 353),IHEL=1,9) / 1,-1, 1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 354),IHEL=1,9) / 1,-1, 1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 355),IHEL=1,9) / 1,-1, 1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 356),IHEL=1,9) / 1,-1, 1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 357),IHEL=1,9) / 1,-1, 1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 358),IHEL=1,9) / 1,-1, 1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 359),IHEL=1,9) / 1,-1, 1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 360),IHEL=1,9) / 1,-1, 1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 361),IHEL=1,9) / 1,-1, 1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 362),IHEL=1,9) / 1,-1, 1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 363),IHEL=1,9) / 1,-1, 1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 364),IHEL=1,9) / 1,-1, 1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 365),IHEL=1,9) / 1,-1, 1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 366),IHEL=1,9) / 1,-1, 1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 367),IHEL=1,9) / 1,-1, 1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 368),IHEL=1,9) / 1,-1, 1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 369),IHEL=1,9) / 1,-1, 1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 370),IHEL=1,9) / 1,-1, 1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 371),IHEL=1,9) / 1,-1, 1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 372),IHEL=1,9) / 1,-1, 1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 373),IHEL=1,9) / 1,-1, 1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 374),IHEL=1,9) / 1,-1, 1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 375),IHEL=1,9) / 1,-1, 1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 376),IHEL=1,9) / 1,-1, 1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 377),IHEL=1,9) / 1,-1, 1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 378),IHEL=1,9) / 1,-1, 1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 379),IHEL=1,9) / 1,-1, 1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 380),IHEL=1,9) / 1,-1, 1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 381),IHEL=1,9) / 1,-1, 1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 382),IHEL=1,9) / 1,-1, 1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 383),IHEL=1,9) / 1,-1, 1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 384),IHEL=1,9) / 1,-1, 1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 385),IHEL=1,9) / 1, 1,-1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 386),IHEL=1,9) / 1, 1,-1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 387),IHEL=1,9) / 1, 1,-1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 388),IHEL=1,9) / 1, 1,-1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 389),IHEL=1,9) / 1, 1,-1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 390),IHEL=1,9) / 1, 1,-1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 391),IHEL=1,9) / 1, 1,-1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 392),IHEL=1,9) / 1, 1,-1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 393),IHEL=1,9) / 1, 1,-1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 394),IHEL=1,9) / 1, 1,-1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 395),IHEL=1,9) / 1, 1,-1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 396),IHEL=1,9) / 1, 1,-1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 397),IHEL=1,9) / 1, 1,-1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 398),IHEL=1,9) / 1, 1,-1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 399),IHEL=1,9) / 1, 1,-1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 400),IHEL=1,9) / 1, 1,-1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 401),IHEL=1,9) / 1, 1,-1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 402),IHEL=1,9) / 1, 1,-1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 403),IHEL=1,9) / 1, 1,-1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 404),IHEL=1,9) / 1, 1,-1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 405),IHEL=1,9) / 1, 1,-1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 406),IHEL=1,9) / 1, 1,-1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 407),IHEL=1,9) / 1, 1,-1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 408),IHEL=1,9) / 1, 1,-1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 409),IHEL=1,9) / 1, 1,-1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 410),IHEL=1,9) / 1, 1,-1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 411),IHEL=1,9) / 1, 1,-1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 412),IHEL=1,9) / 1, 1,-1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 413),IHEL=1,9) / 1, 1,-1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 414),IHEL=1,9) / 1, 1,-1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 415),IHEL=1,9) / 1, 1,-1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 416),IHEL=1,9) / 1, 1,-1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 417),IHEL=1,9) / 1, 1,-1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 418),IHEL=1,9) / 1, 1,-1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 419),IHEL=1,9) / 1, 1,-1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 420),IHEL=1,9) / 1, 1,-1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 421),IHEL=1,9) / 1, 1,-1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 422),IHEL=1,9) / 1, 1,-1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 423),IHEL=1,9) / 1, 1,-1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 424),IHEL=1,9) / 1, 1,-1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 425),IHEL=1,9) / 1, 1,-1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 426),IHEL=1,9) / 1, 1,-1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 427),IHEL=1,9) / 1, 1,-1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 428),IHEL=1,9) / 1, 1,-1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 429),IHEL=1,9) / 1, 1,-1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 430),IHEL=1,9) / 1, 1,-1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 431),IHEL=1,9) / 1, 1,-1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 432),IHEL=1,9) / 1, 1,-1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 433),IHEL=1,9) / 1, 1,-1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 434),IHEL=1,9) / 1, 1,-1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 435),IHEL=1,9) / 1, 1,-1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 436),IHEL=1,9) / 1, 1,-1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 437),IHEL=1,9) / 1, 1,-1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 438),IHEL=1,9) / 1, 1,-1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 439),IHEL=1,9) / 1, 1,-1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 440),IHEL=1,9) / 1, 1,-1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 441),IHEL=1,9) / 1, 1,-1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 442),IHEL=1,9) / 1, 1,-1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 443),IHEL=1,9) / 1, 1,-1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 444),IHEL=1,9) / 1, 1,-1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 445),IHEL=1,9) / 1, 1,-1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 446),IHEL=1,9) / 1, 1,-1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 447),IHEL=1,9) / 1, 1,-1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 448),IHEL=1,9) / 1, 1,-1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 449),IHEL=1,9) / 1, 1, 1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 450),IHEL=1,9) / 1, 1, 1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 451),IHEL=1,9) / 1, 1, 1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 452),IHEL=1,9) / 1, 1, 1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 453),IHEL=1,9) / 1, 1, 1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 454),IHEL=1,9) / 1, 1, 1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 455),IHEL=1,9) / 1, 1, 1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 456),IHEL=1,9) / 1, 1, 1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 457),IHEL=1,9) / 1, 1, 1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 458),IHEL=1,9) / 1, 1, 1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 459),IHEL=1,9) / 1, 1, 1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 460),IHEL=1,9) / 1, 1, 1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 461),IHEL=1,9) / 1, 1, 1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 462),IHEL=1,9) / 1, 1, 1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 463),IHEL=1,9) / 1, 1, 1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 464),IHEL=1,9) / 1, 1, 1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 465),IHEL=1,9) / 1, 1, 1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 466),IHEL=1,9) / 1, 1, 1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 467),IHEL=1,9) / 1, 1, 1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 468),IHEL=1,9) / 1, 1, 1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 469),IHEL=1,9) / 1, 1, 1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 470),IHEL=1,9) / 1, 1, 1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 471),IHEL=1,9) / 1, 1, 1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 472),IHEL=1,9) / 1, 1, 1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 473),IHEL=1,9) / 1, 1, 1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 474),IHEL=1,9) / 1, 1, 1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 475),IHEL=1,9) / 1, 1, 1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 476),IHEL=1,9) / 1, 1, 1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 477),IHEL=1,9) / 1, 1, 1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 478),IHEL=1,9) / 1, 1, 1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 479),IHEL=1,9) / 1, 1, 1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 480),IHEL=1,9) / 1, 1, 1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 481),IHEL=1,9) / 1, 1, 1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 482),IHEL=1,9) / 1, 1, 1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 483),IHEL=1,9) / 1, 1, 1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 484),IHEL=1,9) / 1, 1, 1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 485),IHEL=1,9) / 1, 1, 1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 486),IHEL=1,9) / 1, 1, 1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 487),IHEL=1,9) / 1, 1, 1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 488),IHEL=1,9) / 1, 1, 1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 489),IHEL=1,9) / 1, 1, 1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 490),IHEL=1,9) / 1, 1, 1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 491),IHEL=1,9) / 1, 1, 1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 492),IHEL=1,9) / 1, 1, 1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 493),IHEL=1,9) / 1, 1, 1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 494),IHEL=1,9) / 1, 1, 1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 495),IHEL=1,9) / 1, 1, 1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 496),IHEL=1,9) / 1, 1, 1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 497),IHEL=1,9) / 1, 1, 1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 498),IHEL=1,9) / 1, 1, 1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 499),IHEL=1,9) / 1, 1, 1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 500),IHEL=1,9) / 1, 1, 1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 501),IHEL=1,9) / 1, 1, 1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 502),IHEL=1,9) / 1, 1, 1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 503),IHEL=1,9) / 1, 1, 1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 504),IHEL=1,9) / 1, 1, 1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 505),IHEL=1,9) / 1, 1, 1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 506),IHEL=1,9) / 1, 1, 1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 507),IHEL=1,9) / 1, 1, 1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 508),IHEL=1,9) / 1, 1, 1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 509),IHEL=1,9) / 1, 1, 1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 510),IHEL=1,9) / 1, 1, 1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 511),IHEL=1,9) / 1, 1, 1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 512),IHEL=1,9) / 1, 1, 1, 1, 1, 1, 1, 1, 1/
      DATA (  IC(IHEL,  1),IHEL=1,9) / 1, 2, 3, 4, 5, 6, 7, 8, 9/
      DATA (IDEN(IHEL),IHEL=  1,  1) /  36/
C ----------
C BEGIN CODE
C ----------
      NTRY=NTRY+1
      DO IPROC=1,NCROSS
      CALL SWITCHMOM(P1,P,IC(1,IPROC),JC,NEXTERNAL)
      DO IHEL=1,NEXTERNAL
         JC(IHEL) = +1
      ENDDO
       
C SF: comment out all instances of multi_channel
c      IF (multi_channel) THEN
c          DO IHEL=1,NGRAPHS
c              amp2(ihel)=0d0
c              jamp2(ihel)=0d0
c          ENDDO
c          DO IHEL=1,int(jamp2(0))
c              jamp2(ihel)=0d0
c          ENDDO
c      ENDIF
      ANS(IPROC) = 0D0
      write(hel_buff,'(16i5)') (0,i=1,nexternal)
      IF (ISUM_HEL .EQ. 0 .OR. NTRY .LT. 10) THEN
          DO IHEL=1,NCOMB
              IF (GOODHEL(IHEL,IPROC) .OR. NTRY .LT. 2) THEN
                 T=MATUUB_TTBG(P ,NHEL(1,IHEL),JC(1))            
                 ANS(IPROC)=ANS(IPROC)+T
                  IF (T .GT. 0D0 .AND. .NOT. GOODHEL(IHEL,IPROC)) THEN
                      GOODHEL(IHEL,IPROC)=.TRUE.
                      NGOOD = NGOOD +1
                      IGOOD(NGOOD) = IHEL
C                WRITE(*,*) ngood,IHEL,T
                  ENDIF
              ENDIF
          ENDDO
          JHEL = 1
          ISUM_HEL=MIN(ISUM_HEL,NGOOD)
      ELSE              !RANDOM HELICITY
          DO J=1,ISUM_HEL
              JHEL=JHEL+1
              IF (JHEL .GT. NGOOD) JHEL=1
              HWGT = REAL(NGOOD)/REAL(ISUM_HEL)
              IHEL = IGOOD(JHEL)
              T=MATUUB_TTBG(P ,NHEL(1,IHEL),JC(1))            
           ANS(IPROC)=ANS(IPROC)+T*HWGT
          ENDDO
          IF (ISUM_HEL .EQ. 1) THEN
              WRITE(HEL_BUFF,'(16i5)')(NHEL(i,IHEL),i=1,nexternal)
          ENDIF
      ENDIF
C SF: comment out all instances of multi_channel
c      IF (MULTI_CHANNEL) THEN
c          XTOT=0D0
c          DO IHEL=1,MAPCONFIG(0)
c              XTOT=XTOT+AMP2(MAPCONFIG(IHEL))
c          ENDDO
c          ANS(IPROC)=ANS(IPROC)*AMP2(MAPCONFIG(ICONFIG))/XTOT
c      ENDIF
      ANS(IPROC)=ANS(IPROC)/DBLE(IDEN(IPROC))
      ENDDO
      END
       
       
C SF: the original name MATRIX has been replaced by MATUUB_TTBG
      REAL*8 FUNCTION MATUUB_TTBG(P,NHEL,IC)
C  
C Generated by MadGraph II Version 3.90. Updated 08/26/05               
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : u u~ -> e+ ve b e- ve~ b~ g  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS,    NEIGEN 
      PARAMETER (NGRAPHS=   5,NEIGEN=  4) 
C SF: replace the following include with the explicit inclusion of
c nexternal.inc, originally included by genps.inc
c      include "genps.inc"
      integer    nexternal
      parameter (nexternal=  9)
      INTEGER    NWAVEFUNCS     , NCOLOR
      PARAMETER (NWAVEFUNCS=  21, NCOLOR=   4) 
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      REAL*8 P(0:3,NEXTERNAL)
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J
      COMPLEX*16 ZTEMP
      REAL*8 DENOM(NCOLOR), CF(NCOLOR,NCOLOR)
      COMPLEX*16 AMP(NGRAPHS), JAMP(NCOLOR)
      COMPLEX*16 W(6,NWAVEFUNCS)
C  
C GLOBAL VARIABLES
C  
C SF: comment out all instances of amp2, used by multi_channel
c      Double Precision amp2(maxamps), jamp2(0:maxamps)
c      common/to_amps/  amp2,       jamp2
C SF: The original coupl.inc has been renamed MEcoupl.inc
      include "MEcoupl.inc"
C  
C COLOR DATA
C  
      DATA Denom(1  )/            3/                                       
      DATA (CF(i,1  ),i=1  ,4  ) /     8,   -1,    7,   -2/                
C               T[8,2]T[1,5,9]                                             
      DATA Denom(2  )/            3/                                       
      DATA (CF(i,2  ),i=1  ,4  ) /    -1,    8,   -2,    7/                
C               T[8,2,9]T[1,5]                                             
      DATA Denom(3  )/            3/                                       
      DATA (CF(i,3  ),i=1  ,4  ) /     7,   -2,    8,   -1/                
C               T[8,2]T[1,5,9]                                             
      DATA Denom(4  )/            3/                                       
      DATA (CF(i,4  ),i=1  ,4  ) /    -2,    7,   -1,    8/                
C               T[1,5]T[8,2,9]                                             
C ----------
C BEGIN CODE
C ----------
      CALL IXXXXX(P(0,1   ),ZERO ,NHEL(1   ),+1*IC(1   ),W(1,1   ))        
      CALL OXXXXX(P(0,2   ),ZERO ,NHEL(2   ),-1*IC(2   ),W(1,2   ))        
      CALL IXXXXX(P(0,3   ),ZERO ,NHEL(3   ),-1*IC(3   ),W(1,3   ))        
      CALL OXXXXX(P(0,4   ),ZERO ,NHEL(4   ),+1*IC(4   ),W(1,4   ))        
      CALL OXXXXX(P(0,5   ),BMASS ,NHEL(5   ),+1*IC(5   ),W(1,5   ))       
      CALL OXXXXX(P(0,6   ),ZERO ,NHEL(6   ),+1*IC(6   ),W(1,6   ))        
      CALL IXXXXX(P(0,7   ),ZERO ,NHEL(7   ),-1*IC(7   ),W(1,7   ))        
      CALL IXXXXX(P(0,8   ),BMASS ,NHEL(8   ),-1*IC(8   ),W(1,8   ))       
      CALL VXXXXX(P(0,9   ),ZERO ,NHEL(9   ),+1*IC(9   ),W(1,9   ))        
      CALL JIOXXX(W(1,3   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,10  ))    
      CALL FVOXXX(W(1,5   ),W(1,10  ),GWF ,TMASS   ,TWIDTH  ,W(1,11  ))    
      CALL JIOXXX(W(1,7   ),W(1,6   ),GWF ,WMASS   ,WWIDTH  ,W(1,12  ))    
      CALL FVIXXX(W(1,8   ),W(1,12  ),GWF ,TMASS   ,TWIDTH  ,W(1,13  ))    
      CALL FVIXXX(W(1,1   ),W(1,9   ),GG ,ZERO    ,ZERO    ,W(1,14  ))     
      CALL JIOXXX(W(1,14  ),W(1,2   ),GG ,ZERO    ,ZERO    ,W(1,15  ))     
      CALL IOVXXX(W(1,13  ),W(1,11  ),W(1,15  ),GG ,AMP(1   ))             
      CALL FVOXXX(W(1,2   ),W(1,9   ),GG ,ZERO    ,ZERO    ,W(1,16  ))     
      CALL JIOXXX(W(1,1   ),W(1,16  ),GG ,ZERO    ,ZERO    ,W(1,17  ))     
      CALL IOVXXX(W(1,13  ),W(1,11  ),W(1,17  ),GG ,AMP(2   ))             
      CALL JIOXXX(W(1,1   ),W(1,2   ),GG ,ZERO    ,ZERO    ,W(1,18  ))     
      CALL FVOXXX(W(1,11  ),W(1,9   ),GG ,TMASS   ,TWIDTH  ,W(1,19  ))     
      CALL IOVXXX(W(1,13  ),W(1,19  ),W(1,18  ),GG ,AMP(3   ))             
      CALL JVVXXX(W(1,9   ),W(1,18  ),G ,ZERO    ,ZERO    ,W(1,20  ))      
      CALL IOVXXX(W(1,13  ),W(1,11  ),W(1,20  ),GG ,AMP(4   ))             
      CALL FVOXXX(W(1,11  ),W(1,18  ),GG ,TMASS   ,TWIDTH  ,W(1,21  ))     
      CALL IOVXXX(W(1,13  ),W(1,21  ),W(1,9   ),GG ,AMP(5   ))             
      JAMP(   1) = +AMP(   1)
      JAMP(   2) = +AMP(   2)
      JAMP(   3) = +AMP(   3)+AMP(   4)
      JAMP(   4) = -AMP(   4)+AMP(   5)
      MATUUB_TTBG = 0.D0 
      DO I = 1, NCOLOR
          ZTEMP = (0.D0,0.D0)
          DO J = 1, NCOLOR
              ZTEMP = ZTEMP + CF(J,I)*JAMP(J)
          ENDDO
          MATUUB_TTBG =MATUUB_TTBG+ZTEMP*DCONJG(JAMP(I))/DENOM(I)   
      ENDDO
C SF: comment out all instances of amp2, used by multi_channel
c      Do I = 1, NGRAPHS
c          amp2(i)=amp2(i)+amp(i)*dconjg(amp(i))
c      Enddo
c      Do I = 1, NCOLOR
c          Jamp2(i)=Jamp2(i)+Jamp(i)*dconjg(Jamp(i))
c      Enddo
C      CALL GAUGECHECK(JAMP,ZTEMP,EIGEN_VEC,EIGEN_VAL,NCOLOR,NEIGEN) 
      END
c
c
c End of qqbar --> ttbar g
c
c
c
c
c Begin of gg --> ttbar g
c
c
C SF: The following routine is SMATRIX generated by MadEvent, suitably modified
      SUBROUTINE GG_TTBG(P1,ANS)
C  
C Generated by MadGraph II Version 3.90. Updated 08/26/05               
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C AND HELICITIES
C FOR THE POINT IN PHASE SPACE P(0:3,NEXTERNAL)
C  
C FOR PROCESS : g g -> e+ ve b e- ve~ b~ g  
C  
C Crossing   1 is g g -> e+ ve b e- ve~ b~ g  
      IMPLICIT NONE
C  
C CONSTANTS
C  
C SF: replace the following include with the explicit inclusion of
c nexternal.inc, originally included by genps.inc
c      Include "genps.inc"
      integer    nexternal
      parameter (nexternal=  9)
      INTEGER                 NCOMB,     NCROSS         
      PARAMETER (             NCOMB= 512, NCROSS=  1)
      INTEGER    THEL
      PARAMETER (THEL=NCOMB*NCROSS)
C  
C ARGUMENTS 
C  
      REAL*8 P1(0:3,NEXTERNAL),ANS(NCROSS)
C  
C LOCAL VARIABLES 
C  
      INTEGER NHEL(NEXTERNAL,NCOMB),NTRY
      REAL*8 T, P(0:3,NEXTERNAL)
      REAL*8 MATGG_TTBG
      INTEGER IHEL,IDEN(NCROSS),IC(NEXTERNAL,NCROSS)
      INTEGER IPROC,JC(NEXTERNAL), I
      LOGICAL GOODHEL(NCOMB,NCROSS)
      INTEGER NGRAPHS
      REAL*8 hwgt, xtot, xtry, xrej, xr, yfrac(0:ncomb)
      INTEGER idum, ngood, igood(ncomb), jhel, j
      LOGICAL warned
      REAL     xran1
      EXTERNAL xran1
C  
C GLOBAL VARIABLES
C  
C SF: comment out all instances of amp2, used by multi_channel
c      Double Precision amp2(maxamps), jamp2(0:maxamps)
c      common/to_amps/  amp2,       jamp2

      character*79         hel_buff
C SF: comment out all common blocks
c      common/to_helicity/  hel_buff

      integer          isum_hel
      logical                    multi_channel
C SF: comment out all common blocks
c      common/to_matrix/isum_hel, multi_channel
C SF: comment out all instances of mapconfig, used by multi_channel
c      INTEGER MAPCONFIG(0:LMAXCONFIGS), ICONFIG
c      common/to_mconfigs/mapconfig, iconfig
      DATA NTRY,IDUM /0,-1/
      DATA xtry, xrej, ngood /0,0,0/
      DATA warned, isum_hel/.false.,0/
      DATA multi_channel/.true./
      SAVE yfrac, igood, IDUM, jhel
      DATA NGRAPHS /   18/          
C SF: comment out all instances of amp2, used by multi_channel
c      DATA jamp2(0) /   6/          
      DATA GOODHEL/THEL*.FALSE./
      DATA (NHEL(IHEL,   1),IHEL=1,9) /-1,-1,-1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,   2),IHEL=1,9) /-1,-1,-1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,   3),IHEL=1,9) /-1,-1,-1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,   4),IHEL=1,9) /-1,-1,-1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,   5),IHEL=1,9) /-1,-1,-1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,   6),IHEL=1,9) /-1,-1,-1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,   7),IHEL=1,9) /-1,-1,-1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,   8),IHEL=1,9) /-1,-1,-1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,   9),IHEL=1,9) /-1,-1,-1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  10),IHEL=1,9) /-1,-1,-1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  11),IHEL=1,9) /-1,-1,-1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  12),IHEL=1,9) /-1,-1,-1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  13),IHEL=1,9) /-1,-1,-1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  14),IHEL=1,9) /-1,-1,-1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  15),IHEL=1,9) /-1,-1,-1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  16),IHEL=1,9) /-1,-1,-1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  17),IHEL=1,9) /-1,-1,-1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  18),IHEL=1,9) /-1,-1,-1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  19),IHEL=1,9) /-1,-1,-1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  20),IHEL=1,9) /-1,-1,-1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  21),IHEL=1,9) /-1,-1,-1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  22),IHEL=1,9) /-1,-1,-1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  23),IHEL=1,9) /-1,-1,-1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  24),IHEL=1,9) /-1,-1,-1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  25),IHEL=1,9) /-1,-1,-1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  26),IHEL=1,9) /-1,-1,-1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  27),IHEL=1,9) /-1,-1,-1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  28),IHEL=1,9) /-1,-1,-1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  29),IHEL=1,9) /-1,-1,-1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  30),IHEL=1,9) /-1,-1,-1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  31),IHEL=1,9) /-1,-1,-1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  32),IHEL=1,9) /-1,-1,-1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  33),IHEL=1,9) /-1,-1,-1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  34),IHEL=1,9) /-1,-1,-1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  35),IHEL=1,9) /-1,-1,-1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  36),IHEL=1,9) /-1,-1,-1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  37),IHEL=1,9) /-1,-1,-1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  38),IHEL=1,9) /-1,-1,-1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  39),IHEL=1,9) /-1,-1,-1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  40),IHEL=1,9) /-1,-1,-1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  41),IHEL=1,9) /-1,-1,-1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  42),IHEL=1,9) /-1,-1,-1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  43),IHEL=1,9) /-1,-1,-1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  44),IHEL=1,9) /-1,-1,-1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  45),IHEL=1,9) /-1,-1,-1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  46),IHEL=1,9) /-1,-1,-1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  47),IHEL=1,9) /-1,-1,-1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  48),IHEL=1,9) /-1,-1,-1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  49),IHEL=1,9) /-1,-1,-1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  50),IHEL=1,9) /-1,-1,-1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  51),IHEL=1,9) /-1,-1,-1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  52),IHEL=1,9) /-1,-1,-1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  53),IHEL=1,9) /-1,-1,-1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  54),IHEL=1,9) /-1,-1,-1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  55),IHEL=1,9) /-1,-1,-1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  56),IHEL=1,9) /-1,-1,-1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  57),IHEL=1,9) /-1,-1,-1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  58),IHEL=1,9) /-1,-1,-1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  59),IHEL=1,9) /-1,-1,-1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  60),IHEL=1,9) /-1,-1,-1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  61),IHEL=1,9) /-1,-1,-1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  62),IHEL=1,9) /-1,-1,-1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  63),IHEL=1,9) /-1,-1,-1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  64),IHEL=1,9) /-1,-1,-1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  65),IHEL=1,9) /-1,-1, 1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  66),IHEL=1,9) /-1,-1, 1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  67),IHEL=1,9) /-1,-1, 1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  68),IHEL=1,9) /-1,-1, 1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  69),IHEL=1,9) /-1,-1, 1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  70),IHEL=1,9) /-1,-1, 1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  71),IHEL=1,9) /-1,-1, 1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  72),IHEL=1,9) /-1,-1, 1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  73),IHEL=1,9) /-1,-1, 1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  74),IHEL=1,9) /-1,-1, 1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  75),IHEL=1,9) /-1,-1, 1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  76),IHEL=1,9) /-1,-1, 1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  77),IHEL=1,9) /-1,-1, 1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  78),IHEL=1,9) /-1,-1, 1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  79),IHEL=1,9) /-1,-1, 1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  80),IHEL=1,9) /-1,-1, 1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  81),IHEL=1,9) /-1,-1, 1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  82),IHEL=1,9) /-1,-1, 1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  83),IHEL=1,9) /-1,-1, 1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  84),IHEL=1,9) /-1,-1, 1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  85),IHEL=1,9) /-1,-1, 1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  86),IHEL=1,9) /-1,-1, 1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  87),IHEL=1,9) /-1,-1, 1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  88),IHEL=1,9) /-1,-1, 1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  89),IHEL=1,9) /-1,-1, 1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  90),IHEL=1,9) /-1,-1, 1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  91),IHEL=1,9) /-1,-1, 1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  92),IHEL=1,9) /-1,-1, 1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  93),IHEL=1,9) /-1,-1, 1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  94),IHEL=1,9) /-1,-1, 1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  95),IHEL=1,9) /-1,-1, 1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  96),IHEL=1,9) /-1,-1, 1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  97),IHEL=1,9) /-1,-1, 1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  98),IHEL=1,9) /-1,-1, 1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  99),IHEL=1,9) /-1,-1, 1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 100),IHEL=1,9) /-1,-1, 1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 101),IHEL=1,9) /-1,-1, 1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 102),IHEL=1,9) /-1,-1, 1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 103),IHEL=1,9) /-1,-1, 1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 104),IHEL=1,9) /-1,-1, 1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 105),IHEL=1,9) /-1,-1, 1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 106),IHEL=1,9) /-1,-1, 1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 107),IHEL=1,9) /-1,-1, 1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 108),IHEL=1,9) /-1,-1, 1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 109),IHEL=1,9) /-1,-1, 1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 110),IHEL=1,9) /-1,-1, 1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 111),IHEL=1,9) /-1,-1, 1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 112),IHEL=1,9) /-1,-1, 1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 113),IHEL=1,9) /-1,-1, 1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 114),IHEL=1,9) /-1,-1, 1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 115),IHEL=1,9) /-1,-1, 1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 116),IHEL=1,9) /-1,-1, 1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 117),IHEL=1,9) /-1,-1, 1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 118),IHEL=1,9) /-1,-1, 1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 119),IHEL=1,9) /-1,-1, 1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 120),IHEL=1,9) /-1,-1, 1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 121),IHEL=1,9) /-1,-1, 1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 122),IHEL=1,9) /-1,-1, 1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 123),IHEL=1,9) /-1,-1, 1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 124),IHEL=1,9) /-1,-1, 1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 125),IHEL=1,9) /-1,-1, 1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 126),IHEL=1,9) /-1,-1, 1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 127),IHEL=1,9) /-1,-1, 1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 128),IHEL=1,9) /-1,-1, 1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 129),IHEL=1,9) /-1, 1,-1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 130),IHEL=1,9) /-1, 1,-1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 131),IHEL=1,9) /-1, 1,-1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 132),IHEL=1,9) /-1, 1,-1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 133),IHEL=1,9) /-1, 1,-1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 134),IHEL=1,9) /-1, 1,-1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 135),IHEL=1,9) /-1, 1,-1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 136),IHEL=1,9) /-1, 1,-1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 137),IHEL=1,9) /-1, 1,-1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 138),IHEL=1,9) /-1, 1,-1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 139),IHEL=1,9) /-1, 1,-1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 140),IHEL=1,9) /-1, 1,-1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 141),IHEL=1,9) /-1, 1,-1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 142),IHEL=1,9) /-1, 1,-1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 143),IHEL=1,9) /-1, 1,-1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 144),IHEL=1,9) /-1, 1,-1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 145),IHEL=1,9) /-1, 1,-1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 146),IHEL=1,9) /-1, 1,-1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 147),IHEL=1,9) /-1, 1,-1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 148),IHEL=1,9) /-1, 1,-1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 149),IHEL=1,9) /-1, 1,-1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 150),IHEL=1,9) /-1, 1,-1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 151),IHEL=1,9) /-1, 1,-1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 152),IHEL=1,9) /-1, 1,-1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 153),IHEL=1,9) /-1, 1,-1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 154),IHEL=1,9) /-1, 1,-1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 155),IHEL=1,9) /-1, 1,-1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 156),IHEL=1,9) /-1, 1,-1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 157),IHEL=1,9) /-1, 1,-1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 158),IHEL=1,9) /-1, 1,-1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 159),IHEL=1,9) /-1, 1,-1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 160),IHEL=1,9) /-1, 1,-1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 161),IHEL=1,9) /-1, 1,-1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 162),IHEL=1,9) /-1, 1,-1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 163),IHEL=1,9) /-1, 1,-1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 164),IHEL=1,9) /-1, 1,-1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 165),IHEL=1,9) /-1, 1,-1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 166),IHEL=1,9) /-1, 1,-1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 167),IHEL=1,9) /-1, 1,-1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 168),IHEL=1,9) /-1, 1,-1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 169),IHEL=1,9) /-1, 1,-1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 170),IHEL=1,9) /-1, 1,-1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 171),IHEL=1,9) /-1, 1,-1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 172),IHEL=1,9) /-1, 1,-1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 173),IHEL=1,9) /-1, 1,-1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 174),IHEL=1,9) /-1, 1,-1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 175),IHEL=1,9) /-1, 1,-1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 176),IHEL=1,9) /-1, 1,-1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 177),IHEL=1,9) /-1, 1,-1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 178),IHEL=1,9) /-1, 1,-1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 179),IHEL=1,9) /-1, 1,-1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 180),IHEL=1,9) /-1, 1,-1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 181),IHEL=1,9) /-1, 1,-1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 182),IHEL=1,9) /-1, 1,-1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 183),IHEL=1,9) /-1, 1,-1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 184),IHEL=1,9) /-1, 1,-1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 185),IHEL=1,9) /-1, 1,-1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 186),IHEL=1,9) /-1, 1,-1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 187),IHEL=1,9) /-1, 1,-1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 188),IHEL=1,9) /-1, 1,-1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 189),IHEL=1,9) /-1, 1,-1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 190),IHEL=1,9) /-1, 1,-1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 191),IHEL=1,9) /-1, 1,-1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 192),IHEL=1,9) /-1, 1,-1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 193),IHEL=1,9) /-1, 1, 1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 194),IHEL=1,9) /-1, 1, 1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 195),IHEL=1,9) /-1, 1, 1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 196),IHEL=1,9) /-1, 1, 1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 197),IHEL=1,9) /-1, 1, 1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 198),IHEL=1,9) /-1, 1, 1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 199),IHEL=1,9) /-1, 1, 1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 200),IHEL=1,9) /-1, 1, 1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 201),IHEL=1,9) /-1, 1, 1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 202),IHEL=1,9) /-1, 1, 1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 203),IHEL=1,9) /-1, 1, 1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 204),IHEL=1,9) /-1, 1, 1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 205),IHEL=1,9) /-1, 1, 1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 206),IHEL=1,9) /-1, 1, 1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 207),IHEL=1,9) /-1, 1, 1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 208),IHEL=1,9) /-1, 1, 1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 209),IHEL=1,9) /-1, 1, 1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 210),IHEL=1,9) /-1, 1, 1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 211),IHEL=1,9) /-1, 1, 1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 212),IHEL=1,9) /-1, 1, 1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 213),IHEL=1,9) /-1, 1, 1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 214),IHEL=1,9) /-1, 1, 1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 215),IHEL=1,9) /-1, 1, 1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 216),IHEL=1,9) /-1, 1, 1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 217),IHEL=1,9) /-1, 1, 1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 218),IHEL=1,9) /-1, 1, 1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 219),IHEL=1,9) /-1, 1, 1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 220),IHEL=1,9) /-1, 1, 1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 221),IHEL=1,9) /-1, 1, 1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 222),IHEL=1,9) /-1, 1, 1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 223),IHEL=1,9) /-1, 1, 1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 224),IHEL=1,9) /-1, 1, 1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 225),IHEL=1,9) /-1, 1, 1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 226),IHEL=1,9) /-1, 1, 1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 227),IHEL=1,9) /-1, 1, 1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 228),IHEL=1,9) /-1, 1, 1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 229),IHEL=1,9) /-1, 1, 1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 230),IHEL=1,9) /-1, 1, 1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 231),IHEL=1,9) /-1, 1, 1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 232),IHEL=1,9) /-1, 1, 1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 233),IHEL=1,9) /-1, 1, 1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 234),IHEL=1,9) /-1, 1, 1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 235),IHEL=1,9) /-1, 1, 1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 236),IHEL=1,9) /-1, 1, 1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 237),IHEL=1,9) /-1, 1, 1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 238),IHEL=1,9) /-1, 1, 1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 239),IHEL=1,9) /-1, 1, 1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 240),IHEL=1,9) /-1, 1, 1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 241),IHEL=1,9) /-1, 1, 1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 242),IHEL=1,9) /-1, 1, 1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 243),IHEL=1,9) /-1, 1, 1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 244),IHEL=1,9) /-1, 1, 1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 245),IHEL=1,9) /-1, 1, 1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 246),IHEL=1,9) /-1, 1, 1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 247),IHEL=1,9) /-1, 1, 1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 248),IHEL=1,9) /-1, 1, 1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 249),IHEL=1,9) /-1, 1, 1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 250),IHEL=1,9) /-1, 1, 1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 251),IHEL=1,9) /-1, 1, 1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 252),IHEL=1,9) /-1, 1, 1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 253),IHEL=1,9) /-1, 1, 1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 254),IHEL=1,9) /-1, 1, 1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 255),IHEL=1,9) /-1, 1, 1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 256),IHEL=1,9) /-1, 1, 1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 257),IHEL=1,9) / 1,-1,-1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 258),IHEL=1,9) / 1,-1,-1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 259),IHEL=1,9) / 1,-1,-1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 260),IHEL=1,9) / 1,-1,-1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 261),IHEL=1,9) / 1,-1,-1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 262),IHEL=1,9) / 1,-1,-1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 263),IHEL=1,9) / 1,-1,-1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 264),IHEL=1,9) / 1,-1,-1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 265),IHEL=1,9) / 1,-1,-1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 266),IHEL=1,9) / 1,-1,-1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 267),IHEL=1,9) / 1,-1,-1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 268),IHEL=1,9) / 1,-1,-1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 269),IHEL=1,9) / 1,-1,-1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 270),IHEL=1,9) / 1,-1,-1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 271),IHEL=1,9) / 1,-1,-1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 272),IHEL=1,9) / 1,-1,-1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 273),IHEL=1,9) / 1,-1,-1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 274),IHEL=1,9) / 1,-1,-1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 275),IHEL=1,9) / 1,-1,-1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 276),IHEL=1,9) / 1,-1,-1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 277),IHEL=1,9) / 1,-1,-1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 278),IHEL=1,9) / 1,-1,-1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 279),IHEL=1,9) / 1,-1,-1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 280),IHEL=1,9) / 1,-1,-1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 281),IHEL=1,9) / 1,-1,-1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 282),IHEL=1,9) / 1,-1,-1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 283),IHEL=1,9) / 1,-1,-1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 284),IHEL=1,9) / 1,-1,-1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 285),IHEL=1,9) / 1,-1,-1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 286),IHEL=1,9) / 1,-1,-1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 287),IHEL=1,9) / 1,-1,-1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 288),IHEL=1,9) / 1,-1,-1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 289),IHEL=1,9) / 1,-1,-1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 290),IHEL=1,9) / 1,-1,-1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 291),IHEL=1,9) / 1,-1,-1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 292),IHEL=1,9) / 1,-1,-1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 293),IHEL=1,9) / 1,-1,-1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 294),IHEL=1,9) / 1,-1,-1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 295),IHEL=1,9) / 1,-1,-1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 296),IHEL=1,9) / 1,-1,-1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 297),IHEL=1,9) / 1,-1,-1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 298),IHEL=1,9) / 1,-1,-1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 299),IHEL=1,9) / 1,-1,-1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 300),IHEL=1,9) / 1,-1,-1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 301),IHEL=1,9) / 1,-1,-1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 302),IHEL=1,9) / 1,-1,-1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 303),IHEL=1,9) / 1,-1,-1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 304),IHEL=1,9) / 1,-1,-1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 305),IHEL=1,9) / 1,-1,-1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 306),IHEL=1,9) / 1,-1,-1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 307),IHEL=1,9) / 1,-1,-1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 308),IHEL=1,9) / 1,-1,-1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 309),IHEL=1,9) / 1,-1,-1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 310),IHEL=1,9) / 1,-1,-1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 311),IHEL=1,9) / 1,-1,-1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 312),IHEL=1,9) / 1,-1,-1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 313),IHEL=1,9) / 1,-1,-1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 314),IHEL=1,9) / 1,-1,-1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 315),IHEL=1,9) / 1,-1,-1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 316),IHEL=1,9) / 1,-1,-1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 317),IHEL=1,9) / 1,-1,-1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 318),IHEL=1,9) / 1,-1,-1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 319),IHEL=1,9) / 1,-1,-1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 320),IHEL=1,9) / 1,-1,-1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 321),IHEL=1,9) / 1,-1, 1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 322),IHEL=1,9) / 1,-1, 1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 323),IHEL=1,9) / 1,-1, 1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 324),IHEL=1,9) / 1,-1, 1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 325),IHEL=1,9) / 1,-1, 1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 326),IHEL=1,9) / 1,-1, 1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 327),IHEL=1,9) / 1,-1, 1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 328),IHEL=1,9) / 1,-1, 1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 329),IHEL=1,9) / 1,-1, 1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 330),IHEL=1,9) / 1,-1, 1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 331),IHEL=1,9) / 1,-1, 1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 332),IHEL=1,9) / 1,-1, 1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 333),IHEL=1,9) / 1,-1, 1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 334),IHEL=1,9) / 1,-1, 1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 335),IHEL=1,9) / 1,-1, 1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 336),IHEL=1,9) / 1,-1, 1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 337),IHEL=1,9) / 1,-1, 1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 338),IHEL=1,9) / 1,-1, 1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 339),IHEL=1,9) / 1,-1, 1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 340),IHEL=1,9) / 1,-1, 1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 341),IHEL=1,9) / 1,-1, 1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 342),IHEL=1,9) / 1,-1, 1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 343),IHEL=1,9) / 1,-1, 1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 344),IHEL=1,9) / 1,-1, 1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 345),IHEL=1,9) / 1,-1, 1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 346),IHEL=1,9) / 1,-1, 1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 347),IHEL=1,9) / 1,-1, 1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 348),IHEL=1,9) / 1,-1, 1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 349),IHEL=1,9) / 1,-1, 1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 350),IHEL=1,9) / 1,-1, 1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 351),IHEL=1,9) / 1,-1, 1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 352),IHEL=1,9) / 1,-1, 1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 353),IHEL=1,9) / 1,-1, 1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 354),IHEL=1,9) / 1,-1, 1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 355),IHEL=1,9) / 1,-1, 1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 356),IHEL=1,9) / 1,-1, 1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 357),IHEL=1,9) / 1,-1, 1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 358),IHEL=1,9) / 1,-1, 1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 359),IHEL=1,9) / 1,-1, 1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 360),IHEL=1,9) / 1,-1, 1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 361),IHEL=1,9) / 1,-1, 1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 362),IHEL=1,9) / 1,-1, 1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 363),IHEL=1,9) / 1,-1, 1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 364),IHEL=1,9) / 1,-1, 1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 365),IHEL=1,9) / 1,-1, 1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 366),IHEL=1,9) / 1,-1, 1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 367),IHEL=1,9) / 1,-1, 1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 368),IHEL=1,9) / 1,-1, 1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 369),IHEL=1,9) / 1,-1, 1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 370),IHEL=1,9) / 1,-1, 1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 371),IHEL=1,9) / 1,-1, 1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 372),IHEL=1,9) / 1,-1, 1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 373),IHEL=1,9) / 1,-1, 1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 374),IHEL=1,9) / 1,-1, 1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 375),IHEL=1,9) / 1,-1, 1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 376),IHEL=1,9) / 1,-1, 1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 377),IHEL=1,9) / 1,-1, 1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 378),IHEL=1,9) / 1,-1, 1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 379),IHEL=1,9) / 1,-1, 1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 380),IHEL=1,9) / 1,-1, 1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 381),IHEL=1,9) / 1,-1, 1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 382),IHEL=1,9) / 1,-1, 1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 383),IHEL=1,9) / 1,-1, 1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 384),IHEL=1,9) / 1,-1, 1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 385),IHEL=1,9) / 1, 1,-1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 386),IHEL=1,9) / 1, 1,-1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 387),IHEL=1,9) / 1, 1,-1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 388),IHEL=1,9) / 1, 1,-1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 389),IHEL=1,9) / 1, 1,-1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 390),IHEL=1,9) / 1, 1,-1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 391),IHEL=1,9) / 1, 1,-1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 392),IHEL=1,9) / 1, 1,-1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 393),IHEL=1,9) / 1, 1,-1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 394),IHEL=1,9) / 1, 1,-1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 395),IHEL=1,9) / 1, 1,-1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 396),IHEL=1,9) / 1, 1,-1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 397),IHEL=1,9) / 1, 1,-1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 398),IHEL=1,9) / 1, 1,-1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 399),IHEL=1,9) / 1, 1,-1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 400),IHEL=1,9) / 1, 1,-1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 401),IHEL=1,9) / 1, 1,-1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 402),IHEL=1,9) / 1, 1,-1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 403),IHEL=1,9) / 1, 1,-1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 404),IHEL=1,9) / 1, 1,-1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 405),IHEL=1,9) / 1, 1,-1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 406),IHEL=1,9) / 1, 1,-1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 407),IHEL=1,9) / 1, 1,-1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 408),IHEL=1,9) / 1, 1,-1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 409),IHEL=1,9) / 1, 1,-1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 410),IHEL=1,9) / 1, 1,-1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 411),IHEL=1,9) / 1, 1,-1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 412),IHEL=1,9) / 1, 1,-1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 413),IHEL=1,9) / 1, 1,-1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 414),IHEL=1,9) / 1, 1,-1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 415),IHEL=1,9) / 1, 1,-1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 416),IHEL=1,9) / 1, 1,-1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 417),IHEL=1,9) / 1, 1,-1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 418),IHEL=1,9) / 1, 1,-1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 419),IHEL=1,9) / 1, 1,-1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 420),IHEL=1,9) / 1, 1,-1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 421),IHEL=1,9) / 1, 1,-1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 422),IHEL=1,9) / 1, 1,-1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 423),IHEL=1,9) / 1, 1,-1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 424),IHEL=1,9) / 1, 1,-1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 425),IHEL=1,9) / 1, 1,-1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 426),IHEL=1,9) / 1, 1,-1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 427),IHEL=1,9) / 1, 1,-1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 428),IHEL=1,9) / 1, 1,-1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 429),IHEL=1,9) / 1, 1,-1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 430),IHEL=1,9) / 1, 1,-1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 431),IHEL=1,9) / 1, 1,-1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 432),IHEL=1,9) / 1, 1,-1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 433),IHEL=1,9) / 1, 1,-1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 434),IHEL=1,9) / 1, 1,-1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 435),IHEL=1,9) / 1, 1,-1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 436),IHEL=1,9) / 1, 1,-1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 437),IHEL=1,9) / 1, 1,-1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 438),IHEL=1,9) / 1, 1,-1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 439),IHEL=1,9) / 1, 1,-1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 440),IHEL=1,9) / 1, 1,-1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 441),IHEL=1,9) / 1, 1,-1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 442),IHEL=1,9) / 1, 1,-1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 443),IHEL=1,9) / 1, 1,-1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 444),IHEL=1,9) / 1, 1,-1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 445),IHEL=1,9) / 1, 1,-1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 446),IHEL=1,9) / 1, 1,-1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 447),IHEL=1,9) / 1, 1,-1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 448),IHEL=1,9) / 1, 1,-1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 449),IHEL=1,9) / 1, 1, 1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 450),IHEL=1,9) / 1, 1, 1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 451),IHEL=1,9) / 1, 1, 1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 452),IHEL=1,9) / 1, 1, 1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 453),IHEL=1,9) / 1, 1, 1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 454),IHEL=1,9) / 1, 1, 1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 455),IHEL=1,9) / 1, 1, 1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 456),IHEL=1,9) / 1, 1, 1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 457),IHEL=1,9) / 1, 1, 1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 458),IHEL=1,9) / 1, 1, 1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 459),IHEL=1,9) / 1, 1, 1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 460),IHEL=1,9) / 1, 1, 1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 461),IHEL=1,9) / 1, 1, 1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 462),IHEL=1,9) / 1, 1, 1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 463),IHEL=1,9) / 1, 1, 1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 464),IHEL=1,9) / 1, 1, 1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 465),IHEL=1,9) / 1, 1, 1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 466),IHEL=1,9) / 1, 1, 1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 467),IHEL=1,9) / 1, 1, 1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 468),IHEL=1,9) / 1, 1, 1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 469),IHEL=1,9) / 1, 1, 1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 470),IHEL=1,9) / 1, 1, 1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 471),IHEL=1,9) / 1, 1, 1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 472),IHEL=1,9) / 1, 1, 1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 473),IHEL=1,9) / 1, 1, 1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 474),IHEL=1,9) / 1, 1, 1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 475),IHEL=1,9) / 1, 1, 1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 476),IHEL=1,9) / 1, 1, 1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 477),IHEL=1,9) / 1, 1, 1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 478),IHEL=1,9) / 1, 1, 1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 479),IHEL=1,9) / 1, 1, 1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 480),IHEL=1,9) / 1, 1, 1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 481),IHEL=1,9) / 1, 1, 1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 482),IHEL=1,9) / 1, 1, 1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 483),IHEL=1,9) / 1, 1, 1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 484),IHEL=1,9) / 1, 1, 1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 485),IHEL=1,9) / 1, 1, 1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 486),IHEL=1,9) / 1, 1, 1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 487),IHEL=1,9) / 1, 1, 1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 488),IHEL=1,9) / 1, 1, 1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 489),IHEL=1,9) / 1, 1, 1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 490),IHEL=1,9) / 1, 1, 1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 491),IHEL=1,9) / 1, 1, 1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 492),IHEL=1,9) / 1, 1, 1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 493),IHEL=1,9) / 1, 1, 1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 494),IHEL=1,9) / 1, 1, 1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 495),IHEL=1,9) / 1, 1, 1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 496),IHEL=1,9) / 1, 1, 1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 497),IHEL=1,9) / 1, 1, 1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 498),IHEL=1,9) / 1, 1, 1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 499),IHEL=1,9) / 1, 1, 1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 500),IHEL=1,9) / 1, 1, 1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 501),IHEL=1,9) / 1, 1, 1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 502),IHEL=1,9) / 1, 1, 1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 503),IHEL=1,9) / 1, 1, 1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 504),IHEL=1,9) / 1, 1, 1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 505),IHEL=1,9) / 1, 1, 1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 506),IHEL=1,9) / 1, 1, 1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 507),IHEL=1,9) / 1, 1, 1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 508),IHEL=1,9) / 1, 1, 1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 509),IHEL=1,9) / 1, 1, 1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 510),IHEL=1,9) / 1, 1, 1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 511),IHEL=1,9) / 1, 1, 1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 512),IHEL=1,9) / 1, 1, 1, 1, 1, 1, 1, 1, 1/
      DATA (  IC(IHEL,  1),IHEL=1,9) / 1, 2, 3, 4, 5, 6, 7, 8, 9/
      DATA (IDEN(IHEL),IHEL=  1,  1) / 256/
C ----------
C BEGIN CODE
C ----------
      NTRY=NTRY+1
      DO IPROC=1,NCROSS
      CALL SWITCHMOM(P1,P,IC(1,IPROC),JC,NEXTERNAL)
      DO IHEL=1,NEXTERNAL
         JC(IHEL) = +1
      ENDDO
       
C SF: comment out all instances of multi_channel
c      IF (multi_channel) THEN
c          DO IHEL=1,NGRAPHS
c              amp2(ihel)=0d0
c              jamp2(ihel)=0d0
c          ENDDO
c          DO IHEL=1,int(jamp2(0))
c              jamp2(ihel)=0d0
c          ENDDO
c      ENDIF
      ANS(IPROC) = 0D0
      write(hel_buff,'(16i5)') (0,i=1,nexternal)
      IF (ISUM_HEL .EQ. 0 .OR. NTRY .LT. 10) THEN
          DO IHEL=1,NCOMB
              IF (GOODHEL(IHEL,IPROC) .OR. NTRY .LT. 2) THEN
                 T=MATGG_TTBG(P ,NHEL(1,IHEL),JC(1))            
                 ANS(IPROC)=ANS(IPROC)+T
                  IF (T .GT. 0D0 .AND. .NOT. GOODHEL(IHEL,IPROC)) THEN
                      GOODHEL(IHEL,IPROC)=.TRUE.
                      NGOOD = NGOOD +1
                      IGOOD(NGOOD) = IHEL
C                WRITE(*,*) ngood,IHEL,T
                  ENDIF
              ENDIF
          ENDDO
          JHEL = 1
          ISUM_HEL=MIN(ISUM_HEL,NGOOD)
      ELSE              !RANDOM HELICITY
          DO J=1,ISUM_HEL
              JHEL=JHEL+1
              IF (JHEL .GT. NGOOD) JHEL=1
              HWGT = REAL(NGOOD)/REAL(ISUM_HEL)
              IHEL = IGOOD(JHEL)
              T=MATGG_TTBG(P ,NHEL(1,IHEL),JC(1))            
           ANS(IPROC)=ANS(IPROC)+T*HWGT
          ENDDO
          IF (ISUM_HEL .EQ. 1) THEN
              WRITE(HEL_BUFF,'(16i5)')(NHEL(i,IHEL),i=1,nexternal)
          ENDIF
      ENDIF
C SF: comment out all instances of multi_channel
c      IF (MULTI_CHANNEL) THEN
c          XTOT=0D0
c          DO IHEL=1,MAPCONFIG(0)
c              XTOT=XTOT+AMP2(MAPCONFIG(IHEL))
c          ENDDO
c          ANS(IPROC)=ANS(IPROC)*AMP2(MAPCONFIG(ICONFIG))/XTOT
c      ENDIF
      ANS(IPROC)=ANS(IPROC)/DBLE(IDEN(IPROC))
      ENDDO
      END
       
       
C SF: the original name MATRIX has been replaced by MATGG_TTBG
      REAL*8 FUNCTION MATGG_TTBG(P,NHEL,IC)
C  
C Generated by MadGraph II Version 3.90. Updated 08/26/05               
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : g g -> e+ ve b e- ve~ b~ g  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS,    NEIGEN 
      PARAMETER (NGRAPHS=  18,NEIGEN=  6) 
C SF: replace the following include with the explicit inclusion of
c nexternal.inc, originally included by genps.inc
c      include "genps.inc"
      integer    nexternal
      parameter (nexternal=  9)
      INTEGER    NWAVEFUNCS     , NCOLOR
      PARAMETER (NWAVEFUNCS=  36, NCOLOR=   6) 
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      REAL*8 P(0:3,NEXTERNAL)
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J
      COMPLEX*16 ZTEMP
      REAL*8 DENOM(NCOLOR), CF(NCOLOR,NCOLOR)
      COMPLEX*16 AMP(NGRAPHS), JAMP(NCOLOR)
      COMPLEX*16 W(6,NWAVEFUNCS)
C  
C GLOBAL VARIABLES
C  
C SF: comment out all instances of amp2, used by multi_channel
c      Double Precision amp2(maxamps), jamp2(0:maxamps)
c      common/to_amps/  amp2,       jamp2
C SF: The original coupl.inc has been renamed MEcoupl.inc
      include "MEcoupl.inc"
C  
C COLOR DATA
C  
      DATA Denom(1  )/            9/                                       
      DATA (CF(i,1  ),i=1  ,6  ) /    64,   -8,    1,    1,   10,   -8/    
C               T[8,5,9,1,2]                                               
      DATA Denom(2  )/            9/                                       
      DATA (CF(i,2  ),i=1  ,6  ) /    -8,   64,   -8,   10,    1,    1/    
C               T[8,5,1,9,2]                                               
      DATA Denom(3  )/            9/                                       
      DATA (CF(i,3  ),i=1  ,6  ) /     1,   -8,   64,    1,   -8,   10/    
C               T[8,5,1,2,9]                                               
      DATA Denom(4  )/            9/                                       
      DATA (CF(i,4  ),i=1  ,6  ) /     1,   10,    1,   64,   -8,   -8/    
C               T[8,5,2,9,1]                                               
      DATA Denom(5  )/            9/                                       
      DATA (CF(i,5  ),i=1  ,6  ) /    10,    1,   -8,   -8,   64,    1/    
C               T[8,5,2,1,9]                                               
      DATA Denom(6  )/            9/                                       
      DATA (CF(i,6  ),i=1  ,6  ) /    -8,    1,   10,   -8,    1,   64/    
C               T[8,5,9,2,1]                                               
C ----------
C BEGIN CODE
C ----------
      CALL VXXXXX(P(0,1   ),ZERO ,NHEL(1   ),-1*IC(1   ),W(1,1   ))        
      CALL VXXXXX(P(0,2   ),ZERO ,NHEL(2   ),-1*IC(2   ),W(1,2   ))        
      CALL IXXXXX(P(0,3   ),ZERO ,NHEL(3   ),-1*IC(3   ),W(1,3   ))        
      CALL OXXXXX(P(0,4   ),ZERO ,NHEL(4   ),+1*IC(4   ),W(1,4   ))        
      CALL OXXXXX(P(0,5   ),BMASS ,NHEL(5   ),+1*IC(5   ),W(1,5   ))       
      CALL OXXXXX(P(0,6   ),ZERO ,NHEL(6   ),+1*IC(6   ),W(1,6   ))        
      CALL IXXXXX(P(0,7   ),ZERO ,NHEL(7   ),-1*IC(7   ),W(1,7   ))        
      CALL IXXXXX(P(0,8   ),BMASS ,NHEL(8   ),-1*IC(8   ),W(1,8   ))       
      CALL VXXXXX(P(0,9   ),ZERO ,NHEL(9   ),+1*IC(9   ),W(1,9   ))        
      CALL JIOXXX(W(1,3   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,10  ))    
      CALL FVOXXX(W(1,5   ),W(1,10  ),GWF ,TMASS   ,TWIDTH  ,W(1,11  ))    
      CALL JIOXXX(W(1,7   ),W(1,6   ),GWF ,WMASS   ,WWIDTH  ,W(1,12  ))    
      CALL FVIXXX(W(1,8   ),W(1,12  ),GWF ,TMASS   ,TWIDTH  ,W(1,13  ))    
      CALL JVVXXX(W(1,9   ),W(1,1   ),G ,ZERO    ,ZERO    ,W(1,14  ))      
      CALL FVOXXX(W(1,11  ),W(1,2   ),GG ,TMASS   ,TWIDTH  ,W(1,15  ))     
      CALL IOVXXX(W(1,13  ),W(1,15  ),W(1,14  ),GG ,AMP(1   ))             
      CALL JVVXXX(W(1,9   ),W(1,2   ),G ,ZERO    ,ZERO    ,W(1,16  ))      
      CALL FVOXXX(W(1,11  ),W(1,16  ),GG ,TMASS   ,TWIDTH  ,W(1,17  ))     
      CALL IOVXXX(W(1,13  ),W(1,17  ),W(1,1   ),GG ,AMP(2   ))             
      CALL FVOXXX(W(1,11  ),W(1,9   ),GG ,TMASS   ,TWIDTH  ,W(1,18  ))     
      CALL FVOXXX(W(1,18  ),W(1,2   ),GG ,TMASS   ,TWIDTH  ,W(1,19  ))     
      CALL IOVXXX(W(1,13  ),W(1,19  ),W(1,1   ),GG ,AMP(3   ))             
      CALL FVIXXX(W(1,13  ),W(1,1   ),GG ,TMASS   ,TWIDTH  ,W(1,20  ))     
      CALL IOVXXX(W(1,20  ),W(1,15  ),W(1,9   ),GG ,AMP(4   ))             
      CALL FVIXXX(W(1,13  ),W(1,9   ),GG ,TMASS   ,TWIDTH  ,W(1,21  ))     
      CALL IOVXXX(W(1,21  ),W(1,15  ),W(1,1   ),GG ,AMP(5   ))             
      CALL FVOXXX(W(1,11  ),W(1,14  ),GG ,TMASS   ,TWIDTH  ,W(1,22  ))     
      CALL IOVXXX(W(1,13  ),W(1,22  ),W(1,2   ),GG ,AMP(6   ))             
      CALL FVOXXX(W(1,11  ),W(1,1   ),GG ,TMASS   ,TWIDTH  ,W(1,23  ))     
      CALL IOVXXX(W(1,13  ),W(1,23  ),W(1,16  ),GG ,AMP(7   ))             
      CALL FVOXXX(W(1,18  ),W(1,1   ),GG ,TMASS   ,TWIDTH  ,W(1,24  ))     
      CALL IOVXXX(W(1,13  ),W(1,24  ),W(1,2   ),GG ,AMP(8   ))             
      CALL FVIXXX(W(1,13  ),W(1,2   ),GG ,TMASS   ,TWIDTH  ,W(1,25  ))     
      CALL IOVXXX(W(1,25  ),W(1,23  ),W(1,9   ),GG ,AMP(9   ))             
      CALL IOVXXX(W(1,21  ),W(1,23  ),W(1,2   ),GG ,AMP(10  ))             
      CALL JVVXXX(W(1,14  ),W(1,2   ),G ,ZERO    ,ZERO    ,W(1,26  ))      
      CALL IOVXXX(W(1,13  ),W(1,11  ),W(1,26  ),GG ,AMP(11  ))             
      CALL JVVXXX(W(1,1   ),W(1,16  ),G ,ZERO    ,ZERO    ,W(1,27  ))      
      CALL IOVXXX(W(1,13  ),W(1,11  ),W(1,27  ),GG ,AMP(12  ))             
      CALL JVVXXX(W(1,1   ),W(1,2   ),G ,ZERO    ,ZERO    ,W(1,28  ))      
      CALL IOVXXX(W(1,13  ),W(1,18  ),W(1,28  ),GG ,AMP(13  ))             
      CALL JVVXXX(W(1,9   ),W(1,28  ),G ,ZERO    ,ZERO    ,W(1,29  ))      
      CALL IOVXXX(W(1,13  ),W(1,11  ),W(1,29  ),GG ,AMP(14  ))             
      CALL FVOXXX(W(1,11  ),W(1,28  ),GG ,TMASS   ,TWIDTH  ,W(1,30  ))     
      CALL IOVXXX(W(1,13  ),W(1,30  ),W(1,9   ),GG ,AMP(15  ))             
      CALL JGGGXX(W(1,1   ),W(1,2   ),W(1,9   ),G ,W(1,31  ))              
      CALL FVOXXX(W(1,11  ),W(1,31  ),GG ,TMASS   ,TWIDTH  ,W(1,32  ))     
      CALL IOVXXX(W(1,8   ),W(1,32  ),W(1,12  ),GWF ,AMP(16  ))            
      CALL JGGGXX(W(1,9   ),W(1,1   ),W(1,2   ),G ,W(1,33  ))              
      CALL FVOXXX(W(1,11  ),W(1,33  ),GG ,TMASS   ,TWIDTH  ,W(1,34  ))     
      CALL IOVXXX(W(1,8   ),W(1,34  ),W(1,12  ),GWF ,AMP(17  ))            
      CALL JGGGXX(W(1,2   ),W(1,9   ),W(1,1   ),G ,W(1,35  ))              
      CALL FVOXXX(W(1,11  ),W(1,35  ),GG ,TMASS   ,TWIDTH  ,W(1,36  ))     
      CALL IOVXXX(W(1,8   ),W(1,36  ),W(1,12  ),GWF ,AMP(18  ))            
      JAMP(   1) = -AMP(   1)+AMP(   5)+AMP(  11)+AMP(  14)-AMP(  15)
     &             +AMP(  16)-AMP(  17)
      JAMP(   2) = +AMP(   1)-AMP(   2)+AMP(   4)-AMP(  11)+AMP(  12)
     &             +AMP(  17)-AMP(  18)
      JAMP(   3) = +AMP(   2)+AMP(   3)-AMP(  12)-AMP(  13)-AMP(  14)
     &             -AMP(  16)+AMP(  18)
      JAMP(   4) = -AMP(   6)+AMP(   7)+AMP(   9)-AMP(  11)+AMP(  12)
     &             +AMP(  17)-AMP(  18)
      JAMP(   5) = +AMP(   6)+AMP(   8)+AMP(  11)+AMP(  13)+AMP(  14)
     &             +AMP(  16)-AMP(  17)
      JAMP(   6) = -AMP(   7)+AMP(  10)-AMP(  12)-AMP(  14)+AMP(  15)
     &             -AMP(  16)+AMP(  18)
      MATGG_TTBG = 0.D0 
      DO I = 1, NCOLOR
          ZTEMP = (0.D0,0.D0)
          DO J = 1, NCOLOR
              ZTEMP = ZTEMP + CF(J,I)*JAMP(J)
          ENDDO
          MATGG_TTBG =MATGG_TTBG+ZTEMP*DCONJG(JAMP(I))/DENOM(I)   
      ENDDO
C SF: comment out all instances of amp2, used by multi_channel
c      Do I = 1, NGRAPHS
c          amp2(i)=amp2(i)+amp(i)*dconjg(amp(i))
c      Enddo
c      Do I = 1, NCOLOR
c          Jamp2(i)=Jamp2(i)+Jamp(i)*dconjg(Jamp(i))
c      Enddo
C      CALL GAUGECHECK(JAMP,ZTEMP,EIGEN_VEC,EIGEN_VAL,NCOLOR,NEIGEN) 
      END
c
c
c End of gg --> ttbar g
c
c
c
c
c Begin of qg --> ttbar q
c
c
C SF: The following routine is SMATRIX generated by MadEvent, suitably modified
      SUBROUTINE UG_TTBU(P1,ANS)
C  
C Generated by MadGraph II Version 3.90. Updated 08/26/05               
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C AND HELICITIES
C FOR THE POINT IN PHASE SPACE P(0:3,NEXTERNAL)
C  
C FOR PROCESS : u g -> e+ ve b e- ve~ b~ u  
C  
C Crossing   1 is u g -> e+ ve b e- ve~ b~ u  
      IMPLICIT NONE
C  
C CONSTANTS
C  
C SF: replace the following include with the explicit inclusion of
c nexternal.inc, originally included by genps.inc
c      Include "genps.inc"
      integer    nexternal
      parameter (nexternal=  9)
      INTEGER                 NCOMB,     NCROSS         
      PARAMETER (             NCOMB= 512, NCROSS=  1)
      INTEGER    THEL
      PARAMETER (THEL=NCOMB*NCROSS)
C  
C ARGUMENTS 
C  
      REAL*8 P1(0:3,NEXTERNAL),ANS(NCROSS)
C  
C LOCAL VARIABLES 
C  
      INTEGER NHEL(NEXTERNAL,NCOMB),NTRY
      REAL*8 T, P(0:3,NEXTERNAL)
      REAL*8 MATUG_TTBU
      INTEGER IHEL,IDEN(NCROSS),IC(NEXTERNAL,NCROSS)
      INTEGER IPROC,JC(NEXTERNAL), I
      LOGICAL GOODHEL(NCOMB,NCROSS)
      INTEGER NGRAPHS
      REAL*8 hwgt, xtot, xtry, xrej, xr, yfrac(0:ncomb)
      INTEGER idum, ngood, igood(ncomb), jhel, j
      LOGICAL warned
      REAL     xran1
      EXTERNAL xran1
C  
C GLOBAL VARIABLES
C  
C SF: comment out all instances of amp2, used by multi_channel
c      Double Precision amp2(maxamps), jamp2(0:maxamps)
c      common/to_amps/  amp2,       jamp2

      character*79         hel_buff
C SF: comment out all common blocks
c      common/to_helicity/  hel_buff

      integer          isum_hel
      logical                    multi_channel
C SF: comment out all common blocks
c      common/to_matrix/isum_hel, multi_channel
C SF: comment out all instances of mapconfig, used by multi_channel
c      INTEGER MAPCONFIG(0:LMAXCONFIGS), ICONFIG
c      common/to_mconfigs/mapconfig, iconfig
      DATA NTRY,IDUM /0,-1/
      DATA xtry, xrej, ngood /0,0,0/
      DATA warned, isum_hel/.false.,0/
      DATA multi_channel/.true./
      SAVE yfrac, igood, IDUM, jhel
      DATA NGRAPHS /    5/          
C SF: comment out all instances of amp2, used by multi_channel
c      DATA jamp2(0) /   4/          
      DATA GOODHEL/THEL*.FALSE./
      DATA (NHEL(IHEL,   1),IHEL=1,9) /-1,-1,-1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,   2),IHEL=1,9) /-1,-1,-1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,   3),IHEL=1,9) /-1,-1,-1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,   4),IHEL=1,9) /-1,-1,-1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,   5),IHEL=1,9) /-1,-1,-1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,   6),IHEL=1,9) /-1,-1,-1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,   7),IHEL=1,9) /-1,-1,-1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,   8),IHEL=1,9) /-1,-1,-1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,   9),IHEL=1,9) /-1,-1,-1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  10),IHEL=1,9) /-1,-1,-1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  11),IHEL=1,9) /-1,-1,-1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  12),IHEL=1,9) /-1,-1,-1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  13),IHEL=1,9) /-1,-1,-1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  14),IHEL=1,9) /-1,-1,-1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  15),IHEL=1,9) /-1,-1,-1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  16),IHEL=1,9) /-1,-1,-1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  17),IHEL=1,9) /-1,-1,-1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  18),IHEL=1,9) /-1,-1,-1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  19),IHEL=1,9) /-1,-1,-1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  20),IHEL=1,9) /-1,-1,-1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  21),IHEL=1,9) /-1,-1,-1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  22),IHEL=1,9) /-1,-1,-1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  23),IHEL=1,9) /-1,-1,-1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  24),IHEL=1,9) /-1,-1,-1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  25),IHEL=1,9) /-1,-1,-1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  26),IHEL=1,9) /-1,-1,-1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  27),IHEL=1,9) /-1,-1,-1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  28),IHEL=1,9) /-1,-1,-1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  29),IHEL=1,9) /-1,-1,-1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  30),IHEL=1,9) /-1,-1,-1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  31),IHEL=1,9) /-1,-1,-1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  32),IHEL=1,9) /-1,-1,-1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  33),IHEL=1,9) /-1,-1,-1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  34),IHEL=1,9) /-1,-1,-1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  35),IHEL=1,9) /-1,-1,-1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  36),IHEL=1,9) /-1,-1,-1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  37),IHEL=1,9) /-1,-1,-1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  38),IHEL=1,9) /-1,-1,-1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  39),IHEL=1,9) /-1,-1,-1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  40),IHEL=1,9) /-1,-1,-1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  41),IHEL=1,9) /-1,-1,-1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  42),IHEL=1,9) /-1,-1,-1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  43),IHEL=1,9) /-1,-1,-1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  44),IHEL=1,9) /-1,-1,-1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  45),IHEL=1,9) /-1,-1,-1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  46),IHEL=1,9) /-1,-1,-1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  47),IHEL=1,9) /-1,-1,-1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  48),IHEL=1,9) /-1,-1,-1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  49),IHEL=1,9) /-1,-1,-1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  50),IHEL=1,9) /-1,-1,-1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  51),IHEL=1,9) /-1,-1,-1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  52),IHEL=1,9) /-1,-1,-1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  53),IHEL=1,9) /-1,-1,-1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  54),IHEL=1,9) /-1,-1,-1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  55),IHEL=1,9) /-1,-1,-1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  56),IHEL=1,9) /-1,-1,-1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  57),IHEL=1,9) /-1,-1,-1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  58),IHEL=1,9) /-1,-1,-1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  59),IHEL=1,9) /-1,-1,-1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  60),IHEL=1,9) /-1,-1,-1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  61),IHEL=1,9) /-1,-1,-1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  62),IHEL=1,9) /-1,-1,-1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  63),IHEL=1,9) /-1,-1,-1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  64),IHEL=1,9) /-1,-1,-1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  65),IHEL=1,9) /-1,-1, 1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  66),IHEL=1,9) /-1,-1, 1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  67),IHEL=1,9) /-1,-1, 1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  68),IHEL=1,9) /-1,-1, 1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  69),IHEL=1,9) /-1,-1, 1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  70),IHEL=1,9) /-1,-1, 1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  71),IHEL=1,9) /-1,-1, 1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  72),IHEL=1,9) /-1,-1, 1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  73),IHEL=1,9) /-1,-1, 1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  74),IHEL=1,9) /-1,-1, 1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  75),IHEL=1,9) /-1,-1, 1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  76),IHEL=1,9) /-1,-1, 1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  77),IHEL=1,9) /-1,-1, 1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  78),IHEL=1,9) /-1,-1, 1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  79),IHEL=1,9) /-1,-1, 1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  80),IHEL=1,9) /-1,-1, 1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  81),IHEL=1,9) /-1,-1, 1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  82),IHEL=1,9) /-1,-1, 1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  83),IHEL=1,9) /-1,-1, 1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,  84),IHEL=1,9) /-1,-1, 1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  85),IHEL=1,9) /-1,-1, 1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,  86),IHEL=1,9) /-1,-1, 1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,  87),IHEL=1,9) /-1,-1, 1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  88),IHEL=1,9) /-1,-1, 1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,  89),IHEL=1,9) /-1,-1, 1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,  90),IHEL=1,9) /-1,-1, 1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,  91),IHEL=1,9) /-1,-1, 1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL,  92),IHEL=1,9) /-1,-1, 1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,  93),IHEL=1,9) /-1,-1, 1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,  94),IHEL=1,9) /-1,-1, 1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,  95),IHEL=1,9) /-1,-1, 1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL,  96),IHEL=1,9) /-1,-1, 1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL,  97),IHEL=1,9) /-1,-1, 1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,  98),IHEL=1,9) /-1,-1, 1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  99),IHEL=1,9) /-1,-1, 1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 100),IHEL=1,9) /-1,-1, 1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 101),IHEL=1,9) /-1,-1, 1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 102),IHEL=1,9) /-1,-1, 1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 103),IHEL=1,9) /-1,-1, 1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 104),IHEL=1,9) /-1,-1, 1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 105),IHEL=1,9) /-1,-1, 1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 106),IHEL=1,9) /-1,-1, 1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 107),IHEL=1,9) /-1,-1, 1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 108),IHEL=1,9) /-1,-1, 1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 109),IHEL=1,9) /-1,-1, 1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 110),IHEL=1,9) /-1,-1, 1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 111),IHEL=1,9) /-1,-1, 1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 112),IHEL=1,9) /-1,-1, 1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 113),IHEL=1,9) /-1,-1, 1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 114),IHEL=1,9) /-1,-1, 1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 115),IHEL=1,9) /-1,-1, 1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 116),IHEL=1,9) /-1,-1, 1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 117),IHEL=1,9) /-1,-1, 1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 118),IHEL=1,9) /-1,-1, 1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 119),IHEL=1,9) /-1,-1, 1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 120),IHEL=1,9) /-1,-1, 1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 121),IHEL=1,9) /-1,-1, 1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 122),IHEL=1,9) /-1,-1, 1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 123),IHEL=1,9) /-1,-1, 1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 124),IHEL=1,9) /-1,-1, 1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 125),IHEL=1,9) /-1,-1, 1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 126),IHEL=1,9) /-1,-1, 1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 127),IHEL=1,9) /-1,-1, 1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 128),IHEL=1,9) /-1,-1, 1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 129),IHEL=1,9) /-1, 1,-1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 130),IHEL=1,9) /-1, 1,-1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 131),IHEL=1,9) /-1, 1,-1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 132),IHEL=1,9) /-1, 1,-1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 133),IHEL=1,9) /-1, 1,-1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 134),IHEL=1,9) /-1, 1,-1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 135),IHEL=1,9) /-1, 1,-1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 136),IHEL=1,9) /-1, 1,-1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 137),IHEL=1,9) /-1, 1,-1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 138),IHEL=1,9) /-1, 1,-1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 139),IHEL=1,9) /-1, 1,-1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 140),IHEL=1,9) /-1, 1,-1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 141),IHEL=1,9) /-1, 1,-1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 142),IHEL=1,9) /-1, 1,-1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 143),IHEL=1,9) /-1, 1,-1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 144),IHEL=1,9) /-1, 1,-1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 145),IHEL=1,9) /-1, 1,-1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 146),IHEL=1,9) /-1, 1,-1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 147),IHEL=1,9) /-1, 1,-1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 148),IHEL=1,9) /-1, 1,-1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 149),IHEL=1,9) /-1, 1,-1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 150),IHEL=1,9) /-1, 1,-1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 151),IHEL=1,9) /-1, 1,-1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 152),IHEL=1,9) /-1, 1,-1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 153),IHEL=1,9) /-1, 1,-1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 154),IHEL=1,9) /-1, 1,-1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 155),IHEL=1,9) /-1, 1,-1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 156),IHEL=1,9) /-1, 1,-1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 157),IHEL=1,9) /-1, 1,-1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 158),IHEL=1,9) /-1, 1,-1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 159),IHEL=1,9) /-1, 1,-1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 160),IHEL=1,9) /-1, 1,-1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 161),IHEL=1,9) /-1, 1,-1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 162),IHEL=1,9) /-1, 1,-1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 163),IHEL=1,9) /-1, 1,-1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 164),IHEL=1,9) /-1, 1,-1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 165),IHEL=1,9) /-1, 1,-1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 166),IHEL=1,9) /-1, 1,-1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 167),IHEL=1,9) /-1, 1,-1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 168),IHEL=1,9) /-1, 1,-1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 169),IHEL=1,9) /-1, 1,-1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 170),IHEL=1,9) /-1, 1,-1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 171),IHEL=1,9) /-1, 1,-1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 172),IHEL=1,9) /-1, 1,-1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 173),IHEL=1,9) /-1, 1,-1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 174),IHEL=1,9) /-1, 1,-1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 175),IHEL=1,9) /-1, 1,-1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 176),IHEL=1,9) /-1, 1,-1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 177),IHEL=1,9) /-1, 1,-1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 178),IHEL=1,9) /-1, 1,-1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 179),IHEL=1,9) /-1, 1,-1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 180),IHEL=1,9) /-1, 1,-1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 181),IHEL=1,9) /-1, 1,-1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 182),IHEL=1,9) /-1, 1,-1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 183),IHEL=1,9) /-1, 1,-1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 184),IHEL=1,9) /-1, 1,-1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 185),IHEL=1,9) /-1, 1,-1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 186),IHEL=1,9) /-1, 1,-1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 187),IHEL=1,9) /-1, 1,-1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 188),IHEL=1,9) /-1, 1,-1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 189),IHEL=1,9) /-1, 1,-1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 190),IHEL=1,9) /-1, 1,-1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 191),IHEL=1,9) /-1, 1,-1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 192),IHEL=1,9) /-1, 1,-1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 193),IHEL=1,9) /-1, 1, 1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 194),IHEL=1,9) /-1, 1, 1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 195),IHEL=1,9) /-1, 1, 1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 196),IHEL=1,9) /-1, 1, 1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 197),IHEL=1,9) /-1, 1, 1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 198),IHEL=1,9) /-1, 1, 1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 199),IHEL=1,9) /-1, 1, 1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 200),IHEL=1,9) /-1, 1, 1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 201),IHEL=1,9) /-1, 1, 1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 202),IHEL=1,9) /-1, 1, 1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 203),IHEL=1,9) /-1, 1, 1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 204),IHEL=1,9) /-1, 1, 1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 205),IHEL=1,9) /-1, 1, 1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 206),IHEL=1,9) /-1, 1, 1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 207),IHEL=1,9) /-1, 1, 1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 208),IHEL=1,9) /-1, 1, 1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 209),IHEL=1,9) /-1, 1, 1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 210),IHEL=1,9) /-1, 1, 1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 211),IHEL=1,9) /-1, 1, 1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 212),IHEL=1,9) /-1, 1, 1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 213),IHEL=1,9) /-1, 1, 1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 214),IHEL=1,9) /-1, 1, 1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 215),IHEL=1,9) /-1, 1, 1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 216),IHEL=1,9) /-1, 1, 1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 217),IHEL=1,9) /-1, 1, 1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 218),IHEL=1,9) /-1, 1, 1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 219),IHEL=1,9) /-1, 1, 1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 220),IHEL=1,9) /-1, 1, 1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 221),IHEL=1,9) /-1, 1, 1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 222),IHEL=1,9) /-1, 1, 1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 223),IHEL=1,9) /-1, 1, 1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 224),IHEL=1,9) /-1, 1, 1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 225),IHEL=1,9) /-1, 1, 1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 226),IHEL=1,9) /-1, 1, 1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 227),IHEL=1,9) /-1, 1, 1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 228),IHEL=1,9) /-1, 1, 1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 229),IHEL=1,9) /-1, 1, 1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 230),IHEL=1,9) /-1, 1, 1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 231),IHEL=1,9) /-1, 1, 1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 232),IHEL=1,9) /-1, 1, 1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 233),IHEL=1,9) /-1, 1, 1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 234),IHEL=1,9) /-1, 1, 1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 235),IHEL=1,9) /-1, 1, 1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 236),IHEL=1,9) /-1, 1, 1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 237),IHEL=1,9) /-1, 1, 1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 238),IHEL=1,9) /-1, 1, 1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 239),IHEL=1,9) /-1, 1, 1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 240),IHEL=1,9) /-1, 1, 1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 241),IHEL=1,9) /-1, 1, 1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 242),IHEL=1,9) /-1, 1, 1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 243),IHEL=1,9) /-1, 1, 1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 244),IHEL=1,9) /-1, 1, 1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 245),IHEL=1,9) /-1, 1, 1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 246),IHEL=1,9) /-1, 1, 1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 247),IHEL=1,9) /-1, 1, 1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 248),IHEL=1,9) /-1, 1, 1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 249),IHEL=1,9) /-1, 1, 1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 250),IHEL=1,9) /-1, 1, 1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 251),IHEL=1,9) /-1, 1, 1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 252),IHEL=1,9) /-1, 1, 1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 253),IHEL=1,9) /-1, 1, 1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 254),IHEL=1,9) /-1, 1, 1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 255),IHEL=1,9) /-1, 1, 1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 256),IHEL=1,9) /-1, 1, 1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 257),IHEL=1,9) / 1,-1,-1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 258),IHEL=1,9) / 1,-1,-1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 259),IHEL=1,9) / 1,-1,-1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 260),IHEL=1,9) / 1,-1,-1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 261),IHEL=1,9) / 1,-1,-1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 262),IHEL=1,9) / 1,-1,-1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 263),IHEL=1,9) / 1,-1,-1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 264),IHEL=1,9) / 1,-1,-1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 265),IHEL=1,9) / 1,-1,-1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 266),IHEL=1,9) / 1,-1,-1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 267),IHEL=1,9) / 1,-1,-1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 268),IHEL=1,9) / 1,-1,-1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 269),IHEL=1,9) / 1,-1,-1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 270),IHEL=1,9) / 1,-1,-1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 271),IHEL=1,9) / 1,-1,-1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 272),IHEL=1,9) / 1,-1,-1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 273),IHEL=1,9) / 1,-1,-1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 274),IHEL=1,9) / 1,-1,-1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 275),IHEL=1,9) / 1,-1,-1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 276),IHEL=1,9) / 1,-1,-1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 277),IHEL=1,9) / 1,-1,-1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 278),IHEL=1,9) / 1,-1,-1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 279),IHEL=1,9) / 1,-1,-1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 280),IHEL=1,9) / 1,-1,-1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 281),IHEL=1,9) / 1,-1,-1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 282),IHEL=1,9) / 1,-1,-1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 283),IHEL=1,9) / 1,-1,-1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 284),IHEL=1,9) / 1,-1,-1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 285),IHEL=1,9) / 1,-1,-1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 286),IHEL=1,9) / 1,-1,-1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 287),IHEL=1,9) / 1,-1,-1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 288),IHEL=1,9) / 1,-1,-1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 289),IHEL=1,9) / 1,-1,-1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 290),IHEL=1,9) / 1,-1,-1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 291),IHEL=1,9) / 1,-1,-1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 292),IHEL=1,9) / 1,-1,-1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 293),IHEL=1,9) / 1,-1,-1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 294),IHEL=1,9) / 1,-1,-1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 295),IHEL=1,9) / 1,-1,-1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 296),IHEL=1,9) / 1,-1,-1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 297),IHEL=1,9) / 1,-1,-1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 298),IHEL=1,9) / 1,-1,-1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 299),IHEL=1,9) / 1,-1,-1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 300),IHEL=1,9) / 1,-1,-1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 301),IHEL=1,9) / 1,-1,-1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 302),IHEL=1,9) / 1,-1,-1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 303),IHEL=1,9) / 1,-1,-1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 304),IHEL=1,9) / 1,-1,-1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 305),IHEL=1,9) / 1,-1,-1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 306),IHEL=1,9) / 1,-1,-1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 307),IHEL=1,9) / 1,-1,-1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 308),IHEL=1,9) / 1,-1,-1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 309),IHEL=1,9) / 1,-1,-1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 310),IHEL=1,9) / 1,-1,-1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 311),IHEL=1,9) / 1,-1,-1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 312),IHEL=1,9) / 1,-1,-1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 313),IHEL=1,9) / 1,-1,-1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 314),IHEL=1,9) / 1,-1,-1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 315),IHEL=1,9) / 1,-1,-1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 316),IHEL=1,9) / 1,-1,-1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 317),IHEL=1,9) / 1,-1,-1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 318),IHEL=1,9) / 1,-1,-1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 319),IHEL=1,9) / 1,-1,-1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 320),IHEL=1,9) / 1,-1,-1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 321),IHEL=1,9) / 1,-1, 1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 322),IHEL=1,9) / 1,-1, 1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 323),IHEL=1,9) / 1,-1, 1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 324),IHEL=1,9) / 1,-1, 1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 325),IHEL=1,9) / 1,-1, 1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 326),IHEL=1,9) / 1,-1, 1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 327),IHEL=1,9) / 1,-1, 1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 328),IHEL=1,9) / 1,-1, 1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 329),IHEL=1,9) / 1,-1, 1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 330),IHEL=1,9) / 1,-1, 1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 331),IHEL=1,9) / 1,-1, 1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 332),IHEL=1,9) / 1,-1, 1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 333),IHEL=1,9) / 1,-1, 1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 334),IHEL=1,9) / 1,-1, 1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 335),IHEL=1,9) / 1,-1, 1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 336),IHEL=1,9) / 1,-1, 1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 337),IHEL=1,9) / 1,-1, 1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 338),IHEL=1,9) / 1,-1, 1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 339),IHEL=1,9) / 1,-1, 1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 340),IHEL=1,9) / 1,-1, 1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 341),IHEL=1,9) / 1,-1, 1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 342),IHEL=1,9) / 1,-1, 1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 343),IHEL=1,9) / 1,-1, 1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 344),IHEL=1,9) / 1,-1, 1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 345),IHEL=1,9) / 1,-1, 1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 346),IHEL=1,9) / 1,-1, 1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 347),IHEL=1,9) / 1,-1, 1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 348),IHEL=1,9) / 1,-1, 1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 349),IHEL=1,9) / 1,-1, 1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 350),IHEL=1,9) / 1,-1, 1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 351),IHEL=1,9) / 1,-1, 1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 352),IHEL=1,9) / 1,-1, 1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 353),IHEL=1,9) / 1,-1, 1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 354),IHEL=1,9) / 1,-1, 1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 355),IHEL=1,9) / 1,-1, 1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 356),IHEL=1,9) / 1,-1, 1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 357),IHEL=1,9) / 1,-1, 1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 358),IHEL=1,9) / 1,-1, 1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 359),IHEL=1,9) / 1,-1, 1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 360),IHEL=1,9) / 1,-1, 1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 361),IHEL=1,9) / 1,-1, 1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 362),IHEL=1,9) / 1,-1, 1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 363),IHEL=1,9) / 1,-1, 1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 364),IHEL=1,9) / 1,-1, 1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 365),IHEL=1,9) / 1,-1, 1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 366),IHEL=1,9) / 1,-1, 1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 367),IHEL=1,9) / 1,-1, 1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 368),IHEL=1,9) / 1,-1, 1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 369),IHEL=1,9) / 1,-1, 1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 370),IHEL=1,9) / 1,-1, 1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 371),IHEL=1,9) / 1,-1, 1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 372),IHEL=1,9) / 1,-1, 1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 373),IHEL=1,9) / 1,-1, 1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 374),IHEL=1,9) / 1,-1, 1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 375),IHEL=1,9) / 1,-1, 1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 376),IHEL=1,9) / 1,-1, 1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 377),IHEL=1,9) / 1,-1, 1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 378),IHEL=1,9) / 1,-1, 1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 379),IHEL=1,9) / 1,-1, 1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 380),IHEL=1,9) / 1,-1, 1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 381),IHEL=1,9) / 1,-1, 1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 382),IHEL=1,9) / 1,-1, 1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 383),IHEL=1,9) / 1,-1, 1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 384),IHEL=1,9) / 1,-1, 1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 385),IHEL=1,9) / 1, 1,-1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 386),IHEL=1,9) / 1, 1,-1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 387),IHEL=1,9) / 1, 1,-1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 388),IHEL=1,9) / 1, 1,-1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 389),IHEL=1,9) / 1, 1,-1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 390),IHEL=1,9) / 1, 1,-1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 391),IHEL=1,9) / 1, 1,-1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 392),IHEL=1,9) / 1, 1,-1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 393),IHEL=1,9) / 1, 1,-1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 394),IHEL=1,9) / 1, 1,-1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 395),IHEL=1,9) / 1, 1,-1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 396),IHEL=1,9) / 1, 1,-1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 397),IHEL=1,9) / 1, 1,-1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 398),IHEL=1,9) / 1, 1,-1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 399),IHEL=1,9) / 1, 1,-1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 400),IHEL=1,9) / 1, 1,-1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 401),IHEL=1,9) / 1, 1,-1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 402),IHEL=1,9) / 1, 1,-1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 403),IHEL=1,9) / 1, 1,-1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 404),IHEL=1,9) / 1, 1,-1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 405),IHEL=1,9) / 1, 1,-1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 406),IHEL=1,9) / 1, 1,-1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 407),IHEL=1,9) / 1, 1,-1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 408),IHEL=1,9) / 1, 1,-1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 409),IHEL=1,9) / 1, 1,-1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 410),IHEL=1,9) / 1, 1,-1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 411),IHEL=1,9) / 1, 1,-1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 412),IHEL=1,9) / 1, 1,-1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 413),IHEL=1,9) / 1, 1,-1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 414),IHEL=1,9) / 1, 1,-1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 415),IHEL=1,9) / 1, 1,-1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 416),IHEL=1,9) / 1, 1,-1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 417),IHEL=1,9) / 1, 1,-1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 418),IHEL=1,9) / 1, 1,-1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 419),IHEL=1,9) / 1, 1,-1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 420),IHEL=1,9) / 1, 1,-1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 421),IHEL=1,9) / 1, 1,-1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 422),IHEL=1,9) / 1, 1,-1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 423),IHEL=1,9) / 1, 1,-1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 424),IHEL=1,9) / 1, 1,-1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 425),IHEL=1,9) / 1, 1,-1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 426),IHEL=1,9) / 1, 1,-1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 427),IHEL=1,9) / 1, 1,-1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 428),IHEL=1,9) / 1, 1,-1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 429),IHEL=1,9) / 1, 1,-1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 430),IHEL=1,9) / 1, 1,-1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 431),IHEL=1,9) / 1, 1,-1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 432),IHEL=1,9) / 1, 1,-1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 433),IHEL=1,9) / 1, 1,-1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 434),IHEL=1,9) / 1, 1,-1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 435),IHEL=1,9) / 1, 1,-1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 436),IHEL=1,9) / 1, 1,-1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 437),IHEL=1,9) / 1, 1,-1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 438),IHEL=1,9) / 1, 1,-1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 439),IHEL=1,9) / 1, 1,-1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 440),IHEL=1,9) / 1, 1,-1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 441),IHEL=1,9) / 1, 1,-1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 442),IHEL=1,9) / 1, 1,-1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 443),IHEL=1,9) / 1, 1,-1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 444),IHEL=1,9) / 1, 1,-1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 445),IHEL=1,9) / 1, 1,-1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 446),IHEL=1,9) / 1, 1,-1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 447),IHEL=1,9) / 1, 1,-1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 448),IHEL=1,9) / 1, 1,-1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 449),IHEL=1,9) / 1, 1, 1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 450),IHEL=1,9) / 1, 1, 1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 451),IHEL=1,9) / 1, 1, 1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 452),IHEL=1,9) / 1, 1, 1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 453),IHEL=1,9) / 1, 1, 1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 454),IHEL=1,9) / 1, 1, 1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 455),IHEL=1,9) / 1, 1, 1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 456),IHEL=1,9) / 1, 1, 1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 457),IHEL=1,9) / 1, 1, 1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 458),IHEL=1,9) / 1, 1, 1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 459),IHEL=1,9) / 1, 1, 1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 460),IHEL=1,9) / 1, 1, 1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 461),IHEL=1,9) / 1, 1, 1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 462),IHEL=1,9) / 1, 1, 1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 463),IHEL=1,9) / 1, 1, 1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 464),IHEL=1,9) / 1, 1, 1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 465),IHEL=1,9) / 1, 1, 1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 466),IHEL=1,9) / 1, 1, 1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 467),IHEL=1,9) / 1, 1, 1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 468),IHEL=1,9) / 1, 1, 1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 469),IHEL=1,9) / 1, 1, 1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 470),IHEL=1,9) / 1, 1, 1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 471),IHEL=1,9) / 1, 1, 1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 472),IHEL=1,9) / 1, 1, 1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 473),IHEL=1,9) / 1, 1, 1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 474),IHEL=1,9) / 1, 1, 1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 475),IHEL=1,9) / 1, 1, 1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 476),IHEL=1,9) / 1, 1, 1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 477),IHEL=1,9) / 1, 1, 1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 478),IHEL=1,9) / 1, 1, 1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 479),IHEL=1,9) / 1, 1, 1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 480),IHEL=1,9) / 1, 1, 1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 481),IHEL=1,9) / 1, 1, 1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 482),IHEL=1,9) / 1, 1, 1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 483),IHEL=1,9) / 1, 1, 1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 484),IHEL=1,9) / 1, 1, 1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 485),IHEL=1,9) / 1, 1, 1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 486),IHEL=1,9) / 1, 1, 1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 487),IHEL=1,9) / 1, 1, 1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 488),IHEL=1,9) / 1, 1, 1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 489),IHEL=1,9) / 1, 1, 1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 490),IHEL=1,9) / 1, 1, 1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 491),IHEL=1,9) / 1, 1, 1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 492),IHEL=1,9) / 1, 1, 1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 493),IHEL=1,9) / 1, 1, 1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 494),IHEL=1,9) / 1, 1, 1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 495),IHEL=1,9) / 1, 1, 1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 496),IHEL=1,9) / 1, 1, 1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(IHEL, 497),IHEL=1,9) / 1, 1, 1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(IHEL, 498),IHEL=1,9) / 1, 1, 1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(IHEL, 499),IHEL=1,9) / 1, 1, 1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(IHEL, 500),IHEL=1,9) / 1, 1, 1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(IHEL, 501),IHEL=1,9) / 1, 1, 1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(IHEL, 502),IHEL=1,9) / 1, 1, 1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(IHEL, 503),IHEL=1,9) / 1, 1, 1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(IHEL, 504),IHEL=1,9) / 1, 1, 1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(IHEL, 505),IHEL=1,9) / 1, 1, 1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(IHEL, 506),IHEL=1,9) / 1, 1, 1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(IHEL, 507),IHEL=1,9) / 1, 1, 1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(IHEL, 508),IHEL=1,9) / 1, 1, 1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(IHEL, 509),IHEL=1,9) / 1, 1, 1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(IHEL, 510),IHEL=1,9) / 1, 1, 1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(IHEL, 511),IHEL=1,9) / 1, 1, 1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(IHEL, 512),IHEL=1,9) / 1, 1, 1, 1, 1, 1, 1, 1, 1/
      DATA (  IC(IHEL,  1),IHEL=1,9) / 1, 2, 3, 4, 5, 6, 7, 8, 9/
      DATA (IDEN(IHEL),IHEL=  1,  1) /  96/
C ----------
C BEGIN CODE
C ----------
      NTRY=NTRY+1
      DO IPROC=1,NCROSS
      CALL SWITCHMOM(P1,P,IC(1,IPROC),JC,NEXTERNAL)
      DO IHEL=1,NEXTERNAL
         JC(IHEL) = +1
      ENDDO
       
C SF: comment out all instances of multi_channel
c      IF (multi_channel) THEN
c          DO IHEL=1,NGRAPHS
c              amp2(ihel)=0d0
c              jamp2(ihel)=0d0
c          ENDDO
c          DO IHEL=1,int(jamp2(0))
c              jamp2(ihel)=0d0
c          ENDDO
c      ENDIF
      ANS(IPROC) = 0D0
      write(hel_buff,'(16i5)') (0,i=1,nexternal)
      IF (ISUM_HEL .EQ. 0 .OR. NTRY .LT. 10) THEN
          DO IHEL=1,NCOMB
              IF (GOODHEL(IHEL,IPROC) .OR. NTRY .LT. 2) THEN
                 T=MATUG_TTBU(P ,NHEL(1,IHEL),JC(1))            
                 ANS(IPROC)=ANS(IPROC)+T
                  IF (T .GT. 0D0 .AND. .NOT. GOODHEL(IHEL,IPROC)) THEN
                      GOODHEL(IHEL,IPROC)=.TRUE.
                      NGOOD = NGOOD +1
                      IGOOD(NGOOD) = IHEL
C                WRITE(*,*) ngood,IHEL,T
                  ENDIF
              ENDIF
          ENDDO
          JHEL = 1
          ISUM_HEL=MIN(ISUM_HEL,NGOOD)
      ELSE              !RANDOM HELICITY
          DO J=1,ISUM_HEL
              JHEL=JHEL+1
              IF (JHEL .GT. NGOOD) JHEL=1
              HWGT = REAL(NGOOD)/REAL(ISUM_HEL)
              IHEL = IGOOD(JHEL)
              T=MATUG_TTBU(P ,NHEL(1,IHEL),JC(1))            
           ANS(IPROC)=ANS(IPROC)+T*HWGT
          ENDDO
          IF (ISUM_HEL .EQ. 1) THEN
              WRITE(HEL_BUFF,'(16i5)')(NHEL(i,IHEL),i=1,nexternal)
          ENDIF
      ENDIF
C SF: comment out all instances of multi_channel
c      IF (MULTI_CHANNEL) THEN
c          XTOT=0D0
c          DO IHEL=1,MAPCONFIG(0)
c              XTOT=XTOT+AMP2(MAPCONFIG(IHEL))
c          ENDDO
c          ANS(IPROC)=ANS(IPROC)*AMP2(MAPCONFIG(ICONFIG))/XTOT
c      ENDIF
      ANS(IPROC)=ANS(IPROC)/DBLE(IDEN(IPROC))
      ENDDO
      END
       
       
C SF: the original name MATRIX has been replaced by MATUG_TTBU
      REAL*8 FUNCTION MATUG_TTBU(P,NHEL,IC)
C  
C Generated by MadGraph II Version 3.90. Updated 08/26/05               
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : u g -> e+ ve b e- ve~ b~ u  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS,    NEIGEN 
      PARAMETER (NGRAPHS=   5,NEIGEN=  4) 
C SF: replace the following include with the explicit inclusion of
c nexternal.inc, originally included by genps.inc
c      include "genps.inc"
      integer    nexternal
      parameter (nexternal=  9)
      INTEGER    NWAVEFUNCS     , NCOLOR
      PARAMETER (NWAVEFUNCS=  21, NCOLOR=   4) 
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      REAL*8 P(0:3,NEXTERNAL)
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J
      COMPLEX*16 ZTEMP
      REAL*8 DENOM(NCOLOR), CF(NCOLOR,NCOLOR)
      COMPLEX*16 AMP(NGRAPHS), JAMP(NCOLOR)
      COMPLEX*16 W(6,NWAVEFUNCS)
C  
C GLOBAL VARIABLES
C  
C SF: comment out all instances of amp2, used by multi_channel
c      Double Precision amp2(maxamps), jamp2(0:maxamps)
c      common/to_amps/  amp2,       jamp2
C SF: The original coupl.inc has been renamed MEcoupl.inc
      include "MEcoupl.inc"
C  
C COLOR DATA
C  
      DATA Denom(1  )/            3/                                       
      DATA (CF(i,1  ),i=1  ,4  ) /     8,   -1,   -2,    7/                
C               T[8,9]T[1,5,2]                                             
      DATA Denom(2  )/            3/                                       
      DATA (CF(i,2  ),i=1  ,4  ) /    -1,    8,    7,   -2/                
C               T[1,5]T[8,9,2]                                             
      DATA Denom(3  )/            3/                                       
      DATA (CF(i,3  ),i=1  ,4  ) /    -2,    7,    8,   -1/                
C               T[8,9,2]T[1,5]                                             
      DATA Denom(4  )/            3/                                       
      DATA (CF(i,4  ),i=1  ,4  ) /     7,   -2,   -1,    8/                
C               T[8,9]T[1,5,2]                                             
C ----------
C BEGIN CODE
C ----------
      CALL IXXXXX(P(0,1   ),ZERO ,NHEL(1   ),+1*IC(1   ),W(1,1   ))        
      CALL VXXXXX(P(0,2   ),ZERO ,NHEL(2   ),-1*IC(2   ),W(1,2   ))        
      CALL IXXXXX(P(0,3   ),ZERO ,NHEL(3   ),-1*IC(3   ),W(1,3   ))        
      CALL OXXXXX(P(0,4   ),ZERO ,NHEL(4   ),+1*IC(4   ),W(1,4   ))        
      CALL OXXXXX(P(0,5   ),BMASS ,NHEL(5   ),+1*IC(5   ),W(1,5   ))       
      CALL OXXXXX(P(0,6   ),ZERO ,NHEL(6   ),+1*IC(6   ),W(1,6   ))        
      CALL IXXXXX(P(0,7   ),ZERO ,NHEL(7   ),-1*IC(7   ),W(1,7   ))        
      CALL IXXXXX(P(0,8   ),BMASS ,NHEL(8   ),-1*IC(8   ),W(1,8   ))       
      CALL OXXXXX(P(0,9   ),ZERO ,NHEL(9   ),+1*IC(9   ),W(1,9   ))        
      CALL JIOXXX(W(1,3   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,10  ))    
      CALL FVOXXX(W(1,5   ),W(1,10  ),GWF ,TMASS   ,TWIDTH  ,W(1,11  ))    
      CALL JIOXXX(W(1,7   ),W(1,6   ),GWF ,WMASS   ,WWIDTH  ,W(1,12  ))    
      CALL FVIXXX(W(1,8   ),W(1,12  ),GWF ,TMASS   ,TWIDTH  ,W(1,13  ))    
      CALL JIOXXX(W(1,1   ),W(1,9   ),GG ,ZERO    ,ZERO    ,W(1,14  ))     
      CALL FVOXXX(W(1,11  ),W(1,2   ),GG ,TMASS   ,TWIDTH  ,W(1,15  ))     
      CALL IOVXXX(W(1,13  ),W(1,15  ),W(1,14  ),GG ,AMP(1   ))             
      CALL FVOXXX(W(1,11  ),W(1,14  ),GG ,TMASS   ,TWIDTH  ,W(1,16  ))     
      CALL IOVXXX(W(1,13  ),W(1,16  ),W(1,2   ),GG ,AMP(2   ))             
      CALL JVVXXX(W(1,14  ),W(1,2   ),G ,ZERO    ,ZERO    ,W(1,17  ))      
      CALL IOVXXX(W(1,13  ),W(1,11  ),W(1,17  ),GG ,AMP(3   ))             
      CALL FVOXXX(W(1,9   ),W(1,2   ),GG ,ZERO    ,ZERO    ,W(1,18  ))     
      CALL JIOXXX(W(1,1   ),W(1,18  ),GG ,ZERO    ,ZERO    ,W(1,19  ))     
      CALL IOVXXX(W(1,13  ),W(1,11  ),W(1,19  ),GG ,AMP(4   ))             
      CALL FVIXXX(W(1,1   ),W(1,2   ),GG ,ZERO    ,ZERO    ,W(1,20  ))     
      CALL JIOXXX(W(1,20  ),W(1,9   ),GG ,ZERO    ,ZERO    ,W(1,21  ))     
      CALL IOVXXX(W(1,13  ),W(1,11  ),W(1,21  ),GG ,AMP(5   ))             
      JAMP(   1) = +AMP(   1)-AMP(   3)
      JAMP(   2) = +AMP(   2)+AMP(   3)
      JAMP(   3) = +AMP(   4)
      JAMP(   4) = +AMP(   5)
      MATUG_TTBU = 0.D0   
      DO I = 1, NCOLOR
          ZTEMP = (0.D0,0.D0)
          DO J = 1, NCOLOR
              ZTEMP = ZTEMP + CF(J,I)*JAMP(J)
          ENDDO
          MATUG_TTBU =MATUG_TTBU+ZTEMP*DCONJG(JAMP(I))/DENOM(I)   
      ENDDO
C SF: comment out all instances of amp2, used by multi_channel
c      Do I = 1, NGRAPHS
c          amp2(i)=amp2(i)+amp(i)*dconjg(amp(i))
c      Enddo
c      Do I = 1, NCOLOR
c          Jamp2(i)=Jamp2(i)+Jamp(i)*dconjg(Jamp(i))
c      Enddo
C      CALL GAUGECHECK(JAMP,ZTEMP,EIGEN_VEC,EIGEN_VAL,NCOLOR,NEIGEN) 
      END
c
c
c End of qg --> ttbar q
c
c
c
c This file collects all the files of the HELAS package as obtained from
c MadEvent, except those listed in packHELAS.com.
c
c The lines relevant to preprocessor instructions, to be found between
c #ifdef and #endif in the original codes, have been eliminated by hand.
c They are affected by trivial programming bugs (as one can see by commenting
c out #ifdef and #endif), and are therefore apparently not used, since the 
c compilation usually runs smoothly, which is equivalent to setting
c HELAS_CHECK=0
c
      subroutine boostx(p,q , pboost)
c
c This subroutine performs the Lorentz boost of a four-momentum.  The
c momentum p is assumed to be given in the rest frame of q.  pboost is
c the momentum p boosted to the frame in which q is given.  q must be a
c timelike momentum.
c
c input:
c       real    p(0:3)         : four-momentum p in the q rest  frame
c       real    q(0:3)         : four-momentum q in the boosted frame
c
c output:
c       real    pboost(0:3)    : four-momentum p in the boosted frame
c
      implicit none
      double precision p(0:3),q(0:3),pboost(0:3),pq,qq,m,lf

      double precision rZero
      parameter( rZero = 0.0d0 )

c
      qq = q(1)**2+q(2)**2+q(3)**2

      if ( qq.ne.rZero ) then
         pq = p(1)*q(1)+p(2)*q(2)+p(3)*q(3)
         m = sqrt(q(0)**2-qq)
         lf = ((q(0)-m)*pq/qq+p(0))/m
         pboost(0) = (p(0)*q(0)+pq)/m
         pboost(1) =  p(1)+q(1)*lf
         pboost(2) =  p(2)+q(2)*lf
         pboost(3) =  p(3)+q(3)*lf
      else
         pboost(0) = p(0)
         pboost(1) = p(1)
         pboost(2) = p(2)
         pboost(3) = p(3)
      endif
c
      return
      end
      subroutine eaixxx(eb,ea,shlf,chlf,phi,nhe,nha , eai)
c
c This subroutine computes an off-shell electron wavefunction after
c emitting a photon from the electron beam, with a special care for the
c small angle region.  The momenta are measured in the laboratory frame,
c where the e- beam is along the positive z axis.
c
c input:
c       real    eb             : energy (GeV)    of beam  e-
c       real    ea             : energy (GeV)    of final photon
c       real    shlf           : sin(theta/2)    of final photon
c       real    chlf           : cos(theta/2)    of final photon
c       real    phi            : azimuthal angle of final photon
c       integer nhe  = -1 or 1 : helicity        of beam  e-
c       integer nha  = -1 or 1 : helicity        of final photon
c
c output:
c       complex eai(6)         : off-shell electron             |e',A,e>
c
      implicit none
      double complex eai(6),phs
      double precision eb,ea,shlf,chlf,phi,alpha,gal,rnhe,x,c,s,d
      double precision coeff,xnnp,xnnm,snp,csp
      integer nhe,nha,nn

      double precision rHalf, rOne, rTwo, rFour, rOte
      double precision rPi, rIalph
      parameter( rHalf = 0.5d0, rOne = 1.0d0, rTwo = 2.0d0 )
      parameter( rFour = 4.0d0, rOte = 128.9d0 )
      parameter( rPi = 3.14159265358979323846d0 )
      parameter( rIalph = 137.0359895d0 )

      double precision me
      parameter( me = 0.510998902d-3 )

c
      alpha = rOne/rOte
      gal = sqrt(alpha*rFour*rPi)

      nn = nha*nhe
      rnhe = nhe
      x = ea/eb
      c = (chlf+shlf)*(chlf-shlf)
      s = rTwo*chlf*shlf
      d = -rOne/(ea*eb*(rFour*shlf**2+(me/eb)**2*c))
      coeff = -nn*gal*sqrt(eb)*d
      xnnp = x*(1+nn)
      xnnm = x*(1-nn)
      snp = sin(phi)
      csp = cos(phi)
      phs = dcmplx( csp, rnhe*snp )

      eai((5-3*nhe)/2) = -rnhe*coeff*me*s*(rOne+xnnp*rHalf)
      eai((5-nhe)/2)   =  xnnp*coeff*me*chlf**2*phs
      eai((5+nhe)/2)   =  rnhe*coeff*eb*s*(-rTwo+xnnm)
      eai((5+3*nhe)/2) =  xnnm*coeff*eb*shlf**2*phs*rTwo

      eai(5) =  eb*dcmplx( rOne-x, rOne-x*c )
      eai(6) = -eb*x*s*dcmplx( csp, snp )
c
      return
      end
      subroutine eaoxxx(eb,ea,shlf,chlf,phi,nhe,nha , eao)
c
c This subroutine computes an off-shell positron wavefunction after
c emitting a photon from the positron beam, with a special care for the
c small angle region.  The momenta are measured in the laboratory frame,
c where the e+ beam is along the negative z axis.
c
c input:
c       real    eb             : energy (GeV)    of beam  e+
c       real    ea             : energy (GeV)    of final photon
c       real    shlf           : sin(theta/2)    of final photon
c       real    chlf           : cos(theta/2)    of final photon
c       real    phi            : azimuthal angle of final photon
c       integer nhe  = -1 or 1 : helicity        of beam  e+
c       integer nha  = -1 or 1 : helicity        of final photon
c
c output:
c       complex eao(6)         : off-shell positron             <e,A,e'|
c
      implicit none
      double complex eao(6),phs
      double precision eb,ea,shlf,chlf,phi,alpha,gal,rnhe,x,c,s,d
      double precision coeff,xnnp,xnnm,snp,csp
      integer nhe,nha,nn

      double precision rHalf, rOne, rTwo, rFour, rOte
      double precision rPi, rIalph
      parameter( rHalf = 0.5d0, rOne = 1.0d0, rTwo = 2.0d0 )
      parameter( rFour = 4.0d0, rOte = 128.9d0 )
      parameter( rPi = 3.14159265358979323846d0 )
      parameter( rIalph = 137.0359895d0 )

      double precision me
      parameter( me = 0.510998902d-3 )

c

      alpha = rOne/rOte
      gal = sqrt(alpha*rFour*rPi)

      nn = nha*nhe
      rnhe = nhe
      x = ea/eb
      c = (chlf+shlf)*(chlf-shlf)
      s = rTwo*chlf*shlf
      d = -rOne/(ea*eb*(rFour*chlf**2-(me/eb)**2*c))
      coeff = nn*gal*sqrt(eb)*d
      xnnp = x*(1+nn)
      xnnm = x*(1-nn)
      snp = sin(phi)
      csp = cos(phi)
      phs = dcmplx( csp, -rnhe*snp )

      eao((5-3*nhe)/2) =               coeff*me*s*(rOne+xnnp*rHalf)
      eao((5-nhe)/2)   = rnhe*xnnp    *coeff*me*shlf**2*phs
      eao((5+nhe)/2)   =               coeff*eb*s*(-rTwo+xnnm)
      eao((5+3*nhe)/2) = real(nha-nhe)*coeff*eb*x*chlf**2*phs*rTwo

      eao(5) = eb*dcmplx( x-rOne, x*c+rOne )
      eao(6) = eb*x*s*dcmplx( csp, snp )
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine ficxxx(fi , fic)
c
c this subroutine charge conjugates a flowing-in fermion wavefunction.  
c                                                                       
c input:                                                                
c       complex fi(6)          : flowing-in fermion                 |fi>
c                                                                       
c output:                                                               
c       complex fic(6)         : charge conjugated fermion         <fic|
c
      implicit none
      double complex fi(6), fic(6)
c
      fic(1) = -fi(2)
      fic(2) =  fi(1)
      fic(3) =  fi(4)
      fic(4) = -fi(3)
      fic(5) = -fi(5)
      fic(6) = -fi(6)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine focxxx(fo , foc)
c
c this subroutine charge conjugates a flowing-out fermion wavefunction. 
c                                                                       
c input:                                                                
c       complex fo(6)          : flowing-out fermion                <fo|
c                                                                       
c output:                                                               
c       complex foc(6)         : charge conjugated fermion         |foc>
c
      implicit none
      double complex fo(6), foc(6)
c
      foc(1) =  fo(2)
      foc(2) = -fo(1)
      foc(3) = -fo(4)
      foc(4) =  fo(3)
      foc(5) = -fo(5)
      foc(6) = -fo(6)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine fsicxx(fic,sc,gc,fmass,fwidth , fsic)
c
c this subroutine computes an off-shell antifermion wavefunction from a 
c flowing-in external antifermion and a vector boson.                   
c                                                                       
c input:                                                                
c       complex fic(6)         : flow-in  antifermion           |fic>
c       complex sc(3)          : input    scalar                   s 
c       complex gc(2)          : coupling constants              gchf
c       real    fmass          : mass  of output antifermion fc'     
c       real    fwidth         : width of output antifermion fc'     
c                                                                       
c output:                                                               
c       complex fsic(6)        : off-shell fermion        |fc',s,fic>
c
      implicit none
      double complex fic(6),sc(3),fsic(6),gc(2),sl1,sl2,sr1,sr2,ds
      double precision pf(0:3),fmass,fwidth,pf2,p0p3,p0m3
c
      fsic(5) = fic(5)-sc(2)
      fsic(6) = fic(6)-sc(3)

      pf(0) = dble( fsic(5))
      pf(1) = dble( fsic(6))
      pf(2) = dimag(fsic(6))
      pf(3) = dimag(fsic(5))
      pf2 = pf(0)**2-(pf(1)**2+pf(2)**2+pf(3)**2)

      ds = -sc(1)/dcmplx( pf2-fmass**2, fmass*fwidth )
      p0p3 = pf(0)+pf(3)
      p0m3 = pf(0)-pf(3)
      sl1 = gc(1)*(p0p3*fic(1)+dconjg(fsic(6))*fic(2))
      sl2 = gc(1)*(p0m3*fic(2)       +fsic(6) *fic(1))
      sr1 = gc(2)*(p0m3*fic(3)-dconjg(fsic(6))*fic(4))
      sr2 = gc(2)*(p0p3*fic(4)       -fsic(6) *fic(3))

      fsic(1) = ( gc(1)*fmass*fic(1) + sr1 )*ds
      fsic(2) = ( gc(1)*fmass*fic(2) + sr2 )*ds
      fsic(3) = ( gc(2)*fmass*fic(3) + sl1 )*ds
      fsic(4) = ( gc(2)*fmass*fic(4) + sl2 )*ds
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine fsigld(fi,sc,gc,fmass,fwidth,smass,mNLSP,idecay , fsi)
c
c This subroutine computes an off-shell fermion wavefunction from a
c flowing-in external fermion and a scalar boson, for the NLSP-boson-
c Goldstino vertex. The h.c. of the NLSP decay is handled via the
c input parameter idecay.
c
c input:
c       complex fi(6)          : flow-in  fermion                   |fi>
c       complex sc(3)          : input    scalar                      s
c       complex gc(2)          : coupling constants                  gsf
c       real    fmass          : mass  of output fermion f'
c       real    fwidth         : width of output fermion f'
c       integer idecay         :  1 for NLSP decay to Goldstino
c                              : -1 for Goldstino to NLSP (h.c. of above)
c
c output:
c       complex fsi(6)         : off-shell fermion             |f',s,fi>
c
      implicit none
      double complex  fi(6), sc(3), gc(2), fsi(6), s1, s2, s3, s4, ds
      double complex  p14p, p14m, p23p, p23m
      double precision  pf(0:3), fmass, fwidth, mNLSP, smass, pf2
      integer idecay

      double complex ci, cZero
      parameter( ci = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )
c
      fsi(5) = fi(5) - sc(2)
      fsi(6) = fi(6) - sc(3)

      pf(0) = dble( fsi(5))
      pf(1) = dble( fsi(6))
      pf(2) = dimag(fsi(6))
      pf(3) = dimag(fsi(5))
      pf2 = pf(0)**2 - pf(1)**2 - pf(2)**2 - pf(3)**2

      if ( idecay.ne.1 .or. idecay.ne.-1 ) then
         write(6,*) 'error in idecay of FSIGLD'
         stop
      end if

      p14p = dble(sc(2)) + dimag(sc(2))
      p14m = dble(sc(2)) - dimag(sc(2))
      p23p = dble(sc(3)) + dimag(sc(3))*ci
      p23m = dble(sc(3)) - dimag(sc(3))*ci

      ds = -sc(1)/dcmplx( pf2-fmass**2, fmass*fwidth )

      s1 = -idecay*gc(1)*fi(1)*smass**2
      s2 = -idecay*gc(1)*fi(2)*smass**2
      s3 = gc(1)*mNLSP*( fi(1)*p14p + fi(2)*p23m ) 
      s4 = gc(1)*mNLSP*( fi(1)*p23p + fi(2)*p14m )

      if ( gc(2).ne.cZero ) then
         s1 = s1 + gc(2)*mNLSP*( fi(3)*p14m - fi(4)*p23m )
         s2 = s2 + gc(2)*mNLSP*(-fi(3)*p23p + fi(4)*p14p )
         s3 = s3 - gc(2)*idecay*fi(3)*smass**2
         s4 = s4 - gc(2)*idecay*fi(4)*smass**2
      end if

      fsi(1) = ( (pf(0)-pf(3))*s3 - dconjg(fsi(6))*s4 + fmass*s1 )*ds
      fsi(2) = (       -fsi(6)*s3 +  (pf(0)+pf(3))*s4 + fmass*s2 )*ds
      fsi(3) = ( (pf(0)+pf(3))*s1 + dconjg(fsi(6))*s2 + fmass*s3 )*ds
      fsi(4) = (        fsi(6)*s1 +  (pf(0)-pf(3))*s2 + fmass*s4 )*ds
c
      return          
      end
      subroutine fsixxx(fi,sc,gc,fmass,fwidth , fsi)
c
c This subroutine computes an off-shell fermion wavefunction from a
c flowing-IN external fermion and a vector boson.
c
c input:
c       complex fi(6)          : flow-in  fermion                   |fi>
c       complex sc(3)          : input    scalar                      s
c       complex gc(2)          : coupling constants                 gchf
c       real    fmass          : mass  of OUTPUT fermion f'
c       real    fwidth         : width of OUTPUT fermion f'
c
c output:
c       complex fsi(6)         : off-shell fermion             |f',s,fi>
c
      implicit none
      double complex fi(6),sc(3),fsi(6),gc(2),sl1,sl2,sr1,sr2,ds
      double precision pf(0:3),fmass,fwidth,pf2,p0p3,p0m3

c

      fsi(5) = fi(5)-sc(2)
      fsi(6) = fi(6)-sc(3)

      pf(0) = dble( fsi(5))
      pf(1) = dble( fsi(6))
      pf(2) = dimag(fsi(6))
      pf(3) = dimag(fsi(5))
      pf2 = pf(0)**2-(pf(1)**2+pf(2)**2+pf(3)**2)


      ds = -sc(1)/dcmplx( pf2-fmass**2, fmass*fwidth )
      p0p3 = pf(0)+pf(3)
      p0m3 = pf(0)-pf(3)
      sl1 = gc(1)*(p0p3*fi(1)+dconjg(fsi(6))*fi(2))
      sl2 = gc(1)*(p0m3*fi(2)       +fsi(6) *fi(1))
      sr1 = gc(2)*(p0m3*fi(3)-dconjg(fsi(6))*fi(4))
      sr2 = gc(2)*(p0p3*fi(4)       -fsi(6) *fi(3))

      fsi(1) = ( gc(1)*fmass*fi(1) + sr1 )*ds
      fsi(2) = ( gc(1)*fmass*fi(2) + sr2 )*ds
      fsi(3) = ( gc(2)*fmass*fi(3) + sl1 )*ds
      fsi(4) = ( gc(2)*fmass*fi(4) + sl2 )*ds
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine fsocxx(foc,sc,gc,fmass,fwidth , fsoc)
c
c this subroutine computes an off-shell antifermion wavefunction from a 
c flowing-out external antifermion and a vector boson.                  
c                                                                       
c input:                                                                
c       complex foc(6)         : flow-out fermion               <foc|
c       complex sc(6)          : input    scalar                   s 
c       complex gc(2)          : coupling constants              gchf
c       real     fmass         : mass  of output antifermion fc'     
c       real     fwidth        : width of output antifermion fc'     
c                                                                       
c output:                                                               
c       complex fsoc(6)        : off-shell fermion         <fo,s,fc'|
c
      implicit none
      double complex foc(6),sc(6),fsoc(6),gc(2),sl1,sl2,sr1,sr2,ds
      double precision pf(0:3),fmass,fwidth,pf2,p0p3,p0m3
c
      fsoc(5) = foc(5)+sc(2)
      fsoc(6) = foc(6)+sc(3)

      pf(0) = dble( fsoc(5))
      pf(1) = dble( fsoc(6))
      pf(2) = dimag(fsoc(6))
      pf(3) = dimag(fsoc(5))
      pf2 = pf(0)**2-(pf(1)**2+pf(2)**2+pf(3)**2)

      ds = -sc(1)/dcmplx( pf2-fmass**2, fmass*fwidth )
      p0p3 = pf(0)+pf(3)
      p0m3 = pf(0)-pf(3)
      sl1 = gc(2)*(p0p3*foc(3)       +fsoc(6) *foc(4))
      sl2 = gc(2)*(p0m3*foc(4)+dconjg(fsoc(6))*foc(3))
      sr1 = gc(1)*(p0m3*foc(1)       -fsoc(6) *foc(2))
      sr2 = gc(1)*(p0p3*foc(2)-dconjg(fsoc(6))*foc(1))

      fsoc(1) = ( gc(1)*fmass*foc(1) + sl1 )*ds
      fsoc(2) = ( gc(1)*fmass*foc(2) + sl2 )*ds
      fsoc(3) = ( gc(2)*fmass*foc(3) + sr1 )*ds
      fsoc(4) = ( gc(2)*fmass*foc(4) + sr2 )*ds
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine fsogld(fo,sc,gc,fmass,fwidth,smass,mNLSP,idecay , fso)
c
c This subroutine computes an off-shell fermion wavefunction from a
c flowing-out external fermion and a scalar boson, for the NLSP-boson-
c Goldstino vertex. The h.c. of the NLSP decay is handled via the
c input parameter idecay.
c
c input:
c       complex fo(6)          : flow-out fermion                   <fo|
c       complex sc(3)          : input    scalar                      s
c       complex gc(2)          : coupling constants                  gsf
c       real    fmass          : mass  of output fermion f'
c       real    fwidth         : width of output fermion f'
c       integer idecay         :  1 for NLSP decay to Goldstino
c                              : -1 for Goldstino to NLSP (h.c. of above)
c
c output:
c       complex fso(6)         : off-shell fermion             <fo,s,f'|
c
      implicit none
      double complex  fo(6), sc(3), gc(2), fso(6), s1, s2, s3, s4, ds
      double precision  pf(0:3), fmass, fwidth, mNLSP, smass, pf2
      double precision  p14p, p14m, p23p, p23m
      integer idecay

      double complex ci, cZero
      parameter( ci = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )
c
      fso(5) = fo(5) + sc(2)
      fso(6) = fo(6) + sc(3)

      pf(0) = dble( fso(5))
      pf(1) = dble( fso(6))
      pf(2) = dimag(fso(6))
      pf(3) = dimag(fso(5))
      pf2 = pf(0)**2 - pf(1)**2 - pf(2)**2 - pf(3)**2

      if ( idecay.ne.1 .or. idecay.ne.-1 ) then
         write(6,*) 'error in idecay of FSOGLD'
         stop
      end if

      p14p = dble(sc(2)) + dimag(sc(2))
      p14m = dble(sc(2)) - dimag(sc(2))
      p23p = dble(sc(3)) + dimag(sc(3))*ci
      p23m = dble(sc(3)) - dimag(sc(3))*ci

      ds = -sc(1)/dcmplx( pf2-fmass**2, fmass*fwidth )

      s1 = -idecay*gc(1)*fo(1)*smass**2
      s2 = -idecay*gc(1)*fo(2)*smass**2
      s3 = gc(1)*mNLSP*( fo(1)*p14m - fo(2)*p23p )
      s4 = gc(1)*mNLSP*(-fo(1)*p23m + fo(2)*p14p )

      if ( gc(2).ne.cZero ) then
         s1 = s1 + gc(2)*mNLSP*( fo(3)*p14p + fo(4)*p23p )
         s2 = s2 + gc(2)*mNLSP*( fo(3)*p23m + fo(4)*p14m )
         s3 = s3 - gc(2)*idecay*fo(3)*smass**2
         s4 = s4 - gc(2)*idecay*fo(4)*smass**2
      end if

      fso(1) = (  (pf(0)+pf(3))*s3 +         fso(6)*s4 + fmass*s1 )*ds
      fso(2) = ( dconjg(fso(6))*s3 +  (pf(0)-pf(3))*s4 + fmass*s2 )*ds
      fso(3) = (  (pf(0)-pf(3))*s1 -         fso(6)*s2 + fmass*s3 )*ds
      fso(4) = (-dconjg(fso(6))*s1 +  (pf(0)+pf(3))*s2 + fmass*s4 )*ds
c
      return          
      end
      subroutine fsoxxx(fo,sc,gc,fmass,fwidth , fso)
c
c This subroutine computes an off-shell fermion wavefunction from a
c flowing-OUT external fermion and a vector boson.
c
c input:
c       complex fo(6)          : flow-out fermion                   <fo|
c       complex sc(6)          : input    scalar                      s
c       complex gc(2)          : coupling constants                 gchf
c       real    fmass          : mass  of OUTPUT fermion f'
c       real    fwidth         : width of OUTPUT fermion f'
c
c output:
c       complex fso(6)         : off-shell fermion             <fo,s,f'|
c
      implicit none
      double complex fo(6),sc(6),fso(6),gc(2),sl1,sl2,sr1,sr2,ds
      double precision pf(0:3),fmass,fwidth,pf2,p0p3,p0m3

c

      fso(5) = fo(5)+sc(2)
      fso(6) = fo(6)+sc(3)

      pf(0) = dble( fso(5))
      pf(1) = dble( fso(6))
      pf(2) = dimag(fso(6))
      pf(3) = dimag(fso(5))
      pf2 = pf(0)**2-(pf(1)**2+pf(2)**2+pf(3)**2)


      ds = -sc(1)/dcmplx( pf2-fmass**2, fmass*fwidth )
      p0p3 = pf(0)+pf(3)
      p0m3 = pf(0)-pf(3)
      sl1 = gc(2)*(p0p3*fo(3)       +fso(6) *fo(4))
      sl2 = gc(2)*(p0m3*fo(4)+dconjg(fso(6))*fo(3))
      sr1 = gc(1)*(p0m3*fo(1)       -fso(6) *fo(2))
      sr2 = gc(1)*(p0p3*fo(2)-dconjg(fso(6))*fo(1))

      fso(1) = ( gc(1)*fmass*fo(1) + sl1 )*ds
      fso(2) = ( gc(1)*fmass*fo(2) + sl2 )*ds
      fso(3) = ( gc(2)*fmass*fo(3) + sr1 )*ds
      fso(4) = ( gc(2)*fmass*fo(4) + sr2 )*ds
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine fvicxx(fic,vc,gc,fmass,fwidth , fvic)
c
c this subroutine computes an off-shell antifermion wavefunction from a 
c flowing-in external antifermion and a vector boson.                   
c                                                                       
c input:                                                                
c       complex fic(6)         : flow-in  antifermion              |fic>
c       complex vc(6)          : input    vector                      v 
c       complex gc(2)          : coupling constants                  gvf
c       real    fmass          : mass  of output antifermion f'         
c       real    fwidth         : width of output antifermion f'         
c                                                                       
c output:                                                               
c       complex fvic(6)        : off-shell antifermion       |fc',v,fic>
c
      implicit none
      double complex fic(6),vc(6),gc(2),fvic(6),sl1,sl2,sr1,sr2,d
      double precision pf(0:3),fmass,fwidth,pf2

      double precision rOne
      parameter( rOne = 1.0d0 )
      double complex cImag, cZero
      parameter( cImag = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )
c
      fvic(5) = fic(5)-vc(5)
      fvic(6) = fic(6)-vc(6)

      pf(0) = dble( fvic(5))
      pf(1) = dble( fvic(6))
      pf(2) = dimag(fvic(6))
      pf(3) = dimag(fvic(5))
      pf2 = pf(0)**2-(pf(1)**2+pf(2)**2+pf(3)**2)

      d = rOne/dcmplx( pf2-fmass**2, fmass*fwidth )
      sl1 =   (vc(1)+      vc(4))*fic(1)
     &      + (vc(2)-cImag*vc(3))*fic(2)
      sl2 =   (vc(2)+cImag*vc(3))*fic(1)
     &      + (vc(1)-      vc(4))*fic(2)

      if ( gc(2).ne.cZero ) then
         sr1 =   (vc(1)-      vc(4))*fic(3)
     &         - (vc(2)-cImag*vc(3))*fic(4)
         sr2 = - (vc(2)+cImag*vc(3))*fic(3)
     &         + (vc(1)+      vc(4))*fic(4)

         fvic(1) = ( gc(2)*((pf(0)-pf(3))*sl1 - dconjg(fvic(6))*sl2)
     &              +gc(1)*fmass*sr1 )*d
         fvic(2) = ( gc(2)*(     -fvic(6)*sl1 +   (pf(0)+pf(3))*sl2)
     &              +gc(1)*fmass*sr2 )*d
         fvic(3) = ( gc(1)*((pf(0)+pf(3))*sr1 + dconjg(fvic(6))*sr2)
     &              +gc(2)*fmass*sl1 )*d
         fvic(4) = ( gc(1)*(      fvic(6)*sr1 +   (pf(0)-pf(3))*sr2)
     &              +gc(2)*fmass*sl2 )*d
      else
         d = d * gc(1)
         fvic(1) = fmass*sr1*d
         fvic(2) = fmass*sr2*d
         fvic(3) = ((pf(0)+pf(3))*sr1 + dconjg(fvic(6))*sr2)*d
         fvic(4) = (      fvic(6)*sr1 +   (pf(0)-pf(3))*sr2)*d
      end if
c
      return
      end
      subroutine fvidmx(fi,vc,gc,fmass,fwidth , fvi)
c
c This subroutine computes a dipole moment off-shell fermion
c wavefunction from a flowing-IN external fermion and a vector boson.
c
c input:
c       complex fi(6)          : flow-in  fermion                   |fi>
c       complex vc(6)          : input    vector                      v
c       complex gc(2,2)        : coupling constants                  gvf
c                              : first index is L,R as normal
c                              : second index is EDM,-MDM
c       real    fmass          : mass  of output fermion f'
c       real    fwidth         : width of output fermion f'
c
c output:
c       complex fvi(6)         : off-shell fermion             |f',v,fi>
c
      implicit none
      double complex fi(6), vc(6), fvi(6), sl1, sl2, sr1, sr2, d
      double complex gc(2,2), gL, gR
      double precision pf(0:3), fmass, fwidth, pf2

      double complex kvc21, kvc31, kvc41, kvc32, kvc42, kvc43
      double precision k(1:4)
      double precision rZero, rOne
      parameter( rZero = 0.0d0, rOne = 1.0d0 )
      double complex cImag, cZero
      parameter( cImag = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )

c

      gL = -gc(1,1) + cImag*gc(1,2)
      gR =  gc(2,1) + cImag*gc(2,2)

c k in vertex formula defined as (pi - po)
      k(1) = dble( vc(5))
      k(2) = dble( vc(6))
      k(3) = dimag(vc(6))
      k(4) = dimag(vc(5))

      kvc21 = (k(2)*vc(1) - k(1)*vc(2))*cImag
      kvc31 =  k(3)*vc(1) - k(1)*vc(3)
      kvc41 = (k(4)*vc(1) - k(1)*vc(4))*cImag
      kvc32 =  k(3)*vc(2) - k(2)*vc(3)
      kvc42 = (k(4)*vc(2) - k(2)*vc(4))*cImag
      kvc43 =  k(4)*vc(3) - k(3)*vc(4)

      fvi(5) = fi(5) - vc(5)
      fvi(6) = fi(6) - vc(6)

      pf(0) = dble( fvi(5))
      pf(1) = dble( fvi(6))
      pf(2) = dimag(fvi(6))
      pf(3) = dimag(fvi(5))
      pf2 = pf(0)**2-(pf(1)**2+pf(2)**2+pf(3)**2)


      d = -rOne/dcmplx( pf2-fmass**2, fmass*fwidth )

      sl1 = gL*(  fi(1)*(kvc41 + kvc32)
     &          + fi(2)*(kvc42 + kvc21 + kvc43 + kvc31) )
      sl2 = gL*(- fi(1)*(kvc42 - kvc21 - kvc43 + kvc31)
     &          - fi(2)*(kvc41 + kvc32)                 )

      if ( gc(2,1).ne.cZero .or.
     &     gc(2,2).ne.cZero      ) then
         sr1 = gR*(- fi(3)*(kvc41 - kvc32)
     &             + fi(4)*(kvc42 - kvc21 + kvc43 - kvc31) )
         sr2 = gR*(- fi(3)*(kvc42 + kvc21 - kvc43 - kvc31)
     &             + fi(4)*(kvc41 - kvc32)                 )

         fvi(1) = ( (pf(0)-pf(3))*sr1 - dconjg(fvi(6))*sr2
     &             + fmass*sl1                             )*d
         fvi(2) = (      - fvi(6)*sr1 +  (pf(0)+pf(3))*sr2
     &             + fmass*sl2                             )*d
         fvi(3) = ( (pf(0)+pf(3))*sl1 + dconjg(fvi(6))*sl2
     &             + fmass*sr1                             )*d
         fvi(4) = (        fvi(6)*sl1 +  (pf(0)-pf(3))*sl2
     &             + fmass*sr2                             )*d

      else
         fvi(1) = fmass*sl1*d
         fvi(2) = fmass*sl2*d
         fvi(3) = ( (pf(0)+pf(3))*sl1 + dconjg(fvi(6))*sl2 )*d
         fvi(4) = (        fvi(6)*sl1 +  (pf(0)-pf(3))*sl2 )*d
      end if
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine fvigld(fi,vc,gc,fmass,fwidth,idecay , fvi)
c
c This subroutine computes an off-shell fermion wavefunction from a
c flowing-in external fermion and a vector boson, for the NLSP-boson-
c Goldstino vertex. The h.c. of the NLSP decay is handled via the
c input parameter idecay (picks out correct Goldstino momentum).
c
c input:
c       complex fi(6)          : flow-in  fermion                   |fi>
c       complex vc(6)          : input    vector                      v
c       complex gc(2)          : coupling constants                  gvf
c       real    fmass          : mass  of output fermion f'
c       real    fwidth         : width of output fermion f'
c       integer idecay         :  1 for NLSP decay to Goldstino
c                              : -1 for Goldstino to NLSP (h.c. of above)
c
c output:
c       complex fvi(6)         : off-shell fermion             |f',v,fi>
c
      implicit none
      double complex  fi(6), vc(6), gc(2), fvi(6), sl1, sl2, sr1, sr2, d
      double complex  p14p, p14m, p23p, p23m, A14p, A14m, A23p, A23m
      double complex  AdotpG
      double precision  fmass, fwidth
      double precision  pf(0:3), pv(4), pf2, pdotpG
      integer idecay

      double precision rOne
      parameter( rOne = 1.0d0 )
      double complex ci, cZero
      parameter( ci = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )
c
      fvi(5) = fi(5) - vc(5)
      fvi(6) = fi(6) - vc(6)

      pv(1) = dble( vc(5))
      pv(2) = dble( vc(6))
      pv(3) = dimag(vc(6))
      pv(4) = dimag(vc(5))

      pf(0) = dble( fvi(5))
      pf(1) = dble( fvi(6))
      pf(2) = dimag(fvi(6))
      pf(3) = dimag(fvi(5))
      pf2 = pf(0)**2 - pf(1)**2 - pf(2)**2 - pf(3)**2

      if ( idecay.eq.1 ) then
         pdotpG = pv(1)*pf(0) - pv(2)*pf(1) - pv(3)*pf(2) - pv(4)*pf(3)
         AdotpG = vc(1)*pf(0) - vc(2)*pf(1) - vc(3)*pf(2) - vc(4)*pf(3)
      else if ( idecay.eq.-1 ) then
         pdotpG =  pv(1)*dble( fi(5)) - pv(2)*dble( fi(6))
     &           - pv(3)*dimag(fi(6)) - pv(4)*dimag(fi(5))
         AdotpG =  vc(1)*dble( fi(5)) - vc(2)*dble( fi(6))
     &           - vc(3)*dimag(fi(6)) - vc(4)*dimag(fi(5))
      else
         write(6,*) 'error in idecay of FVIGLD'
         stop
      end if

      p14p = dble(vc(5)) + dimag(vc(5))
      p14m = dble(vc(5)) - dimag(vc(5))
      p23p = vc(6)
      p23m = dconjg(vc(6))
      A14p = vc(1) + vc(4)
      A14m = vc(1) - vc(4)
      A23p = vc(2) + vc(3)*ci
      A23m = vc(2) - vc(3)*ci

      d = -rOne/dcmplx( pf2-fmass**2, fmass*fwidth )
      d = d*idecay

      sl1 =  (p14p*AdotpG - A14p*pdotpG)*fi(1)
     &      +(p23m*AdotpG - A23m*pdotpG)*fi(2)
      sl2 =  (p23p*AdotpG - A23p*pdotpG)*fi(1)
     &      +(p14m*AdotpG - A14m*pdotpG)*fi(2)

      if ( gc(2).ne.cZero ) then
         sr1 =  (p14m*AdotpG - A14m*pdotpG)*fi(3)
     &         -(p23m*AdotpG - A23m*pdotpG)*fi(4)
         sr2 = -(p23p*AdotpG - A23p*pdotpG)*fi(3)
     &         +(p14p*AdotpG - A14p*pdotpG)*fi(4)

         fvi(1) = ( gc(1)*((pf(0)-pf(3))*sl1 - dconjg(fvi(6))*sl2 )
     &             +gc(2)*fmass*sr1 )*d
         fvi(2) = ( gc(1)*(      -fvi(6)*sl1 +  (pf(0)+pf(3))*sl2 )
     &             +gc(2)*fmass*sr2 )*d
         fvi(3) = ( gc(2)*((pf(0)+pf(3))*sr1 + dconjg(fvi(6))*sr2 )
     &             +gc(1)*fmass*sl1 )*d
         fvi(4) = ( gc(2)*(       fvi(6)*sr1 +  (pf(0)-pf(3))*sr2 )
     &             +gc(1)*fmass*sl2 )*d

      else
         d = d*gc(1)
         fvi(1) = d*((pf(0)-pf(3))*sl1 - dconjg(fvi(6))*sl2)
         fvi(2) = d*(      -fvi(6)*sl1 +  (pf(0)+pf(3))*sl2)
         fvi(3) = d*fmass*sl1
         fvi(4) = d*fmass*sl2
      end if
c
      return          
      end
      subroutine fvixxx(fi,vc,gc,fmass,fwidth , fvi)
c
c This subroutine computes an off-shell fermion wavefunction from a
c flowing-IN external fermion and a vector boson.
c
c input:
c       complex fi(6)          : flow-in  fermion                   |fi>
c       complex vc(6)          : input    vector                      v
c       complex gc(2)          : coupling constants                  gvf
c       real    fmass          : mass  of output fermion f'
c       real    fwidth         : width of output fermion f'
c
c output:
c       complex fvi(6)         : off-shell fermion             |f',v,fi>
c
      implicit none
      double complex fi(6),vc(6),gc(2),fvi(6),sl1,sl2,sr1,sr2,d
      double precision pf(0:3),fmass,fwidth,pf2
      
      double precision rZero, rOne
      parameter( rZero = 0.0d0, rOne = 1.0d0 )
      double complex cImag, cZero
      parameter( cImag = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )

c

      fvi(5) = fi(5)-vc(5)
      fvi(6) = fi(6)-vc(6)

      pf(0) = dble( fvi(5))
      pf(1) = dble( fvi(6))
      pf(2) = dimag(fvi(6))
      pf(3) = dimag(fvi(5))
      pf2 = pf(0)**2-(pf(1)**2+pf(2)**2+pf(3)**2)


      d = -rOne/dcmplx( pf2-fmass**2, fmass*fwidth )
      sl1 =   (vc(1)+      vc(4))*fi(1)
     &      + (vc(2)-cImag*vc(3))*fi(2)
      sl2 =   (vc(2)+cImag*vc(3))*fi(1)
     &      + (vc(1)-      vc(4))*fi(2)

      if ( gc(2).ne.cZero ) then
         sr1 =   (vc(1)-      vc(4))*fi(3)
     &         - (vc(2)-cImag*vc(3))*fi(4)
         sr2 = - (vc(2)+cImag*vc(3))*fi(3)
     &         + (vc(1)+      vc(4))*fi(4)

         fvi(1) = ( gc(1)*((pf(0)-pf(3))*sl1 - dconjg(fvi(6))*sl2)
     &             +gc(2)*fmass*sr1 )*d
         fvi(2) = ( gc(1)*(      -fvi(6)*sl1 +  (pf(0)+pf(3))*sl2)
     &             +gc(2)*fmass*sr2 )*d
         fvi(3) = ( gc(2)*((pf(0)+pf(3))*sr1 + dconjg(fvi(6))*sr2)
     &             +gc(1)*fmass*sl1 )*d
         fvi(4) = ( gc(2)*(       fvi(6)*sr1 +  (pf(0)-pf(3))*sr2)
     &             +gc(1)*fmass*sl2 )*d

      else
         d = d * gc(1)
         fvi(1) = ((pf(0)-pf(3))*sl1 - dconjg(fvi(6))*sl2)*d
         fvi(2) = (      -fvi(6)*sl1 +  (pf(0)+pf(3))*sl2)*d
         fvi(3) = fmass*sl1*d
         fvi(4) = fmass*sl2*d
      end if
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine fvocxx(foc,vc,gc,fmass,fwidth , fvoc)
c
c this subroutine computes an off-shell antifermion wavefunction from a 
c flowing-out external antifermion and a vector boson.                  
c                                                                       
c input:                                                                
c       complex foc(6)         : flow-out antifermion              <foc|
c       complex vc(6)          : input    vector                      v 
c       complex gc(2)          : coupling constants                  gvf
c       real    fmass          : mass  of output antifermion f'         
c       real    fwidth         : width of output antifermion f'         
c                                                                       
c output:                                                               
c       complex fvoc(6)        : off-shell antifermion       <foc,v,fc'|
c
      implicit none
      double complex foc(6),vc(6),gc(2),fvoc(6),sl1,sl2,sr1,sr2,d
      double precision pf(0:3),fmass,fwidth,pf2

      double precision rOne
      parameter( rOne = 1.0d0 )
      double complex cImag, cZero
      parameter( cImag = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )
c
      fvoc(5) = foc(5)+vc(5)
      fvoc(6) = foc(6)+vc(6)

      pf(0) = dble( fvoc(5))
      pf(1) = dble( fvoc(6))
      pf(2) = dimag(fvoc(6))
      pf(3) = dimag(fvoc(5))
      pf2 = pf(0)**2-(pf(1)**2+pf(2)**2+pf(3)**2)

      d = rOne/dcmplx( pf2-fmass**2, fmass*fwidth )
      sl1 =   (vc(1)+      vc(4))*foc(3)
     &      + (vc(2)+cImag*vc(3))*foc(4)
      sl2 =   (vc(2)-cImag*vc(3))*foc(3)
     &      + (vc(1)-      vc(4))*foc(4)

      if ( gc(2).ne.cZero ) then
         sr1 =   (vc(1)-      vc(4))*foc(1)
     &         - (vc(2)+cImag*vc(3))*foc(2)
         sr2 = - (vc(2)-cImag*vc(3))*foc(1)
     &         + (vc(1)+      vc(4))*foc(2)

         fvoc(1) = ( gc(1)*( (pf(0)+pf(3))*sr1          +fvoc(6)*sr2)
     &              +gc(2)*fmass*sl1 )*d
         fvoc(2) = ( gc(1)*( dconjg(fvoc(6))*sr1 + (pf(0)-pf(3))*sr2)
     &              +gc(2)*fmass*sl2 )*d
         fvoc(3) = ( gc(2)*( (pf(0)-pf(3))*sl1          -fvoc(6)*sl2)
     &              +gc(1)*fmass*sr1 )*d
         fvoc(4) = ( gc(2)*(-dconjg(fvoc(6))*sl1 + (pf(0)+pf(3))*sl2)
     &              +gc(1)*fmass*sr2 )*d
      else
         d = d * gc(1)
         fvoc(1) = ((pf(0)+pf(3))*sr1          +fvoc(6)*sr2)*d
         fvoc(2) = (dconjg(fvoc(6))*sr1 + (pf(0)-pf(3))*sr2)*d
         fvoc(3) = fmass*sr1*d
         fvoc(4) = fmass*sr2*d
      end if
c
      return
      end
      subroutine fvodmx(fo,vc,gc,fmass,fwidth , fvo)
c
c This subroutine computes a dipole moment off-shell fermion
c wavefunction from a flowing-OUT external fermion and a vector boson.
c
c input:
c       complex fo(6)          : flow-out fermion                   <fo|
c       complex vc(6)          : input    vector                      v
c       complex gc(2,2)        : coupling constants                  gvf
c                              : first index is L,R as normal
c                              : second index is EDM,-MDM
c       real    fmass          : mass  of output fermion f'
c       real    fwidth         : width of output fermion f'
c
c output:
c       complex fvo(6)         : off-shell fermion             <fo,v,f'|
c
      implicit none
      double complex fo(6), vc(6), fvo(6), sl1, sl2, sr1, sr2, d
      double complex gc(2,2), gL, gR
      double precision  pf(0:3), fmass, fwidth, pf2

      double complex kvc21, kvc31, kvc41, kvc32, kvc42, kvc43
      double precision k(1:4)
      double precision rZero, rOne
      parameter( rZero = 0.0d0, rOne = 1.0d0 )
      double complex cImag, cZero
      parameter( cImag = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )

c

      gL = -gc(1,1) + cImag*gc(1,2)
      gR =  gc(2,1) + cImag*gc(2,2)

c k in vertex formula defined as (pi - po)
      k(1) = dble( vc(5))
      k(2) = dble( vc(6))
      k(3) = dimag(vc(6))
      k(4) = dimag(vc(5))

      kvc21 = (k(2)*vc(1) - k(1)*vc(2))*cImag
      kvc31 =  k(3)*vc(1) - k(1)*vc(3)
      kvc41 = (k(4)*vc(1) - k(1)*vc(4))*cImag
      kvc32 =  k(3)*vc(2) - k(2)*vc(3)
      kvc42 = (k(4)*vc(2) - k(2)*vc(4))*cImag
      kvc43 =  k(4)*vc(3) - k(3)*vc(4)

      fvo(5) = fo(5) + vc(5)
      fvo(6) = fo(6) + vc(6)

      pf(0) = dble( fvo(5))
      pf(1) = dble( fvo(6))
      pf(2) = dimag(fvo(6))
      pf(3) = dimag(fvo(5))
      pf2 = pf(0)**2-(pf(1)**2+pf(2)**2+pf(3)**2)


      d = -rOne/dcmplx( pf2-fmass**2, fmass*fwidth )

      sl1 = gL*(  fo(1)*(kvc41 + kvc32)
     &          - fo(2)*(kvc42 - kvc21 - kvc43 + kvc31) )
      sl2 = gL*(  fo(1)*(kvc42 + kvc21 + kvc43 + kvc31)
     &          - fo(2)*(kvc41 + kvc32)                 )

      if ( gc(2,1).ne.cZero .or.
     &     gc(2,2).ne.cZero      ) then
         sr1 = gR*(- fo(3)*(kvc41 - kvc32)
     &             - fo(4)*(kvc42 + kvc21 - kvc43 - kvc31) )
         sr2 = gR*(  fo(3)*(kvc42 - kvc21 + kvc43 - kvc31)
     &             + fo(4)*(kvc41 - kvc32)                 )

         fvo(1) = (  (pf(0)+pf(3))*sr1       + fvo(6)*sr2
     &             + fmass*sl1                            )*d
         fvo(2) = ( dconjg(fvo(6))*sr1 +(pf(0)-pf(3))*sr2
     &             + fmass*sl2                            )*d
         fvo(3) = (  (pf(0)-pf(3))*sl1       - fvo(6)*sl2
     &             + fmass*sr1                            )*d
         fvo(4) = (-dconjg(fvo(6))*sl1 +(pf(0)+pf(3))*sl2
     &             + fmass*sr2                            )*d

      else
         fvo(1) = fmass*sl1*d
         fvo(2) = fmass*sl2*d
         fvo(3) = (  (pf(0)-pf(3))*sl1        - fvo(6)*sl2)*d
         fvo(4) = (-dconjg(fvo(6))*sl1 + (pf(0)+pf(3))*sl2)*d
      end if
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine fvogld(fo,vc,gc,fmass,fwidth,idecay , fvo)
c
c This subroutine computes an off-shell fermion wavefunction from a
c flowing-out external fermion and a vector boson, for the NLSP-boson-
c Goldstino vertex. The h.c. of the NLSP decay is handled via the
c input parameter idecay (picks out correct Goldstino momentum).
c
c input:
c       complex fo(6)          : flow-out fermion                   <fo|
c       complex vc(6)          : input    vector                      v
c       complex gc(2)          : coupling constants                  gvf
c       real    fmass          : mass  of output fermion f'
c       real    fwidth         : width of output fermion f'
c       integer idecay         :  1 for NLSP decay to Goldstino
c                              : -1 for Goldstino to NLSP (h.c. of above)
c
c output:
c       complex fvo(6)         : off-shell fermion             <fo,v,f'|
c
      implicit none
      double complex  fo(6), vc(6), gc(2), fvo(6), sl1, sl2, sr1, sr2, d
      double complex  p14p, p14m, p23p, p23m, A14p, A14m, A23p, A23m
      double complex  AdotpG
      double precision  fmass, fwidth
      double precision  pf(0:3), pv(4), pf2, pdotpG
      integer idecay

      double precision rOne
      parameter( rOne = 1.0d0 )
      double complex ci, cZero
      parameter( ci = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )
c
      fvo(5) = fo(5) + vc(5)
      fvo(6) = fo(6) + vc(6)

      pv(1) = dble( vc(5))
      pv(2) = dble( vc(6))
      pv(3) = dimag(vc(6))
      pv(4) = dimag(vc(5))

      pf(0) = dble( fvo(5))
      pf(1) = dble( fvo(6))
      pf(2) = dimag(fvo(6))
      pf(3) = dimag(fvo(5))
      pf2 = pf(0)**2 - pf(1)**2 - pf(2)**2 - pf(3)**2

      if ( idecay.eq.1 ) then
         pdotpG = pv(1)*pf(0) - pv(2)*pf(1) - pv(3)*pf(2) - pv(4)*pf(3)
         AdotpG = vc(1)*pf(0) - vc(2)*pf(1) - vc(3)*pf(2) - vc(4)*pf(3)
      else if ( idecay.eq.-1 ) then
         pdotpG =  pv(1)*dble( fo(5)) - pv(2)*dble( fo(6))
     &           - pv(3)*dimag(fo(6)) - pv(4)*dimag(fo(5))
         AdotpG =  vc(1)*dble( fo(5)) - vc(2)*dble( fo(6))
     &           - vc(3)*dimag(fo(6)) - vc(4)*dimag(fo(5))
      else
         write(6,*) 'error in idecay of FVOGLD'
         stop
      end if

      p14p = dble(vc(5)) + dimag(vc(5))
      p14m = dble(vc(5)) - dimag(vc(5))
      p23p = vc(6)
      p23m = dconjg(vc(6))
      A14p = vc(1) + vc(4)
      A14m = vc(1) - vc(4)
      A23p = vc(2) + vc(3)*ci
      A23m = vc(2) - vc(3)*ci

      d = -rOne/dcmplx( pf2-fmass**2, fmass*fwidth )
      d = d*idecay

      sl1 =  (p14p*AdotpG - A14p*pdotpG)*fo(3)
     &      +(p23p*AdotpG - A23p*pdotpG)*fo(4)
      sl2 =  (p23m*AdotpG - A23m*pdotpG)*fo(3)
     &      +(p14m*AdotpG - A14m*pdotpG)*fo(4)

      if ( gc(2).ne.cZero ) then
         sr1 =  (p14m*AdotpG - A14m*pdotpG)*fo(1)
     &         -(p23p*AdotpG - A23p*pdotpG)*fo(2)
         sr2 = -(p23m*AdotpG - A23m*pdotpG)*fo(1)
     &         +(p14p*AdotpG - A14p*pdotpG)*fo(2)

         fvo(1) = ( gc(2)*(  (pf(0)+pf(3))*sr1         +fvo(6)*sr2 )
     &             +gc(1)*fmass*sl1 )*d
         fvo(2) = ( gc(2)*( dconjg(fvo(6))*sr1 + (pf(0)-pf(3))*sr2 )
     &             +gc(1)*fmass*sl2 )*d
         fvo(3) = ( gc(1)*(  (pf(0)-pf(3))*sl1         -fvo(6)*sl2 )
     &             +gc(2)*fmass*sr1 )*d
         fvo(4) = ( gc(1)*(-dconjg(fvo(6))*sl1 + (pf(0)+pf(3))*sl2 )
     &             +gc(2)*fmass*sr2 )*d

      else
         d = d*gc(1)
         fvo(1) = d*fmass*sl1
         fvo(2) = d*fmass*sl2
         fvo(3) = d*(  (pf(0)-pf(3))*sl1         -fvo(6)*sl2)
         fvo(4) = d*(-dconjg(fvo(6))*sl1 + (pf(0)+pf(3))*sl2)
      end if
c
      return          
      end
      subroutine fvoxxx(fo,vc,gc,fmass,fwidth , fvo)
c
c This subroutine computes an off-shell fermion wavefunction from a
c flowing-OUT external fermion and a vector boson.
c
c
c input:
c       complex fo(6)          : flow-out fermion                   <fo|
c       complex vc(6)          : input    vector                      v
c       complex gc(2)          : coupling constants                  gvf
c       real    fmass          : mass  of OUTPUT fermion f'
c       real    fwidth         : width of OUTPUT fermion f'
c
c output:
c       complex fvo(6)         : off-shell fermion             <fo,v,f'|
c
      implicit none
      double complex fo(6),vc(6),gc(2),fvo(6),sl1,sl2,sr1,sr2,d
      double precision pf(0:3),fmass,fwidth,pf2

      double precision rZero, rOne
      parameter( rZero = 0.0d0, rOne = 1.0d0 )
      double complex cImag, cZero
      parameter( cImag = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )

c

      fvo(5) = fo(5)+vc(5)
      fvo(6) = fo(6)+vc(6)

      pf(0) = dble( fvo(5))
      pf(1) = dble( fvo(6))
      pf(2) = dimag(fvo(6))
      pf(3) = dimag(fvo(5))
      pf2 = pf(0)**2-(pf(1)**2+pf(2)**2+pf(3)**2)


      d = -rOne/dcmplx( pf2-fmass**2, fmass*fwidth )
      sl1 =   (vc(1)+      vc(4))*fo(3)
     &      + (vc(2)+cImag*vc(3))*fo(4)
      sl2 =   (vc(2)-cImag*vc(3))*fo(3)
     &      + (vc(1)-      vc(4))*fo(4)

      if ( gc(2).ne.cZero ) then
         sr1 =   (vc(1)-      vc(4))*fo(1)
     &         - (vc(2)+cImag*vc(3))*fo(2)
         sr2 = - (vc(2)-cImag*vc(3))*fo(1)
     &         + (vc(1)+      vc(4))*fo(2)

         fvo(1) = ( gc(2)*( (pf(0)+pf(3))*sr1  +        fvo(6)*sr2)
     &             +gc(1)*fmass*sl1 )*d
         fvo(2) = ( gc(2)*( dconjg(fvo(6))*sr1 + (pf(0)-pf(3))*sr2)
     &             +gc(1)*fmass*sl2 )*d
         fvo(3) = ( gc(1)*( (pf(0)-pf(3))*sl1  -        fvo(6)*sl2)
     &             +gc(2)*fmass*sr1 )*d
         fvo(4) = ( gc(1)*(-dconjg(fvo(6))*sl1 + (pf(0)+pf(3))*sl2)
     &             +gc(2)*fmass*sr2 )*d

      else
         d = d * gc(1)
         fvo(1) = fmass*sl1*d
         fvo(2) = fmass*sl2*d
         fvo(3) = (  (pf(0)-pf(3))*sl1 -        fvo(6)*sl2)*d
         fvo(4) = (-dconjg(fvo(6))*sl1 + (pf(0)+pf(3))*sl2)*d
      end if
c
      return
      end
      subroutine ggggxx(ga,gb,gc,gd,g, vertex)
c
c This subroutine computes the portion of the amplitude of the four-point 
c coupling of 4 massless color octet gauge bosons (gluons) corresponding 
c to the color structure f^{a,b,e} f{c,d,e}. 
c To optain the complete amplitude, this coupling must be called three
c times (once for each color structure) with the following permutations:
c	call ggggxx(ga,gb,gc,gd,g,v1)
c       call ggggxx(ga,gc,gd,gb,g,v2)
c       call ggggxx(ga,gd,gb,gc,g,v3)
c
c	f^{a,b,e} f{c,d,e}*v1+
c	f^{a,c,e} f{d,b,e}*v2+
c	f^{a,d,e} f{b,c,e}*v3
c (See 2.9.1 of the manual for more information).
c                                                                       
c input:                                                                
c       complex ga(0:3)        : Boson with adjoint color index a 
c       complex gb(0:3)        : Boson with adjoint color index b
c       complex gc(0:3)        : Boson with adjoint color index c 
c       complex gd(0:3)        : Boson with adjoint color index d
c       real    g              : coupling of w31 with w-/w+             
c
      implicit none
      double complex ga(6),gb(6),gc(6),gd(6),vertex
      double complex dv1(0:3),dv2(0:3),dv3(0:3),dv4(0:3),
     &     dvertx,v12,v13,v14,v23,v24,v34
      double precision pga(0:3),pgb(0:3),pgc(0:3),pgd(0:3),g

      save dv1,dv2,dv3, dv4
c      save dv1,dv2,dv3,dv4,dvertx,v12,v13,v14,v23,v24,v34

c

      dv1(0) = dcmplx(ga(1))
      dv1(1) = dcmplx(ga(2))
      dv1(2) = dcmplx(ga(3))
      dv1(3) = dcmplx(ga(4))
      dv2(0) = dcmplx(gb(1))
      dv2(1) = dcmplx(gb(2))
      dv2(2) = dcmplx(gb(3))
      dv2(3) = dcmplx(gb(4))
      dv3(0) = dcmplx(gc(1))
      dv3(1) = dcmplx(gc(2))
      dv3(2) = dcmplx(gc(3))
      dv3(3) = dcmplx(gc(4))
      dv4(0) = dcmplx(gd(1))
      dv4(1) = dcmplx(gd(2))
      dv4(2) = dcmplx(gd(3))
      dv4(3) = dcmplx(gd(4))

      v12 = dv1(0)*dv2(0)-dv1(1)*dv2(1)-dv1(2)*dv2(2)-dv1(3)*dv2(3)
      v13 = dv1(0)*dv3(0)-dv1(1)*dv3(1)-dv1(2)*dv3(2)-dv1(3)*dv3(3)
      v14 = dv1(0)*dv4(0)-dv1(1)*dv4(1)-dv1(2)*dv4(2)-dv1(3)*dv4(3)
      v23 = dv2(0)*dv3(0)-dv2(1)*dv3(1)-dv2(2)*dv3(2)-dv2(3)*dv3(3)
      v24 = dv2(0)*dv4(0)-dv2(1)*dv4(1)-dv2(2)*dv4(2)-dv2(3)*dv4(3)
      v34 = dv3(0)*dv4(0)-dv3(1)*dv4(1)-dv3(2)*dv4(2)-dv3(3)*dv4(3)

      dvertx = v14*v23 -v13*v24

      vertex = dcmplx( dvertx ) * (g*g)

c      if (abs(dvertx) .gt. 1d40) then
c         write(*,*) 'Careful',abs(dvertx)
c         write(*,*) v12,v13,v14
c         write(*,*) v23,v24,v34
c      endif
c
      return
      end
      subroutine gggxxx(wm,wp,w3,g , vertex)
c
c This subroutine computes an amplitude of the three-point coupling of
c the gauge bosons.
c
c input:
c       complex wm(6)          : vector               flow-out W-
c       complex wp(6)          : vector               flow-out W+
c       complex w3(6)          : vector               j3 or A    or Z
c       real    g              : coupling constant    gw or gwwa or gwwz
c
c output:
c       complex vertex         : amplitude               gamma(wm,wp,w3)
c
      implicit none
      double complex wm(6),wp(6),w3(6),vertex
      double complex xv1,xv2,xv3,v12,v23,v31
      double complex p12,p13,p21,p23,p31,p32
      double precision pwm(0:3),pwp(0:3),pw3(0:3),g

      double precision rZero, rTenth
      parameter( rZero = 0.0d0, rTenth = 0.1d0 )

c
      pwm(0) = dble( wm(5))
      pwm(1) = dble( wm(6))
      pwm(2) = dimag(wm(6))
      pwm(3) = dimag(wm(5))
      pwp(0) = dble( wp(5))
      pwp(1) = dble( wp(6))
      pwp(2) = dimag(wp(6))
      pwp(3) = dimag(wp(5))
      pw3(0) = dble( w3(5))
      pw3(1) = dble( w3(6))
      pw3(2) = dimag(w3(6))
      pw3(3) = dimag(w3(5))


      v12 = wm(1)*wp(1)-wm(2)*wp(2)-wm(3)*wp(3)-wm(4)*wp(4)
      v23 = wp(1)*w3(1)-wp(2)*w3(2)-wp(3)*w3(3)-wp(4)*w3(4)
      v31 = w3(1)*wm(1)-w3(2)*wm(2)-w3(3)*wm(3)-w3(4)*wm(4)
      xv1 = rZero
      xv2 = rZero
      xv3 = rZero
      if ( abs(wm(1)).ne.rZero ) then
         if ( abs(wm(1)).ge.max(abs(wm(2)),abs(wm(3)),abs(wm(4)))
     &        *rTenth )
     &      xv1 = pwm(0)/wm(1)
      endif
      if ( abs(wp(1)).ne.rZero ) then
         if ( abs(wp(1)).ge.max(abs(wp(2)),abs(wp(3)),abs(wp(4)))
     &        *rTenth )
     &      xv2 = pwp(0)/wp(1)
      endif
      if ( abs(w3(1)).ne.rZero ) then
         if ( abs(w3(1)).ge.max(abs(w3(2)),abs(w3(3)),abs(w3(4)))
     &        *rTenth )
     &      xv3 = pw3(0)/w3(1)
      endif

      p12 = (pwm(0)-xv1*wm(1))*wp(1)-(pwm(1)-xv1*wm(2))*wp(2)
     &     -(pwm(2)-xv1*wm(3))*wp(3)-(pwm(3)-xv1*wm(4))*wp(4)
      p13 = (pwm(0)-xv1*wm(1))*w3(1)-(pwm(1)-xv1*wm(2))*w3(2)
     &     -(pwm(2)-xv1*wm(3))*w3(3)-(pwm(3)-xv1*wm(4))*w3(4)
      p21 = (pwp(0)-xv2*wp(1))*wm(1)-(pwp(1)-xv2*wp(2))*wm(2)
     &     -(pwp(2)-xv2*wp(3))*wm(3)-(pwp(3)-xv2*wp(4))*wm(4)
      p23 = (pwp(0)-xv2*wp(1))*w3(1)-(pwp(1)-xv2*wp(2))*w3(2)
     &     -(pwp(2)-xv2*wp(3))*w3(3)-(pwp(3)-xv2*wp(4))*w3(4)
      p31 = (pw3(0)-xv3*w3(1))*wm(1)-(pw3(1)-xv3*w3(2))*wm(2)
     &     -(pw3(2)-xv3*w3(3))*wm(3)-(pw3(3)-xv3*w3(4))*wm(4)
      p32 = (pw3(0)-xv3*w3(1))*wp(1)-(pw3(1)-xv3*w3(2))*wp(2)
     &     -(pw3(2)-xv3*w3(3))*wp(3)-(pw3(3)-xv3*w3(4))*wp(4)

      vertex = -(v12*(p13-p23)+v23*(p21-p31)+v31*(p32-p12))*g
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine hiocxx(fic,foc,gc,smass,swidth , hioc)                
c                                                                       
c this subroutine computes an off-shell scalar current from an external 
c antifermion pair.                                                     
c                                                                       
c input:                                                                
c       complex fic(6)         : flow-in  antifermion              |fic>
c       complex foc(6)         : flow-out antifermion              <foc|
c       complex gc(2)          : coupling constants                 gchf
c       real    smass          : mass  of output scalar s               
c       real    swidth         : width of output scalar s               
c                                                                       
c output:                                                               
c       complex hioc(3)        : scalar current           j(<fic|s|foc>)
c                                                                       
      implicit none
      double complex fic(6),foc(6),hioc(3),gc(2),dn
      double precision q(0:3),smass,swidth,q2
c
      hioc(2) = foc(5)-fic(5)
      hioc(3) = foc(6)-fic(6)

      q(0) = dble( hioc(2))
      q(1) = dble( hioc(3))
      q(2) = dimag(hioc(3))
      q(3) = dimag(hioc(2))
      q2 = q(0)**2-(q(1)**2+q(2)**2+q(3)**2)

      dn = -dcmplx( q2-smass**2, smass*swidth )

      hioc(1) = (  gc(1)*(foc(1)*fic(1)+foc(2)*fic(2))
     &           + gc(2)*(foc(3)*fic(3)+foc(4)*fic(4)) )/dn
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine hiogld(fi,fo,gc,smass,swidth,mNLSP,idecay , hio)
c
c This subroutine computes an off-shell scalar current for the NLSP-
c Goldstino vertex from the external fermion pair. The h.c. of the NLSP
c decay is handled via the input parameter idecay.
c
c input:
c       complex fi(6)          : flow-in  fermion                   |fi>
c       complex fo(6)          : flow-out fermion                   <fo|
c       complex gc(2)          : coupling constants                  gsf
c       real    smass          : mass  of output scalar s
c       real    swidth         : width of output scalar s
c       real    mNLSP          : mass of NLSP
c       integer idecay         :  1 for NLSP decay to Goldstino
c                              : -1 for Goldstino to NLSP (h.c. of above)
c
c output:
c       complex hio(3)         : scalar current          j^mu(<fo|s|fi>)
c
      implicit none
      double complex fi(6), fo(6), gc(2), hio(3)
      double complex dn, p14p, p14m, p23p, p23m
      double precision q(0:3), smass, swidth, mNLSP, q2
      double precision pG(1:4)
      integer idecay

      double complex ci, cZero
      parameter( ci = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )
c
      hio(2) = -fi(5) + fo(5)
      hio(3) = -fi(6) + fo(6)

      if ( idecay.ne.1 .or. idecay.ne.-1 ) then
         write(6,*) 'error in idecay of HIOGLD'
         stop
      end if

      q(0) = dble( hio(2))
      q(1) = dble( hio(3))
      q(2) = dimag(hio(3))
      q(3) = dimag(hio(2))
      q2 = q(0)**2 - q(1)**2 - q(2)**2 - q(3)**2

      p14p = q(0) + q(3)
      p14m = q(0) - q(3)
      p23p = q(1) + q(2)*ci
      p23m = q(1) - q(2)*ci

      dn = -dcmplx( q2-smass**2, smass*swidth )

      hio(1) = gc(1)*( ( ( fo(3)*p14p + fo(4)*p23p )*fi(1)
     &                  +( fo(3)*p23m + fo(4)*p14m )*fi(2) )*mNLSP
     &                -( fo(1)*fi(1) + fo(2)*fi(2) )*idecay*smass**2 )

      if ( gc(2).ne.cZero ) then
         hio(1) = hio(1) + gc(2) *
     &            ( ( ( fo(1)*p14m - fo(2)*p23p )*fi(3)
     &               -( fo(1)*p23m - fo(2)*p14p )*fi(4) )*mNLSP
     &             -( fo(3)*fi(3) + fo(4)*fi(4) )*idecay*smass**2 )
      end if

      hio(1) = hio(1)/dn
c
      return
      end
      subroutine hioxxx(fi,fo,gc,smass,swidth , hio)
c
c This subroutine computes an off-shell scalar current from an external
c fermion pair.
c
c input:
c       complex fi(6)          : flow-in  fermion                   |fi>
c       complex fo(6)          : flow-out fermion                   <fo|
c       complex gc(2)          : coupling constants                 gchf
c       real    smass          : mass  of OUTPUT scalar s
c       real    swidth         : width of OUTPUT scalar s
c
c output:
c       complex hio(3)         : scalar current             j(<fi|s|fo>)
c
      implicit none
      double complex fi(6),fo(6),hio(3),gc(2),dn
      double precision q(0:3),smass,swidth,q2

c

      hio(2) = fo(5)-fi(5)
      hio(3) = fo(6)-fi(6)

      q(0) = dble( hio(2))
      q(1) = dble( hio(3))
      q(2) = dimag(hio(3))
      q(3) = dimag(hio(2))
      q2 = q(0)**2-(q(1)**2+q(2)**2+q(3)**2)


      dn = -dcmplx( q2-smass**2, smass*swidth )

      hio(1) = ( gc(1)*(fo(1)*fi(1)+fo(2)*fi(2))
     &          +gc(2)*(fo(3)*fi(3)+fo(4)*fi(4)) )/dn
c
      return
      end
      subroutine hsssxx(s1,s2,s3,gc,smass,swidth , hsss)
c
c This subroutine computes an off-shell scalar current from the four-
c scalar coupling.
c
c input:
c       complex s1(3)          : first  scalar                        s1
c       complex s2(3)          : second scalar                        s2
c       complex s3(3)          : third  scalar                        s3
c       complex gc             : coupling constant                 ghhhh
c       real    smass          : mass  of OUTPUT scalar s'
c       real    swidth         : width of OUTPUT scalar s'
c
c output:
c       complex hsss(3)        : scalar current           j(s':s1,s2,s3)
c     
      implicit none
      double complex s1(3),s2(3),s3(3),gc,hsss(3),dg
      double precision q(0:3),smass,swidth,q2

c

      hsss(2) = s1(2)+s2(2)+s3(2)
      hsss(3) = s1(3)+s2(3)+s3(3)

      q(0) = dble( hsss(2))
      q(1) = dble( hsss(3))
      q(2) = dimag(hsss(3))
      q(3) = dimag(hsss(2))
      q2 = q(0)**2-(q(1)**2+q(2)**2+q(3)**2)


      dg = -gc/dcmplx( q2-smass**2, smass*swidth )

      hsss(1) = dg * s1(1)*s2(1)*s3(1)
c
      return
      end
      subroutine hssxxx(s1,s2,gc,smass,swidth , hss)
c
c This subroutine computes an off-shell scalar current from the three-
c scalar coupling.
c
c input:
c       complex s1(3)          : first  scalar                        s1
c       complex s2(3)          : second scalar                        s2
c       complex gc             : coupling constant                  ghhh
c       real    smass          : mass  of OUTPUT scalar s'
c       real    swidth         : width of OUTPUT scalar s'
c
c output:
c       complex hss(3)         : scalar current              j(s':s1,s2)
c     
      implicit none
      double complex s1(3),s2(3),gc,hss(3),dg
      double precision q(0:3),smass,swidth,q2

c

      hss(2) = s1(2)+s2(2)
      hss(3) = s1(3)+s2(3)

      q(0) = dble( hss(2))
      q(1) = dble( hss(3))
      q(2) = dimag(hss(3))
      q(3) = dimag(hss(2))
      q2 = q(0)**2-(q(1)**2+q(2)**2+q(3)**2)


      dg = -gc/dcmplx( q2-smass**2, smass*swidth )

      hss(1) = dg*s1(1)*s2(1)
c
      return
      end
      subroutine hvsxxx(vc,sc,gc,smass,swidth , hvs)
c
c This subroutine computes an off-shell scalar current from the vector-
c scalar-scalar coupling.  The coupling is absent in the minimal SM in
c unitary gauge.
c
c input:
c       complex vc(6)          : input vector                          v
c       complex sc(3)          : input scalar                          s
c       complex gc             : coupling constant (s charge)
c       real    smass          : mass  of OUTPUT scalar s'
c       real    swidth         : width of OUTPUT scalar s'
c
c examples of the coupling constant gc for susy particles are as follows:
c   -----------------------------------------------------------
c   |    s1    | (q,i3) of s1  ||   v=A   |   v=Z   |   v=W   |
c   -----------------------------------------------------------
c   | nu~_l    | (  0  , +1/2) ||   ---   |  gzn(1) |  gwf(1) |
c   | e~_l     | ( -1  , -1/2) ||  gal(1) |  gzl(1) |  gwf(1) |
c   | u~_l     | (+2/3 , +1/2) ||  gau(1) |  gzu(1) |  gwf(1) |
c   | d~_l     | (-1/3 , -1/2) ||  gad(1) |  gzd(1) |  gwf(1) |
c   -----------------------------------------------------------
c   | e~_r-bar | ( +1  ,  0  ) || -gal(2) | -gzl(2) | -gwf(2) |
c   | u~_r-bar | (-2/3 ,  0  ) || -gau(2) | -gzu(2) | -gwf(2) |
c   | d~_r-bar | (+1/3 ,  0  ) || -gad(2) | -gzd(2) | -gwf(2) |
c   -----------------------------------------------------------
c where the sc charge is defined by the flowing-OUT quantum number.
c
c output:
c       complex hvs(3)         : scalar current                j(s':v,s)
c     
      implicit none
      double complex vc(6),sc(3),hvs(3),dg,qvv,qpv,gc
      double precision qv(0:3),qp(0:3),qa(0:3),smass,swidth,q2

      double precision rTwo
      parameter( rTwo = 2.0d0 )

c

      hvs(2) = vc(5)+sc(2)
      hvs(3) = vc(6)+sc(3)

      qv(0) = dble(  vc(5))
      qv(1) = dble(  vc(6))
      qv(2) = dimag( vc(6))
      qv(3) = dimag( vc(5))
      qp(0) = dble(  sc(2))
      qp(1) = dble(  sc(3))
      qp(2) = dimag( sc(3))
      qp(3) = dimag( sc(2))
      qa(0) = dble( hvs(2))
      qa(1) = dble( hvs(3))
      qa(2) = dimag(hvs(3))
      qa(3) = dimag(hvs(2))
      q2 = qa(0)**2-(qa(1)**2+qa(2)**2+qa(3)**2)


      dg = -gc/dcmplx( q2-smass**2, smass*swidth )
      qvv = qv(0)*vc(1)-qv(1)*vc(2)-qv(2)*vc(3)-qv(3)*vc(4)
      qpv = qp(0)*vc(1)-qp(1)*vc(2)-qp(2)*vc(3)-qp(3)*vc(4)

      hvs(1) = dg*(rTwo*qpv+qvv)*sc(1)
c
      return
      end
      subroutine hvvsxx(v1,v2,sc,gc,smass,swidth , hvvs)
c
c This subroutine computes an off-shell scalar current of the vector-
c vector-scalar-scalar coupling.
c
c input:
c       complex v1(6)          : first  vector                        v1
c       complex v2(6)          : second vector                        v2
c       complex sc(3)          : input  scalar                        s
c       complex gc             : coupling constant                 gvvhh
c       real    smass          : mass  of OUTPUT scalar s'
c       real    swidth         : width of OUTPUT scalar s'
c
c output:
c       complex hvvs(3)        : scalar current            j(s':v1,v2,s)
c     
      implicit none
      double complex v1(6),v2(6),sc(3),gc,hvvs(3),dg
      double precision q(0:3),smass,swidth,q2

c

      hvvs(2) = v1(5)+v2(5)+sc(2)
      hvvs(3) = v1(6)+v2(6)+sc(3)

      q(0) = dble( hvvs(2))
      q(1) = dble( hvvs(3))
      q(2) = dimag(hvvs(3))
      q(3) = dimag(hvvs(2))
      q2 = q(0)**2-(q(1)**2+q(2)**2+q(3)**2)


      dg = -gc/dcmplx( q2-smass**2, smass*swidth )

      hvvs(1) = dg*sc(1)
     &         *(v1(1)*v2(1)-v1(2)*v2(2)-v1(3)*v2(3)-v1(4)*v2(4))
c
      return
      end
      subroutine hvvxxx(v1,v2,gc,smass,swidth , hvv)
c
c This subroutine computes an off-shell scalar current from the vector-
c vector-scalar coupling.
c
c input:
c       complex v1(6)          : first  vector                        v1
c       complex v2(6)          : second vector                        v2
c       complex gc             : coupling constant                  gvvh
c       real    smass          : mass  of OUTPUT scalar s
c       real    swidth         : width of OUTPUT scalar s
c
c output:
c       complex hvv(3)         : off-shell scalar current     j(s:v1,v2)
c     
      implicit none
      double complex v1(6),v2(6),gc,hvv(3),dg
      double precision q(0:3),smass,swidth,q2

      double precision rZero
      parameter( rZero = 0.0d0 )

c

      hvv(2) = v1(5)+v2(5)
      hvv(3) = v1(6)+v2(6)

      q(0) = dble( hvv(2))
      q(1) = dble( hvv(3))
      q(2) = dimag(hvv(3))
      q(3) = dimag(hvv(2))
      q2 = q(0)**2-(q(1)**2+q(2)**2+q(3)**2)


      dg = -gc/dcmplx( q2-smass**2, smass*swidth )

      hvv(1) = dg*(v1(1)*v2(1)-v1(2)*v2(2)-v1(3)*v2(3)-v1(4)*v2(4))
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine ioscxx(fic,foc,sc,gc , vertex)
c
c This subroutine computes an amplitude of the antifermion-antifermion- 
c scalar coupling.                                                      
c                                                                       
c input:                                                                
c       complex fic(6)         : flow-in  antifermion              |fic>
c       complex foc(6)         : flow-out antifermion              <foc|
c       complex sc(3)          : input    scalar                      s 
c       complex gc(2)          : coupling constants                 gchf
c                                                                       
c output:                                                               
c       complex vertex         : amplitude                   <foc|s|fic>
c
      implicit none
      double complex fic(6),foc(6),sc(3),gc(2),vertex
c
      vertex = sc(1)*( gc(1)*(fic(1)*foc(1)+fic(2)*foc(2))
     &                +gc(2)*(fic(3)*foc(3)+fic(4)*foc(4)) )
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine iosgld(fi,fo,sc,gc,smass,mNLSP,idecay , vertex)
c
c This subroutine computes an amplitude of the fermion-fermion-scalar
c SUSY Goldstino coupling. In this routine, the NLSP is decaying to a
c boson and a Goldstino. The h.c. of the NLSP decay is handled via the
c input parameter idecay.
c
c input:
c       complex fi(6)          : flow-in  fermion                   |fi>
c       complex fo(6)          : flow-out fermion                   <fo|
c       complex sc(3)          : input    scalar                      s
c       complex gc(2)          : coupling constants                  gsf
c       real    mNLSP          : mass of the NLSP
c       real    smass          : mass of the scalar boson
c       integer idecay         :  1 for NLSP decay to Goldstino
c                              : -1 for Goldstino to NLSP (h.c. of above)
c
c output:
c       complex vertex         : amplitude                     <fo|s|fi>
c
      implicit none
      double complex  fi(6), fo(6), gc(2), sc(3), vertex
      double complex  p14p, p14m, p23p, p23m
      double precision  mNLSP, smass
      integer idecay

      double complex ci, cZero
      parameter( ci = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )
c
      if ( idecay.ne.1 .or. idecay.ne.-1 ) then
         write(6,*) 'error in idecay of IOSGLD'
         stop
      end if

      p14p = dble(sc(2)) + dimag(sc(2))
      p14m = dble(sc(2)) - dimag(sc(2))
      p23p = dble(sc(3)) + dimag(sc(3))*ci
      p23m = dble(sc(3)) - dimag(sc(3))*ci

      vertex = gc(1) *
     &         ( ( ( fo(3)*p14p + fo(4)*p23p )*fi(1)
     &            +( fo(3)*p23m + fo(4)*p14m )*fi(2) )*mNLSP
     &          -( fo(1)*fi(1) + fo(2)*fi(2) )*idecay*smass**2 )

      if ( gc(2).ne.cZero ) then
         vertex = vertex + gc(2) *
     &            ( ( ( fo(1)*p14m - fo(2)*p23p )*fi(3)
     &               -( fo(1)*p23m - fo(2)*p14p )*fi(4) )*mNLSP
     &             -( fo(3)*fi(3) + fo(4)*fi(4) )*idecay*smass**2 )
      end if

      vertex = vertex * sc(1)
c
      return
      end
      subroutine iosxxx(fi,fo,sc,gc , vertex)
c
c This subroutine computes an amplitude of the fermion-fermion-scalar
c coupling.
c
c input:
c       complex fi(6)          : flow-in  fermion                   |fi>
c       complex fo(6)          : flow-out fermion                   <fo|
c       complex sc(3)          : input    scalar                      s
c       complex gc(2)          : coupling constants                 gchf
c
c output:
c       complex vertex         : amplitude                     <fo|s|fi>
c     
      implicit none
      double complex fi(6),fo(6),sc(3),gc(2),vertex

c

      vertex = sc(1)*( gc(1)*(fi(1)*fo(1)+fi(2)*fo(2))
     &                +gc(2)*(fi(3)*fo(3)+fi(4)*fo(4)) )
c
      return
      end
      subroutine iotxkk(fi,fo,tc,g,fmass , vertex)
c
c This subroutine computes an amplitude of the fermion-fermion-vector
c coupling.
c
c input:
c       complex fi(6)          : flow-in  fermion                   |fi>
c       complex fo(6)          : flow-out fermion                   <fo|
c       complex tc(6,4)        : input    tensor                      t
c       real    g              : coupling constant                 -kappa/8
c       real    fmass          : fermion mass                        m_f
c
c output:
c       complex vertex         : amplitude                        <fo|t|fi>
c     
      implicit none
      double complex fi(6), fo(6), tc(6,4), vertex
      double precision g, fmass

      double complex k23, k23s, D1, D2, D3, D4, Tii
      double complex T11, T22, T33, T44, T12, T13, T14, T23, T24, T34
      double complex f13, f14, f23, f24, f31, f32, f41, f42
      double precision k(4), k14p, k14m, m2

      double precision rZero, rTwo
      parameter( rZero = 0.0d0, rTwo = 2.0d0 )
      double complex ci
      parameter( ci = ( 0.0d0, 1.0d0 ) )
c
      m2 = rTwo*fmass

      k(1) = dreal(fi(5)+fo(5))
      k(2) = dreal(fi(6)+fo(6))
      k(3) = dimag(fi(6)+fo(6))
      k(4) = dimag(fi(5)+fo(5))
      k23  = dcmplx( k(2),k(3) )
      k23s = dconjg( k23 )
      k14p = k(1) + k(4)
      k14m = k(1) - k(4)

      f13 = fo(1)*fi(3)
      f14 = fo(1)*fi(4)
      f23 = fo(2)*fi(3)
      f24 = fo(2)*fi(4)
      f31 = fo(3)*fi(1)
      f32 = fo(3)*fi(2)
      f41 = fo(4)*fi(1)
      f42 = fo(4)*fi(2)

      T11 = rTwo*tc(1,1)
      T22 = rTwo*tc(2,2)
      T33 = rTwo*tc(3,3)
      T44 = rTwo*tc(4,4)
      T12 = tc(1,2) + tc(2,1)
      T13 = tc(1,3) + tc(3,1)
      T14 = tc(1,4) + tc(4,1)
      T23 = tc(2,3) + tc(3,2)
      T24 = tc(2,4) + tc(4,2)
      T34 = tc(3,4) + tc(4,3)

      D1 =   k(1)*(T11-T14) - k(2)*(T12-T24)
     &     - k(3)*(T13-T34) - k(4)*(T14-T44)

      D2 = - k(1)*(T12-ci*T13) + k(2)*(T22-ci*T23)
     &     + k(3)*(T23-ci*T33) + k(4)*(T24-ci*T34)

      D3 = - k(1)*(T12+ci*T13) + k(2)*(T22+ci*T23)
     &     + k(3)*(T23+ci*T33) + k(4)*(T24+ci*T34)

      D4 =   k(1)*(T11+T14) - k(2)*(T12+T24)
     &     - k(3)*(T13+T34) - k(4)*(T14+T44)

      Tii = T11 - T22 - T33 - T44

      vertex = D1*(f13+f42) + D2*(f14-f32) + D3*(f23-f41) + D4*(f24+f31)

      vertex = vertex + Tii*( - k14p*(f24+f31) - k14m*(f13+f42)
     &                        +  k23*(f23-f41) + k23s*(f14-f32) )

      if ( fmass.ne.rZero ) then
         vertex = vertex + m2*Tii*(  fo(1)*fi(1) + fo(2)*fi(2)
     &                             + fo(3)*fi(3) + fo(4)*fi(4) )
      end if

      vertex = vertex * g
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine iovcxx(fic,foc,vc,gc , vertex)
c
c this subroutine computes an amplitude of the antifermion-antifermion- 
c vector coupling.                                                      
c                                                                       
c input:                                                                
c       complex fic(6)         : flow-in  antifermion              |fic>
c       complex foc(6)         : flow-out antifermion              <foc|
c       complex vc(6)          : input    vector                      v 
c       complex gc(2)          : coupling constants                  gvf
c                                                                       
c output:                                                               
c       complex vertex         : amplitude                   <foc|v|fic>
c
      implicit none
      double complex fic(6),foc(6),vc(6),gc(2),vertex

      double complex cImag, cZero
      parameter( cImag = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )
c
      vertex = - gc(1)*( (foc(1)*fic(3)+foc(2)*fic(4))*vc(1)
     &                  -(foc(1)*fic(4)+foc(2)*fic(3))*vc(2)
     &                  +(foc(1)*fic(4)-foc(2)*fic(3))*vc(3)*cImag
     &                  -(foc(1)*fic(3)-foc(2)*fic(4))*vc(4)       )

      if ( gc(2).ne.cZero ) then
         vertex = vertex
     &            - gc(2)*( (foc(3)*fic(1)+foc(4)*fic(2))*vc(1)
     &                     +(foc(3)*fic(2)+foc(4)*fic(1))*vc(2)
     &                     -(foc(3)*fic(2)-foc(4)*fic(1))*vc(3)*cImag
     &                     +(foc(3)*fic(1)-foc(4)*fic(2))*vc(4)       )
      end if
c
      return
      end
      subroutine iovdmx(fi,fo,vc,gc, vertex)
c
c This subroutine computes an amplitude of the fermion-fermion-vector
c dipole moment (non-renormalizable) coupling.
c
c input:
c       complex fi(6)          : flow-in  fermion                   |fi>
c       complex fo(6)          : flow-out fermion                   <fo|
c       complex vc(6)          : input    vector                      v
c       complex gc(2,2)        : coupling constants                  gvf
c                              : first index is L,R as normal
c                              : second index is EDM,-MDM
c
c output:
c       complex vertex         : amplitude                     <fo|v|fi>
c
      implicit none
      double complex fi(6), fo(6), vc(6), vertex, gc(2,2)

      double complex q(5:6), dum1, dum2
      double complex f1122, f12, f21, f3344, f34, f43
      double complex f12p21, f12m21, f34p43, f34m43
      double complex kvc21, kvc31, kvc41, kvc32, kvc42, kvc43
      double precision  rZero, rOne
      parameter( rZero = 0.0d0, rOne = 1.0d0 )
      double complex cImag, cZero
      parameter( cImag = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )

c

      q(5) = fi(5) - fo(5)
      q(6) = fi(6) - fo(6)

      f1122  = fo(1)*fi(1) - fo(2)*fi(2)
      f12    = fo(1)*fi(2)
      f21    = fo(2)*fi(1)
      f12p21 = f12 + f21
      f12m21 = f12 - f21

      kvc21 = ( dble(q(6))*vc(1) -  dble(q(5))*vc(2))*cImag
      kvc31 =  dimag(q(6))*vc(1) -  dble(q(5))*vc(3)
      kvc41 = (dimag(q(5))*vc(1) -  dble(q(5))*vc(4))*cImag
      kvc32 =  dimag(q(6))*vc(2) -  dble(q(6))*vc(3)
      kvc42 = (dimag(q(5))*vc(2) -  dble(q(6))*vc(4))*cImag
      kvc43 =  dimag(q(5))*vc(3) - dimag(q(6))*vc(4)

      dum1 =   ( kvc31 + kvc42 )*f12m21
     &       + ( kvc32 + kvc41 )*f1122
     &       + ( kvc43 + kvc21 )*f12p21

c     (-) from gamma^5 in EDM only
      vertex = ( -gc(1,1) + cImag*gc(1,2) )*dum1    

      if ( gc(2,1).ne.cZero .or.
     &     gc(2,2).ne.cZero      ) then
         f3344  = fo(3)*fi(3) - fo(4)*fi(4)
         f34    = fo(3)*fi(4)
         f43    = fo(4)*fi(3)
         f34p43 = f34 + f43
         f34m43 = f34 - f43
         dum2 =   (-kvc31 + kvc42 )*f34m43
     &          + ( kvc32 - kvc41 )*f3344
     &          + ( kvc43 - kvc21 )*f34p43
         vertex = vertex + ( gc(2,1) + cImag*gc(2,2) )*dum2
      end if
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine iovgld(fi,fo,vc,gc,idecay , vertex)
c
c This subroutine computes an amplitude of the fermion-fermion-vector
c SUSY Goldstino coupling. In this routine, the NLSP is decaying to a
c boson and a Goldstino. The h.c. of the NLSP decay is handled via the
c input parameter idecay (picks out correct Goldstino momentum).
c
c input:
c       complex fi(6)          : flow-in  fermion                   |fi>
c       complex fo(6)          : flow-out fermion                   <fo|
c       complex vc(6)          : input    vector                      v
c       complex gc(2)          : coupling constants                  gvf
c       integer idecay         :  1 for NLSP decay to Goldstino
c                              : -1 for Goldstino to NLSP (h.c. of above)
c
c output:
c       complex vertex         : amplitude                     <fo|v|fi>
c
      implicit none
      double complex  fi(6), fo(6), gc(2), vc(6), vertex
      double complex  AdotpG, A14p, A14m, A23p, A23m
      double complex  p14p, p14m, p23p, p23m
      double precision  pdotpG
      integer idecay

      double precision rOne
      parameter( rOne = 1.0d0 )
      double complex ci, cZero
      parameter( ci = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )
c
      if ( idecay.eq.1 ) then
         pdotpG =  dble( vc(5))*dble( fo(5))
     &           - dble( vc(6))*dble( fo(6))
     &           - dimag(vc(6))*dimag(fo(6))
     &           - dimag(vc(5))*dimag(fo(5))
         AdotpG =  vc(1)*dble( fo(5)) - vc(2)*dble( fo(6))
     &           - vc(3)*dimag(fo(6)) - vc(4)*dimag(fo(5))
      else if ( idecay.eq.-1 ) then
         pdotpG =  dble( vc(5))*dble( fi(5))
     &           - dble( vc(6))*dble( fi(6))
     &           - dimag(vc(6))*dimag(fi(6))
     &           - dimag(vc(5))*dimag(fi(5))
         AdotpG =  vc(1)*dble( fi(5)) - vc(2)*dble( fi(6))
     &           - vc(3)*dimag(fi(6)) - vc(4)*dimag(fi(5))
      else
         write(6,*) 'error in idecay of IOVGLD'
         stop
      end if

      p14p = dble(vc(5)) + dimag(vc(5))
      p14m = dble(vc(5)) - dimag(vc(5))
      p23p = vc(6)
      p23m = dconjg(vc(6))
      A14p = vc(1) + vc(4)
      A14m = vc(1) - vc(4)
      A23p = vc(2) + vc(3)*ci
      A23m = vc(2) - vc(3)*ci

      vertex = gc(1)*( ( ( fo(3)*p14p + fo(4)*p23p )*fi(1)
     &                  +( fo(3)*p23m + fo(4)*p14m )*fi(2) )*AdotpG
     &                -( ( fo(3)*A14p + fo(4)*A23p )*fi(1)
     &                  +( fo(3)*A23m + fo(4)*A14m )*fi(2) )*pdotpG )

      if ( gc(2).ne.cZero ) then
         vertex = vertex
     &          + gc(2)*( ( (fo(1)*p14m - fo(2)*p23p )*fi(3)
     &                     -(fo(1)*p23m - fo(2)*p14p )*fi(4) )*AdotpG
     &                   -( (fo(1)*A14m - fo(2)*A23p )*fi(3)
     &                     -(fo(1)*A23m - fo(2)*A14p )*fi(4) )*pdotpG )
      end if

      vertex = vertex * idecay
c
      return
      end
      subroutine iovtkk(fi,fo,vc,tc,g , vertex)
c
c This subroutine computes an amplitude of the three-point coupling of
c two gauge bosons and a Kaluza-Klein tensor boson.
c
c input:
c       complex fi(6)          : flow-in  fermion     SM |fi>
c       complex fo(6)          : flow-out fermion     SM <fo|
c       complex vc(6)          : vector               SM   v
c       complex tc(6,4)        : tensor               KK   t
c       real    g(2)           : coupling constant    -g(L,R)*kappa/4
c
c output:
c       complex vertex         : amplitude            gamma(fi,fo,vc,tc)
c     
      implicit none
      double complex fi(6), fo(6), vc(6), tc(6,4), vertex
      double precision g(2)

      double complex f13, f14, f23, f24, f31, f32, f41, f42
      double complex fs1L, fs1R, fs2L, fs2R, fs3L, fs3R, fs4L, fs4R
      double complex T12, T13, T14, T23, T24, T34

      double precision rZero, rTwo
      parameter( rZero = 0.0d0, rTwo = 2.0d0 )
      double complex ci
      parameter( ci = ( 0.0d0, 1.0d0 ) )
c
      f31 = fo(3)*fi(1)*g(1)
      f32 = fo(3)*fi(2)*g(1)
      f41 = fo(4)*fi(1)*g(1)
      f42 = fo(4)*fi(2)*g(1)

      fs1L =  f31 + f42
      fs2L = -f32 - f41
      fs3L = (f32 - f41)*ci
      fs4L = -f31 + f42

      if ( g(2).ne.rZero ) then
         f14 = fo(1)*fi(4)*g(2)
         f13 = fo(1)*fi(3)*g(2)
         f23 = fo(2)*fi(3)*g(2)
         f24 = fo(2)*fi(4)*g(2)
         fs1R =  f13 + f24
         fs2R =  f23 + f14
         fs3R = (f23 - f14)*ci
         fs4R =  f13 - f24
      end if

      T12 = tc(1,2) + tc(2,1)
      T13 = tc(1,3) + tc(3,1)
      T14 = tc(1,4) + tc(4,1)
      T23 = tc(2,3) + tc(3,2)
      T24 = tc(2,4) + tc(4,2)
      T34 = tc(3,4) + tc(4,3)

      if ( g(2).ne.rZero ) then

         vertex =  (fs1L + fs1R)*(  vc(1)*rTwo*tc(1,1)
     &                            - vc(2)*T12 - vc(3)*T13 - vc(4)*T14 )

     &           + (fs2L + fs2R)*(  vc(2)*rTwo*tc(2,2)
     &                            - vc(1)*T12 + vc(3)*T23 + vc(4)*T24 )

     &           + (fs3L + fs3R)*(  vc(3)*rTwo*tc(3,3)
     &                            - vc(1)*T13 + vc(2)*T23 + vc(4)*T34 )

     &           + (fs4L + fs4R)*(  vc(4)*rTwo*tc(4,4)
     &                            - vc(1)*T14 + vc(2)*T24 + vc(3)*T34 )

         vertex = vertex - rTwo*( tc(1,1)-tc(2,2)-tc(3,3)-tc(4,4) )
     &                         *(  (vc(1)+      vc(4))*(f31+f24)
     &                           + (vc(1)-      vc(4))*(f13+f42)
     &                           + (vc(2)+ci*vc(3))*(f41-f23)
     &                           + (vc(2)-ci*vc(3))*(f32-f14) )

      else

         vertex =  fs1L*(  vc(1)*rTwo*tc(1,1)
     &                   - vc(2)*T12 - vc(3)*T13 - vc(4)*T14 )

     &           + fs2L*(  vc(2)*rTwo*tc(2,2)
     &                   - vc(1)*T12 + vc(3)*T23 + vc(4)*T24 )

     &           + fs3L*(  vc(3)*rTwo*tc(3,3)
     &                   - vc(1)*T13 + vc(2)*T23 + vc(4)*T34 )

     &           + fs4L*(  vc(4)*rTwo*tc(4,4)
     &                   - vc(1)*T14 + vc(2)*T24 + vc(3)*T34 )

         vertex = vertex - rTwo*( tc(1,1)-tc(2,2)-tc(3,3)-tc(4,4) )
     &                         *(  (vc(1)+      vc(4))*f31
     &                           + (vc(1)-      vc(4))*f42
     &                           + (vc(2)+ci*vc(3))*f41
     &                           + (vc(2)-ci*vc(3))*f32 )

      end if
c
      return
      end
      subroutine iovxxx(fi,fo,vc,gc , vertex)
c
c This subroutine computes an amplitude of the fermion-fermion-vector
c coupling.
c
c input:
c       complex fi(6)          : flow-in  fermion                   |fi>
c       complex fo(6)          : flow-out fermion                   <fo|
c       complex vc(6)          : input    vector                      v
c       complex gc(2)          : coupling constants                  gvf
c
c output:
c       complex vertex         : amplitude                     <fo|v|fi>
c     
      implicit none
      double complex fi(6),fo(6),gc(2),vc(6),vertex

      double precision rZero, rOne
      parameter( rZero = 0.0d0 )
      double complex cImag, cZero
      parameter( cImag = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )

c

      vertex =  gc(1)*( (fo(3)*fi(1)+fo(4)*fi(2))*vc(1)
     &                 +(fo(3)*fi(2)+fo(4)*fi(1))*vc(2)
     &                 -(fo(3)*fi(2)-fo(4)*fi(1))*vc(3)*cImag
     &                 +(fo(3)*fi(1)-fo(4)*fi(2))*vc(4)        )

      if ( gc(2).ne.cZero ) then
         vertex = vertex
     &          + gc(2)*( (fo(1)*fi(3)+fo(2)*fi(4))*vc(1)
     &                   -(fo(1)*fi(4)+fo(2)*fi(3))*vc(2)
     &                   +(fo(1)*fi(4)-fo(2)*fi(3))*vc(3)*cImag
     &                   -(fo(1)*fi(3)-fo(2)*fi(4))*vc(4)        )
      end if
c
      return
      end
      subroutine ixxxxx(p,fmass,nhel,nsf , fi)
c
c This subroutine computes a fermion wavefunction with the flowing-IN
c fermion number.
c
c input:
c       real    p(0:3)         : four-momentum of fermion
c       real    fmass          : mass          of fermion
c       integer nhel = -1 or 1 : helicity      of fermion
c       integer nsf  = -1 or 1 : +1 for particle, -1 for anti-particle
c
c output:
c       complex fi(6)          : fermion wavefunction               |fi>
c     
      implicit none
      double complex fi(6),chi(2)
      double precision p(0:3),sf(2),sfomeg(2),omega(2),fmass,
     &     pp,pp3,sqp0p3,sqm
      integer nhel,nsf,ip,im,nh

      double precision rZero, rHalf, rTwo
      parameter( rZero = 0.0d0, rHalf = 0.5d0, rTwo = 2.0d0 )
      
c

      fi(5) = dcmplx(p(0),p(3))*nsf
      fi(6) = dcmplx(p(1),p(2))*nsf

      nh = nhel*nsf

      if ( fmass.ne.rZero ) then

         pp = min(p(0),dsqrt(p(1)**2+p(2)**2+p(3)**2))
         
         if ( pp.eq.rZero ) then
            
            sqm = dsqrt(fmass)
            ip = (1+nh)/2
            im = (1-nh)/2
            
            fi(1) = ip     * sqm
            fi(2) = im*nsf * sqm
            fi(3) = ip*nsf * sqm
            fi(4) = im     * sqm            

         else

            sf(1) = dble(1+nsf+(1-nsf)*nh)*rHalf
            sf(2) = dble(1+nsf-(1-nsf)*nh)*rHalf
            omega(1) = dsqrt(p(0)+pp)
            omega(2) = fmass/omega(1)
            ip = (3+nh)/2
            im = (3-nh)/2
            sfomeg(1) = sf(1)*omega(ip)
            sfomeg(2) = sf(2)*omega(im)
            pp3 = max(pp+p(3),rZero)
            chi(1) = dcmplx( dsqrt(pp3*rHalf/pp) )
            if ( pp3.eq.rZero ) then
               chi(2) = dcmplx(-nh )
            else
               chi(2) = dcmplx( nh*p(1) , p(2) )/dsqrt(rTwo*pp*pp3)
            endif
            
            fi(1) = sfomeg(1)*chi(im)
            fi(2) = sfomeg(1)*chi(ip)
            fi(3) = sfomeg(2)*chi(im)
            fi(4) = sfomeg(2)*chi(ip)
            
         endif
         
      else
         
         sqp0p3 = dsqrt(max(p(0)+p(3),rZero))*nsf
         chi(1) = dcmplx( sqp0p3 )
         if ( sqp0p3.eq.rZero ) then
            chi(2) = dcmplx(-nhel )*dsqrt(rTwo*p(0))
         else
            chi(2) = dcmplx( nh*p(1), p(2) )/sqp0p3
         endif
         if ( nh.eq.1 ) then
            fi(1) = dcmplx( rZero )
            fi(2) = dcmplx( rZero )
            fi(3) = chi(1)
            fi(4) = chi(2)
         else
            fi(1) = chi(2)
            fi(2) = chi(1)
            fi(3) = dcmplx( rZero )
            fi(4) = dcmplx( rZero )
         endif
      endif
c
      return
      end
      subroutine j3xxxx(fi,fo,gaf,gzf,zmass,zwidth , j3)
c
c This subroutine computes the sum of photon and Z currents with the
c suitable weights ( j(W3) = cos(theta_W) j(Z) + sin(theta_W) j(A) ).
c The output j3 is useful as an input of vvvxxx, jvvxxx or w3w3xx.
c The photon propagator is given in Feynman gauge, and the Z propagator
c is given in unitary gauge.
c
c input:
c       complex fi(6)          : flow-in  fermion                   |fi>
c       complex fo(6)          : flow-out fermion                   <fo|
c       complex gaf(2)         : fi couplings with A                 gaf
c       complex gzf(2)         : fi couplings with Z                 gzf
c       real    zmass          : mass  of Z
c       real    zwidth         : width of Z
c
c output:
c       complex j3(6)          : W3 current             j^mu(<fo|w3|fi>)
c     
      implicit none
      double complex fi(6),fo(6),j3(6),gaf(2),gzf(2)
      double complex c0l,c1l,c2l,c3l,csl,c0r,c1r,c2r,c3r,csr,dz,ddif
      double complex gn,gz3l,ga3l
      double complex cm2  ! mass**2- I Gamma mass (Fabio)
      double precision q(0:3),zmass,zwidth,zm2,zmw
      double precision q2,da,ww,cw,sw

      double precision rZero, rOne
      parameter( rZero = 0.0d0, rOne = 1.0d0 )
      double complex cImag, cZero
      parameter( cImag = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )

c

      j3(5) = fo(5)-fi(5)
      j3(6) = fo(6)-fi(6)

      q(0) = -dble( j3(5))
      q(1) = -dble( j3(6))
      q(2) = -dimag(j3(6))
      q(3) = -dimag(j3(5))
      q2 = q(0)**2-(q(1)**2+q(2)**2+q(3)**2)
      zm2 = zmass**2
      zmw = zmass*zwidth


      da = rOne/q2
C      ww = max(dsign(zmw,q2), rZero)
      dz = rOne/dcmplx( q2-zm2, zmw )
      ddif = dcmplx( -zm2, zmw )*da*dz

c ddif is the difference : ddif=da-dz
c  For the running width, use below instead of the above ww,dz and ddif.
c      ww = max( zwidth*q2/zmass, rZero )
c      dz = rOne/dcmplx( q2-zm2, zmw )
c      ddif = dcmplx( -zm2, zmw )*da*dz



      cw = rOne/sqrt(rOne+(gzf(2)/gaf(2))**2)
      sw = sqrt((rOne-cw)*(rOne+cw))
      gn = gaf(2)*sw
      gz3l = gzf(1)*cw
      ga3l = gaf(1)*sw
      c0l =   fo(3)*fi(1)+fo(4)*fi(2)
      c0r =   fo(1)*fi(3)+fo(2)*fi(4)
      c1l = -(fo(3)*fi(2)+fo(4)*fi(1))
      c1r =   fo(1)*fi(4)+fo(2)*fi(3)
      c2l =  (fo(3)*fi(2)-fo(4)*fi(1))*cImag
      c2r = (-fo(1)*fi(4)+fo(2)*fi(3))*cImag
      c3l =  -fo(3)*fi(1)+fo(4)*fi(2)
      c3r =   fo(1)*fi(3)-fo(2)*fi(4)

c     Fabio's implementation of the fixed width
      cm2=dcmplx( zm2, -zmw )
c     csl = (q(0)*c0l-q(1)*c1l-q(2)*c2l-q(3)*c3l)/zm2
c     csr = (q(0)*c0r-q(1)*c1r-q(2)*c2r-q(3)*c3r)/zm2
      csl = (q(0)*c0l-q(1)*c1l-q(2)*c2l-q(3)*c3l)/cm2
      csr = (q(0)*c0r-q(1)*c1r-q(2)*c2r-q(3)*c3r)/cm2
      
      j3(1) =  gz3l*dz*(c0l-csl*q(0))+ga3l*c0l*da
     &       + gn*(c0r*ddif+csr*q(0)*dz)
      j3(2) =  gz3l*dz*(c1l-csl*q(1))+ga3l*c1l*da
     &       + gn*(c1r*ddif+csr*q(1)*dz)
      j3(3) =  gz3l*dz*(c2l-csl*q(2))+ga3l*c2l*da
     &       + gn*(c2r*ddif+csr*q(2)*dz)
      j3(4) =  gz3l*dz*(c3l-csl*q(3))+ga3l*c3l*da
     &       + gn*(c3r*ddif+csr*q(3)*dz)
c
      return
      end
      subroutine jeexxx(eb,ef,shlf,chlf,phi,nhb,nhf,nsf , jee)
c
c This subroutine computes an off-shell photon wavefunction emitted from
c the electron or positron beam, with a special care for the small angle
c region.  The momenta are measured in the laboratory frame, where the
c e- (e+) beam is along the positive (negative) z axis.
c
c input:
c       real    eb             : energy (gev)    of beam  e-/e+
c       real    ef             : energy (gev)    of final e-/e+
c       real    shlf           : sin(theta/2)    of final e-/e+
c       real    chlf           : cos(theta/2)    of final e-/e+
c       real    phi            : azimuthal angle of final e-/e+
c       integer nhb  = -1 or 1 : helicity        of beam  e-/e+
c       integer nhf  = -1 or 1 : helicity        of final e-/e+
c       integer nsf  = -1 or 1 : +1 for electron, -1 for positron
c
c output:
c       complex jee(6)         : off-shell photon          j^mu(<e|a|e>)
c     
      implicit none
      double complex jee(6),coeff
      double precision cs(2),eb,ef,shlf,chlf,phi,alpha,gal,hi,sf,sfh
      double precision x,me2,q2,rfp,rfm,snp,csp,rxc,c,s
      integer nhb,nhf,nsf

      double precision rZero, rHalf, rOne, rTwo, rFour, rOte
      double precision rPi, rIalph
      parameter( rZero = 0.0d0, rHalf = 0.5d0, rOne = 1.0d0 )
      parameter( rTwo = 2.0d0, rFour = 4.0d0, rOte = 128.9d0 )
      parameter( rPi = 3.14159265358979323846d0 )
      parameter( rIalph = 137.0359895d0 )

      double precision me
      parameter( me = 0.51099906d-3 )

c

      alpha = rOne/rOte
      gal = sqrt(alpha*rFour*rPi)

      hi = nhb
      sf = nsf
      sfh = nhb*nsf
      cs((3+nsf)/2) = shlf
      cs((3-nsf)/2) = chlf
c cs(1)=chlf and cs(2)=shlf for electron
c cs(1)=shlf and cs(2)=chlf for positron
      x = ef/eb
      me2 = me**2
      q2 = - rFour*cs(2)**2*(ef*eb-me2)
     &     + sf*(rOne-x)**2/x*(shlf+chlf)*(shlf-chlf)*me2
      rfp = (1+nsf)
      rfm = (1-nsf)
      snp = sin(phi)
      csp = cos(phi)

      if ( nhb.eq.nhf ) then
         rxc = rTwo*x/(rOne-x)*cs(1)**2
         coeff = gal*rTwo*eb*sqrt(x)*cs(2)/q2
     &          *(dcmplx( rfp )-rfm*dcmplx( csp, -snp*hi ))*rHalf
         jee(1) = dcmplx( rZero )
         jee(2) = coeff*dcmplx( (rOne+rxc)*csp, -sfh*snp )
         jee(3) = coeff*dcmplx( (rOne+rxc)*snp,  sfh*csp )
         jee(4) = coeff*(-sf*rxc/cs(1)*cs(2))
      else
         coeff = gal*me/q2/sqrt(x)
     &          *(dcmplx( rfp )+rfm*dcmplx( csp, snp*hi ))*rHalf*hi
         jee(1) = -coeff*(rOne+x)*cs(2)*dcmplx( csp , sfh*snp )
         jee(2) =  coeff*(rOne-x)*cs(1)
         jee(3) =  jee(2)*dcmplx( rZero, sfh )
         jee(4) =  jee(1)*sf*(rOne-x)/(rOne+x)
      endif

      c = (chlf+shlf)*(chlf-shlf)
      s = rTwo*chlf*shlf

      jee(5) = -eb*dcmplx( rOne-x, sf-x*c )
      jee(6) =  eb*x*s*dcmplx( csp, snp )
c
      return
      end
      subroutine jgggxx(w1,w2,w3,g, jw3w)
c
c This subroutine computes an off-shell W+, W-, W3, Z or photon current
c from the four-point gauge boson coupling, including the contributions
c of W exchange diagrams.  The vector propagator is given in Feynman
c gauge for a photon and in unitary gauge for W and Z bosons.  If one
c sets wmass=0.0, then the ggg-->g current is given (see sect 2.9.1 of
c the manual).
c
c input:
c       complex w1(6)          : first  vector                        w1
c       complex w2(6)          : second vector                        w2
c       complex w3(6)          : third  vector                        w3
c       real    g             : first  coupling constant
c                                                  (see the table below)
c
c output:
c       complex jw3w(6)        : W current             j^mu(w':w1,w2,w3)
c
      implicit none
      double complex w1(6),w2(6),w3(6),jw3w(6)
      double complex dw1(0:3),dw2(0:3),dw3(0:3)
      double complex jj(0:3),dv,w32,w13
      double precision p1(0:3),p2(0:3),p3(0:3),q(0:3),g,dg2,q2

      double precision rZero, rOne
      parameter( rZero = 0.0d0, rOne = 1.0d0 )

c

      jw3w(5) = w1(5)+w2(5)+w3(5)
      jw3w(6) = w1(6)+w2(6)+w3(6)


      dw1(0) = dcmplx(w1(1))
      dw1(1) = dcmplx(w1(2))
      dw1(2) = dcmplx(w1(3))
      dw1(3) = dcmplx(w1(4))
      dw2(0) = dcmplx(w2(1))
      dw2(1) = dcmplx(w2(2))
      dw2(2) = dcmplx(w2(3))
      dw2(3) = dcmplx(w2(4))
      dw3(0) = dcmplx(w3(1))
      dw3(1) = dcmplx(w3(2))
      dw3(2) = dcmplx(w3(3))
      dw3(3) = dcmplx(w3(4))
      p1(0) = dble(      w1(5))
      p1(1) = dble(      w1(6))
      p1(2) = dble(dimag(w1(6)))
      p1(3) = dble(dimag(w1(5)))
      p2(0) = dble(      w2(5))
      p2(1) = dble(      w2(6))
      p2(2) = dble(dimag(w2(6)))
      p2(3) = dble(dimag(w2(5)))
      p3(0) = dble(      w3(5))
      p3(1) = dble(      w3(6))
      p3(2) = dble(dimag(w3(6)))
      p3(3) = dble(dimag(w3(5)))
      q(0) = -(p1(0)+p2(0)+p3(0))
      q(1) = -(p1(1)+p2(1)+p3(1))
      q(2) = -(p1(2)+p2(2)+p3(2))
      q(3) = -(p1(3)+p2(3)+p3(3))

      q2 = q(0)**2 -(q(1)**2 +q(2)**2 +q(3)**2)

      dg2 = dble(g)*dble(g)

      dv = rOne/dcmplx( q2 )

      w32 = dw3(0)*dw2(0)-dw3(1)*dw2(1)-dw3(2)*dw2(2)-dw3(3)*dw2(3)

      w13 = dw1(0)*dw3(0)-dw1(1)*dw3(1)-dw1(2)*dw3(2)-dw1(3)*dw3(3)

      jj(0) = dg2*( dw1(0)*w32 - dw2(0)*w13 )
      jj(1) = dg2*( dw1(1)*w32 - dw2(1)*w13 )
      jj(2) = dg2*( dw1(2)*w32 - dw2(2)*w13 )
      jj(3) = dg2*( dw1(3)*w32 - dw2(3)*w13 )

      jw3w(1) = dcmplx( jj(0)*dv )
      jw3w(2) = dcmplx( jj(1)*dv )
      jw3w(3) = dcmplx( jj(2)*dv )
      jw3w(4) = dcmplx( jj(3)*dv )
c
      return
      end
      subroutine jggxxx(v1,v2,g, jvv)
c
c This subroutine computes an off-shell vector current from the three-
c point gauge boson coupling.  The vector propagator is given in Feynman
c gauge for a massless vector and in unitary gauge for a massive vector.
c
c input:
c       complex v1(6)          : first  vector                        v1
c       complex v2(6)          : second vector                        v2
c       real    g              : coupling constant (see the table below)
c
c output:
c       complex jvv(6)         : vector current            j^mu(v:v1,v2)
c
      implicit none
      double complex v1(6),v2(6),jvv(6),j12(0:3)
      double complex sv1,sv2,v12
      double precision p1(0:3),p2(0:3),q(0:3),g,gs,s

c

      jvv(5) = v1(5) + v2(5)
      jvv(6) = v1(6) + v2(6)

      p1(0) = dble( v1(5))
      p1(1) = dble( v1(6))
      p1(2) = dimag(v1(6))
      p1(3) = dimag(v1(5))
      p2(0) = dble( v2(5))
      p2(1) = dble( v2(6))
      p2(2) = dimag(v2(6))
      p2(3) = dimag(v2(5))
      q(0) = -dble( jvv(5))
      q(1) = -dble( jvv(6))
      q(2) = -dimag(jvv(6))
      q(3) = -dimag(jvv(5))
      s = q(0)**2-(q(1)**2+q(2)**2+q(3)**2)

      v12 = v1(1)*v2(1)-v1(2)*v2(2)-v1(3)*v2(3)-v1(4)*v2(4)
      sv1 =   (p2(0)-q(0))*v1(1) -(p2(1)-q(1))*v1(2)
     &      - (p2(2)-q(2))*v1(3) -(p2(3)-q(3))*v1(4)
      sv2 = - (p1(0)-q(0))*v2(1) +(p1(1)-q(1))*v2(2)
     &      + (p1(2)-q(2))*v2(3) +(p1(3)-q(3))*v2(4)
      j12(0) = (p1(0)-p2(0))*v12 +sv1*v2(1) +sv2*v1(1)
      j12(1) = (p1(1)-p2(1))*v12 +sv1*v2(2) +sv2*v1(2)
      j12(2) = (p1(2)-p2(2))*v12 +sv1*v2(3) +sv2*v1(3)
      j12(3) = (p1(3)-p2(3))*v12 +sv1*v2(4) +sv2*v1(4)

      gs = -g/s

      jvv(1) = gs*j12(0)
      jvv(2) = gs*j12(1)
      jvv(3) = gs*j12(2)
      jvv(4) = gs*j12(3)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine jiocxx(fic,foc,gc,vmass,vwidth , jioc)
c
c This subroutine computes an off-shell vector current from an external 
c antifermion pair. The vector boson propagator is given in Feynman     
c gauge for a massless vector and in unitary gauge for a massive vector.
c                                                                       
c input:                                                                
c       complex fic(6)         : flow-in  antifermion              |fic>
c       complex foc(6)         : flow-out antifermion              <foc|
c       complex gc(2)          : coupling constants                  gvf
c       real    vmass          : mass  of output vector v               
c       real    vwidth         : width of output vector v               
c                                                                       
c output:                                                               
c       complex jioc(6)        : vector current        j^mu(<foc|v|fic>)
c
      implicit none
      double complex fic(6),foc(6),gc(2),jioc(6),c0,c1,c2,c3,cs,d
      double precision q(0:3),vmass,vwidth,q2,vm2,dd

      double precision rZero, rOne
      parameter( rZero = 0.0d0, rOne = 1.0d0 )
      double complex cImag, cZero
      parameter( cImag = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )
c
      jioc(5) = foc(5)-fic(5)
      jioc(6) = foc(6)-fic(6)

      q(0) = dble( jioc(5))
      q(1) = dble( jioc(6))
      q(2) = dimag(jioc(6))
      q(3) = dimag(jioc(5))
      q2 = q(0)**2-(q(1)**2+q(2)**2+q(3)**2)
      vm2 = vmass**2

      if ( vmass.ne.rZero ) then

         d = -rOne/dcmplx( q2-vm2, vmass*vwidth )
c  for the running width, use below instead of the above d.
c         d = -rOne/dcmplx( q2-vm2, max(vwidth*q2/vmass,rZero) )

         if ( gc(2).ne.cZero ) then
            c0=  gc(2)*( foc(3)*fic(1)+foc(4)*fic(2))
     &          +gc(1)*( foc(1)*fic(3)+foc(2)*fic(4))
            c1= -gc(2)*( foc(3)*fic(2)+foc(4)*fic(1))
     &          +gc(1)*( foc(1)*fic(4)+foc(2)*fic(3))
            c2=( gc(2)*( foc(3)*fic(2)-foc(4)*fic(1)) 
     &          +gc(1)*(-foc(1)*fic(4)+foc(2)*fic(3)))*cImag
            c3=  gc(2)*(-foc(3)*fic(1)+foc(4)*fic(2))
     &          +gc(1)*( foc(1)*fic(3)-foc(2)*fic(4))
         else
            d = d*gc(1)
            c0 =  foc(1)*fic(3)+foc(2)*fic(4)
            c1 =  foc(1)*fic(4)+foc(2)*fic(3)
            c2 =(-foc(1)*fic(4)+foc(2)*fic(3))*cImag
            c3 =  foc(1)*fic(3)-foc(2)*fic(4)
         end if
         cs = (q(0)*c0-q(1)*c1-q(2)*c2-q(3)*c3)/vm2
         jioc(1) = (c0-cs*q(0))*d
         jioc(2) = (c1-cs*q(1))*d
         jioc(3) = (c2-cs*q(2))*d
         jioc(4) = (c3-cs*q(3))*d

      else

         d = dcmplx( -rOne/q2, rZero )
         if ( gc(2).ne.cZero ) then
            jioc(1) = ( gc(2)*( foc(3)*fic(1)+foc(4)*fic(2))
     &                 +gc(1)*( foc(1)*fic(3)+foc(2)*fic(4)) )*d
            jioc(2) = (-gc(2)*( foc(3)*fic(2)+foc(4)*fic(1))
     &                 +gc(1)*( foc(1)*fic(4)+foc(2)*fic(3)) )*d
            jioc(3) = ( gc(2)*( foc(3)*fic(2)-foc(4)*fic(1))
     &                 +gc(1)*(-foc(1)*fic(4)+foc(2)*fic(3)) )
     &                *d*cImag
            jioc(4) = ( gc(2)*(-foc(3)*fic(1)+foc(4)*fic(2))
     &                 +gc(1)*( foc(1)*fic(3)-foc(2)*fic(4)) )*d
         else
            d = d*gc(1)
            jioc(1) = ( foc(1)*fic(3)+foc(2)*fic(4))*d
            jioc(2) = ( foc(1)*fic(4)+foc(2)*fic(3))*d
            jioc(3) = (-foc(1)*fic(4)+foc(2)*fic(3))*d*cImag
            jioc(4) = ( foc(1)*fic(3)-foc(2)*fic(4))*d
         end if

      end if
c
      return
      end
      subroutine jiodmx(fi,fo,gc,vmass,vwidth , jio)
c
c This subroutine computes an off-shell vector dipole moment
c (non-renormalizable) current from an external
c fermion pair.  The vector boson propagator is given in Feynman gauge
c for a massless vector and in unitary gauge for a massive vector.
c
c input:
c       complex fi(6)          : flow-in  fermion                   |fi>
c       complex fo(6)          : flow-out fermion                   <fo|
c       complex gc(2,2)        : coupling constants                 gvf
c                              : first index is L,R as normal
c                              : second index is EDM,-MDM
c       real    vmass          : mass  of output vector v
c       real    vwidth         : width of output vector v
c
c output:
c       complex jio(6)         : vector current          j^mu(<fo|v|fi>)
c
      implicit none
      double complex fi(6), fo(6), jio(6), c0, c1, c2, c3, d
      double complex gc(2,2), gL, gR
      double precision  q(0:3), vmass, vwidth, q2, vm2, dd

      double complex f1122, f12, f21, f12p21, f12m21
      double complex f3344, f34, f43, f34p43, f34m43
      double complex dumL1, dumL2, dumL3, dumL4
      double complex dumR1, dumR2, dumR3, dumR4
      double precision rZero, rOne
      parameter( rZero = 0.0d0, rOne = 1.0d0 )
      double complex cImag, cZero
      parameter( cImag = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )

c

      gL = -gc(1,1) + cImag*gc(1,2)
      gR =  gc(2,1) + cImag*gc(2,2)

      jio(5) = fo(5) - fi(5)
      jio(6) = fo(6) - fi(6)

      q(0) = dble( jio(5))
      q(1) = dble( jio(6))
      q(2) = dimag(jio(6))
      q(3) = dimag(jio(5))
      q2 = q(0)**2-(q(1)**2+q(2)**2+q(3)**2)
      vm2 = vmass**2


      f1122  = fo(1)*fi(1) - fo(2)*fi(2)
      f12    = fo(1)*fi(2)
      f21    = fo(2)*fi(1)
      f12p21 = f12 + f21
      f12m21 = f12 - f21
      if ( gc(2,1).ne.cZero .or. gc(2,2).ne.cZero ) then
         f3344  = fo(3)*fi(3) - fo(4)*fi(4)
         f34    = fo(3)*fi(4)
         f43    = fo(4)*fi(3)
         f34p43 = f34 + f43
         f34m43 = f34 - f43
      end if

c note overall (-), since k in vertex is -q above
      dumL1 = -q(2)*f12m21 - cImag*( q(1)*f12p21 + q(3)*f1122 )
      dumL2 =  q(2)*f1122  - cImag*( q(0)*f12p21 - q(3)*f12m21 )
      dumL3 = -q(0)*f12m21 - q(1)*f1122 - q(3)*f12p21
      dumL4 = -q(2)*f12p21 - cImag*( q(0)*f1122  + q(1)*f12m21 )
      if ( gc(2,1).ne.cZero .or. gc(2,2).ne.cZero ) then
         dumR1 =  q(2)*f34m43 + cImag*( q(1)*f34p43 + q(3)*f3344 )
         dumR2 =  q(2)*f3344  + cImag*( q(0)*f34p43 + q(3)*f34m43 )
         dumR3 =  q(0)*f34m43 - q(1)*f3344 - q(3)*f34p43
         dumR4 = -q(2)*f34p43 + cImag*( q(0)*f3344  - q(1)*f34m43 )
      end if

      if ( vmass.ne.rZero ) then

         d = rOne/dcmplx( q2-vm2, vmass*vwidth )

         c0 = gL*dumL1
         c1 = gL*dumL2
         c2 = gL*dumL3
         c3 = gL*dumL4

         if ( gc(2,1).ne.cZero .or.
     &        gc(2,2).ne.cZero      ) then
            c0 = c0 + gR*dumR1
            c1 = c1 + gR*dumR2
            c2 = c2 + gR*dumR3
            c3 = c3 + gR*dumR4
         end if

         jio(1) = c0*d
         jio(2) = c1*d
         jio(3) = c2*d
         jio(4) = c3*d

      else

         dd = rOne/q2

         jio(1) = gL*dumL1
         jio(2) = gL*dumL2
         jio(3) = gL*dumL3
         jio(4) = gL*dumL4

         if ( gc(2,1).ne.cZero .or.
     &        gc(2,2).ne.cZero      ) then
            jio(1) = jio(1) + gR*dumR1
            jio(2) = jio(2) + gR*dumR2
            jio(3) = jio(3) + gR*dumR3
            jio(4) = jio(4) + gR*dumR4
         end if

         jio(1) = jio(1)*dd
         jio(2) = jio(2)*dd
         jio(3) = jio(3)*dd
         jio(4) = jio(4)*dd

      end if
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine jiogld(fi,fo,gc,vmass,vwidth,idecay , jio)
c
c This subroutine computes an off-shell vector current for the NLSP-
c Goldstino vertex from an external fermion pair. The vector boson 
c propagator is given in feynman gauge for a massless vector and in 
c unitary gauge for a massive vector. The h.c. of the NLSP decay is
c handled via the input parameter idecay (picks out correct
c Goldstino momentum).
c
c input:
c       complex fi(6)          : flow-in  fermion                   |fi>
c       complex fo(6)          : flow-out fermion                   <fo|
c       complex gc(2)          : coupling constants                  gvf
c       real    vmass          : mass  of output vector v
c       real    vwidth         : width of output vector v
c       integer idecay         :  1 for NLSP decay to Goldstino
c                              : -1 for Goldstino to NLSP (h.c. of above)
c
c output:
c       complex jio(6)         : vector current          j^mu(<fo|v|fi>)
c
      implicit none
      double complex  fi(6), fo(6), gc(2), jio(6), c0, c1, c2, c3, cs
      double complex  d, dum, p14p, p14m, p23p, p23m
      double precision  q(0:3), vmass, vwidth, q2, vm2, dd
      double precision  pG(1:4), pdotpG
      integer idecay

      double precision rZero, rOne
      parameter( rZero = 0.0d0, rOne = 1.0d0 )
      double complex ci, cZero
      parameter( ci = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )
c
      if ( idecay.eq.1 ) then
         pG(1) =  dble(fo(5))
         pG(2) =  dble(fo(6))
         pG(3) = dimag(fo(6))
         pG(4) = dimag(fo(5))
      else if ( idecay.eq.-1 ) then
         pG(1) =  dble(fi(5))
         pG(2) =  dble(fi(6))
         pG(3) = dimag(fi(6))
         pG(4) = dimag(fi(5))
      else
         write(6,*) 'error in idecay of JIOGLD'
         stop
      end if

      jio(5) = fo(5) - fi(5)
      jio(6) = fo(6) - fi(6)

      q(0) = dble( jio(5))
      q(1) = dble( jio(6))
      q(2) = dimag(jio(6))
      q(3) = dimag(jio(5))
      q2  = q(0)**2 - q(1)**2 - q(2)**2 - q(3)**2
      vm2 = vmass**2

      pdotpG = q(0)*pG(1) - q(1)*pG(2) - q(2)*pG(3) - q(3)*pG(4)

      p14p = q(0) + q(3)
      p14m = q(0) - q(3)
      p23p = jio(6)
      p23m = dconjg(jio(6))

      if ( vmass.ne.rZero ) then

         d = rOne/dcmplx( q2-vm2, vmass*vwidth )
         d = d*idecay
c  for the running width, use below instead of the above d.
c         d = rOne/dcmplx( q2-vm2, max(vwidth*q2/vmass,rZero) )

         if ( gc(2).ne.cZero ) then
            dum =  ( (fo(3)*p14p + fo(4)*p23p)*fi(1)
     &              +(fo(3)*p23m + fo(4)*p14m)*fi(2) )*gc(1)
     &           + ( (fo(1)*p14m - fo(2)*p23p)*fi(3)
     &              -(fo(1)*p23m - fo(2)*p14p)*fi(4) )*gc(2)

            c0 =  dum*pG(1)
     &           -pdotpG*( gc(1)*( fo(3)*fi(1) + fo(4)*fi(2) )
     &                    +gc(2)*( fo(1)*fi(3) + fo(2)*fi(4) ) )
            c1 =  dum*pG(2)
     &           -pdotpG*(-gc(1)*( fo(4)*fi(1) + fo(3)*fi(2) )
     &                    +gc(2)*( fo(2)*fi(3) + fo(1)*fi(4) ) )
            c2 =  dum*pG(3)
     &           -pdotpG*( gc(1)*(-fo(4)*fi(1) + fo(3)*fi(2) )
     &                    +gc(2)*( fo(2)*fi(3) - fo(1)*fi(4) ) )*ci
            c3 =  dum*pG(4)
     &           -pdotpG*( gc(1)*(-fo(3)*fi(1) + fo(4)*fi(2) )
     &                    +gc(2)*( fo(1)*fi(3) - fo(2)*fi(4) ) )
         else
            d = d*gc(1)
            dum =  (fo(3)*p14p + fo(4)*p23p)*fi(1)
     &            +(fo(3)*p23m + fo(4)*p14m)*fi(2)

            c0 = dum*pG(1) - ( fo(3)*fi(1) + fo(4)*fi(2) )*pdotpG
            c1 = dum*pG(2) + ( fo(4)*fi(1) + fo(3)*fi(2) )*pdotpG
            c2 = dum*pG(3) + ( fo(4)*fi(1) - fo(3)*fi(2) )*pdotpG*ci
            c3 = dum*pG(4) + ( fo(3)*fi(1) - fo(4)*fi(2) )*pdotpG
         end if

         cs = (q(0)*c0 - q(1)*c1 - q(2)*c2 - q(3)*c3) / vm2

         jio(1) = (c0-cs*q(0))*d
         jio(2) = (c1-cs*q(1))*d
         jio(3) = (c2-cs*q(2))*d
         jio(4) = (c3-cs*q(3))*d

      else
         dd = idecay*rOne/q2

         if ( gc(2).ne.cZero ) then
            dum =  ( (fo(3)*p14p + fo(4)*p23p)*fi(1)
     &              +(fo(3)*p23m + fo(4)*p14m)*fi(2) )*gc(1)
     &           + ( (fo(1)*p14m - fo(2)*p23p)*fi(3)
     &              -(fo(1)*p23m - fo(2)*p14p)*fi(4) )*gc(2)

            jio(1) = ( dum*pG(1) - pdotpG*(
     &                 gc(1)*( fo(3)*fi(1) + fo(4)*fi(2) )
     &                +gc(2)*( fo(1)*fi(3) + fo(2)*fi(4) ) ) )*dd
            jio(2) = ( dum*pG(2) - pdotpG*(
     &                -gc(1)*( fo(4)*fi(1) + fo(3)*fi(2) )
     &                +gc(2)*( fo(2)*fi(3) + fo(1)*fi(4) ) ) )*dd
            jio(3) = ( dum*pG(3) - pdotpG*ci*(
     &                 gc(1)*(-fo(4)*fi(1) + fo(3)*fi(2) )
     &                +gc(2)*( fo(2)*fi(3) - fo(1)*fi(4) ) ) )*dd
            jio(4) = ( dum*pG(4) - pdotpG*(
     &                 gc(1)*(-fo(3)*fi(1) + fo(4)*fi(2) )
     &                +gc(2)*( fo(1)*fi(3) - fo(2)*fi(4) ) ) )*dd

         else
            dd = dd*gc(1)
            dum =  (fo(3)*p14p + fo(4)*p23p)*fi(1)
     &            +(fo(3)*p23m + fo(4)*p14m)*fi(2)

            jio(1)=dd*(dum*pG(1) - pdotpG*(fo(3)*fi(1) + fo(4)*fi(2)))
            jio(2)=dd*(dum*pG(2) + pdotpG*(fo(4)*fi(1) + fo(3)*fi(2)))
            jio(3)=dd*(dum*pG(3) + ci*pdotpG*(fo(4)*fi(1)-fo(3)*fi(2)))
            jio(4)=dd*(dum*pG(4) + pdotpG*(fo(3)*fi(1) - fo(4)*fi(2)))
         end if
      end if
c
      return
      end
      subroutine jioxxx(fi,fo,gc,vmass,vwidth , jio)
c
c This subroutine computes an off-shell vector current from an external
c fermion pair.  The vector boson propagator is given in Feynman gauge
c for a massless vector and in unitary gauge for a massive vector.
c
c input:
c       complex fi(6)          : flow-in  fermion                   |fi>
c       complex fo(6)          : flow-out fermion                   <fo|
c       complex gc(2)          : coupling constants                  gvf
c       real    vmass          : mass  of OUTPUT vector v
c       real    vwidth         : width of OUTPUT vector v
c
c output:
c       complex jio(6)         : vector current          j^mu(<fo|v|fi>)
c     
      implicit none
      double complex fi(6),fo(6),gc(2),jio(6),c0,c1,c2,c3,cs,d
      double precision q(0:3),vmass,vwidth,q2,vm2
      double complex cm2 ! mass**2- I Gamma mass (Fabio)


      double precision rZero, rOne
      parameter( rZero = 0.0d0, rOne = 1.0d0 )
      double complex cImag, cZero
      parameter( cImag = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )

c

      jio(5) = fo(5)-fi(5)
      jio(6) = fo(6)-fi(6)

      q(0) = dble( jio(5))
      q(1) = dble( jio(6))
      q(2) = dimag(jio(6))
      q(3) = dimag(jio(5))
      q2 = q(0)**2-(q(1)**2+q(2)**2+q(3)**2)
      vm2 = vmass**2


      if ( vmass.ne.rZero ) then

         d = rOne/dcmplx( q2-vm2, vmass*vwidth )
c     For the running width, use below instead of the above d.
c     d = rOne/dcmplx( q2-vm2, max(vwidth*q2/vmass,rZero) )


         if ( gc(2).ne.cZero ) then
            c0 =  gc(1)*( fo(3)*fi(1)+fo(4)*fi(2))
     &           +gc(2)*( fo(1)*fi(3)+fo(2)*fi(4))
            c1 = -gc(1)*( fo(3)*fi(2)+fo(4)*fi(1))
     &           +gc(2)*( fo(1)*fi(4)+fo(2)*fi(3))
            c2 =( gc(1)*( fo(3)*fi(2)-fo(4)*fi(1))
     &           +gc(2)*(-fo(1)*fi(4)+fo(2)*fi(3)))*cImag
            c3 =  gc(1)*(-fo(3)*fi(1)+fo(4)*fi(2))
     &           +gc(2)*( fo(1)*fi(3)-fo(2)*fi(4))
         else
            d = d*gc(1)
            c0 =   fo(3)*fi(1)+fo(4)*fi(2)
            c1 =  -fo(3)*fi(2)-fo(4)*fi(1)
            c2 = ( fo(3)*fi(2)-fo(4)*fi(1))*cImag
            c3 =  -fo(3)*fi(1)+fo(4)*fi(2)
         end if

c     Fabio's implementation of the fixed width
         cm2=dcmplx( vm2, -vmass*vwidth )
c     cs = (q(0)*c0-q(1)*c1-q(2)*c2-q(3)*c3)/vm2
         cs = (q(0)*c0-q(1)*c1-q(2)*c2-q(3)*c3)/cm2
         jio(1) = (c0-cs*q(0))*d
         jio(2) = (c1-cs*q(1))*d
         jio(3) = (c2-cs*q(2))*d
         jio(4) = (c3-cs*q(3))*d

      else

         d = dcmplx( rOne/q2, rZero )
         if ( gc(2).ne.cZero ) then
            jio(1) = ( gc(1)*( fo(3)*fi(1)+fo(4)*fi(2))
     &                +gc(2)*( fo(1)*fi(3)+fo(2)*fi(4)) )*d
            jio(2) = (-gc(1)*( fo(3)*fi(2)+fo(4)*fi(1))
     &                +gc(2)*( fo(1)*fi(4)+fo(2)*fi(3)) )*d
            jio(3) = ( gc(1)*( fo(3)*fi(2)-fo(4)*fi(1))
     &                +gc(2)*(-fo(1)*fi(4)+fo(2)*fi(3)))
     &               *d*cImag
            jio(4) = ( gc(1)*(-fo(3)*fi(1)+fo(4)*fi(2))
     &                +gc(2)*( fo(1)*fi(3)-fo(2)*fi(4)) )*d
         else
            d = d*gc(1)
            jio(1) =  ( fo(3)*fi(1)+fo(4)*fi(2))*d
            jio(2) = -( fo(3)*fi(2)+fo(4)*fi(1))*d
            jio(3) =  ( fo(3)*fi(2)-fo(4)*fi(1))*d*cImag
            jio(4) =  (-fo(3)*fi(1)+fo(4)*fi(2))*d
         end if

      end if
c
      return
      end
      subroutine jssxxx(s1,s2,gc,vmass,vwidth , jss)
c
c This subroutine computes an off-shell vector current from the vector-
c scalar-scalar coupling.  The coupling is absent in the minimal SM in
c unitary gauge.  The propagator is given in Feynman gauge for a
c massless vector and in unitary gauge for a massive vector.
c
c input:
c       complex s1(3)          : first  scalar                        s1
c       complex s2(3)          : second scalar                        s2
c       complex gc             : coupling constant (s1 charge)
c       real    vmass          : mass  of output vector v
c       real    vwidth         : width of output vector v
c
c examples of the coupling constant g for susy particles are as follows:
c   -----------------------------------------------------------
c   |    s1    | (q,i3) of s1  ||   v=A   |   v=Z   |   v=W   |
c   -----------------------------------------------------------
c   | nu~_l    | (  0  , +1/2) ||   ---   |  gzn(1) |  gwf(1) |
c   | e~_l     | ( -1  , -1/2) ||  gal(1) |  gzl(1) |  gwf(1) |
c   | u~_l     | (+2/3 , +1/2) ||  gau(1) |  gzu(1) |  gwf(1) |
c   | d~_l     | (-1/3 , -1/2) ||  gad(1) |  gzd(1) |  gwf(1) |
c   -----------------------------------------------------------
c   | e~_r-bar | ( +1  ,  0  ) || -gal(2) | -gzl(2) | -gwf(2) |
c   | u~_r-bar | (-2/3 ,  0  ) || -gau(2) | -gzu(2) | -gwf(2) |
c   | d~_r-bar | (+1/3 ,  0  ) || -gad(2) | -gzd(2) | -gwf(2) |
c   -----------------------------------------------------------
c where the s1 charge is defined by the flowing-OUT quantum number.
c
c output:
c       complex jss(6)         : vector current            j^mu(v:s1,s2)
c     
      implicit none
      double complex s1(3),s2(3),gc,jss(6),dg,adg
      double complex cm2        ! mass**2- I Gamma mass (Fabio)
      double precision pp(0:3),pa(0:3),q(0:3),vmass,vwidth
      double precision q2,vm2,mp2,ma2,m2d

      double precision rZero
      parameter( rZero = 0.0d0 )

c

      jss(5) = s1(2)+s2(2)
      jss(6) = s1(3)+s2(3)

      q(0) = dble( jss(5))
      q(1) = dble( jss(6))
      q(2) = dimag(jss(6))
      q(3) = dimag(jss(5))
      q2 = q(0)**2-(q(1)**2+q(2)**2+q(3)**2)
      vm2 = vmass**2


      if ( vmass.ne.rZero ) then

         dg = gc/dcmplx( q2-vm2, vmass*vwidth )
c  For the running width, use below instead of the above dg.
c         dg = g/dcmplx( q2-vm2, max(vwidth*q2/vmass,rZero) )


         adg = dg*s1(1)*s2(1)

         pp(0) = dble( s1(2))
         pp(1) = dble( s1(3))
         pp(2) = dimag(s1(3))
         pp(3) = dimag(s1(2))
         pa(0) = dble( s2(2))
         pa(1) = dble( s2(3))
         pa(2) = dimag(s2(3))
         pa(3) = dimag(s2(2))
         mp2 = pp(0)**2-(pp(1)**2+pp(2)**2+pp(3)**2)
         ma2 = pa(0)**2-(pa(1)**2+pa(2)**2+pa(3)**2)
         m2d = mp2-ma2

c     Fabio's implementation of the fixed width
         cm2=dcmplx( vm2, -vmass*vwidth )
c     jss(1) = adg*( (pp(0)-pa(0)) - q(0)*m2d/vm2)
c     jss(2) = adg*( (pp(1)-pa(1)) - q(1)*m2d/vm2)
c     jss(3) = adg*( (pp(2)-pa(2)) - q(2)*m2d/vm2)
c     jss(4) = adg*( (pp(3)-pa(3)) - q(3)*m2d/vm2)
         jss(1) = adg*( (pp(0)-pa(0)) - q(0)*m2d/cm2)
         jss(2) = adg*( (pp(1)-pa(1)) - q(1)*m2d/cm2)
         jss(3) = adg*( (pp(2)-pa(2)) - q(2)*m2d/cm2)
         jss(4) = adg*( (pp(3)-pa(3)) - q(3)*m2d/cm2)

      else

         adg = gc*s1(1)*s2(1)/q2

         jss(1) = adg*dble( s1(2)-s2(2))
         jss(2) = adg*dble( s1(3)-s2(3))
         jss(3) = adg*dimag(s1(3)-s2(3))
         jss(4) = adg*dimag(s1(2)-s2(2))

      endif
c
      return
      end
      subroutine jvssxx(vc,s1,s2,gc,vmass,vwidth , jvss)
c
c This subroutine computes an off-shell vector current from the vector-
c vector-scalar-scalar coupling.  The vector propagator is given in
c Feynman gauge for a massless vector and in unitary gauge for a massive
c vector.
c
c input:
c       complex vc(6)          : input  vector                        v
c       complex s1(3)          : first  scalar                        s1
c       complex s2(3)          : second scalar                        s2
c       complex gc             : coupling constant                 gvvhh
c       real    vmass          : mass  of output vector v'
c       real    vwidth         : width of output vector v'
c
c output:
c       complex jvss(6)        : vector current         j^mu(v':v,s1,s2)
c     
      implicit none
      double complex vc(6),s1(3),s2(3),gc,jvss(6),dg
      double complex cm2        ! mass**2- I Gamma mass (Fabio)
      double precision q(0:3),vmass,vwidth,q2,vk,vm2

      double precision rZero
      parameter( rZero = 0.0d0 )

c

      jvss(5) = vc(5)+s1(2)+s2(2)
      jvss(6) = vc(6)+s1(3)+s2(3)

      q(0) = dble( jvss(5))
      q(1) = dble( jvss(6))
      q(2) = dimag(jvss(6))
      q(3) = dimag(jvss(5))
      q2 = q(0)**2-(q(1)**2+q(2)**2+q(3)**2)
      vm2 = vmass**2


      if ( vmass.ne.rZero ) then

         dg = gc*s1(1)*s2(1)/dcmplx( q2-vm2, vmass*vwidth )
c  For the running width, use below instead of the above dg.
c         dg = gc*s1(1)*s2(1)/cmplx( q2-vm2 , max( vwidth*q2/vmass ,rZero))

c     Fabio's implementation of the fixed width
         cm2=dcmplx( vm2, -vmass*vwidth )
c     vk = (q(0)*vc(1)-q(1)*vc(2)-q(2)*vc(3)-q(3)*vc(4))/vm2
         vk = (q(0)*vc(1)-q(1)*vc(2)-q(2)*vc(3)-q(3)*vc(4))/cm2

         jvss(1) = dg*(vc(1)-vk*q(0))
         jvss(2) = dg*(vc(2)-vk*q(1))
         jvss(3) = dg*(vc(3)-vk*q(2))
         jvss(4) = dg*(vc(4)-vk*q(3))

      else

         dg = gc*s1(1)*s2(1)/q2

         jvss(1) = dg*vc(1)
         jvss(2) = dg*vc(2)
         jvss(3) = dg*vc(3)
         jvss(4) = dg*vc(4)

      endif
c
      return
      end
      subroutine jvsxxx(vc,sc,gc,vmass,vwidth , jvs)
c
c This subroutine computes an off-shell vector current from the vector-
c vector-scalar coupling.  The vector propagator is given in Feynman
c gauge for a massless vector and in unitary gauge for a massive vector.
c
c input:
c       complex vc(6)          : input vector                          v
c       complex sc(3)          : input scalar                          s
c       complex gc             : coupling constant                  gvvh
c       real    vmass          : mass  of output vector v'
c       real    vwidth         : width of output vector v'
c
c output:
c       complex jvs(6)         : vector current             j^mu(v':v,s)
c     
      implicit none
      double complex vc(6),sc(3),gc,jvs(6),dg,vk
      double complex cm2        ! mass**2- I Gamma mass (Fabio)
      double precision q(0:3),vmass,vwidth,q2,vm2

      double precision rZero
      parameter( rZero = 0.0d0 )

c

      jvs(5) = vc(5)+sc(2)
      jvs(6) = vc(6)+sc(3)

      q(0) = dble( jvs(5))
      q(1) = dble( jvs(6))
      q(2) = dimag(jvs(6))
      q(3) = dimag(jvs(5))
      q2 = q(0)**2-(q(1)**2+q(2)**2+q(3)**2)
      vm2 = vmass**2


      if ( vmass.ne.rZero ) then

         dg = gc*sc(1)/dcmplx( q2-vm2, vmass*vwidth )
c  For the running width, use below instead of the above dg.
c         dg = g*sc(1)/dcmplx( q2-vm2, max(vwidth*q2/vmass,rZero) )

c     Fabio's implementation of the fixed width
         cm2=dcmplx( vm2, -vmass*vwidth )
c     vk = (-q(0)*vc(1)+q(1)*vc(2)+q(2)*vc(3)+q(3)*vc(4))/vm2
         vk = (-q(0)*vc(1)+q(1)*vc(2)+q(2)*vc(3)+q(3)*vc(4))/cm2

         jvs(1) = dg*(q(0)*vk+vc(1))
         jvs(2) = dg*(q(1)*vk+vc(2))
         jvs(3) = dg*(q(2)*vk+vc(3))
         jvs(4) = dg*(q(3)*vk+vc(4))

      else

         dg=gc*sc(1)/q2

         jvs(1) = dg*vc(1)
         jvs(2) = dg*vc(2)
         jvs(3) = dg*vc(3)
         jvs(4) = dg*vc(4)

      endif
c
      return
      end
      subroutine jvvxxx(v1,v2,g,vmass,vwidth , jvv)
c
c This subroutine computes an off-shell vector current from the three-
c point gauge boson coupling.  The vector propagator is given in Feynman
c gauge for a massless vector and in unitary gauge for a massive vector.
c
c input:
c       complex v1(6)          : first  vector                        v1
c       complex v2(6)          : second vector                        v2
c       real    g              : coupling constant (see the table below)
c       real    vmass          : mass  of output vector v
c       real    vwidth         : width of output vector v
c
c the possible sets of the inputs are as follows:
c    ------------------------------------------------------------------
c    |   v1   |   v2   |  jvv   |      g       |   vmass  |  vwidth   |
c    ------------------------------------------------------------------
c    |   W-   |   W+   |  A/Z   |  gwwa/gwwz   | 0./zmass | 0./zwidth |
c    | W3/A/Z |   W-   |  W+    | gw/gwwa/gwwz |   wmass  |  wwidth   |
c    |   W+   | W3/A/Z |  W-    | gw/gwwa/gwwz |   wmass  |  wwidth   |
c    ------------------------------------------------------------------
c where all the bosons are defined by the flowing-OUT quantum number.
c
c output:
c       complex jvv(6)         : vector current            j^mu(v:v1,v2)
c     
      implicit none
      double complex v1(6),v2(6),jvv(6),j12(0:3),js,dg
      double complex sv1,sv2,s11,s12,s21,s22,v12
      double complex cm2        ! mass**2- I Gamma mass (Fabio)
      double precision p1(0:3),p2(0:3),q(0:3),g,vmass,vwidth,gs,s
      double precision vm2,m1,m2

      double precision rZero
      parameter( rZero = 0.0d0 )
 
c

      jvv(5) = v1(5)+v2(5)
      jvv(6) = v1(6)+v2(6)

      p1(0) =  dble( v1(5))
      p1(1) =  dble( v1(6))
      p1(2) =  dimag(v1(6))
      p1(3) =  dimag(v1(5))
      p2(0) =  dble( v2(5))
      p2(1) =  dble( v2(6))
      p2(2) =  dimag(v2(6))
      p2(3) =  dimag(v2(5))
      q(0)  = -dble( jvv(5))
      q(1)  = -dble( jvv(6))
      q(2)  = -dimag(jvv(6))
      q(3)  = -dimag(jvv(5))
      s = q(0)**2-(q(1)**2+q(2)**2+q(3)**2)
      vm2 = vmass**2


      v12 = v1(1)*v2(1)-v1(2)*v2(2)-v1(3)*v2(3)-v1(4)*v2(4)
      sv1 =   (p2(0)-q(0))*v1(1) -(p2(1)-q(1))*v1(2)
     &      - (p2(2)-q(2))*v1(3) -(p2(3)-q(3))*v1(4)
      sv2 = - (p1(0)-q(0))*v2(1) +(p1(1)-q(1))*v2(2)
     &      + (p1(2)-q(2))*v2(3) +(p1(3)-q(3))*v2(4)
      j12(0) = (p1(0)-p2(0))*v12 +sv1*v2(1) +sv2*v1(1)
      j12(1) = (p1(1)-p2(1))*v12 +sv1*v2(2) +sv2*v1(2)
      j12(2) = (p1(2)-p2(2))*v12 +sv1*v2(3) +sv2*v1(3)
      j12(3) = (p1(3)-p2(3))*v12 +sv1*v2(4) +sv2*v1(4)

      if ( vmass.ne.rZero ) then

         m1 = p1(0)**2-(p1(1)**2+p1(2)**2+p1(3)**2)
         m2 = p2(0)**2-(p2(1)**2+p2(2)**2+p2(3)**2)
         s11 = p1(0)*v1(1)-p1(1)*v1(2)-p1(2)*v1(3)-p1(3)*v1(4)
         s12 = p1(0)*v2(1)-p1(1)*v2(2)-p1(2)*v2(3)-p1(3)*v2(4)
         s21 = p2(0)*v1(1)-p2(1)*v1(2)-p2(2)*v1(3)-p2(3)*v1(4)
         s22 = p2(0)*v2(1)-p2(1)*v2(2)-p2(2)*v2(3)-p2(3)*v2(4)

c     Fabio's implementation of the fixed width
         cm2=dcmplx( vm2, -vmass*vwidth )
c     js = (v12*(-m1+m2) +s11*s12 -s21*s22)/vm2
         js = (v12*(-m1+m2) +s11*s12 -s21*s22)/cm2
        
         dg = -g/dcmplx( s-vm2, vmass*vwidth )

c  For the running width, use below instead of the above dg.
c         dg = -g/dcmplx( s-vm2, max(vwidth*s/vmass,rZero) )

         jvv(1) = dg*(j12(0)-q(0)*js)
         jvv(2) = dg*(j12(1)-q(1)*js)
         jvv(3) = dg*(j12(2)-q(2)*js)
         jvv(4) = dg*(j12(3)-q(3)*js)

      else

         gs = -g/s

         jvv(1) = gs*j12(0)
         jvv(2) = gs*j12(1)
         jvv(3) = gs*j12(2)
         jvv(4) = gs*j12(3)

      end if
c
      return
      end
      subroutine jw3wxx(w1,w2,w3,g1,g2,vmass,vwidth , jw3w)
c
c This subroutine computes an off-shell W+, W-, W3, Z or photon current
c from the four-point gauge boson coupling.  The vector propagator is
c given in Feynman gauge for a photon and in unitary gauge for W and
c Z bosons.  If one sets wmass=0.0, then the ggg-->g current is given
c (see sect 2.9.1 of the manual).
c
c input:
c       complex w1(6)          : first  vector                        w1
c       complex w2(6)          : second vector                        w2
c       complex w3(6)          : third  vector                        w3
c       real    g1             : first  coupling constant
c       real    g2             : second coupling constant
c                                                  (see the table below)
c       real    wmass          : mass  of internal W
c       real    wwidth         : width of internal W
c       real    vmass          : mass  of output W'
c       real    vwidth         : width of output W'
c
c the possible sets of the inputs are as follows:
c   -------------------------------------------------------------------
c   |  w1  |  w2  |  w3  | g1 | g2 |wmass|wwidth|vmass|vwidth || jw3w |
c   -------------------------------------------------------------------
c   |  W-  |  W3  |  W+  | gw |gwwz|wmass|wwidth|zmass|zwidth ||  Z   |
c   |  W-  |  W3  |  W+  | gw |gwwa|wmass|wwidth|  0. |  0.   ||  A   |
c   |  W-  |  Z   |  W+  |gwwz|gwwz|wmass|wwidth|zmass|zwidth ||  Z   |
c   |  W-  |  Z   |  W+  |gwwz|gwwa|wmass|wwidth|  0. |  0.   ||  A   |
c   |  W-  |  A   |  W+  |gwwa|gwwz|wmass|wwidth|zmass|zwidth ||  Z   |
c   |  W-  |  A   |  W+  |gwwa|gwwa|wmass|wwidth|  0. |  0.   ||  A   |
c   -------------------------------------------------------------------
c   |  W3  |  W-  |  W3  | gw | gw |wmass|wwidth|wmass|wwidth ||  W+  |
c   |  W3  |  W+  |  W3  | gw | gw |wmass|wwidth|wmass|wwidth ||  W-  |
c   |  W3  |  W-  |  Z   | gw |gwwz|wmass|wwidth|wmass|wwidth ||  W+  |
c   |  W3  |  W+  |  Z   | gw |gwwz|wmass|wwidth|wmass|wwidth ||  W-  |
c   |  W3  |  W-  |  A   | gw |gwwa|wmass|wwidth|wmass|wwidth ||  W+  |
c   |  W3  |  W+  |  A   | gw |gwwa|wmass|wwidth|wmass|wwidth ||  W-  |
c   |  Z   |  W-  |  Z   |gwwz|gwwz|wmass|wwidth|wmass|wwidth ||  W+  |
c   |  Z   |  W+  |  Z   |gwwz|gwwz|wmass|wwidth|wmass|wwidth ||  W-  |
c   |  Z   |  W-  |  A   |gwwz|gwwa|wmass|wwidth|wmass|wwidth ||  W+  |
c   |  Z   |  W+  |  A   |gwwz|gwwa|wmass|wwidth|wmass|wwidth ||  W-  |
c   |  A   |  W-  |  A   |gwwa|gwwa|wmass|wwidth|wmass|wwidth ||  W+  |
c   |  A   |  W+  |  A   |gwwa|gwwa|wmass|wwidth|wmass|wwidth ||  W-  |
c   -------------------------------------------------------------------
c where all the bosons are defined by the flowing-OUT quantum number.
c
c output:
c       complex jw3w(6)        : W current             j^mu(w':w1,w2,w3)
c     
      implicit none
      double complex w1(6),w2(6),w3(6),jw3w(6)
      double complex dw1(0:3),dw2(0:3),dw3(0:3)
      double complex jj(0:3),j4(0:3),dv,w12,w32,w13,jq
      double complex cm2        ! mass**2- I Gamma mass (Fabio)
      double precision g1,g2,vmass,vwidth
      double precision p1(0:3),p2(0:3),p3(0:3),q(0:3)
      double precision dg2,dmv,dwv,mv2,q2

      double precision rZero, rOne, rTwo
      parameter( rZero = 0.0d0, rOne = 1.0d0, rTwo = 2.0d0 )

c

      jw3w(5) = w1(5)+w2(5)+w3(5)
      jw3w(6) = w1(6)+w2(6)+w3(6)

      dw1(0) = dcmplx(w1(1))
      dw1(1) = dcmplx(w1(2))
      dw1(2) = dcmplx(w1(3))
      dw1(3) = dcmplx(w1(4))
      dw2(0) = dcmplx(w2(1))
      dw2(1) = dcmplx(w2(2))
      dw2(2) = dcmplx(w2(3))
      dw2(3) = dcmplx(w2(4))
      dw3(0) = dcmplx(w3(1))
      dw3(1) = dcmplx(w3(2))
      dw3(2) = dcmplx(w3(3))
      dw3(3) = dcmplx(w3(4))
      p1(0) = dble(      w1(5))
      p1(1) = dble(      w1(6))
      p1(2) = dble(dimag(w1(6)))
      p1(3) = dble(dimag(w1(5)))
      p2(0) = dble(      w2(5))
      p2(1) = dble(      w2(6))
      p2(2) = dble(dimag(w2(6)))
      p2(3) = dble(dimag(w2(5)))
      p3(0) = dble(      w3(5))
      p3(1) = dble(      w3(6))
      p3(2) = dble(dimag(w3(6)))
      p3(3) = dble(dimag(w3(5)))
      q(0) = -(p1(0)+p2(0)+p3(0))
      q(1) = -(p1(1)+p2(1)+p3(1))
      q(2) = -(p1(2)+p2(2)+p3(2))
      q(3) = -(p1(3)+p2(3)+p3(3))

      q2 = q(0)**2 -(q(1)**2 +q(2)**2 +q(3)**2)
      dg2 = dble(g1)*dble(g2)
      dmv = dble(vmass)
      dwv = dble(vwidth)
      mv2 = dmv**2


      if ( vmass.eq.rZero ) then
         dv = rOne/dcmplx( q2 )
      else
         dv = rOne/dcmplx( q2-mv2, dmv*dwv )
      endif

c  For the running width, use below instead of the above dv.
c      dv = rOne/dcmplx( q2-mv2 , max(dwv*q2/dmv,rZero) )

      w12=dw1(0)*dw2(0)-dw1(1)*dw2(1)-dw1(2)*dw2(2)-dw1(3)*dw2(3)
      w32=dw3(0)*dw2(0)-dw3(1)*dw2(1)-dw3(2)*dw2(2)-dw3(3)*dw2(3)

      w13=dw1(0)*dw3(0)-dw1(1)*dw3(1)-dw1(2)*dw3(2)-dw1(3)*dw3(3)
      
      j4(0) = dg2*( dw1(0)*w32 + dw3(0)*w12 - rTwo*dw2(0)*w13 )
      j4(1) = dg2*( dw1(1)*w32 + dw3(1)*w12 - rTwo*dw2(1)*w13 )
      j4(2) = dg2*( dw1(2)*w32 + dw3(2)*w12 - rTwo*dw2(2)*w13 )
      j4(3) = dg2*( dw1(3)*w32 + dw3(3)*w12 - rTwo*dw2(3)*w13 )

      jj(0) = j4(0)
      jj(1) = j4(1)
      jj(2) = j4(2)
      jj(3) = j4(3)

      if ( vmass.ne.rZero ) then

c     Fabio's implementation of the fixed width
         cm2=dcmplx( mv2, -dmv*dwv)
c     jq = (jj(0)*q(0)-jj(1)*q(1)-jj(2)*q(2)-jj(3)*q(3))/mv2
         jq = (jj(0)*q(0)-jj(1)*q(1)-jj(2)*q(2)-jj(3)*q(3))/cm2
         
         jw3w(1) = dcmplx( (jj(0)-jq*q(0))*dv )
         jw3w(2) = dcmplx( (jj(1)-jq*q(1))*dv )
         jw3w(3) = dcmplx( (jj(2)-jq*q(2))*dv )
         jw3w(4) = dcmplx( (jj(3)-jq*q(3))*dv )

      else

         jw3w(1) = dcmplx( jj(0)*dv )
         jw3w(2) = dcmplx( jj(1)*dv )
         jw3w(3) = dcmplx( jj(2)*dv )
         jw3w(4) = dcmplx( jj(3)*dv )
      end if
c
      return
      end
      subroutine jwwwxx(w1,w2,w3,gwwa,gwwz,wmass,wwidth , jwww)
c
c This subroutine computes an off-shell W+/W- current from the four-
c point gauge boson coupling.  The vector propagators for the output
c W and the internal Z bosons are given in unitary gauge, and that of
c the internal photon is given in Feynman gauge.
c
c input:
c       complex w1(6)          : first  vector                        w1
c       complex w2(6)          : second vector                        w2
c       complex w3(6)          : third  vector                        w3
c       real    gwwa           : coupling constant of W and A       gwwa
c       real    gwwz           : coupling constant of W and Z       gwwz
c       real    zmass          : mass  of internal Z
c       real    zwidth         : width of internal Z
c       real    wmass          : mass  of output W
c       real    wwidth         : width of output W
c
c the possible sets of the inputs are as follows:
c   -------------------------------------------------------------------
c   |  w1  |  w2  |  w3  |gwwa|gwwz|zmass|zwidth|wmass|wwidth || jwww |
c   -------------------------------------------------------------------
c   |  W-  |  W+  |  W-  |gwwa|gwwz|zmass|zwidth|wmass|wwidth ||  W+  |
c   |  W+  |  W-  |  W+  |gwwa|gwwz|zmass|zwidth|wmass|wwidth ||  W-  |
c   -------------------------------------------------------------------
c where all the bosons are defined by the flowing-OUT quantum number.
c
c output:
c       complex jwww(6)        : W current             j^mu(w':w1,w2,w3)
c     
      implicit none
      double complex w1(6),w2(6),w3(6),jwww(6)
      double complex dw1(0:3),dw2(0:3),dw3(0:3),jj(0:3)
      double complex dw,w12,w32,w13,jq
      double complex cm2        ! mass**2- I Gamma mass (Fabio)
      double precision gwwa,gwwz,wmass,wwidth
      double precision p1(0:3),p2(0:3),p3(0:3),q(0:3)
      double precision dgwwa2,dgwwz2,dgw2,dmw,dww,mw2,q2

      double precision rZero, rOne, rTwo
      parameter( rZero = 0.0d0, rOne = 1.0d0, rTwo = 2.0d0 )

c

      jwww(5) = w1(5)+w2(5)+w3(5)
      jwww(6) = w1(6)+w2(6)+w3(6)

      dw1(0) = dcmplx(w1(1))
      dw1(1) = dcmplx(w1(2))
      dw1(2) = dcmplx(w1(3))
      dw1(3) = dcmplx(w1(4))
      dw2(0) = dcmplx(w2(1))
      dw2(1) = dcmplx(w2(2))
      dw2(2) = dcmplx(w2(3))
      dw2(3) = dcmplx(w2(4))
      dw3(0) = dcmplx(w3(1))
      dw3(1) = dcmplx(w3(2))
      dw3(2) = dcmplx(w3(3))
      dw3(3) = dcmplx(w3(4))
      p1(0) = dble(      w1(5))
      p1(1) = dble(      w1(6))
      p1(2) = dble(dimag(w1(6)))
      p1(3) = dble(dimag(w1(5)))
      p2(0) = dble(      w2(5))
      p2(1) = dble(      w2(6))
      p2(2) = dble(dimag(w2(6)))
      p2(3) = dble(dimag(w2(5)))
      p3(0) = dble(      w3(5))
      p3(1) = dble(      w3(6))
      p3(2) = dble(dimag(w3(6)))
      p3(3) = dble(dimag(w3(5)))
      q(0) = -(p1(0)+p2(0)+p3(0))
      q(1) = -(p1(1)+p2(1)+p3(1))
      q(2) = -(p1(2)+p2(2)+p3(2))
      q(3) = -(p1(3)+p2(3)+p3(3))
      q2 = q(0)**2 -(q(1)**2 +q(2)**2 +q(3)**2)
      dgwwa2 = dble(gwwa)**2
      dgwwz2 = dble(gwwz)**2
      dgw2 = dgwwa2+dgwwz2
      dmw = dble(wmass)
      dww = dble(wwidth)
      mw2 = dmw**2


      dw = -rOne/dcmplx( q2-mw2, dmw*dww )
c  For the running width, use below instead of the above dw.
c      dw = -rOne/dcmplx( q2-mw2 , max(dww*q2/dmw,rZero) )

      w12=dw1(0)*dw2(0)-dw1(1)*dw2(1)-dw1(2)*dw2(2)-dw1(3)*dw2(3)
      w32=dw3(0)*dw2(0)-dw3(1)*dw2(1)-dw3(2)*dw2(2)-dw3(3)*dw2(3)

      w13=dw1(0)*dw3(0)-dw1(1)*dw3(1)-dw1(2)*dw3(2)-dw1(3)*dw3(3)

      jj(0) = dgw2*( dw1(0)*w32 + dw3(0)*w12 - rTwo*dw2(0)*w13 )
      jj(1) = dgw2*( dw1(1)*w32 + dw3(1)*w12 - rTwo*dw2(1)*w13 )
      jj(2) = dgw2*( dw1(2)*w32 + dw3(2)*w12 - rTwo*dw2(2)*w13 )
      jj(3) = dgw2*( dw1(3)*w32 + dw3(3)*w12 - rTwo*dw2(3)*w13 )

c     Fabio's implementation of the fixed width
      cm2=dcmplx( mw2, -dmw*dww )
c     jq = (jj(0)*q(0)-jj(1)*q(1)-jj(2)*q(2)-jj(3)*q(3))/mw2
      jq = (jj(0)*q(0)-jj(1)*q(1)-jj(2)*q(2)-jj(3)*q(3))/cm2

      jwww(1) = dcmplx( (jj(0)-jq*q(0))*dw )
      jwww(2) = dcmplx( (jj(1)-jq*q(1))*dw )
      jwww(3) = dcmplx( (jj(2)-jq*q(2))*dw )
      jwww(4) = dcmplx( (jj(3)-jq*q(3))*dw )
c
      return
      end
      subroutine mom2cx(esum,mass1,mass2,costh1,phi1 , p1,p2)
c
c This subroutine sets up two four-momenta in the two particle rest
c frame.
c
c input:
c       real    esum           : energy sum of particle 1 and 2
c       real    mass1          : mass            of particle 1
c       real    mass2          : mass            of particle 2
c       real    costh1         : cos(theta)      of particle 1
c       real    phi1           : azimuthal angle of particle 1
c
c output:
c       real    p1(0:3)        : four-momentum of particle 1
c       real    p2(0:3)        : four-momentum of particle 2
c     
      implicit none
      double precision p1(0:3),p2(0:3),
     &     esum,mass1,mass2,costh1,phi1,md2,ed,pp,sinth1

      double precision rZero, rHalf, rOne, rTwo
      parameter( rZero = 0.0d0, rHalf = 0.5d0 )
      parameter( rOne = 1.0d0, rTwo = 2.0d0 )

c

      md2 = (mass1-mass2)*(mass1+mass2)
      ed = md2/esum
      if ( mass1*mass2.eq.rZero ) then
         pp = (esum-abs(ed))*rHalf
      else
         pp = sqrt((md2/esum)**2-rTwo*(mass1**2+mass2**2)+esum**2)*rHalf
      endif
      sinth1 = sqrt((rOne-costh1)*(rOne+costh1))

      p1(0) = max((esum+ed)*rHalf,rZero)
      p1(1) = pp*sinth1*cos(phi1)
      p1(2) = pp*sinth1*sin(phi1)
      p1(3) = pp*costh1

      p2(0) = max((esum-ed)*rHalf,rZero)
      p2(1) = -p1(1)
      p2(2) = -p1(2)
      p2(3) = -p1(3)
c
      return
      end
      subroutine momntx(energy,mass,costh,phi , p)
c
c This subroutine sets up a four-momentum from the four inputs.
c
c input:
c       real    energy         : energy
c       real    mass           : mass
c       real    costh          : cos(theta)
c       real    phi            : azimuthal angle
c
c output:
c       real    p(0:3)         : four-momentum
c     
      implicit none
      double precision p(0:3),energy,mass,costh,phi,pp,sinth

      double precision rZero, rOne
      parameter( rZero = 0.0d0, rOne = 1.0d0 )

c

      p(0) = energy

      if ( energy.eq.mass ) then

         p(1) = rZero
         p(2) = rZero
         p(3) = rZero

      else

         pp = sqrt((energy-mass)*(energy+mass))
         sinth = sqrt((rOne-costh)*(rOne+costh))
         p(3) = pp*costh
         if ( phi.eq.rZero ) then
            p(1) = pp*sinth
            p(2) = rZero
         else
            p(1) = pp*sinth*cos(phi)
            p(2) = pp*sinth*sin(phi)
         endif

      endif
c
      return
      end
      subroutine oxxxxx(p,fmass,nhel,nsf , fo)
c
c This subroutine computes a fermion wavefunction with the flowing-OUT
c fermion number.
c
c input:
c       real    p(0:3)         : four-momentum of fermion
c       real    fmass          : mass          of fermion
c       integer nhel = -1 or 1 : helicity      of fermion
c       integer nsf  = -1 or 1 : +1 for particle, -1 for anti-particle
c
c output:
c       complex fo(6)          : fermion wavefunction               <fo|
c     
      implicit none
      double complex fo(6),chi(2)
      double precision p(0:3),sf(2),sfomeg(2),omega(2),fmass,
     &     pp,pp3,sqp0p3,sqm
      integer nhel,nsf,nh,ip,im

      double precision rZero, rHalf, rTwo
      parameter( rZero = 0.0d0, rHalf = 0.5d0, rTwo = 2.0d0 )

c

      fo(5) = dcmplx(p(0),p(3))*nsf
      fo(6) = dcmplx(p(1),p(2))*nsf

      nh = nhel*nsf

      if ( fmass.ne.rZero ) then

         pp = min(p(0),dsqrt(p(1)**2+p(2)**2+p(3)**2))

         if ( pp.eq.rZero ) then
            
            sqm = dsqrt(fmass)
            ip = -((1+nh)/2)
            im =  (1-nh)/2
            
            fo(1) = im     * sqm
            fo(2) = ip*nsf * sqm
            fo(3) = im*nsf * sqm
            fo(4) = ip     * sqm
            
         else
            
            pp = min(p(0),dsqrt(p(1)**2+p(2)**2+p(3)**2))
            sf(1) = dble(1+nsf+(1-nsf)*nh)*rHalf
            sf(2) = dble(1+nsf-(1-nsf)*nh)*rHalf
            omega(1) = dsqrt(p(0)+pp)
            omega(2) = fmass/omega(1)
            ip = (3+nh)/2
            im = (3-nh)/2
            sfomeg(1) = sf(1)*omega(ip)
            sfomeg(2) = sf(2)*omega(im)
            pp3 = max(pp+p(3),rZero)
            chi(1) = dcmplx( dsqrt(pp3*rHalf/pp) )
            if ( pp3.eq.rZero ) then
               chi(2) = dcmplx(-nh )
            else
               chi(2) = dcmplx( nh*p(1) , -p(2) )/dsqrt(rTwo*pp*pp3)
            endif
            
            fo(1) = sfomeg(2)*chi(im)
            fo(2) = sfomeg(2)*chi(ip)
            fo(3) = sfomeg(1)*chi(im)
            fo(4) = sfomeg(1)*chi(ip)

         endif
         
      else
         
         sqp0p3 = dsqrt(max(p(0)+p(3),rZero))*nsf
         chi(1) = dcmplx( sqp0p3 )
         if ( sqp0p3.eq.rZero ) then
            chi(2) = dcmplx(-nhel )*dsqrt(rTwo*p(0))
         else
            chi(2) = dcmplx( nh*p(1), -p(2) )/sqp0p3
         endif
         if ( nh.eq.1 ) then
            fo(1) = chi(1)
            fo(2) = chi(2)
            fo(3) = dcmplx( rZero )
            fo(4) = dcmplx( rZero )
         else
            fo(1) = dcmplx( rZero )
            fo(2) = dcmplx( rZero )
            fo(3) = chi(2)
            fo(4) = chi(1)
         endif
         
      endif
c
      return
      end
      subroutine rotxxx(p,q , prot)
c
c This subroutine performs the spacial rotation of a four-momentum.
c the momentum p is assumed to be given in the frame where the spacial
c component of q points the positive z-axis.  prot is the momentum p
c rotated to the frame where q is given.
c
c input:
c       real    p(0:3)         : four-momentum p in q(1)=q(2)=0 frame
c       real    q(0:3)         : four-momentum q in the rotated frame
c
c output:
c       real    prot(0:3)      : four-momentum p in the rotated frame
c     
      implicit none
      double precision p(0:3),q(0:3),prot(0:3),qt2,qt,psgn,qq,p1

      double precision rZero, rOne
      parameter( rZero = 0.0d0, rOne = 1.0d0 )

c
      prot(0) = p(0)

      qt2 = q(1)**2 + q(2)**2


      if ( qt2.eq.rZero ) then
          if ( q(3).eq.rZero ) then
             prot(1) = p(1)
             prot(2) = p(2)
             prot(3) = p(3)
          else
             psgn = dsign(rOne,q(3))
             prot(1) = p(1)*psgn
             prot(2) = p(2)*psgn
             prot(3) = p(3)*psgn
          endif
      else
          qq = sqrt(qt2+q(3)**2)
          qt = sqrt(qt2)
          p1 = p(1)
          prot(1) = q(1)*q(3)/qq/qt*p1 -q(2)/qt*p(2) +q(1)/qq*p(3)
          prot(2) = q(2)*q(3)/qq/qt*p1 +q(1)/qt*p(2) +q(2)/qq*p(3)
          prot(3) =          -qt/qq*p1               +q(3)/qq*p(3)
      endif
c
      return
      end
      subroutine ssssxx(s1,s2,s3,s4,gc , vertex)
c
c This subroutine computes an amplitude of the four-scalar coupling.
c
c input:
c       complex s1(3)          : first  scalar                        s1
c       complex s2(3)          : second scalar                        s2
c       complex s3(3)          : third  scalar                        s3
c       complex s4(3)          : fourth scalar                        s4
c       complex gc             : coupling constant                 ghhhh
c
c output:
c       complex vertex         : amplitude            gamma(s1,s2,s3,s4)
c     
      implicit none
      double complex s1(3),s2(3),s3(3),s4(3),gc,vertex

c

      vertex = gc*s1(1)*s2(1)*s3(1)*s4(1)
c
      return
      end
      subroutine sssxxx(s1,s2,s3,gc , vertex)
c
c This subroutine computes an amplitude of the three-scalar coupling.
c
c input:
c       complex s1(3)          : first  scalar                        s1
c       complex s2(3)          : second scalar                        s2
c       complex s3(3)          : third  scalar                        s3
c       complex gc             : coupling constant                  ghhh
c
c output:
c       complex vertex         : amplitude               gamma(s1,s2,s3)
c     
      implicit none
      double complex s1(3),s2(3),s3(3),gc,vertex

c

      vertex = gc*s1(1)*s2(1)*s3(1)
c
      return
      end
      subroutine sxxxxx(p,nss , sc)
c
c This subroutine computes a complex SCALAR wavefunction.
c
c input:
c       real    p(0:3)         : four-momentum of scalar boson
c       integer nss  = -1 or 1 : +1 for final, -1 for initial
c
c output:
c       complex sc(3)          : scalar wavefunction                   s
c     
      implicit none
      double complex sc(3)
      double precision p(0:3)
      integer nss

      double precision rOne
      parameter( rOne = 1.0d0 )

c

      sc(1) = dcmplx( rOne )
      sc(2) = dcmplx(p(0),p(3))*nss
      sc(3) = dcmplx(p(1),p(2))*nss
c
      return
      end
      subroutine txxxx2(p,tmass,nhel,nst , tc)
c
c This subroutine computes k^mu*e^nu where e is delta(i,nhel).
c It is used to test for gauge invariance of the tensor routines.
c
c input:
c       real    p(0:3)             : four-momentum of tensor boson
c       real    tmass              : mass          of tensor boson
c       integer nhel = 1..4        : construction of e^nu
c       integer nst  = -1 or 1     : +1 for final, -1 for initial
c
c output:
c       complex tc(6,4)            : tensor wavefunction       epsilon^mu^nu(t)
c     
      implicit none
      double complex tc(6,4), ep(4), em(4)
      double precision p(0:3), tmass
      integer nhel, nst, i, j

      double precision rZero, rOne
      parameter( rZero = 0.0d0, rOne = 1.0d0 )
c
      tc(5,1) = dcmplx(p(0),p(3))*nst
      tc(6,1) = dcmplx(p(1),p(2))*nst

      ep(1) = dcmplx( p(0), rZero )
      ep(2) = dcmplx( p(1), rZero )
      ep(3) = dcmplx( p(2), rZero )
      ep(4) = dcmplx( p(3), rZero )

      if ( nhel.eq.1 ) then
         em(1) = dcmplx( rOne , rZero )
         em(2) = dcmplx( rZero, rZero )
         em(3) = dcmplx( rZero, rZero )
         em(4) = dcmplx( rZero, rZero )
      else if ( nhel.eq.2 ) then
         em(1) = dcmplx( rZero, rZero )
         em(2) = dcmplx( rOne , rZero )
         em(3) = dcmplx( rZero, rZero )
         em(4) = dcmplx( rZero, rZero )
      else if ( nhel.eq.3 ) then
         em(1) = dcmplx( rZero, rZero )
         em(2) = dcmplx( rZero, rZero )
         em(3) = dcmplx( rOne , rZero )
         em(4) = dcmplx( rZero, rZero )
      else if ( nhel.eq.4 ) then
         em(1) = dcmplx( rZero, rZero )
         em(2) = dcmplx( rZero, rZero )
         em(3) = dcmplx( rZero, rZero )
         em(4) = dcmplx( rOne , rZero )
      end if

      do j = 1,4
         do i = 1,4
            tc(i,j) = ep(i)*em(j)
         end do
      end do
c
      return
      end
      subroutine txxxxx(p,tmass,nhel,nst , tc)
c
c This subroutine computes a TENSOR wavefunction.
c
c input:
c       real    p(0:3)             : four-momentum of tensor boson
c       real    tmass              : mass          of tensor boson
c       integer nhel = -2,-1,0,1,2 : helicity      of tensor boson
c                                    (0 is forbidden if tmass = 0)
c       integer nst  = -1 or 1     : +1 for final, -1 for initial
c
c output:
c       complex tc(6,4)            : tensor wavefunction   epsilon^mu^nu(t)
c     
      implicit none
      double complex tc(6,4), ep(4), em(4), e0(4)
      double precision p(0:3), tmass, pt, pt2, pp, pzpt, emp, sqh, sqs
      integer nhel, nst, i, j

      double precision rZero, rHalf, rOne, rTwo
      parameter( rZero = 0.0d0, rHalf = 0.5d0 )
      parameter( rOne = 1.0d0, rTwo = 2.0d0 )
c
      sqh = sqrt(rHalf)
      sqs = sqrt(rHalf/3.d0)

      pt2 = p(1)**2 + p(2)**2
      pp = min(p(0),sqrt(pt2+p(3)**2))
      pt = min(pp,sqrt(pt2))

      tc(5,1) = dcmplx(p(0),p(3))*nst
      tc(6,1) = dcmplx(p(1),p(2))*nst

      if ( nhel.ge.0 ) then  !construct eps+
         if ( pp.eq.rZero ) then
            ep(1) = dcmplx( rZero )
            ep(2) = dcmplx( -sqh )
            ep(3) = dcmplx( rZero , nst*sqh )
            ep(4) = dcmplx( rZero )
         else
            ep(1) = dcmplx( rZero )
            ep(4) = dcmplx( pt/pp*sqh )
            if ( pt.ne.rZero ) then
               pzpt = p(3)/(pp*pt)*sqh
               ep(2) = dcmplx( -p(1)*pzpt , -nst*p(2)/pt*sqh )
               ep(3) = dcmplx( -p(2)*pzpt ,  nst*p(1)/pt*sqh )
            else
               ep(2) = dcmplx( -sqh )
               ep(3) = dcmplx( rZero , nst*sign(sqh,p(3)) )
            endif
         endif
      end if

      if ( nhel.le.0 ) then  !construct eps-
         if ( pp.eq.rZero ) then
            em(1) = dcmplx( rZero )
            em(2) = dcmplx( sqh )
            em(3) = dcmplx( rZero , nst*sqh )
            em(4) = dcmplx( rZero )
         else
            em(1) = dcmplx( rZero )
            em(4) = dcmplx( -pt/pp*sqh )
            if ( pt.ne.rZero ) then
               pzpt = -p(3)/(pp*pt)*sqh
               em(2) = dcmplx( -p(1)*pzpt , -nst*p(2)/pt*sqh )
               em(3) = dcmplx( -p(2)*pzpt ,  nst*p(1)/pt*sqh )
            else
               em(2) = dcmplx( sqh )
               em(3) = dcmplx( rZero , nst*sign(sqh,p(3)) )
            endif
         endif
      end if

      if ( abs(nhel).le.1 ) then  !construct eps0
         if ( pp.eq.rZero ) then
            e0(1) = dcmplx( rZero )
            e0(2) = dcmplx( rZero )
            e0(3) = dcmplx( rZero )
            e0(4) = dcmplx( rOne )
         else
            emp = p(0)/(tmass*pp)
            e0(1) = dcmplx( pp/tmass )
            e0(4) = dcmplx( p(3)*emp )
            if ( pt.ne.rZero ) then
               e0(2) = dcmplx( p(1)*emp )
               e0(3) = dcmplx( p(2)*emp )
            else
               e0(2) = dcmplx( rZero )
               e0(3) = dcmplx( rZero )
            endif
         end if
      end if

      if ( nhel.eq.2 ) then
         do j = 1,4
            do i = 1,4
               tc(i,j) = ep(i)*ep(j)
            end do
         end do
      else if ( nhel.eq.1 ) then
         do j = 1,4
            do i = 1,4
               tc(i,j) = sqh*( ep(i)*e0(j) + e0(i)*ep(j) )
            end do
         end do
      else if ( nhel.eq.0 ) then
         do j = 1,4
            do i = 1,4
               tc(i,j) = sqs*( ep(i)*em(j) + em(i)*ep(j)
     &                                + rTwo*e0(i)*e0(j) )
            end do
         end do
      else if ( nhel.eq.-1 ) then
         do j = 1,4
            do i = 1,4
               tc(i,j) = sqh*( em(i)*e0(j) + e0(i)*em(j) )
            end do
         end do
      else if ( nhel.eq.-2 ) then
         do j = 1,4
            do i = 1,4
               tc(i,j) = em(i)*em(j)
            end do
         end do
      else
         write(6,*) 'invalid helicity in TXXXXX'
         stop
      end if
c
      return
      end
      subroutine vssxxx(vc,s1,s2,gc , vertex)
c
c This subroutine computes an amplitude from the vector-scalar-scalar
c coupling.  The coupling is absent in the minimal SM in unitary gauge.
c
c       complex vc(6)          : input  vector                        v
c       complex s1(3)          : first  scalar                        s1
c       complex s2(3)          : second scalar                        s2
c       complex gc             : coupling constant (s1 charge)
c
c examples of the coupling constant gc for SUSY particles are as follows:
c   -----------------------------------------------------------
c   |    s1    | (q,i3) of s1  ||   v=a   |   v=z   |   v=w   |
c   -----------------------------------------------------------
c   | nu~_l    | (  0  , +1/2) ||   ---   |  gzn(1) |  gwf(1) |
c   | e~_l     | ( -1  , -1/2) ||  gal(1) |  gzl(1) |  gwf(1) |
c   | u~_l     | (+2/3 , +1/2) ||  gau(1) |  gzu(1) |  gwf(1) |
c   | d~_l     | (-1/3 , -1/2) ||  gad(1) |  gzd(1) |  gwf(1) |
c   -----------------------------------------------------------
c   | e~_r-bar | ( +1  ,  0  ) || -gal(2) | -gzl(2) | -gwf(2) |
c   | u~_r-bar | (-2/3 ,  0  ) || -gau(2) | -gzu(2) | -gwf(2) |
c   | d~_r-bar | (+1/3 ,  0  ) || -gad(2) | -gzd(2) | -gwf(2) |
c   -----------------------------------------------------------
c where the s1 charge is defined by the flowing-OUT quantum number.
c
c output:
c       complex vertex         : amplitude                gamma(v,s1,s2)
c     
      implicit none
      double complex vc(6),s1(3),s2(3),gc,vertex
      double precision p(0:3)

c

      p(0) = dble( s1(2)-s2(2))
      p(1) = dble( s1(3)-s2(3))
      p(2) = dimag(s1(3)-s2(3))
      p(3) = dimag(s1(2)-s2(2))

      vertex = gc*s1(1)*s2(1)
     &        *(vc(1)*p(0)-vc(2)*p(1)-vc(3)*p(2)-vc(4)*p(3))
c
      return
      end
      subroutine vvssxx(v1,v2,s1,s2,gc , vertex)
c
c This subroutine computes an amplitude of the vector-vector-scalar-
c scalar coupling.
c
c input:
c       complex v1(6)          : first  vector                        v1
c       complex v2(6)          : second vector                        v2
c       complex s1(3)          : first  scalar                        s1
c       complex s2(3)          : second scalar                        s2
c       complex gc             : coupling constant                 gvvhh
c
c output:
c       complex vertex         : amplitude            gamma(v1,v2,s1,s2)
c     
      implicit none
      double complex v1(6),v2(6),s1(3),s2(3),gc,vertex

c

      vertex = gc*s1(1)*s2(1)
     &        *(v1(1)*v2(1)-v1(2)*v2(2)-v1(3)*v2(3)-v1(4)*v2(4))
c
      return
      end
      subroutine vvsxxx(v1,v2,sc,gc , vertex)
c
c This subroutine computes an amplitude of the vector-vector-scalar
c coupling.
c
c input:
c       complex v1(6)          : first  vector                        v1
c       complex v2(6)          : second vector                        v2
c       complex sc(3)          : input  scalar                        s
c       complex gc             : coupling constant                  gvvh
c
c output:
c       complex vertex         : amplitude                gamma(v1,v2,s)
c     
      implicit none
      double complex v1(6),v2(6),sc(3),gc,vertex

c

      vertex = gc*sc(1)
     &        *(v1(1)*v2(1)-v1(2)*v2(2)-v1(3)*v2(3)-v1(4)*v2(4))
c
      return
      end
      subroutine vvtxkk(wm,wp,tc,g,vmass , vertex)
c
c This subroutine computes an amplitude of the three-point coupling of
c two gauge bosons and a Kaluza-Klein tensor boson.
c
c input:
c       complex wm(6)          : vector               flow-in  V
c       complex wp(6)          : vector               flow-out V~
c       complex tc(6,4)        : tensor               KK mode T
c       real    g              : coupling constant    -kappa/2
c       real    vmass          : V boson mass          m_V
c
c output:
c       complex vertex         : amplitude            gamma(wm,wp,tc)
c     
      implicit none
      double complex wm(6), wp(6), tc(6,4), vertex
      double precision g, vmass

      double complex T12, T13, T14, T23, T24, T34
      double complex V1V2, k1V2, k2V1
      double complex Tkk, TVV, Tk1V2, Tk2V1, dum
      double precision pwm(4), pwp(4), F

      integer i, j

      double complex cZero
      double precision rZero, rTwo
      parameter( rZero = 0.0d0, rTwo = 2.0d0 )
      parameter( cZero = ( 0.0d0, 0.0d0 ) )
c
      pwm(1) = dreal(wm(5))
      pwm(2) = dreal(wm(6))
      pwm(3) = dimag(wm(6))
      pwm(4) = dimag(wm(5))
      pwp(1) = dreal(wp(5))
      pwp(2) = dreal(wp(6))
      pwp(3) = dimag(wp(6))
      pwp(4) = dimag(wp(5))

      T12 = tc(1,2) + tc(2,1)
      T13 = tc(1,3) + tc(3,1)
      T14 = tc(1,4) + tc(4,1)
      T23 = tc(2,3) + tc(3,2)
      T24 = tc(2,4) + tc(4,2)
      T34 = tc(3,4) + tc(4,3)

      V1V2 =  wm(1)*wp(1) -  wm(2)*wp(2) -  wm(3)*wp(3) -  wm(4)*wp(4)
      k1V2 = pwm(1)*wp(1) - pwm(2)*wp(2) - pwm(3)*wp(3) - pwm(4)*wp(4)
      k2V1 = pwp(1)*wm(1) - pwp(2)*wm(2) - pwp(3)*wm(3) - pwp(4)*wm(4)

      F = pwm(1)*pwp(1) - pwm(2)*pwp(2) - pwm(3)*pwp(3) - pwm(4)*pwp(4)
      if ( vmass.ne.rZero ) then
         F = F + vmass**2
      end if

      Tkk   = cZero
      TVV   = cZero
      Tk1V2 = cZero
      Tk2V1 = cZero

      do i = 1,4
         dum   = tc(i,i)*pwm(i)
         Tkk   = Tkk   + dum*pwp(i)
         Tk1V2 = Tk1V2 + dum*wp(i)
         dum   = tc(i,i)*wm(i)
         TVV   = TVV   + dum*wp(i)
         Tk2V1 = Tk2V1 + dum*pwp(i)
      end do

      Tkk   = rTwo*Tkk
      TVV   = rTwo*TVV
      Tk1V2 = rTwo*Tk1V2
      Tk2V1 = rTwo*Tk2V1

      Tkk = Tkk - T12*(pwm(1)*pwp(2) + pwm(2)*pwp(1))
     &          - T13*(pwm(1)*pwp(3) + pwm(3)*pwp(1))
     &          - T14*(pwm(1)*pwp(4) + pwm(4)*pwp(1))
     &          + T23*(pwm(2)*pwp(3) + pwm(3)*pwp(2))
     &          + T24*(pwm(2)*pwp(4) + pwm(4)*pwp(2))
     &          + T34*(pwm(3)*pwp(4) + pwm(4)*pwp(3))

      Tk1V2 = Tk1V2 - T12*(pwm(1)*wp(2) + pwm(2)*wp(1))
     &              - T13*(pwm(1)*wp(3) + pwm(3)*wp(1))
     &              - T14*(pwm(1)*wp(4) + pwm(4)*wp(1))
     &              + T23*(pwm(2)*wp(3) + pwm(3)*wp(2))
     &              + T24*(pwm(2)*wp(4) + pwm(4)*wp(2))
     &              + T34*(pwm(3)*wp(4) + pwm(4)*wp(3))

      TVV = TVV - T12*(wm(1)*wp(2) + wm(2)*wp(1))
     &          - T13*(wm(1)*wp(3) + wm(3)*wp(1))
     &          - T14*(wm(1)*wp(4) + wm(4)*wp(1))
     &          + T23*(wm(2)*wp(3) + wm(3)*wp(2))
     &          + T24*(wm(2)*wp(4) + wm(4)*wp(2))
     &          + T34*(wm(3)*wp(4) + wm(4)*wp(3))

      Tk2V1 = Tk2V1 - T12*(wm(1)*pwp(2) + wm(2)*pwp(1))
     &              - T13*(wm(1)*pwp(3) + wm(3)*pwp(1))
     &              - T14*(wm(1)*pwp(4) + wm(4)*pwp(1))
     &              + T23*(wm(2)*pwp(3) + wm(3)*pwp(2))
     &              + T24*(wm(2)*pwp(4) + wm(4)*pwp(2))
     &              + T34*(wm(3)*pwp(4) + wm(4)*pwp(3))

      vertex =  (tc(1,1)-tc(2,2)-tc(3,3)-tc(4,4))*( k1V2*k2V1 - V1V2*F )
     &        + F*TVV + V1V2*Tkk - k2V1*Tk1V2 - k1V2*Tk2V1

C      vertex = F*TVV + V1V2*Tkk - k2V1*Tk1V2 - k1V2*Tk2V1

      vertex = vertex * g
c
      return
      end
      subroutine vvvxxx(wm,wp,w3,g , vertex)
c
c This subroutine computes an amplitude of the three-point coupling of
c the gauge bosons.
c
c input:
c       complex wm(6)          : vector               flow-out W-
c       complex wp(6)          : vector               flow-out W+
c       complex w3(6)          : vector               j3 or A    or Z
c       real    g              : coupling constant    gw or gwwa or gwwz
c
c output:
c       complex vertex         : amplitude               gamma(wm,wp,w3)
c     
      implicit none
      double complex wm(6),wp(6),w3(6),vertex,
     &     xv1,xv2,xv3,v12,v23,v31,p12,p13,p21,p23,p31,p32
      double precision pwm(0:3),pwp(0:3),pw3(0:3),g

      double precision rZero, rTenth
      parameter( rZero = 0.0d0, rTenth = 0.1d0 )

c
      pwm(0) = dble( wm(5))
      pwm(1) = dble( wm(6))
      pwm(2) = dimag(wm(6))
      pwm(3) = dimag(wm(5))
      pwp(0) = dble( wp(5))
      pwp(1) = dble( wp(6))
      pwp(2) = dimag(wp(6))
      pwp(3) = dimag(wp(5))
      pw3(0) = dble( w3(5))
      pw3(1) = dble( w3(6))
      pw3(2) = dimag(w3(6))
      pw3(3) = dimag(w3(5))


      v12 = wm(1)*wp(1)-wm(2)*wp(2)-wm(3)*wp(3)-wm(4)*wp(4)
      v23 = wp(1)*w3(1)-wp(2)*w3(2)-wp(3)*w3(3)-wp(4)*w3(4)
      v31 = w3(1)*wm(1)-w3(2)*wm(2)-w3(3)*wm(3)-w3(4)*wm(4)
      xv1 = rZero
      xv2 = rZero
      xv3 = rZero

      if ( abs(wm(1)).ne.rZero ) then
         if ( abs(wm(1)).ge.max(abs(wm(2)),abs(wm(3)),abs(wm(4)))
     &        *rTenth )
     &      xv1 = pwm(0)/wm(1)
      endif
      if ( abs(wp(1)).ne.rZero) then
         if ( abs(wp(1)).ge.max(abs(wp(2)),abs(wp(3)),abs(wp(4)))
     &        *rTenth )
     &      xv2 = pwp(0)/wp(1)
      endif
      if ( abs(w3(1)).ne.rZero) then
         if ( abs(w3(1)).ge.max(abs(w3(2)),abs(w3(3)),abs(w3(4)))
     &        *rTenth )
     &      xv3 = pw3(0)/w3(1)
      endif

      p12 = (pwm(0)-xv1*wm(1))*wp(1)-(pwm(1)-xv1*wm(2))*wp(2)
     &     -(pwm(2)-xv1*wm(3))*wp(3)-(pwm(3)-xv1*wm(4))*wp(4)
      p13 = (pwm(0)-xv1*wm(1))*w3(1)-(pwm(1)-xv1*wm(2))*w3(2)
     &     -(pwm(2)-xv1*wm(3))*w3(3)-(pwm(3)-xv1*wm(4))*w3(4)
      p21 = (pwp(0)-xv2*wp(1))*wm(1)-(pwp(1)-xv2*wp(2))*wm(2)
     &     -(pwp(2)-xv2*wp(3))*wm(3)-(pwp(3)-xv2*wp(4))*wm(4)
      p23 = (pwp(0)-xv2*wp(1))*w3(1)-(pwp(1)-xv2*wp(2))*w3(2)
     &     -(pwp(2)-xv2*wp(3))*w3(3)-(pwp(3)-xv2*wp(4))*w3(4)
      p31 = (pw3(0)-xv3*w3(1))*wm(1)-(pw3(1)-xv3*w3(2))*wm(2)
     &     -(pw3(2)-xv3*w3(3))*wm(3)-(pw3(3)-xv3*w3(4))*wm(4)
      p32 = (pw3(0)-xv3*w3(1))*wp(1)-(pw3(1)-xv3*w3(2))*wp(2)
     &     -(pw3(2)-xv3*w3(3))*wp(3)-(pw3(3)-xv3*w3(4))*wp(4)

      vertex = -(v12*(p13-p23)+v23*(p21-p31)+v31*(p32-p12))*g
c
      return
      end
      subroutine vxxxxx(p,vmass,nhel,nsv , vc)
c
c This subroutine computes a VECTOR wavefunction.
c
c input:
c       real    p(0:3)         : four-momentum of vector boson
c       real    vmass          : mass          of vector boson
c       integer nhel = -1, 0, 1: helicity      of vector boson
c                                (0 is forbidden if vmass=0.0)
c       integer nsv  = -1 or 1 : +1 for final, -1 for initial
c
c output:
c       complex vc(6)          : vector wavefunction       epsilon^mu(v)
c     
      implicit none
      double complex vc(6)
      double precision p(0:3),vmass,hel,hel0,pt,pt2,pp,pzpt,emp,sqh
      integer nhel,nsv,nsvahl

      double precision rZero, rHalf, rOne, rTwo
      parameter( rZero = 0.0d0, rHalf = 0.5d0 )
      parameter( rOne = 1.0d0, rTwo = 2.0d0 )
      
c

      sqh = dsqrt(rHalf)
      hel = dble(nhel)
      nsvahl = nsv*dabs(hel)
      pt2 = p(1)**2+p(2)**2
      pp = min(p(0),dsqrt(pt2+p(3)**2))
      pt = min(pp,dsqrt(pt2))

      vc(5) = dcmplx(p(0),p(3))*nsv
      vc(6) = dcmplx(p(1),p(2))*nsv


      if ( vmass.ne.rZero ) then

         hel0 = rOne-dabs(hel)

         if ( pp.eq.rZero ) then

            vc(1) = dcmplx( rZero )
            vc(2) = dcmplx(-hel*sqh )
            vc(3) = dcmplx( rZero , nsvahl*sqh )
            vc(4) = dcmplx( hel0 )

         else

            emp = p(0)/(vmass*pp)
            vc(1) = dcmplx( hel0*pp/vmass )
            vc(4) = dcmplx( hel0*p(3)*emp+hel*pt/pp*sqh )
            if ( pt.ne.rZero ) then
               pzpt = p(3)/(pp*pt)*sqh*hel
               vc(2) = dcmplx( hel0*p(1)*emp-p(1)*pzpt , 
     &                         -nsvahl*p(2)/pt*sqh       )
               vc(3) = dcmplx( hel0*p(2)*emp-p(2)*pzpt ,  
     &                          nsvahl*p(1)/pt*sqh       )
            else
               vc(2) = dcmplx( -hel*sqh )
               vc(3) = dcmplx( rZero , nsvahl*sign(sqh,p(3)) )
            endif

         endif

      else

         pp = p(0)
         pt = sqrt(p(1)**2+p(2)**2)
         vc(1) = dcmplx( rZero )
         vc(4) = dcmplx( hel*pt/pp*sqh )
         if ( pt.ne.rZero ) then
            pzpt = p(3)/(pp*pt)*sqh*hel
            vc(2) = dcmplx( -p(1)*pzpt , -nsv*p(2)/pt*sqh )
            vc(3) = dcmplx( -p(2)*pzpt ,  nsv*p(1)/pt*sqh )
         else
            vc(2) = dcmplx( -hel*sqh )
            vc(3) = dcmplx( rZero , nsv*sign(sqh,p(3)) )
         endif

      endif
c
      return
      end
      subroutine w3w3xx(wm,w31,wp,w32,g31,g32, vertex)
c
c This subroutine computes an amplitude of the four-point coupling of
c the W-, W+ and two W3/Z/A.
c If one sets wmass=0.0, then the gggg vertex is given
c (see sect 2.9.1 of the manual).
c
c input:
c       complex wm(0:3)        : flow-out W-                         wm
c       complex w31(0:3)       : first    W3/Z/A                     w31
c       complex wp(0:3)        : flow-out W+                         wp
c       complex w32(0:3)       : second   W3/Z/A                     w32
c       real    g31            : coupling of w31 with W-/W+
c       real    g32            : coupling of w32 with W-/W+
c                                                  (see the table below)
c       real    wmass          : mass  of W
c       real    wwidth         : width of W
c
c the possible sets of the inputs are as follows:
c   -------------------------------------------
c   |  wm  |  w31 |  wp  |  w32 |  g31 |  g32 |
c   -------------------------------------------
c   |  W-  |  W3  |  W+  |  W3  |  gw  |  gw  |
c   |  W-  |  W3  |  W+  |  Z   |  gw  | gwwz |
c   |  W-  |  W3  |  W+  |  A   |  gw  | gwwa |
c   |  W-  |  Z   |  W+  |  Z   | gwwz | gwwz |
c   |  W-  |  Z   |  W+  |  A   | gwwz | gwwa |
c   |  W-  |  A   |  W+  |  A   | gwwa | gwwa |
c   -------------------------------------------
c where all the bosons are defined by the flowing-OUT quantum number.
c
c output:
c       complex vertex         : amplitude          gamma(wm,w31,wp,w32)
c     
      implicit none
      double complex wm(6),w31(6),wp(6),w32(6),vertex
      double complex dv1(0:3),dv2(0:3),dv3(0:3),dv4(0:3),dvertx
      double complex v12,v13,v14,v23,v24,v34
      double precision pwm(0:3),pw31(0:3),pwp(0:3),pw32(0:3)
      double precision g31,g32

      double precision rZero, rOne, rTwo
      parameter( rZero = 0.0d0, rOne = 1.0d0, rTwo = 2.0d0 )


      pwm(0) = dble( wm(5))
      pwm(1) = dble( wm(6))
      pwm(2) = dimag(wm(6))
      pwm(3) = dimag(wm(5))
      pwp(0) = dble( wp(5))
      pwp(1) = dble( wp(6))
      pwp(2) = dimag(wp(6))
      pwp(3) = dimag(wp(5))
      pw31(0) = dble( w31(5))
      pw31(1) = dble( w31(6))
      pw31(2) = dimag(w31(6))
      pw31(3) = dimag(w31(5))
      pw32(0) = dble( w32(5))
      pw32(1) = dble( w32(6))
      pw32(2) = dimag(w32(6))
      pw32(3) = dimag(w32(5))


      dv1(0) = dcmplx(wm(1))
      dv1(1) = dcmplx(wm(2))
      dv1(2) = dcmplx(wm(3))
      dv1(3) = dcmplx(wm(4))
      dv2(0) = dcmplx(w31(1))
      dv2(1) = dcmplx(w31(2))
      dv2(2) = dcmplx(w31(3))
      dv2(3) = dcmplx(w31(4))
      dv3(0) = dcmplx(wp(1))
      dv3(1) = dcmplx(wp(2))
      dv3(2) = dcmplx(wp(3))
      dv3(3) = dcmplx(wp(4))
      dv4(0) = dcmplx(w32(1))
      dv4(1) = dcmplx(w32(2))
      dv4(2) = dcmplx(w32(3))
      dv4(3) = dcmplx(w32(4))

      v12 = dv1(0)*dv2(0)-dv1(1)*dv2(1)-dv1(2)*dv2(2)-dv1(3)*dv2(3)
      v13 = dv1(0)*dv3(0)-dv1(1)*dv3(1)-dv1(2)*dv3(2)-dv1(3)*dv3(3)
      v14 = dv1(0)*dv4(0)-dv1(1)*dv4(1)-dv1(2)*dv4(2)-dv1(3)*dv4(3)
      v23 = dv2(0)*dv3(0)-dv2(1)*dv3(1)-dv2(2)*dv3(2)-dv2(3)*dv3(3)
      v24 = dv2(0)*dv4(0)-dv2(1)*dv4(1)-dv2(2)*dv4(2)-dv2(3)*dv4(3)
      v34 = dv3(0)*dv4(0)-dv3(1)*dv4(1)-dv3(2)*dv4(2)-dv3(3)*dv4(3)

      dvertx = v12*v34 + v14*v23 - rTwo*v13*v24
      
      vertex = dcmplx( dvertx ) * (g31*g32)
c
      return
      end
      subroutine wwwwxx(wm1,wp1,wm2,wp2,gwwa,gwwz , vertex)
c
c This subroutine computes an amplitude of the four-point W-/W+ coupling.
c
c input:
c       complex wm1(0:3)       : first  flow-out W-                  wm1
c       complex wp1(0:3)       : first  flow-out W+                  wp1
c       complex wm2(0:3)       : second flow-out W-                  wm2
c       complex wp2(0:3)       : second flow-out W+                  wp2
c       real    gwwa           : coupling constant of W and A       gwwa
c       real    gwwz           : coupling constant of W and Z       gwwz
c       real    zmass          : mass  of Z
c       real    zwidth         : width of Z
c
c output:
c       complex vertex         : amplitude        gamma(wm1,wp1,wm2,wp2)
c     
      implicit none
      double complex wm1(6),wp1(6),wm2(6),wp2(6),vertex
      double complex dv1(0:3),dv2(0:3),dv3(0:3),dv4(0:3),dvertx
      double complex v12,v13,v14,v23,v24,v34
      double precision pwm1(0:3),pwp1(0:3),pwm2(0:3),pwp2(0:3)
      double precision gwwa,gwwz

      double precision rZero, rOne, rTwo
      parameter( rZero = 0.0d0, rOne = 1.0d0, rTwo = 2.0d0 )

c
      pwm1(0) = dble( wm1(5))
      pwm1(1) = dble( wm1(6))
      pwm1(2) = dimag(wm1(6))
      pwm1(3) = dimag(wm1(5))
      pwp1(0) = dble( wp1(5))
      pwp1(1) = dble( wp1(6))
      pwp1(2) = dimag(wp1(6))
      pwp1(3) = dimag(wp1(5))
      pwm2(0) = dble( wm2(5))
      pwm2(1) = dble( wm2(6))
      pwm2(2) = dimag(wm2(6))
      pwm2(3) = dimag(wm2(5))
      pwp2(0) = dble( wp2(5))
      pwp2(1) = dble( wp2(6))
      pwp2(2) = dimag(wp2(6))
      pwp2(3) = dimag(wp2(5))


      dv1(0) = dcmplx(wm1(1))
      dv1(1) = dcmplx(wm1(2))
      dv1(2) = dcmplx(wm1(3))
      dv1(3) = dcmplx(wm1(4))
      dv2(0) = dcmplx(wp1(1))
      dv2(1) = dcmplx(wp1(2))
      dv2(2) = dcmplx(wp1(3))
      dv2(3) = dcmplx(wp1(4))
      dv3(0) = dcmplx(wm2(1))
      dv3(1) = dcmplx(wm2(2))
      dv3(2) = dcmplx(wm2(3))
      dv3(3) = dcmplx(wm2(4))
      dv4(0) = dcmplx(wp2(1))
      dv4(1) = dcmplx(wp2(2))
      dv4(2) = dcmplx(wp2(3))
      dv4(3) = dcmplx(wp2(4))

      v12 = dv1(0)*dv2(0)-dv1(1)*dv2(1)-dv1(2)*dv2(2)-dv1(3)*dv2(3)
      v13 = dv1(0)*dv3(0)-dv1(1)*dv3(1)-dv1(2)*dv3(2)-dv1(3)*dv3(3)
      v14 = dv1(0)*dv4(0)-dv1(1)*dv4(1)-dv1(2)*dv4(2)-dv1(3)*dv4(3)
      v23 = dv2(0)*dv3(0)-dv2(1)*dv3(1)-dv2(2)*dv3(2)-dv2(3)*dv3(3)
      v24 = dv2(0)*dv4(0)-dv2(1)*dv4(1)-dv2(2)*dv4(2)-dv2(3)*dv4(3)
      v34 = dv3(0)*dv4(0)-dv3(1)*dv4(1)-dv3(2)*dv4(2)-dv3(3)*dv4(3)

      dvertx = (v12*v34 + v14*v23 - rTwo*v13*v24)*(gwwa**2+gwwz**2)

      vertex = -dcmplx( dvertx )
c
      return
      end
      function dotprod(p,q)
      implicit none
      real * 8 dotprod,p(4),q(4)
      dotprod=p(4)*q(4)-p(1)*q(1)-p(2)*q(2)-p(3)*q(3)
      end

      function random()
      real * 8 random
      call rm48(random,1)
      end

      subroutine resetrandom
      real * 8 powheginput
      integer seed
      seed=powheginput("#randomseed")
      if(seed.lt.0) then
         call RM48IN(54217137,0,0)
      else
         call RM48IN(seed,0,0)
      endif
      end

      subroutine rn3vec(vec,r)
c Generates a 3d vector in unit sphere
      implicit none
      real * 8 vec(3),r,r02,norm
      integer j
c generate in unit cube -1<x,y,z<1
 1    call rm48(vec,3)
      do j=1,3
         vec(j)=1-2*vec(j)
      enddo
c generate in unit sphere by hit and miss
      r02=vec(1)**2+vec(2)**2+vec(3)**2
      if(r02.gt.1) goto 1
c normalize
      norm=r/sqrt(r02)
      do j=1,3
         vec(j)=vec(j)*norm
      enddo
      end
C----------------------------------------------------------------------------
C-------------------------------------------------------------------
C------- ALPHA QCD -------------------------------------
c Program to calculate alfa strong with nf flavours,
c as a function of lambda with 5 flavors.
c The value of alfa is matched at the thresholds q = mq.
c When invoked with nf < 0 it chooses nf as the number of
c flavors with mass less then q.
c
      function alfas(q2,xlam,inf)
      implicit none
      real * 8 alfas,q2,xlam
      integer inf
      real * 8 pi
      parameter (pi=3.141592653589793d0)
      real * 8 olam,b5,bp5,b4,bp4,b3,bp3,xlc,xlb,xllc,xllb,c45,c35,
     # xmc,xmb
      real * 8 q,xlq,xllq
      integer nf
      data olam/0.d0/
      data xmb/5.d0/,xmc/1.5d0/
      save olam,b5,bp5,b4,bp4,b3,bp3,xlc,xlb,xllc,xllb,c45,c35
      if(xlam.ne.olam) then
        olam = xlam
        b5  = (33-2*5)/pi/12
        bp5 = (153 - 19*5) / pi / 2 / (33 - 2*5)
        b4  = (33-2*4)/pi/12
        bp4 = (153 - 19*4) / pi / 2 / (33 - 2*4)
        b3  = (33-2*3)/pi/12
        bp3 = (153 - 19*3) / pi / 2 / (33 - 2*3)
        xlc = 2 * log(xmc/xlam)
        xlb = 2 * log(xmb/xlam)
        xllc = log(xlc)
        xllb = log(xlb)
        c45  =  1/( 1/(b5 * xlb) - xllb*bp5/(b5 * xlb)**2 )
     #        - 1/( 1/(b4 * xlb) - xllb*bp4/(b4 * xlb)**2 )
        c35  =  1/( 1/(b4 * xlc) - xllc*bp4/(b4 * xlc)**2 )
     #        - 1/( 1/(b3 * xlc) - xllc*bp3/(b3 * xlc)**2 ) + c45
      endif
      q   = sqrt(q2)
      xlq = 2 * log( q/xlam )
      xllq = log( xlq )
      nf = inf
      if( nf .lt. 0) then
        if( q .gt. xmb ) then
          nf = 5
        elseif( q .gt. xmc ) then
          nf = 4
        else
          nf = 3
        endif
      endif
      if    ( nf .eq. 5 ) then
        alfas = 1/(b5 * xlq) -  bp5/(b5 * xlq)**2 * xllq
      elseif( nf .eq. 4 ) then
        alfas = 1/( 1/(1/(b4 * xlq) - bp4/(b4 * xlq)**2 * xllq) + c45 )
      elseif( nf .eq. 3 ) then
        alfas = 1/( 1/(1/(b3 * xlq) - bp3/(b3 * xlq)**2 * xllq) + c35 )
      else
        print *,'error in alfa: unimplemented # of light flavours',nf
        stop
      endif
      return
      end

C----------------------------------------------------------------------------
C-------------------------------------------------------------------
C------- ALPHA QCD -------------------------------------
c Program to calculate alfa strong with nf flavours,
c as a function of lambda with 5 flavors.
c The value of alfa is matched at the thresholds q = mq.
c When invoked with nf < 0 it chooses nf as the number of
c flavors with mass less then q.
c
      function alfas0(q2,xlam,inf)
      implicit none
      real * 8 alfas0,q2,xlam
      integer inf
      real * 8 pi
      parameter (pi=3.141592653589793d0)
      real * 8 b0
      b0=(33-2*inf)/(12*pi)
      alfas0=1/(b0*log(q2/xlam**2))
      end



      function alfas1(q2,xlam,nf)
      implicit none
      real * 8 alfas1,q2,xlam,b,bp,t,xlt,pi
      integer nf
      parameter (pi=3.14159265358979312D0)
      b  = (33-2*nf)/pi/12
      bp = (153 - 19*nf) / pi / 2 / (33 - 2*nf)
      t = log( q2/xlam**2 )
      xlt = log( t )
      alfas1 = 1/(b * t) -  bp/(b * t)**2 * xlt
      end

      subroutine lamvals(xlam,nfl,xlam3,xlam4,xlam5,xlam6)
c returns alfas_nfa(q), for given xlam_nfl
      implicit none
      real * 8 xlam,xlam3,xlam4,xlam5,xlam6
      integer nfl
      integer j
      real * 8  xl(3:6),xm(4:6),as
      data xm/1.5,5,172/
      data xl/4*0.d0/
      real * 8 alfalmvl,xlambdlmvl
      save xm
      if(xl(nfl).ne.xlam) then
         xl(nfl) = xlam
         do j=nfl,5,1
c find value of as at next matching threshold
            as = alfalmvl(xm(j+1),xl(j),j)
c find corresponding value for lambda_{j+1}
            xl(j+1) = xlambdlmvl(as,xm(j+1),j+1)
         enddo
c same backward
         do j=nfl,4,-1
            as = alfalmvl(xm(j),xl(j),j)
            xl(j-1) = xlambdlmvl(as,xm(j),j-1)
         enddo
      endif
      xlam3=xl(3)
      xlam4=xl(4)
      xlam5=xl(5)
      xlam6=xl(6)
      end

      function alfalmvl(q,xlam,nf)
      implicit none
      real * 8 alfalmvl,q,xlam,b,bp,t,xlt,pi
      integer nf
      parameter (pi=3.14159265358979312D0)
      b  = (33-2*nf)/pi/12
      bp = (153 - 19*nf) / pi / 2 / (33 - 2*nf)
      t = 2 * log( q/xlam )
      xlt = log( t )
      alfalmvl = 1/(b * t) -  bp/(b * t)**2 * xlt
      end

      function xlambdlmvl(as,q,nf)
      implicit none
      real * 8 xlambdlmvl,as,q,b,bp,t,pi,ot,as0,as1,xlt
      parameter (pi=3.14159265358979312D0)
      integer nf
      b  = (33-2*nf)/pi/12
      bp = (153 - 19*nf) / pi / 2 / (33 - 2*nf)
      t  = 1/b/as
    1 xlt = log(t)
      ot = t
c-----------------------------------------------------------
c Value and Derivative of alfa with respect to t
      as0  = 1/b/t - bp*xlt/(b*t)**2
      as1  = - 1/b/t**2 -bp/b**2*(1-2*xlt)/t**3
      t  = (as-as0)/as1 + t
      if(abs(ot-t)/ot.gt.0.00000001d0)goto 1
      xlambdlmvl = q/exp(t/2)
      return
      end

      subroutine printstat
      implicit none
      integer nev
      real * 8 getcnt,powheginput
      external getcnt,powheginput
      nev=nint(getcnt('events number'))
      write(57,*) ' Upper bound failures in inclusive cross section',
     # getcnt('upper bound failure in inclusive cross section'),
     # ' out of ', nev, ' events'
      write(57,*)
     # ' Efficiency in generation of inclusive cross section', nev
     # /(nev+getcnt('vetoed calls in inclusive cross section'))
      write(57,*)
     # ' Upper bound failures in the generation of radiation',
     # getcnt('upper bound failures in generation of radiation'),
     #  ' out of ', nev, ' events'
      write(57,*) ' Efficiency in the generation of radiation',
     #           nev/(nev+getcnt('vetoed radiation'))
      if(powheginput('#topdecaymode').gt.0) then
         write(57,*) ' Upper bound failures in top decay generation',
     #        getcnt('topdecay upper bound violations'),
     #        ' out of ', nev, ' events'
         write(57,*) ' Efficiency in top decay generation',
     #        nev/(nev+getcnt('topdecay vetoed configurations'))
      endif
      call printcnt(57)
      end
